/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/map","os","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","fs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/registry/common/platform","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/editor/common/core/range","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/mime","vs/base/common/processes","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/functional","vs/base/common/json","path","net","vs/base/common/hash","vs/base/common/glob","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/decorators","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/editor/common/core/position","vs/base/common/stopwatch","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/unc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminal","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/lazy","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/node/extpath","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","https","yauzl","yazl","http","vs/server/node/server.main"],pe=function(oe){for(var e=[],w=0,L=oe.length;w<L;w++)e[w]=ge[oe[w]];return e};define(ge[140],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class w{static get(){const o=new Map,P=new Map,C=new Map,A=new Map;function v(d,p){d.has(p.detail)||d.set(p.detail,-p.timestamp)}function m(d,p){const b=d.get(p.detail);b&&(b>=0||d.set(p.detail,b+p.timestamp))}let T=[];typeof oe.getStats=="function"&&(T=oe.getStats().slice(0).sort((d,p)=>d.timestamp-p.timestamp));for(const d of T)switch(d.type){case 10:v(o,d);break;case 11:case 12:m(o,d);break;case 21:v(P,d);break;case 22:m(P,d);break;case 33:v(C,d);break;case 34:m(C,d);break;case 31:v(A,d);break;case 32:m(A,d);break}let y=0;C.forEach(d=>y+=d);function E(d){const p=[];return d.forEach((b,s)=>p.push([s,b])),p}return{amdLoad:E(o),amdInvoke:E(P),nodeRequire:E(C),nodeEval:E(A),nodeRequireTotal:y}}static toMarkdownTable(o,P){let C="";const A=[];return o.forEach((v,m)=>{A[m]=v.length}),P.forEach(v=>{v.forEach((m,T)=>{typeof m>"u"&&(m=v[T]="-");const y=m.toString().length;A[T]=Math.max(y,A[T])})}),o.forEach((v,m)=>{C+=`| ${v+" ".repeat(A[m]-v.toString().length)} `}),C+=`|
`,o.forEach((v,m)=>{C+=`| ${"-".repeat(A[m])} `}),C+=`|
`,P.forEach(v=>{v.forEach((m,T)=>{typeof m<"u"&&(C+=`| ${m+" ".repeat(A[T]-m.toString().length)} `)}),C+=`|
`}),C}}e.LoaderStats=w}),define(ge[91],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function w(C){return(A,v,m)=>{let T=null,y=null;if(typeof m.value=="function"?(T="value",y=m.value):typeof m.get=="function"&&(T="get",y=m.get),!y)throw new Error("not supported");m[T]=C(y,v)}}function L(C,A,v){let m=null,T=null;if(typeof v.value=="function"?(m="value",T=v.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(m="get",T=v.get),!T)throw new Error("not supported");const y=`$memoize$${A}`;v[m]=function(...E){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,E)}),this[y]}}e.memoize=L;function o(C,A,v){return w((m,T)=>{const y=`$debounce$${T}`,E=`$debounce$result$${T}`;return function(...d){this[E]||(this[E]=v?v():void 0),clearTimeout(this[y]),A&&(this[E]=A(this[E],...d),d=[this[E]]),this[y]=setTimeout(()=>{m.apply(this,d),this[E]=v?v():void 0},C)}})}e.debounce=o;function P(C,A,v){return w((m,T)=>{const y=`$throttle$timer$${T}`,E=`$throttle$result$${T}`,d=`$throttle$lastRun$${T}`,p=`$throttle$pending$${T}`;return function(...b){if(this[E]||(this[E]=v?v():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),A&&(this[E]=A(this[E],...b)),this[p])return;const s=this[d]+C;s<=Date.now()?(this[d]=Date.now(),m.apply(this,[this[E]]),this[E]=v?v():void 0):(this[p]=!0,this[y]=setTimeout(()=>{this[p]=!1,this[d]=Date.now(),m.apply(this,[this[E]]),this[E]=v?v():void 0},s-Date.now()))}})}e.throttle=P}),define(ge[11],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?I.isErrorNoTelemetry(n)?new I(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(r=>{r(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=w,e.errorHandler=new w;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function o(t){if(!t||typeof t!="object")return!1;const n=t;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=o;function P(t){m(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=P;function C(t){m(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=C;function A(t){if(t instanceof Error){const{name:n,message:r}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:n,message:r,stack:i,noTelemetry:I.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=A;const v="Canceled";function m(t){return t instanceof T?!0:t instanceof Error&&t.name===v&&t.message===v}e.isCancellationError=m;class T extends Error{constructor(){super(v),this.name=this.message}}e.CancellationError=T;function y(){const t=new Error(v);return t.name=t.message,t}e.canceled=y;function E(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=E;function d(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=d;function p(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function b(t){const n=new Error(`${t} has been disposed`);return n.name="DISPOSED",n}e.disposed=b;function s(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=s;class h extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=h;class u extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=u;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=f;class I extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof I)return n;const r=new I;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=I;class O extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,O.prototype);debugger}}e.BugIndicatingError=O}),define(ge[18],pe([1,0,11]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(j,$=0){return j[j.length-(1+$)]}e.tail=L;function o(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=o;function P(j,$,J=(V,Z)=>V===Z){if(j===$)return!0;if(!j||!$||j.length!==$.length)return!1;for(let V=0,Z=j.length;V<Z;V++)if(!J(j[V],$[V]))return!1;return!0}e.equals=P;function C(j,$){const J=j.length-1;$<J&&(j[$]=j[J]),j.pop()}e.removeFastWithoutKeepingOrder=C;function A(j,$,J){return v(j.length,V=>J(j[V],$))}e.binarySearch=A;function v(j,$){let J=0,V=j-1;for(;J<=V;){const Z=(J+V)/2|0,Y=$(Z);if(Y<0)J=Z+1;else if(Y>0)V=Z-1;else return Z}return-(J+1)}e.binarySearch2=v;function m(j,$){let J=0,V=j.length;if(V===0)return 0;for(;J<V;){const Z=Math.floor((J+V)/2);$(j[Z])?V=Z:J=Z+1}return J}e.findFirstInSorted=m;function T(j,$,J){if(j=j|0,j>=$.length)throw new TypeError("invalid index");const V=$[Math.floor($.length*Math.random())],Z=[],Y=[],_=[];for(const ae of $){const Ee=J(ae,V);Ee<0?Z.push(ae):Ee>0?Y.push(ae):_.push(ae)}return j<Z.length?T(j,Z,J):j<Z.length+_.length?_[0]:T(j-(Z.length+_.length),Y,J)}e.quickSelect=T;function y(j,$){const J=[];let V;for(const Z of j.slice(0).sort($))!V||$(V[0],Z)!==0?(V=[Z],J.push(V)):V.push(Z);return J}e.groupBy=y;function E(j,$,J){const V=[];function Z(ae,Ee,Ce){if(Ee===0&&Ce.length===0)return;const ke=V[V.length-1];ke&&ke.start+ke.deleteCount===ae?(ke.deleteCount+=Ee,ke.toInsert.push(...Ce)):V.push({start:ae,deleteCount:Ee,toInsert:Ce})}let Y=0,_=0;for(;;){if(Y===j.length){Z(Y,0,$.slice(_));break}if(_===$.length){Z(Y,j.length-Y,[]);break}const ae=j[Y],Ee=$[_],Ce=J(ae,Ee);Ce===0?(Y+=1,_+=1):Ce<0?(Z(Y,1,[]),Y+=1):Ce>0&&(Z(Y,0,[Ee]),_+=1)}return V}e.sortedDiff=E;function d(j,$,J){const V=E(j,$,J),Z=[],Y=[];for(const _ of V)Z.push(...j.slice(_.start,_.start+_.deleteCount)),Y.push(..._.toInsert);return{removed:Z,added:Y}}e.delta=d;function p(j,$,J){if(J===0)return[];const V=j.slice(0,J).sort($);return s(j,$,V,J,j.length),V}e.top=p;function b(j,$,J,V,Z){return J===0?Promise.resolve([]):new Promise((Y,_)=>{(async()=>{const ae=j.length,Ee=j.slice(0,J).sort($);for(let Ce=J,ke=Math.min(J+V,ae);Ce<ae;Ce=ke,ke=Math.min(ke+V,ae)){if(Ce>J&&await new Promise(Ue=>setTimeout(Ue)),Z&&Z.isCancellationRequested)throw new w.CancellationError;s(j,$,Ee,Ce,ke)}return Ee})().then(Y,_)})}e.topAsync=b;function s(j,$,J,V,Z){for(const Y=J.length;V<Z;V++){const _=j[V];if($(_,J[Y-1])<0){J.pop();const ae=m(J,Ee=>$(_,Ee)<0);J.splice(ae,0,_)}}}function h(j){return j.filter($=>!!$)}e.coalesce=h;function u(j){let $=0;for(let J=0;J<j.length;J++)j[J]&&(j[$]=j[J],$+=1);j.length=$}e.coalesceInPlace=u;function f(j,$,J){j.splice(J,0,j.splice($,1)[0])}e.move=f;function I(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=I;function O(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=O;function t(j,$=J=>J){const J=new Set;return j.filter(V=>{const Z=$(V);return J.has(Z)?!1:(J.add(Z),!0)})}e.distinct=t;function n(j){const $=new Set;return J=>{const V=j(J);return $.has(V)?!1:($.add(V),!0)}}e.uniqueFilter=n;function r(j,$){const J=i(j,$);if(J!==-1)return j[J]}e.findLast=r;function i(j,$){for(let J=j.length-1;J>=0;J--){const V=j[J];if($(V))return J}return-1}e.lastIndex=i;function a(j,$){return j.length>0?j[0]:$}e.firstOrDefault=a;function l(j,$){return j.length>0?j[j.length-1]:$}e.lastOrDefault=l;function c(j,$,J=(V,Z)=>V===Z){let V=0;for(let Z=0,Y=Math.min(j.length,$.length);Z<Y&&J(j[Z],$[Z]);Z++)V++;return V}e.commonPrefixLength=c;function g(j){return[].concat(...j)}e.flatten=g;function D(j,$){let J=typeof $=="number"?j:0;typeof $=="number"?J=j:(J=0,$=j);const V=[];if(J<=$)for(let Z=J;Z<$;Z++)V.push(Z);else for(let Z=J;Z>$;Z--)V.push(Z);return V}e.range=D;function k(j,$,J){return j.reduce((V,Z)=>(V[$(Z)]=J?J(Z):Z,V),Object.create(null))}e.index=k;function S(j,$){return j.push($),()=>F(j,$)}e.insert=S;function F(j,$){const J=j.indexOf($);if(J>-1)return j.splice(J,1),$}e.remove=F;function H(j,$,J){const V=j.slice(0,$),Z=j.slice($);return V.concat(J,Z)}e.arrayInsert=H;function te(j,$){let J;if(typeof $=="number"){let V=$;J=()=>{const Z=Math.sin(V++)*179426549;return Z-Math.floor(Z)}}else J=Math.random;for(let V=j.length-1;V>0;V-=1){const Z=Math.floor(J()*(V+1)),Y=j[V];j[V]=j[Z],j[Z]=Y}}e.shuffle=te;function ce(j,$){const J=j.indexOf($);J>-1&&(j.splice(J,1),j.unshift($))}e.pushToStart=ce;function le(j,$){const J=j.indexOf($);J>-1&&(j.splice(J,1),j.push($))}e.pushToEnd=le;function ue(j,$){for(const J of $)j.push(J)}e.pushMany=ue;function ve(j,$){return Array.isArray(j)?j.map($):$(j)}e.mapArrayOrNot=ve;function K(j){return Array.isArray(j)?j:[j]}e.asArray=K;function ee(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=ee;function z(j,$){for(const J of j){const V=$(J);if(V!==void 0)return V}}e.mapFind=z;function q(j,$,J){const V=ne(j,$),Z=j.length,Y=J.length;j.length=Z+Y;for(let _=Z-1;_>=V;_--)j[_+Y]=j[_];for(let _=0;_<Y;_++)j[_+V]=J[_]}e.insertInto=q;function G(j,$,J,V){const Z=ne(j,$),Y=j.splice(Z,J);return q(j,Z,V),Y}e.splice=G;function ne(j,$){return $<0?Math.max($+j.length,0):Math.min($,j.length)}var se;(function(j){function $(Z){return Z<0}j.isLessThan=$;function J(Z){return Z>0}j.isGreaterThan=J;function V(Z){return Z===0}j.isNeitherLessOrGreaterThan=V,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(se||(e.CompareResult=se={}));function de(j,$){return(J,V)=>$(j(J),j(V))}e.compareBy=de;function W(...j){return($,J)=>{for(const V of j){const Z=V($,J);if(!se.isNeitherLessOrGreaterThan(Z))return Z}return se.neitherLessOrGreaterThan}}e.tieBreakComparators=W;const x=(j,$)=>j-$;e.numberComparator=x;function N(j,$){if(j.length===0)return;let J=j[0];for(let V=1;V<j.length;V++){const Z=j[V];$(Z,J)>0&&(J=Z)}return J}e.findMaxBy=N;function R(j,$){if(j.length===0)return;let J=j[0];for(let V=1;V<j.length;V++){const Z=j[V];$(Z,J)>=0&&(J=Z)}return J}e.findLastMaxBy=R;function U(j,$){return N(j,(J,V)=>-$(J,V))}e.findMinBy=U;class X{constructor($){this.f=$,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile($){let J=this.c;for(;J<this.f.length&&$(this.f[J]);)J++;const V=J===this.c?null:this.f.slice(this.c,J);return this.c=J,V}takeFromEndWhile($){let J=this.d;for(;J>=0&&$(this.f[J]);)J--;const V=J===this.d?null:this.f.slice(J+1,this.d+1);return this.d=J,V}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const $=this.f[this.c];return this.c++,$}removeLast(){const $=this.f[this.d];return this.d--,$}takeCount($){const J=this.f.slice(this.c,this.c+$);return this.c+=$,J}}e.ArrayQueue=X;class ie{constructor($){this.iterate=$}forEach($){this.iterate(J=>($(J),!0))}toArray(){const $=[];return this.iterate(J=>($.push(J),!0)),$}filter($){return new ie(J=>this.iterate(V=>$(V)?J(V):!0))}map($){return new ie(J=>this.iterate(V=>J($(V))))}some($){let J=!1;return this.iterate(V=>(J=$(V),!J)),J}findFirst($){let J;return this.iterate(V=>$(V)?(J=V,!1):!0),J}findLast($){let J;return this.iterate(V=>($(V)&&(J=V),!0)),J}findLastMaxBy($){let J,V=!0;return this.iterate(Z=>((V||se.isGreaterThan($(Z,J)))&&(V=!1,J=Z),!0)),J}}e.CallbackIterable=ie,ie.empty=new ie(j=>{})}),define(ge[92],pe([1,0,11]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(v,m){if(!v)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=L;function o(v,m="Unreachable"){throw new Error(m)}e.assertNever=o;function P(v){if(!v)throw new w.BugIndicatingError("Assertion Failed")}e.assert=P;function C(v){if(!v()){debugger;v(),(0,w.onUnexpectedError)(new w.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function A(v,m){let T=0;for(;T<v.length-1;){const y=v[T],E=v[T+1];if(!m(y,E))return!1;T++}return!0}e.checkAdjacentItems=A}),define(ge[71],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(L){const o=this;let P=!1,C;return function(){return P||(P=!0,C=L.apply(o,arguments)),C}}e.once=w}),define(ge[46],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(L){function o(I){return I&&typeof I=="object"&&typeof I[Symbol.iterator]=="function"}L.is=o;const P=Object.freeze([]);function C(){return P}L.empty=C;function*A(I){yield I}L.single=A;function v(I){return o(I)?I:A(I)}L.wrap=v;function m(I){return I||P}L.from=m;function T(I){return!I||I[Symbol.iterator]().next().done===!0}L.isEmpty=T;function y(I){return I[Symbol.iterator]().next().value}L.first=y;function E(I,O){for(const t of I)if(O(t))return!0;return!1}L.some=E;function d(I,O){for(const t of I)if(O(t))return t}L.find=d;function*p(I,O){for(const t of I)O(t)&&(yield t)}L.filter=p;function*b(I,O){let t=0;for(const n of I)yield O(n,t++)}L.map=b;function*s(...I){for(const O of I)for(const t of O)yield t}L.concat=s;function h(I,O,t){let n=t;for(const r of I)n=O(n,r);return n}L.reduce=h;function*u(I,O,t=I.length){for(O<0&&(O+=I.length),t<0?t+=I.length:t>I.length&&(t=I.length);O<t;O++)yield I[O]}L.slice=u;function f(I,O=Number.POSITIVE_INFINITY){const t=[];if(O===0)return[t,I];const n=I[Symbol.iterator]();for(let r=0;r<O;r++){const i=n.next();if(i.done)return[t,L.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return n}}]}L.consume=f})(w||(e.Iterable=w={}))}),define(ge[72],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var o;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(o||(e.ParseErrorCode=o={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function C(t,n=!1){let r=0;const i=t.length;let a="",l=0,c=16,g=0;function D(le){let ue=0,ve=0;for(;ue<le;){const K=t.charCodeAt(r);if(K>=48&&K<=57)ve=ve*16+K-48;else if(K>=65&&K<=70)ve=ve*16+K-65+10;else if(K>=97&&K<=102)ve=ve*16+K-97+10;else break;r++,ue++}return ue<le&&(ve=-1),ve}function k(le){r=le,a="",l=0,c=16,g=0}function S(){const le=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&m(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&m(t.charCodeAt(r)))for(r++;r<t.length&&m(t.charCodeAt(r));)r++;else return g=3,t.substring(le,r);let ue=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&m(t.charCodeAt(r))){for(r++;r<t.length&&m(t.charCodeAt(r));)r++;ue=r}else g=3;return t.substring(le,ue)}function F(){let le="",ue=r;for(;;){if(r>=i){le+=t.substring(ue,r),g=2;break}const ve=t.charCodeAt(r);if(ve===34){le+=t.substring(ue,r),r++;break}if(ve===92){if(le+=t.substring(ue,r),r++,r>=i){g=2;break}switch(t.charCodeAt(r++)){case 34:le+='"';break;case 92:le+="\\";break;case 47:le+="/";break;case 98:le+="\b";break;case 102:le+="\f";break;case 110:le+=`
`;break;case 114:le+="\r";break;case 116:le+="	";break;case 117:{const ee=D(4);ee>=0?le+=String.fromCharCode(ee):g=4;break}default:g=5}ue=r;continue}if(ve>=0&&ve<=31)if(v(ve)){le+=t.substring(ue,r),g=2;break}else g=6;r++}return le}function H(){if(a="",g=0,l=r,r>=i)return l=i,c=17;let le=t.charCodeAt(r);if(A(le)){do r++,a+=String.fromCharCode(le),le=t.charCodeAt(r);while(A(le));return c=15}if(v(le))return r++,a+=String.fromCharCode(le),le===13&&t.charCodeAt(r)===10&&(r++,a+=`
`),c=14;switch(le){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,a=F(),c=10;case 47:{const ue=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!v(t.charCodeAt(r));)r++;return a=t.substring(ue,r),c=12}if(t.charCodeAt(r+1)===42){r+=2;const ve=i-1;let K=!1;for(;r<ve;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,K=!0;break}r++}return K||(r++,g=1),a=t.substring(ue,r),c=13}return a+=String.fromCharCode(le),r++,c=16}case 45:if(a+=String.fromCharCode(le),r++,r===i||!m(t.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=S(),c=11;default:for(;r<i&&te(le);)r++,le=t.charCodeAt(r);if(l!==r){switch(a=t.substring(l,r),a){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return a+=String.fromCharCode(le),r++,c=16}}function te(le){if(A(le)||v(le))return!1;switch(le){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let le;do le=H();while(le>=12&&le<=15);return le}return{setPosition:k,getPosition:()=>r,scan:n?ce:H,getToken:()=>c,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>g}}e.createScanner=C;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function y(t,n){const r=[],i=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function g(D,k,S,F){l.value=D,l.offset=k,l.length=S,l.type=F,l.colonOffset=void 0,a=l}try{f(t,{onObjectBegin:(D,k)=>{if(n<=D)throw i;a=void 0,c=n>D,r.push("")},onObjectProperty:(D,k,S)=>{if(n<k||(g(D,k,S,"property"),r[r.length-1]=D,n<=k+S))throw i},onObjectEnd:(D,k)=>{if(n<=D)throw i;a=void 0,r.pop()},onArrayBegin:(D,k)=>{if(n<=D)throw i;a=void 0,r.push(0)},onArrayEnd:(D,k)=>{if(n<=D)throw i;a=void 0,r.pop()},onLiteralValue:(D,k,S)=>{if(n<k||(g(D,k,S,O(D)),n<=k+S))throw i},onSeparator:(D,k,S)=>{if(n<=k)throw i;if(D===":"&&a&&a.type==="property")a.colonOffset=k,c=!1,a=void 0;else if(D===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(c=!0,r[r.length-1]=""),a=void 0}}})}catch(D){if(D!==i)throw D}return{path:r,previousNode:a,isAtPropertyKey:c,matches:D=>{let k=0;for(let S=0;k<D.length&&S<r.length;S++)if(D[k]===r[S]||D[k]==="*")k++;else if(D[k]!=="**")return!1;return k===D.length}}}e.getLocation=y;function E(t,n=[],r=P.DEFAULT){let i=null,a=[];const l=[];function c(D){Array.isArray(a)?a.push(D):i!==null&&(a[i]=D)}return f(t,{onObjectBegin:()=>{const D={};c(D),l.push(a),a=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const D=[];c(D),l.push(a),a=D,i=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:c,onError:(D,k,S)=>{n.push({error:D,offset:k,length:S})}},r),a[0]}e.parse=E;function d(t,n=[],r=P.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function l(D){return i.children.push(D),D}f(t,{onObjectBegin:D=>{i=l({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,k,S)=>{i=l({type:"property",offset:k,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:k,length:S,parent:i})},onObjectEnd:(D,k)=>{i.length=D+k-i.offset,i=i.parent,a(D+k)},onArrayBegin:(D,k)=>{i=l({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,k)=>{i.length=D+k-i.offset,i=i.parent,a(D+k)},onLiteralValue:(D,k,S)=>{l({type:O(D),offset:k,length:S,parent:i,value:D}),a(k+S)},onSeparator:(D,k,S)=>{i.type==="property"&&(D===":"?i.colonOffset=k:D===","&&a(k))},onError:(D,k,S)=>{n.push({error:D,offset:k,length:S})}},r);const g=i.children[0];return g&&delete g.parent,g}e.parseTree=d;function p(t,n){if(!t)return;let r=t;for(const i of n)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===i){r=l.children[1],a=!0;break}if(!a)return}else{const a=i;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.findNodeAtLocation=p;function b(t){if(!t.parent||!t.parent.children)return[];const n=b(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=b;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const n=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(n[r.children[0].value]=s(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=s;function h(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=h;function u(t,n,r=!1){if(h(t,n,r)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=n;a++){const l=u(i[a],n,r);if(l)return l}return t}}e.findNodeAtOffset=u;function f(t,n,r=P.DEFAULT){const i=C(t,!1);function a(de){return de?()=>de(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(de){return de?W=>de(W,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=a(n.onObjectBegin),g=l(n.onObjectProperty),D=a(n.onObjectEnd),k=a(n.onArrayBegin),S=a(n.onArrayEnd),F=l(n.onLiteralValue),H=l(n.onSeparator),te=a(n.onComment),ce=l(n.onError),le=r&&r.disallowComments,ue=r&&r.allowTrailingComma;function ve(){for(;;){const de=i.scan();switch(i.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:le||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(de){case 12:case 13:le?K(10):te();break;case 16:K(1);break;case 15:case 14:break;default:return de}}}function K(de,W=[],x=[]){if(ce(de),W.length+x.length>0){let N=i.getToken();for(;N!==17;){if(W.indexOf(N)!==-1){ve();break}else if(x.indexOf(N)!==-1)break;N=ve()}}}function ee(de){const W=i.getTokenValue();return de?F(W):g(W),ve(),!0}function z(){switch(i.getToken()){case 11:{let de=0;try{de=JSON.parse(i.getTokenValue()),typeof de!="number"&&(K(2),de=0)}catch{K(2)}F(de);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return ve(),!0}function q(){return i.getToken()!==10?(K(3,[],[2,5]),!1):(ee(!1),i.getToken()===6?(H(":"),ve(),se()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function G(){c(),ve();let de=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(de||K(4,[],[]),H(","),ve(),i.getToken()===2&&ue)break}else de&&K(6,[],[]);q()||K(4,[],[2,5]),de=!0}return D(),i.getToken()!==2?K(7,[2],[]):ve(),!0}function ne(){k(),ve();let de=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(de||K(4,[],[]),H(","),ve(),i.getToken()===4&&ue)break}else de&&K(6,[],[]);se()||K(4,[],[4,5]),de=!0}return S(),i.getToken()!==4?K(8,[4],[]):ve(),!0}function se(){switch(i.getToken()){case 3:return ne();case 1:return G();case 10:return ee(!0);default:return z()}}return ve(),i.getToken()===17?r.allowEmptyContent?!0:(K(4,[],[]),!1):se()?(i.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=f;function I(t,n){const r=C(t),i=[];let a,l=0,c;do switch(c=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:l!==c&&i.push(t.substring(l,c)),n!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,n)),l=r.getPosition();break}while(a!==17);return i.join("")}e.stripComments=I;function O(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=O}),define(ge[141],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(o){this.d=o,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(o){this.c=o}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=w}),define(ge[2],pe([1,0,71,46]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const o=!1;let P=null;function C(l){P=l}if(e.setDisposableTracker=C,o){const l="__is_disposable_tracked__";C(new class{trackDisposable(c){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[l]||console.log(g)},3e3)}setParent(c,g){if(c&&c!==u.None)try{c[l]=!0}catch{}}markAsDisposed(c){if(c&&c!==u.None)try{c[l]=!0}catch{}}markAsSingleton(c){}})}function A(l){return P?.trackDisposable(l),l}function v(l){P?.markAsDisposed(l)}function m(l,c){P?.setParent(l,c)}function T(l,c){if(P)for(const g of l)P.setParent(g,c)}function y(l){return P?.markAsSingleton(l),l}e.markAsSingleton=y;function E(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=E;function d(l){if(L.Iterable.is(l)){const c=[];for(const g of l)if(g)try{g.dispose()}catch(D){c.push(D)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=d;function p(l){for(const c of l)E(c)&&c.dispose();return[]}e.disposeIfDisposable=p;function b(...l){const c=s(()=>d(l));return T(l,c),c}e.combinedDisposable=b;function s(l){const c=A({dispose:(0,w.once)(()=>{v(c),l()})});return c}e.toDisposable=s;class h{constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return m(c,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(c),c}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this.q=new h,A(this),m(this.q,this)}dispose(){v(this),this.q.dispose()}B(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(c)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class f{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(c){this.b||c===this.a||(this.a?.dispose(),c&&m(c,this),this.a=c)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const c=this.a;return this.a=void 0,c&&m(c,null),c}}e.MutableDisposable=f;class I{constructor(c){this.b=c,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=I;class O{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(c){let g=c;return this.unset=()=>g=void 0,this.isset=()=>g!==void 0,this.dispose=()=>{g&&(g(),g=void 0,v(this))},this}}e.SafeDisposable=O;class t{constructor(){this.a=new Map}acquire(c,...g){let D=this.a.get(c);D||(D={counter:0,object:this.b(c,...g)},this.a.set(c,D));const{object:k}=D,S=(0,w.once)(()=>{--D.counter===0&&(this.c(c,D.object),this.a.delete(c))});return D.counter++,{object:k,dispose:S}}}e.ReferenceCollection=t;class n{constructor(c){this.a=c}async acquire(c,...g){const D=this.a.acquire(c,...g);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(k){throw D.dispose(),k}}}e.AsyncReferenceCollection=n;class r{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=r;function i(l){const c=new h;try{l(c)}finally{c.dispose()}}e.disposeOnReturn=i;class a{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(c){return this.a.has(c)}get(c){return this.a.get(c)}set(c,g,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(c)?.dispose(),this.a.set(c,g)}deleteAndDispose(c){this.a.get(c)?.dispose(),this.a.delete(c)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=a}),define(ge[93],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(P){this.element=P,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class L{constructor(){this.a=w.Undefined,this.b=w.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===w.Undefined}clear(){let P=this.a;for(;P!==w.Undefined;){const C=P.next;P.prev=w.Undefined,P.next=w.Undefined,P=C}this.a=w.Undefined,this.b=w.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,C){const A=new w(P);if(this.a===w.Undefined)this.a=A,this.b=A;else if(C){const m=this.b;this.b=A,A.prev=m,m.next=A}else{const m=this.a;this.a=A,A.next=m,m.prev=A}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(A))}}shift(){if(this.a!==w.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==w.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==w.Undefined&&P.next!==w.Undefined){const C=P.prev;C.next=P.next,P.next.prev=C}else P.prev===w.Undefined&&P.next===w.Undefined?(this.a=w.Undefined,this.b=w.Undefined):P.next===w.Undefined?(this.b=this.b.prev,this.b.next=w.Undefined):P.prev===w.Undefined&&(this.a=this.a.next,this.a.prev=w.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==w.Undefined;)yield P.element,P=P.next}}e.LinkedList=L}),define(ge[27],pe([1,0]),function(oe,e){"use strict";var w,L,o;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function P(b,s,h){let u=b.get(s);return u===void 0&&(u=h,b.set(s,u)),u}e.getOrSet=P;function C(b){const s=[];return b.forEach((h,u)=>{s.push(`${u} => ${h}`)}),`Map(${b.size}) {${s.join(", ")}}`}e.mapToString=C;function A(b){const s=[];return b.forEach(h=>{s.push(h)}),`Set(${b.size}) {${s.join(", ")}}`}e.setToString=A;class v{constructor(s,h){this.uri=s,this.value=h}}class m{constructor(s,h){this[w]="ResourceMap",s instanceof m?(this.b=new Map(s.b),this.c=h??m.a):(this.b=new Map,this.c=s??m.a)}set(s,h){return this.b.set(this.c(s),new v(s,h)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,h){typeof h<"u"&&(s=s.bind(h));for(const[u,f]of this.b)s(f.value,f.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}e.ResourceMap=m,m.a=b=>b.toString();class T{constructor(s,h){this[L]="ResourceSet",!s||typeof s=="function"?this.a=new m(s):(this.a=new m(h),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,h){this.a.forEach((u,f)=>s.call(h,f,f,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=T;var y;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class E{constructor(){this[o]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,h=0){const u=this.a.get(s);if(u)return h!==0&&this.j(u,h),u.value}set(s,h,u=0){let f=this.a.get(s);if(f)f.value=h,u!==0&&this.j(f,u);else{switch(f={key:s,value:h,next:void 0,previous:void 0},u){case 0:this.h(f);break;case 1:this.g(f);break;case 2:this.h(f);break;default:this.h(f);break}this.a.set(s,f),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const h=this.a.get(s);if(h)return this.a.delete(s),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,h){const u=this.e;let f=this.b;for(;f;){if(h?s.bind(h)(f.value,f.key,this):s(f.value,f.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const s=this,h=this.e;let u=this.b;const f={[Symbol.iterator](){return f},next(){if(s.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const I={value:u.key,done:!1};return u=u.next,I}else return{value:void 0,done:!0}}};return f}values(){const s=this,h=this.e;let u=this.b;const f={[Symbol.iterator](){return f},next(){if(s.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const I={value:u.value,done:!1};return u=u.next,I}else return{value:void 0,done:!0}}};return f}entries(){const s=this,h=this.e;let u=this.b;const f={[Symbol.iterator](){return f},next(){if(s.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const I={value:[u.key,u.value],done:!1};return u=u.next,I}else return{value:void 0,done:!0}}};return f}[(o=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let h=this.b,u=this.size;for(;h&&u>s;)this.a.delete(h.key),h=h.next,u--;this.b=h,this.d=u,h&&(h.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const h=s.next,u=s.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}s.next=void 0,s.previous=void 0,this.e++}j(s,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(s===this.b)return;const u=s.next,f=s.previous;s===this.c?(f.next=void 0,this.c=f):(u.previous=f,f.next=u),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(h===2){if(s===this.c)return;const u=s.next,f=s.previous;s===this.b?(u.previous=void 0,this.b=u):(u.previous=f,f.next=u),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((h,u)=>{s.push([u,h])}),s}fromJSON(s){this.clear();for(const[h,u]of s)this.set(h,u)}}e.LinkedMap=E;class d extends E{constructor(s,h=1){super(),this.k=s,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,h=2){return super.get(s,h)}peek(s){return super.get(s,0)}set(s,h){return super.set(s,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=d;class p{constructor(){this.a=new Map}add(s){return this.a.set(s,(this.a.get(s)||0)+1),this}delete(s){let h=this.a.get(s)||0;return h===0?!1:(h--,h===0?this.a.delete(s):this.a.set(s,h),!0)}has(s){return this.a.has(s)}}e.CounterSet=p}),function(oe,e){typeof define=="function"&&define.amd?define(ge[142],pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(j,$){for(var J=0;J<$.length;J++){var V=$[J];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(j,V.key,V)}}function w(j,$,J){return $&&e(j.prototype,$),J&&e(j,J),Object.defineProperty(j,"prototype",{writable:!1}),j}function L(j,$){if(j){if(typeof j=="string")return o(j,$);var J=Object.prototype.toString.call(j).slice(8,-1);if(J==="Object"&&j.constructor&&(J=j.constructor.name),J==="Map"||J==="Set")return Array.from(j);if(J==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(J))return o(j,$)}}function o(j,$){($==null||$>j.length)&&($=j.length);for(var J=0,V=new Array($);J<$;J++)V[J]=j[J];return V}function P(j,$){var J=typeof Symbol<"u"&&j[Symbol.iterator]||j["@@iterator"];if(J)return(J=J.call(j)).next.bind(J);if(Array.isArray(j)||(J=L(j))||$&&j&&typeof j.length=="number"){J&&(j=J);var V=0;return function(){return V>=j.length?{done:!0}:{done:!1,value:j[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=C();function A(j){oe.defaults=j}var v=/[&<>"']/,m=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function($){return E[$]};function p(j,$){if($){if(v.test(j))return j.replace(m,d)}else if(T.test(j))return j.replace(y,d);return j}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(j){return j.replace(b,function($,J){return J=J.toLowerCase(),J==="colon"?":":J.charAt(0)==="#"?J.charAt(1)==="x"?String.fromCharCode(parseInt(J.substring(2),16)):String.fromCharCode(+J.substring(1)):""})}var h=/(^|[^\[])\^/g;function u(j,$){j=typeof j=="string"?j:j.source,$=$||"";var J={replace:function(Z,Y){return Y=Y.source||Y,Y=Y.replace(h,"$1"),j=j.replace(Z,Y),J},getRegex:function(){return new RegExp(j,$)}};return J}var f=/[^\w:]/g,I=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function O(j,$,J){if(j){var V;try{V=decodeURIComponent(s(J)).replace(f,"").toLowerCase()}catch{return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}$&&!I.test(J)&&(J=a($,J));try{J=encodeURI(J).replace(/%25/g,"%")}catch{return null}return J}var t={},n=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(j,$){t[" "+j]||(n.test(j)?t[" "+j]=j+"/":t[" "+j]=D(j,"/",!0)),j=t[" "+j];var J=j.indexOf(":")===-1;return $.substring(0,2)==="//"?J?$:j.replace(r,"$1")+$:$.charAt(0)==="/"?J?$:j.replace(i,"$1")+$:j+$}var l={exec:function(){}};function c(j){for(var $=1,J,V;$<arguments.length;$++){J=arguments[$];for(V in J)Object.prototype.hasOwnProperty.call(J,V)&&(j[V]=J[V])}return j}function g(j,$){var J=j.replace(/\|/g,function(Y,_,ae){for(var Ee=!1,Ce=_;--Ce>=0&&ae[Ce]==="\\";)Ee=!Ee;return Ee?"|":" |"}),V=J.split(/ \|/),Z=0;if(V[0].trim()||V.shift(),V.length>0&&!V[V.length-1].trim()&&V.pop(),V.length>$)V.splice($);else for(;V.length<$;)V.push("");for(;Z<V.length;Z++)V[Z]=V[Z].trim().replace(/\\\|/g,"|");return V}function D(j,$,J){var V=j.length;if(V===0)return"";for(var Z=0;Z<V;){var Y=j.charAt(V-Z-1);if(Y===$&&!J)Z++;else if(Y!==$&&J)Z++;else break}return j.slice(0,V-Z)}function k(j,$){if(j.indexOf($[1])===-1)return-1;for(var J=j.length,V=0,Z=0;Z<J;Z++)if(j[Z]==="\\")Z++;else if(j[Z]===$[0])V++;else if(j[Z]===$[1]&&(V--,V<0))return Z;return-1}function S(j){j&&j.sanitize&&!j.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(j,$){if($<1)return"";for(var J="";$>1;)$&1&&(J+=j),$>>=1,j+=j;return J+j}function H(j,$,J,V){var Z=$.href,Y=$.title?p($.title):null,_=j[1].replace(/\\([\[\]])/g,"$1");if(j[0].charAt(0)!=="!"){V.state.inLink=!0;var ae={type:"link",raw:J,href:Z,title:Y,text:_,tokens:V.inlineTokens(_)};return V.state.inLink=!1,ae}return{type:"image",raw:J,href:Z,title:Y,text:p(_)}}function te(j,$){var J=j.match(/^(\s+)(?:```)/);if(J===null)return $;var V=J[1];return $.split(`
`).map(function(Z){var Y=Z.match(/^\s+/);if(Y===null)return Z;var _=Y[0];return _.length>=V.length?Z.slice(V.length):Z}).join(`
`)}var ce=function(){function j(J){this.options=J||oe.defaults}var $=j.prototype;return $.space=function(V){var Z=this.rules.block.newline.exec(V);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},$.code=function(V){var Z=this.rules.block.code.exec(V);if(Z){var Y=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:D(Y,`
`)}}},$.fences=function(V){var Z=this.rules.block.fences.exec(V);if(Z){var Y=Z[0],_=te(Y,Z[3]||"");return{type:"code",raw:Y,lang:Z[2]?Z[2].trim():Z[2],text:_}}},$.heading=function(V){var Z=this.rules.block.heading.exec(V);if(Z){var Y=Z[2].trim();if(/#$/.test(Y)){var _=D(Y,"#");(this.options.pedantic||!_||/ $/.test(_))&&(Y=_.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:Y,tokens:this.lexer.inline(Y)}}},$.hr=function(V){var Z=this.rules.block.hr.exec(V);if(Z)return{type:"hr",raw:Z[0]}},$.blockquote=function(V){var Z=this.rules.block.blockquote.exec(V);if(Z){var Y=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},$.list=function(V){var Z=this.rules.block.list.exec(V);if(Z){var Y,_,ae,Ee,Ce,ke,Ue,ze,me,Se,we,Oe,je=Z[1].trim(),_e=je.length>1,Ve={type:"list",raw:"",ordered:_e,start:_e?+je.slice(0,-1):"",loose:!1,items:[]};je=_e?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=_e?je:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");V&&(Oe=!1,!(!(Z=Ye.exec(V))||this.rules.block.hr.test(V)));){if(Y=Z[0],V=V.substring(Y.length),ze=Z[2].split(`
`,1)[0],me=V.split(`
`,1)[0],this.options.pedantic?(Ee=2,we=ze.trimLeft()):(Ee=Z[2].search(/[^ ]/),Ee=Ee>4?1:Ee,we=ze.slice(Ee),Ee+=Z[1].length),ke=!1,!ze&&/^ *$/.test(me)&&(Y+=me+`
`,V=V.substring(me.length+1),Oe=!0),!Oe)for(var Xe=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Je=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:```|~~~)"),Ge=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}#");V&&(Se=V.split(`
`,1)[0],ze=Se,this.options.pedantic&&(ze=ze.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Je.test(ze)||Ge.test(ze)||Xe.test(ze)||it.test(V)));){if(ze.search(/[^ ]/)>=Ee||!ze.trim())we+=`
`+ze.slice(Ee);else if(!ke)we+=`
`+ze;else break;!ke&&!ze.trim()&&(ke=!0),Y+=Se+`
`,V=V.substring(Se.length+1)}Ve.loose||(Ue?Ve.loose=!0:/\n *\n *$/.test(Y)&&(Ue=!0)),this.options.gfm&&(_=/^\[[ xX]\] /.exec(we),_&&(ae=_[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:Y,task:!!_,checked:ae,loose:!1,text:we}),Ve.raw+=Y}Ve.items[Ve.items.length-1].raw=Y.trimRight(),Ve.items[Ve.items.length-1].text=we.trimRight(),Ve.raw=Ve.raw.trimRight();var he=Ve.items.length;for(Ce=0;Ce<he;Ce++){this.lexer.state.top=!1,Ve.items[Ce].tokens=this.lexer.blockTokens(Ve.items[Ce].text,[]);var Ie=Ve.items[Ce].tokens.filter(function(Ae){return Ae.type==="space"}),Te=Ie.every(function(Ae){for(var Ne=Ae.raw.split(""),$e=0,We=P(Ne),Ke;!(Ke=We()).done;){var et=Ke.value;if(et===`
`&&($e+=1),$e>1)return!0}return!1});!Ve.loose&&Ie.length&&Te&&(Ve.loose=!0,Ve.items[Ce].loose=!0)}return Ve}},$.html=function(V){var Z=this.rules.block.html.exec(V);if(Z){var Y={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var _=this.options.sanitizer?this.options.sanitizer(Z[0]):p(Z[0]);Y.type="paragraph",Y.text=_,Y.tokens=this.lexer.inline(_)}return Y}},$.def=function(V){var Z=this.rules.block.def.exec(V);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var Y=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:Z[0],href:Z[2],title:Z[3]}}},$.table=function(V){var Z=this.rules.block.table.exec(V);if(Z){var Y={type:"table",header:g(Z[1]).map(function(Ue){return{text:Ue}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=Z[0];var _=Y.align.length,ae,Ee,Ce,ke;for(ae=0;ae<_;ae++)/^ *-+: *$/.test(Y.align[ae])?Y.align[ae]="right":/^ *:-+: *$/.test(Y.align[ae])?Y.align[ae]="center":/^ *:-+ *$/.test(Y.align[ae])?Y.align[ae]="left":Y.align[ae]=null;for(_=Y.rows.length,ae=0;ae<_;ae++)Y.rows[ae]=g(Y.rows[ae],Y.header.length).map(function(Ue){return{text:Ue}});for(_=Y.header.length,Ee=0;Ee<_;Ee++)Y.header[Ee].tokens=this.lexer.inline(Y.header[Ee].text);for(_=Y.rows.length,Ee=0;Ee<_;Ee++)for(ke=Y.rows[Ee],Ce=0;Ce<ke.length;Ce++)ke[Ce].tokens=this.lexer.inline(ke[Ce].text);return Y}}},$.lheading=function(V){var Z=this.rules.block.lheading.exec(V);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},$.paragraph=function(V){var Z=this.rules.block.paragraph.exec(V);if(Z){var Y=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:Y,tokens:this.lexer.inline(Y)}}},$.text=function(V){var Z=this.rules.block.text.exec(V);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},$.escape=function(V){var Z=this.rules.inline.escape.exec(V);if(Z)return{type:"escape",raw:Z[0],text:p(Z[1])}},$.tag=function(V){var Z=this.rules.inline.tag.exec(V);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):p(Z[0]):Z[0]}},$.link=function(V){var Z=this.rules.inline.link.exec(V);if(Z){var Y=Z[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var _=D(Y.slice(0,-1),"\\");if((Y.length-_.length)%2===0)return}else{var ae=k(Z[2],"()");if(ae>-1){var Ee=Z[0].indexOf("!")===0?5:4,Ce=Ee+Z[1].length+ae;Z[2]=Z[2].substring(0,ae),Z[0]=Z[0].substring(0,Ce).trim(),Z[3]=""}}var ke=Z[2],Ue="";if(this.options.pedantic){var ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ke);ze&&(ke=ze[1],Ue=ze[3])}else Ue=Z[3]?Z[3].slice(1,-1):"";return ke=ke.trim(),/^</.test(ke)&&(this.options.pedantic&&!/>$/.test(Y)?ke=ke.slice(1):ke=ke.slice(1,-1)),H(Z,{href:ke&&ke.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},$.reflink=function(V,Z){var Y;if((Y=this.rules.inline.reflink.exec(V))||(Y=this.rules.inline.nolink.exec(V))){var _=(Y[2]||Y[1]).replace(/\s+/g," ");if(_=Z[_.toLowerCase()],!_||!_.href){var ae=Y[0].charAt(0);return{type:"text",raw:ae,text:ae}}return H(Y,_,Y[0],this.lexer)}},$.emStrong=function(V,Z,Y){Y===void 0&&(Y="");var _=this.rules.inline.emStrong.lDelim.exec(V);if(_&&!(_[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ae=_[1]||_[2]||"";if(!ae||ae&&(Y===""||this.rules.inline.punctuation.exec(Y))){var Ee=_[0].length-1,Ce,ke,Ue=Ee,ze=0,me=_[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,Z=Z.slice(-1*V.length+Ee);(_=me.exec(Z))!=null;)if(Ce=_[1]||_[2]||_[3]||_[4]||_[5]||_[6],!!Ce){if(ke=Ce.length,_[3]||_[4]){Ue+=ke;continue}else if((_[5]||_[6])&&Ee%3&&!((Ee+ke)%3)){ze+=ke;continue}if(Ue-=ke,!(Ue>0)){if(ke=Math.min(ke,ke+Ue+ze),Math.min(Ee,ke)%2){var Se=V.slice(1,Ee+_.index+ke);return{type:"em",raw:V.slice(0,Ee+_.index+ke+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var we=V.slice(2,Ee+_.index+ke-1);return{type:"strong",raw:V.slice(0,Ee+_.index+ke+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},$.codespan=function(V){var Z=this.rules.inline.code.exec(V);if(Z){var Y=Z[2].replace(/\n/g," "),_=/[^ ]/.test(Y),ae=/^ /.test(Y)&&/ $/.test(Y);return _&&ae&&(Y=Y.substring(1,Y.length-1)),Y=p(Y,!0),{type:"codespan",raw:Z[0],text:Y}}},$.br=function(V){var Z=this.rules.inline.br.exec(V);if(Z)return{type:"br",raw:Z[0]}},$.del=function(V){var Z=this.rules.inline.del.exec(V);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},$.autolink=function(V,Z){var Y=this.rules.inline.autolink.exec(V);if(Y){var _,ae;return Y[2]==="@"?(_=p(this.options.mangle?Z(Y[1]):Y[1]),ae="mailto:"+_):(_=p(Y[1]),ae=_),{type:"link",raw:Y[0],text:_,href:ae,tokens:[{type:"text",raw:_,text:_}]}}},$.url=function(V,Z){var Y;if(Y=this.rules.inline.url.exec(V)){var _,ae;if(Y[2]==="@")_=p(this.options.mangle?Z(Y[0]):Y[0]),ae="mailto:"+_;else{var Ee;do Ee=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while(Ee!==Y[0]);_=p(Y[0]),Y[1]==="www."?ae="http://"+_:ae=_}return{type:"link",raw:Y[0],text:_,href:ae,tokens:[{type:"text",raw:_,text:_}]}}},$.inlineText=function(V,Z){var Y=this.rules.inline.text.exec(V);if(Y){var _;return this.lexer.state.inRawBlock?_=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):p(Y[0]):Y[0]:_=p(this.options.smartypants?Z(Y[0]):Y[0]),{type:"text",raw:Y[0],text:_}}},j}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=u(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=u(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=u(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=u(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=u(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=u(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=c({},le),le.gfm=c({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=u(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=u(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=c({},le.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:u(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ue={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ue._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ue.punctuation=u(ue.punctuation).replace(/punctuation/g,ue._punctuation).getRegex(),ue.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ue.escapedEmSt=/\\\*|\\_/g,ue._comment=u(le._comment).replace("(?:-->|$)","-->").getRegex(),ue.emStrong.lDelim=u(ue.emStrong.lDelim).replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimAst=u(ue.emStrong.rDelimAst,"g").replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimUnd=u(ue.emStrong.rDelimUnd,"g").replace(/punct/g,ue._punctuation).getRegex(),ue._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ue._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ue._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ue.autolink=u(ue.autolink).replace("scheme",ue._scheme).replace("email",ue._email).getRegex(),ue._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ue.tag=u(ue.tag).replace("comment",ue._comment).replace("attribute",ue._attribute).getRegex(),ue._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ue._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ue._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ue.link=u(ue.link).replace("label",ue._label).replace("href",ue._href).replace("title",ue._title).getRegex(),ue.reflink=u(ue.reflink).replace("label",ue._label).replace("ref",le._label).getRegex(),ue.nolink=u(ue.nolink).replace("ref",le._label).getRegex(),ue.reflinkSearch=u(ue.reflinkSearch,"g").replace("reflink",ue.reflink).replace("nolink",ue.nolink).getRegex(),ue.normal=c({},ue),ue.pedantic=c({},ue.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",ue._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ue._label).getRegex()}),ue.gfm=c({},ue.normal,{escape:u(ue.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ue.gfm.url=u(ue.gfm.url,"i").replace("email",ue.gfm._extended_email).getRegex(),ue.breaks=c({},ue.gfm,{br:u(ue.br).replace("{2,}","*").getRegex(),text:u(ue.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ve(j){return j.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(j){var $="",J,V,Z=j.length;for(J=0;J<Z;J++)V=j.charCodeAt(J),Math.random()>.5&&(V="x"+V.toString(16)),$+="&#"+V+";";return $}var ee=function(){function j(J){this.tokens=[],this.tokens.links=Object.create(null),this.options=J||oe.defaults,this.options.tokenizer=this.options.tokenizer||new ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var V={block:le.normal,inline:ue.normal};this.options.pedantic?(V.block=le.pedantic,V.inline=ue.pedantic):this.options.gfm&&(V.block=le.gfm,this.options.breaks?V.inline=ue.breaks:V.inline=ue.gfm),this.tokenizer.rules=V}j.lex=function(V,Z){var Y=new j(Z);return Y.lex(V)},j.lexInline=function(V,Z){var Y=new j(Z);return Y.inlineTokens(V)};var $=j.prototype;return $.lex=function(V){V=V.replace(/\r\n|\r/g,`
`),this.blockTokens(V,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},$.blockTokens=function(V,Z){var Y=this;Z===void 0&&(Z=[]),this.options.pedantic?V=V.replace(/\t/g,"    ").replace(/^ +$/gm,""):V=V.replace(/^( *)(\t+)/gm,function(Ue,ze,me){return ze+"    ".repeat(me.length)});for(var _,ae,Ee,Ce;V;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ue){return(_=Ue.call({lexer:Y},V,Z))?(V=V.substring(_.raw.length),Z.push(_),!0):!1}))){if(_=this.tokenizer.space(V)){V=V.substring(_.raw.length),_.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push(_);continue}if(_=this.tokenizer.code(V)){V=V.substring(_.raw.length),ae=Z[Z.length-1],ae&&(ae.type==="paragraph"||ae.type==="text")?(ae.raw+=`
`+_.raw,ae.text+=`
`+_.text,this.inlineQueue[this.inlineQueue.length-1].src=ae.text):Z.push(_);continue}if(_=this.tokenizer.fences(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.heading(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.hr(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.blockquote(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.list(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.html(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.def(V)){V=V.substring(_.raw.length),ae=Z[Z.length-1],ae&&(ae.type==="paragraph"||ae.type==="text")?(ae.raw+=`
`+_.raw,ae.text+=`
`+_.raw,this.inlineQueue[this.inlineQueue.length-1].src=ae.text):this.tokens.links[_.tag]||(this.tokens.links[_.tag]={href:_.href,title:_.title});continue}if(_=this.tokenizer.table(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.lheading(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(Ee=V,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ue=1/0,ze=V.slice(1),me=void 0;Y.options.extensions.startBlock.forEach(function(Se){me=Se.call({lexer:this},ze),typeof me=="number"&&me>=0&&(Ue=Math.min(Ue,me))}),Ue<1/0&&Ue>=0&&(Ee=V.substring(0,Ue+1))}(),this.state.top&&(_=this.tokenizer.paragraph(Ee))){ae=Z[Z.length-1],Ce&&ae.type==="paragraph"?(ae.raw+=`
`+_.raw,ae.text+=`
`+_.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ae.text):Z.push(_),Ce=Ee.length!==V.length,V=V.substring(_.raw.length);continue}if(_=this.tokenizer.text(V)){V=V.substring(_.raw.length),ae=Z[Z.length-1],ae&&ae.type==="text"?(ae.raw+=`
`+_.raw,ae.text+=`
`+_.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ae.text):Z.push(_);continue}if(V){var ke="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return this.state.top=!0,Z},$.inline=function(V,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:V,tokens:Z}),Z},$.inlineTokens=function(V,Z){var Y=this;Z===void 0&&(Z=[]);var _,ae,Ee,Ce=V,ke,Ue,ze;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(ke=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)me.includes(ke[0].slice(ke[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,ke.index)+"["+F("a",ke[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ke=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,ke.index)+"["+F("a",ke[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ke=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,ke.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;)if(Ue||(ze=""),Ue=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(_=we.call({lexer:Y},V,Z))?(V=V.substring(_.raw.length),Z.push(_),!0):!1}))){if(_=this.tokenizer.escape(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.tag(V)){V=V.substring(_.raw.length),ae=Z[Z.length-1],ae&&_.type==="text"&&ae.type==="text"?(ae.raw+=_.raw,ae.text+=_.text):Z.push(_);continue}if(_=this.tokenizer.link(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(_.raw.length),ae=Z[Z.length-1],ae&&_.type==="text"&&ae.type==="text"?(ae.raw+=_.raw,ae.text+=_.text):Z.push(_);continue}if(_=this.tokenizer.emStrong(V,Ce,ze)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.codespan(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.br(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.del(V)){V=V.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.autolink(V,K)){V=V.substring(_.raw.length),Z.push(_);continue}if(!this.state.inLink&&(_=this.tokenizer.url(V,K))){V=V.substring(_.raw.length),Z.push(_);continue}if(Ee=V,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Oe=V.slice(1),je=void 0;Y.options.extensions.startInline.forEach(function(_e){je=_e.call({lexer:this},Oe),typeof je=="number"&&je>=0&&(we=Math.min(we,je))}),we<1/0&&we>=0&&(Ee=V.substring(0,we+1))}(),_=this.tokenizer.inlineText(Ee,ve)){V=V.substring(_.raw.length),_.raw.slice(-1)!=="_"&&(ze=_.raw.slice(-1)),Ue=!0,ae=Z[Z.length-1],ae&&ae.type==="text"?(ae.raw+=_.raw,ae.text+=_.text):Z.push(_);continue}if(V){var Se="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return Z},w(j,null,[{key:"rules",get:function(){return{block:le,inline:ue}}}]),j}(),z=function(){function j(J){this.options=J||oe.defaults}var $=j.prototype;return $.code=function(V,Z,Y){var _=(Z||"").match(/\S*/)[0];if(this.options.highlight){var ae=this.options.highlight(V,_);ae!=null&&ae!==V&&(Y=!0,V=ae)}return V=V.replace(/\n$/,"")+`
`,_?'<pre><code class="'+this.options.langPrefix+p(_,!0)+'">'+(Y?V:p(V,!0))+`</code></pre>
`:"<pre><code>"+(Y?V:p(V,!0))+`</code></pre>
`},$.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},$.html=function(V){return V},$.heading=function(V,Z,Y,_){if(this.options.headerIds){var ae=this.options.headerPrefix+_.slug(Y);return"<h"+Z+' id="'+ae+'">'+V+"</h"+Z+`>
`}return"<h"+Z+">"+V+"</h"+Z+`>
`},$.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},$.list=function(V,Z,Y){var _=Z?"ol":"ul",ae=Z&&Y!==1?' start="'+Y+'"':"";return"<"+_+ae+`>
`+V+"</"+_+`>
`},$.listitem=function(V){return"<li>"+V+`</li>
`},$.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},$.paragraph=function(V){return"<p>"+V+`</p>
`},$.table=function(V,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+Z+`</table>
`},$.tablerow=function(V){return`<tr>
`+V+`</tr>
`},$.tablecell=function(V,Z){var Y=Z.header?"th":"td",_=Z.align?"<"+Y+' align="'+Z.align+'">':"<"+Y+">";return _+V+("</"+Y+`>
`)},$.strong=function(V){return"<strong>"+V+"</strong>"},$.em=function(V){return"<em>"+V+"</em>"},$.codespan=function(V){return"<code>"+V+"</code>"},$.br=function(){return this.options.xhtml?"<br/>":"<br>"},$.del=function(V){return"<del>"+V+"</del>"},$.link=function(V,Z,Y){if(V=O(this.options.sanitize,this.options.baseUrl,V),V===null)return Y;var _='<a href="'+p(V)+'"';return Z&&(_+=' title="'+Z+'"'),_+=">"+Y+"</a>",_},$.image=function(V,Z,Y){if(V=O(this.options.sanitize,this.options.baseUrl,V),V===null)return Y;var _='<img src="'+V+'" alt="'+Y+'"';return Z&&(_+=' title="'+Z+'"'),_+=this.options.xhtml?"/>":">",_},$.text=function(V){return V},j}(),q=function(){function j(){}var $=j.prototype;return $.strong=function(V){return V},$.em=function(V){return V},$.codespan=function(V){return V},$.del=function(V){return V},$.html=function(V){return V},$.text=function(V){return V},$.link=function(V,Z,Y){return""+Y},$.image=function(V,Z,Y){return""+Y},$.br=function(){return""},j}(),G=function(){function j(){this.seen={}}var $=j.prototype;return $.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},$.getNextSafeSlug=function(V,Z){var Y=V,_=0;if(this.seen.hasOwnProperty(Y)){_=this.seen[V];do _++,Y=V+"-"+_;while(this.seen.hasOwnProperty(Y))}return Z||(this.seen[V]=_,this.seen[Y]=0),Y},$.slug=function(V,Z){Z===void 0&&(Z={});var Y=this.serialize(V);return this.getNextSafeSlug(Y,Z.dryrun)},j}(),ne=function(){function j(J){this.options=J||oe.defaults,this.options.renderer=this.options.renderer||new z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new G}j.parse=function(V,Z){var Y=new j(Z);return Y.parse(V)},j.parseInline=function(V,Z){var Y=new j(Z);return Y.parseInline(V)};var $=j.prototype;return $.parse=function(V,Z){Z===void 0&&(Z=!0);var Y="",_,ae,Ee,Ce,ke,Ue,ze,me,Se,we,Oe,je,_e,Ve,Ye,Xe,it,Je,Ge,he=V.length;for(_=0;_<he;_++){if(we=V[_],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Ge=this.options.extensions.renderers[we.type].call({parser:this},we),Ge!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){Y+=Ge||"";continue}switch(we.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(we.tokens),we.depth,s(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(me="",ze="",Ce=we.header.length,ae=0;ae<Ce;ae++)ze+=this.renderer.tablecell(this.parseInline(we.header[ae].tokens),{header:!0,align:we.align[ae]});for(me+=this.renderer.tablerow(ze),Se="",Ce=we.rows.length,ae=0;ae<Ce;ae++){for(Ue=we.rows[ae],ze="",ke=Ue.length,Ee=0;Ee<ke;Ee++)ze+=this.renderer.tablecell(this.parseInline(Ue[Ee].tokens),{header:!1,align:we.align[Ee]});Se+=this.renderer.tablerow(ze)}Y+=this.renderer.table(me,Se);continue}case"blockquote":{Se=this.parse(we.tokens),Y+=this.renderer.blockquote(Se);continue}case"list":{for(Oe=we.ordered,je=we.start,_e=we.loose,Ce=we.items.length,Se="",ae=0;ae<Ce;ae++)Ye=we.items[ae],Xe=Ye.checked,it=Ye.task,Ve="",Ye.task&&(Je=this.renderer.checkbox(Xe),_e?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=Je+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=Je+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:Je}):Ve+=Je),Ve+=this.parse(Ye.tokens,_e),Se+=this.renderer.listitem(Ve,it,Xe);Y+=this.renderer.list(Se,Oe,je);continue}case"html":{Y+=this.renderer.html(we.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(Se=we.tokens?this.parseInline(we.tokens):we.text;_+1<he&&V[_+1].type==="text";)we=V[++_],Se+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);Y+=Z?this.renderer.paragraph(Se):Se;continue}default:{var Ie='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return Y},$.parseInline=function(V,Z){Z=Z||this.renderer;var Y="",_,ae,Ee,Ce=V.length;for(_=0;_<Ce;_++){if(ae=V[_],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(Ee=this.options.extensions.renderers[ae.type].call({parser:this},ae),Ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ae.type))){Y+=Ee||"";continue}switch(ae.type){case"escape":{Y+=Z.text(ae.text);break}case"html":{Y+=Z.html(ae.text);break}case"link":{Y+=Z.link(ae.href,ae.title,this.parseInline(ae.tokens,Z));break}case"image":{Y+=Z.image(ae.href,ae.title,ae.text);break}case"strong":{Y+=Z.strong(this.parseInline(ae.tokens,Z));break}case"em":{Y+=Z.em(this.parseInline(ae.tokens,Z));break}case"codespan":{Y+=Z.codespan(ae.text);break}case"br":{Y+=Z.br();break}case"del":{Y+=Z.del(this.parseInline(ae.tokens,Z));break}case"text":{Y+=Z.text(ae.text);break}default:{var ke='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return Y},j}();function se(j,$,J){if(typeof j>"u"||j===null)throw new Error("marked(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");if(typeof $=="function"&&(J=$,$=null),$=c({},se.defaults,$||{}),S($),J){var V=$.highlight,Z;try{Z=ee.lex(j,$)}catch(Ce){return J(Ce)}var Y=function(ke){var Ue;if(!ke)try{$.walkTokens&&se.walkTokens(Z,$.walkTokens),Ue=ne.parse(Z,$)}catch(ze){ke=ze}return $.highlight=V,ke?J(ke):J(null,Ue)};if(!V||V.length<3||(delete $.highlight,!Z.length))return Y();var _=0;se.walkTokens(Z,function(Ce){Ce.type==="code"&&(_++,setTimeout(function(){V(Ce.text,Ce.lang,function(ke,Ue){if(ke)return Y(ke);Ue!=null&&Ue!==Ce.text&&(Ce.text=Ue,Ce.escaped=!0),_--,_===0&&Y()})},0))}),_===0&&Y();return}function ae(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,$.silent)return"<p>An error occurred:</p><pre>"+p(Ce.message+"",!0)+"</pre>";throw Ce}try{var Ee=ee.lex(j,$);if($.walkTokens){if($.async)return Promise.all(se.walkTokens(Ee,$.walkTokens)).then(function(){return ne.parse(Ee,$)}).catch(ae);se.walkTokens(Ee,$.walkTokens)}return ne.parse(Ee,$)}catch(Ce){ae(Ce)}}se.options=se.setOptions=function(j){return c(se.defaults,j),A(se.defaults),se},se.getDefaults=C,se.defaults=oe.defaults,se.use=function(){for(var j=arguments.length,$=new Array(j),J=0;J<j;J++)$[J]=arguments[J];var V=c.apply(void 0,[{}].concat($)),Z=se.defaults.extensions||{renderers:{},childTokens:{}},Y;$.forEach(function(_){if(_.extensions&&(Y=!0,_.extensions.forEach(function(Ee){if(!Ee.name)throw new Error("extension name required");if(Ee.renderer){var Ce=Z.renderers?Z.renderers[Ee.name]:null;Ce?Z.renderers[Ee.name]=function(){for(var ke=arguments.length,Ue=new Array(ke),ze=0;ze<ke;ze++)Ue[ze]=arguments[ze];var me=Ee.renderer.apply(this,Ue);return me===!1&&(me=Ce.apply(this,Ue)),me}:Z.renderers[Ee.name]=Ee.renderer}if(Ee.tokenizer){if(!Ee.level||Ee.level!=="block"&&Ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[Ee.level]?Z[Ee.level].unshift(Ee.tokenizer):Z[Ee.level]=[Ee.tokenizer],Ee.start&&(Ee.level==="block"?Z.startBlock?Z.startBlock.push(Ee.start):Z.startBlock=[Ee.start]:Ee.level==="inline"&&(Z.startInline?Z.startInline.push(Ee.start):Z.startInline=[Ee.start]))}Ee.childTokens&&(Z.childTokens[Ee.name]=Ee.childTokens)})),_.renderer&&function(){var Ee=se.defaults.renderer||new z,Ce=function(ze){var me=Ee[ze];Ee[ze]=function(){for(var Se=arguments.length,we=new Array(Se),Oe=0;Oe<Se;Oe++)we[Oe]=arguments[Oe];var je=_.renderer[ze].apply(Ee,we);return je===!1&&(je=me.apply(Ee,we)),je}};for(var ke in _.renderer)Ce(ke);V.renderer=Ee}(),_.tokenizer&&function(){var Ee=se.defaults.tokenizer||new ce,Ce=function(ze){var me=Ee[ze];Ee[ze]=function(){for(var Se=arguments.length,we=new Array(Se),Oe=0;Oe<Se;Oe++)we[Oe]=arguments[Oe];var je=_.tokenizer[ze].apply(Ee,we);return je===!1&&(je=me.apply(Ee,we)),je}};for(var ke in _.tokenizer)Ce(ke);V.tokenizer=Ee}(),_.walkTokens){var ae=se.defaults.walkTokens;V.walkTokens=function(Ee){var Ce=[];return Ce.push(_.walkTokens.call(this,Ee)),ae&&(Ce=Ce.concat(ae.call(this,Ee))),Ce}}Y&&(V.extensions=Z),se.setOptions(V)})},se.walkTokens=function(j,$){for(var J=[],V=function(){var ae=Y.value;switch(J=J.concat($.call(se,ae)),ae.type){case"table":{for(var Ee=P(ae.header),Ce;!(Ce=Ee()).done;){var ke=Ce.value;J=J.concat(se.walkTokens(ke.tokens,$))}for(var Ue=P(ae.rows),ze;!(ze=Ue()).done;)for(var me=ze.value,Se=P(me),we;!(we=Se()).done;){var Oe=we.value;J=J.concat(se.walkTokens(Oe.tokens,$))}break}case"list":{J=J.concat(se.walkTokens(ae.items,$));break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[ae.type]?se.defaults.extensions.childTokens[ae.type].forEach(function(je){J=J.concat(se.walkTokens(ae[je],$))}):ae.tokens&&(J=J.concat(se.walkTokens(ae.tokens,$)))}},Z=P(j),Y;!(Y=Z()).done;)V();return J},se.parseInline=function(j,$){if(typeof j>"u"||j===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");$=c({},se.defaults,$||{}),S($);try{var J=ee.lexInline(j,$);return $.walkTokens&&se.walkTokens(J,$.walkTokens),ne.parseInline(J,$)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,$.silent)return"<p>An error occurred:</p><pre>"+p(V.message+"",!0)+"</pre>";throw V}},se.Parser=ne,se.parser=ne.parse,se.Renderer=z,se.TextRenderer=q,se.Lexer=ee,se.lexer=ee.lex,se.Tokenizer=ce,se.Slugger=G,se.parse=se;var de=se.options,W=se.setOptions,x=se.use,N=se.walkTokens,R=se.parseInline,U=se,X=ne.parse,ie=ee.lex;oe.Lexer=ee,oe.Parser=ne,oe.Renderer=z,oe.Slugger=G,oe.TextRenderer=q,oe.Tokenizer=ce,oe.getDefaults=C,oe.lexer=ie,oe.marked=se,oe.options=de,oe.parse=U,oe.parseInline=R,oe.parser=X,oe.setOptions=W,oe.use=x,oe.walkTokens=N,Object.defineProperty(oe,"__esModule",{value:!0})}),define(ge[94],pe([1,0,27]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new w.LRUCache(1e4);function o(m){return v(m,"NFC",L)}e.normalizeNFC=o;const P=new w.LRUCache(1e4);function C(m){return v(m,"NFD",P)}e.normalizeNFD=C;const A=/[^\u0000-\u0080]/;function v(m,T,y){if(!m)return m;const E=y.get(m);if(E)return E;let d;return A.test(m)?d=m.normalize(T):d=m,y.set(m,d),d}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(T){return C(T).replace(m,"")}}()}),define(ge[143],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(A,v,m){return Math.min(Math.max(A,v),m)}e.clamp=w;function L(A,v){return(v+A%v)%v}e.rot=L;class o{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=o;class P{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=P;class C{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const m=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function oe(o){const P=[];typeof o=="number"&&P.push("code/timeOrigin",o);function C(v){P.push(v,Date.now())}function A(){const v=[];for(let m=0;m<P.length;m+=2)v.push({name:P[m],startTime:P[m+1]});return v}return{mark:C,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(o){performance.mark(o)},getMarks(){let o=performance.timeOrigin;typeof o!="number"&&(o=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(o)}];for(const C of performance.getEntriesByType("mark"))P.push({name:C.name,startTime:Math.round(o+C.startTime)});return P}};if(typeof process=="object"){const o=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(o)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function w(o){return o.MonacoPerformanceMarks||(o.MonacoPerformanceMarks=e()),o.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=w(L))}(),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var L in w)(typeof exports=="object"?exports:oe)[L]=w[L]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function w(L){if(e[L])return e[L].exports;var o=e[L]={i:L,l:!1,exports:{}};return oe[L].call(o.exports,o,o.exports,w),o.l=!0,o.exports}return w.m=oe,w.c=e,w.d=function(L,o,P){w.o(L,o)||Object.defineProperty(L,o,{enumerable:!0,get:P})},w.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},w.t=function(L,o){if(1&o&&(L=w(L)),8&o||4&o&&typeof L=="object"&&L&&L.__esModule)return L;var P=Object.create(null);if(w.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:L}),2&o&&typeof L!="string")for(var C in L)w.d(P,C,function(A){return L[A]}.bind(null,C));return P},w.n=function(L){var o=L&&L.__esModule?function(){return L.default}:function(){return L};return w.d(o,"a",o),o},w.o=function(L,o){return Object.prototype.hasOwnProperty.call(L,o)},w.p="",w(w.s=0)}([function(oe,e,w){(function(L){var o;e=oe.exports=x,o=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],v=e.src=[],m=0,T=m++;v[T]="0|[1-9]\\d*";var y=m++;v[y]="[0-9]+";var E=m++;v[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=m++;v[d]="("+v[T]+")\\.("+v[T]+")\\.("+v[T]+")";var p=m++;v[p]="("+v[y]+")\\.("+v[y]+")\\.("+v[y]+")";var b=m++;v[b]="(?:"+v[T]+"|"+v[E]+")";var s=m++;v[s]="(?:"+v[y]+"|"+v[E]+")";var h=m++;v[h]="(?:-("+v[b]+"(?:\\."+v[b]+")*))";var u=m++;v[u]="(?:-?("+v[s]+"(?:\\."+v[s]+")*))";var f=m++;v[f]="[0-9A-Za-z-]+";var I=m++;v[I]="(?:\\+("+v[f]+"(?:\\."+v[f]+")*))";var O=m++,t="v?"+v[d]+v[h]+"?"+v[I]+"?";v[O]="^"+t+"$";var n="[v=\\s]*"+v[p]+v[u]+"?"+v[I]+"?",r=m++;v[r]="^"+n+"$";var i=m++;v[i]="((?:<|>)?=?)";var a=m++;v[a]=v[y]+"|x|X|\\*";var l=m++;v[l]=v[T]+"|x|X|\\*";var c=m++;v[c]="[v=\\s]*("+v[l]+")(?:\\.("+v[l]+")(?:\\.("+v[l]+")(?:"+v[h]+")?"+v[I]+"?)?)?";var g=m++;v[g]="[v=\\s]*("+v[a]+")(?:\\.("+v[a]+")(?:\\.("+v[a]+")(?:"+v[u]+")?"+v[I]+"?)?)?";var D=m++;v[D]="^"+v[i]+"\\s*"+v[c]+"$";var k=m++;v[k]="^"+v[i]+"\\s*"+v[g]+"$";var S=m++;v[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=m++;v[F]="(?:~>?)";var H=m++;v[H]="(\\s*)"+v[F]+"\\s+",A[H]=new RegExp(v[H],"g");var te=m++;v[te]="^"+v[F]+v[c]+"$";var ce=m++;v[ce]="^"+v[F]+v[g]+"$";var le=m++;v[le]="(?:\\^)";var ue=m++;v[ue]="(\\s*)"+v[le]+"\\s+",A[ue]=new RegExp(v[ue],"g");var ve=m++;v[ve]="^"+v[le]+v[c]+"$";var K=m++;v[K]="^"+v[le]+v[g]+"$";var ee=m++;v[ee]="^"+v[i]+"\\s*("+n+")$|^$";var z=m++;v[z]="^"+v[i]+"\\s*("+t+")$|^$";var q=m++;v[q]="(\\s*)"+v[i]+"\\s*("+n+"|"+v[c]+")",A[q]=new RegExp(v[q],"g");var G=m++;v[G]="^\\s*("+v[c]+")\\s+-\\s+("+v[c]+")\\s*$";var ne=m++;v[ne]="^\\s*("+v[g]+")\\s+-\\s+("+v[g]+")\\s*$";var se=m++;v[se]="(<|>)?=?\\s*\\*";for(var de=0;de<35;de++)o(de,v[de]),A[de]||(A[de]=new RegExp(v[de]));function W(me,Se){if(me instanceof x)return me;if(typeof me!="string"||me.length>P||!(Se?A[r]:A[O]).test(me))return null;try{return new x(me,Se)}catch{return null}}function x(me,Se){if(me instanceof x){if(me.loose===Se)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof x))return new x(me,Se);o("SemVer",me,Se),this.loose=Se;var we=me.trim().match(Se?A[r]:A[O]);if(!we)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var je=+Oe;if(je>=0&&je<C)return je}return Oe}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=W,e.valid=function(me,Se){var we=W(me,Se);return we?we.version:null},e.clean=function(me,Se){var we=W(me.trim().replace(/^[=v]+/,""),Se);return we?we.version:null},e.SemVer=x,x.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},x.prototype.toString=function(){return this.version},x.prototype.compare=function(me){return o("SemVer.compare",this.version,this.loose,me),me instanceof x||(me=new x(me,this.loose)),this.compareMain(me)||this.comparePre(me)},x.prototype.compareMain=function(me){return me instanceof x||(me=new x(me,this.loose)),R(this.major,me.major)||R(this.minor,me.minor)||R(this.patch,me.patch)},x.prototype.comparePre=function(me){if(me instanceof x||(me=new x(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var Se=0;do{var we=this.prerelease[Se],Oe=me.prerelease[Se];if(o("prerelease compare",Se,we,Oe),we===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(we===void 0)return-1;if(we!==Oe)return R(we,Oe)}while(++Se)},x.prototype.inc=function(me,Se){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,Se,we,Oe){typeof we=="string"&&(Oe=we,we=void 0);try{return new x(me,we).inc(Se,Oe).version}catch{return null}},e.diff=function(me,Se){if(j(me,Se))return null;var we=W(me),Oe=W(Se);if(we.prerelease.length||Oe.prerelease.length){for(var je in we)if((je==="major"||je==="minor"||je==="patch")&&we[je]!==Oe[je])return"pre"+je;return"prerelease"}for(var je in we)if((je==="major"||je==="minor"||je==="patch")&&we[je]!==Oe[je])return je},e.compareIdentifiers=R;var N=/^[0-9]+$/;function R(me,Se){var we=N.test(me),Oe=N.test(Se);return we&&Oe&&(me=+me,Se=+Se),we&&!Oe?-1:Oe&&!we?1:me<Se?-1:me>Se?1:0}function U(me,Se,we){return new x(me,we).compare(new x(Se,we))}function X(me,Se,we){return U(me,Se,we)>0}function ie(me,Se,we){return U(me,Se,we)<0}function j(me,Se,we){return U(me,Se,we)===0}function $(me,Se,we){return U(me,Se,we)!==0}function J(me,Se,we){return U(me,Se,we)>=0}function V(me,Se,we){return U(me,Se,we)<=0}function Z(me,Se,we,Oe){var je;switch(Se){case"===":typeof me=="object"&&(me=me.version),typeof we=="object"&&(we=we.version),je=me===we;break;case"!==":typeof me=="object"&&(me=me.version),typeof we=="object"&&(we=we.version),je=me!==we;break;case"":case"=":case"==":je=j(me,we,Oe);break;case"!=":je=$(me,we,Oe);break;case">":je=X(me,we,Oe);break;case">=":je=J(me,we,Oe);break;case"<":je=ie(me,we,Oe);break;case"<=":je=V(me,we,Oe);break;default:throw new TypeError("Invalid operator: "+Se)}return je}function Y(me,Se){if(me instanceof Y){if(me.loose===Se)return me;me=me.value}if(!(this instanceof Y))return new Y(me,Se);o("comparator",me,Se),this.loose=Se,this.parse(me),this.semver===_?this.value="":this.value=this.operator+this.semver.version,o("comp",this)}e.rcompareIdentifiers=function(me,Se){return R(Se,me)},e.major=function(me,Se){return new x(me,Se).major},e.minor=function(me,Se){return new x(me,Se).minor},e.patch=function(me,Se){return new x(me,Se).patch},e.compare=U,e.compareLoose=function(me,Se){return U(me,Se,!0)},e.rcompare=function(me,Se,we){return U(Se,me,we)},e.sort=function(me,Se){return me.sort(function(we,Oe){return e.compare(we,Oe,Se)})},e.rsort=function(me,Se){return me.sort(function(we,Oe){return e.rcompare(we,Oe,Se)})},e.gt=X,e.lt=ie,e.eq=j,e.neq=$,e.gte=J,e.lte=V,e.cmp=Z,e.Comparator=Y;var _={};function ae(me,Se){if(me instanceof ae)return me.loose===Se?me:new ae(me.raw,Se);if(me instanceof Y)return new ae(me.value,Se);if(!(this instanceof ae))return new ae(me,Se);if(this.loose=Se,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function Ee(me){return!me||me.toLowerCase()==="x"||me==="*"}function Ce(me,Se,we,Oe,je,_e,Ve,Ye,Xe,it,Je,Ge,he){return((Se=Ee(we)?"":Ee(Oe)?">="+we+".0.0":Ee(je)?">="+we+"."+Oe+".0":">="+Se)+" "+(Ye=Ee(Xe)?"":Ee(it)?"<"+(+Xe+1)+".0.0":Ee(Je)?"<"+Xe+"."+(+it+1)+".0":Ge?"<="+Xe+"."+it+"."+Je+"-"+Ge:"<="+Ye)).trim()}function ke(me,Se){for(var we=0;we<me.length;we++)if(!me[we].test(Se))return!1;if(Se.prerelease.length){for(we=0;we<me.length;we++)if(o(me[we].semver),me[we].semver!==_&&me[we].semver.prerelease.length>0){var Oe=me[we].semver;if(Oe.major===Se.major&&Oe.minor===Se.minor&&Oe.patch===Se.patch)return!0}return!1}return!0}function Ue(me,Se,we){try{Se=new ae(Se,we)}catch{return!1}return Se.test(me)}function ze(me,Se,we,Oe){var je,_e,Ve,Ye,Xe;switch(me=new x(me,Oe),Se=new ae(Se,Oe),we){case">":je=X,_e=V,Ve=ie,Ye=">",Xe=">=";break;case"<":je=ie,_e=J,Ve=X,Ye="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(me,Se,Oe))return!1;for(var it=0;it<Se.set.length;++it){var Je=Se.set[it],Ge=null,he=null;if(Je.forEach(function(Ie){Ie.semver===_&&(Ie=new Y(">=0.0.0")),Ge=Ge||Ie,he=he||Ie,je(Ie.semver,Ge.semver,Oe)?Ge=Ie:Ve(Ie.semver,he.semver,Oe)&&(he=Ie)}),Ge.operator===Ye||Ge.operator===Xe||(!he.operator||he.operator===Ye)&&_e(me,he.semver)||he.operator===Xe&&Ve(me,he.semver))return!1}return!0}Y.prototype.parse=function(me){var Se=this.loose?A[ee]:A[z],we=me.match(Se);if(!we)throw new TypeError("Invalid comparator: "+me);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new x(we[2],this.loose):this.semver=_},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(me){return o("Comparator.test",me,this.loose),this.semver===_||(typeof me=="string"&&(me=new x(me,this.loose)),Z(me,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(me,Se){if(!(me instanceof Y))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new ae(me.value,Se),Ue(this.value,we,Se);if(me.operator==="")return we=new ae(this.value,Se),Ue(me.semver,we,Se);var Oe=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),_e=this.semver.version===me.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Ye=Z(this.semver,"<",me.semver,Se)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),Xe=Z(this.semver,">",me.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Oe||je||_e&&Ve||Ye||Xe},e.Range=ae,ae.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},ae.prototype.toString=function(){return this.range},ae.prototype.parseRange=function(me){var Se=this.loose;me=me.trim(),o("range",me,Se);var we=Se?A[ne]:A[G];me=me.replace(we,Ce),o("hyphen replace",me),me=me.replace(A[q],"$1$2$3"),o("comparator trim",me,A[q]),me=(me=(me=me.replace(A[H],"$1~")).replace(A[ue],"$1^")).split(/\s+/).join(" ");var Oe=Se?A[ee]:A[z],je=me.split(" ").map(function(_e){return function(Ve,Ye){return o("comp",Ve),Ve=function(Xe,it){return Xe.trim().split(/\s+/).map(function(Je){return function(Ge,he){o("caret",Ge,he);var Ie=he?A[K]:A[ve];return Ge.replace(Ie,function(Te,Ae,Ne,$e,We){var Ke;return o("caret",Ge,Te,Ae,Ne,$e,We),Ee(Ae)?Ke="":Ee(Ne)?Ke=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":Ee($e)?Ke=Ae==="0"?">="+Ae+"."+Ne+".0 <"+Ae+"."+(+Ne+1)+".0":">="+Ae+"."+Ne+".0 <"+(+Ae+1)+".0.0":We?(o("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),Ke=Ae==="0"?Ne==="0"?">="+Ae+"."+Ne+"."+$e+We+" <"+Ae+"."+Ne+"."+(+$e+1):">="+Ae+"."+Ne+"."+$e+We+" <"+Ae+"."+(+Ne+1)+".0":">="+Ae+"."+Ne+"."+$e+We+" <"+(+Ae+1)+".0.0"):(o("no pr"),Ke=Ae==="0"?Ne==="0"?">="+Ae+"."+Ne+"."+$e+" <"+Ae+"."+Ne+"."+(+$e+1):">="+Ae+"."+Ne+"."+$e+" <"+Ae+"."+(+Ne+1)+".0":">="+Ae+"."+Ne+"."+$e+" <"+(+Ae+1)+".0.0"),o("caret return",Ke),Ke})}(Je,it)}).join(" ")}(Ve,Ye),o("caret",Ve),Ve=function(Xe,it){return Xe.trim().split(/\s+/).map(function(Je){return function(Ge,he){var Ie=he?A[ce]:A[te];return Ge.replace(Ie,function(Te,Ae,Ne,$e,We){var Ke;return o("tilde",Ge,Te,Ae,Ne,$e,We),Ee(Ae)?Ke="":Ee(Ne)?Ke=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":Ee($e)?Ke=">="+Ae+"."+Ne+".0 <"+Ae+"."+(+Ne+1)+".0":We?(o("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),Ke=">="+Ae+"."+Ne+"."+$e+We+" <"+Ae+"."+(+Ne+1)+".0"):Ke=">="+Ae+"."+Ne+"."+$e+" <"+Ae+"."+(+Ne+1)+".0",o("tilde return",Ke),Ke})}(Je,it)}).join(" ")}(Ve,Ye),o("tildes",Ve),Ve=function(Xe,it){return o("replaceXRanges",Xe,it),Xe.split(/\s+/).map(function(Je){return function(Ge,he){Ge=Ge.trim();var Ie=he?A[k]:A[D];return Ge.replace(Ie,function(Te,Ae,Ne,$e,We,Ke){o("xRange",Ge,Te,Ae,Ne,$e,We,Ke);var et=Ee(Ne),qe=et||Ee($e),rt=qe||Ee(We);return Ae==="="&&rt&&(Ae=""),et?Te=Ae===">"||Ae==="<"?"<0.0.0":"*":Ae&&rt?(qe&&($e=0),rt&&(We=0),Ae===">"?(Ae=">=",qe?(Ne=+Ne+1,$e=0,We=0):rt&&($e=+$e+1,We=0)):Ae==="<="&&(Ae="<",qe?Ne=+Ne+1:$e=+$e+1),Te=Ae+Ne+"."+$e+"."+We):qe?Te=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":rt&&(Te=">="+Ne+"."+$e+".0 <"+Ne+"."+(+$e+1)+".0"),o("xRange return",Te),Te})}(Je,it)}).join(" ")}(Ve,Ye),o("xrange",Ve),Ve=function(Xe,it){return o("replaceStars",Xe,it),Xe.trim().replace(A[se],"")}(Ve,Ye),o("stars",Ve),Ve}(_e,Se)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(_e){return!!_e.match(Oe)})),je=je.map(function(_e){return new Y(_e,Se)})},ae.prototype.intersects=function(me,Se){if(!(me instanceof ae))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Oe){return me.set.some(function(je){return je.every(function(_e){return Oe.intersects(_e,Se)})})})})},e.toComparators=function(me,Se){return new ae(me,Se).set.map(function(we){return we.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},ae.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new x(me,this.loose));for(var Se=0;Se<this.set.length;Se++)if(ke(this.set[Se],me))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(me,Se,we){var Oe=null,je=null;try{var _e=new ae(Se,we)}catch{return null}return me.forEach(function(Ve){_e.test(Ve)&&(Oe&&je.compare(Ve)!==-1||(je=new x(Oe=Ve,we)))}),Oe},e.minSatisfying=function(me,Se,we){var Oe=null,je=null;try{var _e=new ae(Se,we)}catch{return null}return me.forEach(function(Ve){_e.test(Ve)&&(Oe&&je.compare(Ve)!==1||(je=new x(Oe=Ve,we)))}),Oe},e.validRange=function(me,Se){try{return new ae(me,Se).range||"*"}catch{return null}},e.ltr=function(me,Se,we){return ze(me,Se,"<",we)},e.gtr=function(me,Se,we){return ze(me,Se,">",we)},e.outside=ze,e.prerelease=function(me,Se){var we=W(me,Se);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(me,Se,we){return me=new ae(me,we),Se=new ae(Se,we),me.intersects(Se)},e.coerce=function(me){if(me instanceof x)return me;if(typeof me!="string")return null;var Se=me.match(A[S]);return Se==null?null:W((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,w(1))},function(oe,e){var w,L,o=oe.exports={};function P(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function A(s){if(w===setTimeout)return setTimeout(s,0);if((w===P||!w)&&setTimeout)return w=setTimeout,setTimeout(s,0);try{return w(s,0)}catch{try{return w.call(null,s,0)}catch{return w.call(this,s,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:P}catch{w=P}try{L=typeof clearTimeout=="function"?clearTimeout:C}catch{L=C}})();var v,m=[],T=!1,y=-1;function E(){T&&v&&(T=!1,v.length?m=v.concat(m):y=-1,m.length&&d())}function d(){if(!T){var s=A(E);T=!0;for(var h=m.length;h;){for(v=m,m=[];++y<h;)v&&v[y].run();y=-1,h=m.length}v=null,T=!1,function(u){if(L===clearTimeout)return clearTimeout(u);if((L===C||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(u);try{L(u)}catch{try{return L.call(null,u)}catch{return L.call(this,u)}}}(s)}}function p(s,h){this.fun=s,this.array=h}function b(){}o.nextTick=function(s){var h=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)h[u-1]=arguments[u];m.push(new p(s,h)),m.length!==1||T||A(d)},p.prototype.run=function(){this.fun.apply(null,this.array)},o.title="browser",o.browser=!0,o.env={},o.argv=[],o.version="",o.versions={},o.on=b,o.addListener=b,o.once=b,o.off=b,o.removeListener=b,o.removeAllListeners=b,o.emit=b,o.prependListener=b,o.prependOnceListener=b,o.listeners=function(s){return[]},o.binding=function(s){throw new Error("process.binding is not supported")},o.cwd=function(){return"/"},o.chdir=function(s){throw new Error("process.chdir is not supported")},o.umask=function(){return 0}}])}),define(ge[144],pe([1,0]),function(oe,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(A,v,m){this.level=A,this.key=v,this.value=m,this.forward=[]}}const o=void 0;class P{constructor(A,v=2**16){this.comparator=A,this[w]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new L(this.c,o,o)}get size(){return this.f}clear(){this.e=new L(this.c,o,o)}has(A){return!!P.g(this,A,this.comparator)}get(A){return P.g(this,A,this.comparator)?.value}set(A,v){return P.h(this,A,v,this.comparator)&&(this.f+=1),this}delete(A){const v=P.k(this,A,this.comparator);return v&&(this.f-=1),v}forEach(A,v){let m=this.e.forward[0];for(;m;)A.call(v,m.value,m.key,this),m=m.forward[0]}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let A=this.e.forward[0];for(;A;)yield[A.key,A.value],A=A.forward[0]}*keys(){let A=this.e.forward[0];for(;A;)yield A.key,A=A.forward[0]}*values(){let A=this.e.forward[0];for(;A;)yield A.value,A=A.forward[0]}toString(){let A="[SkipList]:",v=this.e.forward[0];for(;v;)A+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return A}static g(A,v,m){let T=A.e;for(let y=A.d-1;y>=0;y--)for(;T.forward[y]&&m(T.forward[y].key,v)<0;)T=T.forward[y];if(T=T.forward[0],T&&m(T.key,v)===0)return T}static h(A,v,m,T){const y=[];let E=A.e;for(let d=A.d-1;d>=0;d--){for(;E.forward[d]&&T(E.forward[d].key,v)<0;)E=E.forward[d];y[d]=E}if(E=E.forward[0],E&&T(E.key,v)===0)return E.value=m,!1;{const d=P.j(A);if(d>A.d){for(let p=A.d;p<d;p++)y[p]=A.e;A.d=d}E=new L(d,v,m);for(let p=0;p<d;p++)E.forward[p]=y[p].forward[p],y[p].forward[p]=E;return!0}}static j(A,v=.5){let m=1;for(;Math.random()<v&&m<A.c;)m+=1;return m}static k(A,v,m){const T=[];let y=A.e;for(let E=A.d-1;E>=0;E--){for(;y.forward[E]&&m(y.forward[E].key,v)<0;)y=y.forward[E];T[E]=y}if(y=y.forward[0],!y||m(y.key,v)!==0)return!1;for(let E=0;E<A.d&&T[E].forward[E]===y;E++)T[E].forward[E]=y.forward[E];for(;A.d>0&&A.e.forward[A.d-1]===o;)A.d-=1;return!0}}e.SkipList=P}),define(ge[47],pe([1,0,11,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function o(I){const O=I;return O?typeof O.read=="function":!1}e.isReadable=o;function P(I){const O=I;return O?[O.on,O.pause,O.resume,O.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=P;function C(I){const O=I;return O?P(O.stream)&&Array.isArray(O.buffer)&&typeof O.ended=="boolean":!1}e.isReadableBufferedStream=C;function A(I,O){return new v(I,O)}e.newWriteableStream=A;class v{constructor(O,t){this.e=O,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(O){if(!this.a.destroyed){if(this.a.flowing)this.g(O);else if(this.b.data.push(O),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(O){this.a.destroyed||(this.a.flowing?this.h(O):this.b.error.push(O))}end(O){this.a.destroyed||(typeof O<"u"&&this.write(O),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(O){this.c.data.slice(0).forEach(t=>t(O))}h(O){this.c.error.length===0?(0,w.onUnexpectedError)(O):this.c.error.slice(0).forEach(t=>t(O))}i(){this.c.end.slice(0).forEach(O=>O())}on(O,t){if(!this.a.destroyed)switch(O){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(O,t){if(this.a.destroyed)return;let n;switch(O){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(t);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const O=this.e(this.b.data);this.g(O),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const O of this.b.error)this.h(O);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(I,O){const t=[];let n;for(;(n=I.read())!==null;)t.push(n);return O(t)}e.consumeReadable=m;function T(I,O,t){const n=[];let r;for(;(r=I.read())!==null&&n.length<t;)n.push(r);return r===null&&n.length>0?O(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return I.read()}}}e.peekReadable=T;function y(I,O){return new Promise((t,n)=>{const r=[];E(I,{onData:i=>{O&&r.push(i)},onError:i=>{O?n(i):t(void 0)},onEnd:()=>{t(O?O(r):void 0)}})})}e.consumeStream=y;function E(I,O){let t=!1;return I.on("error",n=>{t||O.onError(n)}),I.on("end",()=>{t||O.onEnd()}),I.on("data",n=>{t||O.onData(n)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=E;function d(I,O){return new Promise((t,n)=>{const r=new L.DisposableStore,i=[],a=g=>{if(i.push(g),i.length>O)return r.dispose(),I.pause(),t({stream:I,buffer:i,ended:!1})},l=g=>n(g),c=()=>t({stream:I,buffer:i,ended:!0});r.add((0,L.toDisposable)(()=>I.removeListener("error",l))),I.on("error",l),r.add((0,L.toDisposable)(()=>I.removeListener("end",c))),I.on("end",c),r.add((0,L.toDisposable)(()=>I.removeListener("data",a))),I.on("data",a)})}e.peekStream=d;function p(I,O){const t=A(O);return t.end(I),t}e.toStream=p;function b(){const I=A(()=>{throw new Error("not supported")});return I.end(),I}e.emptyStream=b;function s(I){let O=!1;return{read:()=>O?null:(O=!0,I)}}e.toReadable=s;function h(I,O,t){const n=A(t);return E(I,{onData:r=>n.write(O.data(r)),onError:r=>n.error(O.error?O.error(r):r),onEnd:()=>n.end()}),n}e.transform=h;function u(I,O,t){let n=!1;return{read:()=>{const r=O.read();return n?r:(n=!0,r!==null?t([I,r]):I)}}}e.prefixedReadable=u;function f(I,O,t){let n=!1;const r=A(t);return E(O,{onData:i=>n?r.write(i):(n=!0,r.write(t([I,i]))),onError:i=>r.error(i),onEnd:()=>{n||(n=!0,r.write(I)),r.end()}}),r}e.prefixedStream=f}),define(ge[15],pe([1,0,47]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u";let o,P;class C{static alloc(g){return L?new C(Buffer.allocUnsafe(g)):new C(new Uint8Array(g))}static wrap(g){return L&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new C(g)}static fromString(g,D){return!(D?.dontUseNodeBuffer||!1)&&L?new C(Buffer.from(g)):(o||(o=new TextEncoder),new C(o.encode(g)))}static fromByteArray(g){const D=C.alloc(g.length);for(let k=0,S=g.length;k<S;k++)D.buffer[k]=g[k];return D}static concat(g,D){if(typeof D>"u"){D=0;for(let F=0,H=g.length;F<H;F++)D+=g[F].byteLength}const k=C.alloc(D);let S=0;for(let F=0,H=g.length;F<H;F++){const te=g[F];k.set(te,S),S+=te.byteLength}return k}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=C.alloc(this.byteLength);return g.set(this),g}toString(){return L?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(g,D){return new C(this.buffer.subarray(g,D))}set(g,D){if(g instanceof C)this.buffer.set(g.buffer,D);else if(g instanceof Uint8Array)this.buffer.set(g,D);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),D);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return m(this.buffer,g)}writeUInt32BE(g,D){T(this.buffer,g,D)}readUInt32LE(g){return y(this.buffer,g)}writeUInt32LE(g,D){E(this.buffer,g,D)}readUInt8(g){return d(this.buffer,g)}writeUInt8(g,D){p(this.buffer,g,D)}}e.VSBuffer=C;function A(c,g){return c[g+0]<<0>>>0|c[g+1]<<8>>>0}e.readUInt16LE=A;function v(c,g,D){c[D+0]=g&255,g=g>>>8,c[D+1]=g&255}e.writeUInt16LE=v;function m(c,g){return c[g]*2**24+c[g+1]*2**16+c[g+2]*2**8+c[g+3]}e.readUInt32BE=m;function T(c,g,D){c[D+3]=g,g=g>>>8,c[D+2]=g,g=g>>>8,c[D+1]=g,g=g>>>8,c[D]=g}e.writeUInt32BE=T;function y(c,g){return c[g+0]<<0>>>0|c[g+1]<<8>>>0|c[g+2]<<16>>>0|c[g+3]<<24>>>0}e.readUInt32LE=y;function E(c,g,D){c[D+0]=g&255,g=g>>>8,c[D+1]=g&255,g=g>>>8,c[D+2]=g&255,g=g>>>8,c[D+3]=g&255}e.writeUInt32LE=E;function d(c,g){return c[g]}e.readUInt8=d;function p(c,g,D){c[D]=g}e.writeUInt8=p;function b(c){return w.consumeReadable(c,g=>C.concat(g))}e.readableToBuffer=b;function s(c){return w.toReadable(c)}e.bufferToReadable=s;function h(c){return w.consumeStream(c,g=>C.concat(g))}e.streamToBuffer=h;async function u(c){return c.ended?C.concat(c.buffer):C.concat([...c.buffer,await h(c.stream)])}e.bufferedStreamToBuffer=u;function f(c){return w.toStream(c,g=>C.concat(g))}e.bufferToStream=f;function I(c){return w.transform(c,{data:g=>typeof g=="string"?C.fromString(g):C.wrap(g)},g=>C.concat(g))}e.streamToBufferReadableStream=I;function O(c){return w.newWriteableStream(g=>C.concat(g),c)}e.newWriteableBufferStream=O;function t(c,g){return w.prefixedReadable(c,g,D=>C.concat(D))}e.prefixedBufferReadable=t;function n(c,g){return w.prefixedStream(c,g,D=>C.concat(D))}e.prefixedBufferStream=n;function r(c){let g=0,D=0,k=0;const S=new Uint8Array(Math.floor(c.length/4*3)),F=te=>{switch(D){case 3:S[k++]=g|te,D=0;break;case 2:S[k++]=g|te>>>2,g=te<<6,D=3;break;case 1:S[k++]=g|te>>>4,g=te<<4,D=2;break;default:g=te<<2,D=1}};for(let te=0;te<c.length;te++){const ce=c.charCodeAt(te);if(ce>=65&&ce<=90)F(ce-65);else if(ce>=97&&ce<=122)F(ce-97+26);else if(ce>=48&&ce<=57)F(ce-48+52);else if(ce===43||ce===45)F(62);else if(ce===47||ce===95)F(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${c[te]}`)}}const H=k;for(;D>0;)F(0);return C.wrap(S).slice(0,H)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:c},g=!0,D=!1){const k=D?a:i;let S="";const F=c.byteLength%3;let H=0;for(;H<c.byteLength-F;H+=3){const te=c[H+0],ce=c[H+1],le=c[H+2];S+=k[te>>>2],S+=k[(te<<4|ce>>>4)&63],S+=k[(ce<<2|le>>>6)&63],S+=k[le&63]}if(F===1){const te=c[H+0];S+=k[te>>>2],S+=k[te<<4&63],g&&(S+="==")}else if(F===2){const te=c[H+0],ce=c[H+1];S+=k[te>>>2],S+=k[(te<<4|ce>>>4)&63],S+=k[ce<<2&63],g&&(S+="=")}return S}e.encodeBase64=l}),define(ge[145],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ge[8],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function w(n){return typeof n=="string"}e.isString=w;function L(n){return Array.isArray(n)&&n.every(r=>w(r))}e.isStringArray=L;function o(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=o;function P(n){const r=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof r}e.isTypedArray=P;function C(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=C;function A(n){return!!n&&typeof n[Symbol.iterator]=="function"}e.isIterable=A;function v(n){return n===!0||n===!1}e.isBoolean=v;function m(n){return typeof n>"u"}e.isUndefined=m;function T(n){return!y(n)}e.isDefined=T;function y(n){return m(n)||n===null}e.isUndefinedOrNull=y;function E(n,r){if(!n)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=E;function d(n){if(y(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=d;function p(...n){const r=[];for(let i=0;i<n.length;i++){const a=n[i];if(y(a))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);r.push(a)}return r}e.assertAllDefined=p;const b=Object.prototype.hasOwnProperty;function s(n){if(!o(n))return!1;for(const r in n)if(b.call(n,r))return!1;return!0}e.isEmptyObject=s;function h(n){return typeof n=="function"}e.isFunction=h;function u(...n){return n.length>0&&n.every(h)}e.areFunctions=u;function f(n,r){const i=Math.min(n.length,r.length);for(let a=0;a<i;a++)I(n[a],r[a])}e.validateConstraints=f;function I(n,r){if(w(r)){if(typeof n!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(h(r)){try{if(n instanceof r)return}catch{}if(!y(n)&&n.constructor===r||r.length===1&&r.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=I;function O(n){return n===null?void 0:n}e.withNullAsUndefined=O;function t(n){return typeof n>"u"?null:n}e.withUndefinedAsNull=t}),define(ge[48],pe([1,0,8]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function o(A,v){if((0,w.isString)(v)){const m=L[v];if(m===void 0)throw new Error(`${A} references an unknown codicon: ${v}`);v=m}return L[A]=v,{id:A}}function P(){return L}e.getCodiconFontCharacters=P;function C(){return Object.values(e.Codicon)}e.getAllCodicons=C,e.Codicon={add:o("add",6e4),plus:o("plus",6e4),gistNew:o("gist-new",6e4),repoCreate:o("repo-create",6e4),lightbulb:o("lightbulb",60001),lightBulb:o("light-bulb",60001),repo:o("repo",60002),repoDelete:o("repo-delete",60002),gistFork:o("gist-fork",60003),repoForked:o("repo-forked",60003),gitPullRequest:o("git-pull-request",60004),gitPullRequestAbandoned:o("git-pull-request-abandoned",60004),recordKeys:o("record-keys",60005),keyboard:o("keyboard",60005),tag:o("tag",60006),tagAdd:o("tag-add",60006),tagRemove:o("tag-remove",60006),person:o("person",60007),personFollow:o("person-follow",60007),personOutline:o("person-outline",60007),personFilled:o("person-filled",60007),gitBranch:o("git-branch",60008),gitBranchCreate:o("git-branch-create",60008),gitBranchDelete:o("git-branch-delete",60008),sourceControl:o("source-control",60008),mirror:o("mirror",60009),mirrorPublic:o("mirror-public",60009),star:o("star",60010),starAdd:o("star-add",60010),starDelete:o("star-delete",60010),starEmpty:o("star-empty",60010),comment:o("comment",60011),commentAdd:o("comment-add",60011),alert:o("alert",60012),warning:o("warning",60012),search:o("search",60013),searchSave:o("search-save",60013),logOut:o("log-out",60014),signOut:o("sign-out",60014),logIn:o("log-in",60015),signIn:o("sign-in",60015),eye:o("eye",60016),eyeUnwatch:o("eye-unwatch",60016),eyeWatch:o("eye-watch",60016),circleFilled:o("circle-filled",60017),primitiveDot:o("primitive-dot",60017),closeDirty:o("close-dirty",60017),debugBreakpoint:o("debug-breakpoint",60017),debugBreakpointDisabled:o("debug-breakpoint-disabled",60017),debugHint:o("debug-hint",60017),primitiveSquare:o("primitive-square",60018),edit:o("edit",60019),pencil:o("pencil",60019),info:o("info",60020),issueOpened:o("issue-opened",60020),gistPrivate:o("gist-private",60021),gitForkPrivate:o("git-fork-private",60021),lock:o("lock",60021),mirrorPrivate:o("mirror-private",60021),close:o("close",60022),removeClose:o("remove-close",60022),x:o("x",60022),repoSync:o("repo-sync",60023),sync:o("sync",60023),clone:o("clone",60024),desktopDownload:o("desktop-download",60024),beaker:o("beaker",60025),microscope:o("microscope",60025),vm:o("vm",60026),deviceDesktop:o("device-desktop",60026),file:o("file",60027),fileText:o("file-text",60027),more:o("more",60028),ellipsis:o("ellipsis",60028),kebabHorizontal:o("kebab-horizontal",60028),mailReply:o("mail-reply",60029),reply:o("reply",60029),organization:o("organization",60030),organizationFilled:o("organization-filled",60030),organizationOutline:o("organization-outline",60030),newFile:o("new-file",60031),fileAdd:o("file-add",60031),newFolder:o("new-folder",60032),fileDirectoryCreate:o("file-directory-create",60032),trash:o("trash",60033),trashcan:o("trashcan",60033),history:o("history",60034),clock:o("clock",60034),folder:o("folder",60035),fileDirectory:o("file-directory",60035),symbolFolder:o("symbol-folder",60035),logoGithub:o("logo-github",60036),markGithub:o("mark-github",60036),github:o("github",60036),terminal:o("terminal",60037),console:o("console",60037),repl:o("repl",60037),zap:o("zap",60038),symbolEvent:o("symbol-event",60038),error:o("error",60039),stop:o("stop",60039),variable:o("variable",60040),symbolVariable:o("symbol-variable",60040),array:o("array",60042),symbolArray:o("symbol-array",60042),symbolModule:o("symbol-module",60043),symbolPackage:o("symbol-package",60043),symbolNamespace:o("symbol-namespace",60043),symbolObject:o("symbol-object",60043),symbolMethod:o("symbol-method",60044),symbolFunction:o("symbol-function",60044),symbolConstructor:o("symbol-constructor",60044),symbolBoolean:o("symbol-boolean",60047),symbolNull:o("symbol-null",60047),symbolNumeric:o("symbol-numeric",60048),symbolNumber:o("symbol-number",60048),symbolStructure:o("symbol-structure",60049),symbolStruct:o("symbol-struct",60049),symbolParameter:o("symbol-parameter",60050),symbolTypeParameter:o("symbol-type-parameter",60050),symbolKey:o("symbol-key",60051),symbolText:o("symbol-text",60051),symbolReference:o("symbol-reference",60052),goToFile:o("go-to-file",60052),symbolEnum:o("symbol-enum",60053),symbolValue:o("symbol-value",60053),symbolRuler:o("symbol-ruler",60054),symbolUnit:o("symbol-unit",60054),activateBreakpoints:o("activate-breakpoints",60055),archive:o("archive",60056),arrowBoth:o("arrow-both",60057),arrowDown:o("arrow-down",60058),arrowLeft:o("arrow-left",60059),arrowRight:o("arrow-right",60060),arrowSmallDown:o("arrow-small-down",60061),arrowSmallLeft:o("arrow-small-left",60062),arrowSmallRight:o("arrow-small-right",60063),arrowSmallUp:o("arrow-small-up",60064),arrowUp:o("arrow-up",60065),bell:o("bell",60066),bold:o("bold",60067),book:o("book",60068),bookmark:o("bookmark",60069),debugBreakpointConditionalUnverified:o("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:o("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:o("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:o("debug-breakpoint-data-unverified",60072),debugBreakpointData:o("debug-breakpoint-data",60073),debugBreakpointDataDisabled:o("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:o("debug-breakpoint-log-unverified",60074),debugBreakpointLog:o("debug-breakpoint-log",60075),debugBreakpointLogDisabled:o("debug-breakpoint-log-disabled",60075),briefcase:o("briefcase",60076),broadcast:o("broadcast",60077),browser:o("browser",60078),bug:o("bug",60079),calendar:o("calendar",60080),caseSensitive:o("case-sensitive",60081),check:o("check",60082),checklist:o("checklist",60083),chevronDown:o("chevron-down",60084),dropDownButton:o("drop-down-button",60084),chevronLeft:o("chevron-left",60085),chevronRight:o("chevron-right",60086),chevronUp:o("chevron-up",60087),chromeClose:o("chrome-close",60088),chromeMaximize:o("chrome-maximize",60089),chromeMinimize:o("chrome-minimize",60090),chromeRestore:o("chrome-restore",60091),circle:o("circle",60092),circleOutline:o("circle-outline",60092),debugBreakpointUnverified:o("debug-breakpoint-unverified",60092),circleSlash:o("circle-slash",60093),circuitBoard:o("circuit-board",60094),clearAll:o("clear-all",60095),clippy:o("clippy",60096),closeAll:o("close-all",60097),cloudDownload:o("cloud-download",60098),cloudUpload:o("cloud-upload",60099),code:o("code",60100),collapseAll:o("collapse-all",60101),colorMode:o("color-mode",60102),commentDiscussion:o("comment-discussion",60103),compareChanges:o("compare-changes",60157),creditCard:o("credit-card",60105),dash:o("dash",60108),dashboard:o("dashboard",60109),database:o("database",60110),debugContinue:o("debug-continue",60111),debugDisconnect:o("debug-disconnect",60112),debugPause:o("debug-pause",60113),debugRestart:o("debug-restart",60114),debugStart:o("debug-start",60115),debugStepInto:o("debug-step-into",60116),debugStepOut:o("debug-step-out",60117),debugStepOver:o("debug-step-over",60118),debugStop:o("debug-stop",60119),debug:o("debug",60120),deviceCameraVideo:o("device-camera-video",60121),deviceCamera:o("device-camera",60122),deviceMobile:o("device-mobile",60123),diffAdded:o("diff-added",60124),diffIgnored:o("diff-ignored",60125),diffModified:o("diff-modified",60126),diffRemoved:o("diff-removed",60127),diffRenamed:o("diff-renamed",60128),diff:o("diff",60129),discard:o("discard",60130),editorLayout:o("editor-layout",60131),emptyWindow:o("empty-window",60132),exclude:o("exclude",60133),extensions:o("extensions",60134),eyeClosed:o("eye-closed",60135),fileBinary:o("file-binary",60136),fileCode:o("file-code",60137),fileMedia:o("file-media",60138),filePdf:o("file-pdf",60139),fileSubmodule:o("file-submodule",60140),fileSymlinkDirectory:o("file-symlink-directory",60141),fileSymlinkFile:o("file-symlink-file",60142),fileZip:o("file-zip",60143),files:o("files",60144),filter:o("filter",60145),flame:o("flame",60146),foldDown:o("fold-down",60147),foldUp:o("fold-up",60148),fold:o("fold",60149),folderActive:o("folder-active",60150),folderOpened:o("folder-opened",60151),gear:o("gear",60152),gift:o("gift",60153),gistSecret:o("gist-secret",60154),gist:o("gist",60155),gitCommit:o("git-commit",60156),gitCompare:o("git-compare",60157),gitMerge:o("git-merge",60158),githubAction:o("github-action",60159),githubAlt:o("github-alt",60160),globe:o("globe",60161),grabber:o("grabber",60162),graph:o("graph",60163),gripper:o("gripper",60164),heart:o("heart",60165),home:o("home",60166),horizontalRule:o("horizontal-rule",60167),hubot:o("hubot",60168),inbox:o("inbox",60169),issueClosed:o("issue-closed",60324),issueReopened:o("issue-reopened",60171),issues:o("issues",60172),italic:o("italic",60173),jersey:o("jersey",60174),json:o("json",60175),bracket:o("bracket",60175),kebabVertical:o("kebab-vertical",60176),key:o("key",60177),law:o("law",60178),lightbulbAutofix:o("lightbulb-autofix",60179),linkExternal:o("link-external",60180),link:o("link",60181),listOrdered:o("list-ordered",60182),listUnordered:o("list-unordered",60183),liveShare:o("live-share",60184),loading:o("loading",60185),location:o("location",60186),mailRead:o("mail-read",60187),mail:o("mail",60188),markdown:o("markdown",60189),megaphone:o("megaphone",60190),mention:o("mention",60191),milestone:o("milestone",60192),mortarBoard:o("mortar-board",60193),move:o("move",60194),multipleWindows:o("multiple-windows",60195),mute:o("mute",60196),noNewline:o("no-newline",60197),note:o("note",60198),octoface:o("octoface",60199),openPreview:o("open-preview",60200),package_:o("package",60201),paintcan:o("paintcan",60202),pin:o("pin",60203),play:o("play",60204),run:o("run",60204),plug:o("plug",60205),preserveCase:o("preserve-case",60206),preview:o("preview",60207),project:o("project",60208),pulse:o("pulse",60209),question:o("question",60210),quote:o("quote",60211),radioTower:o("radio-tower",60212),reactions:o("reactions",60213),references:o("references",60214),refresh:o("refresh",60215),regex:o("regex",60216),remoteExplorer:o("remote-explorer",60217),remote:o("remote",60218),remove:o("remove",60219),replaceAll:o("replace-all",60220),replace:o("replace",60221),repoClone:o("repo-clone",60222),repoForcePush:o("repo-force-push",60223),repoPull:o("repo-pull",60224),repoPush:o("repo-push",60225),report:o("report",60226),requestChanges:o("request-changes",60227),rocket:o("rocket",60228),rootFolderOpened:o("root-folder-opened",60229),rootFolder:o("root-folder",60230),rss:o("rss",60231),ruby:o("ruby",60232),saveAll:o("save-all",60233),saveAs:o("save-as",60234),save:o("save",60235),screenFull:o("screen-full",60236),screenNormal:o("screen-normal",60237),searchStop:o("search-stop",60238),server:o("server",60240),settingsGear:o("settings-gear",60241),settings:o("settings",60242),shield:o("shield",60243),smiley:o("smiley",60244),sortPrecedence:o("sort-precedence",60245),splitHorizontal:o("split-horizontal",60246),splitVertical:o("split-vertical",60247),squirrel:o("squirrel",60248),starFull:o("star-full",60249),starHalf:o("star-half",60250),symbolClass:o("symbol-class",60251),symbolColor:o("symbol-color",60252),symbolCustomColor:o("symbol-customcolor",60252),symbolConstant:o("symbol-constant",60253),symbolEnumMember:o("symbol-enum-member",60254),symbolField:o("symbol-field",60255),symbolFile:o("symbol-file",60256),symbolInterface:o("symbol-interface",60257),symbolKeyword:o("symbol-keyword",60258),symbolMisc:o("symbol-misc",60259),symbolOperator:o("symbol-operator",60260),symbolProperty:o("symbol-property",60261),wrench:o("wrench",60261),wrenchSubaction:o("wrench-subaction",60261),symbolSnippet:o("symbol-snippet",60262),tasklist:o("tasklist",60263),telescope:o("telescope",60264),textSize:o("text-size",60265),threeBars:o("three-bars",60266),thumbsdown:o("thumbsdown",60267),thumbsup:o("thumbsup",60268),tools:o("tools",60269),triangleDown:o("triangle-down",60270),triangleLeft:o("triangle-left",60271),triangleRight:o("triangle-right",60272),triangleUp:o("triangle-up",60273),twitter:o("twitter",60274),unfold:o("unfold",60275),unlock:o("unlock",60276),unmute:o("unmute",60277),unverified:o("unverified",60278),verified:o("verified",60279),versions:o("versions",60280),vmActive:o("vm-active",60281),vmOutline:o("vm-outline",60282),vmRunning:o("vm-running",60283),watch:o("watch",60284),whitespace:o("whitespace",60285),wholeWord:o("whole-word",60286),window:o("window",60287),wordWrap:o("word-wrap",60288),zoomIn:o("zoom-in",60289),zoomOut:o("zoom-out",60290),listFilter:o("list-filter",60291),listFlat:o("list-flat",60292),listSelection:o("list-selection",60293),selection:o("selection",60293),listTree:o("list-tree",60294),debugBreakpointFunctionUnverified:o("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:o("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:o("debug-breakpoint-function-disabled",60296),debugStackframeActive:o("debug-stackframe-active",60297),circleSmallFilled:o("circle-small-filled",60298),debugStackframeDot:o("debug-stackframe-dot",60298),debugStackframe:o("debug-stackframe",60299),debugStackframeFocused:o("debug-stackframe-focused",60299),debugBreakpointUnsupported:o("debug-breakpoint-unsupported",60300),symbolString:o("symbol-string",60301),debugReverseContinue:o("debug-reverse-continue",60302),debugStepBack:o("debug-step-back",60303),debugRestartFrame:o("debug-restart-frame",60304),callIncoming:o("call-incoming",60306),callOutgoing:o("call-outgoing",60307),menu:o("menu",60308),expandAll:o("expand-all",60309),feedback:o("feedback",60310),groupByRefType:o("group-by-ref-type",60311),ungroupByRefType:o("ungroup-by-ref-type",60312),account:o("account",60313),bellDot:o("bell-dot",60314),debugConsole:o("debug-console",60315),library:o("library",60316),output:o("output",60317),runAll:o("run-all",60318),syncIgnored:o("sync-ignored",60319),pinned:o("pinned",60320),githubInverted:o("github-inverted",60321),debugAlt:o("debug-alt",60305),serverProcess:o("server-process",60322),serverEnvironment:o("server-environment",60323),pass:o("pass",60324),stopCircle:o("stop-circle",60325),playCircle:o("play-circle",60326),record:o("record",60327),debugAltSmall:o("debug-alt-small",60328),vmConnect:o("vm-connect",60329),cloud:o("cloud",60330),merge:o("merge",60331),exportIcon:o("export",60332),graphLeft:o("graph-left",60333),magnet:o("magnet",60334),notebook:o("notebook",60335),redo:o("redo",60336),checkAll:o("check-all",60337),pinnedDirty:o("pinned-dirty",60338),passFilled:o("pass-filled",60339),circleLargeFilled:o("circle-large-filled",60340),circleLarge:o("circle-large",60341),circleLargeOutline:o("circle-large-outline",60341),combine:o("combine",60342),gather:o("gather",60342),table:o("table",60343),variableGroup:o("variable-group",60344),typeHierarchy:o("type-hierarchy",60345),typeHierarchySub:o("type-hierarchy-sub",60346),typeHierarchySuper:o("type-hierarchy-super",60347),gitPullRequestCreate:o("git-pull-request-create",60348),runAbove:o("run-above",60349),runBelow:o("run-below",60350),notebookTemplate:o("notebook-template",60351),debugRerun:o("debug-rerun",60352),workspaceTrusted:o("workspace-trusted",60353),workspaceUntrusted:o("workspace-untrusted",60354),workspaceUnspecified:o("workspace-unspecified",60355),terminalCmd:o("terminal-cmd",60356),terminalDebian:o("terminal-debian",60357),terminalLinux:o("terminal-linux",60358),terminalPowershell:o("terminal-powershell",60359),terminalTmux:o("terminal-tmux",60360),terminalUbuntu:o("terminal-ubuntu",60361),terminalBash:o("terminal-bash",60362),arrowSwap:o("arrow-swap",60363),copy:o("copy",60364),personAdd:o("person-add",60365),filterFilled:o("filter-filled",60366),wand:o("wand",60367),debugLineByLine:o("debug-line-by-line",60368),inspect:o("inspect",60369),layers:o("layers",60370),layersDot:o("layers-dot",60371),layersActive:o("layers-active",60372),compass:o("compass",60373),compassDot:o("compass-dot",60374),compassActive:o("compass-active",60375),azure:o("azure",60376),issueDraft:o("issue-draft",60377),gitPullRequestClosed:o("git-pull-request-closed",60378),gitPullRequestDraft:o("git-pull-request-draft",60379),debugAll:o("debug-all",60380),debugCoverage:o("debug-coverage",60381),runErrors:o("run-errors",60382),folderLibrary:o("folder-library",60383),debugContinueSmall:o("debug-continue-small",60384),beakerStop:o("beaker-stop",60385),graphLine:o("graph-line",60386),graphScatter:o("graph-scatter",60387),pieChart:o("pie-chart",60388),bracketDot:o("bracket-dot",60389),bracketError:o("bracket-error",60390),lockSmall:o("lock-small",60391),azureDevops:o("azure-devops",60392),verifiedFilled:o("verified-filled",60393),newLine:o("newline",60394),layout:o("layout",60395),layoutActivitybarLeft:o("layout-activitybar-left",60396),layoutActivitybarRight:o("layout-activitybar-right",60397),layoutPanelLeft:o("layout-panel-left",60398),layoutPanelCenter:o("layout-panel-center",60399),layoutPanelJustify:o("layout-panel-justify",60400),layoutPanelRight:o("layout-panel-right",60401),layoutPanel:o("layout-panel",60402),layoutSidebarLeft:o("layout-sidebar-left",60403),layoutSidebarRight:o("layout-sidebar-right",60404),layoutStatusbar:o("layout-statusbar",60405),layoutMenubar:o("layout-menubar",60406),layoutCentered:o("layout-centered",60407),layoutSidebarRightOff:o("layout-sidebar-right-off",60416),layoutPanelOff:o("layout-panel-off",60417),layoutSidebarLeftOff:o("layout-sidebar-left-off",60418),target:o("target",60408),indent:o("indent",60409),recordSmall:o("record-small",60410),errorSmall:o("error-small",60411),arrowCircleDown:o("arrow-circle-down",60412),arrowCircleLeft:o("arrow-circle-left",60413),arrowCircleRight:o("arrow-circle-right",60414),arrowCircleUp:o("arrow-circle-up",60415),heartFilled:o("heart-filled",60420),map:o("map",60421),mapFilled:o("map-filled",60422),circleSmall:o("circle-small",60423),bellSlash:o("bell-slash",60424),bellSlashDot:o("bell-slash-dot",60425),commentUnresolved:o("comment-unresolved",60426),gitPullRequestGoToChanges:o("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:o("git-pull-request-new-changes",60428),searchFuzzy:o("search-fuzzy",60429),commentDraft:o("comment-draft",60430),send:o("send",60431),sparkle:o("sparkle",60432),insert:o("insert",60433),dialogError:o("dialog-error","error"),dialogWarning:o("dialog-warning","warning"),dialogInfo:o("dialog-info","info"),dialogClose:o("dialog-close","close"),treeItemExpanded:o("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:o("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:o("tree-filter-on-type-off","list-selection"),treeFilterClear:o("tree-filter-clear","close"),treeItemLoading:o("tree-item-loading","loading"),menuSelection:o("menu-selection","check"),menuSubmenu:o("menu-submenu","chevron-right"),menuBarMore:o("menubar-more","more"),scrollbarButtonLeft:o("scrollbar-button-left","triangle-left"),scrollbarButtonRight:o("scrollbar-button-right","triangle-right"),scrollbarButtonUp:o("scrollbar-button-up","triangle-up"),scrollbarButtonDown:o("scrollbar-button-down","triangle-down"),toolBarMore:o("toolbar-more","more"),quickInputBack:o("quick-input-back","arrow-left")}}),define(ge[21],pe([1,0,8]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const u=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([f,I])=>{u[f]=I&&typeof I=="object"?L(I):I}),u}e.deepClone=L;function o(h){if(!h||typeof h!="object")return h;const u=[h];for(;u.length>0;){const f=u.shift();Object.freeze(f);for(const I in f)if(P.call(f,I)){const O=f[I];typeof O=="object"&&!Object.isFrozen(O)&&!(0,w.isTypedArray)(O)&&u.push(O)}}return h}e.deepFreeze=o;const P=Object.prototype.hasOwnProperty;function C(h,u){return A(h,u,new Set)}e.cloneAndChange=C;function A(h,u,f){if((0,w.isUndefinedOrNull)(h))return h;const I=u(h);if(typeof I<"u")return I;if(Array.isArray(h)){const O=[];for(const t of h)O.push(A(t,u,f));return O}if((0,w.isObject)(h)){if(f.has(h))throw new Error("Cannot clone recursive data-structure");f.add(h);const O={};for(const t in h)P.call(h,t)&&(O[t]=A(h[t],u,f));return f.delete(h),O}return h}function v(h,u,f=!0){return(0,w.isObject)(h)?((0,w.isObject)(u)&&Object.keys(u).forEach(I=>{I in h?f&&((0,w.isObject)(h[I])&&(0,w.isObject)(u[I])?v(h[I],u[I],f):h[I]=u[I]):h[I]=u[I]}),h):u}e.mixin=v;function m(h,u){if(h===u)return!0;if(h==null||u===null||u===void 0||typeof h!=typeof u||typeof h!="object"||Array.isArray(h)!==Array.isArray(u))return!1;let f,I;if(Array.isArray(h)){if(h.length!==u.length)return!1;for(f=0;f<h.length;f++)if(!m(h[f],u[f]))return!1}else{const O=[];for(I in h)O.push(I);O.sort();const t=[];for(I in u)t.push(I);if(t.sort(),!m(O,t))return!1;for(f=0;f<O.length;f++)if(!m(h[O[f]],u[O[f]]))return!1}return!0}e.equals=m;function T(h){const u=new Set;return JSON.stringify(h,(f,I)=>{if((0,w.isObject)(I)||Array.isArray(I)){if(u.has(I))return"[Circular]";u.add(I)}return I})}e.safeStringify=T;function y(h,u){const f=Object.create(null);return!h||!u||Object.keys(u).forEach(O=>{const t=h[O],n=u[O];m(t,n)||(f[O]=n)}),f}e.distinct=y;function E(h,u){const f=u.toLowerCase(),I=Object.keys(h).find(O=>O.toLowerCase()===f);return I?h[I]:h[u]}e.getCaseInsensitive=E;function d(h,u){const f=Object.create(null);for(const[I,O]of Object.entries(h))u(I,O)&&(f[I]=O);return f}e.filter=d;function p(h){let u=[],f=Object.getPrototypeOf(h);for(;Object.prototype!==f;)u=u.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return u}e.getAllPropertyNames=p;function b(h){const u=[];for(const f of p(h))typeof h[f]=="function"&&u.push(f);return u}e.getAllMethodNames=b;function s(h,u){const f=O=>function(){const t=Array.prototype.slice.call(arguments,0);return u(O,t)},I={};for(const O of h)I[O]=f(O);return I}e.createProxyObject=s}),define(ge[95],pe([1,0,48]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(C){function A(v){return v&&typeof v=="object"&&typeof v.id=="string"}C.isThemeColor=A})(L||(e.ThemeColor=L={}));function o(C){return{id:C}}e.themeColorFromId=o;var P;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function v(u){const f=A.exec(u.id);if(!f)return v(w.Codicon.error);const[,I,O]=f,t=["codicon","codicon-"+I];return O&&t.push("codicon-modifier-"+O.substring(1)),t}C.asClassNameArray=v;function m(u){return v(u).join(" ")}C.asClassName=m;function T(u){return"."+v(u).join(".")}C.asCSSSelector=T;function y(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||L.isThemeColor(u.color))}C.isThemeIcon=y;const E=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function d(u){const f=E.exec(u);if(!f)return;const[,I]=f;return{id:I}}C.fromString=d;function p(u){return{id:u}}C.fromId=p;function b(u,f){let I=u.id;const O=I.lastIndexOf("~");return O!==-1&&(I=I.substring(0,O)),f&&(I=`${I}~${f}`),{id:I}}C.modify=b;function s(u){const f=u.id.lastIndexOf("~");if(f!==-1)return u.id.substring(f+1)}C.getModifier=s;function h(u,f){return u.id===f.id&&u.color?.id===f.color?.id}C.isEqual=h})(P||(e.ThemeIcon=P={}))}),define(ge[22],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(o){return w.test(o)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let o;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?o=crypto.getRandomValues.bind(crypto):o=function(A){for(let v=0;v<A.length;v++)A[v]=Math.floor(Math.random()*256);return A};const P=new Uint8Array(16),C=[];for(let A=0;A<256;A++)C.push(A.toString(16).padStart(2,"0"));return function(){o(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let v=0,m="";return m+=C[P[v++]],m+=C[P[v++]],m+=C[P[v++]],m+=C[P[v++]],m+="-",m+=C[P[v++]],m+=C[P[v++]],m+="-",m+=C[P[v++]],m+=C[P[v++]],m+="-",m+=C[P[v++]],m+=C[P[v++]],m+="-",m+=C[P[v++]],m+=C[P[v++]],m+=C[P[v++]],m+=C[P[v++]],m+=C[P[v++]],m+=C[P[v++]],m}}()}),define(ge[146],pe([1,0,18,46,22]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function P(v){return{id:(0,o.generateUuid)(),asString:async()=>v,asFile:()=>{},value:typeof v=="string"?v:void 0}}e.createStringDataTransferItem=P;function C(v,m,T){return{id:(0,o.generateUuid)(),asString:async()=>"",asFile:()=>({name:v,uri:m,data:T}),value:void 0}}e.createFileDataTransferItem=C;class A{constructor(){this.a=new Map}get size(){let m=0;return this.forEach(()=>m++),m}has(m){return this.a.has(this.b(m))}matches(m){if(this.has(m))return!0;if(m.toLowerCase()==="files")return L.Iterable.some(this.values(),p=>p.asFile());if(m==="*/*")return this.a.size>0;const T=this.b(m).match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!T)return!1;const[y,E,d]=T;return d==="*"?L.Iterable.some(this.a.keys(),p=>p.startsWith(E+"/")):!1}get(m){return this.a.get(this.b(m))?.[0]}append(m,T){const y=this.a.get(m);y?y.push(T):this.a.set(this.b(m),[T])}replace(m,T){this.a.set(this.b(m),[T])}delete(m){this.a.delete(this.b(m))}*entries(){for(const[m,T]of this.a.entries())for(const y of T)yield[m,y]}values(){return Array.from(this.a.values()).flat()}forEach(m){for(const[T,y]of this.entries())m(y,T)}b(m){return m.toLowerCase()}}e.VSDataTransfer=A,e.UriList=Object.freeze({create:v=>(0,w.distinct)(v.map(m=>m.toString())).join(`\r
`),split:v=>v.split(`\r
`),parse:v=>e.UriList.split(v).filter(m=>!m.startsWith("#"))})}),function(){"use strict";function oe(e,w,L){function o(d){return new Promise(p=>w.exists(d,p))}function P(d){return new Promise((p,b)=>{const s=new Date;w.utimes(d,s,s,h=>h?b(h):p())})}function C(d){return new Promise((p,b)=>w.mkdir(d,{recursive:!0},s=>s&&s.code!=="EEXIST"?b(s):p(d)))}function A(d){return new Promise((p,b)=>w.rm(d,{recursive:!0,force:!0,maxRetries:3},s=>s?b(s):p()))}function v(d){return new Promise((p,b)=>w.readFile(d,"utf8",(s,h)=>s?b(s):p(h)))}function m(d,p){return new Promise((b,s)=>w.writeFile(d,p,"utf8",h=>h?s(h):b()))}async function T(d){const p=e.join(d,"languagepacks.json");try{return JSON.parse(await v(p))}catch{}}function y(d,p){try{for(;p;){if(d[p])return p;{const b=p.lastIndexOf("-");if(b>0)p=p.substring(0,b);else return}}}catch(b){console.error("Resolving language pack configuration failed.",b)}}function E(d,p,b,s,h){const u=function(I){return L.mark("code/didGenerateNls"),Promise.resolve({locale:I,osLocale:h,availableLanguages:{}})};if(L.mark("code/willGenerateNls"),s==="pseudo")return Promise.resolve({locale:s,osLocale:h,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:s,osLocale:h,availableLanguages:{}});if(s&&(s==="en"||s==="en-us"))return Promise.resolve({locale:s,osLocale:h,availableLanguages:{}});const f=s;try{return d?T(p).then(I=>{if(!I)return u(f);const O=y(I,s);if(!O)return u(f);s=O;const t=I[s];let n;return!t||typeof t.hash!="string"||!t.translations||typeof(n=t.translations.vscode)!="string"?u(f):o(n).then(r=>{if(!r)return u(f);const i=t.hash+"."+s,a=e.join(p,"clp",i),l=e.join(a,d),c=e.join(a,"tcf.json"),g=e.join(a,"corrupted.info"),D={locale:f,osLocale:h,availableLanguages:{"*":s},_languagePackId:i,_translationsConfigFile:c,_cacheRoot:a,_resolvedLanguagePackCoreLocation:l,_corruptedFile:g};return o(g).then(k=>{let S;return k?S=A(a):S=Promise.resolve(void 0),S.then(()=>o(l).then(F=>F?(P(l).catch(()=>{}),L.mark("code/didGenerateNls"),D):C(l).then(()=>Promise.all([v(b),v(n)])).then(H=>{const te=JSON.parse(H[0]),ce=JSON.parse(H[1]).contents,le=Object.keys(te.bundles),ue=[];for(const ve of le){const K=te.bundles[ve],ee=Object.create(null);for(const z of K){const q=te.keys[z],G=te.messages[z],ne=ce[z];let se;if(ne){se=[];for(let de=0;de<q.length;de++){const W=q[de],x=typeof W=="string"?W:W.key;let N=ne[x];N===void 0&&(N=G[de]),se.push(N)}}else se=G;ee[z]=se}ue.push(m(e.join(l,ve.replace(/\//g,"!")+".nls.json"),JSON.stringify(ee)))}return ue.push(m(c,JSON.stringify(t.translations))),Promise.all(ue)}).then(()=>(L.mark("code/didGenerateNls"),D)).catch(H=>(console.error("Generating translation files failed.",H),u(s)))))})})}):u(f)}catch(I){return console.error("Generating translation files failed.",I),u(s)}}return{getNLSConfiguration:E}}if(typeof define=="function")define(ge[147],pe([73,33,41]),function(e,w,L){return oe(e,w,L)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),w=require("fs"),L=require("../common/performance");module.exports=oe(e,w,L)}else throw new Error("Unknown context")}(),define(ge[148],pe([1,0,28]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function o(C){const A=C.replace(/\-/g,":").toLowerCase();return!L.has(A)}function P(){const C=(0,w.networkInterfaces)();for(const A in C){const v=C[A];if(v){for(const{mac:m}of v)if(o(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=P}),define(ge[149],pe([1,0,74]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(A,v,m,T=1){let y=!1;return new Promise(E=>{const d=setTimeout(()=>{if(!y)return y=!0,E(0)},m);o(A,v,T,p=>{if(!y)return y=!0,clearTimeout(d),E(p)})})}e.findFreePort=L;function o(A,v,m,T){if(v===0)return T(0);const y=new w.Socket;y.once("connect",()=>(C(y),o(A+m,v-1,m,T))),y.once("data",()=>{}),y.once("error",E=>(C(y),E.code!=="ECONNREFUSED"?o(A+m,v-1,m,T):T(A))),y.connect(A,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(A,v,m,T="127.0.0.1"){let y=!1,E,d=1;const p=w.createServer({pauseOnConnect:!0});function b(s,h){y||(y=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),h(s))}return new Promise(s=>{E=setTimeout(()=>{b(0,s)},m),p.on("listening",()=>{b(A,s)}),p.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&d<v?(A++,d++,p.listen(A,T)):b(0,s)}),p.on("close",()=>{b(0,s)}),p.listen(A,T)})}e.findFreePortFaster=P;function C(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(v){console.error(v)}}}),define(ge[96],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class w{constructor(o,P){this.lineNumber=o,this.column=P}with(o=this.lineNumber,P=this.column){return o===this.lineNumber&&P===this.column?this:new w(o,P)}delta(o=0,P=0){return this.with(this.lineNumber+o,this.column+P)}equals(o){return w.equals(this,o)}static equals(o,P){return!o&&!P?!0:!!o&&!!P&&o.lineNumber===P.lineNumber&&o.column===P.column}isBefore(o){return w.isBefore(this,o)}static isBefore(o,P){return o.lineNumber<P.lineNumber?!0:P.lineNumber<o.lineNumber?!1:o.column<P.column}isBeforeOrEqual(o){return w.isBeforeOrEqual(this,o)}static isBeforeOrEqual(o,P){return o.lineNumber<P.lineNumber?!0:P.lineNumber<o.lineNumber?!1:o.column<=P.column}static compare(o,P){const C=o.lineNumber|0,A=P.lineNumber|0;if(C===A){const v=o.column|0,m=P.column|0;return v-m}return C-A}clone(){return new w(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(o){return new w(o.lineNumber,o.column)}static isIPosition(o){return o&&typeof o.lineNumber=="number"&&typeof o.column=="number"}}e.Position=w}),define(ge[49],pe([1,0,96]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(P,C,A,v){P>A||P===A&&C>v?(this.startLineNumber=A,this.startColumn=v,this.endLineNumber=P,this.endColumn=C):(this.startLineNumber=P,this.startColumn=C,this.endLineNumber=A,this.endColumn=v)}isEmpty(){return L.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return L.containsPosition(this,P)}static containsPosition(P,C){return!(C.lineNumber<P.startLineNumber||C.lineNumber>P.endLineNumber||C.lineNumber===P.startLineNumber&&C.column<P.startColumn||C.lineNumber===P.endLineNumber&&C.column>P.endColumn)}static strictContainsPosition(P,C){return!(C.lineNumber<P.startLineNumber||C.lineNumber>P.endLineNumber||C.lineNumber===P.startLineNumber&&C.column<=P.startColumn||C.lineNumber===P.endLineNumber&&C.column>=P.endColumn)}containsRange(P){return L.containsRange(this,P)}static containsRange(P,C){return!(C.startLineNumber<P.startLineNumber||C.endLineNumber<P.startLineNumber||C.startLineNumber>P.endLineNumber||C.endLineNumber>P.endLineNumber||C.startLineNumber===P.startLineNumber&&C.startColumn<P.startColumn||C.endLineNumber===P.endLineNumber&&C.endColumn>P.endColumn)}strictContainsRange(P){return L.strictContainsRange(this,P)}static strictContainsRange(P,C){return!(C.startLineNumber<P.startLineNumber||C.endLineNumber<P.startLineNumber||C.startLineNumber>P.endLineNumber||C.endLineNumber>P.endLineNumber||C.startLineNumber===P.startLineNumber&&C.startColumn<=P.startColumn||C.endLineNumber===P.endLineNumber&&C.endColumn>=P.endColumn)}plusRange(P){return L.plusRange(this,P)}static plusRange(P,C){let A,v,m,T;return C.startLineNumber<P.startLineNumber?(A=C.startLineNumber,v=C.startColumn):C.startLineNumber===P.startLineNumber?(A=C.startLineNumber,v=Math.min(C.startColumn,P.startColumn)):(A=P.startLineNumber,v=P.startColumn),C.endLineNumber>P.endLineNumber?(m=C.endLineNumber,T=C.endColumn):C.endLineNumber===P.endLineNumber?(m=C.endLineNumber,T=Math.max(C.endColumn,P.endColumn)):(m=P.endLineNumber,T=P.endColumn),new L(A,v,m,T)}intersectRanges(P){return L.intersectRanges(this,P)}static intersectRanges(P,C){let A=P.startLineNumber,v=P.startColumn,m=P.endLineNumber,T=P.endColumn;const y=C.startLineNumber,E=C.startColumn,d=C.endLineNumber,p=C.endColumn;return A<y?(A=y,v=E):A===y&&(v=Math.max(v,E)),m>d?(m=d,T=p):m===d&&(T=Math.min(T,p)),A>m||A===m&&v>T?null:new L(A,v,m,T)}equalsRange(P){return L.equalsRange(this,P)}static equalsRange(P,C){return!P&&!C?!0:!!P&&!!C&&P.startLineNumber===C.startLineNumber&&P.startColumn===C.startColumn&&P.endLineNumber===C.endLineNumber&&P.endColumn===C.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(P){return new w.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(P){return new w.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,C){return new L(this.startLineNumber,this.startColumn,P,C)}setStartPosition(P,C){return new L(P,C,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(P){return new L(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(P){return new L(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new L(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,C=P){return new L(P.lineNumber,P.column,C.lineNumber,C.column)}static lift(P){return P?new L(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,C){return!(P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<C.startColumn||C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<P.startColumn)}static areIntersecting(P,C){return!(P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<=C.startColumn||C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,C){if(P&&C){const m=P.startLineNumber|0,T=C.startLineNumber|0;if(m===T){const y=P.startColumn|0,E=C.startColumn|0;if(y===E){const d=P.endLineNumber|0,p=C.endLineNumber|0;if(d===p){const b=P.endColumn|0,s=C.endColumn|0;return b-s}return d-p}return y-E}return m-T}return(P?1:0)-(C?1:0)}static compareRangesUsingEnds(P,C){return P.endLineNumber===C.endLineNumber?P.endColumn===C.endColumn?P.startLineNumber===C.startLineNumber?P.startColumn-C.startColumn:P.startLineNumber-C.startLineNumber:P.endColumn-C.endColumn:P.endLineNumber-C.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=L}),define(ge[150],pe([9,10]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(ge[151],pe([9,10]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(ge[152],pe([1,0,151]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,o=L*60,P=o*24,C=P*7,A=P*30,v=P*365;function m(y,E,d,p){typeof y!="number"&&(y=y.getTime());const b=Math.round((new Date().getTime()-y)/1e3);if(b<-30)return(0,w.localize)(0,null,m(new Date().getTime()+b*1e3,!1));if(!p&&b<30)return(0,w.localize)(1,null);let s;return b<L?(s=b,E?s===1?d?(0,w.localize)(2,null,s):(0,w.localize)(3,null,s):d?(0,w.localize)(4,null,s):(0,w.localize)(5,null,s):s===1?d?(0,w.localize)(6,null,s):(0,w.localize)(7,null,s):d?(0,w.localize)(8,null,s):(0,w.localize)(9,null,s)):b<o?(s=Math.floor(b/L),E?s===1?d?(0,w.localize)(10,null,s):(0,w.localize)(11,null,s):d?(0,w.localize)(12,null,s):(0,w.localize)(13,null,s):s===1?d?(0,w.localize)(14,null,s):(0,w.localize)(15,null,s):d?(0,w.localize)(16,null,s):(0,w.localize)(17,null,s)):b<P?(s=Math.floor(b/o),E?s===1?d?(0,w.localize)(18,null,s):(0,w.localize)(19,null,s):d?(0,w.localize)(20,null,s):(0,w.localize)(21,null,s):s===1?d?(0,w.localize)(22,null,s):(0,w.localize)(23,null,s):d?(0,w.localize)(24,null,s):(0,w.localize)(25,null,s)):b<C?(s=Math.floor(b/P),E?s===1?(0,w.localize)(26,null,s):(0,w.localize)(27,null,s):s===1?(0,w.localize)(28,null,s):(0,w.localize)(29,null,s)):b<A?(s=Math.floor(b/C),E?s===1?d?(0,w.localize)(30,null,s):(0,w.localize)(31,null,s):d?(0,w.localize)(32,null,s):(0,w.localize)(33,null,s):s===1?d?(0,w.localize)(34,null,s):(0,w.localize)(35,null,s):d?(0,w.localize)(36,null,s):(0,w.localize)(37,null,s)):b<v?(s=Math.floor(b/A),E?s===1?d?(0,w.localize)(38,null,s):(0,w.localize)(39,null,s):d?(0,w.localize)(40,null,s):(0,w.localize)(41,null,s):s===1?d?(0,w.localize)(42,null,s):(0,w.localize)(43,null,s):d?(0,w.localize)(44,null,s):(0,w.localize)(45,null,s)):(s=Math.floor(b/v),E?s===1?d?(0,w.localize)(46,null,s):(0,w.localize)(47,null,s):d?(0,w.localize)(48,null,s):(0,w.localize)(49,null,s):s===1?d?(0,w.localize)(50,null,s):(0,w.localize)(51,null,s):d?(0,w.localize)(52,null,s):(0,w.localize)(53,null,s))}e.fromNow=m;function T(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(ge[153],pe([9,10]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(ge[38],pe([1,0,18,8,153]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(y,E){return E&&(y.stack||y.stacktrace)?o.localize(0,null,A(y),C(y.stack)||C(y.stacktrace)):A(y)}function C(y){return Array.isArray(y)?y.join(`
`):y}function A(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?o.localize(1,null,y.message):y.message||o.localize(2,null)}function v(y=null,E=!1){if(!y)return o.localize(3,null);if(Array.isArray(y)){const d=w.coalesce(y),p=v(d[0],E);return d.length>1?o.localize(4,null,p,d.length):p}if(L.isString(y))return y;if(y.detail){const d=y.detail;if(d.error)return P(d.error,E);if(d.exception)return P(d.exception,E)}return y.stack?P(y,E):y.message?y.message:o.localize(5,null)}e.toErrorMessage=v;function m(y){const E=y;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=m;function T(y,E){let d;return typeof y=="string"?d=new Error(y):d=y,d.actions=E,d}e.createErrorWithActions=T}),define(ge[154],pe([9,10]),function(oe,e){return oe.create("vs/base/common/jsonErrorMessages",e)}),define(ge[155],pe([1,0,154]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(o){switch(o){case 1:return(0,w.localize)(0,null);case 2:return(0,w.localize)(1,null);case 3:return(0,w.localize)(2,null);case 4:return(0,w.localize)(3,null);case 5:return(0,w.localize)(4,null);case 6:return(0,w.localize)(5,null);case 7:return(0,w.localize)(6,null);case 8:return(0,w.localize)(7,null);case 9:return(0,w.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ge[156],pe([9,10]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(ge[3],pe([1,0,156]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,o=!1,P=!1,C=!1,A=!1,v=!1,m=!1,T=!1,y=!1,E=!1,d,p=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT,s,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const f=typeof u?.versions?.electron=="string",I=f&&u?.type==="renderer";if(typeof navigator=="object"&&!I)h=navigator.userAgent,L=h.indexOf("Windows")>=0,o=h.indexOf("Macintosh")>=0,T=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=h.indexOf("Linux")>=0,E=h?.indexOf("Mobi")>=0,v=!0,d=w.getConfiguredDefaultLocale(w.localize(0,null))||e.LANGUAGE_DEFAULT,p=d,b=navigator.language;else if(typeof u=="object"){L=u.platform==="win32",o=u.platform==="darwin",P=u.platform==="linux",C=P&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,m=f,y=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const g=u.env.VSCODE_NLS_CONFIG;if(g)try{const D=JSON.parse(g),k=D.availableLanguages["*"];d=D.locale,b=D.osLocale,p=k||e.LANGUAGE_DEFAULT,s=D._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var O;(function(g){g[g.Web=0]="Web",g[g.Mac=1]="Mac",g[g.Linux=2]="Linux",g[g.Windows=3]="Windows"})(O||(e.Platform=O={}));function t(g){switch(g){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let n=0;o?n=1:L?n=3:P&&(n=2),e.isWindows=L,e.isMacintosh=o,e.isLinux=P,e.isLinuxSnap=C,e.isNative=A,e.isElectron=m,e.isWeb=v,e.isWebWorker=v&&typeof e.globals.importScripts=="function",e.isIOS=T,e.isMobile=E,e.isCI=y,e.platform=n,e.userAgent=h,e.language=p;var r;(function(g){function D(){return e.language}g.value=D;function k(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}g.isDefaultVariant=k;function S(){return e.language==="en"}g.isDefault=S})(r||(e.Language=r={})),e.locale=d,e.platformLocale=b,e.translationsConfigFile=s,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const g=[];e.globals.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let S=0,F=g.length;S<F;S++){const H=g[S];if(H.id===k.data.vscodeScheduleAsyncWork){g.splice(S,1),H.callback();return}}});let D=0;return k=>{const S=++D;g.push({id:S,callback:k}),e.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return g=>setTimeout(g)})();var i;(function(g){g[g.Windows=1]="Windows",g[g.Macintosh=2]="Macintosh",g[g.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=o||T?2:L?1:3;let a=!0,l=!1;function c(){if(!l){l=!0;const g=new Uint8Array(2);g[0]=1,g[1]=2,a=new Uint16Array(g.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ge[29],pe([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof w.globals.vscode<"u"&&typeof w.globals.vscode.process<"u"){const o=w.globals.vscode.process;L={get platform(){return o.platform},get arch(){return o.arch},get env(){return o.env},cwd(){return o.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ge[7],pe([1,0,29]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,o=97,P=90,C=122,A=46,v=47,m=92,T=58,y=63;class E extends Error{constructor(n,r,i){let a;typeof r=="string"&&r.indexOf("not ")===0?(a="must not be",r=r.replace(/^not /,"")):a="must be";const l=n.indexOf(".")!==-1?"property":"argument";let c=`The "${n}" ${l} ${a} of type ${r}`;c+=`. Received type ${typeof i}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,n){if(t===null||typeof t!="object")throw new E(n,"Object",t)}function p(t,n){if(typeof t!="string")throw new E(n,"string",t)}const b=w.platform==="win32";function s(t){return t===v||t===m}function h(t){return t===v}function u(t){return t>=L&&t<=P||t>=o&&t<=C}function f(t,n,r,i){let a="",l=0,c=-1,g=0,D=0;for(let k=0;k<=t.length;++k){if(k<t.length)D=t.charCodeAt(k);else{if(i(D))break;D=v}if(i(D)){if(!(c===k-1||g===1))if(g===2){if(a.length<2||l!==2||a.charCodeAt(a.length-1)!==A||a.charCodeAt(a.length-2)!==A){if(a.length>2){const S=a.lastIndexOf(r);S===-1?(a="",l=0):(a=a.slice(0,S),l=a.length-1-a.lastIndexOf(r)),c=k,g=0;continue}else if(a.length!==0){a="",l=0,c=k,g=0;continue}}n&&(a+=a.length>0?`${r}..`:"..",l=2)}else a.length>0?a+=`${r}${t.slice(c+1,k)}`:a=t.slice(c+1,k),l=k-c-1;c=k,g=0}else D===A&&g!==-1?++g:g=-1}return a}function I(t,n){d(n,"pathObject");const r=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return r?r===n.root?`${r}${i}`:`${r}${t}${i}`:i}e.win32={resolve(...t){let n="",r="",i=!1;for(let a=t.length-1;a>=-1;a--){let l;if(a>=0){if(l=t[a],p(l,"path"),l.length===0)continue}else n.length===0?l=w.cwd():(l=w.env[`=${n}`]||w.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==n.toLowerCase()&&l.charCodeAt(2)===m)&&(l=`${n}\\`));const c=l.length;let g=0,D="",k=!1;const S=l.charCodeAt(0);if(c===1)s(S)&&(g=1,k=!0);else if(s(S))if(k=!0,s(l.charCodeAt(1))){let F=2,H=F;for(;F<c&&!s(l.charCodeAt(F));)F++;if(F<c&&F!==H){const te=l.slice(H,F);for(H=F;F<c&&s(l.charCodeAt(F));)F++;if(F<c&&F!==H){for(H=F;F<c&&!s(l.charCodeAt(F));)F++;(F===c||F!==H)&&(D=`\\\\${te}\\${l.slice(H,F)}`,g=F)}}}else g=1;else u(S)&&l.charCodeAt(1)===T&&(D=l.slice(0,2),g=2,c>2&&s(l.charCodeAt(2))&&(k=!0,g=3));if(D.length>0)if(n.length>0){if(D.toLowerCase()!==n.toLowerCase())continue}else n=D;if(i){if(n.length>0)break}else if(r=`${l.slice(g)}\\${r}`,i=k,k&&n.length>0)break}return r=f(r,!i,"\\",s),i?`${n}\\${r}`:`${n}${r}`||"."},normalize(t){p(t,"path");const n=t.length;if(n===0)return".";let r=0,i,a=!1;const l=t.charCodeAt(0);if(n===1)return h(l)?"\\":t;if(s(l))if(a=!0,s(t.charCodeAt(1))){let g=2,D=g;for(;g<n&&!s(t.charCodeAt(g));)g++;if(g<n&&g!==D){const k=t.slice(D,g);for(D=g;g<n&&s(t.charCodeAt(g));)g++;if(g<n&&g!==D){for(D=g;g<n&&!s(t.charCodeAt(g));)g++;if(g===n)return`\\\\${k}\\${t.slice(D)}\\`;g!==D&&(i=`\\\\${k}\\${t.slice(D,g)}`,r=g)}}}else r=1;else u(l)&&t.charCodeAt(1)===T&&(i=t.slice(0,2),r=2,n>2&&s(t.charCodeAt(2))&&(a=!0,r=3));let c=r<n?f(t.slice(r),!a,"\\",s):"";return c.length===0&&!a&&(c="."),c.length>0&&s(t.charCodeAt(n-1))&&(c+="\\"),i===void 0?a?`\\${c}`:c:a?`${i}\\${c}`:`${i}${c}`},isAbsolute(t){p(t,"path");const n=t.length;if(n===0)return!1;const r=t.charCodeAt(0);return s(r)||n>2&&u(r)&&t.charCodeAt(1)===T&&s(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,r;for(let l=0;l<t.length;++l){const c=t[l];p(c,"path"),c.length>0&&(n===void 0?n=r=c:n+=`\\${c}`)}if(n===void 0)return".";let i=!0,a=0;if(typeof r=="string"&&s(r.charCodeAt(0))){++a;const l=r.length;l>1&&s(r.charCodeAt(1))&&(++a,l>2&&(s(r.charCodeAt(2))?++a:i=!1))}if(i){for(;a<n.length&&s(n.charCodeAt(a));)a++;a>=2&&(n=`\\${n.slice(a)}`)}return e.win32.normalize(n)},relative(t,n){if(p(t,"from"),p(n,"to"),t===n)return"";const r=e.win32.resolve(t),i=e.win32.resolve(n);if(r===i||(t=r.toLowerCase(),n=i.toLowerCase(),t===n))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===m;)a++;let l=t.length;for(;l-1>a&&t.charCodeAt(l-1)===m;)l--;const c=l-a;let g=0;for(;g<n.length&&n.charCodeAt(g)===m;)g++;let D=n.length;for(;D-1>g&&n.charCodeAt(D-1)===m;)D--;const k=D-g,S=c<k?c:k;let F=-1,H=0;for(;H<S;H++){const ce=t.charCodeAt(a+H);if(ce!==n.charCodeAt(g+H))break;ce===m&&(F=H)}if(H!==S){if(F===-1)return i}else{if(k>S){if(n.charCodeAt(g+H)===m)return i.slice(g+H+1);if(H===2)return i.slice(g+H)}c>S&&(t.charCodeAt(a+H)===m?F=H:H===2&&(F=3)),F===-1&&(F=0)}let te="";for(H=a+F+1;H<=l;++H)(H===l||t.charCodeAt(H)===m)&&(te+=te.length===0?"..":"\\..");return g+=F,te.length>0?`${te}${i.slice(g,D)}`:(i.charCodeAt(g)===m&&++g,i.slice(g,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.win32.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===m){if(n.charCodeAt(1)===m){const r=n.charCodeAt(2);if(r!==y&&r!==A)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(u(n.charCodeAt(0))&&n.charCodeAt(1)===T&&n.charCodeAt(2)===m)return`\\\\?\\${n}`;return t},dirname(t){p(t,"path");const n=t.length;if(n===0)return".";let r=-1,i=0;const a=t.charCodeAt(0);if(n===1)return s(a)?t:".";if(s(a)){if(r=i=1,s(t.charCodeAt(1))){let g=2,D=g;for(;g<n&&!s(t.charCodeAt(g));)g++;if(g<n&&g!==D){for(D=g;g<n&&s(t.charCodeAt(g));)g++;if(g<n&&g!==D){for(D=g;g<n&&!s(t.charCodeAt(g));)g++;if(g===n)return t;g!==D&&(r=i=g+1)}}}}else u(a)&&t.charCodeAt(1)===T&&(r=n>2&&s(t.charCodeAt(2))?3:2,i=r);let l=-1,c=!0;for(let g=n-1;g>=i;--g)if(s(t.charCodeAt(g))){if(!c){l=g;break}}else c=!1;if(l===-1){if(r===-1)return".";l=r}return t.slice(0,l)},basename(t,n){n!==void 0&&p(n,"ext"),p(t,"path");let r=0,i=-1,a=!0,l;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===T&&(r=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let c=n.length-1,g=-1;for(l=t.length-1;l>=r;--l){const D=t.charCodeAt(l);if(s(D)){if(!a){r=l+1;break}}else g===-1&&(a=!1,g=l+1),c>=0&&(D===n.charCodeAt(c)?--c===-1&&(i=l):(c=-1,i=g))}return r===i?i=g:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=r;--l)if(s(t.charCodeAt(l))){if(!a){r=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){p(t,"path");let n=0,r=-1,i=0,a=-1,l=!0,c=0;t.length>=2&&t.charCodeAt(1)===T&&u(t.charCodeAt(0))&&(n=i=2);for(let g=t.length-1;g>=n;--g){const D=t.charCodeAt(g);if(s(D)){if(!l){i=g+1;break}continue}a===-1&&(l=!1,a=g+1),D===A?r===-1?r=g:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||a===-1||c===0||c===1&&r===a-1&&r===i+1?"":t.slice(r,a)},format:I.bind(null,"\\"),parse(t){p(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.length;let i=0,a=t.charCodeAt(0);if(r===1)return s(a)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(s(a)){if(i=1,s(t.charCodeAt(1))){let F=2,H=F;for(;F<r&&!s(t.charCodeAt(F));)F++;if(F<r&&F!==H){for(H=F;F<r&&s(t.charCodeAt(F));)F++;if(F<r&&F!==H){for(H=F;F<r&&!s(t.charCodeAt(F));)F++;F===r?i=F:F!==H&&(i=F+1)}}}}else if(u(a)&&t.charCodeAt(1)===T){if(r<=2)return n.root=n.dir=t,n;if(i=2,s(t.charCodeAt(2))){if(r===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let l=-1,c=i,g=-1,D=!0,k=t.length-1,S=0;for(;k>=i;--k){if(a=t.charCodeAt(k),s(a)){if(!D){c=k+1;break}continue}g===-1&&(D=!1,g=k+1),a===A?l===-1?l=k:S!==1&&(S=1):l!==-1&&(S=-1)}return g!==-1&&(l===-1||S===0||S===1&&l===g-1&&l===c+1?n.base=n.name=t.slice(c,g):(n.name=t.slice(c,l),n.base=t.slice(c,g),n.ext=t.slice(l,g))),c>0&&c!==i?n.dir=t.slice(0,c-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const O=(()=>{if(b){const t=/\\/g;return()=>{const n=w.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>w.cwd()})();e.posix={resolve(...t){let n="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const a=i>=0?t[i]:O();p(a,"path"),a.length!==0&&(n=`${a}/${n}`,r=a.charCodeAt(0)===v)}return n=f(n,!r,"/",h),r?`/${n}`:n.length>0?n:"."},normalize(t){if(p(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===v,r=t.charCodeAt(t.length-1)===v;return t=f(t,!n,"/",h),t.length===0?n?"/":r?"./":".":(r&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return p(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let n;for(let r=0;r<t.length;++r){const i=t[r];p(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.posix.normalize(n)},relative(t,n){if(p(t,"from"),p(n,"to"),t===n||(t=e.posix.resolve(t),n=e.posix.resolve(n),t===n))return"";const r=1,i=t.length,a=i-r,l=1,c=n.length-l,g=a<c?a:c;let D=-1,k=0;for(;k<g;k++){const F=t.charCodeAt(r+k);if(F!==n.charCodeAt(l+k))break;F===v&&(D=k)}if(k===g)if(c>g){if(n.charCodeAt(l+k)===v)return n.slice(l+k+1);if(k===0)return n.slice(l+k)}else a>g&&(t.charCodeAt(r+k)===v?D=k:k===0&&(D=0));let S="";for(k=r+D+1;k<=i;++k)(k===i||t.charCodeAt(k)===v)&&(S+=S.length===0?"..":"/..");return`${S}${n.slice(l+D)}`},toNamespacedPath(t){return t},dirname(t){if(p(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===v;let r=-1,i=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===v){if(!i){r=a;break}}else i=!1;return r===-1?n?"/":".":n&&r===1?"//":t.slice(0,r)},basename(t,n){n!==void 0&&p(n,"ext"),p(t,"path");let r=0,i=-1,a=!0,l;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let c=n.length-1,g=-1;for(l=t.length-1;l>=0;--l){const D=t.charCodeAt(l);if(D===v){if(!a){r=l+1;break}}else g===-1&&(a=!1,g=l+1),c>=0&&(D===n.charCodeAt(c)?--c===-1&&(i=l):(c=-1,i=g))}return r===i?i=g:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===v){if(!a){r=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){p(t,"path");let n=-1,r=0,i=-1,a=!0,l=0;for(let c=t.length-1;c>=0;--c){const g=t.charCodeAt(c);if(g===v){if(!a){r=c+1;break}continue}i===-1&&(a=!1,i=c+1),g===A?n===-1?n=c:l!==1&&(l=1):n!==-1&&(l=-1)}return n===-1||i===-1||l===0||l===1&&n===i-1&&n===r+1?"":t.slice(n,i)},format:I.bind(null,"/"),parse(t){p(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.charCodeAt(0)===v;let i;r?(n.root="/",i=1):i=0;let a=-1,l=0,c=-1,g=!0,D=t.length-1,k=0;for(;D>=i;--D){const S=t.charCodeAt(D);if(S===v){if(!g){l=D+1;break}continue}c===-1&&(g=!1,c=D+1),S===A?a===-1?a=D:k!==1&&(k=1):a!==-1&&(k=-1)}if(c!==-1){const S=l===0&&r?1:l;a===-1||k===0||k===1&&a===c-1&&a===l+1?n.base=n.name=t.slice(S,c):(n.name=t.slice(S,a),n.base=t.slice(S,c),n.ext=t.slice(a,c))}return l>0?n.dir=t.slice(0,l-1):r&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(ge[57],pe([1,0,7]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(T){const y=(0,w.extname)(T),E=L[y.toLowerCase()];return E!==void 0?E:C(T)}e.getMediaOrTextMime=P;function C(T){const y=(0,w.extname)(T);return o[y.toLowerCase()]}e.getMediaMime=C;function A(T){for(const y in o)if(o[y]===T)return y}e.getExtensionForMimeType=A;const v=/^(.+)\/(.+?)(;.+)?$/;function m(T,y){const E=v.exec(T);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:y?void 0:T}e.normalizeMimeType=m}),define(ge[58],pe([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(L||(e.Source=L={}));var o;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(o||(e.TerminateResponseCode=o={}));function P(A,...v){const m=v.reduce((E,d)=>(E[d]=!0,E),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(E=>!m[E]).forEach(E=>{for(let d=0;d<T.length;d++)if(E.search(T[d])!==-1){delete A[E];break}})}e.sanitizeProcessEnvironment=P;function C(A){A&&(delete A.DEBUG,w.isMacintosh&&delete A.DYLD_LIBRARY_PATH,w.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(ge[97],pe([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=w.globals.performance&&typeof w.globals.performance.now=="function";class o{static create(C=!0){return new o(C)}constructor(C){this.a=L&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?w.globals.performance.now():Date.now()}}e.StopWatch=o}),define(ge[6],pe([1,0,11,71,2,93,97]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,v=!1;var m;(function(l){l.None=()=>o.Disposable.None;function c(X){if(v){const{onDidAddListener:ie}=X,j=p.create();let $=0;X.onDidAddListener=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),ie?.()}}}function g(X,ie){return ue(X,()=>{},0,void 0,!0,void 0,ie)}l.defer=g;function D(X){return(ie,j=null,$)=>{let J=!1,V;return V=X(Z=>{if(!J)return V?V.dispose():J=!0,ie.call(j,Z)},null,$),J&&V.dispose(),V}}l.once=D;function k(X,ie,j){return le(($,J=null,V)=>X(Z=>$.call(J,ie(Z)),null,V),j)}l.map=k;function S(X,ie,j){return le(($,J=null,V)=>X(Z=>{ie(Z),$.call(J,Z)},null,V),j)}l.forEach=S;function F(X,ie,j){return le(($,J=null,V)=>X(Z=>ie(Z)&&$.call(J,Z),null,V),j)}l.filter=F;function H(X){return X}l.signal=H;function te(...X){return(ie,j=null,$)=>(0,o.combinedDisposable)(...X.map(J=>J(V=>ie.call(j,V),null,$)))}l.any=te;function ce(X,ie,j,$){let J=j;return k(X,V=>(J=ie(J,V),J),$)}l.reduce=ce;function le(X,ie){let j;const $={onWillAddFirstListener(){j=X(J.fire,J)},onDidRemoveLastListener(){j?.dispose()}};ie||c($);const J=new s($);return ie?.add(J),J.event}function ue(X,ie,j=100,$=!1,J=!1,V,Z){let Y,_,ae,Ee=0,Ce;const ke={leakWarningThreshold:V,onWillAddFirstListener(){Y=X(ze=>{Ee++,_=ie(_,ze),$&&!ae&&(Ue.fire(_),_=void 0),Ce=()=>{const me=_;_=void 0,ae=void 0,(!$||Ee>1)&&Ue.fire(me),Ee=0},typeof j=="number"?(clearTimeout(ae),ae=setTimeout(Ce,j)):ae===void 0&&(ae=0,queueMicrotask(Ce))})},onWillRemoveListener(){J&&Ee>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,Y.dispose()}};Z||c(ke);const Ue=new s(ke);return Z?.add(Ue),Ue.event}l.debounce=ue;function ve(X,ie=0,j){return l.debounce(X,($,J)=>$?($.push(J),$):[J],ie,void 0,!0,void 0,j)}l.accumulate=ve;function K(X,ie=($,J)=>$===J,j){let $=!0,J;return F(X,V=>{const Z=$||!ie(V,J);return $=!1,J=V,Z},j)}l.latch=K;function ee(X,ie,j){return[l.filter(X,ie,j),l.filter(X,$=>!ie($),j)]}l.split=ee;function z(X,ie=!1,j=[]){let $=j.slice(),J=X(Y=>{$?$.push(Y):Z.fire(Y)});const V=()=>{$?.forEach(Y=>Z.fire(Y)),$=null},Z=new s({onWillAddFirstListener(){J||(J=X(Y=>Z.fire(Y)))},onDidAddFirstListener(){$&&(ie?setTimeout(V):V())},onDidRemoveLastListener(){J&&J.dispose(),J=null}});return Z.event}l.buffer=z;class q{constructor(ie){this.event=ie,this.c=new o.DisposableStore}map(ie){return new q(k(this.event,ie,this.c))}forEach(ie){return new q(S(this.event,ie,this.c))}filter(ie){return new q(F(this.event,ie,this.c))}reduce(ie,j){return new q(ce(this.event,ie,j,this.c))}latch(){return new q(K(this.event,void 0,this.c))}debounce(ie,j=100,$=!1,J=!1,V){return new q(ue(this.event,ie,j,$,J,V,this.c))}on(ie,j,$){return this.event(ie,j,$)}once(ie,j,$){return D(this.event)(ie,j,$)}dispose(){this.c.dispose()}}function G(X){return new q(X)}l.chain=G;function ne(X,ie,j=$=>$){const $=(...Y)=>Z.fire(j(...Y)),J=()=>X.on(ie,$),V=()=>X.removeListener(ie,$),Z=new s({onWillAddFirstListener:J,onDidRemoveLastListener:V});return Z.event}l.fromNodeEventEmitter=ne;function se(X,ie,j=$=>$){const $=(...Y)=>Z.fire(j(...Y)),J=()=>X.addEventListener(ie,$),V=()=>X.removeEventListener(ie,$),Z=new s({onWillAddFirstListener:J,onDidRemoveLastListener:V});return Z.event}l.fromDOMEventEmitter=se;function de(X){return new Promise(ie=>D(X)(ie))}l.toPromise=de;function W(X,ie){return ie(void 0),X(j=>ie(j))}l.runAndSubscribe=W;function x(X,ie){let j=null;function $(V){j?.dispose(),j=new o.DisposableStore,ie(V,j)}$(void 0);const J=X(V=>$(V));return(0,o.toDisposable)(()=>{J.dispose(),j?.dispose()})}l.runAndSubscribeWithStore=x;class N{constructor(ie,j){this._observable=ie,this.c=0,this.d=!1;const $={onWillAddFirstListener:()=>{ie.addObserver(this)},onDidRemoveLastListener:()=>{ie.removeObserver(this)}};j||c($),this.emitter=new s($),j&&j.add(this.emitter)}beginUpdate(ie){this.c++}handlePossibleChange(ie){}handleChange(ie,j){this.d=!0}endUpdate(ie){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function R(X,ie){return new N(X,ie).emitter.event}l.fromObservable=R;function U(X){return ie=>{let j=0,$=!1;const J={beginUpdate(){j++},endUpdate(){j--,j===0&&(X.reportChanges(),$&&($=!1,ie()))},handlePossibleChange(){},handleChange(){$=!0}};return X.addObserver(J),{dispose(){X.removeObserver(J)}}}}l.fromObservableLight=U})(m||(e.Event=m={}));class T{constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${T.c++}`,T.all.add(this)}start(c){this.d=new C.StopWatch(!0),this.listenerCount=c}stop(){if(this.d){const c=this.d.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=T,T.all=new Set,T.c=0;let y=-1;function E(l){const c=y;return y=l,{dispose(){y=c}}}e.setGlobalLeakWarningThreshold=E;class d{constructor(c,g=Math.random().toString(18).slice(2,5)){this.threshold=c,this.name=g,this.d=0}dispose(){this.c?.clear()}check(c,g){const D=this.threshold;if(D<=0||g<D)return;this.c||(this.c=new Map);const k=this.c.get(c.value)||0;if(this.c.set(c.value,k+1),this.d-=1,this.d<=0){this.d=D*.5;let S,F=0;for(const[H,te]of this.c)(!S||F<te)&&(S=H,F=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${F}):`),console.warn(S)}return()=>{const S=this.c.get(c.value)||0;this.c.set(c.value,S-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(c,g,D){this.callback=c,this.callbackThis=g,this.stack=D,this.subscription=new o.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class s{constructor(c){this.j=!1,this.d=c,this.f=y>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??y):void 0,this.g=this.d?._profName?new T(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const c=Array.from(this.q);queueMicrotask(()=>{for(const g of c)g.subscription.isset()&&(g.subscription.unset(),g.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(c,g,D)=>{if(this.q||(this.q=new P.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),o.Disposable.None;const k=this.q.isEmpty();k&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let S,F;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(F=p.create(),S=this.f.check(F,this.q.size+1)),A&&(F=F??p.create());const H=new b(c,g,F),te=this.q.push(H);k&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,c,g);const ce=H.subscription.set(()=>{S?.(),this.j||(this.d?.onWillRemoveListener?.(this),te(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return D instanceof o.DisposableStore?D.add(ce):Array.isArray(D)&&D.push(ce),ce}),this.l}fire(c){if(this.q){this.m||(this.m=new u(this.d?.onListenerError));for(const g of this.q)this.m.push(this,g,c);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=s;class h{constructor(c=w.onUnexpectedError){this.d=c,this.c=new P.LinkedList}get size(){return this.c.size}push(c,g,D){this.c.push(new f(c,g,D))}clear(c){const g=new P.LinkedList;for(const D of this.c)D.emitter!==c&&g.push(D);this.c=g}deliver(){for(;this.c.size>0;){const c=this.c.shift();try{c.listener.invoke(c.event)}catch(g){this.d(g)}}}}e.EventDeliveryQueue=h;class u extends h{clear(c){this.c.clear()}}class f{constructor(c,g,D){this.emitter=c,this.listener=g,this.event=D}}class I extends s{async fireAsync(c,g,D){if(this.q){this.c||(this.c=new P.LinkedList);for(const k of this.q)this.c.push([k,c]);for(;this.c.size>0&&!g.isCancellationRequested;){const[k,S]=this.c.shift(),F=[],H={...S,token:g,waitUntil:te=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");D&&(te=D(te,k.callback)),F.push(te)}};try{k.invoke(H)}catch(te){(0,w.onUnexpectedError)(te);continue}Object.freeze(F),await Promise.allSettled(F).then(te=>{for(const ce of te)ce.status==="rejected"&&(0,w.onUnexpectedError)(ce.reason)})}}}}e.AsyncEmitter=I;class O extends s{constructor(c){super(c),this.h=0,this.s=new P.LinkedList,this.t=c?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const c=Array.from(this.s);this.s.clear(),super.fire(this.t(c))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(c){this.q&&(this.h!==0?this.s.push(c):super.fire(c))}}e.PauseableEmitter=O;class t extends O{constructor(c){super(c),this.c=c.delay??100}fire(c){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(c)}}e.DebounceEmitter=t;class n extends s{constructor(c){super(c),this.c=[],this.h=c?.merge}fire(c){this.hasListeners()&&(this.c.push(c),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(g=>super.fire(g)),this.c=[]}))}}e.MicrotaskEmitter=n;class r{constructor(){this.d=!1,this.f=[],this.c=new s({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(c){const g={event:c,listener:null};this.f.push(g),this.d&&this.j(g);const D=()=>{this.d&&this.k(g);const k=this.f.indexOf(g);this.f.splice(k,1)};return(0,o.toDisposable)((0,L.once)(D))}g(){this.d=!0,this.f.forEach(c=>this.j(c))}h(){this.d=!1,this.f.forEach(c=>this.k(c))}j(c){c.listener=c.event(g=>this.c.fire(g))}k(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class i{constructor(){this.c=[]}wrapEvent(c){return(g,D,k)=>c(S=>{const F=this.c[this.c.length-1];F?F.push(()=>g.call(D,S)):g.call(D,S)},void 0,k)}bufferEvents(c){const g=[];this.c.push(g);const D=c();return this.c.pop(),g.forEach(k=>k()),D}}e.EventBufferer=i;class a{constructor(){this.c=!1,this.d=m.None,this.f=o.Disposable.None,this.g=new s({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(c){this.d=c,this.c&&(this.f.dispose(),this.f=c(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=a}),define(ge[157],pe([1,0,6,2,150]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class P extends L.Disposable{constructor(E,d="",p="",b=!0,s){super(),this.h=this.B(new w.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=E,this.m=d,this.u=p,this.w=b,this.C=s}get id(){return this.j}get label(){return this.m}set label(E){this.D(E)}D(E){this.m!==E&&(this.m=E,this.h.fire({label:E}))}get tooltip(){return this.n||""}set tooltip(E){this.F(E)}F(E){this.n!==E&&(this.n=E,this.h.fire({tooltip:E}))}get class(){return this.u}set class(E){this.G(E)}G(E){this.u!==E&&(this.u=E,this.h.fire({class:E}))}get enabled(){return this.w}set enabled(E){this.H(E)}H(E){this.w!==E&&(this.w=E,this.h.fire({enabled:E}))}get checked(){return this.z}set checked(E){this.I(E)}I(E){this.z!==E&&(this.z=E,this.h.fire({checked:E}))}async run(E,d){this.C&&await this.C(E)}}e.Action=P;class C extends L.Disposable{constructor(){super(...arguments),this.f=this.B(new w.Emitter),this.onWillRun=this.f.event,this.h=this.B(new w.Emitter),this.onDidRun=this.h.event}async run(E,d){if(!E.enabled)return;this.f.fire({action:E});let p;try{await this.k(E,d)}catch(b){p=b}this.h.fire({action:E,error:p})}async k(E,d){await E.run(d)}}e.ActionRunner=C;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...E){let d=[];for(const p of E)p.length&&(d.length?d=[...d,new A,...p]:d=p);return d}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class v{get actions(){return this.a}constructor(E,d,p,b){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=E,this.label=d,this.class=b,this.a=p}async run(){}}e.SubmenuAction=v;class m extends P{constructor(){super(m.ID,o.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=m,m.ID="vs.actions.empty";function T(y){return{id:y.id,label:y.label,class:void 0,enabled:y.enabled??!0,checked:y.checked??!1,run:async()=>y.run(),tooltip:y.label}}e.toAction=T}),define(ge[20],pe([1,0,6]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(A,v){const m=setTimeout(A.bind(v),0);return{dispose(){clearTimeout(m)}}});var o;(function(A){function v(m){return m===A.None||m===A.Cancelled||m instanceof P?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}A.isCancellationToken=v,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(o||(e.CancellationToken=o={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new w.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(v){this.a=void 0,this.b=void 0,this.b=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new P),this.a}cancel(){this.a?this.a instanceof P&&this.a.cancel():this.a=o.Cancelled}dispose(v=!1){v&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof P&&this.a.dispose():this.a=o.None}}e.CancellationTokenSource=C}),define(ge[158],pe([1,0,20]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new w.CancellationTokenSource,v=this.b(A.token);return this.a={promise:v,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=L;class o{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const v=JSON.stringify(A);return this.b!==v&&(this.b=v,this.a=this.c(A)),this.a}}e.LRUCachedFunction=o;class P{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const v=this.b(A);return this.a.set(A,v),v}}e.CachedFunction=P}),define(ge[17],pe([1,0,158,141]),function(oe,e,w,L){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(he){return!he||typeof he!="string"?!0:he.trim().length===0}e.isFalsyOrWhitespace=P;const C=/{(\d+)}/g;function A(he,...Ie){return Ie.length===0?he:he.replace(C,function(Te,Ae){const Ne=parseInt(Ae,10);return isNaN(Ne)||Ne<0||Ne>=Ie.length?Te:Ie[Ne]})}e.format=A;const v=/{([^}]+)}/g;function m(he,Ie){return he.replace(v,(Te,Ae)=>Ie[Ae]??Te)}e.format2=m;function T(he){return he.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=T;function y(he){return he.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function E(he,Ie){let Te=0;const Ae=Ie.charCodeAt(0);for(let Ne=he.length-1;Ne>=0;Ne--)he.charCodeAt(Ne)===Ae&&Te++;return Te}e.count=E;function d(he,Ie,Te="\u2026"){return he.length<=Ie?he:`${he.substr(0,Ie)}${Te}`}e.truncate=d;function p(he,Ie=" "){const Te=b(he,Ie);return s(Te,Ie)}e.trim=p;function b(he,Ie){if(!he||!Ie)return he;const Te=Ie.length;if(Te===0||he.length===0)return he;let Ae=0;for(;he.indexOf(Ie,Ae)===Ae;)Ae=Ae+Te;return he.substring(Ae)}e.ltrim=b;function s(he,Ie){if(!he||!Ie)return he;const Te=Ie.length,Ae=he.length;if(Te===0||Ae===0)return he;let Ne=Ae,$e=-1;for(;$e=he.lastIndexOf(Ie,Ne-1),!($e===-1||$e+Te!==Ne);){if($e===0)return"";Ne=$e}return he.substring(0,Ne)}e.rtrim=s;function h(he){return he.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function u(he){return he.replace(/\*/g,"")}e.stripWildcards=u;function f(he,Ie,Te={}){if(!he)throw new Error("Cannot create regex from empty string");Ie||(he=y(he)),Te.wholeWord&&(/\B/.test(he.charAt(0))||(he="\\b"+he),/\B/.test(he.charAt(he.length-1))||(he=he+"\\b"));let Ae="";return Te.global&&(Ae+="g"),Te.matchCase||(Ae+="i"),Te.multiline&&(Ae+="m"),Te.unicode&&(Ae+="u"),new RegExp(he,Ae)}e.createRegExp=f;function I(he){return he.source==="^"||he.source==="^$"||he.source==="$"||he.source==="^\\s*$"?!1:!!(he.exec("")&&he.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function O(he){return!!he.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=O;function t(he){return(he.global?"g":"")+(he.ignoreCase?"i":"")+(he.multiline?"m":"")+(he.unicode?"u":"")}e.regExpFlags=t;function n(he){return he.split(/\r\n|\r|\n/)}e.splitLines=n;function r(he){for(let Ie=0,Te=he.length;Ie<Te;Ie++){const Ae=he.charCodeAt(Ie);if(Ae!==32&&Ae!==9)return Ie}return-1}e.firstNonWhitespaceIndex=r;function i(he,Ie=0,Te=he.length){for(let Ae=Ie;Ae<Te;Ae++){const Ne=he.charCodeAt(Ae);if(Ne!==32&&Ne!==9)return he.substring(Ie,Ae)}return he.substring(Ie,Te)}e.getLeadingWhitespace=i;function a(he,Ie=he.length-1){for(let Te=Ie;Te>=0;Te--){const Ae=he.charCodeAt(Te);if(Ae!==32&&Ae!==9)return Te}return-1}e.lastNonWhitespaceIndex=a;function l(he,Ie,Te){const Ae=[];let Ne=0;for(const $e of he.matchAll(Ie)){if(Ae.push(he.slice(Ne,$e.index)),$e.index===void 0)throw new Error("match.index should be defined");Ne=$e.index+$e[0].length,Ae.push(Te($e[0],...$e.slice(1),$e.index,he,$e.groups))}return Ae.push(he.slice(Ne)),Promise.all(Ae).then($e=>$e.join(""))}e.replaceAsync=l;function c(he,Ie){return he<Ie?-1:he>Ie?1:0}e.compare=c;function g(he,Ie,Te=0,Ae=he.length,Ne=0,$e=Ie.length){for(;Te<Ae&&Ne<$e;Te++,Ne++){const et=he.charCodeAt(Te),qe=Ie.charCodeAt(Ne);if(et<qe)return-1;if(et>qe)return 1}const We=Ae-Te,Ke=$e-Ne;return We<Ke?-1:We>Ke?1:0}e.compareSubstring=g;function D(he,Ie){return k(he,Ie,0,he.length,0,Ie.length)}e.compareIgnoreCase=D;function k(he,Ie,Te=0,Ae=he.length,Ne=0,$e=Ie.length){for(;Te<Ae&&Ne<$e;Te++,Ne++){let et=he.charCodeAt(Te),qe=Ie.charCodeAt(Ne);if(et===qe)continue;if(et>=128||qe>=128)return g(he.toLowerCase(),Ie.toLowerCase(),Te,Ae,Ne,$e);F(et)&&(et-=32),F(qe)&&(qe-=32);const rt=et-qe;if(rt!==0)return rt}const We=Ae-Te,Ke=$e-Ne;return We<Ke?-1:We>Ke?1:0}e.compareSubstringIgnoreCase=k;function S(he){return he>=48&&he<=57}e.isAsciiDigit=S;function F(he){return he>=97&&he<=122}e.isLowerAsciiLetter=F;function H(he){return he>=65&&he<=90}e.isUpperAsciiLetter=H;function te(he,Ie){return he.length===Ie.length&&k(he,Ie)===0}e.equalsIgnoreCase=te;function ce(he,Ie){const Te=Ie.length;return Ie.length>he.length?!1:k(he,Ie,0,Te)===0}e.startsWithIgnoreCase=ce;function le(he,Ie){const Te=Math.min(he.length,Ie.length);let Ae;for(Ae=0;Ae<Te;Ae++)if(he.charCodeAt(Ae)!==Ie.charCodeAt(Ae))return Ae;return Te}e.commonPrefixLength=le;function ue(he,Ie){const Te=Math.min(he.length,Ie.length);let Ae;const Ne=he.length-1,$e=Ie.length-1;for(Ae=0;Ae<Te;Ae++)if(he.charCodeAt(Ne-Ae)!==Ie.charCodeAt($e-Ae))return Ae;return Te}e.commonSuffixLength=ue;function ve(he){return 55296<=he&&he<=56319}e.isHighSurrogate=ve;function K(he){return 56320<=he&&he<=57343}e.isLowSurrogate=K;function ee(he,Ie){return(he-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=ee;function z(he,Ie,Te){const Ae=he.charCodeAt(Te);if(ve(Ae)&&Te+1<Ie){const Ne=he.charCodeAt(Te+1);if(K(Ne))return ee(Ae,Ne)}return Ae}e.getNextCodePoint=z;function q(he,Ie){const Te=he.charCodeAt(Ie-1);if(K(Te)&&Ie>1){const Ae=he.charCodeAt(Ie-2);if(ve(Ae))return ee(Ae,Te)}return Te}class G{get offset(){return this.e}constructor(Ie,Te=0){this.c=Ie,this.d=Ie.length,this.e=Te}setOffset(Ie){this.e=Ie}prevCodePoint(){const Ie=q(this.c,this.e);return this.e-=Ie>=65536?2:1,Ie}nextCodePoint(){const Ie=z(this.c,this.d,this.e);return this.e+=Ie>=65536?2:1,Ie}eol(){return this.e>=this.d}}e.CodePointIterator=G;class ne{get offset(){return this.c.offset}constructor(Ie,Te=0){this.c=new G(Ie,Te)}nextGraphemeLength(){const Ie=je.getInstance(),Te=this.c,Ae=Te.offset;let Ne=Ie.getGraphemeBreakType(Te.nextCodePoint());for(;!Te.eol();){const $e=Te.offset,We=Ie.getGraphemeBreakType(Te.nextCodePoint());if(we(Ne,We)){Te.setOffset($e);break}Ne=We}return Te.offset-Ae}prevGraphemeLength(){const Ie=je.getInstance(),Te=this.c,Ae=Te.offset;let Ne=Ie.getGraphemeBreakType(Te.prevCodePoint());for(;Te.offset>0;){const $e=Te.offset,We=Ie.getGraphemeBreakType(Te.prevCodePoint());if(we(We,Ne)){Te.setOffset($e);break}Ne=We}return Ae-Te.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ne;function se(he,Ie){return new ne(he,Ie).nextGraphemeLength()}e.nextCharLength=se;function de(he,Ie){return new ne(he,Ie).prevGraphemeLength()}e.prevCharLength=de;function W(he,Ie){Ie>0&&K(he.charCodeAt(Ie))&&Ie--;const Te=Ie+se(he,Ie);return[Te-de(he,Te),Te]}e.getCharContainingOffset=W;function x(he){const Ie=new ne(he);let Te=0;for(;!Ie.eol();)Te++,Ie.nextGraphemeLength();return Te}e.charCount=x;let N;function R(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(he){return N||(N=R()),N.test(he)}e.containsRTL=U;const X=/^[\t\n\r\x20-\x7E]*$/;function ie(he){return X.test(he)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(he){return e.UNUSUAL_LINE_TERMINATORS.test(he)}e.containsUnusualLineTerminators=j;function $(he){return he>=11904&&he<=55215||he>=63744&&he<=64255||he>=65281&&he<=65374}e.isFullWidthCharacter=$;function J(he){return he>=127462&&he<=127487||he===8986||he===8987||he===9200||he===9203||he>=9728&&he<=10175||he===11088||he===11093||he>=127744&&he<=128591||he>=128640&&he<=128764||he>=128992&&he<=129008||he>=129280&&he<=129535||he>=129648&&he<=129782}e.isEmojiImprecise=J;function V(he,Ie){if(he.length<Ie)return he;const Te=/\b/g;let Ae=0;for(;Te.test(he)&&!(he.length-Te.lastIndex<Ie);)Ae=Te.lastIndex,Te.lastIndex+=1;return he.substring(Ae).replace(/^\s/,"")}e.lcut=V;const Z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Y=/\x1b\].*?\x07/g;function _(he){return he&&(he=he.replace(Z,"").replace(Y,"")),he}e.removeAnsiEscapeCodes=_,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(he){return!!(he&&he.length>0&&he.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ae;function Ee(he){return ae(he)?he.substr(1):he}e.stripUTF8BOM=Ee;function Ce(he,Ie){if(!he||!Ie||he.length<Ie.length)return!1;const Te=Ie.length,Ae=he.toLowerCase();let Ne=0,$e=-1;for(;Ne<Te;){const We=Ae.indexOf(Ie[Ne],$e+1);if(We<0)return!1;$e=We,Ne++}return!0}e.fuzzyContains=Ce;function ke(he,Ie=!1){return he?(Ie&&(he=he.replace(/\\./g,"")),he.toLowerCase()!==he):!1}e.containsUppercaseCharacter=ke;function Ue(he){return he.charAt(0).toUpperCase()+he.slice(1)}e.uppercaseFirstLetter=Ue;function ze(he,Ie=1){if(Ie===0)return"";let Te=-1;do Te=he.indexOf(`
`,Te+1),Ie--;while(Ie>0&&Te>=0);return Te===-1?he:(he[Te-1]==="\r"&&Te--,he.substr(0,Te))}e.getNLines=ze;function me(he){return he=he%(2*26),he<26?String.fromCharCode(97+he):String.fromCharCode(65+he-26)}e.singleLetterHash=me;function Se(he){return je.getInstance().getGraphemeBreakType(he)}e.getGraphemeBreakType=Se;function we(he,Ie){return he===0?Ie!==5&&Ie!==7:he===2&&Ie===3?!1:he===4||he===2||he===3||Ie===4||Ie===2||Ie===3?!0:!(he===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(he===11||he===9)&&(Ie===9||Ie===10)||(he===12||he===10)&&Ie===10||Ie===5||Ie===13||Ie===7||he===1||he===13&&Ie===14||he===6&&Ie===6)}var Oe;(function(he){he[he.Other=0]="Other",he[he.Prepend=1]="Prepend",he[he.CR=2]="CR",he[he.LF=3]="LF",he[he.Control=4]="Control",he[he.Extend=5]="Extend",he[he.Regional_Indicator=6]="Regional_Indicator",he[he.SpacingMark=7]="SpacingMark",he[he.L=8]="L",he[he.V=9]="V",he[he.T=10]="T",he[he.LV=11]="LV",he[he.LVT=12]="LVT",he[he.ZWJ=13]="ZWJ",he[he.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(e.GraphemeBreakType=Oe={}));class je{static getInstance(){return je.c||(je.c=new je),je.c}constructor(){this.d=_e()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Te=this.d,Ae=Te.length/3;let Ne=1;for(;Ne<=Ae;)if(Ie<Te[3*Ne])Ne=2*Ne;else if(Ie>Te[3*Ne+1])Ne=2*Ne+1;else return Te[3*Ne+2];return 0}}je.c=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(he,Ie){if(he===0)return 0;const Te=Ye(he,Ie);if(Te!==void 0)return Te;const Ae=new G(Ie,he);return Ae.prevCodePoint(),Ae.offset}e.getLeftDeleteOffset=Ve;function Ye(he,Ie){const Te=new G(Ie,he);let Ae=Te.prevCodePoint();for(;Xe(Ae)||Ae===65039||Ae===8419;){if(Te.offset===0)return;Ae=Te.prevCodePoint()}if(!J(Ae))return;let Ne=Te.offset;return Ne>0&&Te.prevCodePoint()===8205&&(Ne=Te.offset),Ne}function Xe(he){return 127995<=he&&he<=127999}var it;(function(he){he[he.zwj=8205]="zwj",he[he.emojiVariantSelector=65039]="emojiVariantSelector",he[he.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.noBreakWhitespace="\xA0";class Je{static getInstance(Ie){return Je.d.get(Array.from(Ie))}static getLocales(){return Je.e.value}constructor(Ie){this.f=Ie}isAmbiguous(Ie){return this.f.has(Ie)}getPrimaryConfusable(Ie){return this.f.get(Ie)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=Je,o=Je,Je.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Je.d=new w.LRUCachedFunction(he=>{function Ie(qe){const rt=new Map;for(let ct=0;ct<qe.length;ct+=2)rt.set(qe[ct],qe[ct+1]);return rt}function Te(qe,rt){const ct=new Map(qe);for(const[st,Et]of rt)ct.set(st,Et);return ct}function Ae(qe,rt){if(!qe)return rt;const ct=new Map;for(const[st,Et]of qe)rt.has(st)&&ct.set(st,Et);return ct}const Ne=o.c.value;let $e=he.filter(qe=>!qe.startsWith("_")&&qe in Ne);$e.length===0&&($e=["_default"]);let We;for(const qe of $e){const rt=Ie(Ne[qe]);We=Ae(We,rt)}const Ke=Ie(Ne._common),et=Te(Ke,We);return new Je(et)}),Je.e=new L.Lazy(()=>Object.keys(Je.c.value).filter(he=>!he.startsWith("_")));class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(Ie){return Ge.e().has(Ie)}static get codePoints(){return Ge.e()}}e.InvisibleCharacters=Ge,Ge.d=void 0}),define(ge[39],pe([1,0,7,3,17,8]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(l){return l===47||l===92}e.isPathSeparator=C;function A(l){return l.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=A;function v(l){return l.indexOf("/")===-1&&(l=A(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=v;function m(l,c=w.posix.sep){if(!l)return"";const g=l.length,D=l.charCodeAt(0);if(C(D)){if(C(l.charCodeAt(1))&&!C(l.charCodeAt(2))){let S=3;const F=S;for(;S<g&&!C(l.charCodeAt(S));S++);if(F!==S&&!C(l.charCodeAt(S+1))){for(S+=1;S<g;S++)if(C(l.charCodeAt(S)))return l.slice(0,S+1).replace(/[\\/]/g,c)}}return c}else if(h(D)&&l.charCodeAt(1)===58)return C(l.charCodeAt(2))?l.slice(0,2)+c:l.slice(0,2);let k=l.indexOf("://");if(k!==-1){for(k+=3;k<g;k++)if(C(l.charCodeAt(k)))return l.slice(0,k+1)}return""}e.getRoot=m;function T(l){if(!L.isWindows||!l||l.length<5)return!1;let c=l.charCodeAt(0);if(c!==92||(c=l.charCodeAt(1),c!==92))return!1;let g=2;const D=g;for(;g<l.length&&(c=l.charCodeAt(g),c!==92);g++);return!(D===g||(c=l.charCodeAt(g+1),isNaN(c)||c===92))}e.isUNC=T;const y=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(l,c=L.isWindows){const g=c?y:E;return!(!l||l.length===0||/^\s+$/.test(l)||(g.lastIndex=0,g.test(l))||c&&d.test(l)||l==="."||l===".."||c&&l[l.length-1]==="."||c&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=p;function b(l,c,g){const D=l===c;return!g||D?D:!l||!c?!1:(0,o.equalsIgnoreCase)(l,c)}e.isEqual=b;function s(l,c,g,D=w.sep){if(l===c)return!0;if(!l||!c||c.length>l.length)return!1;if(g){if(!(0,o.startsWithIgnoreCase)(l,c))return!1;if(c.length===l.length)return!0;let S=c.length;return c.charAt(c.length-1)===D&&S--,l.charAt(S)===D}return c.charAt(c.length-1)!==D&&(c+=D),l.indexOf(c)===0}e.isEqualOrParent=s;function h(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=h;function u(l,c){return L.isWindows&&l.endsWith(":")&&(l+=w.sep),(0,w.isAbsolute)(l)||(l=(0,w.join)(c,l)),l=(0,w.normalize)(l),L.isWindows?(l=(0,o.rtrim)(l,w.sep),l.endsWith(":")&&(l+=w.sep)):(l=(0,o.rtrim)(l,w.sep),l||(l=w.sep)),l}e.sanitizeFilePath=u;function f(l){const c=(0,w.normalize)(l);return L.isWindows?l.length>3?!1:I(c)&&(l.length===2||c.charCodeAt(2)===92):c===w.posix.sep}e.isRootOrDriveLetter=f;function I(l,c=L.isWindows){return c?h(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=I;function O(l){return I(l)?l[0]:void 0}e.getDriveLetter=O;function t(l,c,g){return c.length>l.length?-1:l===c?0:(g&&(l=l.toLowerCase(),c=c.toLowerCase()),l.indexOf(c))}e.indexOfPath=t;function n(l){const c=l.split(":");let g,D,k;for(const S of c){const F=Number(S);(0,P.isNumber)(F)?D===void 0?D=F:k===void 0&&(k=F):g=g?[g,S].join(":"):S}if(!g)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:g,line:D!==void 0?D:void 0,column:k!==void 0?k:D!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(l,c,g=8){let D="";for(let S=0;S<g;S++){let F;S===0&&L.isWindows&&!c&&(g===3||g===4)?F=i:F=r,D+=F.charAt(Math.floor(Math.random()*F.length))}let k;return c?k=`${c}-${D}`:k=D,l?(0,w.join)(l,k):k}e.randomPath=a}),define(ge[159],pe([1,0,27,17]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function o(...Y){return function(_,ae){for(let Ee=0,Ce=Y.length;Ee<Ce;Ee++){const ke=Y[Ee](_,ae);if(ke)return ke}return null}}e.or=o,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(Y,_,ae){if(!ae||ae.length<_.length)return null;let Ee;return Y?Ee=L.startsWithIgnoreCase(ae,_):Ee=ae.indexOf(_)===0,Ee?_.length>0?[{start:0,end:_.length}]:[]:null}function C(Y,_){const ae=_.toLowerCase().indexOf(Y.toLowerCase());return ae===-1?null:[{start:ae,end:ae+Y.length}]}e.matchesContiguousSubString=C;function A(Y,_){return v(Y.toLowerCase(),_.toLowerCase(),0,0)}e.matchesSubString=A;function v(Y,_,ae,Ee){if(ae===Y.length)return[];if(Ee===_.length)return null;if(Y[ae]===_[Ee]){let Ce=null;return(Ce=v(Y,_,ae+1,Ee+1))?h({start:Ee,end:Ee+1},Ce):null}return v(Y,_,ae,Ee+1)}function m(Y){return 97<=Y&&Y<=122}function T(Y){return 65<=Y&&Y<=90}e.isUpper=T;function y(Y){return 48<=Y&&Y<=57}function E(Y){return Y===32||Y===9||Y===10||Y===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Y=>d.add(Y.charCodeAt(0)));function p(Y){return E(Y)||d.has(Y)}function b(Y,_){return Y===_||p(Y)&&p(_)}function s(Y){return m(Y)||T(Y)||y(Y)}function h(Y,_){return _.length===0?_=[Y]:Y.end===_[0].start?_[0].start=Y.start:_.unshift(Y),_}function u(Y,_){for(let ae=_;ae<Y.length;ae++){const Ee=Y.charCodeAt(ae);if(T(Ee)||y(Ee)||ae>0&&!s(Y.charCodeAt(ae-1)))return ae}return Y.length}function f(Y,_,ae,Ee){if(ae===Y.length)return[];if(Ee===_.length)return null;if(Y[ae]!==_[Ee].toLowerCase())return null;{let Ce=null,ke=Ee+1;for(Ce=f(Y,_,ae+1,Ee+1);!Ce&&(ke=u(_,ke))<_.length;)Ce=f(Y,_,ae+1,ke),ke++;return Ce===null?null:h({start:Ee,end:Ee+1},Ce)}}function I(Y){let _=0,ae=0,Ee=0,Ce=0,ke=0;for(let we=0;we<Y.length;we++)ke=Y.charCodeAt(we),T(ke)&&_++,m(ke)&&ae++,s(ke)&&Ee++,y(ke)&&Ce++;const Ue=_/Y.length,ze=ae/Y.length,me=Ee/Y.length,Se=Ce/Y.length;return{upperPercent:Ue,lowerPercent:ze,alphaPercent:me,numericPercent:Se}}function O(Y){const{upperPercent:_,lowerPercent:ae}=Y;return ae===0&&_>.6}function t(Y){const{upperPercent:_,lowerPercent:ae,alphaPercent:Ee,numericPercent:Ce}=Y;return ae>.2&&_<.8&&Ee>.6&&Ce<.2}function n(Y){let _=0,ae=0,Ee=0,Ce=0;for(let ke=0;ke<Y.length;ke++)Ee=Y.charCodeAt(ke),T(Ee)&&_++,m(Ee)&&ae++,E(Ee)&&Ce++;return(_===0||ae===0)&&Ce===0?Y.length<=30:_<=5}function r(Y,_){if(!_||(_=_.trim(),_.length===0)||!n(Y)||_.length>60)return null;const ae=I(_);if(!t(ae)){if(!O(ae))return null;_=_.toLowerCase()}let Ee=null,Ce=0;for(Y=Y.toLowerCase();Ce<_.length&&(Ee=f(Y,_,0,Ce))===null;)Ce=u(_,Ce+1);return Ee}e.matchesCamelCase=r;function i(Y,_,ae=!1){if(!_||_.length===0)return null;let Ee=null,Ce=0;for(Y=Y.toLowerCase(),_=_.toLowerCase();Ce<_.length&&(Ee=a(Y,_,0,Ce,ae))===null;)Ce=l(_,Ce+1);return Ee}e.matchesWords=i;function a(Y,_,ae,Ee,Ce){if(ae===Y.length)return[];if(Ee===_.length)return null;if(b(Y.charCodeAt(ae),_.charCodeAt(Ee))){let ke=null,Ue=Ee+1;if(ke=a(Y,_,ae+1,Ee+1,Ce),!Ce)for(;!ke&&(Ue=l(_,Ue))<_.length;)ke=a(Y,_,ae+1,Ue,Ce),Ue++;return ke?Y.charCodeAt(ae)!==_.charCodeAt(Ee)?ke:h({start:Ee,end:Ee+1},ke):null}else return null}function l(Y,_){for(let ae=_;ae<Y.length;ae++)if(p(Y.charCodeAt(ae))||ae>0&&p(Y.charCodeAt(ae-1)))return ae;return Y.length}const c=o(e.matchesPrefix,r,C),g=o(e.matchesPrefix,r,A),D=new w.LRUCache(1e4);function k(Y,_,ae=!1){if(typeof Y!="string"||typeof _!="string")return null;let Ee=D.get(Y);Ee||(Ee=new RegExp(L.convertSimple2RegExpPattern(Y),"i"),D.set(Y,Ee));const Ce=Ee.exec(_);return Ce?[{start:Ce.index,end:Ce.index+Ce[0].length}]:ae?g(Y,_):c(Y,_)}e.matchesFuzzy=k;function S(Y,_){const ae=X(Y,Y.toLowerCase(),0,_,_.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ae?H(ae):null}e.matchesFuzzy2=S;function F(Y,_,ae,Ee,Ce,ke){const Ue=Math.min(13,Y.length);for(;ae<Ue;ae++){const ze=X(Y,_,ae,Ee,Ce,ke,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ze)return ze}return[0,ke]}e.anyScore=F;function H(Y){if(typeof Y>"u")return[];const _=[],ae=Y[1];for(let Ee=Y.length-1;Ee>1;Ee--){const Ce=Y[Ee]+ae,ke=_[_.length-1];ke&&ke.end===Ce?ke.end=Ce+1:_.push({start:Ce,end:Ce+1})}return _}e.createMatches=H;const te=128;function ce(){const Y=[],_=[];for(let ae=0;ae<=te;ae++)_[ae]=0;for(let ae=0;ae<=te;ae++)Y.push(_.slice(0));return Y}function le(Y){const _=[];for(let ae=0;ae<=Y;ae++)_[ae]=0;return _}const ue=le(2*te),ve=le(2*te),K=ce(),ee=ce(),z=ce(),q=!1;function G(Y,_,ae,Ee,Ce){function ke(ze,me,Se=" "){for(;ze.length<me;)ze=Se+ze;return ze}let Ue=` |   |${Ee.split("").map(ze=>ke(ze,3)).join("|")}
`;for(let ze=0;ze<=ae;ze++)ze===0?Ue+=" |":Ue+=`${_[ze-1]}|`,Ue+=Y[ze].slice(0,Ce+1).map(me=>ke(me.toString(),3)).join("|")+`
`;return Ue}function ne(Y,_,ae,Ee){Y=Y.substr(_),ae=ae.substr(Ee),console.log(G(ee,Y,Y.length,ae,ae.length)),console.log(G(z,Y,Y.length,ae,ae.length)),console.log(G(K,Y,Y.length,ae,ae.length))}function se(Y,_){if(_<0||_>=Y.length)return!1;const ae=Y.codePointAt(_);switch(ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ae)}}function de(Y,_){if(_<0||_>=Y.length)return!1;switch(Y.charCodeAt(_)){case 32:case 9:return!0;default:return!1}}function W(Y,_,ae){return _[Y]!==ae[Y]}function x(Y,_,ae,Ee,Ce,ke,Ue=!1){for(;_<ae&&Ce<ke;)Y[_]===Ee[Ce]&&(Ue&&(ue[_]=Ce),_+=1),Ce+=1;return _===ae}e.isPatternInWord=x;var N;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(N||(N={}));var R;(function(Y){Y.Default=[-100,0];function _(ae){return!ae||ae.length===2&&ae[0]===-100&&ae[1]===0}Y.isDefault=_})(R||(e.FuzzyScore=R={}));class U{constructor(_,ae){this.firstMatchCanBeWeak=_,this.boostFullMatch=ae}}e.FuzzyScoreOptions=U,U.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function X(Y,_,ae,Ee,Ce,ke,Ue=U.default){const ze=Y.length>te?te:Y.length,me=Ee.length>te?te:Ee.length;if(ae>=ze||ke>=me||ze-ae>me-ke||!x(_,ae,ze,Ce,ke,me,!0))return;ie(ze,me,ae,ke,_,Ce);let Se=1,we=1,Oe=ae,je=ke;const _e=[!1];for(Se=1,Oe=ae;Oe<ze;Se++,Oe++){const Je=ue[Oe],Ge=ve[Oe],he=Oe+1<ze?ve[Oe+1]:me;for(we=Je-ke+1,je=Je;je<he;we++,je++){let Ie=Number.MIN_SAFE_INTEGER,Te=!1;je<=Ge&&(Ie=j(Y,_,Oe,ae,Ee,Ce,je,me,ke,K[Se-1][we-1]===0,_e));let Ae=0;Ie!==Number.MAX_SAFE_INTEGER&&(Te=!0,Ae=Ie+ee[Se-1][we-1]);const Ne=je>Je,$e=Ne?ee[Se][we-1]+(K[Se][we-1]>0?-5:0):0,We=je>Je+1&&K[Se][we-1]>0,Ke=We?ee[Se][we-2]+(K[Se][we-2]>0?-5:0):0;if(We&&(!Ne||Ke>=$e)&&(!Te||Ke>=Ae))ee[Se][we]=Ke,z[Se][we]=3,K[Se][we]=0;else if(Ne&&(!Te||$e>=Ae))ee[Se][we]=$e,z[Se][we]=2,K[Se][we]=0;else if(Te)ee[Se][we]=Ae,z[Se][we]=1,K[Se][we]=K[Se-1][we-1]+1;else throw new Error("not possible")}}if(q&&ne(Y,ae,Ee,ke),!_e[0]&&!Ue.firstMatchCanBeWeak)return;Se--,we--;const Ve=[ee[Se][we],ke];let Ye=0,Xe=0;for(;Se>=1;){let Je=we;do{const Ge=z[Se][Je];if(Ge===3)Je=Je-2;else if(Ge===2)Je=Je-1;else break}while(Je>=1);Ye>1&&_[ae+Se-1]===Ce[ke+we-1]&&!W(Je+ke-1,Ee,Ce)&&Ye+1>K[Se][Je]&&(Je=we),Je===we?Ye++:Ye=1,Xe||(Xe=Je),Se--,we=Je-1,Ve.push(we)}me===ze&&Ue.boostFullMatch&&(Ve[0]+=2);const it=Xe-ze;return Ve[0]-=it,Ve}e.fuzzyScore=X;function ie(Y,_,ae,Ee,Ce,ke){let Ue=Y-1,ze=_-1;for(;Ue>=ae&&ze>=Ee;)Ce[Ue]===ke[ze]&&(ve[Ue]=ze,Ue--),ze--}function j(Y,_,ae,Ee,Ce,ke,Ue,ze,me,Se,we){if(_[ae]!==ke[Ue])return Number.MIN_SAFE_INTEGER;let Oe=1,je=!1;return Ue===ae-Ee?Oe=Y[ae]===Ce[Ue]?7:5:W(Ue,Ce,ke)&&(Ue===0||!W(Ue-1,Ce,ke))?(Oe=Y[ae]===Ce[Ue]?7:5,je=!0):se(ke,Ue)&&(Ue===0||!se(ke,Ue-1))?Oe=5:(se(ke,Ue-1)||de(ke,Ue-1))&&(Oe=5,je=!0),Oe>1&&ae===Ee&&(we[0]=!0),je||(je=W(Ue,Ce,ke)||se(ke,Ue-1)||de(ke,Ue-1)),ae===Ee?Ue>me&&(Oe-=je?3:5):Se?Oe+=je?2:0:Oe+=je?0:1,Ue+1===ze&&(Oe-=je?3:5),Oe}function $(Y,_,ae,Ee,Ce,ke,Ue){return V(Y,_,ae,Ee,Ce,ke,!0,Ue)}e.fuzzyScoreGracefulAggressive=$;function J(Y,_,ae,Ee,Ce,ke,Ue){return V(Y,_,ae,Ee,Ce,ke,!1,Ue)}e.fuzzyScoreGraceful=J;function V(Y,_,ae,Ee,Ce,ke,Ue,ze){let me=X(Y,_,ae,Ee,Ce,ke,ze);if(me&&!Ue)return me;if(Y.length>=3){const Se=Math.min(7,Y.length-1);for(let we=ae+1;we<Se;we++){const Oe=Z(Y,we);if(Oe){const je=X(Oe,Oe.toLowerCase(),ae,Ee,Ce,ke,ze);je&&(je[0]-=3,(!me||je[0]>me[0])&&(me=je))}}}return me}function Z(Y,_){if(_+1>=Y.length)return;const ae=Y[_],Ee=Y[_+1];if(ae!==Ee)return Y.slice(0,_)+Ee+ae+Y.slice(_+2)}}),define(ge[75],pe([1,0,17]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(h){return o(h,0)}e.hash=L;function o(h,u){switch(typeof h){case"object":return h===null?P(349,u):Array.isArray(h)?v(h,u):m(h,u);case"string":return A(h,u);case"boolean":return C(h,u);case"number":return P(h,u);case"undefined":return P(937,u);default:return P(617,u)}}e.doHash=o;function P(h,u){return(u<<5)-u+h|0}e.numberHash=P;function C(h,u){return P(h?433:863,u)}function A(h,u){u=P(149417,u);for(let f=0,I=h.length;f<I;f++)u=P(h.charCodeAt(f),u);return u}e.stringHash=A;function v(h,u){return u=P(104579,u),h.reduce((f,I)=>o(I,f),u)}function m(h,u){return u=P(181387,u),Object.keys(h).sort().reduce((f,I)=>(f=A(I,f),o(h[I],f)),u)}class T{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=o(u,this.g),this.g}}e.Hasher=T;var y;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function E(h,u,f=32){const I=f-u,O=~((1<<I)-1);return(h<<u|(O&h)>>>I)>>>0}function d(h,u=0,f=h.byteLength,I=0){for(let O=0;O<f;O++)h[u+O]=I}function p(h,u,f="0"){for(;h.length<u;)h=f+h;return h}function b(h,u=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(f=>f.toString(16).padStart(2,"0")).join(""):p((h>>>0).toString(16),u/4)}e.toHexString=b;class s{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const f=u.length;if(f===0)return;const I=this.p;let O=this.r,t=this.u,n,r;for(t!==0?(n=t,r=-1,t=0):(n=u.charCodeAt(0),r=0);;){let i=n;if(w.isHighSurrogate(n))if(r+1<f){const a=u.charCodeAt(r+1);w.isLowSurrogate(a)?(r++,i=w.computeCodePoint(n,a)):i=65533}else{t=n;break}else w.isLowSurrogate(n)&&(i=65533);if(O=this.w(I,O,i),r++,r<f)n=u.charCodeAt(r);else break}this.r=O,this.u=t}w(u,f,I){return I<128?u[f++]=I:I<2048?(u[f++]=192|(I&1984)>>>6,u[f++]=128|(I&63)>>>0):I<65536?(u[f++]=224|(I&61440)>>>12,u[f++]=128|(I&4032)>>>6,u[f++]=128|(I&63)>>>0):(u[f++]=240|(I&1835008)>>>18,u[f++]=128|(I&258048)>>>12,u[f++]=128|(I&4032)>>>6,u[f++]=128|(I&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=s.g,f=this.q;for(let c=0;c<64;c+=4)u.setUint32(c,f.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)u.setUint32(c,E(u.getUint32(c-12,!1)^u.getUint32(c-32,!1)^u.getUint32(c-56,!1)^u.getUint32(c-64,!1),1),!1);let I=this.h,O=this.l,t=this.m,n=this.n,r=this.o,i,a,l;for(let c=0;c<80;c++)c<20?(i=O&t|~O&n,a=1518500249):c<40?(i=O^t^n,a=1859775393):c<60?(i=O&t|O&n|t&n,a=2400959708):(i=O^t^n,a=3395469782),l=E(I,5)+i+r+a+u.getUint32(c*4,!1)&4294967295,r=n,n=t,t=E(O,30),O=I,I=l;this.h=this.h+I&4294967295,this.l=this.l+O&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.StringSHA1=s,s.g=new DataView(new ArrayBuffer(320))}),define(ge[160],pe([1,0,159,17,95]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const P="$(",C=new RegExp(`\\$\\(${o.ThemeIcon.iconNameExpression}(?:${o.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${C.source}`,"g");function v(h){return h.replace(A,(u,f)=>f?u:`\\${u}`)}e.escapeIcons=v;const m=new RegExp(`\\\\${C.source}`,"g");function T(h){return h.replace(m,u=>`\\${u}`)}e.markdownEscapeEscapedIcons=T;const y=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function E(h){return h.indexOf(P)===-1?h:h.replace(y,(u,f,I,O)=>I?u:f||O||"")}e.stripIcons=E;function d(h){return h?h.replace(/\$\((.*?)\)/g,(u,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=d;const p=new RegExp(`\\$\\(${o.ThemeIcon.iconNameCharacter}+\\)`,"g");function b(h){p.lastIndex=0;let u="";const f=[];let I=0;for(;;){const O=p.lastIndex,t=p.exec(h),n=h.substring(O,t?.index);if(n.length>0){u+=n;for(let r=0;r<n.length;r++)f.push(I)}if(!t)break;I+=t[0].length}return{text:u,iconOffsets:f}}e.parseLabelWithIcons=b;function s(h,u,f=!1){const{text:I,iconOffsets:O}=u;if(!O||O.length===0)return(0,w.matchesFuzzy)(h,I,f);const t=(0,L.ltrim)(I," "),n=I.length-t.length,r=(0,w.matchesFuzzy)(h,t,f);if(r)for(const i of r){const a=O[i.start+n]+n;i.start+=a,i.end+=a}return r}e.matchesFuzzyIconAware=s}),define(ge[59],pe([1,0,17]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(o){o[o.Ignore=0]="Ignore",o[o.Info=1]="Info",o[o.Warning=2]="Warning",o[o.Error=3]="Error"})(L||(L={})),function(o){const P="error",C="warning",A="warn",v="info",m="ignore";function T(E){return E?w.equalsIgnoreCase(P,E)?o.Error:w.equalsIgnoreCase(C,E)||w.equalsIgnoreCase(A,E)?o.Warning:w.equalsIgnoreCase(v,E)?o.Info:o.Ignore:o.Ignore}o.fromValue=T;function y(E){switch(E){case o.Error:return P;case o.Warning:return C;case o.Info:return v;default:return m}}o.toString=y}(L||(L={})),e.default=L}),define(ge[60],pe([1,0,18,17]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class o{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const p=d.charCodeAt(0),b=this.b.charCodeAt(this.c);return p-b}value(){return this.b[this.c]}}e.StringIterator=o;class P{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,L.compareSubstring)(d,this.b,0,d.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=P;class C{constructor(d=!0,p=!0){this.f=d,this.g=p}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let p=d.length-1;p>=0;p--,this.c--){const b=this.b.charCodeAt(p);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,L.compareSubstring)(d,this.b,0,d.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var A;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(A||(A={}));class v{constructor(d,p){this.f=d,this.g=p,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(d,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,L.compare)(d,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=v;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(T||(T={}));class y{static forUris(d=()=>!1,p=()=>!1){return new y(new v(d,p))}static forPaths(d=!1){return new y(new C(void 0,!d))}static forStrings(){return new y(new o)}static forConfigKeys(){return new y(new P)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,p){if(p){const b=p.slice(0);(0,w.shuffle)(b);for(const s of b)this.set(s,d)}else{const b=d.slice(0);(0,w.shuffle)(b);for(const s of b)this.set(s[0],s[1])}}set(d,p){const b=this.b.reset(d);let s;this.c||(this.c=new m,this.c.segment=b.value());const h=[];for(s=this.c;;){const f=b.cmp(s.segment);if(f>0)s.left||(s.left=new m,s.left.segment=b.value()),h.push([-1,s]),s=s.left;else if(f<0)s.right||(s.right=new m,s.right.segment=b.value()),h.push([1,s]),s=s.right;else if(b.hasNext())b.next(),s.mid||(s.mid=new m,s.mid.segment=b.value()),h.push([0,s]),s=s.mid;else break}const u=s.value;s.value=p,s.key=d;for(let f=h.length-1;f>=0;f--){const I=h[f][1];I.updateHeight();const O=I.balanceFactor();if(O<-1||O>1){const t=h[f][0],n=h[f+1][0];if(t===1&&n===1)h[f][1]=I.rotateLeft();else if(t===-1&&n===-1)h[f][1]=I.rotateRight();else if(t===1&&n===-1)I.right=h[f+1][1]=h[f+1][1].rotateRight(),h[f][1]=I.rotateLeft();else if(t===-1&&n===1)I.left=h[f+1][1]=h[f+1][1].rotateLeft(),h[f][1]=I.rotateRight();else throw new Error;if(f>0)switch(h[f-1][0]){case-1:h[f-1][1].left=h[f][1];break;case 1:h[f-1][1].right=h[f][1];break;case 0:h[f-1][1].mid=h[f][1];break}else this.c=h[0][1]}}return u}get(d){return this.d(d)?.value}d(d){const p=this.b.reset(d);let b=this.c;for(;b;){const s=p.cmp(b.segment);if(s>0)b=b.left;else if(s<0)b=b.right;else if(p.hasNext())p.next(),b=b.mid;else break}return b}has(d){const p=this.d(d);return!(p?.value===void 0&&p?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,p){const b=this.b.reset(d),s=[];let h=this.c;for(;h;){const u=b.cmp(h.segment);if(u>0)s.push([-1,h]),h=h.left;else if(u<0)s.push([1,h]),h=h.right;else if(b.hasNext())b.next(),s.push([0,h]),h=h.mid;else break}if(h){if(p?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const u=this.f(h.right);if(u.key){const{key:f,value:I,segment:O}=u;this.e(u.key,!1),h.key=f,h.value=I,h.segment=O}}else{const u=h.left??h.right;if(s.length>0){const[f,I]=s[s.length-1];switch(f){case-1:I.left=u;break;case 0:I.mid=u;break;case 1:I.right=u;break}}else this.c=u}for(let u=s.length-1;u>=0;u--){const f=s[u][1];f.updateHeight();const I=f.balanceFactor();if(I>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),s[u][1]=f.rotateLeft()):I<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),s[u][1]=f.rotateRight()),u>0)switch(s[u-1][0]){case-1:s[u-1][1].left=s[u][1];break;case 1:s[u-1][1].right=s[u][1];break;case 0:s[u-1][1].mid=s[u][1];break}else this.c=s[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const p=this.b.reset(d);let b=this.c,s;for(;b;){const h=p.cmp(b.segment);if(h>0)b=b.left;else if(h<0)b=b.right;else if(p.hasNext())p.next(),s=b.value||s,b=b.mid;else break}return b&&b.value||s}findSuperstr(d){return this.g(d,!1)}g(d,p){const b=this.b.reset(d);let s=this.c;for(;s;){const h=b.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(b.hasNext())b.next(),s=s.mid;else return s.mid?this.h(s.mid):p?s.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[p,b]of this)d(b,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const p=[];return this.j(d,p),p[Symbol.iterator]()}j(d,p){d&&(d.left&&this.j(d.left,p),d.value&&p.push([d.key,d.value]),d.mid&&this.j(d.mid,p),d.right&&this.j(d.right,p))}_isBalanced(){const d=p=>{if(!p)return!0;const b=p.balanceFactor();return b<-1||b>1?!1:d(p.left)&&d(p.right)};return d(this.c)}}e.TernarySearchTree=y}),define(ge[4],pe([1,0,7,3]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const o=/^\w[\w\d+.-]*$/,P=/^\//,C=/^\/\//;function A(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!o.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!P.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(r,i){return!r&&!i?"file":r}function m(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const T="",y="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(i){return i instanceof d?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,a,l,c,g,D=!1){typeof i=="object"?(this.scheme=i.scheme||T,this.authority=i.authority||T,this.path=i.path||T,this.query=i.query||T,this.fragment=i.fragment||T):(this.scheme=v(i,D),this.authority=a||T,this.path=m(this.scheme,l||T),this.query=c||T,this.fragment=g||T,A(this,D))}get fsPath(){return f(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:l,path:c,query:g,fragment:D}=i;return a===void 0?a=this.scheme:a===null&&(a=T),l===void 0?l=this.authority:l===null&&(l=T),c===void 0?c=this.path:c===null&&(c=T),g===void 0?g=this.query:g===null&&(g=T),D===void 0?D=this.fragment:D===null&&(D=T),a===this.scheme&&l===this.authority&&c===this.path&&g===this.query&&D===this.fragment?this:new b(a,l,c,g,D)}static parse(i,a=!1){const l=E.exec(i);return l?new b(l[2]||T,n(l[4]||T),n(l[5]||T),n(l[7]||T),n(l[9]||T),a):new b(T,T,T,T,T)}static file(i){let a=T;if(L.isWindows&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const l=i.indexOf(y,2);l===-1?(a=i.substring(2),i=y):(a=i.substring(2,l),i=i.substring(l)||y)}return new b("file",a,i,T,T)}static from(i){const a=new b(i.scheme,i.authority,i.path,i.query,i.fragment);return A(a,!0),a}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&i.scheme==="file"?l=d.file(w.win32.join(f(i,!0),...a)).path:l=w.posix.join(i.path,...a),i.with({path:l})}toString(i=!1){return I(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof d)return i;{const a=new b(i);return a._formatted=i.external,a._fsPath=i._sep===p?i.fsPath:null,a}}else return i}}e.URI=d;const p=L.isWindows?1:void 0;class b extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(i=!1){return i?I(this,!0):(this._formatted||(this._formatted=I(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(r,i,a){let l,c=-1;for(let g=0;g<r.length;g++){const D=r.charCodeAt(g);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||i&&D===47||a&&D===91||a&&D===93||a&&D===58)c!==-1&&(l+=encodeURIComponent(r.substring(c,g)),c=-1),l!==void 0&&(l+=r.charAt(g));else{l===void 0&&(l=r.substr(0,g));const k=s[D];k!==void 0?(c!==-1&&(l+=encodeURIComponent(r.substring(c,g)),c=-1),l+=k):c===-1&&(c=g)}}return c!==-1&&(l+=encodeURIComponent(r.substring(c))),l!==void 0?l:r}function u(r){let i;for(let a=0;a<r.length;a++){const l=r.charCodeAt(a);l===35||l===63?(i===void 0&&(i=r.substr(0,a)),i+=s[l]):i!==void 0&&(i+=r[a])}return i!==void 0?i:r}function f(r,i){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=f;function I(r,i){const a=i?u:h;let l="",{scheme:c,authority:g,path:D,query:k,fragment:S}=r;if(c&&(l+=c,l+=":"),(g||c==="file")&&(l+=y,l+=y),g){let F=g.indexOf("@");if(F!==-1){const H=g.substr(0,F);g=g.substr(F+1),F=H.lastIndexOf(":"),F===-1?l+=a(H,!1,!1):(l+=a(H.substr(0,F),!1,!1),l+=":",l+=a(H.substr(F+1),!1,!0)),l+="@"}g=g.toLowerCase(),F=g.lastIndexOf(":"),F===-1?l+=a(g,!1,!0):(l+=a(g.substr(0,F),!1,!0),l+=g.substr(F))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const F=D.charCodeAt(1);F>=65&&F<=90&&(D=`/${String.fromCharCode(F+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const F=D.charCodeAt(0);F>=65&&F<=90&&(D=`${String.fromCharCode(F+32)}:${D.substr(2)}`)}l+=a(D,!0,!1)}return k&&(l+="?",l+=a(k,!1,!1)),S&&(l+="#",l+=i?S:h(S,!1,!1)),l}function O(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+O(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,i=>O(i)):r}}),define(ge[161],pe([1,0,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(m){const T=m;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=L;function o(m){const T=[];let y;try{const E=JSON.parse(m.arguments),d=E[E.length-1];d&&d.__$stack&&(E.pop(),y=d.__$stack),T.push(...E)}catch{T.push("Unable to log remote console arguments",m.arguments)}return{args:T,stack:y}}e.parse=o;function P(m){if(typeof m!="string")return P(o(m).stack);const T=m;if(T){const y=C(T),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(E&&E.length===4)return{uri:w.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=P;function C(m){if(!m)return m;const T=m.indexOf(`
`);return T===-1?m:m.substring(0,T)}function A(m,T){const{args:y,stack:E}=o(m),d=typeof y[0]=="string"&&y.length===1;let p=C(E);p&&(p=`(${p.trim()})`);let b=[];if(typeof y[0]=="string"?p&&d?b=[`%c[${T}] %c${y[0]} %c${p}`,v("blue"),v(""),v("grey")]:b=[`%c[${T}] %c${y[0]}`,v("blue"),v(""),...y.slice(1)]:b=[`%c[${T}]%`,v("blue"),...y],p&&!d&&b.push(p),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,b)}e.log=A;function v(m){return`color: ${m}`}}),define(ge[61],pe([1,0,15,17,4]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(m){return JSON.stringify(m,A)}e.stringify=P;function C(m){let T=JSON.parse(m);return T=v(T),T}e.parse=C;function A(m,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,L.regExpFlags)(T)}:T}function v(m,T=0){if(!m||T>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return o.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof w.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let y=0;y<m.length;++y)m[y]=v(m[y],T+1);else for(const y in m)Object.hasOwnProperty.call(m,y)&&(m[y]=v(m[y],T+1))}return m}e.revive=v}),define(ge[13],pe([1,0,11,3,4]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var P;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeInteractiveSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(P||(e.Schemas=P={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${P.vscodeRemoteResource}`}setPreferredWebSchema(T){this.d=T}setDelegate(T){this.e=T}setServerRootPath(T){this.f=`${T}/${P.vscodeRemoteResource}`}set(T,y,E){this.a[T]=y,this.b[T]=E}setConnectionToken(T,y){this.c[T]=y}getPreferredWebSchema(){return this.d}rewrite(T){if(this.e)try{return this.e(T)}catch(s){return w.onUnexpectedError(s),T}const y=T.authority;let E=this.a[y];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const d=this.b[y],p=this.c[y];let b=`path=${encodeURIComponent(T.path)}`;return typeof p=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),o.URI.from({scheme:L.isWeb?this.d:P.vscodeRemoteResource,authority:`${E}:${d}`,path:this.f,query:b})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(T){const y=this.b(T,oe);return this.uriToBrowserUri(y)}uriToBrowserUri(T){return T.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===P.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${P.vscodeFileResource}://${A.a}`)?T.with({scheme:P.vscodeFileResource,authority:T.authority||A.a,query:null,fragment:null}):T}asFileUri(T){const y=this.b(T,oe);return this.uriToFileUri(y)}uriToFileUri(T){return T.scheme===P.vscodeFileResource?T.with({scheme:P.file,authority:T.authority!==A.a?T.authority:null,query:null,fragment:null}):T}b(T,y){return o.URI.isUri(T)?T:o.URI.parse(y.toUrl(T))}}A.a="vscode-app",e.FileAccess=new A;var v;(function(m){const T=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(T.get("3"));const y="vscode-coi";function E(p){let b;typeof p=="string"?b=new URL(p).searchParams:p instanceof URL?b=p.searchParams:o.URI.isUri(p)&&(b=new URL(p.toString(!0)).searchParams);const s=b?.get(y);if(s)return T.get(s)}m.getHeadersFromQuery=E;function d(p,b,s){if(!globalThis.crossOriginIsolated)return;const h=b&&s?"3":s?"2":"1";p instanceof URLSearchParams?p.set(y,h):p[y]=h}m.addSearchParam=d})(v||(e.COI=v={}))}),define(ge[19],pe([1,0,39,13,7,3,17,4]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(d){return(0,A.uriToFsPath)(d,!0)}e.originalFSPath=v;class m{constructor(p){this.a=p}compare(p,b,s=!1){return p===b?0:(0,C.compare)(this.getComparisonKey(p,s),this.getComparisonKey(b,s))}isEqual(p,b,s=!1){return p===b?!0:!p||!b?!1:this.getComparisonKey(p,s)===this.getComparisonKey(b,s)}getComparisonKey(p,b=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,b,s=!1){if(p.scheme===b.scheme){if(p.scheme===L.Schemas.file)return w.isEqualOrParent(v(p),v(b),this.a(p))&&p.query===b.query&&(s||p.fragment===b.fragment);if((0,e.isEqualAuthority)(p.authority,b.authority))return w.isEqualOrParent(p.path,b.path,this.a(p),"/")&&p.query===b.query&&(s||p.fragment===b.fragment)}return!1}joinPath(p,...b){return A.URI.joinPath(p,...b)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return o.posix.basename(p.path)}extname(p){return o.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let b;return p.scheme===L.Schemas.file?b=A.URI.file(o.dirname(v(p))).path:(b=o.posix.dirname(p.path),p.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),b="/")),p.with({path:b})}normalizePath(p){if(!p.path.length)return p;let b;return p.scheme===L.Schemas.file?b=A.URI.file(o.normalize(v(p))).path:b=o.posix.normalize(p.path),p.with({path:b})}relativePath(p,b){if(p.scheme!==b.scheme||!(0,e.isEqualAuthority)(p.authority,b.authority))return;if(p.scheme===L.Schemas.file){const u=o.relative(v(p),v(b));return P.isWindows?w.toSlashes(u):u}let s=p.path||"/";const h=b.path||"/";if(this.a(p)){let u=0;for(const f=Math.min(s.length,h.length);u<f&&!(s.charCodeAt(u)!==h.charCodeAt(u)&&s.charAt(u).toLowerCase()!==h.charAt(u).toLowerCase());u++);s=h.substr(0,u)+s.substr(u)}return o.posix.relative(s,h)}resolvePath(p,b){if(p.scheme===L.Schemas.file){const s=A.URI.file(o.resolve(v(p),b));return p.with({authority:s.authority,path:s.path})}return b=w.toPosixPath(b),p.with({path:o.posix.resolve(p.path,b)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,b){return p===b||p!==void 0&&b!==void 0&&(0,C.equalsIgnoreCase)(p,b)}hasTrailingPathSeparator(p,b=o.sep){if(p.scheme===L.Schemas.file){const s=v(p);return s.length>w.getRoot(s).length&&s[s.length-1]===b}else{const s=p.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,b=o.sep){return(0,e.hasTrailingPathSeparator)(p,b)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,b=o.sep){let s=!1;if(p.scheme===L.Schemas.file){const h=v(p);s=h!==void 0&&h.length===w.getRoot(h).length&&h[h.length-1]===b}else{b="/";const h=p.path;s=h.length===1&&h.charCodeAt(h.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(p,b)?p.with({path:p.path+"/"}):p}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(d=>d.scheme===L.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new m(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(d,p){const b=[];for(let s=0;s<d.length;s++){const h=p(d[s]);d.some((u,f)=>f===s?!1:(0,e.isEqualOrParent)(h,p(u)))||b.push(d[s])}return b}e.distinctParents=T;var y;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function p(b){const s=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(f=>{const[I,O]=f.split(":");I&&O&&s.set(I,O)});const u=b.path.substring(0,b.path.indexOf(";"));return u&&s.set(d.META_DATA_MIME,u),s}d.parseMetaData=p})(y||(e.DataUri=y={}));function E(d,p,b){if(p){let s=d.path;return s&&s[0]!==o.posix.sep&&(s=o.posix.sep+s),d.with({scheme:b,authority:p,path:s})}return d.with({scheme:b})}e.toLocalResource=E}),define(ge[14],pe([1,0,20,11,6,2,19,3,145]),function(oe,e,w,L,o,P,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(x){return!!x&&typeof x.then=="function"}e.isThenable=m;function T(x){const N=new w.CancellationTokenSource,R=x(N.token),U=new Promise((X,ie)=>{const j=N.token.onCancellationRequested(()=>{j.dispose(),N.dispose(),ie(new L.CancellationError)});Promise.resolve(R).then($=>{j.dispose(),N.dispose(),X($)},$=>{j.dispose(),N.dispose(),ie($)})});return new class{cancel(){N.cancel()}then(X,ie){return U.then(X,ie)}catch(X){return this.then(void 0,X)}finally(X){return U.finally(X)}}}e.createCancelablePromise=T;function y(x,N,R){return new Promise((U,X)=>{const ie=N.onCancellationRequested(()=>{ie.dispose(),U(R)});x.then(U,X).finally(()=>ie.dispose())})}e.raceCancellation=y;function E(x,N){return new Promise((R,U)=>{const X=N.onCancellationRequested(()=>{X.dispose(),U(new L.CancellationError)});x.then(R,U).finally(()=>X.dispose())})}e.raceCancellationError=E;async function d(x){let N=-1;const R=x.map((U,X)=>U.then(ie=>(N=X,ie)));try{return await Promise.race(R)}finally{x.forEach((U,X)=>{X!==N&&U.cancel()})}}e.raceCancellablePromises=d;function p(x,N,R){let U;const X=setTimeout(()=>{U?.(void 0),R?.()},N);return Promise.race([x.finally(()=>clearTimeout(X)),new Promise(ie=>U=ie)])}e.raceTimeout=p;function b(x){return new Promise((N,R)=>{const U=x();m(U)?U.then(N,R):N(U)})}e.asPromise=b;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(N){if(this.a){if(this.d=N,!this.b){const R=()=>{this.b=null;const U=this.queue(this.d);return this.d=null,U};this.b=new Promise(U=>{this.a.then(R,R).then(U)})}return new Promise((R,U)=>{this.b.then(R,U)})}return this.a=N(),new Promise((R,U)=>{this.a.then(X=>{this.a=null,R(X)},X=>{this.a=null,U(X)})})}}e.Throttler=s;class h{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.Sequencer=h;class u{constructor(){this.a=new Map}queue(N,R){const X=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(R).finally(()=>{this.a.get(N)===X&&this.a.delete(N)});return this.a.set(N,X),X}}e.SequencerByKey=u;const f=(x,N)=>{let R=!0;const U=setTimeout(()=>{R=!1,N()},x);return{isTriggered:()=>R,dispose:()=>{clearTimeout(U),R=!1}}},I=x=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,x())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class O{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,R=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((X,ie)=>{this.d=X,this.f=ie}).then(()=>{if(this.b=null,this.d=null,this.g){const X=this.g;return this.g=null,X()}}));const U=()=>{this.a=null,this.d?.(null)};return this.a=R===v.MicrotaskDelay?I(U):f(R,U),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=O;class t{constructor(N){this.a=new O(N),this.b=new s}trigger(N,R){return this.a.trigger(()=>this.b.queue(N),R)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class n{constructor(){this.a=!1,this.b=new Promise((N,R)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class r extends n{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function i(x,N){return N?new Promise((R,U)=>{const X=setTimeout(()=>{ie.dispose(),R()},x),ie=N.onCancellationRequested(()=>{clearTimeout(X),ie.dispose(),U(new L.CancellationError)})}):T(R=>i(x,R))}e.timeout=i;function a(x,N=0){const R=setTimeout(x,N);return(0,P.toDisposable)(()=>clearTimeout(R))}e.disposableTimeout=a;function l(x){const N=[];let R=0;const U=x.length;function X(){return R<U?x[R++]():null}function ie(j){j!=null&&N.push(j);const $=X();return $?$.then(ie):Promise.resolve(N)}return Promise.resolve(null).then(ie)}e.sequence=l;function c(x,N=U=>!!U,R=null){let U=0;const X=x.length,ie=()=>{if(U>=X)return Promise.resolve(R);const j=x[U++];return Promise.resolve(j()).then(J=>N(J)?Promise.resolve(J):ie())};return ie()}e.first=c;function g(x,N=U=>!!U,R=null){if(x.length===0)return Promise.resolve(R);let U=x.length;const X=()=>{U=-1;for(const ie of x)ie.cancel?.()};return new Promise((ie,j)=>{for(const $ of x)$.then(J=>{--U>=0&&N(J)?(X(),ie(J)):U===0&&ie(R)}).catch(J=>{--U>=0&&(X(),j(J))})})}e.firstParallel=g;class D{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new o.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((R,U)=>{this.f.push({factory:N,c:R,e:U}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const R=N.factory();R.then(N.c,N.e),R.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=D;class k extends D{constructor(){super(1)}}e.Queue=k;class S{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const N=new q;return this.b.add(N),N.p}d(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,R=C.extUri){const U=R.getComparisonKey(N);let X=this.a.get(U);return X||(X=new k,o.Event.once(X.onDrained)(()=>{X?.dispose(),this.a.delete(U),this.f()}),this.a.set(U,X)),X}f(){this.d()&&this.g()}g(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.g()}}e.ResourceQueue=S;class F{constructor(N,R){this.a=-1,typeof N=="function"&&typeof R=="number"&&this.setIfNotSet(N,R)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,R){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},R)}setIfNotSet(N,R){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},R))}}e.TimeoutTimer=F;class H{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(N,R){this.cancel(),this.a=setInterval(()=>{N()},R)}}e.IntervalTimer=H;class te{constructor(N,R){this.b=-1,this.a=N,this.d=R,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=te;class ce{constructor(N,R){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.a=N,this.b=R,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=ce;class le extends te{constructor(N,R){super(N,R),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=le;class ue extends P.Disposable{constructor(N,R){super(),this.g=N,this.h=R,this.a=[],this.b=this.B(new P.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const R of N)this.a.push(R);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,A.setTimeout0)(()=>{if(N)return;const R=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,R-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(x,N)=>{const R=requestIdleCallback(x,typeof N=="number"?{timeout:N}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(R))}}}}();class ve{constructor(N){this.d=!1,this.a=()=>{try{this.f=N()}catch(R){this.g=R}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ve;async function K(x,N,R){let U;for(let X=0;X<R;X++)try{return await x()}catch(ie){U=ie,await i(N)}throw U}e.retry=K;class ee{hasPending(N){return this.a?typeof N=="number"?this.a.taskId===N:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(N,R,U){return this.a={taskId:N,cancel:()=>U?.(),promise:R},R.then(()=>this.d(N),()=>this.d(N)),R}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this.b)this.b.run=N;else{let R,U;const X=new Promise((ie,j)=>{R=ie,U=j});this.b={run:N,promise:X,promiseResolve:R,promiseReject:U}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=ee;class z{constructor(N,R=()=>Date.now()){this.d=N,this.f=R,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.IntervalCounter=z;class q{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((N,R)=>{this.a=N,this.b=R})}complete(N){return new Promise(R=>{this.a(N),this.f=!0,R()})}error(N){return new Promise(R=>{this.b(N),this.d=!0,R()})}cancel(){new Promise(N=>{this.b(new L.CancellationError),this.d=!0,N()})}}e.DeferredPromise=q;var G;(function(x){async function N(U){let X;const ie=await Promise.all(U.map(j=>j.then($=>$,$=>{X||(X=$)})));if(typeof X<"u")throw X;return ie}x.settled=N;function R(U){return new Promise(async(X,ie)=>{try{await U(X,ie)}catch(j){ie(j)}})}x.withAsyncBody=R})(G||(e.Promises=G={}));var ne;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(ne||(ne={}));class se{static fromArray(N){return new se(R=>{R.emitMany(N)})}static fromPromise(N){return new se(async R=>{R.emitMany(await N)})}static fromPromises(N){return new se(async R=>{await Promise.all(N.map(async U=>R.emitOne(await U)))})}static merge(N){return new se(async R=>{await Promise.all(N.map(async U=>{for await(const X of U)R.emitOne(X)}))})}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new o.Emitter,queueMicrotask(async()=>{const R={emitOne:U=>this.g(U),emitMany:U=>this.h(U),reject:U=>this.k(U)};try{await Promise.resolve(N(R)),this.j()}catch(U){this.k(U)}finally{R.emitOne=void 0,R.emitMany=void 0,R.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await o.Event.toPromise(this.f.event)}while(!0)}}}static map(N,R){return new se(async U=>{for await(const X of N)U.emitOne(R(X))})}map(N){return se.map(this,N)}static filter(N,R){return new se(async U=>{for await(const X of N)R(X)&&U.emitOne(X)})}filter(N){return se.filter(this,N)}static coalesce(N){return se.filter(N,R=>!!R)}coalesce(){return se.coalesce(this)}static async toPromise(N){const R=[];for await(const U of N)R.push(U);return R}toPromise(){return se.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}e.AsyncIterableObject=se,se.EMPTY=se.fromArray([]);class de extends se{constructor(N,R){super(R),this.l=N}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=de;function W(x){const N=new w.CancellationTokenSource,R=x(N.token);return new de(N,async U=>{const X=N.token.onCancellationRequested(()=>{X.dispose(),N.dispose(),U.reject(new L.CancellationError)});try{for await(const ie of R){if(N.token.isCancellationRequested)return;U.emitOne(ie)}X.dispose(),N.dispose()}catch(ie){X.dispose(),N.dispose(),U.reject(ie)}})}e.createCancelableAsyncIterable=W}),define(ge[76],pe([1,0,18,14,39,27,7,3,17]),function(oe,e,w,L,o,P,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",y="[^/\\\\]",E=/\//g;function d(z,q){switch(z){case 0:return"";case 1:return`${y}*?`;default:return`(?:${T}|${y}+${T}${q?`|${T}${y}+`:""})*?`}}function p(z,q){if(!z)return[];const G=[];let ne=!1,se=!1,de="";for(const W of z){switch(W){case q:if(!ne&&!se){G.push(de),de="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":se=!0;break;case"]":se=!1;break}de+=W}return de&&G.push(de),G}e.splitGlobAware=p;function b(z){if(!z)return"";let q="";const G=p(z,e.GLOB_SPLIT);if(G.every(ne=>ne===e.GLOBSTAR))q=".*";else{let ne=!1;G.forEach((se,de)=>{if(se===e.GLOBSTAR){if(ne)return;q+=d(2,de===G.length-1)}else{let W=!1,x="",N=!1,R="";for(const U of se){if(U!=="}"&&W){x+=U;continue}if(N&&(U!=="]"||!R)){let X;U==="-"?X=U:(U==="^"||U==="!")&&!R?X="^":U===e.GLOB_SPLIT?X="":X=(0,v.escapeRegExpCharacters)(U),R+=X;continue}switch(U){case"{":W=!0;continue;case"[":N=!0;continue;case"}":{const ie=`(?:${p(x,",").map(j=>b(j)).join("|")})`;q+=ie,W=!1,x="";break}case"]":{q+="["+R+"]",N=!1,R="";break}case"?":q+=y;continue;case"*":q+=d(1);continue;default:q+=(0,v.escapeRegExpCharacters)(U)}}de<G.length-1&&(G[de+1]!==e.GLOBSTAR||de+2<G.length)&&(q+=T)}ne=se===e.GLOBSTAR})}return q}const s=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,I=/^\*\*((\/[\w\.-]+)+)\/?$/,O=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),n=function(){return!1},r=function(){return null};function i(z,q){if(!z)return r;let G;typeof z!="string"?G=z.pattern:G=z,G=G.trim();const ne=`${G}_${!!q.trimForExclusions}`;let se=t.get(ne);if(se)return a(se,z);let de;return s.test(G)?se=c(G.substr(4),G):(de=h.exec(l(G,q)))?se=g(de[1],G):(q.trimForExclusions?f:u).test(G)?se=D(G,q):(de=I.exec(l(G,q)))?se=k(de[1].substr(1),G,!0):(de=O.exec(l(G,q)))?se=k(de[1],G,!1):se=S(G),t.set(ne,se),a(se,z)}function a(z,q){if(typeof q=="string")return z;const G=function(ne,se){return(0,o.isEqualOrParent)(ne,q.base,!A.isLinux)?z((0,v.ltrim)(ne.substr(q.base.length),C.sep),se):null};return G.allBasenames=z.allBasenames,G.allPaths=z.allPaths,G.basenames=z.basenames,G.patterns=z.patterns,G}function l(z,q){return q.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function c(z,q){return function(G,ne){return typeof G=="string"&&G.endsWith(z)?q:null}}function g(z,q){const G=`/${z}`,ne=`\\${z}`,se=function(W,x){return typeof W!="string"?null:x?x===z?q:null:W===z||W.endsWith(G)||W.endsWith(ne)?q:null},de=[z];return se.basenames=de,se.patterns=[q],se.allBasenames=de,se}function D(z,q){const G=K(z.slice(1,-1).split(",").map(x=>i(x,q)).filter(x=>x!==r),z),ne=G.length;if(!ne)return r;if(ne===1)return G[0];const se=function(x,N){for(let R=0,U=G.length;R<U;R++)if(G[R](x,N))return z;return null},de=G.find(x=>!!x.allBasenames);de&&(se.allBasenames=de.allBasenames);const W=G.reduce((x,N)=>N.allPaths?x.concat(N.allPaths):x,[]);return W.length&&(se.allPaths=W),se}function k(z,q,G){const ne=C.sep===C.posix.sep,se=ne?z:z.replace(E,C.sep),de=C.sep+se,W=C.posix.sep+z;let x;return G?x=function(N,R){return typeof N=="string"&&(N===se||N.endsWith(de)||!ne&&(N===z||N.endsWith(W)))?q:null}:x=function(N,R){return typeof N=="string"&&(N===se||!ne&&N===z)?q:null},x.allPaths=[(G?"*/":"./")+z],x}function S(z){try{const q=new RegExp(`^${b(z)}$`);return function(G){return q.lastIndex=0,typeof G=="string"&&q.test(G)?z:null}}catch{return r}}function F(z,q,G){return!z||typeof q!="string"?!1:H(z)(q,void 0,G)}e.match=F;function H(z,q={}){if(!z)return n;if(typeof z=="string"||te(z)){const G=i(z,q);if(G===r)return n;const ne=function(se,de){return!!G(se,de)};return G.allBasenames&&(ne.allBasenames=G.allBasenames),G.allPaths&&(ne.allPaths=G.allPaths),ne}return ue(z,q)}e.parse=H;function te(z){const q=z;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=te;function ce(z){return z.allBasenames||[]}e.getBasenameTerms=ce;function le(z){return z.allPaths||[]}e.getPathTerms=le;function ue(z,q){const G=K(Object.getOwnPropertyNames(z).map(x=>ve(x,z[x],q)).filter(x=>x!==r)),ne=G.length;if(!ne)return r;if(!G.some(x=>!!x.requiresSiblings)){if(ne===1)return G[0];const x=function(U,X){let ie;for(let j=0,$=G.length;j<$;j++){const J=G[j](U,X);if(typeof J=="string")return J;(0,L.isThenable)(J)&&(ie||(ie=[]),ie.push(J))}return ie?(async()=>{for(const j of ie){const $=await j;if(typeof $=="string")return $}return null})():null},N=G.find(U=>!!U.allBasenames);N&&(x.allBasenames=N.allBasenames);const R=G.reduce((U,X)=>X.allPaths?U.concat(X.allPaths):U,[]);return R.length&&(x.allPaths=R),x}const se=function(x,N,R){let U,X;for(let ie=0,j=G.length;ie<j;ie++){const $=G[ie];$.requiresSiblings&&R&&(N||(N=(0,C.basename)(x)),U||(U=N.substr(0,N.length-(0,C.extname)(x).length)));const J=$(x,N,U,R);if(typeof J=="string")return J;(0,L.isThenable)(J)&&(X||(X=[]),X.push(J))}return X?(async()=>{for(const ie of X){const j=await ie;if(typeof j=="string")return j}return null})():null},de=G.find(x=>!!x.allBasenames);de&&(se.allBasenames=de.allBasenames);const W=G.reduce((x,N)=>N.allPaths?x.concat(N.allPaths):x,[]);return W.length&&(se.allPaths=W),se}function ve(z,q,G){if(q===!1)return r;const ne=i(z,G);if(ne===r)return r;if(typeof q=="boolean")return ne;if(q){const se=q.when;if(typeof se=="string"){const de=(W,x,N,R)=>{if(!R||!ne(W,x))return null;const U=se.replace("$(basename)",()=>N),X=R(U);return(0,L.isThenable)(X)?X.then(ie=>ie?z:null):X?z:null};return de.requiresSiblings=!0,de}}return ne}function K(z,q){const G=z.filter(x=>!!x.basenames);if(G.length<2)return z;const ne=G.reduce((x,N)=>{const R=N.basenames;return R?x.concat(R):x},[]);let se;if(q){se=[];for(let x=0,N=ne.length;x<N;x++)se.push(q)}else se=G.reduce((x,N)=>{const R=N.patterns;return R?x.concat(R):x},[]);const de=function(x,N){if(typeof x!="string")return null;if(!N){let U;for(U=x.length;U>0;U--){const X=x.charCodeAt(U-1);if(X===47||X===92)break}N=x.substr(U)}const R=ne.indexOf(N);return R!==-1?se[R]:null};de.basenames=ne,de.patterns=se,de.allBasenames=ne;const W=z.filter(x=>!x.basenames);return W.push(de),W}function ee(z,q){return(0,w.equals)(z,q,(G,ne)=>typeof G=="string"&&typeof ne=="string"?G===ne:typeof G!="string"&&typeof ne!="string"?G.base===ne.base&&G.pattern===ne.pattern:!1)}e.patternsEquals=ee}),define(ge[98],pe([1,0,11,160,19,17,4]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class v{constructor(h="",u=!1){if(this.value=h,typeof this.value!="string")throw(0,w.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(h,u=0){return this.value+=E(this.supportThemeIcons?(0,L.escapeIcons)(h):h).replace(/([ \t]+)/g,(f,I)=>"&nbsp;".repeat(I.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,u){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}appendLink(h,u,f){return this.value+="[",this.value+=this.c(u,"]"),this.value+="](",this.value+=this.c(String(h),")"),f&&(this.value+=` "${this.c(this.c(f,'"'),")")}"`),this.value+=")",this}c(h,u){const f=new RegExp((0,P.escapeRegExpCharacters)(u),"g");return h.replace(f,(I,O)=>h.charAt(O-1)!=="\\"?`\\${I}`:I)}}e.MarkdownString=v;function m(s){return T(s)?!s.value:Array.isArray(s)?s.every(m):!0}e.isEmptyMarkdownString=m;function T(s){return s instanceof v?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function y(s,h){return s===h?!0:!s||!h?!1:s.value===h.value&&s.isTrusted===h.isTrusted&&s.supportThemeIcons===h.supportThemeIcons&&s.supportHtml===h.supportHtml&&(s.baseUri===h.baseUri||!!s.baseUri&&!!h.baseUri&&(0,o.isEqual)(C.URI.from(s.baseUri),C.URI.from(h.baseUri)))}e.markdownStringEqual=y;function E(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function d(s){return s.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=d;function p(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=p;function b(s){const h=[],u=s.split("|").map(I=>I.trim());s=u[0];const f=u[1];if(f){const I=/height=(\d+)/.exec(f),O=/width=(\d+)/.exec(f),t=I?I[1]:"",n=O?O[1]:"",r=isFinite(parseInt(n)),i=isFinite(parseInt(t));r&&h.push(`width="${n}"`),i&&h.push(`height="${t}"`)}return{href:s,dimensions:h}}e.parseHrefAndDimensions=b}),define(ge[162],pe([1,0,18,39,7,3,19,17]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function v(r,i){const{os:a,tildify:l,relative:c}=i;if(c){const k=m(r,c,a);if(typeof k=="string")return k}let g=r.fsPath;if(a===1&&!P.isWindows?g=g.replace(/\//g,"\\"):a!==1&&P.isWindows&&(g=g.replace(/\\/g,"/")),a!==1&&l?.userHome){const k=l.userHome.fsPath;let S;r.scheme!==l.userHome.scheme&&r.path.startsWith(o.posix.sep)?S=l.userHome.with({path:r.path}).fsPath:S=r.fsPath,g=E(S,k,a)}return(a===1?o.win32:o.posix).normalize(T(g,a===1))}e.getPathLabel=v;function m(r,i,a){const l=a===1?o.win32:o.posix,c=a===3?C.extUri:C.extUriIgnorePathCase,g=i.getWorkspace(),D=(0,w.firstOrDefault)(g.folders);if(!D)return;r.scheme!==D.uri.scheme&&r.path.startsWith(o.posix.sep)&&(r=D.uri.with({path:r.path}));const k=i.getWorkspaceFolder(r);if(!k)return;let S;if(c.isEqual(k.uri,r)?S="":S=c.relativePath(k.uri,r)??"",S&&(S=l.normalize(S)),g.folders.length>1&&!i.noPrefix){const F=k.name?k.name:c.basenameOrAuthority(k.uri);S=S?`${F} \u2022 ${S}`:F}return S}function T(r,i=P.isWindows){return(0,L.hasDriveLetter)(r,i)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=T;let y=Object.create(null);function E(r,i,a=P.OS){if(a===1||!r||!i)return r;let l=y.original===i?y.normalized:void 0;l||(l=i,P.isWindows&&(l=(0,L.toSlashes)(l)),l=`${(0,A.rtrim)(l,o.posix.sep)}${o.posix.sep}`,y={original:i,normalized:l});let c=r;return P.isWindows&&(c=(0,L.toSlashes)(c)),(a===3?c.startsWith(l):(0,A.startsWithIgnoreCase)(c,l))?`~/${c.substr(l.length)}`:r}e.tildify=E;function d(r,i){return r.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=d;const p="\u2026",b="\\\\",s="~";function h(r,i=o.sep){const a=new Array(r.length);let l=!1;for(let c=0;c<r.length;c++){const g=r[c];if(g===""){a[c]=`.${i}`;continue}if(!g){a[c]=g;continue}l=!0;let D="",k=g;k.indexOf(b)===0?(D=k.substr(0,k.indexOf(b)+b.length),k=k.substr(k.indexOf(b)+b.length)):k.indexOf(i)===0?(D=k.substr(0,k.indexOf(i)+i.length),k=k.substr(k.indexOf(i)+i.length)):k.indexOf(s)===0&&(D=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length));const S=k.split(i);for(let F=1;l&&F<=S.length;F++)for(let H=S.length-F;l&&H>=0;H--){l=!1;let te=S.slice(H,H+F).join(i);for(let ce=0;!l&&ce<r.length;ce++)if(ce!==c&&r[ce]&&r[ce].indexOf(te)>-1){const le=H+F===S.length,ue=H>0&&r[ce].indexOf(i)>-1?i+te:te,ve=r[ce].endsWith(ue);l=!le||ve}if(!l){let ce="";(S[0].endsWith(":")||D!=="")&&(H===1&&(H=0,F++,te=S[0]+i+te),H>0&&(ce=S[0]+i),ce=D+ce),H>0&&(ce=ce+p+i),ce=ce+te,H+F<S.length&&(ce=ce+i+p),a[c]=ce}}l&&(a[c]=g)}return a}e.shorten=h;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function f(r,i=Object.create(null)){const a=[];let l=!1,c="";for(const g of r)if(g==="$"||l&&g==="{")c&&a.push({value:c,type:u.TEXT}),c="",l=!0;else if(g==="}"&&l){const D=i[c];if(typeof D=="string")D.length&&a.push({value:D,type:u.VARIABLE});else if(D){const k=a[a.length-1];(!k||k.type!==u.SEPARATOR)&&a.push({value:D.label,type:u.SEPARATOR})}c="",l=!1}else c+=g;return c&&!l&&a.push({value:c,type:u.TEXT}),a.filter((g,D)=>{if(g.type===u.SEPARATOR){const k=a[D-1],S=a[D+1];return[k,S].every(F=>F&&(F.type===u.VARIABLE||F.type===u.TEXT)&&F.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=f;function I(r,i){return P.isMacintosh||i?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):r.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=I;function O(r,i){return P.isMacintosh||i?r.replace(/\(&&\w\)|&&/g,""):P.isWindows?r.replace(/&&|&/g,a=>a==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=O;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function n(r){const i=r.indexOf("/")!==-1?o.posix:o.win32,a=i.basename(r),l=i.dirname(r);return a.length?{name:a,parentPath:l}:{name:l,parentPath:""}}e.splitName=n}),define(ge[50],pe([1,0,15,4]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function o(y){return y.toJSON()}class P{constructor(E){this.a=E}transformIncoming(E){const d=this.a.transformIncoming(E);return d===E?E:o(L.URI.from(d))}transformOutgoing(E){const d=this.a.transformOutgoing(E);return d===E?E:o(L.URI.from(d))}transformOutgoingURI(E){const d=this.a.transformOutgoing(E);return d===E?E:L.URI.from(d)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function C(y,E,d){if(!y||d>200)return null;if(typeof y=="object"){if(y instanceof L.URI)return E.transformOutgoing(y);for(const p in y)if(Object.hasOwnProperty.call(y,p)){const b=C(y[p],E,d+1);b!==null&&(y[p]=b)}}return null}function A(y,E){const d=C(y,E,0);return d===null?y:d}e.transformOutgoingURIs=A;function v(y,E,d,p){if(!y||p>200)return null;if(typeof y=="object"){if(y.$mid===1)return d?L.URI.revive(E.transformIncoming(y)):E.transformIncoming(y);if(y instanceof w.VSBuffer)return null;for(const b in y)if(Object.hasOwnProperty.call(y,b)){const s=v(y[b],E,d,p+1);s!==null&&(y[b]=s)}}return null}function m(y,E){const d=v(y,E,!1,0);return d===null?y:d}e.transformIncomingURIs=m;function T(y,E){const d=v(y,E,!0,0);return d===null?y:d}e.transformAndReviveIncomingURIs=T}),define(ge[99],pe([1,0,28,60,22,148]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(m){return this.a||(this.a=L.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,T=0;const y=(0,w.networkInterfaces)();for(const E in y){const d=y[E];if(d)for(const{mac:p,internal:b}of d)b||(T+=1,this.c(p.toUpperCase())&&(m+=1))}this.b=T>0?m/T:0}return this.b}};let C;async function A(m){return C||(C=(async()=>await v(m)||o.generateUuid())()),C}e.getMachineId=A;async function v(m){try{const T=await new Promise((E,d)=>{oe(["crypto"],E,d)}),y=(0,P.getMac)();return T.createHash("sha256").update(y,"utf8").digest("hex")}catch(T){m(T);return}}}),define(ge[23],pe([1,0,33,28,292,14,39,94,7,3,19,4]),function(oe,e,w,L,o,P,C,A,v,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(ue){ue[ue.UNLINK=0]="UNLINK",ue[ue.MOVE=1]="MOVE"})(E||(e.RimRafMode=E={}));async function d(ue,ve=E.UNLINK){if((0,C.isRootOrDriveLetter)(ue))throw new Error("rimraf - will refuse to recursively delete root");return ve===E.UNLINK?b(ue):p(ue)}async function p(ue){try{const ve=(0,C.randomPath)((0,L.tmpdir)());try{await w.promises.rename(ue,ve)}catch(K){return K.code==="ENOENT"?void 0:b(ue)}b(ve).catch(K=>{})}catch(ve){if(ve.code!=="ENOENT")throw ve}}async function b(ue){return(0,o.promisify)(w.rm)(ue,{recursive:!0,force:!0,maxRetries:3})}function s(ue){if((0,C.isRootOrDriveLetter)(ue))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(ue,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=s;async function h(ue,ve){return I(await(ve?u(ue):(0,o.promisify)(w.readdir)(ue)))}async function u(ue){try{return await(0,o.promisify)(w.readdir)(ue,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const ve=[],K=await h(ue);for(const ee of K){let z=!1,q=!1,G=!1;try{const ne=await e.Promises.lstat((0,v.join)(ue,ee));z=ne.isFile(),q=ne.isDirectory(),G=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}ve.push({name:ee,isFile:()=>z,isDirectory:()=>q,isSymbolicLink:()=>G})}return ve}function f(ue){return I(w.readdirSync(ue))}e.readdirSync=f;function I(ue){return ue.map(ve=>typeof ve=="string"?m.isMacintosh?(0,A.normalizeNFC)(ve):ve:(ve.name=m.isMacintosh?(0,A.normalizeNFC)(ve.name):ve.name,ve))}async function O(ue){const ve=await h(ue),K=[];for(const ee of ve)await n.existsDirectory((0,v.join)(ue,ee))&&K.push(ee);return K}function t(ue,ve=1e3){return new Promise(K=>{let ee=!1;const z=setInterval(()=>{ee||(ee=!0,w.access(ue,q=>{ee=!1,q&&(clearInterval(z),K(void 0))}))},ve)})}e.whenDeleted=t;var n;(function(ue){async function ve(z){let q;try{if(q=await e.Promises.lstat(z),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(m.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw ne}throw G}}ue.stat=ve;async function K(z){try{const{stat:q,symbolicLink:G}=await ue.stat(z);return q.isFile()&&G?.dangling!==!0}catch{}return!1}ue.existsFile=K;async function ee(z){try{const{stat:q,symbolicLink:G}=await ue.stat(z);return q.isDirectory()&&G?.dangling!==!0}catch{}return!1}ue.existsDirectory=ee})(n||(e.SymlinkSupport=n={}));const r=new P.ResourceQueue;function i(ue,ve,K){return r.queueFor(y.URI.file(ue),T.extUriBiasedIgnorePathCase).queue(()=>{const ee=D(K);return new Promise((z,q)=>c(ue,ve,ee,G=>G?q(G):z()))})}let a=!0;function l(ue){a=ue}e.configureFlushOnWrite=l;function c(ue,ve,K,ee){if(!a)return w.writeFile(ue,ve,{mode:K.mode,flag:K.flag},ee);w.open(ue,K.flag,K.mode,(z,q)=>{if(z)return ee(z);w.writeFile(q,ve,G=>{if(G)return w.close(q,()=>ee(G));w.fdatasync(q,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),l(!1)),w.close(q,se=>ee(se))))})})}function g(ue,ve,K){const ee=D(K);if(!a)return w.writeFileSync(ue,ve,{mode:ee.mode,flag:ee.flag});const z=w.openSync(ue,ee.flag,ee.mode);try{w.writeFileSync(z,ve);try{w.fdatasyncSync(z)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),l(!1)}}finally{w.closeSync(z)}}e.writeFileSync=g;function D(ue){return ue?{mode:typeof ue.mode=="number"?ue.mode:438,flag:typeof ue.flag=="string"?ue.flag:"w"}:{mode:438,flag:"w"}}async function k(ue,ve){if(ue!==ve)try{await e.Promises.rename(ue,ve)}catch(K){if(ue.toLowerCase()!==ve.toLowerCase()&&K.code==="EXDEV"||ue.endsWith("."))await S(ue,ve,{preserveSymlinks:!1}),await d(ue,E.MOVE);else throw K}}async function S(ue,ve,K){return H(ue,ve,{root:{source:ue,target:ve},options:K,handledSourcePaths:new Set})}const F=511;async function H(ue,ve,K){if(K.handledSourcePaths.has(ue))return;K.handledSourcePaths.add(ue);const{stat:ee,symbolicLink:z}=await n.stat(ue);if(z){if(K.options.preserveSymlinks)try{return await le(ue,ve,K)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(z.dangling)return}return ee.isDirectory()?te(ue,ve,ee.mode&F,K):ce(ue,ve,ee.mode&F)}async function te(ue,ve,K,ee){await e.Promises.mkdir(ve,{recursive:!0,mode:K});const z=await h(ue);for(const q of z)await H((0,v.join)(ue,q),(0,v.join)(ve,q),ee)}async function ce(ue,ve,K){await e.Promises.copyFile(ue,ve),await e.Promises.chmod(ve,K)}async function le(ue,ve,K){let ee=await e.Promises.readlink(ue);(0,C.isEqualOrParent)(ee,K.root.source,!m.isLinux)&&(ee=(0,v.join)(K.root.target,ee.substr(K.root.source.length+1))),await e.Promises.symlink(ee,ve)}e.Promises=new class{get access(){return(0,o.promisify)(w.access)}get stat(){return(0,o.promisify)(w.stat)}get lstat(){return(0,o.promisify)(w.lstat)}get utimes(){return(0,o.promisify)(w.utimes)}get read(){return(ue,ve,K,ee,z)=>new Promise((q,G)=>{w.read(ue,ve,K,ee,z,(ne,se,de)=>ne?G(ne):q({bytesRead:se,buffer:de}))})}get readFile(){return(0,o.promisify)(w.readFile)}get write(){return(ue,ve,K,ee,z)=>new Promise((q,G)=>{w.write(ue,ve,K,ee,z,(ne,se,de)=>ne?G(ne):q({bytesWritten:se,buffer:de}))})}get appendFile(){return(0,o.promisify)(w.appendFile)}get fdatasync(){return(0,o.promisify)(w.fdatasync)}get truncate(){return(0,o.promisify)(w.truncate)}get rename(){return(0,o.promisify)(w.rename)}get copyFile(){return(0,o.promisify)(w.copyFile)}get open(){return(0,o.promisify)(w.open)}get close(){return(0,o.promisify)(w.close)}get symlink(){return(0,o.promisify)(w.symlink)}get readlink(){return(0,o.promisify)(w.readlink)}get chmod(){return(0,o.promisify)(w.chmod)}get mkdir(){return(0,o.promisify)(w.mkdir)}get unlink(){return(0,o.promisify)(w.unlink)}get rmdir(){return(0,o.promisify)(w.rmdir)}get realpath(){return(0,o.promisify)(w.realpath)}async exists(ue){try{return await e.Promises.access(ue),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return O}get writeFile(){return i}get rm(){return d}get move(){return k}get copy(){return S}}}),define(ge[163],pe([1,0,33,7,3,17,23]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(E){if(o.isLinux)return E;const d=(0,L.dirname)(E);if(E===d)return E;const p=((0,L.basename)(E)||E).toLowerCase();try{const s=(0,C.readdirSync)(d).filter(h=>h.toLowerCase()===p);if(s.length===1){const h=A(d);if(h)return(0,L.join)(h,s[0])}else if(s.length>1){const h=s.indexOf(p);if(h>=0){const u=A(d);if(u)return(0,L.join)(u,s[h])}}}catch{}return null}e.realcaseSync=A;async function v(E){if(o.isLinux)return E;const d=(0,L.dirname)(E);if(E===d)return E;const p=((0,L.basename)(E)||E).toLowerCase();try{const s=(await C.Promises.readdir(d)).filter(h=>h.toLowerCase()===p);if(s.length===1){const h=await v(d);if(h)return(0,L.join)(h,s[0])}else if(s.length>1){const h=s.indexOf(p);if(h>=0){const u=await v(d);if(u)return(0,L.join)(u,s[h])}}}catch{}return null}e.realcase=v;async function m(E){try{return await C.Promises.realpath(E)}catch{const p=y(E);return await C.Promises.access(p,w.constants.R_OK),p}}e.realpath=m;function T(E){try{return w.realpathSync(E)}catch{const p=y(E);return w.accessSync(p,w.constants.R_OK),p}}e.realpathSync=T;function y(E){return(0,P.rtrim)((0,L.normalize)(E),L.sep)}}),define(ge[100],pe([1,0,28,7,23]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,C=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var v;(function(I){I[I.x64=0]="x64",I[I.x86=1]="x86",I[I.ARM=2]="ARM"})(v||(v={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class y{constructor(O,t,n){this.exePath=O,this.displayName=t,this.a=n}async exists(){return this.a===void 0&&(this.a=await o.SymlinkSupport.existsFile(this.exePath)),this.a}}function E({useAlternateBitness:I=!1}={}){return I?m===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:I=!1,findPreview:O=!1}={}){const t=E({useAlternateBitness:I});if(!t)return null;const n=L.join(t,"PowerShell");if(!await o.SymlinkSupport.existsDirectory(n))return null;let r=-1,i=null;for(const c of await o.Promises.readdir(n)){let g=-1;if(O){const k=c.indexOf("-");if(k<0)continue;const S=c.substring(0,k);if(!P.test(S)||c.substring(k+1)!=="preview")continue;g=parseInt(S,10)}else{if(!P.test(c))continue;g=parseInt(c,10)}if(g<=r)continue;const D=L.join(n,c,"pwsh.exe");await o.SymlinkSupport.existsFile(D)&&(i=D,r=g)}if(!i)return null;const a=t.includes("x86")?" (x86)":"",l=O?" Preview":"";return new y(i,`PowerShell${l}${a}`,!0)}async function p({findPreview:I}={}){if(!process.env.LOCALAPPDATA)return null;const O=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await o.SymlinkSupport.existsDirectory(O))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=I?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await o.Promises.readdir(O))if(t.test(r)){const i=L.join(O,r,"pwsh.exe");return new y(i,n)}return null}function b(){const I=L.join(w.homedir(),".dotnet","tools","pwsh.exe");return new y(I,".NET Core PowerShell Global Tool")}function s(){const I=L.join(process.env.windir,m===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(I,"Windows PowerShell",!0)}async function*h(){let I=await d();I&&(yield I),I=await d({useAlternateBitness:!0}),I&&(yield I),I=await p(),I&&(yield I),I=b(),I&&(yield I),I=await d({findPreview:!0}),I&&(yield I),I=await p({findPreview:!0}),I&&(yield I),I=await d({useAlternateBitness:!0,findPreview:!0}),I&&(yield I),I=s(),I&&(yield I)}async function*u(){for await(const I of h())await I.exists()&&(yield I)}e.enumeratePowerShellInstallations=u;async function f(){for await(const I of u())return I;return null}e.getFirstAvailablePowerShellInstallation=f}),define(ge[101],pe([1,0,7,3,29,58,8,23]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function v(y=o.env){return y.comspec||"cmd.exe"}e.getWindowsShell=v;function m(y){let E=[],d=!1;const p=function(b){if(d){E.push(b);return}(!y.send(b,h=>{if(h&&console.error(h),d=!1,E.length>0){const u=E.slice(0);E=[],u.forEach(f=>p(f))}})||L.isWindows)&&(d=!0)};return{send:p}}e.createQueuedSender=m;var T;(function(y){async function E(d,p,b){if(w.isAbsolute(d))return d;if(p===void 0&&(p=o.cwd()),w.dirname(d)!=="."||(b===void 0&&C.isString(o.env.PATH)&&(b=o.env.PATH.split(w.delimiter)),b===void 0||b.length===0))return w.join(p,d);async function h(u){if(await A.Promises.exists(u)){let f;try{f=await A.Promises.stat(u)}catch(I){I.message.startsWith("EACCES")&&(f=await A.Promises.lstat(u))}return f?!f.isDirectory():!1}return!1}for(const u of b){let f;if(w.isAbsolute(u)?f=w.join(u,d):f=w.join(p,u,d),await h(f))return f;let I=f+".com";if(await h(I)||(I=f+".exe",await h(I)))return I}return w.join(p,d)}y.findExecutable=E})(T||(e.win32=T={}))}),define(ge[102],pe([1,0,51,13]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function o(C){return new Promise((A,v)=>{let m;const T=new Map;function y(d,p,b,s,h){const u=T.get(p);if(d===C||u){const f={name:E(b),cmd:b,pid:d,ppid:p,load:s,mem:h};T.set(d,f),d===C&&(m=f),u&&(u.children||(u.children=[]),u.children.push(f),u.children.length>1&&(u.children=u.children.sort((I,O)=>I.pid-O.pid)))}}function E(d){const p=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,s=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,u=/conhost\.exe/i,f=/--type=([a-zA-Z-]+)/;if(s.exec(d))return"electron-crash-reporter";if(h.exec(d))return"winpty-process";if(u.exec(d))return"console-window-host (Windows internal process)";let I=f.exec(d);if(I&&I.length===2)return I[1]==="renderer"?"window":I[1]==="utility"?p.exec(d)?"utility-network-service":"utility-process":I[1]==="extensionHost"?"extension-host":I[1];const O=/[a-zA-Z-]+\.js/g;let t="";do I=O.exec(d),I&&(t+=I+" ");while(I);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${t})`:b.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,b)=>{oe(["@vscode/windows-process-tree"],p,b)}).then(p=>{p.getProcessList(C,b=>{if(!b){v(new Error(`Root process ${C} not found`));return}p.getProcessCpuUsage(b,s=>{const h=new Map;s.forEach(u=>{const f=d(u.commandLine||"");h.set(u.pid,{name:E(f),cmd:f,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),m=h.get(C),m?(h.forEach(u=>{const f=h.get(u.ppid);f&&(f.children||(f.children=[]),f.children.push(u))}),h.forEach(u=>{u.children&&(u.children=u.children.sort((f,I)=>f.pid-I.pid))}),A(m)):v(new Error(`Root process ${C} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let d=function(){let p=[m];const b=[];for(;p.length;){const h=p.shift();h&&(b.push(h.pid),h.children&&(p=p.concat(h.children)))}let s=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);s+=" "+b.join(" "),(0,w.exec)(s,{},(h,u,f)=>{if(h||f)v(h||new Error(f.toString()));else{const I=u.toString().split(`
`);for(let O=0;O<b.length;O++){const t=T.get(b[O]);t.load=parseFloat(I[O])}if(!m){v(new Error(`Root process ${C} not found`));return}A(m)}})};(0,w.exec)("which ps",{},(p,b,s)=>{if(p||s)if(process.platform!=="linux")v(p||new Error(s.toString()));else{const h=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,w.exec)(h,{},(u,f,I)=>{u||I?v(u||new Error(I.toString())):(P(f,y),d())})}else{const h=b.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${h} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,I,O)=>{f||O&&!O.includes("screen size is bogus")?v(f||new Error(O.toString())):(P(I,y),process.platform==="linux"?d():m?A(m):v(new Error(`Root process ${C} not found`)))})}})}})}e.listProcesses=o;function P(C,A){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=C.toString().split(`
`);for(const T of m){const y=v.exec(T.trim());y&&y.length===6&&A(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(ge[164],pe([1,0,28,3,100,101]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function C(y,E){return y===1?L.isWindows?T():P.getWindowsShell(E):v(y,E)}e.getSystemShell=C;let A=null;function v(y,E){if(L.isLinux&&y===2||L.isMacintosh&&y===3)return"/bin/bash";if(!A){let d;if(L.isWindows)d="/bin/bash";else{if(d=E.SHELL,!d)try{d=(0,w.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}A=d}return A}let m=null;async function T(){return m||(m=(await(0,o.getFirstAvailablePowerShellInstallation)()).exePath),m}}),define(ge[103],pe([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUNCHostAllowlist=e.addUNCHostToAllowlist=e.getUNCHostAllowlist=e.setUNCHostAllowlist=void 0;function L(){return process.uncHostAllowlist}function o(v){if(!w.isWindows)return;const m=L();if(m){m.clear();for(const T of v)m.add(T)}}e.setUNCHostAllowlist=o;function P(){const v=L();return v?Array.from(v):[]}e.getUNCHostAllowlist=P;function C(v){if(!w.isWindows)return;const m=L();m&&m.add(v)}e.addUNCHostToAllowlist=C;function A(v){const m=new Set;if(Array.isArray(v))for(const T of v)typeof T=="string"&&m.add(T);return Array.from(m)}e.toUNCHostAllowlist=A});var Le=this&&this.__decorate||function(oe,e,w,L){var o=arguments.length,P=o<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,w):L,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(oe,e,w,L);else for(var A=oe.length-1;A>=0;A--)(C=oe[A])&&(P=(o<3?C(P):o>3?C(e,w,P):C(e,w))||P);return o>3&&P&&Object.defineProperty(e,w,P),P};define(ge[42],pe([1,0,18,14,15,20,91,11,6,2,61,17,8]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(d||(d={}));function p(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(b||(b={}));function s(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(h||(h={}));function u(q){let G=0;for(let ne=0;;ne+=7){const se=q.read(1);if(G|=(se.buffer[0]&127)<<ne,!(se.buffer[0]&128))return G}}const f=r(0);function I(q,G){if(G===0){q.write(f);return}let ne=0;for(let de=G;de!==0;de=de>>>7)ne++;const se=o.VSBuffer.alloc(ne);for(let de=0;G!==0;de++)se.buffer[de]=G&127,G=G>>>7,G>0&&(se.buffer[de]|=128);q.write(se)}class O{constructor(G){this.b=G,this.a=0}read(G){const ne=this.b.slice(this.a,this.a+G);return this.a+=ne.byteLength,ne}}e.BufferReader=O;class t{constructor(){this.a=[]}get buffer(){return o.VSBuffer.concat(this.a)}write(G){this.a.push(G)}}e.BufferWriter=t;var n;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(n||(n={}));function r(q){const G=o.VSBuffer.alloc(1);return G.writeUInt8(q,0),G}const i={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},a=typeof Buffer<"u";function l(q,G){if(typeof G>"u")q.write(i.Undefined);else if(typeof G=="string"){const ne=o.VSBuffer.fromString(G);q.write(i.String),I(q,ne.byteLength),q.write(ne)}else if(a&&Buffer.isBuffer(G)){const ne=o.VSBuffer.wrap(G);q.write(i.Buffer),I(q,ne.byteLength),q.write(ne)}else if(G instanceof o.VSBuffer)q.write(i.VSBuffer),I(q,G.byteLength),q.write(G);else if(Array.isArray(G)){q.write(i.Array),I(q,G.length);for(const ne of G)l(q,ne)}else if(typeof G=="number"&&(G|0)===G)q.write(i.Uint),I(q,G);else{const ne=o.VSBuffer.fromString(JSON.stringify(G));q.write(i.Object),I(q,ne.byteLength),q.write(ne)}}e.serialize=l;function c(q){switch(q.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return q.read(u(q)).toString();case n.Buffer:return q.read(u(q)).buffer;case n.VSBuffer:return q.read(u(q));case n.Array:{const ne=u(q),se=[];for(let de=0;de<ne;de++)se.push(c(q));return se}case n.Object:return JSON.parse(q.read(u(q)).toString());case n.Int:return u(q)}}e.deserialize=c;class g{constructor(G,ne,se=null,de=1e3){this.h=G,this.j=ne,this.k=se,this.l=de,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(W=>this.q(W)),this.m({type:200})}registerChannel(G,ne){this.b.set(G,ne),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const ne=this.o([G.type]);this.k?.logOutgoing(ne,0,1,s(G.type));return}case 201:case 202:case 204:case 203:{const ne=this.o([G.type,G.id],G.data);this.k?.logOutgoing(ne,G.id,1,s(G.type),G.data);return}}}o(G,ne=void 0){const se=new t;return l(se,G),l(se,ne),this.p(se.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const ne=new O(G),se=c(ne),de=c(ne),W=se[0];switch(W){case 100:return this.k?.logIncoming(G.byteLength,se[1],1,`${p(W)}: ${se[2]}.${se[3]}`,de),this.s({type:W,id:se[1],channelName:se[2],name:se[3],arg:de});case 102:return this.k?.logIncoming(G.byteLength,se[1],1,`${p(W)}: ${se[2]}.${se[3]}`,de),this.t({type:W,id:se[1],channelName:se[2],name:se[3],arg:de});case 101:return this.k?.logIncoming(G.byteLength,se[1],1,`${p(W)}`),this.u({type:W,id:se[1]});case 103:return this.k?.logIncoming(G.byteLength,se[1],1,`${p(W)}`),this.u({type:W,id:se[1]})}}s(G){const ne=this.b.get(G.channelName);if(!ne){this.v(G);return}const se=new P.CancellationTokenSource;let de;try{de=ne.call(this.j,G.name,G.arg,se.token)}catch(N){de=Promise.reject(N)}const W=G.id;de.then(N=>{this.m({id:W,data:N,type:201}),this.d.delete(G.id)},N=>{N instanceof Error?this.m({id:W,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:W,data:N,type:203}),this.d.delete(G.id)});const x=(0,m.toDisposable)(()=>se.cancel());this.d.set(G.id,x)}t(G){const ne=this.b.get(G.channelName);if(!ne){this.v(G);return}const se=G.id,W=ne.listen(this.j,G.name,G.arg)(x=>this.m({id:se,data:x,type:204}));this.d.set(G.id,W)}u(G){const ne=this.d.get(G.id);ne&&(ne.dispose(),this.d.delete(G.id))}v(G){let ne=this.g.get(G.channelName);ne||(ne=[],this.g.set(G.channelName,ne));const se=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ne.push({request:G,timeoutTimer:se})}w(G){const ne=this.g.get(G);if(ne){for(const se of ne)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.s(se.request);break;case 102:this.t(se.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=g;var D;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class k{constructor(G,ne=null){this.l=G,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=ne}getChannel(G){const ne=this;return{call(se,de,W){return ne.a?Promise.reject(new A.CancellationError):ne.m(G,se,de,W)},listen(se,de){return ne.a?v.Event.None:ne.o(G,se,de)}}}m(G,ne,se,de=P.CancellationToken.None){const W=this.g++,N={id:W,type:100,channelName:G,name:ne,arg:se};if(de.isCancellationRequested)return Promise.reject(new A.CancellationError);let R;return new Promise((X,ie)=>{if(de.isCancellationRequested)return ie(new A.CancellationError);const j=()=>{const Z=Y=>{switch(Y.type){case 201:this.f.delete(W),X(Y.data);break;case 202:{this.f.delete(W);const _=new Error(Y.data.message);_.stack=Array.isArray(Y.data.stack)?Y.data.stack.join(`
`):Y.data.stack,_.name=Y.data.name,ie(_);break}case 203:this.f.delete(W),ie(Y.data);break}};this.f.set(W,Z),this.p(N)};let $=null;this.b===h.Idle?j():($=(0,L.createCancelablePromise)(Z=>this.u()),$.then(()=>{$=null,j()}));const J=()=>{$?($.cancel(),$=null):this.p({id:W,type:101}),ie(new A.CancellationError)},V=de.onCancellationRequested(J);R=(0,m.combinedDisposable)((0,m.toDisposable)(J),V),this.d.add(R)}).finally(()=>{this.d.delete(R)})}o(G,ne,se){const de=this.g++,x={id:de,type:102,channelName:G,name:ne,arg:se};let N=null;const R=new v.Emitter({onWillAddFirstListener:()=>{N=(0,L.createCancelablePromise)(X=>this.u()),N.then(()=>{N=null,this.d.add(R),this.p(x)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete(R),this.p({id:de,type:103}))}}),U=X=>R.fire(X.data);return this.f.set(de,U),R.event}p(G){switch(G.type){case 100:case 102:{const ne=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(ne,G.id,0,`${p(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const ne=this.q([G.type,G.id]);this.j?.logOutgoing(ne,G.id,0,p(G.type));return}}}q(G,ne=void 0){const se=new t;return l(se,G),l(se,ne),this.r(se.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const ne=new O(G),se=c(ne),de=c(ne),W=se[0];switch(W){case 200:return this.j?.logIncoming(G.byteLength,0,0,s(W)),this.t({type:se[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,se[1],0,s(W),de),this.t({type:se[0],id:se[1],data:de})}}t(G){if(G.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelClient=k,Le([C.memoize],k.prototype,"onDidInitializePromise",null);class S{get connections(){const G=[];return this.f.forEach(ne=>G.push(ne)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new v.Emitter,this.onDidAddConnection=this.g.event,this.h=new v.Emitter,this.onDidRemoveConnection=this.h.event,G(({protocol:ne,onDidClientDisconnect:se})=>{v.Event.once(ne.onMessage)(W=>{const x=new O(W),N=c(x),R=new g(ne,N),U=new k(ne);this.a.forEach((ie,j)=>R.registerChannel(j,ie));const X={channelServer:R,channelClient:U,ctx:N};this.f.add(X),this.g.fire(X),se(()=>{R.dispose(),U.dispose(),this.f.delete(X),this.h.fire(X)})})})}getChannel(G,ne){const se=this;return{call(de,W,x){let N;if((0,E.isFunction)(ne)){const U=(0,w.getRandomElement)(se.connections.filter(ne));N=U?Promise.resolve(U):v.Event.toPromise(v.Event.filter(se.onDidAddConnection,ne))}else N=ne.routeCall(se,de,W);const R=N.then(U=>U.channelClient.getChannel(G));return H(R).call(de,W,x)},listen(de,W){if((0,E.isFunction)(ne))return se.j(G,ne,de,W);const x=ne.routeEvent(se,de,W).then(N=>N.channelClient.getChannel(G));return H(x).listen(de,W)}}}j(G,ne,se,de){const W=this;let x=new m.DisposableStore;const N=new v.Emitter({onWillAddFirstListener:()=>{x=new m.DisposableStore;const R=new v.EventMultiplexer,U=new Map,X=j=>{const J=j.channelClient.getChannel(G).listen(se,de),V=R.add(J);U.set(j,V)},ie=j=>{const $=U.get(j);$&&($.dispose(),U.delete(j))};W.connections.filter(ne).forEach(X),v.Event.filter(W.onDidAddConnection,ne)(X,void 0,x),W.onDidRemoveConnection(ie,void 0,x),R.event(N.fire,N,x),x.add(R)},onDidRemoveLastListener:()=>{x.dispose()}});return N.event}registerChannel(G,ne){this.a.set(G,ne),this.f.forEach(se=>{se.channelServer.registerChannel(G,ne)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=S;class F{constructor(G,ne,se=null){const de=new t;l(de,ne),G.send(de.buffer),this.a=new k(G,se),this.d=new g(G,ne,se)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,ne){this.d.registerChannel(G,ne)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=F;function H(q){return{call(G,ne,se){return q.then(de=>de.call(G,ne,se))},listen(G,ne){const se=new v.Relay;return q.then(de=>se.input=de.listen(G,ne)),se.event}}}e.getDelayedChannel=H;function te(q){let G=!1;return{call(ne,se,de){return G?q.call(ne,se,de):(0,L.timeout)(0).then(()=>G=!0).then(()=>q.call(ne,se,de))},listen(ne,se){if(G)return q.listen(ne,se);const de=new v.Relay;return(0,L.timeout)(0).then(()=>G=!0).then(()=>de.input=q.listen(ne,se)),de.event}}}e.getNextTickChannel=te;class ce{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const ne of G.connections)if(await Promise.resolve(this.a(ne.ctx)))return Promise.resolve(ne);return await v.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.StaticRouter=ce;var le;(function(q){function G(W,x){const N=W,R=x&&x.disableMarshalling,U=new Map;for(const X in N)se(X)&&U.set(X,v.Event.buffer(N[X],!0));return new class{listen(X,ie,j){const $=U.get(ie);if($)return $;if(de(ie)){const J=N[ie];if(typeof J=="function")return J.call(N,j)}throw new Error(`Event not found: ${ie}`)}call(X,ie,j){const $=N[ie];if(typeof $=="function"){if(!R&&Array.isArray(j))for(let J=0;J<j.length;J++)j[J]=(0,T.revive)(j[J]);return $.apply(N,j)}throw new Error(`Method not found: ${ie}`)}}}q.fromService=G;function ne(W,x){const N=x&&x.disableMarshalling;return new Proxy({},{get(R,U){if(typeof U=="string")return x?.properties?.has(U)?x.properties.get(U):de(U)?function(X){return W.listen(U,X)}:se(U)?W.listen(U):async function(...X){let ie;x&&!(0,E.isUndefinedOrNull)(x.context)?ie=[x.context,...X]:ie=X;const j=await W.call(U,ie);return N?j:(0,T.revive)(j)};throw new Error(`Property not found: ${String(U)}`)}})}q.toService=ne;function se(W){return W[0]==="o"&&W[1]==="n"&&y.isUpperAsciiLetter(W.charCodeAt(2))}function de(W){return/^onDynamic/.test(W)&&y.isUpperAsciiLetter(W.charCodeAt(9))}})(le||(e.ProxyChannel=le={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ve(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const G=q.toString();if(G!=="[object Object]")return G}return q}function K(q){return Array.isArray(q)?q.map(ve):ve(q)}function ee(q,G,ne,se,de,W,x){x=K(x);const N=ue[de],R=N[se%N.length];let U=[`%c[${q}]%c[${String(G).padStart(7," ")}]%c[len: ${String(ne).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(W)?(U=U.concat(x),U.push(")")):U.push(x),console.log.apply(console,U)}class z{constructor(G,ne){this.d=G,this.f=ne,this.a=0,this.b=0}logOutgoing(G,ne,se,de,W){this.b+=G,ee(this.d,this.b,G,ne,se,de,W)}logIncoming(G,ne,se,de,W){this.a+=G,ee(this.f,this.a,G,ne,se,de,W)}}e.IPCLogger=z}),define(ge[104],pe([1,0,14,15,6,2,42]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(k){k.Created="created",k.Read="read",k.Write="write",k.Open="open",k.Error="error",k.Close="close",k.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",k.NodeEndReceived="nodeEndReceived",k.NodeEndSent="nodeEndSent",k.NodeDrainBegin="nodeDrainBegin",k.NodeDrainEnd="nodeDrainEnd",k.zlibInflateError="zlibInflateError",k.zlibInflateData="zlibInflateData",k.zlibInflateInitialWrite="zlibInflateInitialWrite",k.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",k.zlibInflateWrite="zlibInflateWrite",k.zlibInflateFlushFired="zlibInflateFlushFired",k.zlibDeflateError="zlibDeflateError",k.zlibDeflateData="zlibDeflateData",k.zlibDeflateWrite="zlibDeflateWrite",k.zlibDeflateFlushFired="zlibDeflateFlushFired",k.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",k.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",k.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",k.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",k.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",k.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",k.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",k.ProtocolHeaderRead="protocolHeaderRead",k.ProtocolMessageRead="protocolMessageRead",k.ProtocolHeaderWrite="protocolHeaderWrite",k.ProtocolMessageWrite="protocolMessageWrite",k.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var v;(function(k){k.enableDiagnostics=!1,k.records=[];const S=new WeakMap;let F=0;function H(ce,le){if(!S.has(ce)){const ue=String(++F);S.set(ce,ue)}return S.get(ce)}function te(ce,le,ue,ve){if(!k.enableDiagnostics)return;const K=H(ce,le);if(ve instanceof L.VSBuffer||ve instanceof Uint8Array||ve instanceof ArrayBuffer||ArrayBuffer.isView(ve)){const ee=L.VSBuffer.alloc(ve.byteLength);ee.set(ve),k.records.push({timestamp:Date.now(),id:K,label:le,type:ue,buff:ee})}else k.records.push({timestamp:Date.now(),id:K,label:le,type:ue,data:ve})}k.traceSocketEvent=te})(v||(e.SocketDiagnostics=v={}));var m;(function(k){k[k.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",k[k.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m||(e.SocketCloseEventType=m={}));let T=null;function y(){return T||(T=L.VSBuffer.alloc(0)),T}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(S){this.a.push(S),this.b+=S.byteLength}read(S){return this.c(S,!0)}peek(S){return this.c(S,!1)}c(S,F){if(S===0)return y();if(S>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===S){const le=this.a[0];return F&&(this.a.shift(),this.b-=S),le}if(this.a[0].byteLength>S){const le=this.a[0].slice(0,S);return F&&(this.a[0]=this.a[0].slice(S),this.b-=S),le}const H=L.VSBuffer.alloc(S);let te=0,ce=0;for(;S>0;){const le=this.a[ce];if(le.byteLength>S){const ue=le.slice(0,S);H.set(ue,te),te+=S,F&&(this.a[ce]=le.slice(S),this.b-=S),S-=S}else H.set(le,te),te+=le.byteLength,F?(this.a.shift(),this.b-=le.byteLength):ce++,S-=le.byteLength}return H}}e.ChunkStream=E;var d;(function(k){k[k.None=0]="None",k[k.Regular=1]="Regular",k[k.Control=2]="Control",k[k.Ack=3]="Ack",k[k.Disconnect=5]="Disconnect",k[k.ReplayRequest=6]="ReplayRequest",k[k.Pause=7]="Pause",k[k.Resume=8]="Resume",k[k.KeepAlive=9]="KeepAlive",k[k.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",k[k.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(d||(d={}));function p(k){switch(k){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var b;(function(k){k[k.HeaderLength=13]="HeaderLength",k[k.AcknowledgeTime=2e3]="AcknowledgeTime",k[k.TimeoutTime=2e4]="TimeoutTime",k[k.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",k[k.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",k[k.KeepAliveSendTime=5e3]="KeepAliveSendTime",k[k.LatencySampleTime=6e4]="LatencySampleTime",k[k.LatencySampleCount=5]="LatencySampleCount",k[k.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",k[k.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(b||(e.ProtocolConstants=b={}));class s{constructor(S,F,H,te){this.type=S,this.id=F,this.ack=H,this.data=te,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends P.Disposable{constructor(S){super(),this.f=this.B(new o.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=S,this.b=!1,this.c=new E,this.B(this.a.onData(F=>this.acceptChunk(F))),this.lastReadTime=Date.now()}acceptChunk(S){if(!(!S||S.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(S);this.c.byteLength>=this.g.readLen;){const F=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=F.readUInt32BE(9),this.g.messageType=F.readUInt8(0),this.g.id=F.readUInt32BE(1),this.g.ack=F.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const H=this.g.messageType,te=this.g.id,ce=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",F),this.f.fire(new s(H,te,ce,F)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(S){this.k=null,this.a=!1,this.b=!1,this.c=S,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(S){if(this.a)return;S.writtenTime=Date.now(),this.lastWriteTime=Date.now();const F=L.VSBuffer.alloc(13);F.writeUInt8(S.type,0),F.writeUInt32BE(S.id,1),F.writeUInt32BE(S.ack,5),F.writeUInt32BE(S.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(S.type),id:S.id,ack:S.ack,messageSize:S.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",S.data),this.j(F,S.data)}g(S,F){const H=this.f===0;return this.d.push(S,F),this.f+=S.byteLength+F.byteLength,H}h(){const S=L.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,S}j(S,F){this.g(S,F)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const S=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:S.byteLength}),this.c.write(S)}}class f extends P.Disposable{constructor(S){super(),this.f=new o.Emitter,this.onMessage=this.f.event,this.g=new o.Emitter,this.onDidDispose=this.g.event,this.a=S,this.b=this.B(new u(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(F=>{F.type===1&&this.f.fire(F.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(S){this.b.write(new s(1,0,0,S))}}e.Protocol=f;class I extends C.IPCClient{static fromSocket(S,F){return new I(new f(S),F)}get onDidDispose(){return this.b.onDidDispose}constructor(S,F,H=null){super(S,F,H),this.b=S}dispose(){super.dispose();const S=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),S.end()}}e.Client=I;class O{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new o.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(S){this.b?this.d.length>0?this.d.push(S):this.a.fire(S):this.d.push(S)}flushBuffer(){this.d=[]}}e.BufferedEmitter=O;class t{constructor(S){this.data=S,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let S=0,F=this.a;for(;F;)F=F.next,S++;return S}peek(){return this.a?this.a.data:null}toArray(){const S=[];let F=0,H=this.a;for(;H;)S[F++]=H.data,H=H.next;return S}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(S){const F=new t(S);if(!this.a){this.a=F,this.b=F;return}this.b.next=F,this.b=F}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const S=Date.now();for(let F=0;F<r.a;F++)this.c[F]=S-1e3*F;setInterval(()=>{for(let F=r.a;F>=1;F--)this.c[F]=this.c[F-1];this.c[0]=Date.now()},1e3)}d(){const S=Date.now(),F=(1+r.a)*1e3;let H=0;for(let te=0;te<r.a;te++)S-this.c[te]<=F&&H++;return 1-H/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var i;(function(k){k[k.Good=0]="Good",k[k.Poor=1]="Poor"})(i||(e.ConnectionHealth=i={}));function a(k){switch(k){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=a;class l{constructor(S){this.connectionHealth=S}}e.ConnectionHealthChangedEvent=l;class c{constructor(S,F){this.roundTripTime=S,this.recentHighRoundTripCount=F}}e.HighRoundTripTimeEvent=c;class g{get unacknowledgedCount(){return this.c-this.d}constructor(S){this.x=new O,this.onControlMessage=this.x.event,this.y=new O,this.onMessage=this.y.event,this.z=new O,this.onDidDispose=this.z.event,this.A=new O,this.onSocketClose=this.A.event,this.B=new O,this.onSocketTimeout=this.B.event,this.C=new O,this.onHighRoundTripTime=this.C.event,this.D=new O,this.onDidChangeConnectionHealth=this.D.event,this.u=S.loadEstimator??r.getInstance(),this.v=S.measureRoundTripTime??!1,this.w=S.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new P.DisposableStore,this.o=S.socket,this.p=this.t.add(new u(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new D),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.v&&this.r.start(),S.initialChunk&&this.q.acceptChunk(S.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const S=new s(5,0,0,y());this.p.write(S),this.p.flush()}sendPause(){const S=new s(7,0,0,y());this.p.write(S)}sendResume(){const S=new s(8,0,0,y());this.p.write(S)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(S,F){this.a=!0,this.t.dispose(),this.t=new P.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=S,this.p=this.t.add(new u(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(H=>this.E(H))),this.t.add(this.o.onClose(H=>this.A.fire(H))),this.r=this.t.add(new D),this.t.add(this.r.onSendLatencyRequest(H=>this.J(H))),this.t.add(this.r.onHighRoundTripTime(H=>this.C.fire(H))),this.t.add(this.r.onDidChangeConnectionHealth(H=>this.D.fire(H))),this.q.acceptChunk(F)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const S=new s(3,0,this.h,y());this.p.write(S);const F=this.b.toArray();for(let H=0,te=F.length;H<te;H++)this.p.write(F[H]);this.G()}acceptDisconnect(){this.z.fire()}E(S){if(S.ack>this.d){this.d=S.ack;do{const F=this.b.peek();if(F&&F.id<=S.ack)this.b.pop();else break}while(!0)}switch(S.type){case 0:break;case 1:{if(S.id>this.g)if(S.id!==this.g+1){const F=Date.now();F-this.m>1e4&&(this.m=F,this.p.write(new s(6,0,0,y())))}else this.g=S.id,this.j=Date.now(),this.F(),this.y.fire(S.data);break}case 2:{this.x.fire(S.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const F=this.b.toArray();for(let H=0,te=F.length;H<te;H++)this.p.write(F[H]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(S.data);break}case 11:{this.r.handleResponse(S.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(S){const F=++this.c;this.h=this.g;const H=new s(1,F,this.h,S);this.b.push(H),this.a||(this.p.write(H),this.G())}sendControl(S){const F=new s(2,0,0,S);this.p.write(F)}F(){if(this.g<=this.h||this.k)return;const S=Date.now()-this.j;if(S>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-S+5)}G(){if(this.c<=this.d||this.f||this.a)return;const S=this.b.peek(),F=Date.now()-S.writtenTime,H=Date.now()-this.q.lastReadTime,te=Date.now()-this.n;if(F>=2e4&&H>=2e4&&te>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:F,timeSinceLastReceivedSomeData:H});return}const ce=Math.max(2e4-F,2e4-H,2e4-te,500);this.f=setTimeout(()=>{this.f=null,this.G()},ce)}H(){if(this.g<=this.h)return;this.h=this.g;const S=new s(3,0,this.h,y());this.p.write(S)}I(){this.h=this.g;const S=new s(9,0,this.h,y());this.p.write(S)}J(S){this.h=this.g;const F=new s(10,0,this.h,S);this.p.write(F)}K(S){this.h=this.g;const F=new s(11,0,this.h,S);this.p.write(F)}}e.PersistentProtocol=g;class D extends P.Disposable{constructor(){super(),this.a=this.B(new o.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new o.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new o.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new w.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},S=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const S=++this.h,F=L.VSBuffer.alloc(4);F.writeUInt32BE(S,0),this.a.fire(F)},6e4)}handleResponse(S){if(S.byteLength!==4)return;const F=S.readUInt32BE(0);if(this.g<=0||F!==this.h)return;const H=Date.now()-this.g,te=this.k++;this.j[te%this.j.length]=H;const ce=this.l,le=this.j.filter(ue=>ue>=1e3).length;this.l=le>=3?1:0,H>1e3&&this.b.fire(new c(H,le)),ce!==this.l&&this.c.fire(this.l)}}}),define(ge[105],pe([1,0,51,14,15,20,161,11,6,2,21,101,58,42]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends d.ChannelServer{constructor(h){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",u=>o.VSBuffer.wrap(Buffer.from(u,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=p;class b{constructor(h,u){this.i=h,this.j=u,this.c=new Set,this.g=new Map,this.h=new v.Emitter,this.onDidProcessExit=this.h.event;const f=u&&u.timeout?u.timeout:6e4;this.b=new L.Delayer(f),this.d=null,this.f=null}getChannel(h){const u=this;return{call(f,I,O){return u.k(h,f,I,O)},listen(f,I){return u.l(h,f,I)}}}k(h,u,f,I=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(I.isCancellationRequested)return Promise.reject(A.canceled());this.b.cancel();const O=this.n(h),t=(0,L.createCancelablePromise)(i=>O.call(u,f,i)),n=I.onCancellationRequested(()=>t.cancel()),r=(0,m.toDisposable)(()=>t.cancel());return this.c.add(r),t.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,u,f){if(!this.b)return v.Event.None;this.b.cancel();let I;const O=new v.Emitter({onWillAddFirstListener:()=>{I=this.n(h).listen(u,f)(O.fire,O),this.c.add(I)},onDidRemoveLastListener:()=>{this.c.delete(I),I.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return O.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,E.removeDangerousEnvVariables)(u.env),this.d=(0,w.fork)(this.i,h,u);const f=new v.Emitter;v.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,C.isRemoteConsoleLog)(a)){(0,C.log)(a,`IPC Library: ${this.j.serverName}`);return}f.fire(o.VSBuffer.wrap(Buffer.from(a,"base64")))});const O=this.j.useQueue?(0,y.createQueuedSender)(this.d):this.d,t=a=>this.d&&this.d.connected&&O.send(a.buffer.toString("base64")),n=f.event,r={send:t,onMessage:n};this.f=new d.ChannelClient(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,l)=>{process.removeListener("exit",i),this.c.forEach(c=>(0,m.dispose)(c)),this.c.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:l})})}return this.f}n(h){let u=this.g.get(h);return u||(u=this.m.getChannel(h),this.g.set(h,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=b}),define(ge[165],pe([1,0,14,6,2,8]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var C;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function A(y){const E=y;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=A;var v;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(v||(e.StorageState=v={}));class m extends o.Disposable{constructor(E,d=Object.create(null)){super(),this.m=E,this.n=d,this.b=this.B(new L.Emitter),this.onDidChangeStorage=this.b.event,this.c=v.None,this.f=new Map,this.g=new w.ThrottledDelayer(m.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(E=>this.r(E)))}r(E){E.changed?.forEach((d,p)=>this.s(p,d)),E.deleted?.forEach(d=>this.s(d,void 0))}s(E,d){if(this.c===v.Closed)return;let p=!1;(0,P.isUndefinedOrNull)(d)?p=this.f.delete(E):this.f.get(E)!==d&&(this.f.set(E,d),p=!0),p&&this.b.fire(E)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===v.None&&(this.c=v.Initialized,this.n.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(E,d){const p=this.f.get(E);return(0,P.isUndefinedOrNull)(p)?d:p}getBoolean(E,d){const p=this.get(E);return(0,P.isUndefinedOrNull)(p)?d:p==="true"}getNumber(E,d){const p=this.get(E);return(0,P.isUndefinedOrNull)(p)?d:parseInt(p,10)}async set(E,d){if(this.c===v.Closed)return;if((0,P.isUndefinedOrNull)(d))return this.delete(E);const p=String(d);if(this.f.get(E)!==p)return this.f.set(E,p),this.j.set(E,p),this.h.delete(E),this.b.fire(E),this.w()}async delete(E){if(!(this.c===v.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire(E),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=v.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(E).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(E){if(this.u)return this.w(E)}async w(E){return this.g.trigger(()=>this.v(),E)}async whenFlushed(){if(this.u)return new Promise(E=>this.l.push(E))}isInMemory(){return this.n.hint===C.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=m,m.a=100;class T{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((d,p)=>this.a.set(p,d)),E.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.InMemoryStorageDatabase=T}),define(ge[166],pe([1,0,6,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class o{constructor(){this.a=new Map,this.b=new Map,this.c=new w.Emitter,this.onDidChange=this.c.event,this.d=null}handleChange(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,v){return this.a.set(A,v),this.handleChange([A]),(0,L.toDisposable)(()=>{this.a.get(A)===v&&(this.a.delete(A),this.handleChange([A]))})}get(A){return this.a.get(A)||null}registerFactory(A,v){this.b.get(A)?.dispose();const m=new P(this,A,v);return this.b.set(A,m),(0,L.toDisposable)(()=>{const T=this.b.get(A);!T||T!==m||(this.b.delete(A),T.dispose())})}async getOrCreate(A){const v=this.get(A);if(v)return v;const m=this.b.get(A);return!m||m.isResolved?null:(await m.resolve(),this.get(A))}isResolved(A){if(this.get(A))return!0;const m=this.b.get(A);return!!(!m||m.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=o;class P extends L.Disposable{get isResolved(){return this.c}constructor(A,v,m){super(),this.f=A,this.g=v,this.h=m,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await this.h.tokenizationSupport;this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(ge[167],pe([1,0,48,4,49,166]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(F,H,te){this.offset=F,this.type=H,this.language=te,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class A{constructor(F,H){this.tokens=F,this.endState=H,this._tokenizationResultBrand=void 0}}e.TokenizationResult=A;class v{constructor(F,H){this.tokens=F,this.endState=H,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=v;var m;(function(S){S[S.Method=0]="Method",S[S.Function=1]="Function",S[S.Constructor=2]="Constructor",S[S.Field=3]="Field",S[S.Variable=4]="Variable",S[S.Class=5]="Class",S[S.Struct=6]="Struct",S[S.Interface=7]="Interface",S[S.Module=8]="Module",S[S.Property=9]="Property",S[S.Event=10]="Event",S[S.Operator=11]="Operator",S[S.Unit=12]="Unit",S[S.Value=13]="Value",S[S.Constant=14]="Constant",S[S.Enum=15]="Enum",S[S.EnumMember=16]="EnumMember",S[S.Keyword=17]="Keyword",S[S.Text=18]="Text",S[S.Color=19]="Color",S[S.File=20]="File",S[S.Reference=21]="Reference",S[S.Customcolor=22]="Customcolor",S[S.Folder=23]="Folder",S[S.TypeParameter=24]="TypeParameter",S[S.User=25]="User",S[S.Issue=26]="Issue",S[S.Snippet=27]="Snippet"})(m||(e.CompletionItemKind=m={}));var T;(function(S){const F=new Map;F.set(0,w.Codicon.symbolMethod),F.set(1,w.Codicon.symbolFunction),F.set(2,w.Codicon.symbolConstructor),F.set(3,w.Codicon.symbolField),F.set(4,w.Codicon.symbolVariable),F.set(5,w.Codicon.symbolClass),F.set(6,w.Codicon.symbolStruct),F.set(7,w.Codicon.symbolInterface),F.set(8,w.Codicon.symbolModule),F.set(9,w.Codicon.symbolProperty),F.set(10,w.Codicon.symbolEvent),F.set(11,w.Codicon.symbolOperator),F.set(12,w.Codicon.symbolUnit),F.set(13,w.Codicon.symbolValue),F.set(15,w.Codicon.symbolEnum),F.set(14,w.Codicon.symbolConstant),F.set(15,w.Codicon.symbolEnum),F.set(16,w.Codicon.symbolEnumMember),F.set(17,w.Codicon.symbolKeyword),F.set(27,w.Codicon.symbolSnippet),F.set(18,w.Codicon.symbolText),F.set(19,w.Codicon.symbolColor),F.set(20,w.Codicon.symbolFile),F.set(21,w.Codicon.symbolReference),F.set(22,w.Codicon.symbolCustomColor),F.set(23,w.Codicon.symbolFolder),F.set(24,w.Codicon.symbolTypeParameter),F.set(25,w.Codicon.account),F.set(26,w.Codicon.issues);function H(le){let ue=F.get(le);return ue||(console.info("No codicon found for CompletionItemKind "+le),ue=w.Codicon.symbolProperty),ue}S.toIcon=H;const te=new Map;te.set("method",0),te.set("function",1),te.set("constructor",2),te.set("field",3),te.set("variable",4),te.set("class",5),te.set("struct",6),te.set("interface",7),te.set("module",8),te.set("property",9),te.set("event",10),te.set("operator",11),te.set("unit",12),te.set("value",13),te.set("constant",14),te.set("enum",15),te.set("enum-member",16),te.set("enumMember",16),te.set("keyword",17),te.set("snippet",27),te.set("text",18),te.set("color",19),te.set("file",20),te.set("reference",21),te.set("customcolor",22),te.set("folder",23),te.set("type-parameter",24),te.set("typeParameter",24),te.set("account",25),te.set("issue",26);function ce(le,ue){let ve=te.get(le);return typeof ve>"u"&&!ue&&(ve=9),ve}S.fromString=ce})(T||(e.CompletionItemKinds=T={}));var y;(function(S){S[S.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var E;(function(S){S[S.None=0]="None",S[S.KeepWhitespace=1]="KeepWhitespace",S[S.InsertAsSnippet=4]="InsertAsSnippet"})(E||(e.CompletionItemInsertTextRule=E={}));var d;(function(S){S[S.Invoke=0]="Invoke",S[S.TriggerCharacter=1]="TriggerCharacter",S[S.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(e.CompletionTriggerKind=d={}));var p;(function(S){S[S.Automatic=0]="Automatic",S[S.Explicit=1]="Explicit"})(p||(e.InlineCompletionTriggerKind=p={}));class b{constructor(F,H,te,ce){this.range=F,this.text=H,this.completionKind=te,this.isSnippetText=ce}equals(F){return o.Range.lift(this.range).equalsRange(F.range)&&this.text===F.text&&this.completionKind===F.completionKind&&this.isSnippetText===F.isSnippetText}}e.SelectedSuggestionInfo=b;var s;(function(S){S[S.Invoke=1]="Invoke",S[S.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var h;(function(S){S[S.Invoke=1]="Invoke",S[S.TriggerCharacter=2]="TriggerCharacter",S[S.ContentChange=3]="ContentChange"})(h||(e.SignatureHelpTriggerKind=h={}));var u;(function(S){S[S.Text=0]="Text",S[S.Read=1]="Read",S[S.Write=2]="Write"})(u||(e.DocumentHighlightKind=u={}));function f(S){return S&&L.URI.isUri(S.uri)&&o.Range.isIRange(S.range)&&(o.Range.isIRange(S.originSelectionRange)||o.Range.isIRange(S.targetSelectionRange))}e.isLocationLink=f;var I;(function(S){S[S.File=0]="File",S[S.Module=1]="Module",S[S.Namespace=2]="Namespace",S[S.Package=3]="Package",S[S.Class=4]="Class",S[S.Method=5]="Method",S[S.Property=6]="Property",S[S.Field=7]="Field",S[S.Constructor=8]="Constructor",S[S.Enum=9]="Enum",S[S.Interface=10]="Interface",S[S.Function=11]="Function",S[S.Variable=12]="Variable",S[S.Constant=13]="Constant",S[S.String=14]="String",S[S.Number=15]="Number",S[S.Boolean=16]="Boolean",S[S.Array=17]="Array",S[S.Object=18]="Object",S[S.Key=19]="Key",S[S.Null=20]="Null",S[S.EnumMember=21]="EnumMember",S[S.Struct=22]="Struct",S[S.Event=23]="Event",S[S.Operator=24]="Operator",S[S.TypeParameter=25]="TypeParameter"})(I||(e.SymbolKind=I={}));var O;(function(S){S[S.Deprecated=1]="Deprecated"})(O||(e.SymbolTag=O={}));var t;(function(S){const F=new Map;F.set(0,w.Codicon.symbolFile),F.set(1,w.Codicon.symbolModule),F.set(2,w.Codicon.symbolNamespace),F.set(3,w.Codicon.symbolPackage),F.set(4,w.Codicon.symbolClass),F.set(5,w.Codicon.symbolMethod),F.set(6,w.Codicon.symbolProperty),F.set(7,w.Codicon.symbolField),F.set(8,w.Codicon.symbolConstructor),F.set(9,w.Codicon.symbolEnum),F.set(10,w.Codicon.symbolInterface),F.set(11,w.Codicon.symbolFunction),F.set(12,w.Codicon.symbolVariable),F.set(13,w.Codicon.symbolConstant),F.set(14,w.Codicon.symbolString),F.set(15,w.Codicon.symbolNumber),F.set(16,w.Codicon.symbolBoolean),F.set(17,w.Codicon.symbolArray),F.set(18,w.Codicon.symbolObject),F.set(19,w.Codicon.symbolKey),F.set(20,w.Codicon.symbolNull),F.set(21,w.Codicon.symbolEnumMember),F.set(22,w.Codicon.symbolStruct),F.set(23,w.Codicon.symbolEvent),F.set(24,w.Codicon.symbolOperator),F.set(25,w.Codicon.symbolTypeParameter);function H(te){let ce=F.get(te);return ce||(console.info("No codicon found for SymbolKind "+te),ce=w.Codicon.symbolProperty),ce}S.toIcon=H})(t||(e.SymbolKinds=t={}));class n{static fromValue(F){switch(F){case"comment":return n.Comment;case"imports":return n.Imports;case"region":return n.Region}return new n(F)}constructor(F){this.value=F}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var r;(function(S){function F(H){return!H||typeof H!="object"?!1:typeof H.id=="string"&&typeof H.title=="string"}S.is=F})(r||(e.Command=r={}));var i;(function(S){S[S.Collapsed=0]="Collapsed",S[S.Expanded=1]="Expanded"})(i||(e.CommentThreadCollapsibleState=i={}));var a;(function(S){S[S.Unresolved=0]="Unresolved",S[S.Resolved=1]="Resolved"})(a||(e.CommentThreadState=a={}));var l;(function(S){S[S.Editing=0]="Editing",S[S.Preview=1]="Preview"})(l||(e.CommentMode=l={}));var c;(function(S){S[S.Published=0]="Published",S[S.Draft=1]="Draft"})(c||(e.CommentState=c={}));var g;(function(S){S[S.Type=1]="Type",S[S.Parameter=2]="Parameter"})(g||(e.InlayHintKind=g={}));class D{constructor(F){this.b=F,this.a=null}dispose(){this.a&&this.a.then(F=>{F&&F.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.LazyTokenizationSupport=D,e.TokenizationRegistry=new P.TokenizationRegistry;var k;(function(S){S[S.None=0]="None",S[S.Option=1]="Option",S[S.Default=2]="Default",S[S.Preferred=3]="Preferred"})(k||(e.ExternalUriOpenerPriority=k={}))}),define(ge[168],pe([9,10]),function(oe,e){return oe.create("vs/base/node/zip",e)}),define(ge[169],pe([9,10]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[170],pe([9,10]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(ge[171],pe([9,10]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(ge[172],pe([9,10]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(ge[173],pe([9,10]),function(oe,e){return oe.create("vs/platform/environment/node/argvHelper",e)}),define(ge[174],pe([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ge[175],pe([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[176],pe([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ge[177],pe([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ge[178],pe([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ge[179],pe([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ge[180],pe([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ge[181],pe([9,10]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[182],pe([9,10]),function(oe,e){return oe.create("vs/platform/files/common/fileService",e)}),define(ge[183],pe([9,10]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(ge[184],pe([9,10]),function(oe,e){return oe.create("vs/platform/files/common/io",e)}),define(ge[185],pe([9,10]),function(oe,e){return oe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ge[186],pe([9,10]),function(oe,e){return oe.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ge[187],pe([9,10]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(ge[188],pe([9,10]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(ge[189],pe([9,10]),function(oe,e){return oe.create("vs/platform/shell/node/shellEnv",e)}),define(ge[190],pe([9,10]),function(oe,e){return oe.create("vs/platform/telemetry/common/telemetryService",e)}),define(ge[191],pe([9,10]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ge[192],pe([9,10]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ge[193],pe([9,10]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ge[194],pe([9,10]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(ge[195],pe([9,10]),function(oe,e){return oe.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(ge[196],pe([9,10]),function(oe,e){return oe.create("vs/server/node/serverEnvironmentService",e)}),define(ge[197],pe([9,10]),function(oe,e){return oe.create("vs/server/node/serverServices",e)}),define(ge[198],pe([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ge[199],pe([9,10]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(ge[200],pe([9,10]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[201],pe([9,10]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(ge[202],pe([1,0,11,171]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var o;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(o||(e.TokenType=o={}));function P(...m){switch(m.length){case 1:return(0,L.localize)(0,null,m[0]);case 2:return(0,L.localize)(1,null,m[0],m[1]);case 3:return(0,L.localize)(2,null,m[0],m[1],m[2]);default:return}}const C=(0,L.localize)(3,null),A=(0,L.localize)(4,null);class v{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,w.illegalState)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const y=this.d,E=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:E};this.g.push({offset:y,lexeme:E,additionalInfo:T}),this.f.push(d)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const y=this.c.substring(this.d,this.e),E=v.b.get(y);E?this.k(E):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,y=!1,E=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(A);return}const p=this.c.charCodeAt(T);if(y)y=!1;else if(p===47&&!E){T++;break}else p===91?E=!0:p===92?y=!0:p===93&&(E=!1);T++}for(;T<this.c.length&&v.a.has(this.c.charCodeAt(T));)T++;this.e=T;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=v,v.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),v.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ge[203],pe([1,0,6,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class o{constructor(){this.a=new w.Emitter,this.b=new w.Emitter,this.c=new w.Emitter,this.d=new w.Emitter}call(A,v,m){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(A,v,m){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=o,o.ChannelName="extensionhostdebugservice";class P extends L.Disposable{constructor(A){super(),this.b=A}reload(A){this.b.call("reload",[A])}get onReload(){return this.b.listen("reload")}close(A){this.b.call("close",[A])}get onClose(){return this.b.listen("close")}attachSession(A,v,m){this.b.call("attach",[A,v,m])}get onAttachSession(){return this.b.listen("attach")}terminateSession(A,v){this.b.call("terminate",[A,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(A,v){return this.b.call("openExtensionDevelopmentHostWindow",[A,v])}}e.ExtensionHostDebugChannelClient=P}),define(ge[204],pe([1,0,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class L{constructor(C){this.a=C}listen(C,A,v){throw new Error("Invalid listen")}call(C,A,v){switch(A){case"download":return this.a.download(w.URI.revive(v[0]),w.URI.revive(v[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=L;class o{constructor(C,A){this.a=C,this.b=A}async download(C,A){const v=this.b();v&&(C=v.transformOutgoingURI(C),A=v.transformOutgoingURI(A)),await this.a.call("download",[C,A])}}e.DownloadServiceChannelClient=o}),define(ge[205],pe([1,0,152,91,13,7,29,19,4]),function(oe,e,w,L,o,P,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,P.dirname)(o.FileAccess.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,P.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,A.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,A.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.join)(this.userDataPath,"logs",d)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.joinPath)(v.URI.file((0,P.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=C.env.VSCODE_PORTABLE;return d?v.URI.file((0,P.join)(d,"argv.json")):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,P.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,P.resolve)(d):(0,P.normalize)((0,P.join)(o.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?v.URI.file((0,P.resolve)(d)):v.URI.file((0,P.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,P.resolve)(d);const p=C.env.VSCODE_EXTENSIONS;if(p)return p;const b=C.env.VSCODE_PORTABLE;return b?(0,P.join)(b,"extensions"):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(p=>/^[^:/?#]+?:\/\//.test(p)?v.URI.parse(p):v.URI.file((0,P.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?v.URI.parse(d):v.URI.file((0,P.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const p of this.args.log||[]){const b=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);b&&b[1]&&b[2]&&d.push([b[1],b[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,A.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=C.env.VSCODE_PORTABLE;return d?v.URI.file((0,P.join)(d,"policy.json")):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,p,b){this.a=d,this.b=p,this.c=b,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=m,Le([L.memoize],m.prototype,"appRoot",null),Le([L.memoize],m.prototype,"userHome",null),Le([L.memoize],m.prototype,"userDataPath",null),Le([L.memoize],m.prototype,"appSettingsHome",null),Le([L.memoize],m.prototype,"tmpDir",null),Le([L.memoize],m.prototype,"cacheHome",null),Le([L.memoize],m.prototype,"stateResource",null),Le([L.memoize],m.prototype,"userRoamingDataHome",null),Le([L.memoize],m.prototype,"userDataSyncHome",null),Le([L.memoize],m.prototype,"sync",null),Le([L.memoize],m.prototype,"machineSettingsResource",null),Le([L.memoize],m.prototype,"workspaceStorageHome",null),Le([L.memoize],m.prototype,"localHistoryHome",null),Le([L.memoize],m.prototype,"keyboardLayoutResource",null),Le([L.memoize],m.prototype,"argvResource",null),Le([L.memoize],m.prototype,"isExtensionDevelopment",null),Le([L.memoize],m.prototype,"untitledWorkspacesHome",null),Le([L.memoize],m.prototype,"builtinExtensionsPath",null),Le([L.memoize],m.prototype,"extensionsPath",null),Le([L.memoize],m.prototype,"extensionDevelopmentLocationURI",null),Le([L.memoize],m.prototype,"extensionDevelopmentKind",null),Le([L.memoize],m.prototype,"extensionTestsLocationURI",null),Le([L.memoize],m.prototype,"debugExtensionHost",null),Le([L.memoize],m.prototype,"logLevel",null),Le([L.memoize],m.prototype,"extensionLogLevel",null),Le([L.memoize],m.prototype,"serviceMachineIdResource",null),Le([L.memoize],m.prototype,"disableTelemetry",null),Le([L.memoize],m.prototype,"disableWorkspaceTrust",null),Le([L.memoize],m.prototype,"policyFile",null);function T(E,d){return y(E["inspect-extensions"],E["inspect-brk-extensions"],5870,d,E.debugId,E.extensionEnvironment)}e.parseExtensionHostDebugPort=T;function y(E,d,p,b,s,h){const f=Number(d||E)||(b?null:p),I=f?!!d:!1;let O;if(h)try{O=JSON.parse(h)}catch{}return{port:f,break:I,debugId:s,env:O}}e.parseDebugParams=y}),define(ge[62],pe([1,0,293,3,172]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const P={o:(0,o.localize)(0,null),e:(0,o.localize)(1,null),t:(0,o.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,o.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,o.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,o.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,o.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,o.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,o.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,o.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,o.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,o.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,o.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,o.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,o.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,o.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,o.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,o.localize)(17,null)},category:{type:"string",cat:"e",description:(0,o.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,o.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,o.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,o.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,o.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,o.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,o.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,o.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,o.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,o.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,o.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,o.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,o.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,o.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,o.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,o.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,o.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function A(b,s,h=C){const u=b.find(l=>l.length>0&&l[0]!=="-"),f={},I=["_"],O=[],t={};let n;for(const l in s){const c=s[l];c.type==="subcommand"?l===u&&(n=c):(c.alias&&(f[l]=c.alias),c.type==="string"||c.type==="string[]"?(I.push(l),c.deprecates&&I.push(...c.deprecates)):c.type==="boolean"&&(O.push(l),c.deprecates&&O.push(...c.deprecates)),c.global&&(t[l]=c))}if(n&&u){const l=t;for(const k in n.options)l[k]=n.options[k];const c=b.filter(k=>k!==u),g=h.getSubcommandReporter?h.getSubcommandReporter(u):void 0,D=A(c,l,g);return{[u]:D,_:[]}}const r=w(b,{string:I,boolean:O,alias:f}),i={},a=r;i._=r._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in s){const c=s[l];if(c.type==="subcommand")continue;c.alias&&delete a[c.alias];let g=a[l];if(c.deprecates)for(const D of c.deprecates)a.hasOwnProperty(D)&&(g||(g=a[D],g&&h.onDeprecatedOption(D,c.deprecationMessage||(0,o.localize)(35,null,l))),delete a[D]);if(typeof g<"u"){if(c.type==="string[]"){if(Array.isArray(g)||(g=[g]),!c.allowEmptyValue){const D=g.filter(k=>k.length>0);D.length!==g.length&&(h.onEmptyValue(l),g=D.length>0?D:void 0)}}else c.type==="string"&&(Array.isArray(g)?(g=g.pop(),h.onMultipleValues(l,g)):!g&&!c.allowEmptyValue&&(h.onEmptyValue(l),g=void 0));i[l]=g,c.deprecationMessage&&h.onDeprecatedOption(l,c.deprecationMessage)}delete a[l]}for(const l in a)h.onUnknownOption(l);return i}e.parseArgs=A;function v(b,s){let h="";return s.args&&(Array.isArray(s.args)?h=` <${s.args.join("> <")}>`:h=` <${s.args}>`),s.alias?`-${s.alias} --${b}${h}`:`--${b}${h}`}function m(b,s){const h=[];for(const u in b){const f=b[u],I=v(u,f);h.push([I,f.description])}return T(h,s)}e.formatOptions=m;function T(b,s){const u=b.reduce((O,t)=>Math.max(O,t[0].length),12)+2+1;if(s-u<25)return b.reduce((O,t)=>O.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const f=s-u-1,I=[];for(const O of b){const t=O[0],n=E(O[1],f),r=y(u-t.length-2);I.push("  "+t+r+n[0]);for(let i=1;i<n.length;i++)I.push(y(u)+n[i])}return I}function y(b){return" ".repeat(b)}function E(b,s){const h=[];for(;b.length;){const u=b.length<s?b.length:b.lastIndexOf(" ",s),f=b.slice(0,u).trim();b=b.slice(u),h.push(f)}return h}function d(b,s,h,u,f){const I=process.stdout.isTTY&&process.stdout.columns||80,O=f?.noInputFiles!==!0?`[${(0,o.localize)(36,null)}...]`:"",t=[`${b} ${h}`];t.push(""),t.push(`${(0,o.localize)(37,null)}: ${s} [${(0,o.localize)(38,null)}]${O}`),t.push(""),f?.noPipe!==!0&&(L.isWindows?t.push((0,o.localize)(39,null,s)):t.push((0,o.localize)(40,null,s)),t.push(""));const n={},r=[];for(const i in u){const a=u[i];if(a.type==="subcommand")a.description&&r.push({command:i,description:a.description});else if(a.description&&a.cat){let l=n[a.cat];l||(n[a.cat]=l={}),l[i]=a}}for(const i in n){const a=i,l=n[a];l&&(t.push(P[a]),t.push(...m(l,I)),t.push(""))}return r.length&&(t.push((0,o.localize)(41,null)),t.push(...T(r.map(i=>[i.command,i.description]),I)),t.push("")),t.join(`
`)}e.buildHelpMessage=d;function p(b,s){return`${b||(0,o.localize)(42,null)}
${s||(0,o.localize)(43,null)}
${process.arch}`}e.buildVersionMessage=p}),define(ge[206],pe([1,0,294,173,62]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(y,E){const d=(f,I)=>{console.warn((0,L.localize)(0,null,f,I))},p=f=>{console.warn((0,L.localize)(1,null,f))},b=(f,I)=>{console.warn((0,L.localize)(2,null,f,I))},s=f=>({onUnknownOption:I=>{f!=="tunnel"&&console.warn((0,L.localize)(3,null,I,f))},onMultipleValues:d,onEmptyValue:p,onDeprecatedOption:b,getSubcommandReporter:f!=="tunnel"?s:void 0}),h={onUnknownOption:f=>{console.warn((0,L.localize)(4,null,f))},onMultipleValues:d,onEmptyValue:p,onDeprecatedOption:b,getSubcommandReporter:s},u=(0,o.parseArgs)(y,o.OPTIONS,E?h:void 0);return u.goto&&u._.forEach(f=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,L.localize)(5,null))),u}function C(y){const E=y.findIndex(d=>!/^-/.test(d));if(E>-1)return[...y.slice(0,E),...y.slice(E+1)]}function A(y){let[,...E]=y;process.env.VSCODE_DEV&&(E=C(E)||[]);const d=!T(process.env);return P(E,d)}e.parseMainProcessArgv=A;function v(y){let[,,...E]=y;return process.env.VSCODE_DEV&&(E=C(E)||[]),P(E,!0)}e.parseCLIProcessArgv=v;function m(y,...E){const d=y.indexOf("--");return d===-1?y.push(...E):y.splice(d,0,...E),y}e.addArg=m;function T(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=T}),function(){"use strict";function oe(e,w,L){function o(C,A){const v=P(C,A),m=[v];return e.isAbsolute(v)||m.unshift(L),e.resolve(...m)}function P(C,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,A);const T=C["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(y,"AppData","Roaming")}break;case"darwin":m=e.join(w.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,A)}return{getUserDataPath:o}}if(typeof define=="function")define(ge[207],pe([73,28,29]),function(e,w,L){return oe(e,w,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),w=require("os");module.exports=oe(e,w,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ge[106],pe([1,0,28,205,207]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class P extends L.AbstractNativeEnvironmentService{constructor(m,T){super(m,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,o.getUserDataPath)(m,T.nameShort)},T)}}e.NativeEnvironmentService=P;function C(v,m){return(0,L.parseDebugParams)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,m,v.extensionEnvironment)}e.parsePtyHostDebugPort=C;function A(v,m){return(0,L.parseDebugParams)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,m,v.extensionEnvironment)}e.parseSharedProcessDebugPort=A}),define(ge[208],pe([1,0,8,177]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function o(C,A,v){try{P(C,A,v)}catch(m){console.error(m?.message??m)}return C}e.localizeManifest=o;function P(C,A,v){const m=(T,y,E)=>{const d=T[y];if((0,w.isString)(d)){const p=d,b=p.length;if(b>1&&p[0]==="%"&&p[b-1]==="%"){const s=p.substr(1,b-2);let h=A[s];h===void 0&&v&&(h=v[s]);const u=typeof h=="string"?h:h?.message,f=v?.[s],I=typeof f=="string"?f:f?.message;if(!u){I||console.warn(`[${C.name}]: ${(0,L.localize)(0,null,s)}`);return}if(E&&(y==="title"||y==="category")&&I&&I!==u){const O={value:u,original:I};T[y]=O}else T[y]=u}}else if((0,w.isObject)(d))for(const p in d)d.hasOwnProperty(p)&&(p==="commands"?m(d,p,!0):m(d,p,E));else if(Array.isArray(d))for(let p=0;p<d.length;p++)m(d,p,E)};for(const T in C)C.hasOwnProperty(T)&&m(C,T)}}),define(ge[77],pe([1,0,19,59,181,52]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function v(h){return h=h.trim(),h==="*"||C.test(h)}e.isValidVersionStr=v;function m(h){if(!v(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=h.match(C);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=m;function T(h){if(!h)return null;const u=h.majorBase,f=h.majorMustEqual,I=h.minorBase;let O=h.minorMustEqual;const t=h.patchBase;let n=h.patchMustEqual;h.hasCaret&&(u===0||(O=!1),n=!1);let r=0;if(h.preRelease){const i=A.exec(h.preRelease);if(i){const[,a,l,c]=i;r=Date.UTC(Number(a),Number(l)-1,Number(c))}}return{majorBase:u,majorMustEqual:f,minorBase:I,minorMustEqual:O,patchBase:t,patchMustEqual:n,isMinimum:h.hasGreaterEquals,notBefore:r}}e.normalizeVersion=T;function y(h,u,f){let I;typeof h=="string"?I=T(m(h)):I=h;let O;u instanceof Date?O=u.getTime():typeof u=="string"&&(O=new Date(u).getTime());let t;if(typeof f=="string"?t=T(m(f)):t=f,!I||!t)return!1;const n=I.majorBase,r=I.minorBase,i=I.patchBase;let a=t.majorBase,l=t.minorBase,c=t.patchBase;const g=t.notBefore;let D=t.majorMustEqual,k=t.minorMustEqual,S=t.patchMustEqual;return t.isMinimum?n>a?!0:n<a?!1:r>l?!0:r<l||O&&O<g?!1:i>=c:(n===1&&a===0&&(!D||!k||!S)&&(a=1,l=0,c=0,D=!0,k=!1,S=!1),n<a?!1:n>a?!D:r<l?!1:r>l?!k:i<c?!1:i>c?!S:!(O&&O<g))}e.isValidVersion=y;function E(h,u,f,I,O){const t=[];if(typeof I.publisher<"u"&&typeof I.publisher!="string")return t.push([L.default.Error,o.localize(0,null)]),t;if(typeof I.name!="string")return t.push([L.default.Error,o.localize(1,null,"name")]),t;if(typeof I.version!="string")return t.push([L.default.Error,o.localize(2,null,"version")]),t;if(!I.engines)return t.push([L.default.Error,o.localize(3,null,"engines")]),t;if(typeof I.engines.vscode!="string")return t.push([L.default.Error,o.localize(4,null,"engines.vscode")]),t;if(typeof I.extensionDependencies<"u"&&!s(I.extensionDependencies))return t.push([L.default.Error,o.localize(5,null,"extensionDependencies")]),t;if(typeof I.activationEvents<"u"){if(!s(I.activationEvents))return t.push([L.default.Error,o.localize(6,null,"activationEvents")]),t;if(typeof I.main>"u"&&typeof I.browser>"u")return t.push([L.default.Error,o.localize(7,null,"activationEvents","main","browser")]),t}if(typeof I.extensionKind<"u"&&typeof I.main>"u"&&t.push([L.default.Warning,o.localize(8,null,"extensionKind")]),typeof I.main<"u"){if(typeof I.main!="string")return t.push([L.default.Error,o.localize(9,null,"main")]),t;{const i=(0,w.joinPath)(f,I.main);(0,w.isEqualOrParent)(i,f)||t.push([L.default.Warning,o.localize(10,null,i.path,f.path)])}}if(typeof I.browser<"u"){if(typeof I.browser!="string")return t.push([L.default.Error,o.localize(11,null,"browser")]),t;{const i=(0,w.joinPath)(f,I.browser);(0,w.isEqualOrParent)(i,f)||t.push([L.default.Warning,o.localize(12,null,i.path,f.path)])}}if(!P.valid(I.version))return t.push([L.default.Error,o.localize(13,null)]),t;const n=[];if(!d(h,u,I,O,n))for(const i of n)t.push([L.default.Error,i]);return t}e.validateExtensionManifest=E;function d(h,u,f,I,O){return I||typeof f.main>"u"&&typeof f.browser>"u"?!0:b(h,u,f.engines.vscode,O)}e.isValidExtensionVersion=d;function p(h,u,f){return h==="*"||b(u,f,h)}e.isEngineValid=p;function b(h,u,f,I=[]){const O=T(m(f));if(!O)return I.push(o.localize(14,null,f)),!1;if(O.majorBase===0){if(!O.majorMustEqual||!O.minorMustEqual)return I.push(o.localize(15,null,f)),!1}else if(!O.majorMustEqual)return I.push(o.localize(16,null,f)),!1;return y(h,u,O)?!0:(I.push(o.localize(17,null,h,f)),!1)}function s(h){if(!Array.isArray(h))return!1;for(let u=0,f=h.length;u<f;u++)if(typeof h[u]!="string")return!1;return!0}}),define(ge[209],pe([1,0,15,22]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function o(P,C,A){let v=A&&A.get("storage.serviceMachineId",-1)||null;if(v)return v;try{const T=(await C.readFile(P.serviceMachineIdResource)).value.toString();v=(0,L.isUUID)(T)?T:null}catch{v=null}if(!v){v=(0,L.generateUuid)();try{await C.writeFile(P.serviceMachineIdResource,w.VSBuffer.fromString(v))}catch{}}return A?.store("storage.serviceMachineId",v,-1,1),v}e.getServiceMachineId=o}),define(ge[63],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(o,P=[],C=!1){this.ctor=o,this.staticArguments=P,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=w}),define(ge[210],pe([1,0,63]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var o;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(o||(e.InstantiationType=o={}));function P(A,v,m){v instanceof w.SyncDescriptor||(v=new w.SyncDescriptor(v,[],!!m)),L.push([A,v])}e.registerSingleton=P;function C(){return L}e.getSingletonServiceDescriptors=C}),define(ge[211],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(P,C){this.key=P,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=w;class L{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const C of this.a.values())C.outgoing.size===0&&P.push(C);return P}insertEdge(P,C){const A=this.lookupOrInsertNode(P),v=this.lookupOrInsertNode(C);A.outgoing.set(v.key,v),v.incoming.set(A.key,A)}removeNode(P){const C=this.b(P);this.a.delete(C);for(const A of this.a.values())A.outgoing.delete(C),A.incoming.delete(C)}lookupOrInsertNode(P){const C=this.b(P);let A=this.a.get(C);return A||(A=new w(C,P),this.a.set(C,A)),A}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[C,A]of this.a)P.push(`${C}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,C]of this.a){const A=new Set([P]),v=this.c(C,A);if(v)return v}}c(P,C){for(const[A,v]of P.outgoing){if(C.has(A))return[...C,A].join(" -> ");C.add(A);const m=this.c(v,C);if(m)return m;C.delete(A)}}}e.Graph=L}),define(ge[5],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function A(v){return v[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=A})(w||(e._util=w={})),e.IInstantiationService=o("instantiationService");function L(C,A,v){A[w.DI_TARGET]===A?A[w.DI_DEPENDENCIES].push({id:C,index:v}):(A[w.DI_DEPENDENCIES]=[{id:C,index:v}],A[w.DI_TARGET]=A)}function o(C){if(w.serviceIds.has(C))return w.serviceIds.get(C);const A=function(v,m,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(A,v,T)};return A.toString=()=>C,w.serviceIds.set(C,A),A}e.createDecorator=o;function P(C){return C}e.refineServiceDecorator=P}),define(ge[24],pe([1,0,8,4,5]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,o.createDecorator)("configurationService");function P(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof L.URI)}e.isConfigurationOverrides=P;function C(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=C;var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function v(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=v;function m(s,h){const u=Object.create(null);for(const f in s)T(u,f,s[f],h);return u}e.toValuesTree=m;function T(s,h,u,f){const I=h.split("."),O=I.pop();let t=s;for(let n=0;n<I.length;n++){const r=I[n];let i=t[r];switch(typeof i){case"undefined":i=t[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${h} as ${I.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[O]=u}catch{f(`Ignoring ${h} as ${I.join(".")} is ${JSON.stringify(t)}`)}else f(`Ignoring ${h} as ${I.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=T;function y(s,h){const u=h.split(".");E(s,u)}e.removeFromValueTree=y;function E(s,h){const u=h.shift();if(h.length===0){delete s[u];return}if(Object.keys(s).indexOf(u)!==-1){const f=s[u];typeof f=="object"&&!Array.isArray(f)&&(E(f,h),Object.keys(f).length===0&&delete s[u])}}function d(s,h,u){function f(t,n){let r=t;for(const i of n){if(typeof r!="object"||r===null)return;r=r[i]}return r}const I=h.split("."),O=f(s,I);return typeof O>"u"?u:O}e.getConfigurationValue=d;function p(s,h,u){Object.keys(h).forEach(f=>{f!=="__proto__"&&(f in s?w.isObject(s[f])&&w.isObject(h[f])?p(s[f],h[f],u):u&&(s[f]=h[f]):s[f]=h[f])})}e.merge=p;function b(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(ge[64],pe([1,0,3,17,202,5,170,11]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",w.isMacintosh),v.set("isLinux",w.isLinux),v.set("isWindows",w.isWindows),v.set("isWeb",w.isWeb),v.set("isMacNative",w.isMacintosh&&!w.isWeb),v.set("isEdge",w.isEdge),v.set("isFirefox",w.isFirefox),v.set("isChrome",w.isChrome),v.set("isSafari",w.isSafari);function m(N,R){if(v.get(N)!==void 0)throw(0,A.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(N,R)}e.setConstant=m;const T=Object.prototype.hasOwnProperty;var y;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const E={regexParsingWithErrorRecovery:!0},d=(0,C.localize)(0,null),p=(0,C.localize)(1,null),b=(0,C.localize)(2,null),s=(0,C.localize)(3,null),h=(0,C.localize)(4,null),u=(0,C.localize)(5,null),f=(0,C.localize)(6,null),I=(0,C.localize)(7,null);class O{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=E){this.k=R,this.d=new o.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const X=this.D(),ie=X.type===17?u:void 0;throw this.h.push({message:h,offset:X.offset,lexeme:o.Scanner.getLexeme(X),additionalInfo:ie}),O.c}return U}catch(U){if(U!==O.c)throw U;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const U=this.o();R.push(U)}return R.length===1?R[0]:t.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const U=this.s();R.push(U)}return R.length===1?R[0]:t.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,s),U?.negate()}case 17:return this.z(),F.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const U=this.l();return this.A(1,s),U}case 17:{const U=R.lexeme;if(this.z(),this.y(9)){const ie=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ie.type!==10)throw this.B("REGEX",ie);const j=ie.lexeme,$=j.lastIndexOf("/"),J=$===j.length-1?void 0:this.w(j.substring($+1));let V;try{V=new RegExp(j.substring(1,$),J)}catch{throw this.B("REGEX",ie)}return ve.create(U,V)}switch(ie.type){case 10:case 19:{const j=[ie.lexeme];this.z();let $=this.D(),J=0;for(let ae=0;ae<ie.lexeme.length;ae++)ie.lexeme.charCodeAt(ae)===40?J++:ie.lexeme.charCodeAt(ae)===41&&J--;for(;!this.E()&&$.type!==15&&$.type!==16;){switch($.type){case 0:J++;break;case 1:J--;break;case 10:case 18:for(let ae=0;ae<$.lexeme.length;ae++)$.lexeme.charCodeAt(ae)===40?J++:ie.lexeme.charCodeAt(ae)===41&&J--}if(J<0)break;j.push(o.Scanner.getLexeme($)),this.z(),$=this.D()}const V=j.join(""),Z=V.lastIndexOf("/"),Y=Z===V.length-1?void 0:this.w(V.substring(Z+1));let _;try{_=new RegExp(V.substring(1,Z),Y)}catch{throw this.B("REGEX",ie)}return t.regex(U,_)}case 18:{const j=ie.lexeme;this.z();let $=null;if(!(0,L.isFalsyOrWhitespace)(j)){const J=j.indexOf("/"),V=j.lastIndexOf("/");if(J!==V&&J>=0){const Z=j.slice(J+1,V),Y=j[V+1]==="i"?"i":"";try{$=new RegExp(Z,Y)}catch{throw this.B("REGEX",ie)}}}if($===null)throw this.B("REGEX",ie);return ve.create(U,$)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const ie=this.u();return t.notIn(U,ie)}switch(this.D().type){case 3:{this.z();const ie=this.u();if(this.x().type===18)return t.equals(U,ie);switch(ie){case"true":return t.has(U);case"false":return t.not(U);default:return t.equals(U,ie)}}case 4:{this.z();const ie=this.u();if(this.x().type===18)return t.notEquals(U,ie);switch(ie){case"true":return t.not(U);case"false":return t.has(U);default:return t.notEquals(U,ie)}}case 5:return this.z(),le.create(U,this.u());case 6:return this.z(),ue.create(U,this.u());case 7:return this.z(),te.create(U,this.u());case 8:return this.z(),ce.create(U,this.u());case 13:return this.z(),t.in(U,this.u());default:return t.has(U)}}case 20:throw this.h.push({message:f,offset:R.offset,lexeme:"",additionalInfo:I}),O.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,U){if(this.C(R))return this.z();throw this.B(U,this.D())}B(R,U,X){const ie=(0,C.localize)(8,null,R,o.Scanner.getLexeme(U)),j=U.offset,$=o.Scanner.getLexeme(U);return this.h.push({message:ie,offset:j,lexeme:$,additionalInfo:X}),O.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=O,O.c=new Error;class t{static false(){return a.INSTANCE}static true(){return l.INSTANCE}static has(R){return c.create(R)}static equals(R,U){return g.create(R,U)}static notEquals(R,U){return S.create(R,U)}static regex(R,U){return ve.create(R,U)}static in(R,U){return D.create(R,U)}static notIn(R,U){return k.create(R,U)}static not(R){return F.create(R)}static and(...R){return z.create(R,null,!0)}static or(...R){return q.create(R,null,!0)}static greater(R,U){return te.create(R,U)}static greaterEquals(R,U){return ce.create(R,U)}static smaller(R,U){return le.create(R,U)}static smallerEquals(R,U){return ue.create(R,U)}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.ContextKeyExpr=t,t.c=new O({regexParsingWithErrorRecovery:!1});function n(N){const R=new O({regexParsingWithErrorRecovery:!1});return N.map(U=>(R.parse(U),R.lexingErrors.length>0?R.lexingErrors.map(X=>({errorMessage:X.additionalInfo?(0,C.localize)(9,null,X.additionalInfo):(0,C.localize)(10,null),offset:X.offset,length:X.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(X=>({errorMessage:X.additionalInfo?`${X.message}. ${X.additionalInfo}`:X.message,offset:X.offset,length:X.lexeme.length})):[]))}e.validateWhenClauses=n;function r(N,R){const U=N?N.substituteConstants():void 0,X=R?R.substituteConstants():void 0;return!U&&!X?!0:!U||!X?!1:U.equals(X)}e.expressionsAreEqualWithConstantSubstitution=r;function i(N,R){return N.cmp(R)}class a{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=a,a.INSTANCE=new a;class l{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class c{static create(R,U=null){const X=v.get(R);return typeof X=="boolean"?X?l.INSTANCE:a.INSTANCE:new c(R,U)}constructor(R,U){this.key=R,this.c=U,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:ne(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=v.get(this.key);return typeof R=="boolean"?R?l.INSTANCE:a.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=c;class g{static create(R,U,X=null){if(typeof U=="boolean")return U?c.create(R,X):F.create(R,X);const ie=v.get(R);return typeof ie=="boolean"?U===(ie?"true":"false")?l.INSTANCE:a.INSTANCE:new g(R,U,X)}constructor(R,U,X){this.c=R,this.d=U,this.f=X,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:se(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=v.get(this.c);if(typeof R=="boolean"){const U=R?"true":"false";return this.d===U?l.INSTANCE:a.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=g;class D{static create(R,U){return new D(R,U)}constructor(R,U){this.d=R,this.f=U,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:se(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const U=R.getValue(this.f),X=R.getValue(this.d);return Array.isArray(U)?U.includes(X):typeof X=="string"&&typeof U=="object"&&U!==null?T.call(U,X):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=D;class k{static create(R,U){return new k(R,U)}constructor(R,U){this.d=R,this.f=U,this.type=11,this.c=D.create(R,U)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=k;class S{static create(R,U,X=null){if(typeof U=="boolean")return U?F.create(R,X):c.create(R,X);const ie=v.get(R);return typeof ie=="boolean"?U===(ie?"true":"false")?a.INSTANCE:l.INSTANCE:new S(R,U,X)}constructor(R,U,X){this.c=R,this.d=U,this.f=X,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:se(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=v.get(this.c);if(typeof R=="boolean"){const U=R?"true":"false";return this.d===U?a.INSTANCE:l.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=S;class F{static create(R,U=null){const X=v.get(R);return typeof X=="boolean"?X?a.INSTANCE:l.INSTANCE:new F(R,U)}constructor(R,U){this.c=R,this.d=U,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:ne(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=v.get(this.c);return typeof R=="boolean"?R?a.INSTANCE:l.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.ContextKeyNotExpr=F;function H(N,R){if(typeof N=="string"){const U=parseFloat(N);isNaN(U)||(N=U)}return typeof N=="string"||typeof N=="number"?R(N):a.INSTANCE}class te{static create(R,U,X=null){return H(U,ie=>new te(R,ie,X))}constructor(R,U,X){this.c=R,this.d=U,this.f=X,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:se(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=te;class ce{static create(R,U,X=null){return H(U,ie=>new ce(R,ie,X))}constructor(R,U,X){this.c=R,this.d=U,this.f=X,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:se(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=ce;class le{static create(R,U,X=null){return H(U,ie=>new le(R,ie,X))}constructor(R,U,X){this.c=R,this.d=U,this.f=X,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:se(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=le;class ue{static create(R,U,X=null){return H(U,ie=>new ue(R,ie,X))}constructor(R,U,X){this.c=R,this.d=U,this.f=X,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:se(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=ue;class ve{static create(R,U){return new ve(R,U)}constructor(R,U){this.d=R,this.f=U,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const U=this.f?this.f.source:"",X=R.f?R.f.source:"";return U<X?-1:U>X?1:0}equals(R){if(R.type===this.type){const U=this.f?this.f.source:"",X=R.f?R.f.source:"";return this.d===R.d&&U===X}return!1}substituteConstants(){return this}evaluate(R){const U=R.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.ContextKeyRegexExpr=ve;class K{static create(R){return new K(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new K(this.c.map(R))}negate(){return this.c}}e.ContextKeyNotRegexExpr=K;function ee(N){let R=null;for(let U=0,X=N.length;U<X;U++){const ie=N[U].substituteConstants();if(N[U]!==ie&&R===null){R=[];for(let j=0;j<U;j++)R[j]=N[j]}R!==null&&(R[U]=ie)}return R===null?N:R}class z{static create(R,U,X){return z.d(R,U,X)}constructor(R,U){this.expr=R,this.c=U,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let U=0,X=this.expr.length;U<X;U++){const ie=i(this.expr[U],R.expr[U]);if(ie!==0)return ie}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let U=0,X=this.expr.length;U<X;U++)if(!this.expr[U].equals(R.expr[U]))return!1;return!0}return!1}substituteConstants(){const R=ee(this.expr);return R===this.expr?this:z.create(R,this.c,!1)}evaluate(R){for(let U=0,X=this.expr.length;U<X;U++)if(!this.expr[U].evaluate(R))return!1;return!0}static d(R,U,X){const ie=[];let j=!1;for(const $ of R)if($){if($.type===1){j=!0;continue}if($.type===0)return a.INSTANCE;if($.type===6){ie.push(...$.expr);continue}ie.push($)}if(ie.length===0&&j)return l.INSTANCE;if(ie.length!==0){if(ie.length===1)return ie[0];ie.sort(i);for(let $=1;$<ie.length;$++)ie[$-1].equals(ie[$])&&(ie.splice($,1),$--);if(ie.length===1)return ie[0];for(;ie.length>1;){const $=ie[ie.length-1];if($.type!==9)break;ie.pop();const J=ie.pop(),V=ie.length===0,Z=q.create($.expr.map(Y=>z.create([Y,J],null,X)),null,V);Z&&(ie.push(Z),ie.sort(i))}if(ie.length===1)return ie[0];if(X){for(let $=0;$<ie.length;$++)for(let J=$+1;J<ie.length;J++)if(ie[$].negate().equals(ie[J]))return a.INSTANCE;if(ie.length===1)return ie[0]}return new z(ie,U)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const U of this.expr)R.push(...U.keys());return R}map(R){return new z(this.expr.map(U=>U.map(R)),null)}negate(){if(!this.c){const R=[];for(const U of this.expr)R.push(U.negate());this.c=q.create(R,this,!0)}return this.c}}e.ContextKeyAndExpr=z;class q{static create(R,U,X){return q.d(R,U,X)}constructor(R,U){this.expr=R,this.c=U,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let U=0,X=this.expr.length;U<X;U++){const ie=i(this.expr[U],R.expr[U]);if(ie!==0)return ie}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let U=0,X=this.expr.length;U<X;U++)if(!this.expr[U].equals(R.expr[U]))return!1;return!0}return!1}substituteConstants(){const R=ee(this.expr);return R===this.expr?this:q.create(R,this.c,!1)}evaluate(R){for(let U=0,X=this.expr.length;U<X;U++)if(this.expr[U].evaluate(R))return!0;return!1}static d(R,U,X){let ie=[],j=!1;if(R){for(let $=0,J=R.length;$<J;$++){const V=R[$];if(V){if(V.type===0){j=!0;continue}if(V.type===1)return l.INSTANCE;if(V.type===9){ie=ie.concat(V.expr);continue}ie.push(V)}}if(ie.length===0&&j)return a.INSTANCE;ie.sort(i)}if(ie.length!==0){if(ie.length===1)return ie[0];for(let $=1;$<ie.length;$++)ie[$-1].equals(ie[$])&&(ie.splice($,1),$--);if(ie.length===1)return ie[0];if(X){for(let $=0;$<ie.length;$++)for(let J=$+1;J<ie.length;J++)if(ie[$].negate().equals(ie[J]))return l.INSTANCE;if(ie.length===1)return ie[0]}return new q(ie,U)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const U of this.expr)R.push(...U.keys());return R}map(R){return new q(this.expr.map(U=>U.map(R)),null)}negate(){if(!this.c){const R=[];for(const U of this.expr)R.push(U.negate());for(;R.length>1;){const U=R.shift(),X=R.shift(),ie=[];for(const j of x(U))for(const $ of x(X))ie.push(z.create([j,$],null,!1));R.unshift(q.create(ie,null,!1))}this.c=q.create(R,this,!0)}return this.c}}e.ContextKeyOrExpr=q;class G extends c{static all(){return G.d.values()}constructor(R,U,X){super(R,null),this.f=U,typeof X=="object"?G.d.push({...X,key:R}):X!==!0&&G.d.push({key:R,description:X,type:U!=null?typeof U:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return g.create(this.key,R)}notEqualsTo(R){return S.create(this.key,R)}}e.RawContextKey=G,G.d=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService");function ne(N,R){return N<R?-1:N>R?1:0}function se(N,R,U,X){return N<U?-1:N>U?1:R<X?-1:R>X?1:0}function de(N,R){if(N.type===0||R.type===1)return!0;if(N.type===9)return R.type===9?W(N.expr,R.expr):!1;if(R.type===9){for(const U of R.expr)if(de(N,U))return!0;return!1}if(N.type===6){if(R.type===6)return W(R.expr,N.expr);for(const U of N.expr)if(de(U,R))return!0;return!1}return N.equals(R)}e.implies=de;function W(N,R){let U=0,X=0;for(;U<N.length&&X<R.length;){const ie=N[U].cmp(R[X]);if(ie<0)return!1;ie===0&&U++,X++}return U===N.length}function x(N){return N.type===9?N.expr:[N]}}),define(ge[78],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,w.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");class L{constructor(){this.a={}}async getPassword(P,C){return this.a[P]?.[C]??null}async setPassword(P,C,A){this.a[P]=this.a[P]??{},this.a[P][C]=A}async deletePassword(P,C){return this.a[P]?.[C]?(delete this.a[P][C],Object.keys(this.a[P]).length===0&&delete this.a[P],!0):!1}async findPassword(P){return JSON.stringify(this.a[P])??null}async findCredentials(P){const C=[];for(const A of Object.keys(this.a[P]||{}))C.push({account:A,password:this.a[P][A]});return C}async clear(){this.a={}}}e.InMemoryCredentialsProvider=L}),define(ge[212],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function L(P){return!!P.hostName&&!!P.errorMessage}e.isRemoteDiagnosticError=L;class o{async getPerformanceInfo(C,A){return{}}async getSystemInfo(C,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,A){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.NullDiagnosticsService=o}),define(ge[79],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,w.createDecorator)("downloadService")}),define(ge[213],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService")}),define(ge[25],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[30],pe([1,0,175,5]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function o(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=o;function P(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function C(u,f){switch(u){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function A(u,f){return f==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function v(u,f,I){return A(f,I)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===I?!0:m(I).includes(u)}e.isTargetPlatformCompatible=v;function m(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function T(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=T;var y;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var E;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var p;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var b;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var s;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class h extends Error{constructor(f,I){super(f),this.code=I,this.name=I}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,w.localize)(1,null),original:"Preferences"}}),define(ge[214],pe([1,0,6,2,21,4,50,30]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function v(s,h){return s?P.URI.revive(h?h.transformIncoming(s):s):void 0}function m(s,h){return h?h.transformOutgoingURI(s):s}function T(s,h){h=h||C.DefaultURITransformer;const u=s.manifest;return{...(0,C.transformAndReviveIncomingURIs)({...s,manifest:void 0},h),manifest:u}}function y(s,h){return s?.profileLocation?(0,C.transformAndReviveIncomingURIs)(s,h??C.DefaultURITransformer):s}function E(s,h){return h?(0,o.cloneAndChange)(s,u=>u instanceof P.URI?h.transformOutgoingURI(u):void 0):s}class d{constructor(h,u){this.a=h,this.b=u,this.onInstallExtension=w.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=w.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=w.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=w.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=w.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,u){const f=this.b(h);switch(u){case"onInstallExtension":return w.Event.map(this.onInstallExtension,I=>({...I,profileLocation:I.profileLocation?m(I.profileLocation,f):I.profileLocation}));case"onDidInstallExtensions":return w.Event.map(this.onDidInstallExtensions,I=>I.map(O=>({...O,local:O.local?E(O.local,f):O.local,profileLocation:O.profileLocation?m(O.profileLocation,f):O.profileLocation})));case"onUninstallExtension":return w.Event.map(this.onUninstallExtension,I=>({...I,profileLocation:I.profileLocation?m(I.profileLocation,f):I.profileLocation}));case"onDidUninstallExtension":return w.Event.map(this.onDidUninstallExtension,I=>({...I,profileLocation:I.profileLocation?m(I.profileLocation,f):I.profileLocation}));case"onDidUpdateExtensionMetadata":return w.Event.map(this.onDidUpdateExtensionMetadata,I=>E(I,f))}throw new Error("Invalid listen")}async call(h,u,f){const I=this.b(h);switch(u){case"zip":{const O=T(f[0],I),t=await this.a.zip(O);return m(t,I)}case"unzip":return this.a.unzip(v(f[0],I));case"install":return this.a.install(v(f[0],I),y(f[1],I));case"installFromLocation":return this.a.installFromLocation(v(f[0],I),v(f[1],I));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(f[0],v(f[1],I),v(f[2],I));case"getManifest":return this.a.getManifest(v(f[0],I));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(f[0]);case"installFromGallery":return this.a.installFromGallery(f[0],y(f[1],I));case"uninstall":return this.a.uninstall(T(f[0],I),y(f[1],I));case"reinstallFromGallery":return this.a.reinstallFromGallery(T(f[0],I));case"getInstalled":return(await this.a.getInstalled(f[0],v(f[1],I))).map(t=>E(t,I));case"copyExtensions":return this.a.copyExtensions(v(f[0],I),v(f[1],I));case"updateMetadata":{const O=await this.a.updateMetadata(T(f[0],I),f[1],v(f[2],I));return E(O,I)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(f[0],f[1],f[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class p extends L.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.k=h,this.c=this.B(new w.Emitter),this.f=this.B(new w.Emitter),this.g=this.B(new w.Emitter),this.h=this.B(new w.Emitter),this.j=this.B(new w.Emitter),this.B(this.k.listen("onInstallExtension")(u=>this.l(this.c,{...u,source:this.m(u.source)?P.URI.revive(u.source):u.source,profileLocation:P.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(u=>this.l(this.f,u.map(f=>({...f,local:f.local?T(f.local,null):f.local,source:this.m(f.source)?P.URI.revive(f.source):f.source,profileLocation:P.URI.revive(f.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(u=>this.l(this.g,{...u,profileLocation:P.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(u=>this.l(this.h,{...u,profileLocation:P.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(T(u,null))))}l(h,u){h.fire(u)}m(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(h){const u=await this.getTargetPlatform();return h.allTargetPlatforms.some(f=>(0,A.isTargetPlatformCompatible)(f,h.allTargetPlatforms,u))}zip(h){return Promise.resolve(this.k.call("zip",[h]).then(u=>P.URI.revive(u)))}unzip(h){return Promise.resolve(this.k.call("unzip",[h]))}install(h,u){return Promise.resolve(this.k.call("install",[h,u])).then(f=>T(f,null))}installFromLocation(h,u){return Promise.resolve(this.k.call("installFromLocation",[h,u])).then(f=>T(f,null))}async installExtensionsFromProfile(h,u,f){return(await this.k.call("installExtensionsFromProfile",[h,u,f])).map(O=>T(O,null))}getManifest(h){return Promise.resolve(this.k.call("getManifest",[h]))}installFromGallery(h,u){return Promise.resolve(this.k.call("installFromGallery",[h,u])).then(f=>T(f,null))}uninstall(h,u){return Promise.resolve(this.k.call("uninstall",[h,u]))}reinstallFromGallery(h){return Promise.resolve(this.k.call("reinstallFromGallery",[h])).then(u=>T(u,null))}getInstalled(h=null,u){return Promise.resolve(this.k.call("getInstalled",[h,u])).then(f=>f.map(I=>T(I,null)))}updateMetadata(h,u,f){return Promise.resolve(this.k.call("updateMetadata",[h,u,f])).then(I=>T(I,null))}copyExtensions(h,u){return this.k.call("copyExtensions",[h,u])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(h,u,f){const I=await this.k.call("download",[h,u,f]);return P.URI.revive(I)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class b{constructor(h){this.a=h}listen(h,u){throw new Error("Invalid listen")}call(h,u,f){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(P.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(ge[80],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,w.createDecorator)("IExtensionSignatureVerificationService");class L{b(){return this.a||(this.a=new Promise((P,C)=>oe(["node-vsce-sign"],async A=>P(A),C))),this.a}async verify(P,C,A){let v;try{v=await this.b()}catch{return!1}return v.verify(P,C,A)}}e.ExtensionSignatureVerificationService=L}),define(ge[16],pe([1,0,60,7,17,8,4,183,5,3,13]),function(oe,e,w,L,o,P,C,A,v,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,v.createDecorator)("fileService");function y(z){return z.create===!0}e.isFileOpenForWriteOptions=y;var E;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var d;(function(z){z[z.Readonly=1]="Readonly"})(d||(e.FilePermission=d={}));var p;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function b(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=b;function s(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=s;function h(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=h;function u(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function f(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=f;function I(z){return b(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=I;var O;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsStorageQuota="EntryExceedsStorageQuota",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(O||(e.FileSystemProviderErrorCode=O={}));class t extends Error{static create(q,G){const ne=new t(q.toString(),G);return i(ne,G),ne}constructor(q,G){super(q),this.code=G}}e.FileSystemProviderError=t;function n(z,q){return t.create(z,q)}e.createFileSystemProviderError=n;function r(z){return z||n((0,A.localize)(0,null),O.Unknown)}e.ensureFileSystemProviderError=r;function i(z,q){return z.name=q?`${q} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=i;function a(z){if(!z)return O.Unknown;if(z instanceof t)return z.code;const q=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!q)return O.Unknown;switch(q[1]){case O.FileExists:return O.FileExists;case O.FileIsADirectory:return O.FileIsADirectory;case O.FileNotADirectory:return O.FileNotADirectory;case O.FileNotFound:return O.FileNotFound;case O.FileTooLarge:return O.FileTooLarge;case O.FileWriteLocked:return O.FileWriteLocked;case O.NoPermissions:return O.NoPermissions;case O.Unavailable:return O.Unavailable}return O.Unknown}e.toFileSystemProviderErrorCode=a;function l(z){if(z instanceof F)return z.fileOperationResult;switch(a(z)){case O.FileNotFound:return 1;case O.FileIsADirectory:return 0;case O.FileNotADirectory:return 9;case O.FileWriteLocked:return 5;case O.NoPermissions:return 6;case O.FileExists:return 4;case O.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=l;var c;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(c||(e.FileOperation=c={}));class g{constructor(q,G,ne){this.resource=q,this.operation=G,this.target=ne}isOperation(q){return this.operation===q}}e.FileOperationEvent=g;var D;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(D||(e.FileChangeType=D={}));class k{constructor(q,G){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ne=new Map;for(const se of q){const de=ne.get(se.type);switch(de?de.push([se.resource,se]):ne.set(se.type,[[se.resource,se]]),se.type){case 1:this.rawAdded.push(se.resource);break;case 0:this.rawUpdated.push(se.resource);break;case 2:this.rawDeleted.push(se.resource);break}}for(const[se,de]of ne)switch(se){case 1:this.a=w.TernarySearchTree.forUris(()=>G),this.a.fill(de);break;case 0:this.b=w.TernarySearchTree.forUris(()=>G),this.b.fill(de);break;case 2:this.c=w.TernarySearchTree.forUris(()=>G),this.c.fill(de);break}}contains(q,...G){return this.d(q,{includeChildren:!1},...G)}affects(q,...G){return this.d(q,{includeChildren:!0},...G)}d(q,G,...ne){if(!q)return!1;const se=ne.length>0;return!!((!se||ne.includes(1))&&(this.a?.get(q)||G.includeChildren&&this.a?.findSuperstr(q))||(!se||ne.includes(0))&&(this.b?.get(q)||G.includeChildren&&this.b?.findSuperstr(q))||(!se||ne.includes(2))&&(this.c?.findSubstr(q)||G.includeChildren&&this.c?.findSuperstr(q)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=k;function S(z,q,G){return!z||!q||z===q||q.length>z.length?!1:(q.charAt(q.length-1)!==L.sep&&(q+=L.sep),G?(0,o.startsWithIgnoreCase)(z,q):z.indexOf(q)===0)}e.isParent=S;class F extends Error{constructor(q,G,ne){super(q),this.fileOperationResult=G,this.options=ne}}e.FileOperationError=F;class H extends F{constructor(q,G,ne,se){super(q,G,se),this.fileOperationResult=G,this.size=ne}}e.TooLargeFileOperationError=H;class te extends F{constructor(q,G,ne){super(q,2,ne),this.stat=G}}e.NotModifiedSinceFileOperationError=te;var ce;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var le;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.ETAG_DISABLED="";function ue(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=ue;async function ve(z,q){if(!q.hasProvider(C.URI.from({scheme:z.scheme})))return new Promise(G=>{const ne=q.onDidChangeFileSystemProviderRegistrations(se=>{se.scheme===z.scheme&&se.added&&(ne.dispose(),G())})})}e.whenProviderRegistered=ve;class K{static formatSize(q){return(0,P.isNumber)(q)||(q=0),q<K.KB?(0,A.localize)(1,null,q.toFixed(0)):q<K.MB?(0,A.localize)(2,null,(q/K.KB).toFixed(2)):q<K.GB?(0,A.localize)(3,null,(q/K.MB).toFixed(2)):q<K.TB?(0,A.localize)(4,null,(q/K.GB).toFixed(2)):(0,A.localize)(5,null,(q/K.TB).toFixed(2))}}e.ByteSize=K,K.KB=1024,K.MB=K.KB*K.KB,K.GB=K.MB*K.KB,K.TB=K.GB*K.KB;function ee(z){const q=typeof z=="string"||z?.scheme===T.Schemas.vscodeRemote;return typeof z!="string"&&z?.scheme===T.Schemas.file?1024*K.MB:q?10*K.MB:m.isWeb?50*K.MB:1024*K.MB}e.getLargeFileConfirmationLimit=ee}),define(ge[215],pe([1,0,15,38,11,6,2,47,4,22,16]),function(oe,e,w,L,o,P,C,A,v,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends C.Disposable{constructor(d,p){super(),this.a=d,this.b=p,this.onDidChangeCapabilities=P.Event.None,this.f=this.B(new P.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new P.Emitter),this.onDidWatchError=this.g.event,this.h=(0,m.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,p){const{buffer:b}=await this.a.call("readFile",[d,p]);return b}readFileStream(d,p,b){const s=(0,A.newWriteableStream)(u=>w.VSBuffer.concat(u.map(f=>w.VSBuffer.wrap(f))).buffer),h=this.a.listen("readFileStream",[d,p])(u=>{if(u instanceof w.VSBuffer)s.write(u.buffer);else{if(u==="end")s.end();else{let f;if(u instanceof Error)f=u;else{const I=u;f=(0,T.createFileSystemProviderError)(I.message??(0,L.toErrorMessage)(I),I.code??T.FileSystemProviderErrorCode.Unknown)}s.error(f),s.end()}h.dispose()}});return b.onCancellationRequested(()=>{s.error((0,o.canceled)()),s.end(),h.dispose()}),s}writeFile(d,p,b){return this.a.call("writeFile",[d,w.VSBuffer.wrap(p),b])}open(d,p){return this.a.call("open",[d,p])}close(d){return this.a.call("close",[d])}async read(d,p,b,s,h){const[u,f]=await this.a.call("read",[d,p,h]);return b.set(u.buffer.slice(0,f),s),f}write(d,p,b,s,h){return this.a.call("write",[d,p,w.VSBuffer.wrap(b),s,h])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,p){return this.a.call("delete",[d,p])}rename(d,p,b){return this.a.call("rename",[d,p,b])}copy(d,p,b){return this.a.call("copy",[d,p,b])}cloneFile(d,p){return this.a.call("cloneFile",[d,p])}i(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const p=d;this.f.fire(p.map(b=>({resource:v.URI.revive(b.resource),type:b.type})))}else{const p=d;this.g.fire(p)}}))}watch(d,p){const b=(0,m.generateUuid)();return this.a.call("watch",[this.h,b,d,p]),(0,C.toDisposable)(()=>this.a.call("unwatch",[this.h,b]))}}e.DiskFileSystemProviderClient=y}),define(ge[107],pe([1,0,15,11,184,16]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(T,y,E,d,p,b){let s;try{await A(T,y,E,d,p,b)}catch(h){s=h}finally{s&&p.errorTransformer&&(s=p.errorTransformer(s)),typeof s<"u"&&E.error(s),E.end()}}e.readFileIntoStream=C;async function A(T,y,E,d,p,b){v(b);const s=await T.open(y,{create:!1});try{v(b);let h=0,u=0,f=p&&typeof p.length=="number"?p.length:void 0,I=w.VSBuffer.alloc(Math.min(p.bufferSize,typeof f=="number"?f:p.bufferSize)),O=p&&typeof p.position=="number"?p.position:0,t=0;do u=await T.read(s,O,I.buffer,t,I.byteLength-t),O+=u,t+=u,h+=u,typeof f=="number"&&(f-=u),t===I.byteLength&&(await E.write(d(I)),I=w.VSBuffer.alloc(Math.min(p.bufferSize,typeof f=="number"?f:p.bufferSize)),t=0);while(u>0&&(typeof f!="number"||f>0)&&v(b)&&m(h,p));if(t>0){let n=t;typeof f=="number"&&(n=Math.min(t,f)),E.write(d(I.slice(0,n)))}}catch(h){throw(0,P.ensureFileSystemProviderError)(h)}finally{await T.close(s)}}function v(T){if(T.isCancellationRequested)throw(0,L.canceled)();return!0}function m(T,y){if(typeof y?.limits?.size=="number"&&T>y.limits.size)throw(0,P.createFileSystemProviderError)((0,o.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ge[65],pe([1,0,76,2,7,3,4,16]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function v(h){return h.recursive===!0}e.isRecursiveWatchRequest=v;class m extends L.Disposable{constructor(u,f,I,O){super(),this.h=u,this.i=f,this.j=I,this.k=O,this.c=this.B(new L.MutableDisposable),this.f=void 0,this.g=0}m(){const u=new L.DisposableStore;this.c.value=u,this.b=this.l(u),this.b.setVerboseLogging(this.j),u.add(this.b.onDidChangeFile(f=>this.h(f))),u.add(this.b.onDidLogMessage(f=>this.i(f))),u.add(this.b.onDidError(f=>this.n(f)))}n(u){this.k.restartOnError?this.g<m.a&&this.f?(this.r(`restarting watcher after error: ${u}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${u}`):this.r(u)}p(u){this.g++,this.m(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.j=u,await this.b?.setVerboseLogging(u)}r(u){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${u}`})}s(u){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.a=5;class T extends m{constructor(u,f,I){super(u,f,I,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class y extends m{constructor(u,f,I){super(u,f,I,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function E(h){return h.map(u=>({type:u.type,resource:C.URI.file(u.path)}))}e.toFileChanges=E;function d(h){const u=new s;for(const f of h)u.processEvent(f);return u.coalesce()}e.coalesceEvents=d;function p(h,u){return typeof u=="string"&&!u.startsWith(w.GLOBSTAR)&&!(0,o.isAbsolute)(u)?{base:h,pattern:u}:u}e.normalizeWatcherPattern=p;function b(h,u){const f=[];for(const I of u)f.push((0,w.parse)(p(h,I)));return f}e.parseWatcherPatterns=b;class s{constructor(){this.a=new Set,this.b=new Map}c(u){return P.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const f=this.b.get(this.c(u));let I=!1;if(f){const O=f.type,t=u.type;f.path!==u.path&&(u.type===2||u.type===1)?I=!0:O===1&&t===2?(this.b.delete(this.c(u)),this.a.delete(f)):O===2&&t===1?f.type=0:O===1&&t===0||(f.type=t)}else I=!0;I&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],f=[];return Array.from(this.a).filter(I=>I.type!==2?(u.push(I),!1):!0).sort((I,O)=>I.path.length-O.path.length).filter(I=>f.some(O=>(0,A.isParent)(I.path,O,!P.isLinux))?!1:(f.push(I.path),!0)).concat(u)}}}),define(ge[216],pe([1,0,33,14,20,39,2,94,7,3,163,23,65]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends C.Disposable{constructor(s,h,u,f){super(),this.j=s,this.k=h,this.l=u,this.m=f,this.c=this.B(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},I=>this.k(I))),this.f=this.B(new L.RunOnceWorker(I=>this.u(I),d.b)),this.g=(0,E.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,E.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new o.CancellationTokenSource,this.ready=this.n()}async n(){try{const s=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await y.Promises.stat(s);this.B(await this.s(s,h.isDirectory()))}catch(s){s.code!=="ENOENT"?this.w(s):this.z(s)}}async r(s){let h=s.path;try{h=await y.Promises.realpath(s.path),s.path===h&&(h=await(0,T.realcase)(s.path)??s.path),s.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${s.path}, real: ${h})`)}catch{}return h}async s(s,h){if(m.isMacintosh&&(0,P.isEqualOrParent)(s,"/Volumes/",!0))return this.w(`Refusing to watch ${s} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const u=new o.CancellationTokenSource(this.i.token),f=new C.DisposableStore;try{const I=(0,v.basename)(s),O=(0,w.watch)(s);f.add((0,C.toDisposable)(()=>{O.removeAllListeners(),O.close()})),this.z(`Started watching: '${s}'`);const t=new Set;if(h)try{for(const r of await y.Promises.readdir(s))t.add(r)}catch(r){this.w(r)}const n=new Map;f.add((0,C.toDisposable)(()=>{for(const[,r]of n)r.dispose();n.clear()})),O.on("error",(r,i)=>{this.w(`Failed to watch ${s} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),O.on("change",(r,i)=>{if(u.token.isCancellationRequested)return;this.z(`[raw] ["${r}"] ${i}`);let a="";if(i&&(a=i.toString(),m.isMacintosh&&(a=(0,A.normalizeNFC)(a))),!(!a||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){n.get(a)?.dispose();const l=setTimeout(async()=>{if(n.delete(a),a===I&&!await y.Promises.exists(s)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.v((0,v.join)(s,a));if(u.token.isCancellationRequested)return;let g;c?t.has(a)?g=0:(g=1,t.add(a)):(t.delete(a),g=2),this.t({path:(0,v.join)(this.j.path,a),type:g})},d.a);n.set(a,(0,C.toDisposable)(()=>clearTimeout(l)))}else{let l;t.has(a)?l=0:(l=1,t.add(a)),this.t({path:(0,v.join)(this.j.path,a),type:l})}else if(r==="rename"||a!==I){const l=setTimeout(async()=>{const c=await y.Promises.exists(s);u.token.isCancellationRequested||(c?(this.t({path:this.j.path,type:0},!0),f.add(await this.s(s,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);f.clear(),f.add((0,C.toDisposable)(()=>clearTimeout(l)))}else this.t({path:this.j.path,type:0},!0)})}catch(I){await y.Promises.exists(s)&&!u.token.isCancellationRequested&&this.w(`Failed to watch ${s} for changes using fs.watch() (${I.toString()})`)}return(0,C.toDisposable)(()=>{u.dispose(!0),f.dispose()})}t(s,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.path}`),!h&&this.g.some(u=>u(s.path))?this.m&&this.z(` >> ignored (excluded) ${s.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(u=>u(s.path))?this.m&&this.z(` >> ignored (not included) ${s.path}`):this.f.work(s))}u(s){const h=(0,E.coalesceEvents)(s);if(h.length>0){if(this.m)for(const f of h)this.z(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(s){if(m.isLinux)return y.Promises.exists(s);try{const h=(0,v.basename)(s);return(await y.Promises.readdir((0,v.dirname)(s))).some(f=>f===h)}catch(h){return this.z(h),!1}}setVerboseLogging(s){this.m=s}w(s){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${s}`})}y(s){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${s}`})}z(s){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${s}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.a=100,d.b=75;async function p(b,s,h,u,f=512){const I=await y.Promises.open(b,"r"),O=Buffer.allocUnsafe(f),t=new o.CancellationTokenSource(u);let n,r=!1;const i={path:b,excludes:[],recursive:!1},a=new d(i,l=>{(async()=>{for(const{type:c}of l)if(c===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:g}=await y.Promises.read(I,O,0,f,null);if(!g||t.token.isCancellationRequested)break;s(O.slice(0,g))}}catch(g){n=new Error(g),t.dispose(!0)}finally{r=!1}}})()});return await a.ready,h(),new Promise((l,c)=>{t.token.onCancellationRequested(async()=>{a.dispose();try{await y.Promises.close(I)}catch(g){n=new Error(g)}n?c(n):l()})})}e.watchFileContents=p}),define(ge[217],pe([1,0,6,76,2,3,216]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class A extends o.Disposable{constructor(){super(...arguments),this.a=this.B(new w.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new w.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=w.Event.None,this.c=new Map,this.f=!1}async watch(m){const T=this.i(m),y=T.filter(d=>{const p=this.c.get(d.path);return p?!(0,L.patternsEquals)(p.request.excludes,d.excludes)||!(0,L.patternsEquals)(p.request.includes,d.includes):!0}),E=Array.from(this.c.values()).filter(({request:d})=>!T.find(p=>p.path===d.path&&(0,L.patternsEquals)(p.excludes,d.excludes)&&(0,L.patternsEquals)(p.includes,d.includes))).map(({request:d})=>d.path);y.length&&this.j(`Request to start watching: ${y.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),E.length&&this.j(`Request to stop watching: ${E.join(",")}`);for(const d of E)this.h(d);for(const d of y)this.g(d)}g(m){const T=new C.NodeJSFileWatcherLibrary(m,E=>this.a.fire(E),E=>this.b.fire(E),this.f),y={request:m,instance:T};this.c.set(m.path,y)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const T=this.c.get(m);T&&(this.c.delete(m),T.instance.dispose())}i(m){const T=new Map;for(const y of m){const E=P.isLinux?y.path:y.path.toLowerCase();T.set(E,y)}return Array.from(T.values())}async setVerboseLogging(m){this.f=m;for(const[,T]of this.c)T.instance.setVerboseLogging(m)}j(m){this.f&&this.b.fire({type:"trace",message:this.k(m)})}k(m,T){return T?`[File Watcher (node.js)] ${m} (path: ${T.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=A}),define(ge[218],pe([1,0,65,217]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class o extends w.AbstractNonRecursiveWatcherClient{constructor(C,A,v){super(C,A,v),this.m()}l(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=o}),define(ge[219],pe([1,0,13,42,105,65]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class C extends P.AbstractUniversalWatcherClient{constructor(v,m,T){super(v,m,T),this.m()}l(v){const m=v.add(new o.Client(w.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(m.onDidProcessExit(({code:T,signal:y})=>this.n(`terminated by itself with code ${T}, signal: ${y}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=C}),define(ge[81],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...o){this.a=new Map;for(const[P,C]of o)this.set(P,C)}set(o,P){const C=this.a.get(o);return this.a.set(o,P),C}has(o){return this.a.has(o)}get(o){return this.a.get(o)}}e.ServiceCollection=w}),define(ge[108],pe([1,0,14,11,2,63,211,5,81,93]),function(oe,e,w,L,o,P,C,A,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class y extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class E{constructor(s=new v.ServiceCollection,h=!1,u,f=T){this.f=s,this.g=h,this.h=u,this.i=f,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=f?u?._globalGraph??new C.Graph(I=>I):void 0}createChild(s){return new E(s,this.g,this,this.i)}invokeFunction(s,...h){const u=p.traceInvocation(this.i,s);let f=!1;try{return s({get:O=>{if(f)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(O,u);if(!t)throw new Error(`[invokeFunction] unknown service '${O}'`);return t}},...h)}finally{f=!0,u.stop()}}createInstance(s,...h){let u,f;return s instanceof P.SyncDescriptor?(u=p.traceCreation(this.i,s.ctor),f=this.j(s.ctor,s.staticArguments.concat(h),u)):(u=p.traceCreation(this.i,s),f=this.j(s,h,u)),u.stop(),f}j(s,h=[],u){const f=A._util.getServiceDependencies(s).sort((t,n)=>t.index-n.index),I=[];for(const t of f){const n=this.m(t.id,u);n||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),I.push(n)}const O=f.length>0?f[0].index:h.length;if(h.length!==O){console.trace(`[createInstance] First service dependency of ${s.name} at position ${O+1} conflicts with ${h.length} static arguments`);const t=O-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,O)}return Reflect.construct(s,h.concat(I))}k(s,h){if(this.f.get(s)instanceof P.SyncDescriptor)this.f.set(s,h);else if(this.h)this.h.k(s,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const h=this.f.get(s);return!h&&this.h?this.h.l(s):h}m(s,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const u=this.l(s);return u instanceof P.SyncDescriptor?this.q(s,u,h.branch(s,!0)):(h.branch(s,!1),u)}q(s,h,u){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,h,u)}finally{this.o.delete(s)}}r(s,h,u){const f=new C.Graph(t=>t.id.toString());let I=0;const O=[{id:s,desc:h,_trace:u}];for(;O.length;){const t=O.pop();if(f.lookupOrInsertNode(t),I++>1e3)throw new y(f);for(const n of A._util.getServiceDependencies(t.desc.ctor)){const r=this.l(n.id);if(r||this.u(`[createInstance] ${s} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),r instanceof P.SyncDescriptor){const i={id:n.id,desc:r,_trace:t._trace.branch(n.id,!0)};f.insertEdge(t,i),O.push(i)}}}for(;;){const t=f.roots();if(t.length===0){if(!f.isEmpty())throw new y(f);break}for(const{data:n}of t){if(this.l(n.id)instanceof P.SyncDescriptor){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}f.removeNode(n)}}return this.l(s)}s(s,h,u=[],f,I){if(this.f.get(s)instanceof P.SyncDescriptor)return this.t(s,h,u,f,I);if(this.h)return this.h.s(s,h,u,f,I);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(s,h,u=[],f,I){if(f){const O=new E(void 0,this.g,this,this.i);O.c=String(s);const t=new Map,n=new w.IdleValue(()=>{const r=O.j(h,u,I);for(const[i,a]of t){const l=r[i];if(typeof l=="function")for(const c of a)l.apply(r,c)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let c=t.get(i);return c||(c=new m.LinkedList,t.set(i,c)),(D,k,S)=>{const F=c.push([D,k,S]);return(0,o.toDisposable)(F)}}if(i in r)return r[i];const a=n.value;let l=a[i];return typeof l!="function"||(l=l.bind(a),r[i]=l),l},set(r,i,a){return n.value[i]=a,!0},getPrototypeOf(r){return h.prototype}})}else return this.j(h,u,I)}u(s,h){if(h&&console.warn(s),this.g)throw new Error(s)}}e.InstantiationService=E;var d;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(d||(d={}));class p{static traceInvocation(s,h){return s?new p(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(s,h){return s?new p(1,h.name):p.c}constructor(s,h){this.type=s,this.name=h,this.g=Date.now(),this.h=[]}branch(s,h){const u=new p(3,s.toString());return this.h.push([s,h,u]),u}stop(){const s=Date.now()-this.g;p.f+=s;let h=!1;function u(I,O){const t=[],n=new Array(I+1).join("	");for(const[r,i,a]of O.h)if(i&&a){h=!0,t.push(`${n}CREATES -> ${r}`);const l=u(I+1,a);l&&t.push(l)}else t.push(`${n}uses -> ${r}`);return t.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(s>2||h)&&p.all.add(f.join(`
`))}}e.Trace=p,p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0}),define(ge[220],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.ILabelService=void 0,e.ILabelService=(0,w.createDecorator)("labelService");var L;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(L||(e.Verbosity=L={}))});var Re=this&&this.__param||function(oe,e){return function(w,L){e(w,L,oe)}};define(ge[82],pe([1,0,20,2,3,186,30,5]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function v(T){return T.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=v,e.ILanguagePackService=(0,A.createDecorator)("languagePackService");let m=e.LanguagePackBaseService=class extends L.Disposable{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new w.CancellationTokenSource;setTimeout(()=>y.cancel(),1e3);let E;try{E=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const p=E.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(s=>s.startsWith("lp-"))).map(b=>{const s=b.properties.localizedLanguages?.[0],h=v(b);return{...this.f(h,s,b),extensionId:b.identifier.id,galleryExtension:b}});return p.push(this.f("en","English")),p}f(y,E,d){const p=E??y;let b;if(p!==y&&(b=`(${y})`),y.toLowerCase()===o.language.toLowerCase()&&(b??="",b+=(0,P.localize)(0,null)),d?.installCount){b??="";const s=d.installCount;let h;s>1e6?h=`${Math.floor(s/1e5)/10}M`:s>1e3?h=`${Math.floor(s/1e3)}K`:h=String(s),b+=` $(cloud-download) ${h}`}return{id:y,label:p,description:b}}};e.LanguagePackBaseService=m=Le([Re(0,C.IExtensionGalleryService)],m)}),define(ge[12],pe([1,0,38,6,75,2,27,3,19,8,4,64,5]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function d(){return new Date().toISOString()}function p(D){return(0,m.isNumber)(D)}e.isLogLevel=p;var b;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(b||(e.LogLevel=b={})),e.DEFAULT_LOG_LEVEL=b.Info;function s(D,k,S){switch(k){case b.Trace:D.trace(S);break;case b.Debug:D.debug(S);break;case b.Info:D.info(S);break;case b.Warning:D.warn(S);break;case b.Error:D.error(S);break;case b.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=s;function h(D,k=!1){let S="";for(let F=0;F<D.length;F++){let H=D[F];if(H instanceof Error&&(H=(0,w.toErrorMessage)(H,k)),typeof H=="object")try{H=JSON.stringify(H)}catch{}S+=(F>0?" ":"")+H}return S}class u extends P.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==b.Off&&this.b<=k}}e.AbstractLogger=u;class f extends u{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...S){this.f(b.Trace)&&this.g(b.Trace,h([k,...S],!0))}debug(k,...S){this.f(b.Debug)&&this.g(b.Debug,h([k,...S]))}info(k,...S){this.f(b.Info)&&this.g(b.Info,h([k,...S]))}warn(k,...S){this.f(b.Warning)&&this.g(b.Warning,h([k,...S]))}error(k,...S){if(this.f(b.Error))if(k instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=k.stack,this.g(b.Error,h(F))}else this.g(b.Error,h([k,...S]))}flush(){}}e.AbstractMessageLogger=f;class I extends u{constructor(k=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(k),this.g=!A.isWindows}trace(k,...S){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...S):console.log(`[main ${d()}]`,k,...S))}debug(k,...S){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...S):console.log(`[main ${d()}]`,k,...S))}info(k,...S){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...S):console.log(`[main ${d()}]`,k,...S))}warn(k,...S){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,k,...S):console.warn(`[main ${d()}]`,k,...S))}error(k,...S){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,k,...S):console.error(`[main ${d()}]`,k,...S))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class O extends u{constructor(k=e.DEFAULT_LOG_LEVEL,S=!0){super(),this.g=S,this.setLevel(k)}trace(k,...S){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...S):console.log(k,...S))}debug(k,...S){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...S):console.log(k,...S))}info(k,...S){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...S):console.log(k,...S))}warn(k,...S){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...S):console.log(k,...S))}error(k,...S){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...S):console.error(k,...S))}dispose(){}flush(){}}e.ConsoleLogger=O;class t extends u{constructor(k,S=e.DEFAULT_LOG_LEVEL){super(),this.g=k,this.setLevel(S)}trace(k,...S){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(k),...S])}debug(k,...S){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(k),...S])}info(k,...S){this.f(b.Info)&&this.g.log(b.Info,[this.h(k),...S])}warn(k,...S){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(k),...S])}error(k,...S){this.f(b.Error)&&this.g.log(b.Error,[this.h(k),...S])}h(k){return typeof k=="string"?k:(0,w.toErrorMessage)(k,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class n extends u{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const S of this.g)S.setLevel(k);super.setLevel(k)}trace(k,...S){for(const F of this.g)F.trace(k,...S)}debug(k,...S){for(const F of this.g)F.debug(k,...S)}info(k,...S){for(const F of this.g)F.info(k,...S)}warn(k,...S){for(const F of this.g)F.warn(k,...S)}error(k,...S){for(const F of this.g)F.error(k,...S)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.MultiplexLogger=n;class r extends P.Disposable{constructor(k,S,F){if(super(),this.h=k,this.j=S,this.b=new C.ResourceMap,this.c=this.B(new L.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeVisibility=this.g.event,F)for(const H of F)this.b.set(H.resource,{logger:void 0,info:H})}k(k){return(0,m.isString)(k)?[...this.b.values()].find(S=>S.info.id===k):this.b.get(k)}getLogger(k){return this.k(k)?.logger}createLogger(k,S){const F=this.l(k),H=(0,m.isString)(k)?k:S?.id??(0,o.hash)(F.toString()).toString(16);let te=this.b.get(F)?.logger;const ce=S?.logLevel==="always"?b.Trace:S?.logLevel;te||(te=this.m(F,ce??this.getLogLevel(F)??this.h,{...S,id:H}));const le={logger:te,info:{resource:F,id:H,logLevel:ce,name:S?.name,hidden:S?.hidden,extensionId:S?.extensionId,when:S?.when}};return this.registerLogger(le.info),this.b.set(F,le),te}l(k){return(0,m.isString)(k)?(0,v.joinPath)(this.j,`${k}.log`):k}setLogLevel(k,S){if(T.URI.isUri(k)){const F=k,H=S,te=this.b.get(F);te&&H!==te.info.logLevel&&(te.info.logLevel=H===this.h?void 0:H,te.logger?.setLevel(H),this.b.set(te.info.resource,te),this.f.fire([F,H]))}else{this.h=k;for(const[F,H]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&H.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,S){const F=this.k(k);F&&S!==!F.info.hidden&&(F.info.hidden=!S,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,S]))}getLogLevel(k){let S;return k&&(S=this.b.get(k)?.info.logLevel),S??this.h}registerLogger(k){const S=this.b.get(k.resource);S?S.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const S=this.b.get(k);S&&(S.logger&&S.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[S.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=r;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(k){}getLevel(){return b.Info}trace(k,...S){}debug(k,...S){}info(k,...S){}warn(k,...S){}error(k,...S){}critical(k,...S){}dispose(){}flush(){}}e.NullLogger=i;class a extends i{}e.NullLogService=a;function l(D){if(D.verbose)return b.Trace;if(typeof D.logLevel=="string"){const k=g(D.logLevel.toLowerCase());if(k!==void 0)return k}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function c(D){switch(D){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=c;function g(D){switch(D){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=g,e.CONTEXT_LOG_LEVEL=new y.RawContextKey("logLevel",c(b.Info))}),define(ge[221],pe([1,0,78,6,2,12,3,14]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let v=e.BaseCredentialsMainService=class Gt extends o.Disposable{constructor(T){super(),this.h=T,this.c=this.B(new L.Emitter),this.onDidChangePassword=this.c.event,this.g=new A.SequencerByKey}async getPassword(T,y){this.h.trace("Going to get password from keytar:",T,y);let E;try{E=await this.i()}catch{return null}return await this.g.queue(T+y,()=>this.k(E,T,y))}async k(T,y,E){this.h.trace("Doing get password from keytar:",y,E);const d=await(0,A.retry)(()=>T.getPassword(y,E),50,3);if(!d)return this.h.trace("Did not get a password from keytar for account:",E),d;let p,b;try{const s=JSON.parse(d);p=s.content,b=s.hasNextChunk}catch{}if(!p||!b)return this.h.trace("Got password from keytar for account:",E),d;try{let s=1;for(;b;){const h=await(0,A.retry)(()=>T.getPassword(y,`${E}-${s}`),50,3),u=JSON.parse(h);p+=u.content,b=u.hasNextChunk,s++}return this.h.trace(`Got ${s}-chunked password from keytar for account:`,E),p}catch(s){return this.h.error(s),d}}async setPassword(T,y,E){this.h.trace("Going to set password using keytar:",T,y);let d;try{d=await this.i()}catch(p){throw this.j?.(p),p}await this.g.queue(T+y,()=>this.l(d,T,y,E)),this.c.fire({service:T,account:y})}async l(T,y,E,d){if(this.h.trace("Doing set password from keytar:",y,E),!C.isWindows){await(0,A.retry)(()=>T.setPassword(y,E,d),50,3),this.h.trace("Set password from keytar for account:",E);return}if(await this.m(T,y,E),d.length<=Gt.b){await(0,A.retry)(()=>T.setPassword(y,E,d),50,3),this.h.trace("Set password from keytar for account:",E);return}let p=0,b=0,s=!0;for(;s;){const h=d.substring(p,p+Gt.b);p+=Gt.b,s=d.length-p>0;const u={content:h,hasNextChunk:s};await(0,A.retry)(()=>T.setPassword(y,b?`${E}-${b}`:E,JSON.stringify(u)),50,3),b++}this.h.trace(`Set${b?` ${b}-chunked`:""} password from keytar for account:`,E)}async deletePassword(T,y){this.h.trace("Going to delete password using keytar:",T,y);let E;try{E=await this.i()}catch(p){throw this.j?.(p),p}const d=await this.g.queue(T+y,()=>this.m(E,T,y));return d&&this.c.fire({service:T,account:y}),d}async m(T,y,E){this.h.trace("Doing delete password from keytar:",y,E);const d=await T.getPassword(y,E);if(!d)return this.h.trace("Did not get a password to delete from keytar for account:",E),!1;let p,b;try{const h=JSON.parse(d);p=h.content,b=h.hasNextChunk}catch{}let s=0;if(p&&b)try{for(s++;b;){const h=`${E}-${s}`,u=await T.getPassword(y,h);await T.deletePassword(y,h),b=JSON.parse(u).hasNextChunk,s++}}catch(h){this.h.error(h)}return await T.deletePassword(y,E)?(this.h.trace(`Deleted${s?` ${s}-chunked`:""} password from keytar for account:`,E),!0):(this.h.trace(`Keytar failed to delete${s?` ${s}-chunked`:""} password for account:`,E),!1)}async findPassword(T){let y;try{y=await this.i()}catch{return null}return await y.findPassword(T)}async findCredentials(T){let y;try{y=await this.i()}catch{return[]}return await y.findCredentials(T)}clear(){return this.f instanceof w.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};v.a=2500,v.b=v.a-100,e.BaseCredentialsMainService=v=Le([Re(0,P.ILogService)],v)}),define(ge[222],pe([1,0,12]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let L=e.EncryptionMainService=class{constructor(P,C){this.a=P,this.b=C}c(){return new Promise((P,C)=>oe(["vscode-encrypt"],P,C))}async encrypt(P){let C;try{C=await this.c()}catch{return P}try{return C.encrypt(this.a,P)}catch(A){return this.b.error(A),P}}async decrypt(P){let C;try{C=await this.c()}catch{return P}try{return C.decrypt(this.a,P)}catch(A){return this.b.error(A),P}}};e.EncryptionMainService=L=Le([Re(1,w.ILogService)],L)}),define(ge[223],pe([1,0,18,14,11,6,2,7,65,12]),function(oe,e,w,L,o,P,C,A,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends C.Disposable{constructor(E,d){super(),this.a=E,this.b=d,this.c=this.B(new P.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new P.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new L.ThrottledDelayer(0)),this.s=[],this.t=this.B(new L.ThrottledDelayer(0))}watch(E,d){return d.recursive||this.b?.watcher?.forceUniversal?this.l(E,d):this.u(E,d)}l(E,d){const p={path:this.C(E),excludes:d.excludes,includes:d.includes,recursive:d.recursive},b=(0,w.insert)(this.j,p);return this.m(),(0,C.toDisposable)(()=>{b(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(E=>(0,o.onUnexpectedError)(E))}n(){this.h||(this.h=this.B(this.p(d=>this.c.fire((0,v.toFileChanges)(d)),d=>this.z(d),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const E=this.b?.watcher?.recursive?.usePolling;if(E===!0)for(const d of this.j)(0,v.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const d of this.j)(0,v.isRecursiveWatchRequest)(d)&&E.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(E,d){const p={path:this.C(E),excludes:d.excludes,includes:d.includes,recursive:!1},b=(0,w.insert)(this.s,p);return this.v(),(0,C.toDisposable)(()=>{b(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(E=>(0,o.onUnexpectedError)(E))}w(){return this.r||(this.r=this.B(this.y(E=>this.c.fire((0,v.toFileChanges)(E)),E=>this.z(E),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.r.watch(this.s)}z(E){E.type==="error"&&this.g.fire(E.message),this.a[E.type](E.message)}C(E){return(0,A.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(ge[109],pe([1,0,18,14,15,20,6,75,46,2,60,13,41,19,47,182,16,107,12,11]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=e.FileService=class extends m.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new C.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new C.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new C.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new L.ResourceQueue)}registerProvider(t,n){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${t}`);const r=new m.DisposableStore;return this.h.set(t,n),this.c.fire({added:!0,scheme:t,provider:n}),r.add(n.onDidChangeFile(i=>this.R.fire(new s.FileChangesEvent(i,!this.O(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this.S.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:t}))),(0,m.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:n}),this.h.delete(t),(0,m.dispose)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const n=[];this.f.fire({scheme:t,join(r){n.push(r)}}),!this.h.has(t)&&await L.Promises.settled(n)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,n){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return v.Iterable.map(this.h,([t,n])=>({scheme:t,capabilities:n.capabilities}))}async j(t){if(!(0,d.isAbsolutePath)(t))throw new s.FileOperationError((0,b.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const n=this.h.get(t.scheme);if(!n){const r=new f.ErrorNoTelemetry;throw r.message=(0,b.localize)(1,null,t.toString()),r}return n}async k(t){const n=await this.j(t);if((0,s.hasOpenReadWriteCloseCapability)(n)||(0,s.hasReadWriteCapability)(n)||(0,s.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const n=await this.j(t);if((0,s.hasOpenReadWriteCloseCapability)(n)||(0,s.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,n){try{return await this.n(t,n)}catch(r){throw(0,s.toFileSystemProviderErrorCode)(r)===s.FileSystemProviderErrorCode.FileNotFound?new s.FileOperationError((0,b.localize)(2,null,this.nb(t)),1):(0,s.ensureFileSystemProviderError)(r)}}async n(t,n){const r=await this.j(t),i=this.O(r),a=n?.resolveTo,l=n?.resolveSingleChildDescendants,c=n?.resolveMetadata,g=await r.stat(t);let D;return this.p(r,t,g,void 0,!!c,(k,S)=>(D||(D=T.TernarySearchTree.forUris(()=>!i),D.set(t,!0),a&&D.fill(!0,a)),D.get(k.resource)||D.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&l?S===1:!1))}async p(t,n,r,i,a,l){const{providerExtUri:c}=this.N(t),g={resource:n,name:c.basename(n),isFile:(r.type&s.FileType.File)!==0,isDirectory:(r.type&s.FileType.Directory)!==0,isSymbolicLink:(r.type&s.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&s.FilePermission.Readonly)||!!(t.capabilities&2048),etag:(0,s.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(g.isDirectory&&l(g,i)){try{const D=await t.readdir(n),k=await L.Promises.settled(D.map(async([S,F])=>{try{const H=c.joinPath(n,S),te=a?await t.stat(H):{type:F};return await this.p(t,H,te,D.length,a,l)}catch(H){return this.b.trace(H),null}}));g.children=(0,w.coalesce)(k)}catch(D){this.b.trace(D),g.children=[]}return g}return g}async resolveAll(t){return L.Promises.settled(t.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const n=await this.j(t),r=await n.stat(t);return this.p(n,t,r,void 0,!0,()=>!1)}async exists(t){const n=await this.j(t);try{return!!await n.stat(t)}catch{return!1}}async canCreateFile(t,n){try{await this.r(t,n)}catch(r){return r}return!0}async r(t,n){if(!n?.overwrite&&await this.exists(t))throw new s.FileOperationError((0,b.localize)(3,null,this.nb(t)),3,n)}async createFile(t,n=o.VSBuffer.fromString(""),r){await this.r(t,r);const i=await this.writeFile(t,n);return this.m.fire(new s.FileOperationEvent(t,0,i)),i}async writeFile(t,n,r){const i=this.lb(await this.l(t),t),{providerExtUri:a}=this.N(i);try{await this.s(i,t,r)||await this.P(i,a.dirname(t));let c;if((0,s.hasReadWriteCapability)(i)&&!(n instanceof o.VSBuffer))if((0,p.isReadableStream)(n)){const g=await(0,p.peekStream)(n,3);g.ended?c=o.VSBuffer.concat(g.buffer):c=g}else c=(0,p.peekReadable)(n,g=>o.VSBuffer.concat(g),3);else c=n;!(0,s.hasOpenReadWriteCloseCapability)(i)||(0,s.hasReadWriteCapability)(i)&&c instanceof o.VSBuffer?await this.cb(i,t,r,c):await this.Y(i,t,r,c instanceof o.VSBuffer?(0,o.bufferToReadable)(c):c),this.m.fire(new s.FileOperationEvent(t,4))}catch(l){throw new s.FileOperationError((0,b.localize)(4,null,this.nb(t),(0,s.ensureFileSystemProviderError)(l).toString()),(0,s.toFileOperationResult)(l),r)}return this.resolve(t,{resolveMetadata:!0})}async s(t,n,r){if(!!r?.unlock&&!(t.capabilities&8192))throw new Error((0,b.localize)(5,null,this.nb(n)));let a;try{a=await t.stat(n)}catch{return}if(a.type&s.FileType.Directory)throw new s.FileOperationError((0,b.localize)(6,null,this.nb(n)),0,r);if(this.mb(n,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==s.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,s.etag)({mtime:r.mtime,size:a.size}))throw new s.FileOperationError((0,b.localize)(7,null),3,r);return a}async readFile(t,n,r){const i=await this.k(t);return n?.atomic?this.t(i,t,n,r):this.u(i,t,n,r)}async t(t,n,r,i){return new Promise((a,l)=>{this.X.queueFor(n,this.N(t).providerExtUri).queue(async()=>{try{const c=await this.u(t,n,r,i);a(c)}catch(c){l(c)}})})}async u(t,n,r,i){const a=await this.v(t,n,{...r,preferUnbuffered:!0},i);return{...a,value:await(0,o.streamToBuffer)(a.value)}}async readFileStream(t,n,r){const i=await this.k(t);return this.v(i,t,n,r)}async v(t,n,r,i){const a=new P.CancellationTokenSource(i),l=this.F(n,r).then(g=>g,g=>{throw a.cancel(),g});let c;try{return typeof r?.etag=="string"&&r.etag!==s.ETAG_DISABLED&&await l,r?.atomic&&(0,s.hasFileAtomicReadCapability)(t)||!((0,s.hasOpenReadWriteCloseCapability)(t)||(0,s.hasFileReadStreamCapability)(t))||(0,s.hasReadWriteCapability)(t)&&r?.preferUnbuffered?c=this.D(t,n,r):(0,s.hasFileReadStreamCapability)(t)?c=this.z(t,n,a.token,r):c=this.C(t,n,a.token,r),{...await l,value:c}}catch(g){throw c&&await(0,p.consumeStream)(c),this.w(g,n,r)}}w(t,n,r){const i=(0,b.localize)(8,null,this.nb(n),(0,s.ensureFileSystemProviderError)(t).toString());return t instanceof s.NotModifiedSinceFileOperationError?new s.NotModifiedSinceFileOperationError(i,t.stat,r):t instanceof s.TooLargeFileOperationError?new s.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new s.FileOperationError(i,(0,s.toFileOperationResult)(t),r)}z(t,n,r,i=Object.create(null)){const a=t.readFileStream(n,i,r);return(0,p.transform)(a,{data:l=>l instanceof o.VSBuffer?l:o.VSBuffer.wrap(l),error:l=>this.w(l,n,i)},l=>o.VSBuffer.concat(l))}C(t,n,r,i=Object.create(null)){const a=(0,o.newWriteableBufferStream)();return(0,h.readFileIntoStream)(t,n,a,l=>l,{...i,bufferSize:this.a,errorTransformer:l=>this.w(l,n,i)},r),a}D(t,n,r){const i=(0,p.newWriteableStream)(a=>o.VSBuffer.concat(a));return(async()=>{try{let a;r?.atomic&&(0,s.hasFileAtomicReadCapability)(t)?a=await t.readFile(n,{atomic:!0}):a=await t.readFile(n),typeof r?.position=="number"&&(a=a.slice(r.position)),typeof r?.length=="number"&&(a=a.slice(0,r.length)),this.G(n,a.byteLength,r),i.end(o.VSBuffer.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async F(t,n){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new s.FileOperationError((0,b.localize)(9,null,this.nb(t)),0,n);if(typeof n?.etag=="string"&&n.etag!==s.ETAG_DISABLED&&n.etag===r.etag)throw new s.NotModifiedSinceFileOperationError((0,b.localize)(10,null),r,n);return this.G(t,r.size,n),r}G(t,n,r){if(typeof r?.limits?.size=="number"&&n>r.limits.size)throw new s.TooLargeFileOperationError((0,b.localize)(11,null,this.nb(t)),7,n,r)}async canMove(t,n,r){return this.H(t,n,"move",r)}async canCopy(t,n,r){return this.H(t,n,"copy",r)}async H(t,n,r,i){if(t.toString()!==n.toString())try{const a=r==="move"?this.lb(await this.l(t),t):await this.k(t),l=this.lb(await this.l(n),n);await this.M(a,t,l,n,r,i)}catch(a){return a}return!0}async move(t,n,r){const i=this.lb(await this.l(t),t),a=this.lb(await this.l(n),n),l=await this.I(i,t,a,n,"move",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new s.FileOperationEvent(t,l==="move"?2:3,c)),c}async copy(t,n,r){const i=await this.k(t),a=this.lb(await this.l(n),n),l=await this.I(i,t,a,n,"copy",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new s.FileOperationEvent(t,l==="copy"?3:2,c)),c}async I(t,n,r,i,a,l){if(n.toString()===i.toString())return a;const{exists:c,isSameResourceWithDifferentPathCase:g}=await this.M(t,n,r,i,a,l);if(c&&!g&&l&&await this.del(i,{recursive:!0}),await this.P(r,this.N(r).providerExtUri.dirname(i)),a==="copy"){if(t===r&&(0,s.hasFileFolderCopyCapability)(t))await t.copy(n,i,{overwrite:l});else{const D=await this.resolve(n);D.isDirectory?await this.L(t,D,r,i):await this.J(t,n,r,i)}return a}else return t===r?(await t.rename(n,i,{overwrite:l}),a):(await this.I(t,n,r,i,"copy",l),await this.del(n,{recursive:!0}),"copy")}async J(t,n,r,i){if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(r))return this.eb(t,n,r,i);if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasReadWriteCapability)(r))return this.kb(t,n,r,i);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(r))return this.ib(t,n,r,i);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasReadWriteCapability)(r))return this.gb(t,n,r,i)}async L(t,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await L.Promises.settled(n.children.map(async a=>{const l=this.N(r).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.L(t,await this.resolve(a.resource),r,l):this.J(t,a.resource,r,l)}))}async M(t,n,r,i,a,l){let c=!1;if(t===r){const{providerExtUri:D,isPathCaseSensitive:k}=this.N(t);if(k||(c=D.isEqual(n,i)),c&&a==="copy")throw new Error((0,b.localize)(12,null,this.nb(n),this.nb(i)));if(!c&&D.isEqualOrParent(i,n))throw new Error((0,b.localize)(13,null,this.nb(n),this.nb(i)))}const g=await this.exists(i);if(g&&!c){if(!l)throw new s.FileOperationError((0,b.localize)(14,null,this.nb(n),this.nb(i)),4);if(t===r){const{providerExtUri:D}=this.N(t);if(D.isEqualOrParent(n,i))throw new Error((0,b.localize)(15,null,this.nb(n),this.nb(i)))}}return{exists:g,isSameResourceWithDifferentPathCase:c}}N(t){const n=this.O(t);return{providerExtUri:n?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:n}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const n=this.lb(await this.j(t),t);await this.P(n,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new s.FileOperationEvent(t,0,r)),r}async P(t,n){const r=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(n,i.dirname(n));)try{if(!((await t.stat(n)).type&s.FileType.Directory))throw new Error((0,b.localize)(16,null,this.nb(n)));break}catch(a){if((0,s.toFileSystemProviderErrorCode)(a)!==s.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(i.basename(n)),n=i.dirname(n)}for(let a=r.length-1;a>=0;a--){n=i.joinPath(n,r[a]);try{await t.mkdir(n)}catch(l){if((0,s.toFileSystemProviderErrorCode)(l)!==s.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,n){try{await this.Q(t,n)}catch(r){return r}return!0}async Q(t,n){const r=this.lb(await this.j(t),t);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,b.localize)(17,null,this.nb(t)));let a;try{a=await r.stat(t)}catch{}if(a)this.mb(t,a);else throw new s.FileOperationError((0,b.localize)(18,null,this.nb(t)),1);if(!!!n?.recursive){const c=await this.resolve(t);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,b.localize)(19,null,this.nb(t)))}return r}async del(t,n){const r=await this.Q(t,n),i=!!n?.useTrash,a=!!n?.recursive;await r.delete(t,{recursive:a,useTrash:i}),this.m.fire(new s.FileOperationEvent(t,1))}async cloneFile(t,n){const r=await this.j(t),i=this.lb(await this.l(n),n);if(r===i&&this.N(r).providerExtUri.isEqual(t,n))return;if(r===i&&(0,s.hasFileCloneCapability)(r))return r.cloneFile(t,n);await this.P(i,this.N(i).providerExtUri.dirname(n));const a=this.X.queueFor(t,this.N(r).providerExtUri);return r===i&&(0,s.hasFileFolderCopyCapability)(r)?a.queue(()=>r.copy(t,n,{overwrite:!0})):a.queue(()=>this.J(r,t,i,n))}watch(t,n={recursive:!1,excludes:[]}){const r=new m.DisposableStore;let i=!1,a=()=>{i=!0};return r.add((0,m.toDisposable)(()=>a())),(async()=>{try{const l=await this.W(t,n);i?(0,m.dispose)(l):a=()=>(0,m.dispose)(l)}catch(l){this.b.error(l)}})(),r}async W(t,n){const r=await this.j(t),i=(0,A.hash)([this.N(r).providerExtUri.getComparisonKey(t),n]);let a=this.U.get(i);return a||(a={count:0,disposable:r.watch(t,n)},this.U.set(i,a)),a.count+=1,(0,m.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,m.dispose)(a.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,m.dispose)(t.disposable);this.U.clear()}async Y(t,n,r,i){return this.X.queueFor(n,this.N(t).providerExtUri).queue(async()=>{const a=await t.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(i)||(0,p.isReadableBufferedStream)(i)?await this.Z(t,a,i):await this.ab(t,a,i)}catch(l){throw(0,s.ensureFileSystemProviderError)(l)}finally{await t.close(a)}})}async Z(t,n,r){let i=0,a;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const l=o.VSBuffer.concat(r.buffer);await this.bb(t,n,l,l.byteLength,i,0),i+=l.byteLength}if(r.ended)return;a=r.stream}else a=r;return new Promise((l,c)=>{(0,p.listenStream)(a,{onData:async g=>{a.pause();try{await this.bb(t,n,g,g.byteLength,i,0)}catch(D){return c(D)}i+=g.byteLength,setTimeout(()=>a.resume())},onError:g=>c(g),onEnd:()=>l()})})}async ab(t,n,r){let i=0,a;for(;(a=r.read())!==null;)await this.bb(t,n,a,a.byteLength,i,0),i+=a.byteLength}async bb(t,n,r,i,a,l){let c=0;for(;c<i;){const g=await t.write(n,a+c,r.buffer,l+c,i-c);c+=g}}async cb(t,n,r,i){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.db(t,n,r,i))}async db(t,n,r,i){let a;i instanceof o.VSBuffer?a=i:(0,p.isReadableStream)(i)?a=await(0,o.streamToBuffer)(i):(0,p.isReadableBufferedStream)(i)?a=await(0,o.bufferedStreamToBuffer)(i):a=(0,o.readableToBuffer)(i),await t.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async eb(t,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.fb(t,n,r,i))}async fb(t,n,r,i){let a,l;try{a=await t.open(n,{create:!1}),l=await r.open(i,{create:!0,unlock:!1});const c=o.VSBuffer.alloc(this.a);let g=0,D=0,k=0;do k=await t.read(a,g,c.buffer,D,c.byteLength-D),await this.bb(r,l,c,k,g,D),g+=k,D+=k,D===c.byteLength&&(D=0);while(k>0)}catch(c){throw(0,s.ensureFileSystemProviderError)(c)}finally{await L.Promises.settled([typeof a=="number"?t.close(a):Promise.resolve(),typeof l=="number"?r.close(l):Promise.resolve()])}}async gb(t,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.hb(t,n,r,i))}async hb(t,n,r,i){return r.writeFile(i,await t.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async ib(t,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.jb(t,n,r,i))}async jb(t,n,r,i){const a=await r.open(i,{create:!0,unlock:!1});try{const l=await t.readFile(n);await this.bb(r,a,o.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,s.ensureFileSystemProviderError)(l)}finally{await r.close(a)}}async kb(t,n,r,i){const a=await(0,o.streamToBuffer)(this.C(t,n,P.CancellationToken.None));await this.cb(r,i,void 0,a)}lb(t,n){if(t.capabilities&2048)throw new s.FileOperationError((0,b.localize)(20,null,this.nb(n)),6);return t}mb(t,n){if((n.permissions??0)&s.FilePermission.Readonly)throw new s.FileOperationError((0,b.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===y.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=I=Le([Re(0,u.ILogService)],I)}),define(ge[66],pe([1,0,33,295,14,27,15,6,39,2,7,3,19,47,23,185,16,107,223,38,219,218]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u,f,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(w)}catch(n){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(n)}`)}})();class t extends u.AbstractDiskFileSystemProvider{constructor(r,i){super(r,i),this.onDidChangeCapabilities=A.Event.None,this.H=new P.ResourceMap(a=>E.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,y.isLinux&&(this.F|=1024)),this.F}async stat(r){try{const{stat:i,symbolicLink:a}=await p.SymlinkSupport.stat(this.C(r));return{type:this.G(i,a),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.Y(i)}}async readdir(r){try{const i=await p.Promises.readdir(this.C(r),{withFileTypes:!0}),a=[];return await Promise.all(i.map(async l=>{try{let c;l.isSymbolicLink()?c=(await this.stat((0,E.joinPath)(r,l.name))).type:c=this.G(l),a.push([l.name,c])}catch(c){this.a.trace(c)}})),a}catch(i){throw this.Y(i)}}G(r,i){let a;return i?.dangling?a=s.FileType.Unknown:r.isFile()?a=s.FileType.File:r.isDirectory()?a=s.FileType.Directory:a=s.FileType.Unknown,i&&(a|=s.FileType.SymbolicLink),a}async I(r){const i=this.C(r);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let a;for(;a=this.H.get(r);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await a.wait();const l=new o.Barrier;return this.H.set(r,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,m.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.H.get(r)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.H.delete(r)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(r,i){let a;try{i?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(r)})`),a=await this.I(r));const l=this.C(r);return await p.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{a?.dispose()}}J(r){t.D&&this.a.trace(r)}readFileStream(r,i,a){const l=(0,d.newWriteableStream)(c=>C.VSBuffer.concat(c.map(g=>C.VSBuffer.wrap(g))).buffer);return(0,h.readFileIntoStream)(this,r,l,c=>c.buffer,{...i,bufferSize:256*1024},a),l}async writeFile(r,i,a){let l;try{const c=this.C(r);if(!a.create||!a.overwrite){if(await p.Promises.exists(c)){if(!a.overwrite)throw(0,s.createFileSystemProviderError)((0,b.localize)(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,s.createFileSystemProviderError)((0,b.localize)(1,null),s.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(r,{create:!0,unlock:a.unlock}),await this.write(l,0,i,0,i.byteLength)}catch(c){throw await this.Z(r,c)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(r){t.O=r}async open(r,i){const a=this.C(r);let l;(0,s.isFileOpenForWriteOptions)(i)&&(l=await this.I(r));let c;try{if((0,s.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:D}=await p.SymlinkSupport.stat(a);D.mode&128||await p.Promises.chmod(a,D.mode|128)}catch(D){this.a.trace(D)}let g;if((0,s.isFileOpenForWriteOptions)(i)){if(y.isWindows)try{await p.Promises.truncate(a,0),g="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}g||(g="w")}else g="r";c=await p.Promises.open(a,g)}catch(g){throw l?.dispose(),(0,s.isFileOpenForWriteOptions)(i)?await this.Z(r,g):this.Y(g)}if(this.L.set(c,0),(0,s.isFileOpenForWriteOptions)(i)&&this.N.set(c,r),l){const g=this.M.get(c);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${a})`),this.M.set(c,l),g&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${a})`),g.dispose())}return c}async close(r){const i=this.M.get(r);try{if(this.L.delete(r),this.N.delete(r)&&t.O)try{await p.Promises.fdatasync(r)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await p.Promises.close(r)}catch(a){throw this.Y(a)}finally{i&&(this.M.get(r)===i&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.M.delete(r)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,a,l,c){const g=this.P(r,i);let D=null;try{D=(await p.Promises.read(r,a,l,c,g)).bytesRead}catch(k){throw this.Y(k)}finally{this.Q(r,g,D)}return D}P(r,i){return i===this.L.get(r)?null:i}Q(r,i,a){const l=this.L.get(r);typeof l=="number"&&(typeof i=="number"||(typeof a=="number"?this.L.set(r,l+a):this.L.delete(r)))}async write(r,i,a,l,c){return(0,o.retry)(()=>this.R(r,i,a,l,c),100,3)}async R(r,i,a,l,c){const g=this.P(r,i);let D=null;try{D=(await p.Promises.write(r,a,l,c,g)).bytesWritten}catch(k){throw await this.Z(this.N.get(r),k)}finally{this.Q(r,g,D)}return D}async mkdir(r){try{await p.Promises.mkdir(this.C(r))}catch(i){throw this.Y(i)}}async delete(r,i){try{const a=this.C(r);i.recursive?await p.Promises.rm(a,p.RimRafMode.MOVE):await p.Promises.unlink(a)}catch(a){throw this.Y(a)}}async rename(r,i,a){const l=this.C(r),c=this.C(i);if(l!==c)try{await this.S(r,i,"move",a.overwrite),await p.Promises.move(l,c)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,b.localize)(2,null,(0,T.basename)(l),(0,T.basename)((0,T.dirname)(c)),g.toString()))),this.Y(g)}}async copy(r,i,a){const l=this.C(r),c=this.C(i);if(l!==c)try{await this.S(r,i,"copy",a.overwrite),await p.Promises.copy(l,c,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,b.localize)(3,null,(0,T.basename)(l),(0,T.basename)((0,T.dirname)(c)),g.toString()))),this.Y(g)}}async S(r,i,a,l){const c=this.C(r),g=this.C(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,v.isEqual)(c,g,!0)),D&&a==="copy")throw(0,s.createFileSystemProviderError)((0,b.localize)(4,null),s.FileSystemProviderErrorCode.FileExists);if(!D&&await p.Promises.exists(g)){if(!l)throw(0,s.createFileSystemProviderError)((0,b.localize)(5,null),s.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(r,i){return this.U(r,i,!1)}async U(r,i,a){const l=this.C(r),c=this.C(i),g=!!(this.capabilities&1024);if((0,v.isEqual)(l,c,!g))return;const D=new m.DisposableStore;try{const[k,S]=await Promise.all([this.I(r),this.I(i)]);D.add(k),D.add(S),a&&await p.Promises.mkdir((0,T.dirname)(c),{recursive:!0}),await p.Promises.copyFile(l,c)}catch(k){if(k.code==="ENOENT"&&!a)return this.U(r,i,!0);throw this.Y(k)}finally{D.dispose()}}p(r,i,a){return new I.UniversalWatcherClient(l=>r(l),l=>i(l),a)}y(r,i,a){return new O.NodeJSWatcherClient(l=>r(l),l=>i(l),a)}Y(r){if(r instanceof s.FileSystemProviderError)return r;let i=r,a;switch(r.code){case"ENOENT":a=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=s.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=s.FileSystemProviderErrorCode.Unknown;break;default:a=s.FileSystemProviderErrorCode.Unknown}return(0,s.createFileSystemProviderError)(i,a)}async Z(r,i){let a=this.Y(i);if(r&&a.code===s.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await p.SymlinkSupport.stat(this.C(r));l.mode&128||(a=(0,s.createFileSystemProviderError)(i,s.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return a}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(ge[224],pe([1,0,6,66,2,15,47,20]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class v extends o.Disposable{constructor(y,E){super(),this.a=y,this.b=E,this.w=new Map,this.y=new Map}call(y,E,d){const p=this.c(y);switch(E){case"stat":return this.g(p,d[0]);case"readdir":return this.h(p,d[0]);case"open":return this.l(p,d[0],d[1]);case"close":return this.m(d[0]);case"read":return this.n(d[0],d[1],d[2]);case"readFile":return this.i(p,d[0],d[1]);case"write":return this.p(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.k(p,d[0],d[1],d[2]);case"rename":return this.t(p,d[0],d[1],d[2]);case"copy":return this.u(p,d[0],d[1],d[2]);case"cloneFile":return this.v(p,d[0],d[1]);case"mkdir":return this.r(p,d[0]);case"delete":return this.s(p,d[0],d[1]);case"watch":return this.C(p,d[0],d[1],d[2],d[3]);case"unwatch":return this.D(d[0],d[1])}throw new Error(`IPC Command ${E} not found`)}listen(y,E,d){const p=this.c(y);switch(E){case"fileChange":return this.z(p,d[0]);case"readFileStream":return this.j(p,d[0],d[1])}throw new Error(`Unknown event ${E}`)}g(y,E){const d=this.f(y,E,!0);return this.a.stat(d)}h(y,E){const d=this.f(y,E);return this.a.readdir(d)}async i(y,E,d){const p=this.f(y,E,!0),b=await this.a.readFile(p,d);return P.VSBuffer.wrap(b)}j(y,E,d){const p=this.f(y,E,!0),b=new A.CancellationTokenSource,s=new w.Emitter({onDidRemoveLastListener:()=>{b.cancel()}}),h=this.a.readFileStream(p,d,b.token);return(0,C.listenStream)(h,{onData:u=>s.fire(P.VSBuffer.wrap(u)),onError:u=>s.fire(u),onEnd:()=>{s.fire("end"),s.dispose(),b.dispose()}}),s.event}k(y,E,d,p){const b=this.f(y,E);return this.a.writeFile(b,d.buffer,p)}l(y,E,d){const p=this.f(y,E,!0);return this.a.open(p,d)}m(y){return this.a.close(y)}async n(y,E,d){const p=P.VSBuffer.alloc(d),b=0,s=await this.a.read(y,E,p.buffer,b,d);return[p,s]}p(y,E,d,p,b){return this.a.write(y,E,d.buffer,p,b)}r(y,E){const d=this.f(y,E);return this.a.mkdir(d)}s(y,E,d){const p=this.f(y,E);return this.a.delete(p,d)}t(y,E,d,p){const b=this.f(y,E),s=this.f(y,d);return this.a.rename(b,s,p)}u(y,E,d,p){const b=this.f(y,E),s=this.f(y,d);return this.a.copy(b,s,p)}v(y,E,d){const p=this.f(y,E),b=this.f(y,d);return this.a.cloneFile(p,b)}z(y,E){const d=new w.Emitter({onWillAddFirstListener:()=>{this.w.set(E,this.F(y,d))},onDidRemoveLastListener:()=>{(0,o.dispose)(this.w.get(E)),this.w.delete(E)}});return d.event}async C(y,E,d,p,b){const s=this.w.get(E);if(s){const h=this.f(y,p),u=s.watch(d,h,b);this.y.set(E+d,u)}}async D(y,E){const d=y+E,p=this.y.get(d);p&&((0,o.dispose)(p),this.y.delete(d))}dispose(){super.dispose();for(const[,y]of this.y)y.dispose();this.y.clear();for(const[,y]of this.w)y.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=v;class m extends o.Disposable{constructor(y,E,d,p){super(),this.c=y,this.f=d,this.g=p,this.a=new Map,this.b=this.B(new L.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(E)}h(y){const E=this.B(new w.Emitter);this.B(E.event(d=>{y.fire(d.map(p=>({resource:this.c.transformOutgoingURI(p.resource),type:p.type})))})),this.B(this.b.onDidChangeFile(d=>E.fire(d))),this.B(this.b.onDidWatchError(d=>y.fire(d)))}i(y){}j(y){}watch(y,E,d){const p=this.j(this.g);return Array.isArray(p)&&(d.excludes=[...d.excludes,...p]),this.a.set(y,this.b.watch(E,d)),(0,o.toDisposable)(()=>{(0,o.dispose)(this.a.get(y)),this.a.delete(y)})}dispose(){super.dispose();for(const[,y]of this.a)y.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=m}),define(ge[110],pe([1,0,4,6,12,2]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class C extends o.AbstractLoggerService{constructor(y,E,d,p,b){super(E,d,p),this.n=y,this.p=b,this.B(b.listen("onDidChangeLogLevel",y)(s=>{(0,o.isLogLevel)(s)?super.setLogLevel(s):super.setLogLevel(w.URI.revive(s[0]),s[1])})),this.B(b.listen("onDidChangeVisibility",y)(([s,h])=>super.setVisibility(w.URI.revive(s),h))),this.B(b.listen("onDidChangeLoggers",y)(({added:s,removed:h})=>{for(const u of s)super.registerLogger({...u,resource:w.URI.revive(u.resource)});for(const u of h)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new o.AdapterLogger({log:(y,E)=>{this.p.call("consoleLog",[y,E])}})}registerLogger(y){super.registerLogger(y),this.p.call("registerLogger",[y,this.n])}deregisterLogger(y){super.deregisterLogger(y),this.p.call("deregisterLogger",[y,this.n])}setLogLevel(y,E){super.setLogLevel(y,E),this.p.call("setLogLevel",[y,E])}setVisibility(y,E){super.setVisibility(y,E),this.p.call("setVisibility",[this.l(y),E])}m(y,E,d){return new A(this.p,y,E,d,this.n)}static setLogLevel(y,E,d){return y.call("setLogLevel",[E,d])}}e.LoggerChannelClient=C;class A extends o.AbstractMessageLogger{constructor(y,E,d,p,b){super(p?.logLevel==="always"),this.m=y,this.n=E,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[E,p,b]).then(()=>{this.r(this.l),this.k=!0})}g(y,E){const d=[[y,E]];this.k?this.r(d):this.l.push(...d)}r(y){this.m.call("log",[this.n,y])}}class v{constructor(y,E){this.a=y,this.b=E}listen(y,E){const d=this.b(y);switch(E){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,p=>({added:[...p.added].map(b=>this.c(b,d)),removed:[...p.removed].map(b=>this.c(b,d))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,p=>[d.transformOutgoingURI(p[0]),p[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,p=>(0,o.isLogLevel)(p)?p:[d.transformOutgoingURI(p[0]),p[1]])}throw new Error(`Event not found: ${E}`)}async call(y,E,d){const p=this.b(y);switch(E){case"setLogLevel":return(0,o.isLogLevel)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(w.URI.revive(p.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,p)))}throw new Error(`Call not found: ${E}`)}c(y,E){return{...y,resource:E.transformOutgoingURI(y.resource)}}}e.LoggerChannel=v;class m extends P.Disposable{constructor(y,E){super(),E.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(d=>E.call("setLogLevel",[d]))),E.call("getRegisteredLoggers").then(d=>{for(const p of d)y.registerLogger({...p,resource:w.URI.revive(p.resource)})}),this.B(E.listen("onDidChangeVisibility")(([d,p])=>y.setVisibility(w.URI.revive(d),p))),this.B(E.listen("onDidChangeLoggers")(({added:d,removed:p})=>{for(const b of d)y.registerLogger({...b,resource:w.URI.revive(b.resource)});for(const b of p)y.deregisterLogger(b.resource)}))}}e.RemoteLoggerChannelClient=m}),define(ge[111],pe([1,0,2,12]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class o extends w.Disposable{constructor(C,A=[]){super(),this.a=new L.MultiplexLogger([C,...A]),this.B(C.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...A){this.a.trace(C,...A)}debug(C,...A){this.a.debug(C,...A)}info(C,...A){this.a.info(C,...A)}warn(C,...A){this.a.warn(C,...A)}error(C,...A){this.a.error(C,...A)}flush(){this.a.flush()}}e.LogService=o}),define(ge[225],pe([1,0,16,12]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var o;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(o||(o={}));async function P(m,T,y,E,d){try{const p=await new Promise((s,h)=>{oe(["@vscode/spdlog"],s,h)});p.setFlushOn(o.Trace);const b=await p.createAsyncRotatingLogger(m,T,y,E);return d?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(p){console.error(p)}return null}function C(m,T,y){switch(T){case L.LogLevel.Trace:m.trace(y);break;case L.LogLevel.Debug:m.debug(y);break;case L.LogLevel.Info:m.info(y);break;case L.LogLevel.Warning:m.warn(y);break;case L.LogLevel.Error:m.error(y);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function A(m,T){switch(T){case L.LogLevel.Trace:m.setLevel(o.Trace);break;case L.LogLevel.Debug:m.setLevel(o.Debug);break;case L.LogLevel.Info:m.setLevel(o.Info);break;case L.LogLevel.Warning:m.setLevel(o.Warning);break;case L.LogLevel.Error:m.setLevel(o.Error);break;case L.LogLevel.Off:m.setLevel(o.Off);break;default:throw new Error(`Invalid log level ${T}`)}}class v extends L.AbstractMessageLogger{constructor(T,y,E,d,p){super(),this.k=[],this.setLevel(p),this.l=this.n(T,y,E,d),this.B(this.onDidChangeLogLevel(b=>{this.m&&A(this.m,b)}))}async n(T,y,E,d){const p=E?6:1,b=30/p*w.ByteSize.MB,s=await P(T,y,b,p,d);if(s){this.m=s,A(this.m,this.getLevel());for(const{level:h,message:u}of this.k)C(this.m,h,u);this.k=[]}}g(T,y){this.m?C(this.m,T,y):this.getLevel()<=T&&this.k.push({level:T,message:y})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=v}),define(ge[112],pe([1,0,22,12,225]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class P extends L.AbstractLoggerService{m(A,v,m){return new o.SpdLogLogger((0,w.generateUuid)(),A.fsPath,!m?.donotRotate,!!m?.donotUseFormatters,v)}}e.LoggerService=P}),define(ge[226],pe([1,0,59,187,5]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var C;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(C||(e.MarkerSeverity=C={})),function(v){function m(p,b){return b-p}v.compare=m;const T=Object.create(null);T[v.Error]=(0,L.localize)(0,null),T[v.Warning]=(0,L.localize)(1,null),T[v.Info]=(0,L.localize)(2,null);function y(p){return T[p]||""}v.toString=y;function E(p){switch(p){case w.default.Error:return v.Error;case w.default.Warning:return v.Warning;case w.default.Info:return v.Info;case w.default.Ignore:return v.Hint}}v.fromSeverity=E;function d(p){switch(p){case v.Error:return w.default.Error;case v.Warning:return w.default.Warning;case v.Info:return w.default.Info;case v.Hint:return w.default.Ignore}}v.toSeverity=d}(C||(e.MarkerSeverity=C={}));var A;(function(v){const m="";function T(E){return y(E,!0)}v.makeKey=T;function y(E,d){const p=[m];return E.source?p.push(E.source.replace("\xA6","\\\xA6")):p.push(m),E.code?typeof E.code=="string"?p.push(E.code.replace("\xA6","\\\xA6")):p.push(E.code.value.replace("\xA6","\\\xA6")):p.push(m),E.severity!==void 0&&E.severity!==null?p.push(C.toString(E.severity)):p.push(m),E.message&&d?p.push(E.message.replace("\xA6","\\\xA6")):p.push(m),E.startLineNumber!==void 0&&E.startLineNumber!==null?p.push(E.startLineNumber.toString()):p.push(m),E.startColumn!==void 0&&E.startColumn!==null?p.push(E.startColumn.toString()):p.push(m),E.endLineNumber!==void 0&&E.endLineNumber!==null?p.push(E.endLineNumber.toString()):p.push(m),E.endColumn!==void 0&&E.endColumn!==null?p.push(E.endColumn.toString()):p.push(m),p.push(m),p.join("\xA6")}v.makeKeyOptionalMessage=y})(A||(e.IMarkerData=A={})),e.IMarkerService=(0,o.createDecorator)("markerService")}),define(ge[67],pe([1,0,6,46,2,5]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,P.createDecorator)("policy");class C extends o.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new w.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const T=Object.keys(this.f).length;return this.f={...m,...this.f},T!==Object.keys(this.f).length&&await this.i(m),L.Iterable.reduce(this.g.entries(),(y,[E,d])=>({...y,[E]:d}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(m,[T,y])=>({...m,[T]:{definition:y,value:this.g.get(T)}}),{})}}e.AbstractPolicyService=C;class A{constructor(){this.onDidChange=w.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=A}),define(ge[53],pe([1,0,3,29]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let o;if(typeof w.globals.vscode<"u"&&typeof w.globals.vscode.context<"u"){const P=w.globals.vscode.context.configuration();if(P)o=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(o=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`,serverDataFolderName:o.serverDataFolderName?`${o.serverDataFolderName}-dev`:void 0}),!o.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(o,{version:P.version})}}else o={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csharp":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"ms-vscode.vscode-typescript-tslint-plugin":{onFileOpen:[{pathGlob:"{**/tslint.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"felipecaputo.git-project-manager":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"GoogleCloudTools.cloudcode":{onFileOpen:[{pathGlob:"{**/skaffold.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"Pivotal.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}]},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"python-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*\\])|("black\\s*["[(<=>!~;@])'}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",showInStartEntry:!0}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows"]},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",showInStartEntry:!0},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",showInStartEntry:!0},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",showInStartEntry:!0}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","testContinuousRun"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","testObserver","envShellEvent","quickPickItemTooltip","terminalDataWriteEvent","envCollectionWorkspace","saveEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["contribCommentThreadAdditionalMenu","tokenInformation","contribShareMenu","fileComments","contribCommentPeekContext","treeItemCheckbox","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare","github.copilot"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]}}},win32TunnelServiceMutex:"vscodetunnelservice",win32TunnelMutex:"vscodetunnel",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.78.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.19",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],walkthroughMetadata:[{id:"Setup",steps:[{id:"copilotInstall",title:"Supercharge your coding with AI-based suggestions",description:`Throw that rubber duck away! Code more efficiently with AI at your fingertips. Try [GitHub Copilot](command:extension.open?"github.copilot") free for 60 days.
[Install Copilot](command:workbench.extensions.installExtension?%22github.copilot%22)`,media:{type:"image",altText:"Copilot Statistics",path:"copilotStep.png"}}]}],featuredExtensions:[{id:"github.copilot",title:"GitHub Copilot",description:"Supercharge your coding experience for as little as $10/month with cutting edge AI code generation."}],version:"1.78.1",commit:"6a995c4f4cc2ced6e3237749973982e751cb0bf9",date:"2023-05-04T09:25:12.084Z"},Object.keys(o).length===0&&Object.assign(o,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=o}),define(ge[26],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ge[227],pe([1,0,78,12,25,26,221]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let A=e.CredentialsWebMainService=class extends C.BaseCredentialsMainService{constructor(m,T,y){super(m),this.p=T,this.r=y}async getSecretStoragePrefix(){return Promise.resolve(`${this.r.urlProtocol}-server`)}async i(){if(this.f)return this.f;if(this.p.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new w.InMemoryCredentialsProvider,this.f;try{this.f=await new Promise((m,T)=>{oe(["keytar"],m,T)}),await this.f.findCredentials("test-keytar-loads")}catch(m){this.h.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${m.message??m}`),this.f=new w.InMemoryCredentialsProvider}return this.f}};e.CredentialsWebMainService=A=Le([Re(0,L.ILogService),Re(1,o.INativeEnvironmentService),Re(2,P.IProductService)],A)}),define(ge[40],pe([1,0,92,8]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class o{constructor(){this.a=new Map}add(C,A){w.ok(L.isString(C)),w.ok(L.isObject(A)),w.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,A)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new o}),define(ge[228],pe([1,0,6,40]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function o(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class P{constructor(){this.b=new w.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,m){this.a[o(v)]=m,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const C=new P;L.Registry.add(e.Extensions.JSONContribution,C)}),define(ge[54],pe([1,0,18,6,8,169,24,228,40]),function(oe,e,w,L,o,P,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(O){O.Multiline="multilineText",O.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(O){O[O.APPLICATION=1]="APPLICATION",O[O.MACHINE=2]="MACHINE",O[O.WINDOW=3]="WINDOW",O[O.RESOURCE=4]="RESOURCE",O[O.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",O[O.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=v.Registry.as(A.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const r=new Set;this.n(t,n,r),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const n=new Set;this.o(t,n),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const r=new Set;this.o(n,r),this.n(t,!1,r),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const r=[];for(const{overrides:i,source:a}of t)for(const l in i)if(n.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const c=this.a.get(l),g=c?.valuesSources??new Map;if(a)for(const F of Object.keys(i[l]))g.set(F,a);const D={...c?.value||{},...i[l]};this.a.set(l,{source:a,value:D,valuesSources:g});const k=(0,C.getLanguageTagSettingPlainKey)(l),S={type:"object",default:D,description:P.localize(1,null,k),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:o.isString(a)?void 0:a,defaultValueSource:a};r.push(...b(l)),this.d[l]=S,this.b.properties[l]=S}else{this.a.set(l,{value:i[l],source:a});const c=this.d[l];c&&(this.w(l,c),this.r(l,c))}this.m(r)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:r,source:i}of t)for(const a in r){const l=this.a.get(a),c=o.isString(i)?i:i?.id,g=o.isString(l?.source)?l?.source:l?.source?.id;if(c===g)if(n.add(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const D=this.d[a];D&&(this.w(a,D),this.r(a,D))}}this.u()}deltaConfiguration(t){let n=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,r){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,n){const r=i=>{if(i.properties)for(const a in i.properties){n.add(a);const l=this.d[a];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[a],this.s(a,i.properties[a])}i.allOf?.forEach(a=>r(a))};for(const i of t){r(i);const a=this.c.indexOf(i);a!==-1&&this.c.splice(a,1)}}p(t,n=!0,r,i,a=3,l){a=o.isUndefinedOrNull(t.scope)?a:t.scope;const c=t.properties;if(c)for(const D in c){const k=c[D];if(n&&f(D,k)){delete c[D];continue}if(k.source=r,k.defaultDefaultValue=c[D].default,this.w(D,k),e.OVERRIDE_PROPERTY_REGEX.test(D)?k.scope=void 0:(k.scope=o.isUndefinedOrNull(k.scope)?a:k.scope,k.restricted=o.isUndefinedOrNull(k.restricted)?!!i?.includes(D):k.restricted),c[D].hasOwnProperty("included")&&!c[D].included){this.f[D]=c[D],delete c[D];continue}else this.d[D]=c[D],c[D].policy?.name&&this.e.set(c[D].policy.name,D);!c[D].deprecationMessage&&c[D].markdownDeprecationMessage&&(c[D].deprecationMessage=c[D].markdownDeprecationMessage),l.add(D)}const g=t.allOf;if(g)for(const D of g)this.p(D,n,r,i,a,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=r=>{const i=r.properties;if(i)for(const l in i)this.r(l,i[l]);r.allOf?.forEach(n)};n(t)}r(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,r={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(n,r),e.allSettings.properties[n]=r,e.applicationSettings.properties[n]=r,e.machineSettings.properties[n]=r,e.machineOverridableSettings.properties[n]=r,e.windowSettings.properties[n]=r,e.resourceSettings.properties[n]=r}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,n){const r=this.a.get(t);let i=r?.value,a=r?.source;o.isUndefined(i)&&(i=n.defaultDefaultValue,a=void 0),o.isUndefined(i)&&(i=h(n.type)),n.default=i,n.defaultValueSource=a}}const d="\\[([^\\]]+)\\]",p=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(O){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(O)){let n=p.exec(O);for(;n?.length;){const r=n[1].trim();r&&t.push(r),n=p.exec(O)}}return(0,w.distinct)(t)}e.overrideIdentifiersFromKey=b;function s(O){return O.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=s;function h(O){switch(Array.isArray(O)?O[0]:O){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const u=new E;v.Registry.add(e.Extensions.Configuration,u);function f(O,t){return O.trim()?e.OVERRIDE_PROPERTY_REGEX.test(O)?P.localize(7,null,O):u.getConfigurationProperties()[O]!==void 0?P.localize(8,null,O):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,O,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}e.validateProperty=f;function I(){const O=[],t=u.getConfigurationProperties();for(const n of Object.keys(t))O.push([n,t[n].scope]);return O.push(["launch",4]),O.push(["task",4]),O}e.getScopes=I}),define(ge[113],pe([1,0,18,6,72,2,27,21,8,4,24,54,40]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(n){return Object.isFrozen(n)?n:A.deepFreeze(n)}class p{constructor(r={},i=[],a=[],l){this.b=r,this.c=i,this.d=a,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof p)return i;const a=new b("");return a.parseRaw(i),a.configurationModel});this.f=r.reduce((i,a)=>a===i?a:i.merge(a),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,T.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const a=this.rawConfiguration.getValue(r),l=i?this.rawConfiguration.getOverrideValue(r,i):void 0,c=i?this.rawConfiguration.override(i).getValue(r):a;return{value:a,override:l,merged:c}}getOverrideValue(r,i){const a=this.i(i);return a?r?(0,T.getConfigurationValue)(a,r):a:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const a of this.overrides)a.identifiers.includes(r)&&i.push(...a.keys);return w.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return w.distinct(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=A.deepClone(this.contents),a=A.deepClone(this.overrides),l=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const g of r)if(c.push(...g.raw?.length?g.raw:[g]),!g.isEmpty()){this.h(i,g.contents);for(const D of g.overrides){const[k]=a.filter(S=>w.equals(S.identifiers,D.identifiers));k?(this.h(k.contents,D.contents),k.keys.push(...D.keys),k.keys=w.distinct(k.keys)):a.push(A.deepClone(D))}for(const D of g.keys)l.indexOf(D)===-1&&l.push(D)}return new p(i,l,a,c.every(g=>g instanceof p)?void 0:c)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const l of w.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[l];const g=i[l];g&&(typeof c=="object"&&typeof g=="object"?(c=A.deepClone(c),this.h(c,g)):c=g),a[l]=c}return new p(a,this.keys,this.overrides)}h(r,i){for(const a of Object.keys(i)){if(a in r&&v.isObject(r[a])&&v.isObject(i[a])){this.h(r[a],i[a]);continue}r[a]=A.deepClone(i[a])}}i(r){let i=null,a=null;const l=c=>{c&&(a?this.h(a,c):a=A.deepClone(c))};for(const c of this.overrides)w.equals(c.identifiers,[r])?i=c.contents:c.identifiers.includes(r)&&l(c.contents);return l(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,T.removeFromValueTree)(this.contents,r),y.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(a=>w.equals(a.identifiers,(0,y.overrideIdentifiersFromKey)(r))),1))}j(r,i,a){(0,T.addToValueTree)(this.contents,r,i,l=>console.error(l)),a=a||this.keys.indexOf(r)===-1,a&&this.keys.push(r),y.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,T.toValuesTree)(this.contents[r],l=>console.error(l))})}}e.ConfigurationModel=p;class b{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!v.isUndefinedOrNull(r)){const a=this.g(r);this.parseRaw(a,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:a,keys:l,overrides:c,restricted:g,hasExcludedProperties:D}=this.h(r,i);this.b=new p(a,l,c,D?[r]:void 0),this.c=g||[]}g(r){let i={},a=null,l=[];const c=[],g=[];function D(S){Array.isArray(l)?l.push(S):a!==null&&(l[a]=S)}const k={onObjectBegin:()=>{const S={};D(S),c.push(l),l=S,a=null},onObjectProperty:S=>{a=S},onObjectEnd:()=>{l=c.pop()},onArrayBegin:()=>{const S=[];D(S),c.push(l),l=S,a=null},onArrayEnd:()=>{l=c.pop()},onLiteralValue:D,onError:(S,F,H)=>{g.push({error:S,offset:F,length:H})}};if(r)try{o.visit(r,k),i=l[0]||{}}catch(S){console.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return i}h(r,i){const a=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),l=this.i(r,a,!0,i);r=l.raw;const c=(0,T.toValuesTree)(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),g=Object.keys(r),D=this.j(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:c,keys:g,overrides:D,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(r,i,a,l){let c=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const g={},D=[];for(const k in r)if(y.OVERRIDE_PROPERTY_REGEX.test(k)&&a){const S=this.i(r[k],i,!1,l);g[k]=S.raw,c=c||S.hasExcludedProperties,D.push(...S.restricted)}else{const S=i[k],F=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&D.push(k),(F===void 0||l.scopes===void 0||l.scopes.includes(F))&&!(l.skipRestricted&&S?.restricted)?g[k]=r[k]:c=!0}return{raw:g,restricted:D,hasExcludedProperties:c}}j(r,i){const a=[];for(const l of Object.keys(r))if(y.OVERRIDE_PROPERTY_REGEX.test(l)){const c={};for(const g in r[l])c[g]=r[l][g];a.push({identifiers:(0,y.overrideIdentifiersFromKey)(l),keys:Object.keys(c),contents:(0,T.toValuesTree)(c,i)})}return a}}e.ConfigurationModelParser=b;class s extends P.Disposable{constructor(r,i,a,l){super(),this.f=r,this.g=i,this.h=l,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.a=new b(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(L.Event.any(L.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&a.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=s;class h{constructor(r,i,a,l,c,g,D,k,S,F,H,te,ce){this.a=r,this.b=i,this.c=a,this.overrideIdentifiers=l,this.d=c,this.f=g,this.g=D,this.h=k,this.i=S,this.j=F,this.k=H,this.l=te,this.m=ce}get value(){return d(this.c)}n(r,i,a){const l=r.inspect(i,a);return{get value(){return d(l.value)},get override(){return d(l.override)},get merged(){return d(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(r,i,a,l,c=new p,g=new p,D=new C.ResourceMap,k=new p,S=new C.ResourceMap){this.c=r,this.d=i,this.f=a,this.g=l,this.h=c,this.i=g,this.j=D,this.l=k,this.m=S,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(r,i,a){return this.q(r,i,a).getValue(r)}updateValue(r,i,a={}){let l;a.resource?(l=this.m.get(a.resource),l||(l=new p,this.m.set(a.resource,l))):l=this.l,i===void 0?l.removeValue(r):l.setValue(r,i),a.resource||(this.a=null)}inspect(r,i,a){const l=this.q(r,i,a),c=this.u(i.resource,a),g=i.resource?this.m.get(i.resource)||this.l:this.l,D=new Set;for(const k of l.overrides)for(const S of k.identifiers)l.getOverrideValue(r,S)!==void 0&&D.add(S);return new h(r,i,l.getValue(r),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,c||void 0,g)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const a=[];if(!i){const{added:l,updated:c,removed:g}=O(this.c,r);i=[...l,...c,...g]}for(const l of i)for(const c of(0,y.overrideIdentifiersFromKey)(l)){const g=this.c.getKeysForOverrideIdentifier(c),D=r.getKeysForOverrideIdentifier(c),k=[...D.filter(S=>g.indexOf(S)===-1),...g.filter(S=>D.indexOf(S)===-1),...g.filter(S=>!A.equals(this.c.override(c).getValue(S),r.override(c).getValue(S)))];a.push([c,k])}return this.updateDefaultConfiguration(r),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:a,removed:l}=O(this.d,r),c=[...i,...a,...l];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:a,removed:l,overrides:c}=O(this.applicationConfiguration,r),g=[...i,...a,...l];return g.length&&this.updateApplicationConfiguration(r),{keys:g,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:a,removed:l,overrides:c}=O(this.localUserConfiguration,r),g=[...i,...a,...l];return g.length&&this.updateLocalUserConfiguration(r),{keys:g,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:a,removed:l,overrides:c}=O(this.remoteUserConfiguration,r),g=[...i,...a,...l];return g.length&&this.updateRemoteUserConfiguration(r),{keys:g,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:a,removed:l,overrides:c}=O(this.workspaceConfiguration,r),g=[...i,...a,...l];return g.length&&this.updateWorkspaceConfiguration(r),{keys:g,overrides:c}}compareAndUpdateFolderConfiguration(r,i){const a=this.p.get(r),{added:l,updated:c,removed:g,overrides:D}=O(a,i),k=[...l,...c,...g];return(k.length||!a)&&this.updateFolderConfiguration(r,i),{keys:k,overrides:D}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:a,updated:l,removed:c,overrides:g}=O(i,void 0);return{keys:[...a,...l,...c],overrides:g}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,a){let l=this.r(i,a);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(l=l.merge(this.d)),l}r({resource:r},i){let a=this.s();if(i&&r){const l=i.getFolder(r);l&&(a=this.t(l.uri)||a);const c=this.m.get(r);c&&(a=a.merge(c))}return a}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const a=this.s(),l=this.j.get(r);l?(i=a.merge(l),this.b.set(r,i)):i=a}return i}u(r,i){if(i&&r){const a=i.getFolder(r);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:a,overrides:l,keys:c}=this.j.get(i);return r.push([i,{contents:a,overrides:l,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(a=>r.add(a))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(a=>r.add(a))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.i.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l))),[...i.values()]}static parse(r){const i=this.x(r.defaults),a=this.x(r.policy),l=this.x(r.application),c=this.x(r.user),g=this.x(r.workspace),D=r.folders.reduce((k,S)=>(k.set(m.URI.revive(S[0]),this.x(S[1])),k),new C.ResourceMap);return new u(i,a,l,c,new p,g,D,new p,new C.ResourceMap)}static x(r){return new p(r.contents,r.keys,r.overrides)}}e.Configuration=u;function f(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const l of n)l.keys.forEach(c=>r.add(c)),l.overrides.forEach(([c,g])=>{const D=(0,C.getOrSet)(i,c,new Set);g.forEach(k=>D.add(k))});const a=[];return i.forEach((l,c)=>a.push([c,[...l.values()]])),{keys:[...r.values()],overrides:a}}e.mergeChanges=f;class I{constructor(r,i,a,l){this.change=r,this.f=i,this.g=a,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const g of c)this.affectedKeys.add(g);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(r,i){const a=this.a+r,l=this.d.indexOf(a);if(l<0)return!1;const c=l+a.length;if(c>=this.d.length)return!1;const g=this.d.charCodeAt(c);if(g!==this.b&&g!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,k=this.g.getValue(r,i,this.h);return!A.equals(D,k)}return!0}}e.ConfigurationChangeEvent=I;function O(n,r){const{added:i,removed:a,updated:l}=t(r?.rawConfiguration,n?.rawConfiguration),c=[],g=n?.getAllOverrideIdentifiers()||[],D=r?.getAllOverrideIdentifiers()||[];if(r){const k=D.filter(S=>!g.includes(S));for(const S of k)c.push([S,r.getKeysForOverrideIdentifier(S)])}if(n){const k=g.filter(S=>!D.includes(S));for(const S of k)c.push([S,n.getKeysForOverrideIdentifier(S)])}if(r&&n){for(const k of g)if(D.includes(k)){const S=t({contents:n.getOverrideValue(void 0,k)||{},keys:n.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});c.push([k,[...S.added,...S.removed,...S.updated]])}}return{added:i,removed:a,updated:l,overrides:c}}function t(n,r){const i=n?r?n.keys.filter(c=>r.keys.indexOf(c)===-1):[...n.keys]:[],a=r?n?r.keys.filter(c=>n.keys.indexOf(c)===-1):[...r.keys]:[],l=[];if(n&&r){for(const c of r.keys)if(n.keys.indexOf(c)!==-1){const g=(0,T.getConfigurationValue)(r.contents,c),D=(0,T.getConfigurationValue)(n.contents,c);A.equals(g,D)||l.push(c)}}return{added:i,removed:a,updated:l}}}),define(ge[229],pe([1,0,18,6,2,21,8,113,54,12,67,40]),function(oe,e,w,L,o,P,C,A,v,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class E extends o.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new A.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:s,defaultsOverrides:h})=>this.c(Array.from(s),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(s,h){this.h(s,y.Registry.as(v.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:s})}f(){return{}}g(){this.b=new A.ConfigurationModel;const s=y.Registry.as(v.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(s),s)}h(s,h){const u=this.f();for(const f of s){const I=u[f],O=h[f];I!==void 0?this.b.addValue(f,I):O?this.b.addValue(f,O.default):this.b.removeValue(f)}}}e.DefaultConfiguration=E;class d{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new A.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let p=e.PolicyConfiguration=class extends o.Disposable{get configurationModel(){return this.b}constructor(s,h,u){super(),this.c=s,this.f=h,this.g=u,this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new A.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(s=>this.i(s))),this.B(this.c.onDidChangeConfiguration(async({properties:s})=>this.j(await this.h(s),!0))),this.b}async h(s){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",s);const h={},u=[],f=y.Registry.as(v.Extensions.Configuration).getConfigurationProperties();for(const I of s){const O=f[I];if(!O){u.push(I);continue}if(O.policy){if(O.type!=="string"&&O.type!=="number"){this.g.warn(`Policy ${O.policy.name} has unsupported type ${O.type}`);continue}u.push(I),h[O.policy.name]={type:O.type}}}return(0,C.isEmptyObject)(h)||await this.f.updatePolicyDefinitions(h),u}i(s){this.g.trace("PolicyConfiguration#onDidChangePolicies",s);const h=y.Registry.as(v.Extensions.Configuration).getPolicyConfigurations(),u=(0,w.coalesce)(s.map(f=>h.get(f)));this.j(u,!0)}j(s,h){this.g.trace("PolicyConfiguration#update",s);const u=y.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),f=[],I=this.b.isEmpty();for(const O of s){const t=u[O]?.policy?.name;if(t){const n=this.f.getPolicyValue(t);(I?n!==void 0:!(0,P.equals)(this.b.getValue(O),n))&&f.push([O,n])}else this.b.getValue(O)!==void 0&&f.push([O,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const O=this.b;this.b=new A.ConfigurationModel;for(const t of O.keys)this.b.setValue(t,O.getValue(t));for(const[t,n]of f)n===void 0?this.b.removeValue(t):this.b.setValue(t,n);h&&this.a.fire(this.b)}}};e.PolicyConfiguration=p=Le([Re(1,T.IPolicyService),Re(2,m.ILogService)],p)}),define(ge[114],pe([1,0,14,6,2,19,24,113,229,67]),function(oe,e,w,L,o,P,C,A,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends o.Disposable{constructor(E,d,p,b){super(),this.i=E,this.h=this.B(new L.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.DefaultConfiguration),this.c=p instanceof m.NullPolicyService?new v.NullPolicyConfiguration:this.B(new v.PolicyConfiguration(this.b,p,b)),this.f=this.B(new A.UserSettings(this.i,void 0,P.extUriBiasedIgnorePathCase,d)),this.a=new A.Configuration(this.b.configurationModel,this.c.configurationModel,new A.ConfigurationModel,new A.ConfigurationModel),this.g=this.B(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:h})=>this.k(s,h))),this.B(this.c.onDidChangeConfiguration(s=>this.l(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[E,d,p]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new A.Configuration(E,d,new A.ConfigurationModel,p)}getConfigurationData(){return this.a.toData()}getValue(E,d){const p=typeof E=="string"?E:void 0,b=(0,C.isConfigurationOverrides)(E)?E:(0,C.isConfigurationOverrides)(d)?d:{};return this.a.getValue(p,b,void 0)}updateValue(E,d,p,b){return Promise.reject(new Error("not supported"))}inspect(E){return this.a.inspect(E,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const E=await this.f.loadConfiguration();this.j(E)}j(E){const d=this.a.toData(),p=this.a.compareAndUpdateLocalUserConfiguration(E);this.m(p,d,2)}k(E,d){const p=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(E,d);this.m(b,p,7)}l(E){const d=this.a.toData(),p=this.a.compareAndUpdatePolicyConfiguration(E);this.m(p,d,7)}m(E,d,p){const b=new A.ConfigurationChangeEvent(E,{data:d},this.a);b.source=p,b.sourceConfig=this.n(p),this.h.fire(b)}n(E){switch(E){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(ge[115],pe([1,0,11,5]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var o;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(o||(e.RemoteAuthorityResolverErrorCode=o={}));class P extends w.ErrorNoTelemetry{static isNotAvailable(v){return v instanceof P&&v._code===o.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof P&&v._code===o.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof P&&v._code===o.NoResolverFound}static isHandled(v){return v instanceof P&&v.isHandled}constructor(v,m=o.Unknown,T){super(v),this._message=v,this._code=m,this._detail=T,this.isHandled=m===o.NotAvailable&&T===!0,Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P;function C(A){const v=A.indexOf("+");return v===-1?A:A.substring(0,v)}e.getRemoteAuthorityPrefix=C}),define(ge[230],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannelName=e.IRemoteExtensionsScannerService=void 0,e.IRemoteExtensionsScannerService=(0,w.createDecorator)("IRemoteExtensionsScannerService"),e.RemoteExtensionsScannerChannelName="remoteExtensionsScanner"}),define(ge[55],pe([1,0,13]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(m){return m.scheme===w.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=L;function o(m){if(!m)return;const T=m.indexOf("+");return T<0?m:m.substr(0,T)}e.getRemoteName=o;function P(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=P;function C(m){const{host:T,port:y}=v(m);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:y}}e.parseAuthorityWithPort=C;function A(m,T){let{host:y,port:E}=v(m);return typeof E>"u"&&(E=T),{host:y,port:E}}e.parseAuthorityWithOptionalPort=A;function v(m){const T=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const y=m.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const E=m.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:m,port:void 0}}}),define(ge[36],pe([1,0,17,5,55]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(C||(e.ExtensionType=C={}));var A;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class v{constructor(s){this.value=s,this.c=s.toLowerCase()}static equals(s,h){if(typeof s>"u"||s===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof s=="string"||typeof h=="string"){const u=typeof s=="string"?s:s.value,f=typeof h=="string"?h:h.value;return w.equalsIgnoreCase(u,f)}return s.c===h.c}static toKey(s){return typeof s=="string"?s.toLowerCase():s.c}}e.ExtensionIdentifier=v;class m{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const h of s)this.add(h)}add(s){this.c.add(v.toKey(s))}delete(s){return this.c.delete(v.toKey(s))}has(s){return this.c.has(v.toKey(s))}}e.ExtensionIdentifierSet=m;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(v.toKey(s))}get(s){return this.c.get(v.toKey(s))}has(s){return this.c.has(v.toKey(s))}set(s,h){this.c.set(v.toKey(s),h)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=T;function y(b){return E(b)}e.isApplicationScopedExtension=y;function E(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function d(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function p(b,s){if(s){const h=`onResolveRemoteAuthority:${(0,o.getRemoteName)(s)}`;return!!b.activationEvents?.includes(h)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[231],pe([1,0,11,36]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class o{constructor(){this.a=new Map,this.b=new WeakMap}register(C,A){this.a.set(C,A)}readActivationEvents(C){return this.b.has(C)||this.b.set(C,this.c(C)),this.b.get(C)}createActivationEventsMap(C){const A=Object.create(null);for(const v of C){const m=this.readActivationEvents(v);m.length>0&&(A[L.ExtensionIdentifier.toKey(v.identifier)]=m)}return A}c(C){if(typeof C.main>"u"&&typeof C.browser>"u")return[];const A=Array.isArray(C.activationEvents)?C.activationEvents.slice(0):[];if(!C.contributes)return A;for(const v in C.contributes){const m=this.a.get(v);if(!m)continue;const T=C.contributes[v],y=Array.isArray(T)?T:[T];try{m(y,A)}catch(E){(0,w.onUnexpectedError)(E)}}return A}}e.ImplicitActivationEventsImpl=o,e.ImplicitActivationEvents=new o}),define(ge[232],pe([1,0,2,36,16]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class P extends w.Disposable{constructor(A,v,m,T,y){super(),this.a=A,this.b=v,this.c=m,this.f=y,this.B(T.onDidInstallExtensions(E=>this.g(E))),this.B(T.onDidUninstallExtension(E=>this.h(E)))}g(A){for(const v of A)v.local&&this.invalidate(v.profileLocation)}h(A){A.error||this.invalidate(A.profileLocation)}async invalidate(A){if(A)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,A)&&await this.i(v);else await this.i(this.a.defaultProfile)}async i(A){try{await this.b.del(this.c.extUri.joinPath(A.cacheHome,L.USER_MANIFEST_CACHE_FILE))}catch(v){(0,o.toFileOperationResult)(v)!==1&&this.f.error(v)}}}e.ExtensionsManifestCache=P}),define(ge[43],pe([1,0,15,11,2,188,54,5,12,40]),function(oe,e,w,L,o,P,C,A,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");class T{constructor(O){this.b=O}toJSON(){if(!this.a){const O=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?O[t]="*****":O[t]=this.b[t];this.a=O}return this.a}}class y extends o.Disposable{constructor(O,t){super(),this.b=0,this.a=t.createLogger(O?"remotenetwork":"network",{name:O?(0,P.localize)(0,null):(0,P.localize)(1,null),when:v.CONTEXT_LOG_LEVEL.isEqualTo((0,v.LogLevelToString)(v.LogLevel.Trace)).serialize()})}async c(O,t,n){const r=`${O} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new T(t.headers??{}));try{const i=await n();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,L.getErrorMessage)(i)),i}}}e.AbstractRequestService=y;function E(I){return I.res.statusCode&&I.res.statusCode>=200&&I.res.statusCode<300||I.res.statusCode===1223}e.isSuccess=E;function d(I){return I.res.statusCode===204}async function p(I){return d(I)?null:(await(0,w.streamToBuffer)(I.stream)).toString()}e.asText=p;async function b(I){if(!E(I))throw new Error("Server returned "+I.res.statusCode);return p(I)}e.asTextOrError=b;async function s(I){if(!E(I))throw new Error("Server returned "+I.res.statusCode);if(d(I))return null;const t=(await(0,w.streamToBuffer)(I.stream)).toString();try{return JSON.parse(t)}catch(n){throw n.message+=`:
`+t,n}}e.asJson=s;function h(I){f(I)}e.updateProxyConfigurationsScope=h;let u;function f(I){const O=m.Registry.as(C.Extensions.Configuration),t=u;u={id:"http",order:15,title:(0,P.localize)(2,null),type:"object",scope:I,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(6,null),(0,P.localize)(7,null),(0,P.localize)(8,null),(0,P.localize)(9,null)],default:"override",description:(0,P.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(11,null),restricted:!0}}},O.updateConfigurations({add:[u],remove:t?[t]:[]})}f(1)}),define(ge[233],pe([1,0,20,13,16,43]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let C=e.DownloadService=class{constructor(v,m){this.a=v,this.b=m}async download(v,m,T=w.CancellationToken.None){if(v.scheme===L.Schemas.file||v.scheme===L.Schemas.vscodeRemote){await this.b.copy(v,m);return}const y={type:"GET",url:v.toString(!0)},E=await this.a.request(y,T);if(E.res.statusCode===200)await this.b.writeFile(m,E.stream);else{const d=await(0,P.asTextOrError)(E);throw new Error(`Expected 200, got back ${E.res.statusCode} instead.

${d}`)}}};e.DownloadService=C=Le([Re(0,P.IRequestService),Re(1,o.IFileService)],C)}),define(ge[234],pe([1,0,15,20]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class o{constructor(A){this.a=A}listen(A,v){throw new Error("Invalid listen")}call(A,v,m,T=L.CancellationToken.None){switch(v){case"request":return this.a.request(m[0],T).then(async({res:y,stream:E})=>{const d=await(0,w.streamToBuffer)(E);return[{statusCode:y.statusCode,headers:y.headers},d]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=o;class P{constructor(A){this.a=A}async request(A,v){const[m,T]=await this.a.call("request",[A],v);return{res:m,stream:(0,w.bufferToStream)(T)}}async resolveProxy(A){return this.a.call("resolveProxy",[A])}}e.RequestChannelClient=P}),define(ge[235],pe([1,0,83,8]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function o(C,A){return C.protocol==="http:"?A.HTTP_PROXY||A.http_proxy||null:C.protocol==="https:"&&(A.HTTPS_PROXY||A.https_proxy||A.HTTP_PROXY||A.http_proxy)||null}async function P(C,A,v={}){const m=(0,w.parse)(C),T=v.proxyUrl||o(m,A);if(!T)return null;const y=(0,w.parse)(T);if(!/^https?:$/.test(y.protocol||""))return null;const E={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,L.isBoolean)(v.strictSSL)?v.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((d,p)=>{oe(["http-proxy-agent"],d,p)}))(E):new(await new Promise((d,p)=>{oe(["https-proxy-agent"],d,p)}))(E)}e.getProxyAgent=P}),define(ge[84],pe([1,0,51,7,189,20,38,11,3,22,164,206,14,143]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let p;async function b(h,u,f,I){return f["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(I)&&!f["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(I)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=E.Promises.withAsyncBody(async(O,t)=>{const n=new P.CancellationTokenSource;let r=1e4;const i=h.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,d.clamp)(i,1,120)*1e3);const a=setTimeout(()=>{n.dispose(!0),t(new Error((0,o.localize)(0,null)))},r);try{O(await s(u,n.token))}catch(l){!(0,A.isCancellationError)(l)&&!n.token.isCancellationRequested?t(new Error((0,o.localize)(1,null,(0,C.toErrorMessage)(l)))):O({})}finally{clearTimeout(a),n.dispose()}})),p)}e.getResolvedShellEnv=b;async function s(h,u){const f=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",f);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",I);const O=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(O+"({.*})"+O),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",n);const r=await(0,T.getSystemShell)(v.OS,n);return h.trace("getUnixShellEnvironment#shell",r),new Promise((i,a)=>{if(u.isCancellationRequested)return a(new A.CancellationError);const l=(0,L.basename)(r);let c,g;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(c=`& '${process.execPath}' ${D} -p '''${O}'' + JSON.stringify(process.env) + ''${O}'''`,g=["-Login","-Command"]):(c=`'${process.execPath}' ${D} -p '"${O}" + JSON.stringify(process.env) + "${O}"'`,l==="tcsh"||l==="csh"?g=["-ic"]:g=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),c);const k=(0,w.spawn)(r,[...g,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});u.onCancellationRequested(()=>(k.kill(),a(new A.CancellationError))),k.on("error",H=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(H)),a(H)});const S=[];k.stdout.on("data",H=>S.push(H));const F=[];k.stderr.on("data",H=>F.push(H)),k.on("close",(H,te)=>{const ce=Buffer.concat(S).toString("utf8");h.trace("getUnixShellEnvironment#raw",ce);const le=Buffer.concat(F).toString("utf8");if(le.trim()&&h.trace("getUnixShellEnvironment#stderr",le),H||te)return a(new Error((0,o.localize)(2,null,H,te)));const ue=t.exec(ce),ve=ue?ue[1]:"{}";try{const K=JSON.parse(ve);f?K.ELECTRON_RUN_AS_NODE=f:delete K.ELECTRON_RUN_AS_NODE,I?K.ELECTRON_NO_ATTACH_CONSOLE=I:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.VSCODE_RESOLVING_ENVIRONMENT,delete K.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",K),i(K)}catch(K){h.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(K)),a(K)}})})}}),define(ge[236],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,w.createDecorator)("stateReadService"),e.IStateService=(0,w.createDecorator)("stateService")}),define(ge[237],pe([1,0,14,15,8,25,16,12]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var v;(function(E){E[E.IMMEDIATE=0]="IMMEDIATE",E[E.DELAYED=1]="DELAYED"})(v||(e.SaveStrategy=v={}));class m{constructor(d,p,b,s){this.f=d,this.g=b,this.h=s,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=p===0?void 0:new w.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.g.error(d)}}getItem(d,p){const b=this.a[d];return(0,o.isUndefinedOrNull)(b)?p:b}setItem(d,p){this.setItems([{key:d,data:p}])}setItems(d){let p=!1;for(const{key:b,data:s}of d)this.a[b]!==s&&((0,o.isUndefinedOrNull)(s)?(0,o.isUndefined)(this.a[b])||(this.a[b]=void 0,p=!0):(this.a[b]=s,p=!0));p&&this.j()}removeItem(d){(0,o.isUndefined)(this.a[d])||(this.a[d]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.h.writeFile(this.f,L.VSBuffer.fromString(d)),this.b=d}catch(p){this.g.error(p)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=m;let T=e.StateReadonlyService=class{constructor(d,p,b,s){this.a=new m(p.stateResource,d,b,s)}async init(){await this.a.init()}getItem(d,p){return this.a.getItem(d,p)}};e.StateReadonlyService=T=Le([Re(1,P.IEnvironmentService),Re(2,A.ILogService),Re(3,C.IFileService)],T);class y extends T{setItem(d,p){this.a.setItem(d,p)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.StateService=y}),define(ge[116],pe([1,0,3,29,22]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(v){if(w.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}function C(v,m,T,y,E,d,p,b){const s=Object.create(null);s["common.machineId"]=d,s.sessionID=(0,o.generateUuid)()+Date.now(),s.commitHash=y,s.version=E,s["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,w.PlatformToString)(w.platform),s["common.nodePlatform"]=L.platform,s["common.nodeArch"]=T,s["common.product"]=b||"desktop",p&&(s["common.msftInternal"]=p);let h=0;const u=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),w.isLinuxSnap&&(s["common.snap"]="true");const f=P(m);return f&&(s["common.platformDetail"]=f),s}e.resolveCommonProperties=C;function A(v){const m=L.env.USERDNSDOMAIN;if(!m)return!1;const T=m.toLowerCase();return v.some(y=>T===y)}e.verifyMicrosoftInternalDomain=A}),define(ge[238],pe([1,0,18,11,2,21,16]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var A;(function(m){function T(y,E){return y.callstack<E.callstack?-1:y.callstack>E.callstack?1:0}m.compare=T})(A||(e.ErrorEvent=A={}));class v{constructor(T,y=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new o.DisposableStore,this.c=T,this.d=y;const E=L.errorHandler.addListener(d=>this.j(d));this.h.add((0,o.toDisposable)(E)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(T){if(!T||(T.detail&&T.detail.stack&&(T=T.detail),L.ErrorNoTelemetry.isErrorNoTelemetry(T)||T instanceof C.FileOperationError||T?.message?.includes("Unable to read file")))return;const y=Array.isArray(T.stack)?T.stack.join(`
`):T.stack,E=T.message?T.message:(0,P.safeStringify)(T);y&&this.k({msg:E,callstack:y})}k(T){const y=(0,w.binarySearch)(this.g,T,A.compare);y<0?(T.count=1,this.g.splice(~y,0,T)):(this.g[y].count||(this.g[y].count=0),this.g[y].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const T of this.g)this.c.publicLogError2("UnhandledError",T);this.g.length=0}}v.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=v}),define(ge[239],pe([1,0,2]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class L extends w.Disposable{constructor(P,C){super(),this.a=P,this.b=C}async call(P,C,A){switch(C){case"updateTelemetryLevel":{const{telemetryLevel:v}=A;return this.a.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:m}=A;return this.b?this.b.log(v,m):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${C} not found`)}listen(P,C,A){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=L}),define(ge[31],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var o;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(o||(e.TelemetryConfiguration=o={}))}),define(ge[240],pe([1,0,28,14,72,13,7,3,4,99,23,102,212,16,26,31]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const s=new Map;async function h(t,n){const r=`${t}::${n.join(":")}`,i=s.get(r);if(i)return i;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,c=new Map,g=2e4;function D(S,F,H,te){const ce=F.substring(S.length+1);return L.Promises.withAsyncBody(async le=>{let ue;try{ue=await T.Promises.readdir(F,{withFileTypes:!0})}catch{le();return}if(te.count>=g){te.count+=ue.length,te.maxReached=!0,le();return}let ve=ue.length;if(ve===0){le();return}let K=ue;te.count+ue.length>g&&(te.maxReached=!0,ve=g-te.count,K=ue.slice(0,ve)),te.count+=ue.length;for(const ee of K)if(ee.isDirectory()){if(H.includes(ee.name)||await D(S,(0,C.join)(F,ee.name),H,te),--ve===0){le();return}}else{const z=ee.name.lastIndexOf(".");if(z>=0){const q=ee.name.substring(z+1);q&&l.set(q,(l.get(q)??0)+1)}for(const q of a)q.relativePathPattern?.test(ce)!==!1&&q.filePattern.test(ee.name)&&c.set(q.tag,(c.get(q.tag)??0)+1);if(--ve===0){le();return}}})}const k=L.Promises.withAsyncBody(async S=>{const F={count:0,maxReached:!1};await D(t,t,n,F);const H=await I(t);S({configFiles:u(c),fileTypes:u(l),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:H})});return s.set(r,k),k}e.collectWorkspaceStats=h;function u(t){return Array.from(t.entries(),([n,r])=>({name:n,count:r})).sort((n,r)=>r.count-n.count)}function f(){const t={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},n=w.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=f;async function I(t){try{const n=new Map,r=(0,C.join)(t,".vscode","launch.json"),i=await T.Promises.readFile(r),a=[],l=(0,o.parse)(i.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,o.getNodeType)(l)==="object"&&l.configurations)for(const c of l.configurations){const g=c.type;g&&(n.has(g)?n.set(g,n.get(g)+1):n.set(g,1))}return u(n)}catch{return[]}}e.collectLaunchConfigs=I;let O=e.DiagnosticsService=class{constructor(n,r){this.c=n,this.d=r}f(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}g(n){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const i=w.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(w.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),A.isWindows||r.push(`Load (avg):       ${w.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,y.listProcesses)(n.mainPID),this.k(n)]).then(async i=>{let[a,l]=i,c=this.m(n,a);return r.forEach(g=>{if((0,E.isRemoteDiagnosticError)(g))c+=`
${g.errorMessage}`,l+=`
${g.errorMessage}`;else if(c+=`

Remote: ${g.hostName}`,g.processes&&(c+=`
${this.m(n,g.processes)}`),g.workspaceMetadata){l+=`
|  Remote: ${g.hostName}`;for(const D of Object.keys(g.workspaceMetadata)){const k=g.workspaceMetadata[D];let S=`${k.fileCount} files`;k.maxFilesReached&&(S=`more than ${S}`),l+=`|    Folder (${D}): ${S}`,l+=this.h(k)}}}),{processInfo:c,workspaceInfo:l}})}async getSystemInfo(n,r){const{memory:i,vmHint:a,os:l,cpus:c}=f(),g={os:l,memory:i,cpus:c,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return A.isWindows||(g.load=`${w.loadavg().map(D=>Math.round(D)).join(", ")}`),A.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(n,r){const i=[];return(0,y.listProcesses)(n.mainPID).then(async a=>(i.push(""),i.push(this.g(n)),i.push(""),i.push(this.m(n,a)),n.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(n))),r.forEach(l=>{if((0,E.isRemoteDiagnosticError)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.f(l.machineInfo)),l.processes&&i.push(this.m(n,l.processes)),l.workspaceMetadata)for(const c of Object.keys(l.workspaceMetadata)){const g=l.workspaceMetadata[c];let D=`${g.fileCount} files`;g.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${c}): ${D}`),i.push(this.h(g))}}),i.push(""),i.push(""),i.join(`
`)))}h(n){const r=[];let a=0;const l=(k,S)=>{const F=` ${k}(${S})`;a+F.length>60?(r.push(c),c="|                 ",a=c.length):a+=F.length,c+=F};let c="|      File types:";const g=10,D=n.fileTypes.length>g?g:n.fileTypes.length;for(let k=0;k<D;k++){const S=n.fileTypes[k];l(S.name,S.count)}if(r.push(c),n.configFiles.length>=0&&(c="|      Conf files:",a=0,n.configFiles.forEach(k=>{l(k.name,k.count)}),r.push(c)),n.launchConfigFiles.length>0){let k="|      Launch Configs:";n.launchConfigFiles.forEach(S=>{const F=S.count>1?` ${S.name}(${S.count})`:` ${S.name}`;k+=F}),r.push(k)}return r.join(`
`)}j(n){const r=Math.max(...Object.keys(n).map(i=>i.length));return Object.keys(n).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${n[i]}`).join(`
                  `)}k(n){const r=[],i=[];return n.windows.forEach(a=>{a.folderURIs.length===0||a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const c=v.URI.revive(l);if(c.scheme===P.Schemas.file){const g=c.fsPath;i.push(h(g,["node_modules",".git"]).then(D=>{let k=`${D.fileCount} files`;D.maxFilesReached&&(k=`more than ${k}`),r.push(`|    Folder (${(0,C.basename)(g)}): ${k}`),r.push(this.h(D))}).catch(D=>{r.push(`|      Error: Unable to collect workspace stats for folder ${g} (${D.toString()})`)}))}else r.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(n,r){const i=new Map;n.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),n.pidToNames.forEach(({pid:l,name:c})=>i.set(l,c));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.n(n.mainPID,i,a,r,0),a.join(`
`)}n(n,r,i,a,l){const c=l===0;let g;c?g=a.pid===n?`${this.d.applicationName} main`:"remote agent":r.has(a.pid)?g=r.get(a.pid):g=`${"  ".repeat(l)} ${a.name}`;const D=process.platform==="win32"?a.mem:w.totalmem()*(a.mem/100);i.push(`${a.load.toFixed(0).padStart(5," ")}	${(D/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(a.children)&&a.children.forEach(k=>this.n(n,r,i,k,l+1))}async getWorkspaceFileExtensions(n){const r=new Set;for(const{uri:i}of n.folders){const a=v.URI.revive(i);if(a.scheme!==P.Schemas.file)continue;const l=a.fsPath;try{(await h(l,["node_modules",".git"])).fileTypes.forEach(g=>r.add(g.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const i=v.URI.revive(r);if(i.scheme!==P.Schemas.file)continue;const a=i.fsPath;try{const l=await h(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),l.fileTypes.forEach(c=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:c.name,count:c.count})}),l.launchConfigFiles.forEach(c=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:c.name,count:c.count})}),l.configFiles.forEach(c=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};e.DiagnosticsService=O=Le([Re(0,b.ITelemetryService),Re(1,p.IProductService)],O)}),define(ge[37],pe([1,0,21,8,6,24,55,116,31]),function(oe,e,w,L,o,P,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class T{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class y{async publicLog(a,l,c){}async publicLogError(a,l,c){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(i,a){return o.Event.debounce(a.onDidChangeConfiguration,(c,g)=>{const D=c?new Set([...c.affectedKeys,...g.affectedKeys]):g.affectedKeys;return{...g,affectedKeys:D}},1e3,!0)(c=>{c.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=E;function d(i,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!i.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=d;function p(i,a){return!(a.isBuilt||a.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=p;function b(i){const a=i.getValue(v.TELEMETRY_SETTING_ID),l=i.getValue(v.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(v.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function s(i){const a={},l={},c={};f(i,c);for(let g in c){g=g.length>150?g.substr(g.length-149):g;const D=c[g];typeof D=="number"?l[g]=D:typeof D=="boolean"?l[g]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${D.length}`),a[g]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(a[g]=D)}return{properties:a,measurements:l}}e.validateTelemetryData=s;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const a=(0,C.getRemoteName)(i);return h.has(a)?a:"other"}e.cleanRemoteAuthority=u;function f(i,a,l=0,c){if(i)for(const g of Object.getOwnPropertyNames(i)){const D=i[g],k=c?c+g:g;Array.isArray(D)?a[k]=(0,w.safeStringify)(D):D instanceof Date?a[k]=D.toISOString():(0,L.isObject)(D)?l<2?f(D,a,l+1,k+"."):a[k]=(0,w.safeStringify)(D):a[k]=D}}function I(i,a){const l=i.msftInternalDomains||[],c=a.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(l)||c}e.isInternalTelemetry=I;function O(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=O;function t(i,a){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let l=i;const c=[];for(const S of a)for(;;){const F=S.exec(i);if(!F)break;c.push([F.index,S.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(l="";;){const S=D.exec(i);if(!S)break;const F=c.some(([H,te])=>S.index<te&&H<D.lastIndex);!g.test(S[0])&&!F&&(l+=i.substring(k,S.index)+"<REDACTED: user-file-path>",k=D.lastIndex)}return k<i.length&&(l+=i.substr(k)),l}function n(i){if(!i)return i;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of a)if(l.regex.test(i))return`<REDACTED: ${l.label}>`;return i}function r(i,a){return(0,w.cloneAndChange)(i,l=>{if(l instanceof m||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let c=l.replaceAll("%20"," ");c=t(c,a);for(const g of a)c=c.replace(g,"");return c=n(c),c}})}e.cleanData=r}),define(ge[34],pe([1,0,17,30,36,3,4,11,29,37]),function(oe,e,w,L,o,P,C,A,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,w.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=T;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(i){const a=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new E(i.identifier,a,l)}static parse(i){const a=y.exec(i);return a&&a[1]&&a[2]?new E({id:a[1]},a[2],a[4]||void 0):null}constructor(i,a,l="undefined"){this.version=a,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof E?T(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=E;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const i=d.exec(r);return i&&i[1]?[s(i[1]),i[2]]:[s(r),void 0]}e.getIdAndVersion=p;function b(r,i){return`${r}.${i}`}e.getExtensionId=b;function s(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=s;function h(r,i){return s(b(r??o.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=h;function u(r,i){const a=[],l=c=>{for(const g of a)if(g.some(D=>T(i(D),i(c))))return g;return null};for(const c of r){const g=l(c);g?g.push(c):a.push([c])}return a}e.groupByExtension=u;function f(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=f;function I(r){return{id:new m.TelemetryTrustedValue(r.identifier.id),name:new m.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new o.ExtensionIdentifier("pprice.better-merge");function O(r,i){const a=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const c=l.shift();if(c&&a.every(g=>!T(g.identifier,{id:c}))){const g=r.filter(D=>T(D.identifier,{id:c}));g.length===1&&(a.push(g[0]),l.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=O;async function t(r,i){if(!P.isLinux)return!1;let a;try{a=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(c))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,i){const a=await t(r,i),l=(0,L.getTargetPlatform)(a?"alpine":P.platform,v.arch);return i.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=n}),define(ge[117],pe([1,0,20,11,13,19,52,4,176,30,34,36]),function(oe,e,w,L,o,P,C,A,v,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const E=s=>(0,v.localize)(0,null,s),d=(0,v.localize)(1,null,"ms-dotnettools.csharp");function p(s,h){return h?`${s.publisher}.${s.name}@${s.version}`:`${s.publisher}.${s.name}`}let b=e.ExtensionManagementCLI=class{constructor(h,u,f){this.a=h,this.b=u,this.d=f}get f(){}async listExtensions(h,u,f){let I=await this.b.getInstalled(1,f);const O=y.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(u&&u!==""){if(O.indexOf(u.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}I=I.filter(n=>n.manifest.categories?n.manifest.categories.map(i=>i.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){this.a.info("Possible Categories: "),O.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,v.localize)(2,null,this.f)),I=I.sort((n,r)=>n.identifier.id.localeCompare(r.identifier.id));let t;for(const n of I)t!==n.identifier.id&&(t=n.identifier.id,this.a.info(p(n.manifest,h)))}async installExtensions(h,u,f,I){const O=[];try{const t=[];h.length&&this.a.info(this.f?(0,v.localize)(3,null,this.f):(0,v.localize)(4,null));const n=[];let r=[];const i=(l,c,g)=>{r.push({id:l,version:c!=="prerelease"?c:void 0,installOptions:{...f,isBuiltin:g,installPreReleaseVersion:c==="prerelease"||f.installPreReleaseVersion}})};for(const l of h)if(l instanceof A.URI)n.push({vsix:l,installOptions:f});else{const[c,g]=(0,T.getIdAndVersion)(l);i(c,g,!1)}for(const l of u)if(l instanceof A.URI)n.push({vsix:l,installOptions:{...f,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,g]=(0,T.getIdAndVersion)(l);i(c,g,!0)}const a=await this.b.getInstalled(1,f.profileLocation);if(n.length&&await Promise.all(n.map(async({vsix:l,installOptions:c})=>{try{const g=await this.g(l,c,I,a);g&&t.push(g)}catch(g){this.a.error(g),O.push(l.toString())}})),r.length&&(r=r.filter(({id:l,version:c})=>{const g=a.find(D=>(0,T.areSameExtensions)(D.identifier,{id:l}));if(g){if(!I&&(!c||c==="prerelease"&&g.preRelease))return this.a.info((0,v.localize)(5,null,l,g.manifest.version,l)),!1;if(c&&g.manifest.version===c)return this.a.info((0,v.localize)(6,null,`${l}@${c}`)),!1}return!0}),r.length)){const l=await this.h(r);await Promise.all(r.map(async c=>{const g=l.get(c.id.toLowerCase());if(g)try{const D=await this.j(c,g,a);D&&t.push(D)}catch(D){this.a.error(D.message||D.stack||D),O.push(c.id)}else this.a.error(`${E(c.version?`${c.id}@${c.version}`:c.id)}
${d}`),O.push(c.id)}))}}catch(t){throw this.a.error((0,v.localize)(7,null,(0,L.getErrorMessage)(t))),t}if(O.length)throw new Error((0,v.localize)(8,null,O.join(", ")))}async g(h,u,f,I){const O=await this.b.getManifest(h);if(!O)throw new Error("Invalid vsix");if(await this.l(O,f,u.profileLocation,I))try{return await this.b.install(h,u),this.a.info((0,v.localize)(9,null,(0,P.basename)(h))),O}catch(n){if((0,L.isCancellationError)(n))return this.a.info((0,v.localize)(10,null,(0,P.basename)(h))),null;throw n}return null}async h(h){const u=new Map,f=h.some(t=>t.installOptions.installPreReleaseVersion),I=await this.b.getTargetPlatform(),O=[];for(const t of h)m.EXTENSION_IDENTIFIER_REGEX.test(t.id)&&O.push({...t,preRelease:f});if(O.length){const t=await this.d.getExtensions(O,{targetPlatform:I},w.CancellationToken.None);for(const n of t)u.set(n.identifier.id.toLowerCase(),n)}return u}async j({id:h,version:u,installOptions:f},I,O){const t=await this.d.getManifest(I,w.CancellationToken.None);if(t&&!this.k(t))return null;const n=O.find(r=>(0,T.areSameExtensions)(r.identifier,I.identifier));if(n){if(I.version===n.manifest.version)return this.a.info((0,v.localize)(11,null,u?`${h}@${u}`:h)),null;this.a.info((0,v.localize)(12,null,h,I.version))}try{f.isBuiltin?this.a.info(u?(0,v.localize)(13,null,h,u):(0,v.localize)(14,null,h)):this.a.info(u?(0,v.localize)(15,null,h,u):(0,v.localize)(16,null,h));const r=await this.b.installFromGallery(I,{...f,installGivenVersion:!!u});return this.a.info((0,v.localize)(17,null,h,r.manifest.version)),t}catch(r){if((0,L.isCancellationError)(r))return this.a.info((0,v.localize)(18,null,h)),null;throw r}}k(h){return!0}async l(h,u,f,I){if(!u){const O={id:(0,T.getGalleryExtensionId)(h.publisher,h.name)},t=I.find(n=>(0,T.areSameExtensions)(O,n.identifier)&&(0,C.gt)(n.manifest.version,h.version));if(t)return this.a.info((0,v.localize)(19,null,t.identifier.id,t.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,u,f){const I=async t=>{if(t instanceof A.URI){const n=await this.b.getManifest(t);return p(n)}return t},O=[];for(const t of h){const n=await I(t),i=(await this.b.getInstalled(void 0,f)).filter(a=>(0,T.areSameExtensions)(a.identifier,{id:n}));if(!i.length)throw new Error(`${this.m(n)}
${d}`);if(i.some(a=>a.type===0)){this.a.info((0,v.localize)(20,null,n));return}if(!u&&i.some(a=>a.isBuiltin)){this.a.info((0,v.localize)(21,null,n));return}this.a.info((0,v.localize)(22,null,n));for(const a of i)await this.b.uninstall(a,{profileLocation:f}),O.push(a);this.f?this.a.info((0,v.localize)(23,null,n,this.f)):this.a.info((0,v.localize)(24,null,n))}}async locateExtension(h){const u=await this.b.getInstalled();h.forEach(f=>{u.forEach(I=>{if(I.identifier.id===f&&I.location.scheme===o.Schemas.file){this.a.info(I.location.fsPath);return}})})}m(h){return this.f?(0,v.localize)(25,null,h,this.f):(0,v.localize)(26,null,h)}};e.ExtensionManagementCLI=b=Le([Re(1,m.IExtensionManagementService),Re(2,m.IExtensionGalleryService)],b)}),define(ge[241],pe([1,0,6,2,27,34,36]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class A extends L.Disposable{constructor(m,T,y,E,d,p,b){super(),this.f=m,this.g=T,this.h=y,this.i=E,this.j=d,this.k=p,this.l=b,this.a=this.B(new w.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.DisposableMap),this.m().then(null,s=>b.error(s))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(m=>this.p(m.added,m.removed))),this.B(this.i.onAddExtensions(m=>this.r(m))),this.B(this.i.onDidAddExtensions(m=>this.s(m))),this.B(this.i.onRemoveExtensions(m=>this.t(m))),this.B(this.i.onDidRemoveExtensions(m=>this.u(m))),this.B(this.k.onDidFilesChange(m=>this.v(m)))}async p(m,T){try{await Promise.all(T.map(y=>(this.c.deleteAndDispose(y.id),this.z(y.extensionsResource)))),m.length&&await Promise.all(m.map(y=>(this.c.set(y.id,(0,L.combinedDisposable)(this.k.watch(this.j.extUri.dirname(y.extensionsResource)),this.k.watch(y.extensionsResource))),this.y(y.extensionsResource))))}catch(y){throw this.l.error(y),y}}async r(m){for(const T of m.extensions)this.D(this.G(T.identifier,T.version),m.profileLocation)}async s(m){for(const T of m.extensions){const y=this.G(T.identifier,T.version);m.error?this.F(y,m.profileLocation):this.D(y,m.profileLocation)}}async t(m){for(const T of m.extensions)this.F(this.G(T.identifier,T.version),m.profileLocation)}async u(m){const T=[],y=[];for(const E of m.extensions){const d=this.G(E.identifier,E.version);m.error?this.D(d,m.profileLocation):(this.F(d,m.profileLocation),this.b.has(d)||(this.l.debug("Extension is removed from all profiles",E.identifier.id,E.version),y.push(this.f.scanInstalledExtensionAtLocation(E.location).then(p=>{p?T.push(p):this.l.info("Extension not found at the location",E.location.toString())},p=>this.l.error(p)))))}try{await Promise.all(y),T.length&&await this.C(T)}catch(E){this.l.error(E)}}v(m){for(const T of this.h.profiles)m.contains(T.extensionsResource,0,1)&&this.w(T.extensionsResource)}async w(m){const T=[],y=[],E=await this.i.scanProfileExtensions(m),d=new Set,p=new Set;for(const[b,s]of this.b)s.has(m)&&p.add(b);for(const b of E){const s=this.G(b.identifier,b.version);d.add(s),p.has(s)||(T.push(b.identifier),this.D(s,m))}for(const b of p)if(!d.has(b)){const s=this.H(b);s&&(y.push(s.identifier),this.F(b,m))}(T.length||y.length)&&this.a.fire({added:T.length?{extensions:T,profileLocation:m}:void 0,removed:y.length?{extensions:y,profileLocation:m}:void 0})}async y(m){const T=await this.i.scanProfileExtensions(m);for(const y of T)this.D(this.G(y.identifier,y.version),m)}async z(m){for(const T of[...this.b.keys()])this.F(T,m);await this.C()}async C(m){m||(m=(await this.f.scanAllUserInstalledExtensions()).filter(y=>!this.b.has(this.G(y.identifier,y.manifest.version)))),m.length&&await this.f.markAsUninstalled(...m)}D(m,T){let y=this.b.get(m);y||this.b.set(m,y=new o.ResourceSet(E=>this.j.extUri.getComparisonKey(E))),y.add(T)}F(m,T){const y=this.b.get(m);y&&y.delete(T),y?.size||this.b.delete(m)}G(m,T){return`${C.ExtensionIdentifier.toKey(m.id)}@${T}`}H(m){const[T,y]=(0,P.getIdAndVersion)(m);return y?{identifier:{id:T},version:y}:void 0}}e.ExtensionsWatcher=A}),define(ge[242],pe([1,0,209,37]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function o(P,C,A,v,m,T,y){const E={"X-Market-Client-Id":`VSCode ${P}`,"User-Agent":`VSCode ${P} (${C.nameShort})`};if((0,L.supportsTelemetry)(C,A)&&(0,L.getTelemetryLevel)(v)===3){const d=await(0,w.getServiceMachineId)(A,m,T);E["X-Market-User-Id"]=d,E["VSCode-SessionId"]=y.machineId||d}return E}e.resolveMarketplaceHeaders=o}),define(ge[118],pe([1,0,85,18,14,2,13,7,23,25,30,34,12,82,4]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let b=e.NativeLanguagePackService=class extends d.LanguagePackBaseService{constructor(f,I,O,t){super(O),this.h=f,this.i=t,this.g=this.B(new s(I,t)),this.h.registerParticipant({postInstall:async n=>this.j(n),postUninstall:async n=>this.k(n)})}async getBuiltInExtensionTranslationsUri(f,I){const t=(await this.g.getLanguagePacks())[I];if(!t){this.i.warn(`No language pack found for ${I}`);return}const n=t.translations[f];return n?p.URI.file(n):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),I=Object.keys(f).map(O=>{const t=f[O];return{...this.f(O,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return I.push(this.f("en","English")),I.sort((O,t)=>O.label.localeCompare(t.label)),I}async j(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",f.identifier.id),await this.update())}async k(f){const I=await this.g.getLanguagePacks();Object.keys(I).some(O=>I[O]&&I[O].extensions.some(t=>(0,y.areSameExtensions)(t.extensionIdentifier,f.identifier)))&&(this.i.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,I]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),O=await this.g.update(I);return!(0,L.equals)(Object.keys(f),Object.keys(O))}};e.NativeLanguagePackService=b=Le([Re(0,T.IExtensionManagementService),Re(1,m.INativeEnvironmentService),Re(2,T.IExtensionGalleryService),Re(3,E.ILogService)],b);let s=class extends P.Disposable{constructor(f,I){super(),this.i=I,this.c={},this.f=(0,A.join)(f.userDataPath,"languagepacks.json"),this.g=new o.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.m(I=>{Object.keys(I).forEach(O=>delete I[O]),this.j(I,...f)}).then(()=>this.c)}j(f,...I){for(const O of I)O&&O.manifest&&O.manifest.contributes&&O.manifest.contributes.localizations&&O.manifest.contributes.localizations.length&&this.k(f,O);Object.keys(f).forEach(O=>this.l(f[O]))}k(f,I){const O=I.identifier,t=I.manifest.contributes&&I.manifest.contributes.localizations?I.manifest.contributes.localizations:[];for(const n of t)if(I.location.scheme===C.Schemas.file&&h(n)){let r=f[n.languageId];r||(r={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},f[n.languageId]=r);const i=r.extensions.filter(a=>(0,y.areSameExtensions)(a.extensionIdentifier,O))[0];i?i.version=I.manifest.version:r.extensions.push({extensionIdentifier:O,version:I.manifest.version});for(const a of n.translations)r.translations[a.id]=(0,A.join)(I.location.fsPath,a.path)}}l(f){if(f){const I=(0,w.createHash)("md5");for(const O of f.extensions)I.update(O.extensionIdentifier.uuid||O.extensionIdentifier.id).update(O.version);f.hash=I.digest("hex")}}m(f=()=>null){return this.g.queue(()=>{let I=null;return v.Promises.readFile(this.f,"utf8").then(void 0,O=>O.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(O)).then(O=>{try{return JSON.parse(O)}catch{return{}}}).then(O=>(I=f(O),O)).then(O=>{for(const n of Object.keys(O))O[n]||delete O[n];this.c=O,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),v.Promises.writeFile(this.f,t)}).then(()=>I,O=>this.i.error(O))})}};s=Le([Re(0,m.INativeEnvironmentService),Re(1,E.ILogService)],s);function h(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const f of u.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ge[243],pe([1,0,11,21,37]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const P="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function A(m,T,y){const E=await new Promise((h,u)=>{oe(["@microsoft/1ds-core-js"],h,u)}),d=await new Promise((h,u)=>{oe(["@microsoft/1ds-post-js"],h,u)}),p=new E.AppInsightsCore,b=new d.PostChannel,s={instrumentationKey:m,endpointUrl:P,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(y){s.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:y};s.extensionConfig[b.identifier]=h}return p.initialize(s,[]),p.addTelemetryInitializer(h=>{T&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),p}class v{constructor(T,y,E,d,p){this.e=T,this.f=y,this.g=E,this.h=p,this.c=P,this.d=C,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(T){if(this.a){if(typeof this.a!="string"){T(this.a);return}this.b||(this.b=A(this.a,this.e,this.h)),this.b.then(y=>{T(y)},y=>{(0,w.onUnexpectedError)(y),console.error(y)})}}log(T,y){if(!this.a)return;y=(0,L.mixin)(y,this.g),y=(0,o.validateTelemetryData)(y);const E=this.f+"/"+T;try{this.i(d=>{d.pluginVersionString=y?.properties.version??"Unknown",d.track({name:E,baseData:{name:E,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(T=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,T(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=v}),define(ge[244],pe([1,0,2,21,3,17,190,24,54,53,26,40,31,37]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=e.TelemetryService=class{constructor(h,u,f){this.k=u,this.l=f,this.d={},this.i=new w.DisposableStore,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const I of this.f)this.j.push(new RegExp((0,P.escapeRegExpCharacters)(I),"gi")),I.indexOf("\\")>=0&&this.j.push(new RegExp((0,P.escapeRegExpCharacters)(I.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(I=>{(I.affectsConfiguration(E.TELEMETRY_SETTING_ID)||I.affectsConfiguration(E.TELEMETRY_OLD_SETTING_ID)||I.affectsConfiguration(E.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(h,u){this.d[h]=u}m(){let h=(0,d.getTelemetryLevel)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const f=u.usage?3:u.error?2:0;h=Math.min(h,f)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,u,f){this.g<u||(f=(0,L.mixin)(f,this.d),f=(0,d.cleanData)(f,this.j),f=(0,L.mixin)(f,this.c),this.b.forEach(I=>I.log(h,f)))}publicLog(h,u){this.n(h,3,u)}publicLog2(h,u){this.publicLog(h,u)}publicLogError(h,u){this.h&&this.n(h,2,u)}publicLogError2(h,u){this.publicLogError(h,u)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=p=Le([Re(1,A.IConfigurationService),Re(2,T.IProductService)],p);function b(){const s=(0,C.localize)(0,null,m.default.nameLong),h=m.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=o.isWeb?"":(0,C.localize)(3,null),f=(0,C.localize)(4,null),I=(0,C.localize)(5,null),O=(0,C.localize)(6,null),t=(0,C.localize)(7,null),n=`
|       | ${f} | ${I} | ${O} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${s} ${h} ${u}

&nbsp;

${t}
${n}

&nbsp;

${r}
`}y.Registry.as(v.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(v.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,C.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,C.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ge[245],pe([1,0,24,5,26,31,244,37]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let v=e.ServerTelemetryService=class extends C.TelemetryService{constructor(T,y,E,d){super(T,E,d),this.o=y}publicLog(T,y){if(!(this.o<3))return super.publicLog(T,y)}publicLog2(T,y){return this.publicLog(T,y)}publicLogError(T,y){return this.o<2?Promise.resolve(void 0):super.publicLogError(T,y)}publicLogError2(T,y){return this.publicLogError(T,y)}async updateInjectedTelemetryLevel(T){if(T===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,T):T,this.o===0&&this.dispose()}};e.ServerTelemetryService=v=Le([Re(2,w.IConfigurationService),Re(3,o.IProductService)],v),e.ServerNullTelemetryService=new class extends A.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,L.refineServiceDecorator)(P.ITelemetryService)}),define(ge[246],pe([1,0,296,243]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class o extends L.AbstractOneDataSystemAppender{constructor(C,A,v,m){const T={sendPOST:(y,E)=>{const d={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const p=w.request(y.urlString,d,b=>{b.on("data",function(s){E(b.statusCode??200,b.headers,s.toString())}),b.on("error",function(s){E(0,{})})});p.write(y.data),p.end()}catch{E(0,{})}}};super(C,A,v,m,T)}}e.OneDataSystemAppender=o}),define(ge[247],pe([1,0,11,238]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class o extends L.default{i(){(0,w.setUnexpectedErrorHandler)(A=>console.error(A));const C=[];process.on("unhandledRejection",(A,v)=>{C.push(v),setTimeout(()=>{const m=C.indexOf(v);m>=0&&v.catch(T=>{C.splice(m,1),(0,w.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),A&&(0,w.onUnexpectedError)(A))})},1e3)}),process.on("rejectionHandled",A=>{const v=C.indexOf(A);v>=0&&C.splice(v,1)}),process.on("uncaughtException",A=>{(0,w.isSigPipeError)(A)||(0,w.onUnexpectedError)(A)})}}e.default=o}),define(ge[119],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var w;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(w||(e.EnvironmentVariableMutatorType=w={}))}),define(ge[120],pe([1,0,3,119]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class o{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((T,y)=>{this.c(T,y);const E=T.map.entries();let d=E.next();for(;!d.done;){const p=d.value[1],b=d.value[0];let s=this.a.get(b);if(s||(s=[],this.a.set(b,s)),s.length>0&&s[0].type===L.EnvironmentVariableMutatorType.Replace){d=E.next();continue}const h={extensionIdentifier:y,value:p.value,type:p.type,scope:p.scope,variable:p.variable};h.scope||delete h.scope,s.unshift(h),d=E.next()}})}async applyToProcessEnvironment(m,T,y){let E;w.isWindows&&(E={},Object.keys(m).forEach(d=>E[d.toLowerCase()]=d));for(const[d,p]of this.getVariableMap(T)){const b=w.isWindows&&E[d.toLowerCase()]||d;for(const s of p){const h=y?await y(s.value):s.value;switch(s.type){case L.EnvironmentVariableMutatorType.Append:m[b]=(m[b]||"")+h;break;case L.EnvironmentVariableMutatorType.Prepend:m[b]=h+(m[b]||"");break;case L.EnvironmentVariableMutatorType.Replace:m[b]=h;break}}}}diff(m,T){const y=new Map,E=new Map,d=new Map;if(m.getVariableMap(T).forEach((p,b)=>{const s=this.getVariableMap(T).get(b),h=C(p,s);h&&y.set(b,h)}),this.getVariableMap(T).forEach((p,b)=>{const s=m.getVariableMap(T).get(b),h=C(p,s);h&&d.set(b,h)}),this.getVariableMap(T).forEach((p,b)=>{const s=m.getVariableMap(T).get(b),h=A(p,s);h&&E.set(b,h)}),!(y.size===0&&E.size===0&&d.size===0))return{added:y,changed:E,removed:d}}getVariableMap(m){const T=new Map;return this.a.forEach((y,E)=>{const d=y.filter(p=>P(p,m));d.length>0&&T.set(d[0].variable,d)}),T}getDescriptionMap(m){const T=new Map;return this.b.forEach((y,E)=>{const d=y.filter(p=>P(p,m));d.length>0&&T.set(d[0].extensionIdentifier,d[0].description)}),T}c(m,T){if(!m.descriptionMap)return;const y=m.descriptionMap.entries();let E=y.next();for(;!E.done;){const d=E.value[1],p=E.value[0];let b=this.b.get(p);b||(b=[],this.b.set(p,b));const s={extensionIdentifier:T,scope:d.scope,description:d.description};s.scope||delete s.scope,b.push(s),E=y.next()}}}e.MergedEnvironmentVariableCollection=o;function P(v,m){return!!(!v.scope||v.scope.workspaceFolder&&m?.workspaceFolder&&v.scope.workspaceFolder.index===m.workspaceFolder.index)}function C(v,m){if(!m)return v;const T=new Set;m.forEach(E=>T.add(E.extensionIdentifier));const y=[];return v.forEach(E=>{T.has(E.extensionIdentifier)||y.push(E)}),y.length===0?void 0:y}function A(v,m){if(!m)return;const T=new Map;m.forEach(E=>T.set(E.extensionIdentifier,E));const y=[];return v.forEach(E=>{const d=T.get(E.extensionIdentifier);d&&(E.type!==d.type||E.value!==d.value||E.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index)&&y.push(d)}),y.length===0?void 0:y}}),define(ge[86],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function w(v){return[...v.entries()]}e.serializeEnvironmentVariableCollection=w;function L(v){return v?[...v.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function o(v){return new Map(v)}e.deserializeEnvironmentVariableCollection=o;function P(v){return new Map(v??[])}e.deserializeEnvironmentDescriptionMap=P;function C(v){return Array.from(v.entries()).map(m=>[m[0],w(m[1].map),L(m[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=C;function A(v){return new Map(v.map(m=>[m[0],{map:o(m[1]),descriptionMap:P(m[2])}]))}e.deserializeEnvironmentVariableCollections=A}),define(ge[248],pe([1,0,14,20,6,2,12]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let A=e.RequestStore=class extends P.Disposable{constructor(m,T){super(),this.h=T,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new o.Emitter),this.onCreateRequest=this.g.event,this.b=m===void 0?15e3:m}createRequest(m){return new Promise((T,y)=>{const E=++this.a;this.c.set(E,T),this.g.fire({requestId:E,...m});const d=new L.CancellationTokenSource;(0,w.timeout)(this.b,d.token).then(()=>y(`Request ${E} timed out (${this.b}ms)`)),this.f.set(E,[(0,P.toDisposable)(()=>d.cancel())])})}acceptReply(m,T){const y=this.c.get(m);y?(this.c.delete(m),(0,P.dispose)(this.f.get(m)||[]),this.f.delete(m),y(T)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${m}`)}};e.RequestStore=A=Le([Re(1,C.ILogService)],A)}),define(ge[121],pe([1,0,5,64]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var o;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(o||(e.TerminalSettingPrefix=o={}));var P;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsDefaultColor="terminal.integrated.tabs.defaultColor",f.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.TabStopWidth="terminal.integrated.tabStopWidth",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.TabFocusMode="terminal.integrated.tabFocusMode",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",f.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",f.SmoothScrolling="terminal.integrated.smoothScrolling"})(P||(e.TerminalSettingId=P={}));var C;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(C||(e.PosixShellType=C={}));var A;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(A||(e.WindowsShellType=A={}));var v;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(v||(e.TitleEventSource=v={}));var m;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Logger="logger",f.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={})),e.IPtyService=(0,w.createDecorator)("ptyService");var T;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions",f.FailedShellIntegrationActivation="failedShellIntegrationActivation",f.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(T||(e.ProcessPropertyType=T={}));var y;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var E;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(E||(e.TerminalLocation=E={}));var d;(function(f){f.TerminalView="view",f.Editor="editor"})(d||(e.TerminalLocationString=d={}));var p;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(p||(e.LocalReconnectConstants=p={}));var b;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(b||(e.FlowControlConstants=b={}));var s;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(s||(e.ProfileSource=s={}));var h;(function(f){f[f.Off=0]="Off",f[f.FinalTerm=1]="FinalTerm",f[f.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var u;(function(f){f[f.Unknown=0]="Unknown",f[f.Shutdown=1]="Shutdown",f[f.Process=2]="Process",f[f.User=3]="User",f[f.Extension=4]="Extension"})(u||(e.TerminalExitReason=u={}))}),define(ge[249],pe([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function L(C){let A=C;A.includes("\\")&&(A=A.replace(/\\/g,"\\\\"));const v=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return A=A.replace(v,""),`'${A}'`}e.escapeNonWindowsPath=L;function o(C,A,v){if(!C)return"";if(!A)return C;A.match(/[\/\\]$/)&&(A=A.slice(0,A.length-1));const m=C.replace(/\\/g,"/").toLowerCase(),T=A.replace(/\\/g,"/").toLowerCase();return m.includes(T)?`~${v}${C.slice(A.length+1)}`:C}e.collapseTildePath=o;function P(C){return C.match(/^['"].*['"]$/)&&(C=C.substring(1,C.length-1)),w.OS===1&&C&&C[1]===":"?C[0].toUpperCase()+C.substring(1):C}e.sanitizeCwd=P}),define(ge[250],pe([1,0,48,4,192,95]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function C(E,d){const p=[{name:null,description:(0,o.localize)(0,null)}];return p.push(...E.map(b=>({name:b.profileName,description:A(b)}))),d&&p.push(...d.map(b=>({name:b.title,description:v(b)}))),{values:p.map(b=>b.name),markdownDescriptions:p.map(b=>b.description)}}e.createProfileSchemaEnums=C;function A(E){let d=`$(${P.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:w.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?d+=`
- args: "${E.args}"`:d+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(d+=`
- overrideName: ${E.overrideName}`),E.color&&(d+=`
- color: ${E.color}`),E.env&&(d+=`
- env: ${JSON.stringify(E.env)}`),d}function v(E){return`$(${P.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:w.Codicon.terminal.id}) ${E.title}
- extensionIdentifier: ${E.extensionIdentifier}`}function m(E,d){if(!E&&!d)return!0;if(typeof E=="string"&&typeof d=="string")return E===d;if(Array.isArray(E)&&Array.isArray(d)){if(E.length!==d.length)return!1;for(let p=0;p<E.length;p++)if(E[p]!==d[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=m;function T(E,d){if(!E&&!d)return!0;if(!E||!d)return!1;if(P.ThemeIcon.isThemeIcon(E)&&P.ThemeIcon.isThemeIcon(d))return E.id===d.id&&E.color===d.color;if(typeof E=="object"&&"light"in E&&"dark"in E&&typeof d=="object"&&"light"in d&&"dark"in d){const p=E,b=d;if((L.URI.isUri(p.light)||y(p.light))&&(L.URI.isUri(p.dark)||y(p.dark))&&(L.URI.isUri(b.light)||y(b.light))&&(L.URI.isUri(b.dark)||y(b.dark)))return p.light.path===b.light.path&&p.dark.path===b.dark.path}if(L.URI.isUri(E)&&L.URI.isUri(d)||y(E)||y(d)){const p=E,b=d;return p.path===b.path&&p.scheme===b.scheme}return!1}e.terminalIconsEqual=T;function y(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=y}),define(ge[251],pe([1,0,48,191,54,40,250]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,w.getAllCodicons)(),I=>I.id),markdownEnumDescriptions:Array.from((0,w.getAllCodicons)(),I=>`$(${I.id})`)};const A={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),...e.terminalIconSchema},color:{description:(0,L.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...A}},m={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(6,null),type:["string"],items:{type:"string"}},...A}},T=(0,L.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),y=(0,L.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),E=(0,L.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d=(0,L.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,L.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),b=(0,L.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),s={id:"terminal",order:100,title:(0,L.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:y},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(26,null)}},{type:"string",markdownDescription:(0,L.localize)(27,null)}],default:[],markdownDeprecationMessage:E},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(29,null),enum:["PowerShell","Git Bash"]},...A}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(30,null),type:"string"},id:{description:(0,L.localize)(31,null),type:"string"},title:{description:(0,L.localize)(32,null),type:"string"},...A}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(34,null),type:"string"},id:{description:(0,L.localize)(35,null),type:"string"},title:{description:(0,L.localize)(36,null),type:"string"},...A}},{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(38,null),type:"string"},id:{description:(0,L.localize)(39,null),type:"string"},title:{description:(0,L.localize)(40,null),type:"string"},...A}},{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,L.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){P.Registry.as(o.Extensions.Configuration).registerConfiguration(s),f()}e.registerTerminalPlatformConfiguration=h;let u;function f(I,O){const t=P.Registry.as(o.Extensions.Configuration);let n;I&&(n=(0,C.createProfileSchemaEnums)(I?.profiles,O));const r=u;u={id:"terminal",order:100,title:(0,L.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:I?.os===3?n?.values:void 0,markdownEnumDescriptions:I?.os===3?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:I?.os===2?n?.values:void 0,markdownEnumDescriptions:I?.os===2?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:I?.os===1?n?.values:void 0,markdownEnumDescriptions:I?.os===1?n?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[u],remove:r?[r]:[]})}e.registerTerminalDefaultProfileConfiguration=f}),define(ge[252],pe([1,0,28,13,21,7,3,29,17,8,23,119,86,120]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function p(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(w.release());let a=0;return i&&i.length===4&&(a=parseInt(i[3])),a}e.getWindowsBuildNumber=p;async function b(i,a,l,c=A.env,g=T.Promises.exists){if(P.isAbsolute(i))return await g(i)?i:void 0;if(a===void 0&&(a=A.cwd()),P.dirname(i)!=="."){const F=P.join(a,i);return await g(F)?F:void 0}const k=(0,o.getCaseInsensitive)(c,"PATH");if(l===void 0&&(0,m.isString)(k)&&(l=k.split(P.delimiter)),l===void 0||l.length===0){const F=P.join(a,i);return await g(F)?F:void 0}for(const F of l){let H;if(P.isAbsolute(F)?H=P.join(F,i):H=P.join(a,F,i),await g(H))return H;if(C.isWindows){let te=H+".com";if(await g(te)||(te=H+".exe",await g(te)))return te}}const S=P.join(a,i);return await g(S)?S:void 0}e.findExecutable=b;function s(i,a,l,c,g){const D=C.isWindows&&(!a.windowsEnableConpty||p()<18309);if(!a.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||D)return;const k=i.args,S=A.platform==="win32"?P.basename(i.executable).toLowerCase():P.basename(i.executable),F=P.dirname(L.FileAccess.asFileUri("").fsPath);let H;const te={VSCODE_INJECTION:"1"};if(C.isWindows){if(S==="pwsh.exe"||S==="powershell.exe")return!k||n(k)?H=f.get(u.WindowsPwsh):t(k)&&(H=f.get(u.WindowsPwshLogin)),H?(H=[...H],H[H.length-1]=(0,v.format)(H[H.length-1],F,""),a.shellIntegration.suggestEnabled&&(te.VSCODE_SUGGEST="1"),{newArgs:H,envMixin:te}):void 0;c.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(S){case"bash":return!k||k.length===0?H=f.get(u.Bash):r(k)&&(te.VSCODE_SHELL_LOGIN="1",h(a,te),H=f.get(u.Bash)),H?(H=[...H],H[H.length-1]=(0,v.format)(H[H.length-1],F),{newArgs:H,envMixin:te}):void 0;case"fish":{const ce=l?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",le=P.join(F,"out/vs/workbench/contrib/xdg_data");return te.XDG_DATA_DIRS=`${ce}:${le}`,h(a,te),{newArgs:void 0,envMixin:te}}case"pwsh":return!k||n(k)?H=f.get(u.Pwsh):t(k)&&(H=f.get(u.PwshLogin)),H?(a.shellIntegration.suggestEnabled&&(te.VSCODE_SUGGEST="1"),H=[...H],H[H.length-1]=(0,v.format)(H[H.length-1],F,""),{newArgs:H,envMixin:te}):void 0;case"zsh":{if(!k||k.length===0?H=f.get(u.Zsh):r(k)?(H=f.get(u.ZshLogin),h(a,te)):(k===f.get(u.Zsh)||k===f.get(u.ZshLogin))&&(H=k),!H)return;H=[...H],H[H.length-1]=(0,v.format)(H[H.length-1],F);let ce;try{ce=w.userInfo().username}catch{ce="unknown"}const le=P.join(w.tmpdir(),`${ce}-${g.applicationName}-zsh`);te.ZDOTDIR=le;const ue=l?.ZDOTDIR??w.homedir()??"~";te.USER_ZDOTDIR=ue;const ve=[];return ve.push({source:P.join(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:P.join(le,".zshrc")}),ve.push({source:P.join(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:P.join(le,".zprofile")}),ve.push({source:P.join(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:P.join(le,".zshenv")}),ve.push({source:P.join(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:P.join(le,".zlogin")}),{newArgs:H,envMixin:te,filesToCopy:ve}}}c.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=s;function h(i,a){if(C.isMacintosh&&i.environmentVariableCollections){const l=(0,E.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),g=new d.MergedEnvironmentVariableCollection(l).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),D=[];if(g)for(const k of g)k.type===y.EnvironmentVariableMutatorType.Prepend&&D.push(k.value);D.length>0&&(a.VSCODE_PATH_PREFIX=D.join(""))}}var u;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(u||(u={}));const f=new Map;f.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(u.Zsh,["-i"]),f.set(u.ZshLogin,["-il"]),f.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const I=["-login","-l"],O=["-nol","-nologo"];function t(i){return typeof i=="string"?I.includes(i.toLowerCase()):i.length===1&&I.includes(i[0].toLowerCase())||i.length===2&&(I.includes(i[0].toLowerCase())||I.includes(i[1].toLowerCase()))&&(O.includes(i[0].toLowerCase())||O.includes(i[1].toLowerCase()))}function n(i){return typeof i=="string"?O.includes(i.toLowerCase()):i.length===0||i?.length===1&&O.includes(i[0].toLowerCase())}function r(i){return i==="string"&&I.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&I.includes(i[0].toLowerCase())}}),define(ge[253],pe([1,0,51,48,7,3,8,23,100,252,73]),function(oe,e,w,L,o,P,C,A,v,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let y,E=!0;function d(i,a,l,c,g=process.env,D,k,S,F){return D=D||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},P.isWindows?p(l,D,g,k,c.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:c.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:c.getValue("terminal.integrated.defaultProfile.windows"),F,S):t(D,k,l,i&&typeof i=="object"?{...i}:c.getValue(P.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:c.getValue(P.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,S,g)}e.detectAvailableProfiles=d;async function p(i,a,l,c,g,D,k,S,F){const H=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),te=`${process.env.windir}\\${H?"Sysnative":"System32"}`;let ce=!1;(0,m.getWindowsBuildNumber)()>=16299&&(ce=!0),await h(S);const le=new Map;if(i){le.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),le.set("Windows PowerShell",{path:`${te}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),le.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),le.set("Command Prompt",{path:`${te}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),le.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),le.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const ve=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;le.set("Cmder",{path:`${te}\\cmd.exe`,args:["/K",ve],requiresPath:process.env.CMDER_ROOT?ve:{path:ve,isUnsafe:!0},isAutoDetected:!0})}n(D,le);const ue=await b(le.entries(),k,a,l,c,F);if(i||g)try{const ve=await I(`${te}\\${ce?"wsl":"bash"}.exe`,k);for(const K of ve)(!D||!(K.profileName in D))&&ue.push(K)}catch{E&&(c?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return ue}async function b(i,a,l,c=process.env,g,D){const k=[];for(const[S,F]of i){if(F===null)continue;let H,te,ce;if("source"in F){const K=y?.get(F.source);if(!K)continue;H=K.paths,te=F.args||K.args,F.icon?ce=s(F.icon):K.icon&&(ce=K.icon)}else H=Array.isArray(F.path)?F.path:[F.path],te=P.isWindows||Array.isArray(F.args)?F.args:void 0,ce=s(F.icon);let le;if(D){const K=H.map(z=>typeof z=="string"?z:z.path),ee=await D(K);le=new Array(H.length);for(let z=0;z<H.length;z++)typeof H[z]=="string"?le[z]=ee[z]:le[z]={path:ee[z],isUnsafe:!0}}else le=H.slice();let ue;if(F.requiresPath){let K;if((0,C.isString)(F.requiresPath)?K=F.requiresPath:(K=F.requiresPath.path,F.requiresPath.isUnsafe&&(ue=K)),!await l.existsFile(K))continue}const ve=await r(S,a,le,l,c,te,F.env,F.overrideName,F.isAutoDetected,ue);ve?(ve.isAutoDetected=F.isAutoDetected,ve.icon=ce,ve.color=F.color,k.push(ve)):g?.debug("Terminal profile not validated",S,H)}return g?.debug("Validated terminal profiles",k),k}function s(i){return typeof i=="string"?{id:i}:i}async function h(i){if(y&&!i)return;const[a,l]=await Promise.all([u(),i||f()]);y=new Map,y.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),y.set("PowerShell",{profileName:"PowerShell",paths:l,icon:L.Codicon.terminalPowershell})}async function u(){const i=new Set,a=await(0,m.findExecutable)("git.exe");if(a){const g=(0,T.dirname)(a);i.add((0,T.resolve)(g,"../.."))}function l(g,D){D&&g.add(D)}l(i,process.env.ProgramW6432),l(i,process.env.ProgramFiles),l(i,process.env["ProgramFiles(X86)"]),l(i,`${process.env.LocalAppData}\\Program`);const c=[];for(const g of i)c.push(`${g}\\Git\\bin\\bash.exe`,`${g}\\Git\\usr\\bin\\bash.exe`,`${g}\\usr\\bin\\bash.exe`);return c.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),c}async function f(){const i=[];for await(const a of(0,v.enumeratePowerShellInstallations)())i.push(a.exePath);return i}async function I(i,a){const l=[],c=await new Promise((k,S)=>{w.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,H)=>{if(F)return S("Problem occurred when getting wsl distros");k(H)})});if(!c)return[];const g=new RegExp(/[\r?\n]/),D=c.split(g).filter(k=>k.trim().length>0&&k!=="");for(const k of D){if(k===""||k.startsWith("docker-desktop"))continue;const S=`${k} (WSL)`,F={profileName:S,path:i,args:["-d",`${k}`],isDefault:S===a,icon:O(k),isAutoDetected:!1};l.push(F)}return l}function O(i){return i.includes("Ubuntu")?L.Codicon.terminalUbuntu:i.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function t(i,a,l,c,g,D,k,S){const F=new Map;if(l){const H=(await i.readFile("/etc/shells")).toString(),te=D||H.split(`
`).filter(le=>le.trim().includes("#")&&le.trim().length>0),ce=new Map;for(const le of te){let ue=(0,o.basename)(le),ve=ce.get(ue)||0;ve++,ve>1&&(ue=`${ue} (${ve})`),ce.set(ue,ve),F.set(ue,{path:le,isAutoDetected:!0})}}return n(c,F),await b(F.entries(),g,i,S,a,k)}function n(i,a){if(i)for(const[l,c]of Object.entries(i))c===null||typeof c!="object"||!("path"in c)&&!("source"in c)?a.delete(l):(c.icon=c.icon||a.get(l)?.icon,a.set(l,c))}async function r(i,a,l,c,g,D,k,S,F,H){if(l.length===0)return Promise.resolve(void 0);const te=l.shift();if(te==="")return r(i,a,l,c,g,D,k,S,F);const ce=typeof te!="string"&&te.isUnsafe,le=typeof te=="string"?te:te.path,ue={profileName:i,path:le,args:D,env:k,overrideName:S,isAutoDetected:F,isDefault:i===a,isUnsafePath:ce,requiresUnsafePath:H};if((0,o.basename)(le)===le){const K=g.PATH?g.PATH.split(o.delimiter):void 0,ee=await(0,m.findExecutable)(le,void 0,K,void 0,c.existsFile);return ee?(ue.path=ee,ue.isFromPath=!0,ue):r(i,a,l,c,g,D)}return await c.existsFile((0,o.normalize)(le))?ue:r(i,a,l,c,g,D,k,S,F)}}),define(ge[254],pe([1,0,6,2,13,3,42,105,24,25,106,84,12,248,121,251,253,110]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var u;(function(O){O[O.MaxRestarts=5]="MaxRestarts"})(u||(u={}));let f=0,I=e.PtyHostService=class extends L.Disposable{constructor(t,n,r,i,a,l){super(),this.C=t,this.D=n,this.F=r,this.G=i,this.H=a,this.I=l,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new w.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new w.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new w.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new w.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new w.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new w.Emitter),this.onProcessData=this.s.event,this.t=this.B(new w.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new w.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new w.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new w.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new w.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new w.Emitter),this.onProcessExit=this.z.event,(0,b.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,L.toDisposable)(()=>this.O())),this.f=this.B(new d.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(P.isWindows)return process.env;try{return await(0,y.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(t){return this.H.error("ptyHost was unable to resolve shell environment",t),{}}}N(){const t={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:f,VSCODE_PTY_REMOTE:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},n=(0,T.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);n&&(n.break&&n.port?t.debugBrk=n.port:!n.break&&n.port&&(t.debug=n.port));const r=new A.Client(o.FileAccess.asFileUri("bootstrap-fork").fsPath,t);this.m.fire(),C.ProxyChannel.toService(r.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(r.onDidProcessExit(l=>{this.l.fire(l.code),this.i||(this.g<=u.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${l.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))})),this.B(new h.RemoteLoggerChannelClient(this.I,r.getChannel(p.TerminalIpcChannels.Logger)));const a=C.ProxyChannel.toService(r.getChannel(p.TerminalIpcChannels.PtyHost));return this.B(a.onProcessData(l=>this.s.fire(l))),this.B(a.onProcessReady(l=>this.t.fire(l))),this.B(a.onProcessExit(l=>this.z.fire(l))),this.B(a.onDidChangeProperty(l=>this.y.fire(l))),this.B(a.onProcessReplay(l=>this.u.fire(l))),this.B(a.onProcessOrphanQuestion(l=>this.v.fire(l))),this.B(a.onDidRequestDetach(l=>this.w.fire(l))),[r,a]}dispose(){this.i=!0,super.dispose()}async createProcess(t,n,r,i,a,l,c,g,D,k,S){const F=setTimeout(()=>this.S(),p.HeartbeatConstants.CreateProcessTimeout),H=await this.b.createProcess(t,n,r,i,a,l,c,g,D,k,S);return clearTimeout(F),f=Math.max(f,H),H}updateTitle(t,n,r){return this.b.updateTitle(t,n,r)}updateIcon(t,n,r,i){return this.b.updateIcon(t,n,r,i)}attachToProcess(t){return this.b.attachToProcess(t)}detachFromProcess(t,n){return this.b.detachFromProcess(t,n)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(t){return this.b.start(t)}shutdown(t,n){return this.b.shutdown(t,n)}input(t,n){return this.b.input(t,n)}processBinary(t,n){return this.b.processBinary(t,n)}resize(t,n,r){return this.b.resize(t,n,r)}acknowledgeDataEvent(t,n){return this.b.acknowledgeDataEvent(t,n)}setUnicodeVersion(t,n){return this.b.setUnicodeVersion(t,n)}getInitialCwd(t){return this.b.getInitialCwd(t)}getCwd(t){return this.b.getCwd(t)}getLatency(t){return this.b.getLatency(t)}orphanQuestionReply(t){return this.b.orphanQuestionReply(t)}installAutoReply(t,n){return this.b.installAutoReply(t,n)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(t){return this.b.uninstallAutoReply(t)}getDefaultSystemShell(t){return this.b.getDefaultSystemShell(t)}async getProfiles(t,n,r,i=!1){const a=await this.c;return(0,s.detectAvailableProfiles)(n,r,i,this.F,a,void 0,this.H,this.W.bind(this,t))}getEnvironment(){return this.b.getEnvironment()}getWslPath(t,n){return this.b.getWslPath(t,n)}getRevivedPtyNewId(t){return this.b.getRevivedPtyNewId(t)}setTerminalLayoutInfo(t){return this.b.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this.b.getTerminalLayoutInfo(t)}async requestDetachInstance(t,n){return this.b.requestDetachInstance(t,n)}async acceptDetachInstanceReply(t,n){return this.b.acceptDetachInstanceReply(t,n)}async freePortKillProcess(t){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(t)}async serializeTerminalState(t){return this.b.serializeTerminalState(t)}async reviveTerminalProcesses(t,n){return this.b.reviveTerminalProcesses(t,n)}async refreshProperty(t,n){return this.b.refreshProperty(t,n)}async updateProperty(t,n,r){return this.b.updateProperty(t,n,r)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(t,n){return this.f.createRequest({workspaceId:t,originalText:n})}async acceptPtyHostResolvedVariables(t,n){this.f.acceptReply(t,n)}};e.PtyHostService=I=Le([Re(2,v.IConfigurationService),Re(3,m.IEnvironmentService),Re(4,E.ILogService),Re(5,E.ILoggerService)],I)}),define(ge[35],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,w.createDecorator)("IUriIdentityService")}),define(ge[122],pe([1,0,35,210,16,19,144,6,2]),function(oe,e,w,L,o,P,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(E){this.uri=E,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let T=e.UriIdentityService=class{constructor(E){this.g=E,this.c=new v.DisposableStore,this.f=2**16;const d=new Map,p=b=>{let s=d.get(b.scheme);return s===void 0&&(s=E.hasProvider(b)&&!this.g.hasCapability(b,1024),d.set(b.scheme,s)),s};this.c.add(A.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(b=>{d.delete(b.scheme)})),this.extUri=new P.ExtUri(p),this.d=new C.SkipList((b,s)=>this.extUri.compare(b,s,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(E){this.g.hasProvider(E)&&(E=(0,P.normalizePath)(E));const d=this.d.get(E);return d?d.touch().uri.with({fragment:E.fragment}):(this.d.set(E,new m(E)),this.h(),E)}h(){if(this.d.size<this.f)return;const E=[...this.d.entries()].sort((p,b)=>p[1].time<b[1].time?1:p[1].time>b[1].time?-1:0);m._clock=0,this.d.clear();const d=this.f*.5;for(let p=0;p<d;p++)this.d.set(E[p][0],E[p][1].touch())}};e.UriIdentityService=T=Le([Re(0,o.IFileService)],T),(0,L.registerSingleton)(w.IUriIdentityService,T,1)}),define(ge[87],pe([1,0,194,7,60,19,4,5,13]),function(oe,e,w,L,o,P,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function m(i){const a=i;return typeof a?.id=="string"&&C.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=m;function T(i){return typeof i?.id=="string"&&!m(i)&&!E(i)}e.isEmptyWorkspaceIdentifier=T,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(i,a){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=y;function E(i){const a=i;return typeof a?.id=="string"&&C.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=E;function d(i){const a=i;if(a?.uri)return{id:a.id,uri:C.URI.revive(a.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:C.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=d;var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function b(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=b;function s(i){const a=i;return!!(a&&typeof a=="object"&&C.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=s;class h{constructor(a,l,c,g,D){this.h=a,this.j=c,this.k=g,this.l=D,this.c=o.TernarySearchTree.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=o.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class u{constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,P.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function f(i){return new u({uri:i,index:0,name:(0,P.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=f,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(i,a){return P.extUriBiasedIgnorePathCase.isEqualOrParent(i,a.untitledWorkspacesHome)}e.isUntitledWorkspace=I;function O(i){let a;return C.URI.isUri(i)?a=i:a=i.configuration,a?.scheme===v.Schemas.tmp}e.isTemporaryWorkspace=O,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function n(i,a){return!I(i,a)&&!O(i)}e.isSavedWorkspace=n;function r(i){return(typeof i=="string"?(0,L.extname)(i):(0,P.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(ge[32],pe([1,0,75,6,2,19,4,193,25,16,5,12,87,27,35,14,22,17,8]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function f(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&C.URI.isUri(i.location)&&C.URI.isUri(i.globalStorageHome)&&C.URI.isUri(i.settingsResource)&&C.URI.isUri(i.keybindingsResource)&&C.URI.isUri(i.tasksResource)&&C.URI.isUri(i.snippetsHome)&&C.URI.isUri(i.extensionsResource))}e.isUserDataProfile=f,e.IUserDataProfilesService=(0,T.createDecorator)("IUserDataProfilesService");function I(r,i){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:C.URI.revive(r.location).with({scheme:i}),globalStorageHome:C.URI.revive(r.globalStorageHome).with({scheme:i}),settingsResource:C.URI.revive(r.settingsResource).with({scheme:i}),keybindingsResource:C.URI.revive(r.keybindingsResource).with({scheme:i}),tasksResource:C.URI.revive(r.tasksResource).with({scheme:i}),snippetsHome:C.URI.revive(r.snippetsHome).with({scheme:i}),extensionsResource:C.URI.revive(r.extensionsResource).with({scheme:i}),cacheHome:C.URI.revive(r.cacheHome).with({scheme:i}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=I;function O(r,i,a,l,c){return{id:r,name:i,location:a,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,P.joinPath)(a,"globalStorage"),settingsResource:(0,P.joinPath)(a,"settings.json"),keybindingsResource:(0,P.joinPath)(a,"keybindings.json"),tasksResource:(0,P.joinPath)(a,"tasks.json"),snippetsHome:(0,P.joinPath)(a,"snippets"),extensionsResource:(0,P.joinPath)(a,"extensions.json"),cacheHome:(0,P.joinPath)(l,r),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=O;let t=e.UserDataProfilesService=class extends o.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,a,l,c){super(),this.n=i,this.r=a,this.s=l,this.t=c,this.f=!0,this.h=this.B(new L.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new L.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new L.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new L.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,P.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,P.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const g of this.J()){if(!g.name||!(0,u.isString)(g.name)||!g.location){this.t.warn("Skipping the invalid stored profile",g.location||g.name);continue}i.push(O((0,P.basename)(g.location),g.name,g.location,this.g,{shortName:g.shortName,useDefaultFlags:g.useDefaultFlags}))}}catch(g){this.t.error(g)}const a=new d.ResourceMap,l=new Map,c=this.w();if(i.unshift({...c,extensionsResource:this.O()??c.extensionsResource,isDefault:!0}),i.length)try{const g=this.M();if(g.workspaces)for(const[D,k]of Object.entries(g.workspaces)){const S=C.URI.parse(D),F=i.find(H=>H.id===k);F&&a.set(S,F)}if(g.emptyWindows)for(const[D,k]of Object.entries(g.emptyWindows)){const S=i.find(F=>F.id===k);S&&l.set(D,S)}}catch(g){this.t.error(g)}this.u={profiles:i,workspaces:a,emptyWindows:l}}return this.u}w(){return O("__default__profile__",(0,A.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const a="Temp",l=new RegExp(`${(0,h.escapeRegExpCharacters)(a)}\\s(\\d+)`);let c=0;for(const D of this.profiles){const k=l.exec(D.name),S=k?parseInt(k[1]):0;c=S>c?S:c}const g=`${a} ${c+1}`;return this.createProfile((0,w.hash)((0,s.generateUuid)()).toString(16),g,{transient:!0},i)}async createNamedProfile(i,a,l){return this.createProfile((0,w.hash)((0,s.generateUuid)()).toString(16),i,a,l)}async createProfile(i,a,l,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=await this.y(i,a,l);return c&&await this.setProfileForWorkspace(c,g),g}async y(i,a,l){if(!(0,u.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let c=this.l.get(a);return c||(c=(async()=>{try{const g=this.profiles.find(S=>S.name===a||S.id===i);if(g)return g;const D=O(i,a,(0,P.joinPath)(this.profilesHome,i),this.g,l);await this.r.createFolder(D.location);const k=[];return this.i.fire({profile:D,join(S){k.push(S)}}),await b.Promises.settled(k),this.D([D],[],[]),D}finally{this.l.delete(a)}})(),this.l.set(a,c)),c}async updateProfile(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(c=>c.id===i.id);if(!l)throw new Error(`Profile '${i.name}' does not exist`);return l=O(l.id,a.name??l.name,l.location,this.g,{shortName:a.shortName??l.shortName,transient:a.transient??l.isTransient,useDefaultFlags:a.useDefaultFlags??l.useDefaultFlags}),this.D([],[],[l]),l}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(c=>c.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const l=[];this.j.fire({profile:a,join(c){l.push(c)}});try{await Promise.allSettled(l)}catch(c){this.t.error(c)}for(const c of[...this.v.emptyWindows.keys()])a.id===this.v.emptyWindows.get(c)?.id&&this.v.emptyWindows.delete(c);for(const c of[...this.v.workspaces.keys()])a.id===this.v.workspaces.get(c)?.id&&this.v.workspaces.delete(c);this.H(),this.D([],[a],[]);try{await this.r.del(a.cacheHome,{recursive:!0})}catch(c){(0,m.toFileOperationResult)(c)!==1&&this.t.error(c)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(a.location,{recursive:!0})}catch(c){this.t.error(c)}}async setProfileForWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(c=>c.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);this.G(i,l)}unsetWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,a)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every(l=>!this.s.extUri.isEqual(l.location,a.resource))).map(a=>this.r.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(a=>!this.C(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}getProfileForWorkspace(i){const a=this.z(i);return C.URI.isUri(a)?this.m.workspaces.get(a)??this.v.workspaces.get(a):this.m.emptyWindows.get(a)??this.v.emptyWindows.get(a)}z(i){return(0,E.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,E.isWorkspaceIdentifier)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.m.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.v.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.v.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,i.location)))}D(i,a,l){const c=[...this.profiles,...i],g=[];this.m.profiles=[];for(let D of c)D.isDefault||a.some(k=>D.id===k.id)||(D=l.find(k=>D.id===k.id)??D,D.isTransient?this.m.profiles.push(D):g.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.L(g),this.u=void 0,this.F(i,a,l)}F(i,a,l){this.h.fire({added:i,removed:a,updated:l,all:this.profiles})}G(i,a,l){l=a?.isTransient?!0:l,l||this.G(i,void 0,!0);const c=this.z(i),g=l?this.m:this.v;C.URI.isUri(c)?(g.workspaces.delete(c),a&&g.workspaces.set(c,a)):(g.emptyWindows.delete(c),a&&g.emptyWindows.set(c,a)),l||this.H()}H(){const i={};for(const[l,c]of this.v.workspaces.entries())i[l.toString()]=c.id;const a={};for(const[l,c]of this.v.emptyWindows.entries())a[l.toString()]=c.id;this.N({workspaces:i,emptyWindows:a}),this.u=void 0}I(i){const a={},l=this.w();if(i.workspaces)for(const[g,D]of Object.entries(i.workspaces)){const k=C.URI.parse(D);a[g]=this.s.extUri.isEqual(k,l.location)?l.id:this.s.extUri.basename(k)}const c={};if(i.emptyWindows)for(const[g,D]of Object.entries(i.emptyWindows)){const k=C.URI.parse(D);c[g]=this.s.extUri.isEqual(k,l.location)?l.id:this.s.extUri.basename(k)}return{workspaces:a,emptyWindows:c}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",e.UserDataProfilesService=t=Le([Re(0,v.IEnvironmentService),Re(1,m.IFileService),Re(2,p.IUriIdentityService),Re(3,y.ILogService)],t);class n extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.InMemoryUserDataProfilesService=n}),define(ge[255],pe([1,0,18,14,20,11,6,2,3,8,4,174,30,34,36,12,26,31,32]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=e.AbstractExtensionManagementService=class extends A.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,a,l,c,g){super(),this.t=i,this.u=a,this.v=l,this.w=c,this.y=g,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new C.Emitter),this.m=this.B(new C.Emitter),this.n=this.B(new C.Emitter),this.p=this.B(new C.Emitter),this.s=[],this.B((0,A.toDisposable)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.k.forEach(D=>D.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const a=await this.getTargetPlatform();return i.allTargetPlatforms.some(l=>(0,E.isTargetPlatformCompatible)(l,i.allTargetPlatforms,a))}async installFromGallery(i,a={}){try{if(!this.t.isEnabled())throw new E.ExtensionManagementError(y.localize(0,null),E.ExtensionManagementErrorCode.Internal);const l=await this.G(i,!!a.installGivenVersion,!!a.installPreReleaseVersion);return await this.z(l.manifest,l.extension,a)}catch(l){throw t(this.u,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(i),error:l}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(l),O(l)}}async uninstall(i,a={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,a)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,a,l){const c=l.isApplicationScoped||l.isBuiltin||(0,p.isApplicationScopedExtension)(i),g={...l,installOnlyNewlyAddedFromExtensionPack:T.URI.isUri(a)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:c,profileLocation:c?this.y.defaultProfile.extensionsResource:l.profileLocation??this.P()},D=ce=>`${d.ExtensionKey.create(ce).toString()}${g.profileLocation?`-${g.profileLocation.toString()}`:""}`;if(!T.URI.isUri(a)){const ce=this.j.get(D(a));if(ce)return this.v.info("Extensions is already requested to install",a.identifier.id),ce.task.waitUntilTaskIsFinished()}const k=[],S=[],F=[],H=this.Q(i,a,g);T.URI.isUri(a)||this.j.set(D(a),{task:H,waitingTasks:[]}),this.l.fire({identifier:H.identifier,source:a,profileLocation:g.profileLocation}),this.v.info("Installing extension:",H.identifier.id),k.push({task:H,manifest:i});let te=!1;try{if(g.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",H.identifier.id);else try{const le=await this.F(H.identifier,i,!!g.installOnlyNewlyAddedFromExtensionPack,!!g.installPreReleaseVersion,g.profileLocation),ue=await this.getInstalled(void 0,g.profileLocation);for(const{gallery:ve,manifest:K}of(0,w.distinct)(le,({gallery:ee})=>ee.identifier.id)){te=te||!!K.extensionDependencies?.some(q=>(0,d.areSameExtensions)({id:q},H.identifier));const ee=D(ve),z=this.j.get(ee);if(z){if(this.C(H,z.task)){const q=z.task.identifier;this.v.info("Waiting for already requested installing extension",q.id,H.identifier.id),z.waitingTasks.push(H),S.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,G=>G.some(ne=>(0,d.areSameExtensions)(ne.identifier,q)))).then(G=>{if(this.v.info("Finished waiting for already requested installing extension",q.id,H.identifier.id),!G.find(se=>(0,d.areSameExtensions)(se.identifier,q))?.local)throw new Error(`Extension ${q.id} is not installed`)}))}}else if(!ue.some(({identifier:q})=>(0,d.areSameExtensions)(q,ve.identifier))){const q=this.Q(K,ve,{...g,donotIncludePackAndDependencies:!0});this.j.set(ee,{task:q,waitingTasks:[H]}),this.l.fire({identifier:q.identifier,source:ve,profileLocation:g.profileLocation}),this.v.info("Installing extension:",q.identifier.id,H.identifier.id),k.push({task:q,manifest:K})}}}catch(le){if(T.URI.isUri(H.source))(0,w.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",H.identifier.id,le.message),(0,w.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",H.identifier.id,le.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",H.identifier.id),le}const ce=k.reduce((le,{task:ue,manifest:ve})=>(le.set(ue.identifier.id.toLowerCase(),{task:ue,manifest:ve}),le),new Map);for(;ce.size;){let le;const ue=[...ce.values()].filter(({manifest:ve})=>!ve.extensionDependencies?.some(K=>ce.has(K.toLowerCase())));ue.length?le=ce.size===1?ue:ue.filter(({task:ve})=>!(ve===H&&!te)):(this.v.info("Found extensions with circular dependencies",ue.map(({task:ve})=>ve.identifier.id)),le=[...ce.values()]),await this.D(le.map(async({task:ve})=>{const K=new Date().getTime();try{const ee=await ve.run();if(await this.D(this.s.map(z=>z.postInstall(ee,ve.source,g,o.CancellationToken.None))),!T.URI.isUri(ve.source)){const z=ve.operation===3,q=z?void 0:(new Date().getTime()-ve.source.lastUpdated)/1e3;if(t(this.u,z?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ve.source),verificationStatus:ve.verificationStatus,duration:new Date().getTime()-K,durationSinceUpdate:q}),v.isWeb&&ve.operation!==3)try{await this.t.reportStatistic(ee.manifest.publisher,ee.manifest.name,ee.manifest.version,"install")}catch{}}F.push({local:ee,identifier:ve.identifier,operation:ve.operation,source:ve.source,context:g.context,profileLocation:ve.profileLocation,applicationScoped:ee.isApplicationScoped})}catch(ee){throw T.URI.isUri(ve.source)||t(this.u,ve.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ve.source),verificationStatus:ve.verificationStatus,duration:new Date().getTime()-K,error:ee}),this.v.error("Error while installing the extension:",ve.identifier.id),ee}finally{ce.delete(ve.identifier.id.toLowerCase())}}))}return S.length&&await this.D(S),F.forEach(({identifier:le})=>this.v.info("Extension installed successfully:",le.id)),this.m.fire(F),F.filter(({identifier:le})=>(0,d.areSameExtensions)(le,H.identifier))[0].local}catch(ce){if(k.forEach(({task:le})=>le.cancel()),F.length)try{const le=await Promise.allSettled(F.map(({local:ue})=>this.R(ue,{versionOnly:!0,profileLocation:g.profileLocation}).run()));for(let ue=0;ue<le.length;ue++){const ve=le[ue],{identifier:K}=F[ue];ve.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",K.id):this.v.warn("Rollback: Error while uninstalling extension",K.id,(0,P.getErrorMessage)(ve.reason))}}catch(le){this.v.warn("Error while rolling back extensions",(0,P.getErrorMessage)(le),F.map(({identifier:ue})=>ue.id))}throw this.m.fire(k.map(({task:le})=>({identifier:le.identifier,operation:2,source:le.source,context:g.context,profileLocation:g.profileLocation}))),ce}finally{for(const{task:ce}of k)ce.source&&!T.URI.isUri(ce.source)&&this.j.delete(D(ce.source))}}C(i,a){for(const[,{task:l,waitingTasks:c}]of this.j.entries())if(l===i&&(c.includes(a)||c.some(g=>this.C(g,a)))||l===a&&c[0]&&!this.C(i,c[0]))return!1;return!0}async D(i){const a=[],l=[],c=await Promise.allSettled(i);for(const g of c)g.status==="fulfilled"?a.push(g.value):l.push(g.reason);if(l.length)throw I(l);return a}async F(i,a,l,c,g){if(!this.t.isEnabled())return[];const D=await this.getInstalled(void 0,g),k=[],S=[],F=async(H,te)=>{k.push(H);const ce=te.extensionDependencies||[],le=[...ce];if(te.extensionPack){const ue=l?D.find(ve=>(0,d.areSameExtensions)(ve.identifier,H)):void 0;for(const ve of te.extensionPack)ue&&ue.manifest.extensionPack&&ue.manifest.extensionPack.some(K=>(0,d.areSameExtensions)({id:K},{id:ve}))||le.every(K=>!(0,d.areSameExtensions)({id:K},{id:ve}))&&le.push(ve)}if(le.length){const ue=le.filter(ve=>k.every(K=>!(0,d.areSameExtensions)(K,{id:ve})));if(ue.length){const ve=await this.t.getExtensions(ue.map(K=>({id:K,preRelease:c})),o.CancellationToken.None);for(const K of ve){if(k.find(q=>(0,d.areSameExtensions)(q,K.identifier)))continue;const ee=ce.some(q=>(0,d.areSameExtensions)({id:q},K.identifier));let z;try{z=await this.G(K,!1,c)}catch(q){if(q instanceof E.ExtensionManagementError&&q.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ee){this.v.info("Skipping the packed extension as it cannot be installed",K.identifier.id);continue}else throw q}S.push({gallery:z.extension,manifest:z.manifest}),await F(z.extension.identifier,z.manifest)}}}};return await F(i,a),S}async G(i,a,l){if((await this.getExtensionsControlManifest()).malicious.some(k=>(0,d.areSameExtensions)(i.identifier,k)))throw new E.ExtensionManagementError(y.localize(1,null,i.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const k=await this.getTargetPlatform();throw new E.ExtensionManagementError(y.localize(2,null,i.identifier.id,this.w.nameLong,(0,E.TargetPlatformToString)(k)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const g=await this.H(i,a,l);if(g){if(l&&!a&&i.hasPreReleaseVersion&&!g.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(y.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!l&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],o.CancellationToken.None))[0]?new E.ExtensionManagementError(y.localize(4,null,i.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(y.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",g.identifier.id);const D=await this.t.getManifest(g,o.CancellationToken.None);if(D===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(D.version!==g.version)throw new E.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:g,manifest:D}}async H(i,a,l){const c=await this.getTargetPlatform();let g=null;return!a&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==l&&(g=(await this.t.getExtensions([{...i.identifier,preRelease:l}],{targetPlatform:c,compatible:!0},o.CancellationToken.None))[0]||null),!g&&await this.t.isExtensionCompatible(i,l,c)&&(g=i),g||(a?g=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:c,compatible:!0},o.CancellationToken.None))[0]||null:g=await this.t.getCompatibleExtension(i,l,c)),g}async I(i,a){const l={...a,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},c=H=>`${H.id.toLowerCase()}${l.versionOnly?`-${i.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,g=this.k.get(c(i.identifier));if(g)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),g.waitUntilTaskIsFinished();const D=H=>{const te=this.R(H,l);return this.k.set(c(te.extension.identifier),te),l.profileLocation?this.v.info("Uninstalling extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,l.profileLocation.toString()):this.v.info("Uninstalling extension:",`${H.identifier.id}@${H.manifest.version}`),this.n.fire({identifier:H.identifier,profileLocation:l.profileLocation,applicationScoped:H.isApplicationScoped}),te},k=(H,te)=>{te?l.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,l.profileLocation.toString(),te.message):this.v.error("Failed to uninstall extension:",`${H.identifier.id}@${H.manifest.version}`,te.message):l.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${H.identifier.id}@${H.manifest.version}`,l.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${H.identifier.id}@${H.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(H),error:te}),this.p.fire({identifier:H.identifier,error:te?.code,profileLocation:l.profileLocation,applicationScoped:H.isApplicationScoped})},S=[],F=[];try{S.push(D(i));const H=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const te=this.M(i,H);for(const ce of te)this.k.has(c(ce.identifier))?this.v.info("Extensions is already requested to uninstall",ce.identifier.id):S.push(D(ce))}l.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(S.map(te=>te.extension),H,i),await this.D(S.map(async te=>{try{if(await te.run(),await this.D(this.s.map(ce=>ce.postUninstall(te.extension,l,o.CancellationToken.None))),te.extension.identifier.uuid)try{await this.t.reportStatistic(te.extension.manifest.publisher,te.extension.manifest.name,te.extension.manifest.version,"uninstall")}catch{}k(te.extension)}catch(ce){const le=ce instanceof E.ExtensionManagementError?ce:new E.ExtensionManagementError((0,P.getErrorMessage)(ce),E.ExtensionManagementErrorCode.Internal);throw k(te.extension,le),le}finally{F.push(te)}}))}catch(H){const te=H instanceof E.ExtensionManagementError?H:new E.ExtensionManagementError((0,P.getErrorMessage)(H),E.ExtensionManagementErrorCode.Internal);for(const ce of S){try{ce.cancel()}catch{}F.includes(ce)||k(ce.extension,te)}throw te}finally{for(const H of S)this.k.delete(c(H.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",H.extension.identifier.id)}}J(i,a,l){for(const c of i){const g=this.N(c,a);if(g.length){const D=g.filter(k=>!i.some(S=>(0,d.areSameExtensions)(S.identifier,k.identifier)));if(D.length)throw new Error(this.L(c,D,l))}}}L(i,a,l){return l===i?a.length===1?y.localize(6,null,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?y.localize(7,null,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):y.localize(8,null,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?y.localize(9,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?y.localize(10,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):y.localize(11,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}M(i,a,l=[]){if(l.indexOf(i)!==-1)return[];l.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const g=a.filter(k=>!k.isBuiltin&&c.some(S=>(0,d.areSameExtensions)({id:S},k.identifier))),D=[];for(const k of g)D.push(...this.M(k,a,l));return[...g,...D]}return[]}N(i,a){return a.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(c=>(0,d.areSameExtensions)({id:c},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};e.AbstractExtensionManagementService=f=Le([Re(0,E.IExtensionGalleryService),Re(1,h.ITelemetryService),Re(2,b.ILogService),Re(3,s.IProductService),Re(4,u.IUserDataProfilesService)],f);function I(r){const i=Array.isArray(r)?r:[r];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((a,l)=>new Error(`${a.message}${a.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.joinErrors=I;function O(r){if(r instanceof E.ExtensionManagementError)return r;const i=new E.ExtensionManagementError(r.message,E.ExtensionManagementErrorCode.Internal);return i.stack=r.stack,i}function t(r,i,{extensionData:a,verificationStatus:l,duration:c,error:g,durationSinceUpdate:D}){let k,S;(0,m.isDefined)(l)&&(l===!0?l="Verified":(l===!1||(k=E.ExtensionManagementErrorCode.Signature,S=l),l="Unverified")),g&&(g instanceof E.ExtensionManagementError?(k=g.code,g.code===E.ExtensionManagementErrorCode.Signature&&(S=g.message)):k=E.ExtensionManagementErrorCode.Internal),r.publicLog(i,{...a,verificationStatus:l,success:!g,duration:c,errorcode:k,errorcodeDetail:S,durationSinceUpdate:D})}class n{constructor(){this.d=new L.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.createCancelablePromise)(i=>new Promise((a,l)=>{const c=i.onCancellationRequested(()=>{c.dispose(),l(new P.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=n}),define(ge[44],pe([1,0,14,15,2,6,27,4,30,34,16,5,12,32,35,8,11,31]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class f extends Error{constructor(r,i){super(r),this.code=i}}e.ExtensionsProfileScanningError=f,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let I=e.AbstractExtensionsProfileScannerService=class extends o.Disposable{constructor(r,i,a,l,c,g){super(),this.i=r,this.j=i,this.k=a,this.l=l,this.m=c,this.n=g,this.b=this.B(new P.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new P.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new P.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new P.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new C.ResourceMap}scanProfileExtensions(r,i){return this.p(r,void 0,i)}async addExtensionsToProfile(r,i){const a=[],l=[];try{return await this.p(i,c=>{const g=[];for(const D of c)r.some(([k])=>(0,m.areSameExtensions)(k.identifier,D.identifier)&&k.manifest.version!==D.version)?a.push(D):g.push(D);for(const[D,k]of r)if(!g.some(S=>(0,m.areSameExtensions)(S.identifier,D.identifier)&&S.version===D.manifest.version)){const S={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:k};l.push(S),g.push(S)}return l.length&&this.b.fire({extensions:l,profileLocation:i}),a.length&&this.f.fire({extensions:a,profileLocation:i}),g}),l.length&&this.c.fire({extensions:l,profileLocation:i}),a.length&&this.g.fire({extensions:a,profileLocation:i}),l}catch(c){throw l.length&&this.c.fire({extensions:l,error:c,profileLocation:i}),a.length&&this.g.fire({extensions:a,error:c,profileLocation:i}),c}}async updateMetadata(r,i){const a=[];return await this.p(i,l=>{const c=[];for(const g of l){const D=r.find(([k])=>(0,m.areSameExtensions)(k.identifier,g.identifier)&&k.manifest.version===g.version);D&&(g.metadata={...g.metadata,...D[1]},a.push(g)),c.push(g)}return c}),a}async removeExtensionFromProfile(r,i){const a=[];this.f.fire({extensions:a,profileLocation:i});try{await this.p(i,l=>{const c=[];for(const g of l)(0,m.areSameExtensions)(g.identifier,r.identifier)?a.push(g):c.push(g);return a.length&&this.f.fire({extensions:a,profileLocation:i}),c}),a.length&&this.g.fire({extensions:a,profileLocation:i})}catch(l){throw a.length&&this.g.fire({extensions:a,error:l,profileLocation:i}),l}}async p(r,i,a){return this.w(r).queue(async()=>{let l=[],c;try{const g=await this.j.readFile(r);c=JSON.parse(g.value.toString().trim()||"[]")}catch(g){if((0,T.toFileOperationResult)(g)!==1)throw g;if(this.l.extUri.isEqual(r,this.k.defaultProfile.extensionsResource)&&(c=await this.v()),!c&&a?.bailOutWhenFileNotFound)throw new f((0,s.getErrorMessage)(g),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.r(r);let g=!1;for(const D of c){O(D)||this.r(r);let k;if((0,b.isString)(D.relativeLocation)&&D.relativeLocation)k=this.t(D.relativeLocation);else if((0,b.isString)(D.location))k=this.t(D.location),g=!0,D.relativeLocation=D.location,D.location=k.toJSON();else{k=A.URI.revive(D.location);const S=this.s(k);S&&(g=!0,D.relativeLocation=S)}l.push({identifier:D.identifier,location:k,version:D.version,metadata:D.metadata})}g&&await this.j.writeFile(r,L.VSBuffer.fromString(JSON.stringify(c)))}if(i){l=i(l);const g=l.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.s(D.location),metadata:D.metadata}));await this.j.writeFile(r,L.VSBuffer.fromString(JSON.stringify(g)))}return l})}r(r){const i=new f(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(r){return this.l.extUri.isEqual(this.l.extUri.dirname(r),this.i)?this.l.extUri.basename(r):void 0}t(r){return this.l.extUri.joinPath(this.i,r)}async v(){return this.u||(this.u=(async()=>{const r=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let a;try{a=(await this.j.readFile(r)).value.toString()}catch(c){if((0,T.toFileOperationResult)(c)===1)return;throw c}this.n.info("Migrating extensions from old default profile location",r.toString());let l;try{const c=JSON.parse(a);Array.isArray(c)&&c.every(g=>O(g))?l=c:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.n.error(c)}if(l)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",r.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(c){if((0,T.toFileOperationResult)(c)===3)this.n.info("Migration from old default profile location to new location is done by another window",r.toString(),this.k.defaultProfile.extensionsResource.toString());else throw c}try{await this.j.del(r)}catch(c){(0,T.toFileOperationResult)(c)!==1&&this.n.error(c)}try{await this.j.del(i)}catch(c){(0,T.toFileOperationResult)(c)!==1&&this.n.error(c)}return l})()),this.u}w(r){let i=this.h.get(r);return i||(i=new w.Queue,this.h.set(r,i)),i}};e.AbstractExtensionsProfileScannerService=I=Le([Re(1,T.IFileService),Re(2,d.IUserDataProfilesService),Re(3,p.IUriIdentityService),Re(4,h.ITelemetryService),Re(5,E.ILogService)],I);function O(n){return(0,b.isObject)(n)&&(0,v.isIExtensionIdentifier)(n.identifier)&&(t(n.location)||(0,b.isString)(n.location)&&n.location)&&((0,b.isUndefined)(n.relativeLocation)||(0,b.isString)(n.relativeLocation))&&n.version&&(0,b.isString)(n.version)}function t(n){return n?(0,b.isString)(n.path)&&(0,b.isString)(n.scheme):!1}}),define(ge[56],pe([1,0,18,14,21,15,11,72,155,2,13,7,3,19,52,59,8,4,178,25,34,36,77,16,5,12,26,6,61,44,32,35,208]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u,f,I,O,t,n,r,i,a,l,c,g,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var F;(function(K){function ee(z,q){if(z===q)return!0;const G=Object.keys(z),ne=new Set;for(const se of Object.keys(q))ne.add(se);if(G.length!==ne.size)return!1;for(const se of G){if(z[se]!==q[se])return!1;ne.delete(se)}return ne.size===0}K.equals=ee})(F||(e.Translations=F={})),e.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let H=e.AbstractExtensionsScannerService=class extends m.Disposable{constructor(ee,z,q,G,ne,se,de,W,x,N,R,U){super(),this.systemExtensionsLocation=ee,this.userExtensionsLocation=z,this.l=q,this.m=G,this.n=ne,this.r=se,this.s=de,this.t=W,this.u=x,this.v=N,this.w=R,this.y=U,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(le,this.m,this.h)),this.j=this.B(this.y.createInstance(le,this.m,this.h)),this.k=this.B(this.y.createInstance(ce,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,I.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(ee,z,q){const[G,ne]=await Promise.all([this.scanSystemExtensions(ee),this.scanUserExtensions(z)]),se=q?await this.scanExtensionsUnderDevelopment(ee,[...G,...ne]):[];return this.G(G,ne,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(ee){const z=[];z.push(this.H(!!ee.useCache,ee.language)),z.push(this.I(ee.language,!!ee.checkControlFile));const[q,G]=await Promise.all(z);return this.F([...q,...G],0,ee,!1)}async scanUserExtensions(ee){const z=ee.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",z);const q=this.w.extUri.isEqual(ee.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,G=await this.L(z,!!ee.profileLocation,1,!ee.includeUninstalled,ee.language,!0,q),ne=ee.useCache&&!G.devMode&&G.excludeObsolete?this.j:this.k;let se;try{se=await ne.scanExtensions(G)}catch(de){if(de instanceof g.ExtensionsProfileScanningError&&de.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),se=await ne.scanExtensions(G);else throw de}return se=await this.F(se,1,ee,!0),this.t.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(ee,z){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const q=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(G=>G.scheme===T.Schemas.file).map(async G=>{const ne=await this.L(G,!1,1,!0,ee.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ne)).map(de=>(de.type=z.find(W=>(0,I.areSameExtensions)(W.identifier,de.identifier))?.type??de.type,this.k.validate(de,ne)))}))).flat();return this.F(q,"development",ee,!0)}return[]}async scanExistingExtension(ee,z,q){const G=await this.L(ee,!1,z,!0,q.language,!0,void 0),ne=await this.k.scanExtension(G);return!ne||!q.includeInvalid&&!ne.isValid?null:ne}async scanOneOrMultipleExtensions(ee,z,q){const G=await this.L(ee,!1,z,!0,q.language,!0,void 0),ne=await this.k.scanOneOrMultipleExtensions(G);return this.F(ne,z,q,!0)}async scanMetadata(ee){const z=(0,d.joinPath)(ee,"package.json"),q=(await this.s.readFile(z)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(ee,z){const q=(0,d.joinPath)(ee,"package.json"),G=(await this.s.readFile(q)).value.toString(),ne=JSON.parse(G);z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,ne.__metadata={...ne.__metadata,...z},await this.s.writeFile((0,d.joinPath)(ee,"package.json"),P.VSBuffer.fromString(JSON.stringify(ne,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(ee){if(ee instanceof g.ExtensionsProfileScanningError&&ee.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw ee}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const ee=await this.scanUserExtensions({includeInvalid:!0});if(ee.length)await this.r.addExtensionsToProfile(ee.map(z=>[z,z.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,P.VSBuffer.fromString(JSON.stringify([])))}catch(z){(0,n.toFileOperationResult)(z)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.getErrorMessage)(z))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(ee){this.t.error(ee)}finally{this.C=void 0}})()),this.C}async F(ee,z,q,G){return q.includeAllVersions||(ee=this.G(z===0?ee:void 0,z===1?ee:void 0,z==="development"?ee:void 0,await this.getTargetPlatform(),G)),q.includeInvalid||(ee=ee.filter(ne=>ne.isValid)),ee.sort((ne,se)=>{const de=y.basename(ne.location.fsPath),W=y.basename(se.location.fsPath);return de<W?-1:de>W?1:0})}G(ee,z,q,G,ne){const se=(W,x,N)=>{if(W.isValid&&!x.isValid)return!1;if(W.isValid===x.isValid){if(ne&&p.gt(W.manifest.version,x.manifest.version))return this.t.debug(`Skipping extension ${x.location.path} with lower version ${x.manifest.version} in favour of ${W.location.path} with version ${W.manifest.version}`),!1;if(p.eq(W.manifest.version,x.manifest.version)){if(W.type===0)return this.t.debug(`Skipping extension ${x.location.path} in favour of system extension ${W.location.path} with same version`),!1;if(W.targetPlatform===G)return this.t.debug(`Skipping extension ${x.location.path} from different target platform ${x.targetPlatform}`),!1}}return N?this.t.warn(`Overwriting user extension ${W.location.path} with ${x.location.path}.`):this.t.debug(`Overwriting user extension ${W.location.path} with ${x.location.path}.`),!0},de=new O.ExtensionIdentifierMap;return ee?.forEach(W=>{const x=de.get(W.identifier.id);(!x||se(x,W,!1))&&de.set(W.identifier.id,W)}),z?.forEach(W=>{const x=de.get(W.identifier.id);if(!x&&ee&&W.type===0){this.t.debug(`Skipping obsolete system extension ${W.location.path}.`);return}(!x||se(x,W,!1))&&de.set(W.identifier.id,W)}),q?.forEach(W=>{const x=de.get(W.identifier.id);(!x||se(x,W,!0))&&de.set(W.identifier.id,W),de.set(W.identifier.id,W)}),[...de.values()]}async H(ee,z){this.t.trace("Started scanning system extensions");const q=await this.L(this.systemExtensionsLocation,!1,0,!0,z,!0,void 0),ne=await(ee&&!q.devMode?this.i:this.k).scanExtensions(q);return this.t.trace("Scanned system extensions:",ne.length),ne}async I(ee,z){const q=this.u.isBuilt?[]:this.v.builtInExtensions;if(!q?.length)return[];this.t.trace("Started scanning dev system extensions");const G=z?await this.J():{},ne=[],se=h.URI.file(y.normalize(y.join(T.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const W of q){const x=G[W.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":ne.push((0,d.joinPath)(se,W.name));break;default:ne.push(h.URI.file(x));break}}const de=await Promise.all(ne.map(async W=>this.k.scanExtension(await this.L(W,!1,0,!0,ee,!0,void 0))));return this.t.trace("Scanned dev system extensions:",de.length),(0,w.coalesce)(de)}async J(){try{const ee=await this.s.readFile(this.l);return JSON.parse(ee.value.toString())}catch{return{}}}async L(ee,z,q,G,ne,se,de){const W=await this.f(ne??E.language),x=await this.M(ee),N=z&&!this.w.extUri.isEqual(ee,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,R=N?await this.M(N):void 0;return new te(ee,x,N,R,z,de,q,G,se,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,ne,W)}async M(ee){try{const z=await this.s.stat(ee);if(typeof z.mtime=="number")return z.mtime}catch{}}};e.AbstractExtensionsScannerService=H=Le([Re(4,D.IUserDataProfilesService),Re(5,g.IExtensionsProfileScannerService),Re(6,n.IFileService),Re(7,i.ILogService),Re(8,f.IEnvironmentService),Re(9,a.IProductService),Re(10,k.IUriIdentityService),Re(11,r.IInstantiationService)],H);class te{constructor(ee,z,q,G,ne,se,de,W,x,N,R,U,X,ie,j){this.location=ee,this.mtime=z,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=G,this.profile=ne,this.profileScanOptions=se,this.type=de,this.excludeObsolete=W,this.validate=x,this.productVersion=N,this.productDate=R,this.productCommit=U,this.devMode=X,this.language=ie,this.translations=j}static createNlsConfiguration(ee){return{language:ee.language,pseudo:ee.language==="pseudo",devMode:ee.devMode,translations:ee.translations}}static equals(ee,z){return(0,d.isEqual)(ee.location,z.location)&&ee.mtime===z.mtime&&(0,d.isEqual)(ee.applicationExtensionslocation,z.applicationExtensionslocation)&&ee.applicationExtensionslocationMtime===z.applicationExtensionslocationMtime&&ee.profile===z.profile&&o.equals(ee.profileScanOptions,z.profileScanOptions)&&ee.type===z.type&&ee.excludeObsolete===z.excludeObsolete&&ee.validate===z.validate&&ee.productVersion===z.productVersion&&ee.productDate===z.productDate&&ee.productCommit===z.productCommit&&ee.devMode===z.devMode&&ee.language===z.language&&F.equals(ee.translations,z.translations)}}e.ExtensionScannerInput=te;let ce=class extends m.Disposable{constructor(ee,z,q,G,ne){super(),this.f=ee,this.g=z,this.h=q,this.i=G,this.j=ne}async scanExtensions(ee){const z=ee.profile?await this.l(ee):await this.k(ee);let q={};if(ee.excludeObsolete&&ee.type===1)try{const G=(await this.i.readFile(this.f)).value.toString();q=JSON.parse(G)}catch{}return(0,s.isEmptyObject)(q)?z:z.filter(G=>!q[I.ExtensionKey.create(G).toString()])}async k(ee){const z=await this.i.resolve(ee.location);if(!z.children?.length)return[];const q=await Promise.all(z.children.map(async G=>{if(!G.isDirectory||ee.type===1&&(0,d.basename)(G.resource).indexOf(".")===0)return null;const ne=new te(G.resource,ee.mtime,ee.applicationExtensionslocation,ee.applicationExtensionslocationMtime,ee.profile,ee.profileScanOptions,ee.type,ee.excludeObsolete,ee.validate,ee.productVersion,ee.productDate,ee.productCommit,ee.devMode,ee.language,ee.translations);return this.scanExtension(ne)}));return(0,w.coalesce)(q).sort((G,ne)=>G.location.path<ne.location.path?-1:1)}async l(ee){let z=await this.m(ee.location,()=>!0,ee);if(ee.applicationExtensionslocation&&!this.h.extUri.isEqual(ee.location,ee.applicationExtensionslocation)){z=z.filter(G=>!G.metadata?.isApplicationScoped);const q=await this.m(ee.applicationExtensionslocation,G=>!!G.metadata?.isBuiltin||!!G.metadata?.isApplicationScoped,ee);z.push(...q)}return z}async m(ee,z,q){const G=await this.g.scanProfileExtensions(ee,q.profileScanOptions);if(!G.length)return[];const ne=await Promise.all(G.map(async se=>{if(z(se)){const de=new te(se.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(de,se.metadata)}return null}));return(0,w.coalesce)(ne)}async scanOneOrMultipleExtensions(ee){try{if(await this.i.exists((0,d.joinPath)(ee.location,"package.json"))){const z=await this.scanExtension(ee);return z?[z]:[]}else return await this.scanExtensions(ee)}catch(z){return this.j.error(`Error scanning extensions at ${ee.location.path}:`,(0,C.getErrorMessage)(z)),[]}}async scanExtension(ee,z){try{let q=await this.scanExtensionManifest(ee.location);if(q){q.publisher||(q.publisher=O.UNDEFINED_PUBLISHER),z=z??q.__metadata,delete q.__metadata;const G=(0,I.getGalleryExtensionId)(q.publisher,q.name),ne=z?.id?{id:G,uuid:z.id}:{id:G},se=z?.isSystem?0:ee.type,de=se===0||!!z?.isBuiltin;q=await this.n(ee.location,q,te.createNlsConfiguration(ee));const W={type:se,identifier:ne,manifest:q,location:ee.location,isBuiltin:de,targetPlatform:z?.targetPlatform??"undefined",metadata:z,isValid:!0,validations:[]};return ee.validate?this.validate(W,ee):W}}catch(q){ee.type!==0&&this.j.error(q)}return null}validate(ee,z){let q=!0;const G=(0,t.validateExtensionManifest)(z.productVersion,z.productDate,z.location,ee.manifest,ee.isBuiltin);for(const[ne,se]of G)ne===b.default.Error&&(q=!1,this.j.error(this.u(z.location,se)));return ee.isValid=q,ee.validations=G,ee}async scanExtensionManifest(ee){const z=(0,d.joinPath)(ee,"package.json");let q;try{q=(await this.i.readFile(z)).value.toString()}catch(ne){return(0,n.toFileOperationResult)(ne)!==1&&this.j.error(this.u(ee,(0,u.localize)(0,null,z.path,ne.message))),null}let G;try{G=JSON.parse(q)}catch{const se=[];(0,A.parse)(q,se);for(const de of se)this.j.error(this.u(ee,(0,u.localize)(1,null,z.path,de.offset,de.length,(0,v.getParseErrorMessage)(de.error))));return null}return(0,A.getNodeType)(G)!=="object"?(this.j.error(this.u(ee,(0,u.localize)(2,null,z.path))),null):G}async n(ee,z,q){const G=await this.r(ee,z,q);if(G)try{const ne=[],se=await this.s(G.default,ne);if(ne.length>0)return ne.forEach(W=>{this.j.error(this.u(ee,(0,u.localize)(3,null,G.default?.path,(0,v.getParseErrorMessage)(W.error))))}),z;if((0,A.getNodeType)(G)!=="object")return this.j.error(this.u(ee,(0,u.localize)(4,null,G.default?.path))),z;const de=G.values||Object.create(null);return(0,S.localizeManifest)(z,de,se)}catch{}return z}async r(ee,z,q){const G=(0,d.joinPath)(ee,"package.nls.json"),ne=(x,N)=>{N.forEach(R=>{this.j.error(this.u(ee,(0,u.localize)(5,null,x?.path,(0,v.getParseErrorMessage)(R.error))))})},se=x=>{this.j.error(this.u(ee,(0,u.localize)(6,null,x?.path)))},de=`${z.publisher}.${z.name}`,W=q.translations[de];if(W)try{const x=h.URI.file(W),N=(await this.i.readFile(x)).value.toString(),R=[],U=(0,A.parse)(N,R);return R.length>0?(ne(x,R),{values:void 0,default:G}):(0,A.getNodeType)(U)!=="object"?(se(x),{values:void 0,default:G}):{values:U.contents?U.contents.package:void 0,default:G}}catch{return{values:void 0,default:G}}else{if(!await this.i.exists(G))return;let N;try{N=await this.t(ee,q)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const R=(await this.i.readFile(N.localized)).value.toString(),U=[],X=(0,A.parse)(R,U);return U.length>0?(ne(N.localized,U),{values:void 0,default:N.original}):(0,A.getNodeType)(X)!=="object"?(se(N.localized),{values:void 0,default:N.original}):{values:X,default:N.original}}catch{return{values:void 0,default:N.original}}}}async s(ee,z){if(ee)try{const q=(await this.i.readFile(ee)).value.toString();return(0,A.parse)(q,z)}catch{}}t(ee,z){return new Promise((q,G)=>{const ne=se=>{const de=(0,d.joinPath)(ee,`package.nls.${se}.json`);this.i.exists(de).then(W=>{W&&q({localized:de,original:(0,d.joinPath)(ee,"package.nls.json")});const x=se.lastIndexOf("-");x===-1?q({localized:(0,d.joinPath)(ee,"package.nls.json"),original:null}):(se=se.substring(0,x),ne(se))})};if(z.devMode||z.pseudo||!z.language)return q({localized:(0,d.joinPath)(ee,"package.nls.json"),original:null});ne(z.language)})}u(ee,z){return`[${ee.path}]: ${z}`}};ce=Le([Re(1,g.IExtensionsProfileScannerService),Re(2,k.IUriIdentityService),Re(3,n.IFileService),Re(4,i.ILogService)],ce);let le=class extends ce{constructor(ee,z,q,G,ne,se,de){super(z,G,ne,se,de),this.z=ee,this.C=q,this.w=this.B(new L.ThrottledDelayer(3e3)),this.y=this.B(new l.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(ee){const z=this.H(ee),q=await this.D(z);if(this.v=ee,q&&q.input&&te.equals(q.input,this.v))return this.j.debug("Using cached extensions scan result",ee.location.toString()),this.w.trigger(()=>this.G()),q.result.map(ne=>(ne.location=h.URI.revive(ne.location),ne));const G=await super.scanExtensions(ee);return await this.F(z,{input:ee,result:G}),G}async D(ee){try{const z=await this.i.readFile(ee),q=JSON.parse(z.value.toString());return{result:q.result,input:(0,c.revive)(q.input)}}catch(z){this.j.debug("Error while reading the extension cache file:",ee.path,(0,C.getErrorMessage)(z))}return null}async F(ee,z){try{await this.i.writeFile(ee,P.VSBuffer.fromString(JSON.stringify(z)))}catch(q){this.j.debug("Error while writing the extension cache file:",ee.path,(0,C.getErrorMessage)(q))}}async G(){if(!this.v)return;const ee=this.H(this.v),z=await this.D(ee);if(!z)return;const q=z.result,G=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!o.equals(G,q))try{this.j.info("Invalidating Cache",q,G),await this.i.del(ee),this.y.fire()}catch(ne){this.j.error(ne)}}H(ee){const z=this.I(ee);return this.h.extUri.joinPath(z.cacheHome,ee.type===0?O.BUILTIN_MANIFEST_CACHE_FILE:O.USER_MANIFEST_CACHE_FILE)}I(ee){return ee.type===0?this.C.defaultProfile:ee.profile?this.h.extUri.isEqual(ee.location,this.z.extensionsResource)?this.z:this.C.profiles.find(z=>this.h.extUri.isEqual(ee.location,z.extensionsResource))??this.z:this.C.defaultProfile}};le=Le([Re(2,D.IUserDataProfilesService),Re(3,g.IExtensionsProfileScannerService),Re(4,k.IUriIdentityService),Re(5,n.IFileService),Re(6,i.ILogService)],le);function ue(K,ee){const z=(0,I.getExtensionId)(K.manifest.publisher,K.manifest.name);return{id:z,identifier:new O.ExtensionIdentifier(z),isBuiltin:K.type===0,isUserBuiltin:K.type===1&&K.isBuiltin,isUnderDevelopment:ee,extensionLocation:K.location,uuid:K.identifier.uuid,targetPlatform:K.targetPlatform,...K.manifest}}e.toExtensionDescription=ue;class ve extends H{constructor(ee,z,q,G,ne,se,de,W,x,N,R,U){super(ee,z,(0,d.joinPath)(q,".vscode-oss-dev","extensions","control.json"),G,ne,se,de,W,x,N,R,U),this.N=(async()=>{if(E.translationsConfigFile)try{const X=await this.s.readFile(h.URI.file(E.translationsConfigFile));return JSON.parse(X.value.toString())}catch{}return Object.create(null)})()}f(ee){return this.N}}e.NativeExtensionsScannerService=ve}),define(ge[256],pe([1,0,51,14,38,6,2,13,7,23,12,32]),function(oe,e,w,L,o,P,C,A,v,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let E=e.ExtensionsLifecycle=class extends C.Disposable{constructor(p,b){super(),this.b=p,this.f=b,this.a=new L.Limiter(5)}async postUninstall(p){const b=this.g(p,"uninstall");b&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(s){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(s)}}));try{await m.Promises.rm(this.j(p))}catch(s){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(s)}}g(p,b){const s=`vscode:${b}`;if(p.location.scheme===A.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[s]=="string"){const h=p.manifest.scripts[s].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${s} should be a node script`),null):{script:(0,v.join)(p.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(p,b,s,h,u){return new Promise((f,I)=>{const O=this.i(p,b,s,u);let t;const n=r=>{t&&(clearTimeout(t),t=null),r?I(r):f(void 0)};O.on("error",r=>{n((0,o.toErrorMessage)(r)||"Unknown")}),O.on("exit",(r,i)=>{n(r?`post-${b} process exited with code ${r}`:void 0)}),h&&(t=setTimeout(()=>{t=null,O.kill(),I("timed out")},5e3))})}i(p,b,s,h){const u={silent:!0,execArgv:void 0},f=(0,w.fork)(p,[`--type=extension-post-${b}`,...s],u);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const I=P.Event.fromNodeEventEmitter(f.stdout,"data"),O=P.Event.fromNodeEventEmitter(f.stderr,"data");I(r=>this.f.info(h.identifier.id,h.manifest.version,`post-${b}`,r)),O(r=>this.f.error(h.identifier.id,h.manifest.version,`post-${b}`,r));const t=P.Event.any(P.Event.map(I,r=>({data:`%c${r}`,format:[""]})),P.Event.map(O,r=>({data:`%c${r}`,format:["color: red"]})));return P.Event.debounce(t,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100)(r=>{console.group(h.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),f}j(p){return(0,v.join)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=E=Le([Re(0,y.IUserDataProfilesService),Re(1,T.ILogService)],E)}),define(ge[123],pe([1,0,12,32,35,31,44,16,25,4]),function(oe,e,w,L,o,P,C,A,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let T=e.ExtensionsProfileScannerService=class extends C.AbstractExtensionsProfileScannerService{constructor(E,d,p,b,s,h){super(m.URI.file(E.extensionsPath),d,p,b,s,h)}};e.ExtensionsProfileScannerService=T=Le([Re(0,v.INativeEnvironmentService),Re(1,A.IFileService),Re(2,L.IUserDataProfilesService),Re(3,o.IUriIdentityService),Re(4,P.ITelemetryService),Re(5,w.ILogService)],T)}),define(ge[257],pe([1,0,14,6,2,41,8,165,5,32]),function(oe,e,w,L,o,P,C,A,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,v.createDecorator)("storageService");var T;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var y;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var E;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(E||(e.StorageTarget=E={}));function d(u){const f=u.get(e.TARGET_KEY);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.loadKeyTargets=d;class p extends o.Disposable{constructor(f={flushInterval:p.a}){super(),this.j=f,this.b=this.B(new L.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new L.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new w.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new o.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,w.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,o.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.J()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(f,I){if(I===e.TARGET_KEY){switch(f){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:f})}else this.b.fire({scope:f,key:I,target:this.F(f)[I]})}r(f){this.f.fire({reason:f})}get(f,I,O){return this.L(I)?.get(f,O)}getBoolean(f,I,O){return this.L(I)?.getBoolean(f,O)}getNumber(f,I,O){return this.L(I)?.getNumber(f,O)}store(f,I,O,t){if((0,C.isUndefinedOrNull)(I)){this.remove(f,O);return}this.t(()=>{this.u(f,O,t),this.L(O)?.set(f,I)})}remove(f,I){this.t(()=>{this.u(f,I,void 0),this.L(I)?.delete(f)})}t(f){this.b.pause(),this.c.pause();try{f()}finally{this.b.resume(),this.c.resume()}}keys(f,I){const O=[],t=this.F(f);for(const n of Object.keys(t))t[n]===I&&O.push(n);return O}u(f,I,O){const t=this.F(I);typeof O=="number"?t[f]!==O&&(t[f]=O,this.L(I)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[f]=="number"&&(delete t[f],this.L(I)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(f){switch(f){case-1:return this.D;case 0:return this.z;default:return this.w}}G(f){const I=this.L(f);return I?d(I):Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=T.NONE){this.f.fire({reason:f});const I=this.L(-1),O=this.L(0),t=this.L(1);switch(f){case T.NONE:await w.Promises.settled([I?.whenFlushed()??Promise.resolve(),O?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await w.Promises.settled([I?.flush(0)??Promise.resolve(),O?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.L(-1)?.items??new Map,I=this.L(0)?.items??new Map,O=this.L(1)?.items??new Map;return h(f,I,O,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(f,I){return this.r(T.NONE),(0,m.isUserDataProfile)(f)?this.N(f,I):this.O(f,I)}H(f,I){return!(f.id===I.id||b(I)&&b(f))}I(f,I,O,t){this.t(()=>{if(t)for(const[n,r]of f)I.set(n,r);else{const n=new Set;for(const[r,i]of f)n.add(r),I.get(r)!==i&&this.n(O,r);for(const[r]of I.items)n.has(r)||this.n(O,r)}})}}e.AbstractStorageService=p,p.a=60*1e3;function b(u){return u.isDefault||!!u.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=b;class s extends p{constructor(){super(),this.p=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(f=>this.n(1,f))),this.B(this.P.onDidChangeStorage(f=>this.n(0,f))),this.B(this.p.onDidChangeStorage(f=>this.n(-1,f)))}L(f){switch(f){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(f){return!1}}e.InMemoryStorageService=s;async function h(u,f,I,O,t,n){const r=F=>{try{return JSON.parse(F)}catch{return F}},i=new Map,a=new Map;u.forEach((F,H)=>{i.set(H,F),a.set(H,r(F))});const l=new Map,c=new Map;f.forEach((F,H)=>{l.set(H,F),c.set(H,r(F))});const g=new Map,D=new Map;I.forEach((F,H)=>{g.set(H,F),D.set(H,r(F))}),console.group(O!==t?`Storage: Application (path: ${O})`:`Storage: Application & Profile (path: ${O}, default profile)`);const k=[];if(i.forEach((F,H)=>{k.push({key:H,value:F})}),console.table(k),console.groupEnd(),console.log(a),O!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const F=[];l.forEach((H,te)=>{F.push({key:te,value:H})}),console.table(F),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${n})`);const S=[];g.forEach((F,H)=>{S.push({key:H,value:F})}),console.table(S),console.groupEnd(),console.log(D)}e.logStorage=h}),define(ge[124],pe([1,0,18,20,11,3,29,8,4,24,25,30,34,77,16,12,26,43,242,257,31]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const O=P.isWeb?"web":(0,y.getTargetPlatform)(P.platform,C.arch),t="X-Market-Search-Activity-Id";var n;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function r(...N){return String(N.reduce((R,U)=>R|U,0))}var i;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},g={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class D{constructor(R=g){this.d=R}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(R,U=this.d.pageSize){return new D({...this.d,pageNumber:R,pageSize:U})}withFilter(R,...U){const X=[...this.d.criteria,...U.length?U.map(ie=>({filterType:R,value:ie})):[{filterType:R}]];return new D({...this.d,criteria:X})}withSortBy(R){return new D({...this.d,sortBy:R})}withSortOrder(R){return new D({...this.d,sortOrder:R})}withFlags(...R){return new D({...this.d,flags:R.reduce((U,X)=>U|X,0)})}withAssetTypes(...R){return new D({...this.d,assetTypes:R})}withSource(R){return new D({...this.d,source:R})}get raw(){const{criteria:R,pageNumber:U,pageSize:X,sortBy:ie,sortOrder:j,flags:$,assetTypes:J}=this.d;return{filters:[{criteria:R,pageNumber:U,pageSize:X,sortBy:ie,sortOrder:j}],assetTypes:J,flags:$}}get searchText(){const R=this.d.criteria.filter(U=>U.filterType===i.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(R=>String(R.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function k(N,R){const U=(N||[]).filter(X=>X.statisticName===R)[0];return U?U.value:0}function S(N){const R="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(X=>X.assetType.indexOf(R)===0).reduce((X,ie)=>{const j=te(N,ie.assetType);return j&&X.push([ie.assetType.substring(R.length),j]),X},[])}function F(N){if(N.properties){const R=N.properties.filter(ie=>ie.key===a.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),X=R.filter(ie=>U.test(ie.value))[0];return X?{uri:X.value,fallbackUri:X.value}:null}return te(N,a.Repository)}function H(N){return{uri:`${N.fallbackAssetUri}/${a.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${a.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function te(N,R){return N.files.filter(X=>X.assetType===R)[0]?{uri:`${N.assetUri}/${R}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${R}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function ce(N,R){const U=N.properties?N.properties.filter(ie=>ie.key===R):[],X=U.length>0&&U[0].value;return X?X.split(",").map(ie=>(0,E.adoptToGalleryExtensionId)(ie)):[]}function le(N){const R=N.properties?N.properties.filter(U=>U.key===l.Engine):[];return R.length>0&&R[0].value||""}function ue(N){const R=N.properties?N.properties.filter(U=>U.key===l.PreRelease):[];return R.length>0&&R[0].value==="true"}function ve(N){const R=N.properties?N.properties.filter(X=>X.key===l.LocalizedLanguages):[],U=R.length>0&&R[0].value||"";return U?U.split(","):[]}function K(N){return N.properties?.find(R=>R.key===l.SponsorLink)?.value}function ee(N){return N.indexOf("preview")!==-1}function z(N){return N.targetPlatform?(0,y.toTargetPlatform)(N.targetPlatform):"undefined"}function q(N){const R=(0,w.distinct)(N.versions.map(z)),U=!!N.tags?.includes(y.WEB_EXTENSION_TAG),X=R.indexOf("web");return U?X===-1&&R.push("web"):X!==-1&&R.splice(X,1),R}function G(N,R){const U=(0,y.getFallbackTargetPlarforms)(R);for(let X=0;X<N.length;X++){const ie=N[X];if(ie.version===N[X-1]?.version){let j=X;const $=z(ie);if($===R)for(;j>0&&N[j-1].version===ie.version;)j--;else if(U.includes($))for(;j>0&&N[j-1].version===ie.version&&z(N[j-1])!==R;)j--;j!==X&&(N.splice(X,1),N.splice(j,0,ie))}}return N}e.sortExtensionVersions=G;function ne(N,R,U){N.telemetryData={index:R,querySource:U,queryActivityId:N.queryContext?.[t]}}function se(N,R,U,X){const ie=N.versions[0],j={manifest:te(R,a.Manifest),readme:te(R,a.Details),changelog:te(R,a.Changelog),license:te(R,a.License),repository:F(R),download:H(R),icon:te(R,a.Icon),signature:te(R,a.Signature),coreTranslations:S(R)};return{identifier:{id:(0,E.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:R.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:K(ie),description:N.shortDescription||"",installCount:k(N.statistics,"install"),rating:k(N.statistics,"averagerating"),ratingCount:k(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:U,assets:j,properties:{dependencies:ce(R,l.Dependency),extensionPack:ce(R,l.ExtensionPack),engine:le(R),localizedLanguages:ve(R),targetPlatform:z(R),isPreReleaseVersion:ue(R)},hasPreReleaseVersion:ue(ie),hasReleaseVersion:!0,preview:ee(N.flags),isSigned:!!j.signature,queryContext:X}}let de=class{constructor(R,U,X,ie,j,$,J,V){this.k=U,this.l=X,this.n=ie,this.o=j,this.q=$,this.u=J,this.w=V;const Z=J.extensionsGallery,Y=Z?.servicePPEUrl&&V.getValue("_extensionsGallery.enablePPE");this.d=Y?Z.servicePPEUrl:Z?.serviceUrl,this.g=Y?void 0:Z?.searchUrl,this.h=Z?.controlUrl,this.j=(0,u.resolveMarketplaceHeaders)(J.version,J,this.n,this.w,this.q,R,this.o)}x(R=""){return`${this.d}${R}`}isEnabled(){return!!this.d}async getExtensions(R,U,X){const ie=L.CancellationToken.isCancellationToken(U)?{}:U,j=L.CancellationToken.isCancellationToken(U)?U:X,$=[],J=[],V=[],Z=[];let Y=!0;for(const Ee of R){Ee.uuid?J.push(Ee.uuid):$.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);V.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&Z.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),Y=Y&&!!Ee.hasPreRelease&&!Ce}if(!J.length&&!$.length)return[];let _=new D().withPage(1,R.length);J.length&&(_=_.withFilter(i.ExtensionId,...J)),$.length&&(_=_.withFilter(i.ExtensionName,...$)),(ie.queryAllVersions||Y)&&(_=_.withFlags(_.flags,n.IncludeVersions)),ie.source&&(_=_.withSource(ie.source));const{extensions:ae}=await this.z(_,{targetPlatform:ie.targetPlatform??O,includePreRelease:V,versions:Z,compatible:!!ie.compatible},j);return ie.source&&ae.forEach((Ee,Ce)=>ne(Ee,Ce,ie.source)),ae}async getCompatibleExtension(R,U,X){if((0,y.isNotWebExtensionInWebTargetPlatform)(R.allTargetPlatforms,X))return null;if(await this.isExtensionCompatible(R,U,X))return R;const ie=new D().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,R.identifier.uuid),{extensions:j}=await this.z(ie,{targetPlatform:X,compatible:!0,includePreRelease:U},L.CancellationToken.None);return j[0]||null}async isExtensionCompatible(R,U,X){if(!(0,y.isTargetPlatformCompatible)(R.properties.targetPlatform,R.allTargetPlatforms,X)||!U&&R.properties.isPreReleaseVersion)return!1;let ie=R.properties.engine;if(!ie){const j=await this.getManifest(R,L.CancellationToken.None);if(!j)throw new Error("Manifest was not found");ie=j.engines.vscode}return(0,d.isEngineValid)(ie,this.u.version,this.u.date)}async y(R,U,X,ie,j){if(!(0,y.isTargetPlatformCompatible)(z(R),ie,j)||U!=="any"&&ue(R)!==(U==="prerelease"))return!1;if(X)try{const $=await this.E(R);if(!(0,d.isEngineValid)($,this.u.version,this.u.date))return!1}catch($){return this.l.error(`Error while getting the engine for the version ${R.version}.`,(0,o.getErrorMessage)($)),!1}return!0}async query(R,U){let X=R.text||"";const ie=R.pageSize??50;let j=new D().withPage(1,ie);X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Y,_,ae)=>(j=j.withFilter(i.Category,ae||_),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Y,_,ae)=>(j=j.withFilter(i.Tag,ae||_),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(j=j.withFilter(i.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),j=j.withFilter(i.SearchText,X)),j=j.withSortBy(0)):R.ids?j=j.withFilter(i.ExtensionId,...R.ids):R.names?j=j.withFilter(i.ExtensionName,...R.names):j=j.withSortBy(4),typeof R.sortBy=="number"&&(j=j.withSortBy(R.sortBy)),typeof R.sortOrder=="number"&&(j=j.withSortOrder(R.sortOrder)),R.source&&(j=j.withSource(R.source));const $=async(Y,_)=>{const{extensions:ae,total:Ee}=await this.z(Y,{targetPlatform:O,compatible:!1,includePreRelease:!!R.includePreRelease},_);return ae.forEach((Ce,ke)=>ne(Ce,(Y.pageNumber-1)*Y.pageSize+ke,R.source)),{extensions:ae,total:Ee}},{extensions:J,total:V}=await $(j,U),Z=async(Y,_)=>{if(_.isCancellationRequested)throw new o.CancellationError;const{extensions:ae}=await $(j.withPage(Y+1),_);return ae};return{firstPage:J,total:V,pageSize:j.pageSize,getPage:Z}}async z(R,U,X){const ie=R.flags;R.flags&n.IncludeLatestVersionOnly&&R.flags&n.IncludeVersions&&(R=R.withFlags(R.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(R.flags&n.IncludeLatestVersionOnly)&&!(R.flags&n.IncludeVersions)&&(R=R.withFlags(R.flags,n.IncludeLatestVersionOnly)),U.versions?.length&&(R=R.withFlags(R.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),R=R.withFlags(R.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:j,total:$,context:J}=await this.B(R,X);if(!(R.flags&n.IncludeLatestVersionOnly)){const _=[];for(const ae of j){const Ee=await this.A(ae,U,J);Ee&&_.push(Ee)}return{extensions:_,total:$}}const Z=[],Y=new Map;for(let _=0;_<j.length;_++){const ae=j[_],Ee={id:(0,E.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),uuid:ae.extensionId},Ce=(0,A.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Ue=>(0,E.areSameExtensions)(Ue,Ee))?.includePreRelease;if(U.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(q(ae),U.targetPlatform))continue;const ke=await this.A(ae,U,J);!ke||ke.properties.isPreReleaseVersion&&(!Ce||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==U.targetPlatform&&ke.hasPreReleaseVersion?Y.set(ae.extensionId,_):Z.push([_,ke])}if(Y.size){const _=new Date().getTime(),ae=new D().withFlags(ie&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,Y.size).withFilter(i.ExtensionId,...Y.keys()),{extensions:Ee}=await this.z(ae,U,X);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-_,count:Y.size});for(const Ce of Ee){const ke=Y.get(Ce.identifier.uuid);Z.push([ke,Ce])}}return{extensions:Z.sort((_,ae)=>_[0]-ae[0]).map(([,_])=>_),total:$}}async A(R,U,X){const ie={id:(0,E.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},j=U.versions?.find(Z=>(0,E.areSameExtensions)(Z,ie))?.version,$=(0,A.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Z=>(0,E.areSameExtensions)(Z,ie))?.includePreRelease,J=q(R),V=G(R.versions,U.targetPlatform);if(U.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(J,U.targetPlatform))return null;for(let Z=0;Z<V.length;Z++){const Y=V[Z];if(!(j&&Y.version!==j)){if(await this.y(Y,$?"any":"release",U.compatible,J,U.targetPlatform))return se(R,Y,J,X);if(j&&Y.version===j)return null}}return j||U.compatible?null:se(R,R.versions[0],J)}async B(R,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,r(n.Unpublished));const X=await this.j,ie=JSON.stringify(R.raw),j={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ie.length)},$=new Date().getTime();let J,V,Z=0;try{if(J=await this.k.request({type:"POST",url:this.g&&R.criteria.some(_=>_.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:ie,headers:j},U),J.res.statusCode&&J.res.statusCode>=400&&J.res.statusCode<500)return{galleryExtensions:[],total:Z};const Y=await(0,h.asJson)(J);if(Y){const _=Y.results[0],ae=_.extensions,Ee=_.resultMetadata&&_.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return Z=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ae,total:Z,context:{[t]:J.res.headers.activityid}}}return{galleryExtensions:[],total:Z}}catch(Y){throw V=Y,Y}finally{this.o.publicLog2("galleryService:query",{...R.telemetryData,requestBodySize:String(ie.length),duration:new Date().getTime()-$,success:!!J&&(0,h.isSuccess)(J),responseBodySize:J?.res.headers["Content-Length"],statusCode:J?String(J.res.statusCode):void 0,errorCode:V?(0,o.isCancellationError)(V)?"canceled":(0,o.getErrorMessage)(V).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Z)})}}async reportStatistic(R,U,X,ie){if(!this.isEnabled())return;const j=P.isWeb?this.x(`/itemName/${R}.${U}/version/${X}/statType/${ie==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${R}/extensions/${U}/${X}/stats?statType=${ie}`),$=P.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",V={...await this.j,Accept:$};try{await this.k.request({type:"POST",url:j,headers:V},L.CancellationToken.None)}catch{}}async download(R,U,X){this.l.trace("ExtensionGalleryService#download",R.identifier.id);const ie=(0,E.getGalleryExtensionTelemetryData)(R),j=new Date().getTime(),$=_=>this.o.publicLog("galleryService:downloadVSIX",{...ie,duration:_}),J=X===2?"install":X===3?"update":"",V=J?{uri:`${R.assets.download.uri}${v.URI.parse(R.assets.download.uri).query?"&":"?"}${J}=true`,fallbackUri:`${R.assets.download.fallbackUri}${v.URI.parse(R.assets.download.fallbackUri).query?"&":"?"}${J}=true`}:R.assets.download,Z=R.queryContext?.[t]?{[t]:R.queryContext[t]}:void 0,Y=await this.D(V,Z?{headers:Z}:void 0);await this.q.writeFile(U,Y.stream),$(new Date().getTime()-j)}async downloadSignatureArchive(R,U){if(!R.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",R.identifier.id);const X=await this.D(R.assets.signature);await this.q.writeFile(U,X.stream)}async getReadme(R,U){if(R.assets.readme){const X=await this.D(R.assets.readme,{},U);return await(0,h.asTextOrError)(X)||""}return""}async getManifest(R,U){if(R.assets.manifest){const X=await this.D(R.assets.manifest,{},U),ie=await(0,h.asTextOrError)(X);return ie?JSON.parse(ie):null}return null}async C(R,U){const X=te(R,a.Manifest);if(!X)throw new Error("Manifest was not found");const ie={"Accept-Encoding":"gzip"},j=await this.D(X,{headers:ie});return await(0,h.asJson)(j)}async getCoreTranslation(R,U){const X=R.assets.coreTranslations.filter(ie=>ie[0]===U.toUpperCase())[0];if(X){const ie=await this.D(X[1]),j=await(0,h.asTextOrError)(ie);return j?JSON.parse(j):null}return null}async getChangelog(R,U){if(R.assets.changelog){const X=await this.D(R.assets.changelog,{},U);return await(0,h.asTextOrError)(X)||""}return""}async getAllCompatibleVersions(R,U,X){let ie=new D().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);R.identifier.uuid?ie=ie.withFilter(i.ExtensionId,R.identifier.uuid):ie=ie.withFilter(i.ExtensionName,R.identifier.id);const{galleryExtensions:j}=await this.B(ie,L.CancellationToken.None);if(!j.length)return[];const $=q(j[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)($,X))return[];const J=[];await Promise.all(j[0].versions.map(async Y=>{try{await this.y(Y,U?"any":"release",!0,$,X)&&J.push(Y)}catch{}}));const V=[],Z=new Set;for(const Y of G(J,X))Z.has(Y.version)||(Z.add(Y.version),V.push({version:Y.version,date:Y.lastUpdated,isPreReleaseVersion:ue(Y)}));return V}async D(R,U={},X=L.CancellationToken.None){const ie=await this.j,j={type:"GET"},$={...ie,...U.headers||{}};U={...U,...j,headers:$};const J=R.uri,V=R.fallbackUri,Z={...U,url:J};try{const Y=await this.k.request(Z,X);if(Y.res.statusCode===200)return Y;const _=await(0,h.asTextOrError)(Y);throw new Error(`Expected 200, got back ${Y.res.statusCode} instead.

${_}`)}catch(Y){if((0,o.isCancellationError)(Y))throw Y;const _=(0,o.getErrorMessage)(Y);this.o.publicLog2("galleryService:cdnFallback",{url:J,message:_});const ae={...U,url:V};return this.k.request(ae,X)}}async E(R){let U=le(R);if(!U){const X=await this.C(R,L.CancellationToken.None);if(!X)throw new Error("Manifest was not found");U=X.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const R=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,h.asJson)(R),X=[],ie={};if(U){for(const j of U.malicious)X.push({id:j});if(U.migrateToPreRelease)for(const[j,$]of Object.entries(U.migrateToPreRelease))(!$.engine||(0,d.isEngineValid)($.engine,this.u.version,this.u.date))&&(ie[j.toLowerCase()]={disallowInstall:!0,extension:{id:$.id,displayName:$.displayName,autoMigrate:{storage:!!$.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[j,$]of Object.entries(U.deprecated))$&&(ie[j.toLowerCase()]=(0,A.isBoolean)($)?{}:$)}return{malicious:X,deprecated:ie}}};de=Le([Re(1,h.IRequestService),Re(2,b.ILogService),Re(3,T.IEnvironmentService),Re(4,I.ITelemetryService),Re(5,p.IFileService),Re(6,s.IProductService),Re(7,m.IConfigurationService)],de);let W=e.ExtensionGalleryService=class extends de{constructor(R,U,X,ie,j,$,J,V){super(R,U,X,ie,j,$,J,V)}};e.ExtensionGalleryService=W=Le([Re(0,f.IStorageService),Re(1,h.IRequestService),Re(2,b.ILogService),Re(3,T.IEnvironmentService),Re(4,I.ITelemetryService),Re(5,p.IFileService),Re(6,s.IProductService),Re(7,m.IConfigurationService)],W);let x=e.ExtensionGalleryServiceWithNoStorageService=class extends de{constructor(R,U,X,ie,j,$,J){super(void 0,R,U,X,ie,j,$,J)}};e.ExtensionGalleryServiceWithNoStorageService=x=Le([Re(0,h.IRequestService),Re(1,b.ILogService),Re(2,T.IEnvironmentService),Re(3,I.ITelemetryService),Re(4,p.IFileService),Re(5,s.IProductService),Re(6,m.IConfigurationService)],x)}),define(ge[258],pe([1,0,6,2,32,50]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class C{constructor(m,T){this.a=m,this.b=T}listen(m,T){const y=this.b(m);switch(T){case"onDidChangeProfiles":return w.Event.map(this.a.onDidChangeProfiles,E=>({all:E.all.map(d=>(0,P.transformOutgoingURIs)({...d},y)),added:E.added.map(d=>(0,P.transformOutgoingURIs)({...d},y)),removed:E.removed.map(d=>(0,P.transformOutgoingURIs)({...d},y)),updated:E.updated.map(d=>(0,P.transformOutgoingURIs)({...d},y))}))}throw new Error(`Invalid listen ${T}`)}async call(m,T,y){const E=this.b(m);switch(T){case"createProfile":{const d=await this.a.createProfile(y[0],y[1],y[2]);return(0,P.transformOutgoingURIs)({...d},E)}case"updateProfile":{let d=(0,o.reviveProfile)((0,P.transformIncomingURIs)(y[0],E),this.a.profilesHome.scheme);return d=await this.a.updateProfile(d,y[1]),(0,P.transformOutgoingURIs)({...d},E)}case"removeProfile":{const d=(0,o.reviveProfile)((0,P.transformIncomingURIs)(y[0],E),this.a.profilesHome.scheme);return this.a.removeProfile(d)}}throw new Error(`Invalid call ${T}`)}}e.RemoteUserDataProfilesServiceChannel=C;class A extends L.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(m,T,y){super(),this.profilesHome=T,this.f=y,this.a=[],this.b=this.B(new w.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=m.map(E=>(0,o.reviveProfile)(E,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(E=>{const d=E.added.map(s=>(0,o.reviveProfile)(s,this.profilesHome.scheme)),p=E.removed.map(s=>(0,o.reviveProfile)(s,this.profilesHome.scheme)),b=E.updated.map(s=>(0,o.reviveProfile)(s,this.profilesHome.scheme));this.a=E.all.map(s=>(0,o.reviveProfile)(s,this.profilesHome.scheme)),this.b.fire({added:d,removed:p,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(m){this.c=m}isEnabled(){return this.c}async createNamedProfile(m,T,y){const E=await this.f.call("createNamedProfile",[m,T,y]);return(0,o.reviveProfile)(E,this.profilesHome.scheme)}async createProfile(m,T,y,E){const d=await this.f.call("createProfile",[m,T,y,E]);return(0,o.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(m){const T=await this.f.call("createTransientProfile",[m]);return(0,o.reviveProfile)(T,this.profilesHome.scheme)}async setProfileForWorkspace(m,T){await this.f.call("setProfileForWorkspace",[m,T])}removeProfile(m){return this.f.call("removeProfile",[m])}async updateProfile(m,T){const y=await this.f.call("updateProfile",[m,T]);return(0,o.reviveProfile)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=A}),define(ge[125],pe([1,0,4,25,16,12,236,35,32,8,237]),function(oe,e,w,L,o,P,C,A,v,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let y=e.UserDataProfilesReadonlyService=class Kt extends v.UserDataProfilesService{constructor(b,s,h,u,f){super(h,u,s,f),this.P=b,this.Q=h}J(){return this.P.getItem(Kt.b,[]).map(s=>({...s,location:(0,m.isString)(s.location)?this.s.extUri.joinPath(this.profilesHome,s.location):w.URI.revive(s.location)}))}M(){const b=this.P.getItem(Kt.c,{});return this.P.getItem(Kt.a,!1)?b:this.I(b)}O(){return this.s.extUri.joinPath(w.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y.a="profileAssociationsMigration",e.UserDataProfilesReadonlyService=y=Le([Re(0,C.IStateReadService),Re(1,A.IUriIdentityService),Re(2,L.INativeEnvironmentService),Re(3,o.IFileService),Re(4,P.ILogService)],y);let E=e.UserDataProfilesService=class Mt extends y{constructor(b,s,h,u,f){super(b,s,h,u,f),this.W=b}L(b){b.length?this.W.setItem(Mt.b,b.map(s=>({...s,location:this.s.extUri.basename(s.location)}))):this.W.removeItem(Mt.b)}J(){const b=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(b),this.W.setItem("userDataProfilesMigration",!0)),b}N(b){b.emptyWindows||b.workspaces?this.W.setItem(Mt.c,b):this.W.removeItem(Mt.c)}M(){const b="workspaceAndProfileInfo",s=this.W.getItem(b,void 0);if(s){this.W.removeItem(b);const u=s.reduce((f,{workspace:I,profile:O})=>(f[w.URI.revive(I).toString()]=w.URI.revive(O).toString(),f),{});this.W.setItem(Mt.c,{workspaces:u})}const h=super.M();return this.W.getItem(Mt.a,!1)||(this.N(h),this.W.setItem(Mt.a,!0)),h}};e.UserDataProfilesService=E=Le([Re(0,C.IStateService),Re(1,A.IUriIdentityService),Re(2,L.INativeEnvironmentService),Re(3,o.IFileService),Re(4,P.ILogService)],E);let d=e.ServerUserDataProfilesService=class extends E{constructor(b,s,h,u){super(new T.StateService(0,s,u,h),b,s,h,u)}async init(){return await this.W.init(),super.init()}};e.ServerUserDataProfilesService=d=Le([Re(0,A.IUriIdentityService),Re(1,L.INativeEnvironmentService),Re(2,o.IFileService),Re(3,P.ILogService)],d)}),define(ge[126],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,w.createDecorator)("extensionHostStatusService");class L{constructor(){this.a=new Map}setExitInfo(P,C){this.a.set(P,C)}getExitInfo(P){return this.a.get(P)||null}}e.ExtensionHostStatusService=L}),define(ge[259],pe([1,0,6,14]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=void 0;function o(C){let A=0,v=0,m=0;C>=1e3&&(m=Math.floor(C/1e3),C-=m*1e3),m>=60&&(v=Math.floor(m/60),m-=v*60),v>=60&&(A=Math.floor(v/60),v-=A*60);const T=A?`${A}h`:"",y=v?`${v}m`:"",E=m?`${m}s`:"",d=C?`${C}ms`:"";return`${T}${y}${E}${d}`}class P{constructor(A,v,m,T){this.i=A,this.j=v,this.a=new w.Emitter,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=m,this.protocol=T,this.e=!1,this.f=new L.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection grace time of ${o(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new L.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection short grace time of ${o(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${o(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(A){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${A}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${o(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const A=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),A.end(),this.a.fire(void 0)}acceptReconnection(A,v,m){this.d=A,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(v,m),this.protocol.endAcceptReconnection()}}e.ManagementConnection=P}),define(ge[127],pe([1,0,33,13,7,147,53]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const A=o.join(L.FileAccess.asFileUri("").fsPath,"nls.metadata.json"),v=new Map;function m(E){return new Promise(d=>w.exists(E,d))}function T(E,d){return m(A).then(p=>{if(!p||!C.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const b=`${E}||${d}`;let s=v.get(b);return s||(s=P.getNLSConfiguration(C.default.commit,d,A,E,E).then(h=>(y.is(h)&&(h._languagePackSupport=!0),h)),v.set(b,s)),s})}e.getNLSConfiguration=T;var y;(function(E){function d(p){const b=p;return b&&typeof b._languagePackId=="string"}E.is=d})(y||(e.InternalNLSConfiguration=y={}))}),define(ge[128],pe([1,0,19,4,25,44,56,16,5,12,26,35,32,127]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=e.ExtensionsScannerService=class extends C.AbstractExtensionsScannerService{constructor(s,h,u,f,I,O,t,n){super(L.URI.file(I.builtinExtensionsPath),L.URI.file(I.extensionsPath),(0,w.joinPath)(I.userHome,".vscode-oss-dev","extensions","control.json"),s.defaultProfile,s,h,u,f,I,O,t,n),this.N=I}async f(s){const h=await(0,d.getNLSConfiguration)(s,this.N.userDataPath);if(d.InternalNLSConfiguration.is(h))try{const u=await this.s.readFile(L.URI.file(h._translationsConfigFile));return JSON.parse(u.value.toString())}catch{}return Object.create(null)}};e.ExtensionsScannerService=p=Le([Re(0,E.IUserDataProfilesService),Re(1,P.IExtensionsProfileScannerService),Re(2,A.IFileService),Re(3,m.ILogService),Re(4,o.INativeEnvironmentService),Re(5,T.IProductService),Re(6,y.IUriIdentityService),Re(7,v.IInstantiationService)],p)}),define(ge[260],pe([1,0,261,33,7,22,13,23]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z_-]+$/;var m;(function(h){h[h.None=0]="None",h[h.Optional=1]="Optional",h[h.Mandatory=2]="Mandatory"})(m||(e.ServerConnectionTokenType=m={}));class T{constructor(){this.type=0}validate(u){return!0}}e.NoneServerConnectionToken=T;class y{constructor(u){this.value=u,this.type=1}validate(u){return u===this.value}}e.OptionalServerConnectionToken=y;class E{constructor(u){this.value=u,this.type=2}validate(u){return u===this.value}}e.MandatoryServerConnectionToken=E;class d{constructor(u){this.message=u}}e.ServerConnectionTokenParseError=d;async function p(h,u){const f=h["without-connection-token"],I=h["connection-token"],O=h["connection-token-file"],t=h.compatibility==="1.63";if(f)return typeof I<"u"||typeof O<"u"?new d("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new T;if(typeof O<"u"){if(typeof I<"u")return new d("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let n;try{n=L.readFileSync(O).toString().replace(/\r?\n$/,"")}catch{return new d(`Unable to read the connection token file at '${O}'.`)}return v.test(n)?new E(n):new d(`The connection token defined in '${O} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof I<"u"?v.test(I)?t?new y(I):new E(I):new d(`The connection token '${I} does not adhere to the characters 0-9, a-z, A-Z or -.`):t?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new y(await u())):new E(await u())}e.parseServerConnectionToken=p;async function b(h){return p(h,async()=>{if(!h["user-data-dir"])return(0,P.generateUuid)();const f=o.join(h["user-data-dir"],"token");try{const t=(await A.Promises.readFile(f)).toString().replace(/\r?\n$/,"");if(v.test(t))return t}catch{}const I=(0,P.generateUuid)();try{await A.Promises.writeFile(f,I,{mode:384})}catch{}return I})}e.determineServerConnectionToken=b;function s(h,u,f){if(h.validate(f.query[C.connectionTokenQueryName]))return!0;const I=w.parse(u.headers.cookie||"");return h.validate(I[C.connectionTokenCookieName])}e.requestHasValidConnectionToken=s}),define(ge[45],pe([1,0,196,106,62,5,25]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:w.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:w.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:w.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:w.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:w.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:w.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:w.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:w.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:w.localize(8,null)},"user-data-dir":o.OPTIONS["user-data-dir"],"enable-smoke-test-driver":o.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":o.OPTIONS["disable-telemetry"],"disable-workspace-trust":o.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:o.OPTIONS.log,logsPath:o.OPTIONS.logsPath,"force-disable-user-env":o.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:w.localize(9,null)},"default-workspace":{type:"string",description:w.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":o.OPTIONS["extensions-dir"],"extensions-download-dir":o.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":o.OPTIONS["builtin-extensions-dir"],"install-extension":o.OPTIONS["install-extension"],"install-builtin-extension":o.OPTIONS["install-builtin-extension"],"uninstall-extension":o.OPTIONS["uninstall-extension"],"list-extensions":o.OPTIONS["list-extensions"],"locate-extension":o.OPTIONS["locate-extension"],"show-versions":o.OPTIONS["show-versions"],category:o.OPTIONS.category,force:o.OPTIONS.force,"do-not-sync":o.OPTIONS["do-not-sync"],"pre-release":o.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:w.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:o.OPTIONS.help,version:o.OPTIONS.version,"locate-shell-integration-path":o.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:o.OPTIONS._},e.IServerEnvironmentService=(0,P.refineServiceDecorator)(C.IEnvironmentService);class A extends L.NativeEnvironmentService{get isRemoteServer(){return!0}get args(){return super.args}}e.ServerEnvironmentService=A}),define(ge[262],pe([1,0,33,73,83,261,85,39,57,3,12,45,7,13,22,26,43,20,4,15,8,55]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u,f,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const t={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function n(c,g,D,k){g.writeHead(D,{"Content-Type":"text/plain"}),g.end(k)}e.serveError=n;var r;(function(c){c[c.NO_CACHING=0]="NO_CACHING",c[c.ETAG=1]="ETAG",c[c.NO_EXPIRY=2]="NO_EXPIRY"})(r||(e.CacheControl=r={}));async function i(c,g,D,k,S,F){try{const H=await w.promises.stat(c);if(g===1){const te=`W/"${[H.ino,H.size,H.mtime.getTime()].join("-")}"`;if(k.headers["if-none-match"]===te)return S.writeHead(304),void S.end();F.Etag=te}else g===2?F["Cache-Control"]="public, max-age=31536000":g===0&&(F["Cache-Control"]="no-store");F["Content-Type"]=t[(0,E.extname)(c)]||(0,v.getMediaMime)(c)||"text/plain",S.writeHead(200,F),(0,w.createReadStream)(c).pipe(S)}catch(H){return H.code!=="ENOENT"?(D.error(H),console.error(H.toString())):console.error(`File not found: ${c}`),S.writeHead(404,{"Content-Type":"text/plain"}),void S.end("Not found")}}e.serveFile=i;const a=(0,E.dirname)(d.FileAccess.asFileUri("").fsPath);let l=e.WebClientServer=class{constructor(g,D,k,S,F){this.f=g,this.g=D,this.h=k,this.i=S,this.j=F,this.a=this.j.extensionsGallery?.resourceUrlTemplate?u.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const H=(0,O.getRemoteServerRootPath)(F);this.b=`${H}/static`,this.c=`${H}/callback`,this.d=`${H}/web-extension-resource`}async handle(g,D,k){try{const S=k.pathname;return S.startsWith(this.b)&&S.charCodeAt(this.b.length)===47?this.k(g,D,k):S==="/"?this.n(g,D,k):S===this.c?this.p(D):S.startsWith(this.d)&&S.charCodeAt(this.d.length)===47?this.m(g,D,k):n(g,D,404,"Not found.")}catch(S){return this.h.error(S),console.error(S.toString()),n(g,D,500,"Internal Server Error.")}}async k(g,D,k){const S=Object.create(null),H=decodeURIComponent(k.pathname).substring(this.b.length+1),te=(0,E.join)(a,H);return(0,A.isEqualOrParent)(te,a,!m.isLinux)?i(te,this.g.isBuilt?2:1,this.h,g,D,S):n(g,D,400,"Bad request.")}l(g){const D=g.authority.indexOf(".");return D!==-1?g.authority.substring(D+1):void 0}async m(g,D,k){if(!this.a)return n(g,D,500,"No extension gallery service configured.");const S=decodeURIComponent(k.pathname),F=(0,E.normalize)(S.substring(this.d.length+1)),H=u.URI.parse(F).with({scheme:this.a.scheme,authority:F.substring(0,F.indexOf("/")),path:F.substring(F.indexOf("/")+1)});if(this.l(this.a)!==this.l(H))return n(g,D,403,"Request Forbidden");const te={},ce=z=>{const q=g.headers[z];q&&((0,I.isString)(q)||q[0])?te[z]=(0,I.isString)(q)?q:q[0]:z!==z.toLowerCase()&&ce(z.toLowerCase())};ce("X-Client-Name"),ce("X-Client-Version"),ce("X-Machine-Id"),ce("X-Client-Commit");const le=await this.i.request({type:"GET",url:H.toString(!0),headers:te},h.CancellationToken.None),ue=le.res.statusCode||500;if(ue!==200){let z=null;try{z=await(0,s.asTextOrError)(le)}catch{}return n(g,D,ue,z||`Request failed with status ${ue}`)}const ve=Object.create(null),K=z=>{const q=le.res.headers[z];q?ve[z]=q:z!==z.toLowerCase()&&K(z.toLowerCase())};K("Cache-Control"),K("Content-Type"),D.writeHead(200,ve);const ee=await(0,f.streamToBuffer)(le.stream);return void D.end(ee.buffer)}async n(g,D,k){const S=k.query[d.connectionTokenQueryName];if(typeof S=="string"){const de=Object.create(null);de["Set-Cookie"]=P.serialize(d.connectionTokenCookieName,S,{sameSite:"lax",maxAge:60*60*24*7});const W=Object.create(null);for(const N in k.query)N!==d.connectionTokenQueryName&&(W[N]=k.query[N]);const x=o.format({pathname:"/",query:W});return de.Location=x,D.writeHead(302,de),void D.end()}const F=de=>{const W=g.headers[de];return Array.isArray(W)?W[0]:W},H=F("x-original-host")||F("x-forwarded-host")||g.headers.host;if(!H)return n(g,D,400,"Bad request.");function te(de){return JSON.stringify(de).replace(/"/g,"&quot;")}let ce;this.g.args["enable-smoke-test-driver"]&&(ce=!1);const le=de=>de&&u.URI.file(L.resolve(de)).with({scheme:d.Schemas.vscodeRemote,authority:H}),ue=d.FileAccess.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,ve=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,p.generateUuid)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,K={embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.j.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:H,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.g.isBuilt)try{const de=JSON.parse((await w.promises.readFile((0,E.join)(a,"product.overrides.json"))).toString());Object.assign(K,de)}catch{}const ee={remoteAuthority:H,_wrapWebWorkerExtHostInIframe:ce,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:le(this.g.args["default-folder"]),workspaceUri:le(this.g.args["default-workspace"]),productConfiguration:K,callbackRoute:this.c},z=this.j.extensionsGallery?.nlsBaseUrl,q={WORKBENCH_WEB_CONFIGURATION:te(ee),WORKBENCH_AUTH_SESSION:ve?te(ve):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:z?`${z}${z.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""};let G;try{G=(await w.promises.readFile(ue)).toString().replace(/\{\{([^}]+)\}\}/g,(W,x)=>q[x]??"undefined")}catch{return D.writeHead(404,{"Content-Type":"text/plain"}),void D.end("Not found")}const se={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(G).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${H};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(se["Set-Cookie"]=P.serialize(d.connectionTokenCookieName,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),D.writeHead(200,se),void D.end(G)}o(g){const D=/<script>([\s\S]+?)<\/script>/img,k=[];let S;for(;S=D.exec(g);){const F=C.createHash("sha256"),H=S[1].replace(/\r\n/g,`
`),te=F.update(Buffer.from(H)).digest().toString("base64");k.push(`'sha256-${te}'`)}return k}async p(g){const D=d.FileAccess.asFileUri("vs/code/browser/workbench/callback.html").fsPath,k=(await w.promises.readFile(D)).toString(),S=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(k).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return g.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":S}),void g.end(k)}};e.WebClientServer=l=Le([Re(1,y.IServerEnvironmentService),Re(2,T.ILogService),Re(3,s.IRequestService),Re(4,b.IProductService)],l)}),define(ge[263],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(ge[264],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class L{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=L}),define(ge[68],pe([1,0,50]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function L(P){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:P,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function o(P){return new w.URITransformer(L(P))}e.createURITransformer=o}),define(ge[265],pe([1,0,3,41,4,68,50,102,240,7,19]),function(oe,e,w,L,o,P,C,A,v,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class y{constructor(d,p,b,s){this.b=d,this.c=p,this.d=b,this.e=s}async call(d,p,b){switch(p){case"getEnvironmentData":{const s=b,h=(0,P.createURITransformer)(s.remoteAuthority);let u=await this.f(s.profile);return u=(0,C.transformOutgoingURIs)(u,h),u}case"getExtensionHostExitInfo":{const s=b;return this.e.getExitInfo(s.reconnectionToken)}case"getDiagnosticInfo":{const s=b,h={machineInfo:(0,v.getMachineInfo)()},u=s.includeProcesses?(0,A.listProcesses)(process.pid):Promise.resolve();let f=[];const I={};if(s.folders){const O=(0,P.createURITransformer)("");f=s.folders.map(n=>o.URI.revive(O.transformIncoming(n))).filter(n=>n.scheme==="file").map(n=>(0,v.collectWorkspaceStats)(n.fsPath,["node_modules",".git"]).then(r=>{I[(0,m.basename)(n.fsPath)]=r}))}return Promise.all([u,...f]).then(([O,t])=>(h.processes=O||void 0,h.workspaceMetadata=s.folders?I:void 0,h))}}throw new Error(`IPC Command ${p} not found`)}listen(d,p,b){throw new Error("Not supported")}async f(d){return d&&!this.d.profiles.some(p=>p.id===d)&&await this.d.createProfile(d,d),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:o.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,T.joinPath)(this.c.logsHome,`exthost${y.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:w.OS,arch:process.arch,marks:L.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(p=>({...p}))}}}}e.RemoteAgentEnvironmentChannel=y,y.a=1}),define(ge[266],pe([1,0,4,68,66,7,224]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class A extends C.AbstractDiskFileSystemProviderChannel{constructor(T,y){super(new o.DiskFileSystemProvider(T),T),this.H=y,this.G=new Map,this.B(this.a)}c(T){let y=this.G.get(T.remoteAuthority);return y||(y=(0,L.createURITransformer)(T.remoteAuthority),this.G.set(T.remoteAuthority,y)),y}f(T,y,E=!1){if(E&&y.path==="/vscode-resource"&&y.query){const d=JSON.parse(y.query).requestResourcePath;return w.URI.from({scheme:"file",path:d})}return w.URI.revive(T.transformIncoming(y))}F(T,y){return new v(T,y,this.b,this.H)}}e.RemoteAgentFileSystemProviderChannel=A;class v extends C.AbstractSessionFileWatcher{constructor(T,y,E,d){super(T,y,E,d)}i(T){const y=T.args["file-watcher-polling"];if(y){const E=y.split(P.delimiter),d=Number(E[0]);if(d>0)return{usePolling:E.length>1?E.slice(1):!0,pollingInterval:d}}}j(T){if(T.extensionsPath)return[P.posix.join(T.extensionsPath,"**")]}}}),define(ge[88],pe([1,0,199,8,4,2,5,40,16,13,38,157,59]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var d;(function(W){W[W.PROGRAMMATIC=1]="PROGRAMMATIC",W[W.USER=2]="USER",W[W.EDIT=3]="EDIT",W[W.NAVIGATION=4]="NAVIGATION",W[W.JUMP=5]="JUMP"})(d||(e.EditorPaneSelectionChangeReason=d={}));var p;(function(W){W[W.IDENTICAL=1]="IDENTICAL",W[W.SIMILAR=2]="SIMILAR",W[W.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function b(W){const x=W;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.isEditorPaneWithSelection=b;function s(W,x,N){for(const R of N.visibleEditorPanes)if(R.group.id===x&&W.matches(R.input))return R.getViewState()}e.findViewStateForEditor=s;function h(W){if(g(W))return!1;const x=W;return o.URI.isUri(x?.resource)}e.isResourceEditorInput=h;function u(W){if(g(W))return!1;const x=W;return x?.original!==void 0&&x.modified!==void 0}e.isResourceDiffEditorInput=u;function f(W){if(g(W)||u(W))return!1;const x=W;return x?.primary!==void 0&&x.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function I(W){if(g(W))return!1;const x=W;return x?x.resource===void 0||x.resource.scheme===m.Schemas.untitled||x.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=I;const O=/Untitled-\d+/;function t(W){return W.scheme===m.Schemas.untitled&&W.path.length>1&&!O.test(W.path)}e.isUntitledWithAssociatedResource=t;function n(W){if(g(W))return!1;const x=W;return o.URI.isUri(x?.base?.resource)&&o.URI.isUri(x?.input1?.resource)&&o.URI.isUri(x?.input2?.resource)&&o.URI.isUri(x?.result?.resource)}e.isResourceMergeEditorInput=n;var r;(function(W){W[W.SHORT=0]="SHORT",W[W.MEDIUM=1]="MEDIUM",W[W.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var i;(function(W){W[W.EXPLICIT=1]="EXPLICIT",W[W.AUTO=2]="AUTO",W[W.FOCUS_CHANGE=3]="FOCUS_CHANGE",W[W.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class a{constructor(){this.a=new Map}registerSource(x,N){let R=this.a.get(x);return R||(R={source:x,label:N},this.a.set(x,R)),R.source}getSourceLabel(x){return this.a.get(x)?.label??x}}e.SaveSourceRegistry=new a;var l;(function(W){W[W.None=0]="None",W[W.Readonly=2]="Readonly",W[W.Untitled=4]="Untitled",W[W.Singleton=8]="Singleton",W[W.RequiresTrust=16]="RequiresTrust",W[W.CanSplitInGroup=32]="CanSplitInGroup",W[W.ForceDescription=64]="ForceDescription",W[W.CanDropIntoEditor=128]="CanDropIntoEditor",W[W.MultipleEditors=256]="MultipleEditors"})(l||(e.EditorInputCapabilities=l={}));class c extends P.Disposable{}e.AbstractEditorInput=c;function g(W){return W instanceof c}e.isEditorInput=g;function D(W){const x=W;return o.URI.isUri(x?.preferredResource)}function k(W){const x=W;return g(x?.primary)&&g(x?.secondary)}e.isSideBySideEditorInput=k;function S(W){const x=W;return g(x?.modified)&&g(x?.original)}e.isDiffEditorInput=S;function F(W,x,N,R,U){return de(R,[(0,y.toAction)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const X={...N,limits:{size:Number.MAX_VALUE}};W.openEditor(x,X)}}),(0,y.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>U.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:E.default.Warning})}e.createTooLargeFileError=F;function H(W){return g(W?.editor)}e.isEditorInputWithOptions=H;function te(W){const x=W;return H(W)&&x?.group!==void 0}e.isEditorInputWithOptionsAndGroup=te;function ce(W){const x=W;return typeof x?.groupId=="number"&&g(x.editor)}e.isEditorIdentifier=ce;var le;(function(W){W[W.UNKNOWN=0]="UNKNOWN",W[W.REPLACE=1]="REPLACE",W[W.MOVE=2]="MOVE",W[W.UNPIN=3]="UNPIN"})(le||(e.EditorCloseContext=le={}));var ue;(function(W){W[W.GROUP_ACTIVE=0]="GROUP_ACTIVE",W[W.GROUP_INDEX=1]="GROUP_INDEX",W[W.GROUP_LOCKED=2]="GROUP_LOCKED",W[W.EDITOR_OPEN=3]="EDITOR_OPEN",W[W.EDITOR_CLOSE=4]="EDITOR_CLOSE",W[W.EDITOR_MOVE=5]="EDITOR_MOVE",W[W.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",W[W.EDITOR_LABEL=7]="EDITOR_LABEL",W[W.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",W[W.EDITOR_PIN=9]="EDITOR_PIN",W[W.EDITOR_STICKY=10]="EDITOR_STICKY",W[W.EDITOR_DIRTY=11]="EDITOR_DIRTY",W[W.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(ue||(e.GroupModelChangeKind=ue={}));var ve;(function(W){W[W.PRIMARY=1]="PRIMARY",W[W.SECONDARY=2]="SECONDARY",W[W.BOTH=3]="BOTH",W[W.ANY=4]="ANY"})(ve||(e.SideBySideEditor=ve={}));class K{getOriginalUri(x,N){if(!x)return;if(n(x))return e.EditorResourceAccessor.getOriginalUri(x.result,N);if(N?.supportSideBySide){const{primary:U,secondary:X}=this.a(x);if(U&&X){if(N?.supportSideBySide===ve.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:N.filterByScheme}),secondary:this.getOriginalUri(X,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===ve.ANY)return this.getOriginalUri(U,{filterByScheme:N.filterByScheme})??this.getOriginalUri(X,{filterByScheme:N.filterByScheme});x=N.supportSideBySide===ve.PRIMARY?U:X}}if(u(x)||f(x)||n(x))return;const R=D(x)?x.preferredResource:x.resource;return!R||!N||!N.filterByScheme?R:this.b(R,N.filterByScheme)}a(x){return k(x)||f(x)?{primary:x.primary,secondary:x.secondary}:S(x)||u(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,N){if(!x)return;if(n(x))return e.EditorResourceAccessor.getCanonicalUri(x.result,N);if(N?.supportSideBySide){const{primary:U,secondary:X}=this.a(x);if(U&&X){if(N?.supportSideBySide===ve.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:N.filterByScheme}),secondary:this.getCanonicalUri(X,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===ve.ANY)return this.getCanonicalUri(U,{filterByScheme:N.filterByScheme})??this.getCanonicalUri(X,{filterByScheme:N.filterByScheme});x=N.supportSideBySide===ve.PRIMARY?U:X}}if(u(x)||f(x)||n(x))return;const R=x.resource;return!R||!N||!N.filterByScheme?R:this.b(R,N.filterByScheme)}b(x,N){if(Array.isArray(N)){if(N.some(R=>x.scheme===R))return x}else if(N===x.scheme)return x}}e.EditorResourceAccessor=new K;var ee;(function(W){W[W.LEFT=0]="LEFT",W[W.RIGHT=1]="RIGHT"})(ee||(e.CloseDirection=ee={}));class z{constructor(){this.c=new Map,this.d=new Map}start(x){const N=this.a=x.get(C.IInstantiationService);for(const[R,U]of this.c)this.e(R,U,N);this.c.clear()}e(x,N,R){const U=R.createInstance(N);this.d.set(x,U)}registerFileEditorFactory(x){if(this.b)throw new Error("Can only register one file editor factory.");this.b=x}getFileEditorFactory(){return(0,L.assertIsDefined)(this.b)}registerEditorSerializer(x,N){if(this.c.has(x)||this.d.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.a?this.e(x,N,this.a):this.c.set(x,N),(0,P.toDisposable)(()=>{this.c.delete(x),this.d.delete(x)})}getEditorSerializer(x){return this.d.get(typeof x=="string"?x:x.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new z);async function q(W,x,N){return!W||!W.length?[]:await Promise.all(W.map(async R=>{const U=o.URI.revive(R.fileUri);if(!U){N.info("Cannot resolve the path because it is not valid.",R);return}if(!await x.canHandleResource(U)){N.info("Cannot resolve the path because it cannot be handled",R);return}let ie=R.exists,j=R.type;if(typeof ie!="boolean"||typeof j!="number")try{j=(await x.stat(U)).isDirectory?v.FileType.Directory:v.FileType.Unknown,ie=!0}catch(J){N.error(J),ie=!1}if(!ie&&R.openOnlyIfExists){N.info("Cannot resolve the path because it does not exist",R);return}if(j===v.FileType.Directory){N.info("Cannot resolve the path because it is a directory",R);return}const $={...R.options,pinned:!0};return ie?{resource:U,options:$}:{resource:U,options:$,forceUntitled:!0}}))}e.pathsToEditors=q;var G;(function(W){W[W.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",W[W.SEQUENTIAL=1]="SEQUENTIAL"})(G||(e.EditorsOrder=G={}));function ne(W){const x=W;if(!x)return!1;const N=x;if(N.modified)return ne(N.modified);const R=x;return!!(R.contributionsState&&R.viewState&&Array.isArray(R.cursorState))}e.isTextEditorViewState=ne;function se(W){return(0,T.isErrorWithActions)(W)}e.isEditorOpenError=se;function de(W,x,N){const R=(0,T.createErrorWithActions)(W,x);return R.forceMessage=N?.forceMessage,R.forceSeverity=N?.forceSeverity,R.allowDialog=N?.allowDialog,R}e.createEditorOpenError=de}),define(ge[129],pe([1,0,15,76,46,57,13,7,3,64]),function(oe,e,w,L,o,P,C,A,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var T;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(T||(e.CellKind=T={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(y||(e.NotebookRunState=y={}));var E;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var d;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var p;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var b;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(b||(e.RendererMessagingSpec=b={}));var s;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var h;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var u;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(u||(e.CellEditType=u={}));var f;(function(K){K.scheme=C.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],z=new RegExp(`^[${ee.join("")}]+`),q=7;function G(N,R){const U=R.toString(q),ie=`${U.length<ee.length?ee[U.length-1]:"z"}${U}s${(0,w.encodeBase64)(w.VSBuffer.fromString(N.scheme),!0,!0)}`;return N.with({scheme:K.scheme,fragment:ie})}K.generate=G;function ne(N){if(N.scheme!==K.scheme)return;const R=N.fragment.indexOf("s");if(R<0)return;const U=parseInt(N.fragment.substring(0,R).replace(z,""),q),X=(0,w.decodeBase64)(N.fragment.substring(R+1)).toString();if(!isNaN(U))return{handle:U,notebook:N.with({scheme:X,fragment:null})}}K.parse=ne;function se(N,R){return N.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${R??""},${N.scheme!==C.Schemas.file?N.scheme:""}`})}K.generateCellOutputUri=se;function de(N){if(N.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const R=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(N.fragment);if(!R)return;const U=R[1]&&R[1]!==""?R[1]:void 0,X=R[2];return{outputId:U,notebook:N.with({scheme:X||C.Schemas.file,fragment:null})}}K.parseCellOutputUri=de;function W(N,R,U){return K.generate(N,R).with({scheme:U})}K.generateCellPropertyUri=W;function x(N,R){if(N.scheme===R)return K.parse(N.with({scheme:K.scheme}))}K.parseCellPropertyUri=x})(f||(e.CellUri=f={}));const I=K=>v.isWindows?K.replace(/\//g,"\\"):K;class O{constructor(ee=[],z=e.NOTEBOOK_DISPLAY_ORDER){this.e=z,this.d=[...new Set(ee)].map(q=>({pattern:q,matches:L.parse(I(q))}))}sort(ee){const z=new Map(o.Iterable.map(ee,G=>[G,I(G)]));let q=[];for(const{matches:G}of this.d)for(const[ne,se]of z)if(G(se)){q.push(ne),z.delete(ne);break}return z.size&&(q=q.concat([...z.keys()].sort((G,ne)=>this.e.indexOf(G)-this.e.indexOf(ne)))),q}prioritize(ee,z){const q=this.f(ee);if(q===-1){this.d.unshift({pattern:ee,matches:L.parse(I(ee))});return}const G=new Set(z.map(se=>this.f(se,q)));G.delete(-1);const ne=Array.from(G).sort();this.d.splice(q+1,0,...ne.map(se=>this.d[se]));for(let se=ne.length-1;se>=0;se--)this.d.splice(ne[se],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,z=this.d.length){const q=I(ee);for(let G=0;G<z;G++)if(this.d[G].matches(q))return G;return-1}}e.MimeTypeDisplayOrder=O;function t(K,ee,z,q=(G,ne)=>G===ne){const G=[];function ne(W,x,N){if(x===0&&N.length===0)return;const R=G[G.length-1];R&&R.start+R.deleteCount===W?(R.deleteCount+=x,R.toInsert.push(...N)):G.push({start:W,deleteCount:x,toInsert:N})}let se=0,de=0;for(;;){if(se===K.length){ne(se,0,ee.slice(de));break}if(de===ee.length){ne(se,K.length-se,[]);break}const W=K[se],x=ee[de];if(q(W,x)){se+=1,de+=1;continue}z(x)?(ne(se,1,[]),se+=1):(ne(se,0,[x]),de+=1)}return G}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(K){K.default="default",K.option="option"})(n||(e.NotebookEditorPriority=n={}));function r(K){const ee=K;return!!((typeof ee.include=="string"||L.isRelativePattern(ee.include))&&(typeof ee.exclude=="string"||L.isRelativePattern(ee.exclude)))}e.isDocumentExcludePattern=r;function i(K,ee,z){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ee)>=0||K.viewType===ee)return!0;if(K.filenamePattern){const q=r(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,G=r(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(L.match(q,(0,A.basename)(z.fsPath).toLowerCase()))return!(G&&L.match(G,(0,A.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",codeActionsOnSave:"notebook.experimental.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var a;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class l{static create(ee){return`${l.d}${ee}`}static parse(ee){if(ee.startsWith(l.d))return ee.substring(l.d.length)}}e.NotebookWorkingCopyTypeIdentifier=l,l.d="notebook/";function c(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}e.isTextStreamMime=c;const g=new TextDecoder;function D(K){const ee=[];let z=!1;for(const q of K)(ee.length===0||z)&&(ee.push(q),z=!0);return H(ee),ve(w.VSBuffer.concat(ee.map(q=>w.VSBuffer.wrap(q))))}e.compressOutputItemStreams=D;const k=`${String.fromCharCode(27)}[A`,S=k.split("").map(K=>K.charCodeAt(0)),F=10;function H(K){K.forEach((ee,z)=>{if(z===0||ee.length<k.length)return;const q=K[z-1],G=ee.subarray(0,k.length);if(G[0]===S[0]&&G[1]===S[1]&&G[2]===S[2]){const ne=q.lastIndexOf(F);if(ne===-1)return;K[z-1]=q.subarray(0,ne),K[z]=ee.subarray(k.length)}})}function te(K){let ee=K;do K=ee,ee=K.replace(/[^\n]\x08/gm,"");while(ee.length<K.length);return K}function ce(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ee=K.match(/^(.*)\r+/m)[1];let z=K.match(/\r+(.*)$/m)[1];z=z+ee.slice(z.length,ee.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,z)}return K}const le="\b".charCodeAt(0),ue="\r".charCodeAt(0);function ve(K){return!K.buffer.includes(le)&&!K.buffer.includes(ue)?K:w.VSBuffer.fromString(ce(te(g.decode(K.buffer))))}}),define(ge[267],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,w.createDecorator)("environmentVariableService")}),define(ge[268],pe([1,0,7,58,3,249,8]),function(oe,e,w,L,o,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preparePathForShell=e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function A(t,n){if(n)if(o.isWindows)for(const r in n){let i=r;for(const l in t)if(r.toLowerCase()===l.toLowerCase()){i=l;break}const a=n[r];a!==void 0&&v(t,i,a)}else Object.keys(n).forEach(r=>{const i=n[r];i!==void 0&&v(t,r,i)})}e.mergeEnvironments=A;function v(t,n,r){typeof r=="string"?t[n]=r:delete t[n]}function m(t,n,r,i){t.TERM_PROGRAM="vscode",n&&(t.TERM_PROGRAM_VERSION=n),E(t,i)&&(t.LANG=d(r)),t.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=m;function T(t,n){if(n)for(const r of Object.keys(n)){const i=n[r];i!=null&&(t[r]=i)}}async function y(t,n){return await Promise.all(Object.entries(n).map(async([r,i])=>{if(typeof i=="string")try{n[r]=await t(i)}catch{n[r]=i}})),n}function E(t,n){if(n==="on")return!0;if(n==="auto"){const r=t.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=E;function d(t){const n=t?t.split("-"):[],r=n.length;if(r===0)return"en_US.UTF-8";if(r===1){const i={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in i&&n.push(i[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}e.getLangEnvVariable=d;async function p(t,n,r,i,a,l){if(t.cwd){const g=typeof t.cwd=="object"?t.cwd.fsPath:t.cwd,D=await b(g,r);return(0,P.sanitizeCwd)(D||g)}let c;return!t.ignoreConfigurationCwd&&a&&(r&&(a=await b(a,r,l)),a&&(w.isAbsolute(a)?c=a:i&&(c=w.join(i.fsPath,a)))),c||(c=i?i.fsPath:n||""),(0,P.sanitizeCwd)(c)}e.getCwd=p;async function b(t,n,r){if(n)try{return await n(t)}catch(i){r?.error("Could not resolve terminal cwd",i);return}return t}function s(t,n,r){if(r)return i=>r.resolveWithEnvironment(n,t,i)}e.createVariableResolver=s;async function h(t,n,r,i,a,l,c,g=o.platform){let D;c&&(D=f(t,"automationShell",g)),D||(D=f(t,"shell",g));let k=D||n;if(g===3&&!r&&i){const S=w.join(i,"Sysnative").replace(/\//g,"\\").toLowerCase();k&&k.toLowerCase().indexOf(S)===0&&(k=w.join(i,"System32",k.substr(S.length+1)))}if(k&&g===3&&(k=k.replace(/\//g,"\\")),a)try{k=await a(k)}catch(S){l.error("Could not resolve shell",S)}return k}e.getDefaultShell=h;async function u(t,n,r,i,a=o.platform){if(n&&f(t,"automationShell",a))return[];const l=a===3?"windows":a===1?"osx":"linux";let c=t(`terminal.integrated.shellArgs.${l}`);if(!c)return[];if(typeof c=="string"&&a===3)return r?await r(c):c;if(r){const g=[];for(const D of c)try{g.push(await r(D))}catch(k){i.error(`Could not resolve terminal.integrated.shellArgs.${l}`,k),g.push(D)}c=g}return c}e.getDefaultShellArgs=u;function f(t,n,r=o.platform){return t(`terminal.integrated.${n}.${r===3?"windows":r===1?"osx":"linux"}`)}async function I(t,n,r,i,a,l){const c={};if(t.strictEnv)T(c,t.env);else{T(c,l);const g={...n};r&&(g&&await y(r,g),t.env&&await y(r,t.env)),(0,L.sanitizeProcessEnvironment)(c,"VSCODE_IPC_HOOK_CLI"),A(c,g),A(c,t.env),m(c,i,o.language,a)}return c}e.createTerminalEnvironment=I;async function O(t,n,r,i,a,l,c=o.isWindows){let g;if((0,C.isString)(t)?g=t:(g=t.fsPath,c&&l!==1?g=g.replace(/\\/g,"/"):!c&&l===1&&(g=g.replace(/\//g,"\\"))),!n)return g;const D=g.includes(" "),k=g.includes("(")||g.includes(")"),S=w.basename(n,".exe"),F=S==="pwsh"||r==="pwsh"||S==="powershell"||r==="powershell";if(F&&(D||g.includes("'")))return`& '${g.replace(/'/g,"''")}'`;if(k&&F)return`& '${g}'`;if(l===1){if(i!==void 0)return i==="gitbash"?(0,P.escapeNonWindowsPath)(g.replace(/\\/g,"/")):i==="wsl"?a?.getWslPath(g,"win-to-unix")||g:D?`"${g}"`:g;const H=n.toLowerCase();return H.includes("wsl")||H.includes("bash.exe")&&!H.toLowerCase().includes("git")?a?.getWslPath(g,"win-to-unix")||g:D?`"${g}"`:g}return(0,P.escapeNonWindowsPath)(g)}e.preparePathForShell=O}),define(ge[69],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(P){P.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var L;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class o{static fromExtHostTestItem(C,A,v=C.parent){if(C._isRoot)return new o([A]);const m=[C.id];for(let T=v;T&&T.id!==A;T=T.parent)m.push(T.id);return m.push(A),new o(m.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const A=C.indexOf("\0");return A===-1?C:C.slice(0,A)}static fromString(C){return new o(C.split("\0"))}static join(C,A){return new o([...C.path,A])}static joinToString(C,A){return C.toString()+"\0"+A}static parentId(C){const A=C.lastIndexOf("\0");return A===-1?void 0:C.slice(0,A)}static localId(C){const A=C.lastIndexOf("\0");return A===-1?C:C.slice(A+1)}static isChild(C,A){return A.startsWith(C)&&A[C.length]==="\0"}static compare(C,A){return C===A?0:o.isChild(C,A)?2:o.isChild(A,C)?3:1}constructor(C,A=C.length){if(this.path=C,this.d=A,C.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new o(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new o(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new o(this.path,C)}compare(C){if(typeof C=="string")return o.compare(this.toString(),C);for(let A=0;A<C.d&&A<this.d;A++)if(C.path[A]!==this.path[A])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=o}),define(ge[89],pe([1,0,4,49,69]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var P;(function(g){g[g.Unset=0]="Unset",g[g.Queued=1]="Queued",g[g.Running=2]="Running",g[g.Passed=3]="Passed",g[g.Failed=4]="Failed",g[g.Skipped=5]="Skipped",g[g.Errored=6]="Errored"})(P||(e.TestResultState=P={}));var C;(function(g){g[g.Run=1]="Run",g[g.Debug=2]="Debug",g[g.Coverage=3]="Coverage"})(C||(e.ExtTestRunProfileKind=C={}));var A;(function(g){g[g.Run=2]="Run",g[g.Debug=4]="Debug",g[g.Coverage=8]="Coverage",g[g.HasNonDefaultProfile=16]="HasNonDefaultProfile",g[g.HasConfigurable=32]="HasConfigurable",g[g.SupportsContinuousRun=64]="SupportsContinuousRun"})(A||(e.TestRunProfileBitset=A={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const v=g=>"runId"in g;e.isStartControllerTests=v;var m;(function(g){g.serialize=D=>({range:D.range.toJSON(),uri:D.uri.toJSON()}),g.deserialize=D=>({range:L.Range.lift(D.range),uri:w.URI.revive(D.uri)})})(m||(e.IRichLocation=m={}));var T;(function(g){g[g.Error=0]="Error",g[g.Output=1]="Output"})(T||(e.TestMessageType=T={}));var y;(function(g){g.serialize=D=>({message:D.message,type:0,expected:D.expected,actual:D.actual,location:D.location&&m.serialize(D.location)}),g.deserialize=D=>({message:D.message,type:0,expected:D.expected,actual:D.actual,location:D.location&&m.deserialize(D.location)})})(y||(e.ITestErrorMessage=y={}));const E=(g,D)=>`${D?"s":"e"}${g}`;e.getMarkId=E;var d;(function(g){g.serialize=D=>({message:D.message,type:1,offset:D.offset,length:D.length,location:D.location&&m.serialize(D.location)}),g.deserialize=D=>({message:D.message,type:1,offset:D.offset,length:D.length,location:D.location&&m.deserialize(D.location)})})(d||(e.ITestOutputMessage=d={}));var p;(function(g){g.serialize=D=>D.type===0?y.serialize(D):d.serialize(D),g.deserialize=D=>D.type===0?y.deserialize(D):d.deserialize(D)})(p||(e.ITestMessage=p={}));var b;(function(g){g.serializeWithoutMessages=D=>({state:D.state,duration:D.duration,messages:[]}),g.serialize=D=>({state:D.state,duration:D.duration,messages:D.messages.map(p.serialize)}),g.deserialize=D=>({state:D.state,duration:D.duration,messages:D.messages.map(p.deserialize)})})(b||(e.ITestTaskState=b={}));const s="\0",h=(g,D)=>g+s+D;e.namespaceTestTag=h;const u=g=>{const D=g.indexOf(s);return{ctrlId:g.slice(0,D),tagId:g.slice(D+1)}};e.denamespaceTestTag=u;var f;(function(g){g.serialize=D=>({extId:D.extId,label:D.label,tags:D.tags,busy:D.busy,children:void 0,uri:D.uri?.toJSON(),range:D.range?.toJSON()||null,description:D.description,error:D.error,sortText:D.sortText}),g.deserialize=D=>({extId:D.extId,label:D.label,tags:D.tags,busy:D.busy,children:void 0,uri:D.uri?w.URI.revive(D.uri):void 0,range:D.range?L.Range.lift(D.range):null,description:D.description,error:D.error,sortText:D.sortText})})(f||(e.ITestItem=f={}));var I;(function(g){g[g.NotExpandable=0]="NotExpandable",g[g.Expandable=1]="Expandable",g[g.BusyExpanding=2]="BusyExpanding",g[g.Expanded=3]="Expanded"})(I||(e.TestItemExpandState=I={}));var O;(function(g){g.serialize=D=>({expand:D.expand,item:f.serialize(D.item)}),g.deserialize=D=>({controllerId:o.TestId.root(D.item.extId),expand:D.expand,item:f.deserialize(D.item)})})(O||(e.InternalTestItem=O={}));var t;(function(g){g.serialize=D=>{let k;return D.item&&(k={},D.item.label!==void 0&&(k.label=D.item.label),D.item.tags!==void 0&&(k.tags=D.item.tags),D.item.busy!==void 0&&(k.busy=D.item.busy),D.item.uri!==void 0&&(k.uri=D.item.uri?.toJSON()),D.item.range!==void 0&&(k.range=D.item.range?.toJSON()),D.item.description!==void 0&&(k.description=D.item.description),D.item.error!==void 0&&(k.error=D.item.error),D.item.sortText!==void 0&&(k.sortText=D.item.sortText)),{extId:D.extId,expand:D.expand,item:k}},g.deserialize=D=>{let k;return D.item&&(k={},D.item.label!==void 0&&(k.label=D.item.label),D.item.tags!==void 0&&(k.tags=D.item.tags),D.item.busy!==void 0&&(k.busy=D.item.busy),D.item.range!==void 0&&(k.range=D.item.range?L.Range.lift(D.item.range):null),D.item.description!==void 0&&(k.description=D.item.description),D.item.error!==void 0&&(k.error=D.item.error),D.item.sortText!==void 0&&(k.sortText=D.item.sortText)),{extId:D.extId,expand:D.expand,item:k}}})(t||(e.ITestItemUpdate=t={}));const n=(g,D)=>{D.expand!==void 0&&(g.expand=D.expand),D.item!==void 0&&(g.item=g.item?Object.assign(g.item,D.item):D.item)};e.applyTestItemUpdate=n;var r;(function(g){g.serializeWithoutMessages=D=>({...O.serialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(b.serializeWithoutMessages),retired:D.retired}),g.serialize=D=>({...O.serialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(b.serialize),retired:D.retired}),g.deserialize=D=>({...O.deserialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(b.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var i;(function(g){g[g.Function=0]="Function",g[g.Statement=1]="Statement"})(i||(e.DetailType=i={}));var a;(function(g){g[g.Add=0]="Add",g[g.Update=1]="Update",g[g.DocumentSynced=2]="DocumentSynced",g[g.Remove=3]="Remove",g[g.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",g[g.Retire=5]="Retire",g[g.AddTag=6]="AddTag",g[g.RemoveTag=7]="RemoveTag"})(a||(e.TestDiffOpType=a={}));var l;(function(g){g.deserialize=D=>D.op===0?{op:D.op,item:O.deserialize(D.item)}:D.op===1?{op:D.op,item:t.deserialize(D.item)}:D.op===2?{op:D.op,uri:w.URI.revive(D.uri),docv:D.docv}:D,g.serialize=D=>D.op===0?{op:D.op,item:O.serialize(D.item)}:D.op===1?{op:D.op,item:t.serialize(D.item)}:D})(l||(e.TestsDiffOp=l={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(D){const k=this.o();for(const S of D)switch(S.op){case 0:this.j(O.deserialize(S.item),k);break;case 1:this.k(t.deserialize(S.item),k);break;case 3:this.l(S.itemId,k);break;case 5:this.m(S.itemId);break;case 4:this.updatePendingRoots(S.amount);break;case 6:this.c.set(S.tag.id,S.tag);break;case 7:this.c.delete(S.id);break}k.complete?.()}j(D,k){const S=o.TestId.parentId(D.item.extId)?.toString();let F;if(!S)F=this.p(D),this.f.add(F),this.d.set(D.item.extId,F);else if(this.d.has(S)){const H=this.d.get(S);H.children.add(D.item.extId),F=this.p(D,H),this.d.set(D.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(D)}`);return}return k.add?.(F),D.expand===2&&this.g++,F}k(D,k){const S=this.d.get(D.extId);if(S)return D.expand!==void 0&&(S.expand===2&&this.g--,D.expand===2&&this.g++),(0,e.applyTestItemUpdate)(S,D),k.update?.(S),S}l(D,k){const S=this.d.get(D);if(!S)return;const F=o.TestId.parentId(S.item.extId)?.toString();F?this.d.get(F).children.delete(S.item.extId):this.f.delete(S);const H=[[D]];for(;H.length;)for(const te of H.pop()){const ce=this.d.get(te);ce&&(H.push(ce.children),this.d.delete(te),k.remove?.(ce,ce!==S),ce.expand===2&&this.g--)}}m(D){}updatePendingRoots(D){this.h+=D}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(ge[130],pe([1,0,14,6,2,92,89,69]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const m=(u,f)=>u===f,y=Object.entries({range:(u,f)=>u===f?!0:!u||!f?!1:u.equalsRange(f),busy:m,label:m,description:m,error:m,sortText:m,tags:(u,f)=>!(u.length!==f.length||u.some(I=>!f.includes(I)))}),E=(u,f)=>{let I;for(const[O,t]of y)t(u[O],f[O])||(I?I[O]=f[O]:I={[O]:f[O]});return I};class d extends o.Disposable{get root(){return this.m.root}constructor(f){super(),this.m=f,this.f=this.B(new w.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new L.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(f){this.h=f;for(const I of this.tree.values())this.G(I)}get resolveHandler(){return this.h}collectDiff(){const f=this.k;return this.k=[],f}pushDiff(f){switch(f.op){case 2:{for(const I of this.k)if(I.op===2&&I.uri===f.uri){I.docv=f.docv;return}break}case 1:{const I=this.k[this.k.length-1];if(I){if(I.op===1&&I.item.extId===f.item.extId){(0,C.applyTestItemUpdate)(I.item,f.item);return}if(I.op===0&&I.item.item.extId===f.item.extId){(0,C.applyTestItemUpdate)(I.item,f.item);return}}break}}this.k.push(f),this.f.isScheduled()||this.f.schedule()}expand(f,I){const O=this.tree.get(f);if(O){if((O.expandLevels===void 0||I>O.expandLevels)&&(O.expandLevels=I),O.expand===1){const t=this.I(O);return t.isOpen()?this.H(O,I-1):t.wait().then(()=>this.H(O,I-1))}else if(O.expand===3)return O.resolveBarrier?.isOpen()===!1?O.resolveBarrier.wait().then(()=>this.H(O,I-1)):this.H(O,I-1)}}dispose(){for(const f of this.tree.values())this.m.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(f,I){switch(I.op){case 3:this.L(A.TestId.joinToString(f.fullId,I.id));break;case 0:this.u(I.item,f);break;case 5:for(const O of I.ops)this.p(f,O);break;case 1:this.w(I.new,I.old,f.fullId.toString());break;case 2:this.G(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:I.update}});break;case 6:this.s(f.actual.uri);break;default:(0,P.assertNever)(I)}}s(f){f&&this.pushDiff({op:2,uri:f,docv:this.m.getDocumentVersion(f)})}u(f,I){const O=A.TestId.fromExtHostTestItem(f,this.root.id,I?.actual),t=this.m.getApiFor(f);t.parent&&t.parent!==I?.actual&&this.m.getChildren(t.parent).delete(f.id);let n=this.tree.get(O.toString());if(!n){n={fullId:O,actual:f,expandLevels:I?.expandLevels?I.expandLevels-1:void 0,expand:0},f.tags.forEach(this.y,this),this.tree.set(n.fullId.toString(),n),this.C(f,I),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:n.expand,item:this.m.toITestItem(f)}}),this.F(f,n,I);return}if(n.actual===f){this.D(f,n,I);return}if(n.actual.uri?.toString()!==f.uri?.toString())return this.L(O.toString()),this.u(f,I);const r=this.m.getChildren(n.actual),i=n.actual,a=E(this.m.toITestItem(i),this.m.toITestItem(f));this.m.getApiFor(i).listener=void 0,n.actual=f,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.w(f.tags,i.tags,O.toString()),delete a.tags),this.p(n,{op:4,update:a})),this.F(f,n,I);for(const[l,c]of r)this.m.getChildren(f).get(c.id)||this.L(A.TestId.joinToString(O,c.id));this.s(n.actual.uri)}w(f,I,O){const t=new Set(I.map(n=>n.id));for(const n of f)t.delete(n.id)||this.y(n);this.pushDiff({op:1,item:{extId:O,item:{tags:f.map(n=>(0,C.namespaceTestTag)(this.m.controllerId,n.id))}}}),t.forEach(this.z,this)}y(f){const I=this.j.get(f.id);I?I.refCount++:(this.j.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,f.id)}}))}z(f){const I=this.j.get(f);I&&!--I.refCount&&(this.j.delete(f),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,f)}))}C(f,I){this.m.getApiFor(f).parent=I&&I.actual!==this.root?I.actual:void 0}D(f,I,O){this.C(f,O);const t=this.m.getApiFor(f);t.parent=O?.actual,t.listener=n=>this.p(I,n),this.G(I)}F(f,I,O){this.D(f,I,O);for(const[t,n]of this.m.getChildren(f))this.u(n,I)}G(f){let I;this.h?f.resolveBarrier?I=f.resolveBarrier.isOpen()?3:2:I=f.actual.canResolveChildren?1:0:I=0,I!==f.expand&&(f.expand=I,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:I}}),I===1&&f.expandLevels!==void 0&&this.I(f))}H(f,I){if(I<0)return;const O=[];for(const[t,n]of this.m.getChildren(f.actual)){const r=this.expand(A.TestId.joinToString(f.fullId,n.id),I);(0,w.isThenable)(r)&&O.push(r)}if(O.length)return Promise.all(O).then(()=>{})}I(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this.h){const n=new w.Barrier;return n.open(),n}f.expand=2,this.J(f);const I=f.resolveBarrier=new w.Barrier,O=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,n)};let t;try{t=this.h(f.actual===this.root?void 0:f.actual)}catch(n){O(n)}return(0,w.isThenable)(t)?t.catch(O).then(()=>{I.open(),this.G(f)}):(I.open(),this.G(f)),f.resolveBarrier}J(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}L(f){const I=this.tree.get(f);if(!I)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const O=[I];for(;O.length;){const t=O.pop();if(t){this.m.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.z(n.id);this.tree.delete(t.fullId.toString());for(const[n,r]of this.m.getChildren(t.actual))O.push(this.tree.get(A.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.g.fire(f)}}e.TestItemCollection=d;class p extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=p;class b extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class s extends Error{constructor(f,I,O){super(`TestItem with ID "${f}" is from controller "${I}" and cannot be added as a child of an item from controller "${O}".`)}}e.MixedTestItemController=s;const h=(u,f,I)=>{let O=new Map;return{get size(){return O.size},forEach(t,n){for(const r of O.values())t.call(n,r,this)},[Symbol.iterator](){return O.entries()},replace(t){const n=new Map,r=new Set(O.keys()),i={op:5,ops:[]};for(const a of t){if(!(a instanceof I))throw new b(a.id);const l=f(a).controllerId;if(l!==u.controllerId)throw new s(a.id,l,u.controllerId);if(n.has(a.id))throw new p(a.id);n.set(a.id,a),r.delete(a.id),i.ops.push({op:0,item:a})}for(const a of r.keys())i.ops.push({op:3,id:a});u.listener?.(i),O=n},add(t){if(!(t instanceof I))throw new b(t.id);O.set(t.id,t),u.listener?.({op:0,item:t})},delete(t){O.delete(t)&&u.listener?.({op:3,id:t})},get(t){return O.get(t)},toJSON(){return Array.from(O.values())}}};e.createTestItemChildren=h}),define(ge[131],pe([1,0,130]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const L=new WeakMap,o=(C,A)=>{const v={controllerId:A};return L.set(C,v),v};e.createPrivateApiFor=o;const P=C=>{const A=L.get(C);if(!A)throw new w.InvalidTestItemError(C?.id||"<unknown>");return A};e.getPrivateApiFor=P}),define(ge[269],pe([1,0,24,5]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5,6],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,L.refineServiceDecorator)(w.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(ge[132],pe([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,w.createDecorator)("configurationResolverService");var L;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class o extends Error{constructor(C,A){super(A),this.variable=C}}e.VariableError=o}),define(ge[270],pe([1,0,7,29,8,21,3,162,200,132,17]),function(oe,e,w,L,o,P,C,A,v,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(d,p,b,s){this.h=new Map,this.a=d,this.b=p,this.g=b,s&&(this.c=s.then(h=>this.i(h)))}i(d){if(C.isWindows){const p=Object.create(null);return Object.keys(d).forEach(b=>{p[b.toLowerCase()]=d[b]}),p}return d}resolveWithEnvironment(d,p,b){return this.l({env:this.i(d),userHome:void 0},p?p.uri:void 0,b)}async resolveAsync(d,p){const b={env:await this.c,userHome:await this.g};return this.l(b,d?d.uri:void 0,p)}async j(d,p,b,s){const h=P.deepClone(p);C.isWindows&&h.windows?Object.keys(h.windows).forEach(f=>h[f]=h.windows[f]):C.isMacintosh&&h.osx?Object.keys(h.osx).forEach(f=>h[f]=h.osx[f]):C.isLinux&&h.linux&&Object.keys(h.linux).forEach(f=>h[f]=h.linux[f]),delete h.windows,delete h.osx,delete h.linux;const u={env:await this.c,userHome:await this.g};return this.l(u,d?d.uri:void 0,h,b,s)}async resolveAnyAsync(d,p,b){return this.j(d,p,b)}async resolveAnyMap(d,p,b){const s=new Map;return{newConfig:await this.j(d,p,b,s),resolvedVariables:s}}resolveWithInteractionReplace(d,p,b,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(d,p,b,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(d,p){if(this.h.has(d))throw new Error("Variable "+d+" is contributed twice.");this.h.set(d,p)}async l(d,p,b,s,h){if(o.isString(b))return this.m(d,p,b,s,h);if(Array.isArray(b))return Promise.all(b.map(u=>this.l(d,p,u,s,h)));if(o.isObject(b)){const u=Object.create(null),f=await Promise.all(Object.keys(b).map(async I=>[await this.m(d,p,I,s,h),await this.l(d,p,b[I],s,h)]));for(const[I,O]of f)u[I]=O;return u}return b}m(d,p,b,s,h){return(0,T.replaceAsync)(b,y.VARIABLE_REGEXP,async(u,f)=>{if(f.includes(y.VARIABLE_LHS))return u;let I=await this.o(d,u,f,p,s);return h?.set(f,I),I!==u&&o.isString(I)&&I.match(y.VARIABLE_REGEXP)&&(I=await this.m(d,p,I,s,h)),I})}n(d){return this.b?this.b.getUriLabel(d,{noPrefix:!0}):d.fsPath}async o(d,p,b,s,h){let u;const f=b.split(":");f.length>1&&(b=f[0],u=f[1]);const I=n=>{const r=this.a.getFilePath();if(r)return(0,A.normalizeDriveLetter)(r);throw new m.VariableError(n,(0,v.localize)(0,null,p))},O=n=>{const r=I(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,A.normalizeDriveLetter)(i)}throw new m.VariableError(n,(0,v.localize)(1,null,p,w.basename(r)))},t=n=>{if(u){const r=this.a.getFolderUri(u);if(r)return r;throw new m.VariableError(n,(0,v.localize)(2,null,p,u))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new m.VariableError(n,(0,v.localize)(3,null,p)):new m.VariableError(n,(0,v.localize)(4,null,p))};switch(b){case"env":if(u){if(d.env){const n=d.env[C.isWindows?u.toLowerCase():u];if(o.isString(n))return n}return""}throw new m.VariableError(m.VariableKind.Env,(0,v.localize)(5,null,p));case"config":if(u){const n=this.a.getConfigurationValue(s,u);if(o.isUndefinedOrNull(n))throw new m.VariableError(m.VariableKind.Config,(0,v.localize)(6,null,p,u));if(o.isObject(n))throw new m.VariableError(m.VariableKind.Config,(0,v.localize)(7,null,p,u));return n}throw new m.VariableError(m.VariableKind.Config,(0,v.localize)(8,null,p));case"command":return this.p(m.VariableKind.Command,p,u,h,"command");case"input":return this.p(m.VariableKind.Input,p,u,h,"input");case"extensionInstallFolder":if(u){const n=await this.a.getExtension(u);if(!n)throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,p,u));return this.n(n.extensionLocation)}throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,p));default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.n(t(m.VariableKind.WorkspaceFolder)));case"cwd":return s||u?(0,A.normalizeDriveLetter)(this.n(t(m.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(w.basename(this.n(t(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(d.userHome)return d.userHome;throw new m.VariableError(m.VariableKind.UserHome,(0,v.localize)(11,null,p))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new m.VariableError(m.VariableKind.LineNumber,(0,v.localize)(12,null,p))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new m.VariableError(m.VariableKind.SelectedText,(0,v.localize)(13,null,p))}case"file":return I(m.VariableKind.File);case"fileWorkspaceFolder":return O(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return s||u?w.relative(this.n(t(m.VariableKind.RelativeFile)),I(m.VariableKind.RelativeFile)):I(m.VariableKind.RelativeFile);case"relativeFileDirname":{const n=w.dirname(I(m.VariableKind.RelativeFileDirname));if(s||u){const r=w.relative(this.n(t(m.VariableKind.RelativeFileDirname)),n);return r.length===0?".":r}return n}case"fileDirname":return w.dirname(I(m.VariableKind.FileDirname));case"fileExtname":return w.extname(I(m.VariableKind.FileExtname));case"fileBasename":return w.basename(I(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=w.basename(I(m.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-w.extname(n).length)}case"fileDirnameBasename":return w.basename(w.dirname(I(m.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||p}case"execInstallFolder":{const n=this.a.getAppRoot();return n||p}case"pathSeparator":return w.sep;default:try{const n=u?`${b}:${u}`:b;return this.p(m.VariableKind.Unknown,p,n,h,void 0)}catch{return p}}}}p(d,p,b,s,h){if(b&&s){const u=h===void 0?s[b]:s[h+":"+b];if(typeof u=="string")return u;throw new m.VariableError(d,(0,v.localize)(14,null,p))}return p}}e.AbstractVariableResolverService=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[271],pe([1,0,5,88]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var o;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(o||(e.GroupDirection=o={}));var P;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var C;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(C||(e.GroupLocation=C={}));var A;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(A||(e.GroupsArrangement=A={}));var v;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function m(p){const b=p;return(0,L.isEditorInput)(b?.editor)&&(0,L.isEditorInput)(b?.replacement)}e.isEditorReplacement=m;var T;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var y;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function E(p){const b=p;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=E;function d(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=d}),define(ge[133],pe([1,0,5,271]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function o(P){const C=P;return typeof P=="number"||(0,L.isEditorGroup)(C)}e.isPreferredGroup=o}),define(ge[272],pe([1,0,8,269,12,115,87,86,132,88,133,13,220,267]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let p=e.RemoteTerminalChannelClient=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(s,h,u,f,I,O,t,n,r,i){this.a=s,this.b=h,this.c=u,this.d=f,this.e=I,this.f=O,this.g=t,this.h=n,this.i=r,this.j=i}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(s,h,u,f,I,O,t,n){await this.c.whenRemoteConfigurationLoaded();const r=Object.create(null),i=u?(0,w.withNullAsUndefined)(this.d.getWorkspaceFolder(u)):void 0;let a;try{a=(await this.e.resolveAnyMap(i,{shellLaunchConfig:s,configuration:h})).resolvedVariables}catch(te){this.h.error(te)}if(a)for(const[te,ce]of a.entries())(/^config:/.test(te)||te==="selectedText"||te==="lineNumber")&&(r[te]=ce);const l=[];for(const[te,ce]of this.f.collections.entries())l.push([te,(0,A.serializeEnvironmentVariableCollection)(ce.map),(0,A.serializeEnvironmentDescriptionMap)(ce.descriptionMap)]);const c=await this.g.resolveAuthority(this.a),g=c.options&&c.options.extensionHostEnv,D=this.d.getWorkspace(),k=D.folders,S=u?this.d.getWorkspaceFolder(u):null,F=m.EditorResourceAccessor.getOriginalUri(this.i.activeEditor,{supportSideBySide:m.SideBySideEditor.PRIMARY,filterByScheme:[y.Schemas.file,y.Schemas.vscodeUserData,y.Schemas.vscodeRemote]}),H={configuration:h,resolvedVariables:r,envVariableCollections:l,shellLaunchConfig:s,workspaceId:D.id,workspaceName:this.j.getWorkspaceLabel(D),workspaceFolders:k,activeWorkspaceFolder:S,activeFileResource:F,shouldPersistTerminal:I,options:f,cols:O,rows:t,unicodeVersion:n,resolverEnv:g};return await this.b.call("$createProcess",H)}requestDetachInstance(s,h){return this.b.call("$requestDetachInstance",[s,h])}acceptDetachInstanceReply(s,h){return this.b.call("$acceptDetachInstanceReply",[s,h])}attachToProcess(s){return this.b.call("$attachToProcess",[s])}detachFromProcess(s,h){return this.b.call("$detachFromProcess",[s,h])}listProcesses(){return this.b.call("$listProcesses")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(s,h){return this.b.call("$processBinary",[s,h])}start(s){return this.b.call("$start",[s])}input(s,h){return this.b.call("$input",[s,h])}acknowledgeDataEvent(s,h){return this.b.call("$acknowledgeDataEvent",[s,h])}setUnicodeVersion(s,h){return this.b.call("$setUnicodeVersion",[s,h])}shutdown(s,h){return this.b.call("$shutdown",[s,h])}resize(s,h,u){return this.b.call("$resize",[s,h,u])}getInitialCwd(s){return this.b.call("$getInitialCwd",[s])}getCwd(s){return this.b.call("$getCwd",[s])}orphanQuestionReply(s){return this.b.call("$orphanQuestionReply",[s])}sendCommandResult(s,h,u){return this.b.call("$sendCommandResult",[s,h,u])}freePortKillProcess(s){return this.b.call("$freePortKillProcess",[s])}installAutoReply(s,h){return this.b.call("$installAutoReply",[s,h])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(s){return this.b.call("$getDefaultSystemShell",[s])}getProfiles(s,h,u){return this.b.call("$getProfiles",[this.d.getWorkspace().id,s,h,u])}acceptPtyHostResolvedVariables(s,h){return this.b.call("$acceptPtyHostResolvedVariables",[s,h])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(s,h){return this.b.call("$getWslPath",[s,h])}setTerminalLayoutInfo(s){const u={workspaceId:this.d.getWorkspace().id,tabs:s?s.tabs:[]};return this.b.call("$setTerminalLayoutInfo",u)}updateTitle(s,h,u){return this.b.call("$updateTitle",[s,h,u])}updateIcon(s,h,u,f){return this.b.call("$updateIcon",[s,h,u,f])}refreshProperty(s,h){return this.b.call("$refreshProperty",[s,h])}updateProperty(s,h,u){return this.b.call("$updateProperty",[s,h,u])}getTerminalLayoutInfo(){const h={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",h)}reviveTerminalProcesses(s,h){return this.b.call("$reviveTerminalProcesses",[s,h])}getRevivedPtyNewId(s){return this.b.call("$getRevivedPtyNewId",[s])}serializeTerminalState(s){return this.b.call("$serializeTerminalState",[s])}};e.RemoteTerminalChannelClient=p=Le([Re(2,L.IWorkbenchConfigurationService),Re(3,C.IWorkspaceContextService),Re(4,v.IConfigurationResolverService),Re(5,d.IEnvironmentVariableService),Re(6,P.IRemoteAuthorityResolverService),Re(7,o.ILogService),Re(8,T.IEditorService),Re(9,E.ILabelService)],p)}),define(ge[273],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var w;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(w||(e.ExtHostConnectionType=w={}));class L{constructor(y){this.pipeName=y,this.type=1}serialize(y){y[L.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=L,L.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class o{constructor(){this.type=2}serialize(y){y[o.ENV_KEY]="1"}}e.SocketExtHostConnection=o,o.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(y){y[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function C(T){delete T[L.ENV_KEY],delete T[o.ENV_KEY],delete T[P.ENV_KEY]}function A(T,y){C(y),T.serialize(y)}e.writeExtHostConnection=A;function v(T){if(T[L.ENV_KEY])return m(T,new L(T[L.ENV_KEY]));if(T[o.ENV_KEY])return m(T,new o);if(T[P.ENV_KEY])return m(T,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=v;function m(T,y){return C(T),y}}),define(ge[274],pe([1,0,15]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(L||(e.UIKind=L={}));var o;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(o||(e.ExtensionHostExitCode=o={}));var P;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function C(m){const T=w.VSBuffer.alloc(1);switch(m){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}e.createMessageOfType=C;function A(m,T){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}e.isMessageOfType=A;var v;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(ge[275],pe([1,0,5,6,12,263,274,55,37,21,4,2,198]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let d=e.ExtHostTelemetry=class extends y.Disposable{constructor(h,u){super(),this.n=h,this.p=u,this.a=this.B(new L.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=T.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=u.createLogger(this.j,{id:v.extensionTelemetryLogChannelId,name:(0,E.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(u.onDidChangeLogLevel(f=>{(0,o.isLogLevel)(f)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===o.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(h,u,f){const I=this.getTelemetryDetails(),O=new p(u,f,h,this.k,this.i,this.getBuiltInCommonProperties(h),{isUsageEnabled:I.isUsageEnabled,isErrorsEnabled:I.isErrorsEnabled}),t=this.m.get(h.identifier.value)??[];return this.m.set(h.identifier.value,[...t,O]),O.apiTelemetryLogger}$initializeTelemetryLevel(h,u,f){this.f=h,this.g=u,this.c=f??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(h){const u=Object.create(null);switch(u["common.extname"]=`${h.publisher}.${h.name}`,u["common.extversion"]=h.version,u["common.vscodemachineid"]=this.n.telemetryInfo.machineId,u["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,u["common.vscodeversion"]=this.n.version,u["common.isnewappinstall"]=b(this.n.telemetryInfo.firstSessionDate),u["common.product"]=this.n.environment.appHost,this.n.uiKind){case C.UIKind.Web:u["common.uikind"]="web";break;case C.UIKind.Desktop:u["common.uikind"]="desktop";break;default:u["common.uikind"]="unknown"}return u["common.remotename"]=(0,A.getRemoteName)((0,v.cleanRemoteAuthority)(this.n.remote.authority)),u}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const u=this.getTelemetryDetails();this.m.forEach((f,I)=>{const O=f.filter(t=>!t.isDisposed);O.length===0?this.m.delete(I):this.m.set(I,O)}),this.m.forEach(f=>{for(const I of f)I.updateTelemetryEnablements(u.isUsageEnabled,u.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(h,u){const I=this.m.get(h.value)?.filter(t=>!t.isDisposed);if(!I)return this.m.delete(h.value),!1;let O=!1;for(const t of I)t.ignoreUnhandledExtHostErrors||(t.logError(u),O=!0);return O}};e.ExtHostTelemetry=d=Le([Re(0,P.IExtHostInitDataService),Re(1,o.ILoggerService)],d);class p{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,u,f,I,O,t,n){this.g=f,this.h=I,this.i=O,this.j=t,this.a=new L.Emitter,this.ignoreUnhandledExtHostErrors=u?.ignoreUnhandledErrors??!1,this.b=u?.ignoreBuiltInCommonProperties??!1,this.c=u?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(h,u){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:u},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let u="properties"in h?h.properties??{}:h;return u=(0,v.cleanData)(u,[]),this.c&&(u=(0,m.mixin)(u,this.c)),this.b||(u=(0,m.mixin)(u,this.j)),"properties"in h?h.properties=u:h=u,h}k(h,u){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,u=this.mixInCommonPropsAndCleanData(u||{}),this.i||this.f?.sendEventData(h,u),this.h.trace(h,u))}logUsage(h,u){this.d.isUsageEnabled&&this.k(h,u)}logError(h,u){!this.d.isErrorsEnabled||!this.f||(typeof h=="string"?this.k(h,u):this.f.sendErrorData(h,u))}get apiTelemetryLogger(){if(!this.e){const h=this,u={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(u)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=p;function b(s){const h=Date.now()-new Date(s).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.isNewAppInstall=b,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(ge[276],pe([1,0,6,4,34,231,36,5]),function(oe,e,w,L,o,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class v{constructor(O){this.dependency=O}}e.MissingExtensionDependency=v;var m;(function(I){I[I.EagerAutoStart=1]="EagerAutoStart",I[I.EagerManualStart=2]="EagerManualStart",I[I.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class T{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:P.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(O,t){const n=[],r=[],i=[],a=[],l=y(this.c),c=y(O),g=(H,te)=>H.extensionLocation.toString()===te.extensionLocation.toString()||H.isBuiltin===te.isBuiltin||H.isUserBuiltin===te.isUserBuiltin||H.isUnderDevelopment===te.isUnderDevelopment;for(const H of this.c){const te=c.get(H.identifier);if(!te){n.push(H.identifier),l.delete(H.identifier);continue}if(!g(H,te)){n.push(H.identifier),l.delete(H.identifier);continue}}for(const H of O){const te=l.get(H.identifier);if(!te){r.push(H);continue}if(!g(te,H)){n.push(te.identifier),l.delete(te.identifier);continue}}const D=new C.ExtensionIdentifierSet(this.d),k=new C.ExtensionIdentifierSet(t);for(const H of this.d)k.has(H)||i.push(H);for(const H of t)D.has(H)||a.push(H);const S=P.ImplicitActivationEvents.createActivationEventsMap(r),F={toRemove:n,toAdd:r,addActivationEvents:S,myToRemove:i,myToAdd:a};return this.delta(F),F}delta(O){const{toRemove:t,toAdd:n,myToRemove:r,myToAdd:i}=O,a=new C.ExtensionIdentifierSet(t),l=new C.ExtensionIdentifierSet(r);for(let c=0;c<this.c.length;c++)a.has(this.c[c].identifier)&&(this.c.splice(c,1),c--);for(let c=0;c<this.d.length;c++)l.has(this.d[c])&&(this.d.splice(c,1),c--);for(const c of n)this.c.push(c);for(const c of i)this.d.push(c)}containsExtension(O){for(const t of this.d)if(C.ExtensionIdentifier.equals(t,O))return!0;return!1}}e.ExtensionHostExtensions=T;function y(I){const O=new C.ExtensionIdentifierMap;for(const t of I)O.set(t.identifier,t);return O}function E(I,O){return I.enabledApiProposals?I.enabledApiProposals.includes(O):!1}e.isProposedApiEnabled=E;function d(I,O){if(!E(I,O))throw new Error(`Extension '${I.identifier.value}' CANNOT use API proposal: ${O}.
Its package.json#enabledApiProposals-property declares: ${I.enabledApiProposals?.join(", ")??"[]"} but NOT ${O}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${I.identifier.value}`)}e.checkProposedApiEnabled=d;class p{constructor(O,t,n,r){this.codeLoadingTime=O,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=r}}e.ActivationTimes=p;class b{constructor(O,t){this.description=O,this.value=t}}e.ExtensionPointContribution=b;var s;(function(I){I[I.Normal=0]="Normal",I[I.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function h(I){return{type:I.isBuiltin?0:1,isBuiltin:I.isBuiltin||I.isUserBuiltin,identifier:{id:(0,o.getGalleryExtensionId)(I.publisher,I.name),uuid:I.uuid},manifest:I,location:I.extensionLocation,targetPlatform:I.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function u(I,O){return{identifier:new C.ExtensionIdentifier((0,o.getExtensionId)(I.manifest.publisher,I.manifest.name)),isBuiltin:I.type===0,isUserBuiltin:I.type===1&&I.isBuiltin,isUnderDevelopment:!!O,extensionLocation:I.location,...I.manifest,uuid:I.identifier.uuid,targetPlatform:I.targetPlatform}}e.toExtensionDescription=u;class f{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(O){return Promise.resolve(void 0)}activationEventIsDone(O){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(O){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(O,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(O){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=f});var Ut=this&&this.__classPrivateFieldSet||function(oe,e,w,L,o){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!o)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!o:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?o.call(oe,w):o?o.value=w:e.set(oe,w),w},nt=this&&this.__classPrivateFieldGet||function(oe,e,w,L){if(w==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!L:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?L:w==="a"?L.call(oe):L?L.value:e.get(oe)};define(ge[134],pe([1,0,18,11,98,27,57,17,8,4,22,16,115,129,276]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p){"use strict";var b,s,h,u,f,I,O,t,n,r,i,a,l,c,g,D,k,S,F,H,te,ce,le,ue,ve;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function K(B){return Object.assign(B,{apply:function(){const re=arguments.length===1?[]:arguments[1];return Reflect.construct(B,re,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(B,[]);{const[re,...be]=arguments;return Reflect.construct(B,be,re.constructor)}}})}var ee;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(ee||(e.TerminalOutputAnchor=ee={}));var z;(function(B){B[B.Command=0]="Command",B[B.Opener=1]="Opener"})(z||(e.TerminalQuickFixType=z={}));let q=e.Disposable=t=class{static from(...M){let re=M;return new t(function(){if(re){for(const be of re)be&&typeof be.dispose=="function"&&be.dispose();re=void 0}})}constructor(M){b.set(this,void 0),Ut(this,b,M,"f")}dispose(){typeof nt(this,b,"f")=="function"&&(nt(this,b,"f").call(this),Ut(this,b,void 0,"f"))}};b=new WeakMap,e.Disposable=q=t=Le([K],q);let G=e.Position=n=class{static Min(...M){if(M.length===0)throw new TypeError;let re=M[0];for(let be=1;be<M.length;be++){const Be=M[be];Be.isBefore(re)&&(re=Be)}return re}static Max(...M){if(M.length===0)throw new TypeError;let re=M[0];for(let be=1;be<M.length;be++){const Be=M[be];Be.isAfter(re)&&(re=Be)}return re}static isPosition(M){if(!M)return!1;if(M instanceof n)return!0;const{line:re,character:be}=M;return typeof re=="number"&&typeof be=="number"}static of(M){if(M instanceof n)return M;if(this.isPosition(M))return new n(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(M,re){if(M<0)throw(0,L.illegalArgument)("line must be non-negative");if(re<0)throw(0,L.illegalArgument)("character must be non-negative");this.c=M,this.e=re}isBefore(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<M.e}isBeforeOrEqual(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<=M.e}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this.c===M.c&&this.e===M.e}compareTo(M){return this.c<M.c?-1:this.c>M.line?1:this.e<M.e?-1:this.e>M.e?1:0}translate(M,re=0){if(M===null||re===null)throw(0,L.illegalArgument)();let be;return typeof M>"u"?be=0:typeof M=="number"?be=M:(be=typeof M.lineDelta=="number"?M.lineDelta:0,re=typeof M.characterDelta=="number"?M.characterDelta:0),be===0&&re===0?this:new n(this.line+be,this.character+re)}with(M,re=this.character){if(M===null||re===null)throw(0,L.illegalArgument)();let be;return typeof M>"u"?be=this.line:typeof M=="number"?be=M:(be=typeof M.line=="number"?M.line:this.line,re=typeof M.character=="number"?M.character:this.character),be===this.line&&re===this.character?this:new n(be,re)}toJSON(){return{line:this.line,character:this.character}}};e.Position=G=n=Le([K],G);let ne=e.Range=r=class{static isRange(M){return M instanceof r?!0:M?G.isPosition(M.start)&&G.isPosition(M.end):!1}static of(M){if(M instanceof r)return M;if(this.isRange(M))return new r(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(M,re,be,Be){let He,Ze;if(typeof M=="number"&&typeof re=="number"&&typeof be=="number"&&typeof Be=="number"?(He=new G(M,re),Ze=new G(be,Be)):G.isPosition(M)&&G.isPosition(re)&&(He=G.of(M),Ze=G.of(re)),!He||!Ze)throw new Error("Invalid arguments");He.isBefore(Ze)?(this.c=He,this.e=Ze):(this.c=Ze,this.e=He)}contains(M){return r.isRange(M)?this.contains(M.start)&&this.contains(M.end):G.isPosition(M)?!(G.of(M).isBefore(this.c)||this.e.isBefore(M)):!1}isEqual(M){return this.c.isEqual(M.c)&&this.e.isEqual(M.e)}intersection(M){const re=G.Max(M.start,this.c),be=G.Min(M.end,this.e);if(!re.isAfter(be))return new r(re,be)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const re=G.Min(M.start,this.c),be=G.Max(M.end,this.end);return new r(re,be)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(M,re=this.end){if(M===null||re===null)throw(0,L.illegalArgument)();let be;return M?G.isPosition(M)?be=M:(be=M.start||this.start,re=M.end||this.end):be=this.start,be.isEqual(this.c)&&re.isEqual(this.end)?this:new r(be,re)}toJSON(){return[this.start,this.end]}};e.Range=ne=r=Le([K],ne);let se=e.Selection=i=class extends ne{static isSelection(M){return M instanceof i?!0:M?ne.isRange(M)&&G.isPosition(M.anchor)&&G.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(M,re,be,Be){let He,Ze;if(typeof M=="number"&&typeof re=="number"&&typeof be=="number"&&typeof Be=="number"?(He=new G(M,re),Ze=new G(be,Be)):G.isPosition(M)&&G.isPosition(re)&&(He=G.of(M),Ze=G.of(re)),!He||!Ze)throw new Error("Invalid arguments");super(He,Ze),this.f=He,this.g=Ze}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=se=i=Le([K],se);class de{constructor(M,re,be){if(typeof M!="string"||M.length===0)throw(0,L.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,L.illegalArgument)("port");if(typeof be<"u"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z_\-]+$/.test(be)))throw(0,L.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(re),this.connectionToken=be}}e.ResolvedAuthority=de;class W extends Error{static NotAvailable(M,re){return new W(M,E.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(M){return new W(M,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,re=E.RemoteAuthorityResolverErrorCode.Unknown,be){super(M),this._message=M,this._code=re,this._detail=be,Object.setPrototypeOf(this,W.prototype)}}e.RemoteAuthorityResolverError=W;var x;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var N;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(N||(e.EnvironmentVariableMutatorType=N={}));let R=e.TextEdit=a=class{static isTextEdit(M){return M instanceof a?!0:M?ne.isRange(M)&&typeof M.newText=="string":!1}static replace(M,re){return new a(M,re)}static insert(M,re){return a.replace(new ne(M,M),re)}static delete(M){return a.replace(M,"")}static setEndOfLine(M){const re=new a(new ne(new G(0,0),new G(0,0)),"");return re.newEol=M,re}get range(){return this.c}set range(M){if(M&&!ne.isRange(M))throw(0,L.illegalArgument)("range");this.c=M}get newText(){return this.e||""}set newText(M){if(M&&typeof M!="string")throw(0,L.illegalArgument)("newText");this.e=M}get newEol(){return this.f}set newEol(M){if(M&&typeof M!="number")throw(0,L.illegalArgument)("newEol");this.f=M}constructor(M,re){this.c=M,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.TextEdit=R=a=Le([K],R);let U=e.NotebookEdit=l=class{static isNotebookCellEdit(M){return M instanceof l?!0:M?Ft.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,re){return new l(M,re)}static insertCells(M,re){return new l(new Ft(M,M),re)}static deleteCells(M){return new l(M,[])}static updateCellMetadata(M,re){const be=new l(new Ft(M,M),[]);return be.newCellMetadata=re,be}static updateNotebookMetadata(M){const re=new l(new Ft(0,0),[]);return re.newNotebookMetadata=M,re}constructor(M,re){this.range=M,this.newCells=re}};e.NotebookEdit=U=l=Le([K],U);class X{static isSnippetTextEdit(M){return M instanceof X?!0:M?ne.isRange(M.range)&&$.isSnippetString(M.snippet):!1}static replace(M,re){return new X(M,re)}static insert(M,re){return X.replace(new ne(M,M),re)}constructor(M,re){this.range=M,this.snippet=re}}e.SnippetTextEdit=X;var ie;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(ie||(e.FileEditType=ie={}));let j=e.WorkspaceEdit=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(M,re,be,Be){this.c.push({_type:1,from:M,to:re,options:be,metadata:Be})}createFile(M,re,be){this.c.push({_type:1,from:void 0,to:M,options:re,metadata:be})}deleteFile(M,re,be){this.c.push({_type:1,from:M,to:void 0,options:re,metadata:be})}e(M,re,be){this.c.push({_type:3,metadata:be,uri:M,edit:{editType:5,metadata:re},notebookMetadata:re})}f(M,re,be,Be){const He=re.start,Ze=re.end;(He!==Ze||be.length>0)&&this.c.push({_type:5,uri:M,index:He,count:Ze-He,cells:be,metadata:Be})}g(M,re,be,Be){this.c.push({_type:3,metadata:Be,uri:M,edit:{editType:8,index:re,metadata:be}})}replace(M,re,be,Be){this.c.push({_type:2,uri:M,edit:new R(re,be),metadata:Be})}insert(M,re,be,Be){this.replace(M,new ne(re,re),be,Be)}delete(M,re,be){this.replace(M,re,"",be)}has(M){return this.c.some(re=>re._type===2&&re.uri.toString()===M.toString())}set(M,re){if(re)for(const be of re){if(!be)continue;let Be,He;Array.isArray(be)?(Be=be[0],He=be[1]):Be=be,U.isNotebookCellEdit(Be)?Be.newCellMetadata?this.g(M,Be.range.start,Be.newCellMetadata,He):Be.newNotebookMetadata?this.e(M,Be.newNotebookMetadata,He):this.f(M,Be.range,Be.newCells,He):X.isSnippetTextEdit(Be)?this.c.push({_type:6,uri:M,range:Be.range,edit:Be.snippet,metadata:He}):this.c.push({_type:2,uri:M,edit:Be,metadata:He})}else{for(let be=0;be<this.c.length;be++){const Be=this.c[be];switch(Be._type){case 2:case 6:case 3:case 5:Be.uri.toString()===M.toString()&&(this.c[be]=void 0);break}}(0,w.coalesceInPlace)(this.c)}}get(M){const re=[];for(const be of this.c)be._type===2&&be.uri.toString()===M.toString()&&re.push(be.edit);return re}entries(){const M=new P.ResourceMap;for(const re of this.c)if(re._type===2){let be=M.get(re.uri);be||(be=[re.uri,[]],M.set(re.uri,be)),be[1].push(re.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=j=Le([K],j);let $=e.SnippetString=c=class{static isSnippetString(M){return M instanceof c?!0:M?typeof M.value=="string":!1}static c(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this.e=1,this.value=M||""}appendText(M){return this.value+=c.c(M),this}appendTabstop(M=this.e++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,re=this.e++){if(typeof M=="function"){const be=new c;be.e=this.e,M(be),this.e=be.e,M=be.value}else M=c.c(M);return this.value+="${",this.value+=re,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,re=this.e++){const be=M.map(Be=>Be.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(M,re){if(typeof re=="function"){const be=new c;be.e=this.e,re(be),this.e=be.e,re=be.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.SnippetString=$=c=Le([K],$);var J;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(J||(e.DiagnosticTag=J={}));var V;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(V||(e.DiagnosticSeverity=V={}));let Z=e.Location=g=class{static isLocation(M){return M instanceof g?!0:M?ne.isRange(M.range)&&m.URI.isUri(M.uri):!1}constructor(M,re){if(this.uri=M,re)if(ne.isRange(re))this.range=ne.of(re);else if(G.isPosition(re))this.range=new ne(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Z=g=Le([K],Z);let Y=e.DiagnosticRelatedInformation=class{static is(M){return M?typeof M.message=="string"&&M.location&&ne.isRange(M.location.range)&&m.URI.isUri(M.location.uri):!1}constructor(M,re){this.location=M,this.message=re}static isEqual(M,re){return M===re?!0:!M||!re?!1:M.message===re.message&&M.location.range.isEqual(re.location.range)&&M.location.uri.toString()===re.location.uri.toString()}};e.DiagnosticRelatedInformation=Y=Le([K],Y);let _=e.Diagnostic=class{constructor(M,re,be=V.Error){if(!ne.isRange(M))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=M,this.message=re,this.severity=be}toJSON(){return{severity:V[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,re){return M===re?!0:!M||!re?!1:M.message===re.message&&M.severity===re.severity&&M.code===re.code&&M.severity===re.severity&&M.source===re.source&&M.range.isEqual(re.range)&&(0,w.equals)(M.tags,re.tags)&&(0,w.equals)(M.relatedInformation,re.relatedInformation,Y.isEqual)}};e.Diagnostic=_=Le([K],_);let ae=e.Hover=class{constructor(M,re){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=re}};e.Hover=ae=Le([K],ae);var Ee;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Ee||(e.DocumentHighlightKind=Ee={}));let Ce=e.DocumentHighlight=class{constructor(M,re=Ee.Text){this.range=M,this.kind=re}toJSON(){return{range:this.range,kind:Ee[this.kind]}}};e.DocumentHighlight=Ce=Le([K],Ce);var ke;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(ke||(e.SymbolKind=ke={}));var Ue;(function(B){B[B.Deprecated=1]="Deprecated"})(Ue||(e.SymbolTag=Ue={}));let ze=e.SymbolInformation=D=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,re,be,Be,He){this.name=M,this.kind=re,this.containerName=He,typeof be=="string"&&(this.containerName=be),Be instanceof Z?this.location=Be:be instanceof ne&&(this.location=new Z(Be,be)),D.validate(this)}toJSON(){return{name:this.name,kind:ke[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=ze=D=Le([K],ze);let me=e.DocumentSymbol=k=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(k.validate)}constructor(M,re,be,Be,He){this.name=M,this.detail=re,this.kind=be,this.range=Be,this.selectionRange=He,this.children=[],k.validate(this)}};e.DocumentSymbol=me=k=Le([K],me);var Se;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Se||(e.CodeActionTriggerKind=Se={}));let we=e.CodeAction=class{constructor(M,re){this.title=M,this.kind=re}};e.CodeAction=we=Le([K],we);let Oe=e.CodeActionKind=S=class{constructor(M){this.value=M}append(M){return new S(this.value?this.value+S.c+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+S.c)}};Oe.c=".",e.CodeActionKind=Oe=S=Le([K],Oe),Oe.Empty=new Oe(""),Oe.QuickFix=Oe.Empty.append("quickfix"),Oe.Refactor=Oe.Empty.append("refactor"),Oe.RefactorExtract=Oe.Refactor.append("extract"),Oe.RefactorInline=Oe.Refactor.append("inline"),Oe.RefactorMove=Oe.Refactor.append("move"),Oe.RefactorRewrite=Oe.Refactor.append("rewrite"),Oe.Source=Oe.Empty.append("source"),Oe.SourceOrganizeImports=Oe.Source.append("organizeImports"),Oe.SourceFixAll=Oe.Source.append("fixAll");let je=e.SelectionRange=class{constructor(M,re){if(this.range=M,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=je=Le([K],je);class _e{constructor(M,re,be,Be,He,Ze){this.kind=M,this.name=re,this.detail=be,this.uri=Be,this.range=He,this.selectionRange=Ze}}e.CallHierarchyItem=_e;class Ve{constructor(M,re){this.fromRanges=re,this.from=M}}e.CallHierarchyIncomingCall=Ve;class Ye{constructor(M,re){this.fromRanges=re,this.to=M}}e.CallHierarchyOutgoingCall=Ye;var Xe;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Xe||(e.LanguageStatusSeverity=Xe={}));let it=e.CodeLens=class{constructor(M,re){this.range=M,this.command=re}get isResolved(){return!!this.command}};e.CodeLens=it=Le([K],it);let Je=e.MarkdownString=F=class{static isMarkdownString(M){return M instanceof F?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,re=!1){s.set(this,void 0),Ut(this,s,new o.MarkdownString(M,{supportThemeIcons:re}),"f")}get value(){return nt(this,s,"f").value}set value(M){nt(this,s,"f").value=M}get isTrusted(){return nt(this,s,"f").isTrusted}set isTrusted(M){nt(this,s,"f").isTrusted=M}get supportThemeIcons(){return nt(this,s,"f").supportThemeIcons}set supportThemeIcons(M){nt(this,s,"f").supportThemeIcons=M}get supportHtml(){return nt(this,s,"f").supportHtml}set supportHtml(M){nt(this,s,"f").supportHtml=M}get baseUri(){return nt(this,s,"f").baseUri}set baseUri(M){nt(this,s,"f").baseUri=M}appendText(M){return nt(this,s,"f").appendText(M),this}appendMarkdown(M){return nt(this,s,"f").appendMarkdown(M),this}appendCodeblock(M,re){return nt(this,s,"f").appendCodeblock(re??"",M),this}};s=new WeakMap,e.MarkdownString=Je=F=Le([K],Je);let Ge=e.ParameterInformation=class{constructor(M,re){this.label=M,this.documentation=re}};e.ParameterInformation=Ge=Le([K],Ge);let he=e.SignatureInformation=class{constructor(M,re){this.label=M,this.documentation=re,this.parameters=[]}};e.SignatureInformation=he=Le([K],he);let Ie=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Ie=Le([K],Ie);var Te;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(Te||(e.SignatureHelpTriggerKind=Te={}));var Ae;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(Ae||(e.InlayHintKind=Ae={}));let Ne=e.InlayHintLabelPart=class{constructor(M){this.value=M}};e.InlayHintLabelPart=Ne=Le([K],Ne);let $e=e.InlayHint=class{constructor(M,re,be){this.position=M,this.label=re,this.kind=be}};e.InlayHint=$e=Le([K],$e);var We;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(We||(e.CompletionTriggerKind=We={}));var Ke;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Ke||(e.CompletionItemKind=Ke={}));var et;(function(B){B[B.Deprecated=1]="Deprecated"})(et||(e.CompletionItemTag=et={}));let qe=e.CompletionItem=class{constructor(M,re){this.label=M,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=qe=Le([K],qe);let rt=e.CompletionList=class{constructor(M=[],re=!1){this.items=M,this.isIncomplete=re}};e.CompletionList=rt=Le([K],rt);let ct=e.InlineSuggestion=class{constructor(M,re,be){this.insertText=M,this.range=re,this.command=be}};e.InlineSuggestion=ct=Le([K],ct);let st=e.InlineSuggestionList=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.InlineSuggestionList=st=Le([K],st);var Et;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Et||(e.ViewColumn=Et={}));var wt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(wt||(e.StatusBarAlignment=wt={}));var Rt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Rt||(e.TextEditorLineNumbersStyle=Rt={}));var gt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(gt||(e.TextDocumentSaveReason=gt={}));var ut;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ut||(e.TextEditorRevealType=ut={}));var yt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(yt||(e.TextEditorSelectionChangeKind=yt={}));var Tt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Tt||(e.TextDocumentChangeReason=Tt={}));var Ct;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Ct||(e.DecorationRangeBehavior=Ct={})),function(B){function M(re){switch(re){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=M}(yt||(e.TextEditorSelectionChangeKind=yt={}));let Lt=e.DocumentLink=class{constructor(M,re){if(re&&!m.URI.isUri(re))throw(0,L.illegalArgument)("target");if(!ne.isRange(M)||M.isEmpty)throw(0,L.illegalArgument)("range");this.range=M,this.target=re}};e.DocumentLink=Lt=Le([K],Lt);let Ot=e.Color=class{constructor(M,re,be,Be){this.red=M,this.green=re,this.blue=be,this.alpha=Be}};e.Color=Ot=Le([K],Ot);let St=e.ColorInformation=class{constructor(M,re){if(re&&!(re instanceof Ot))throw(0,L.illegalArgument)("color");if(!ne.isRange(M)||M.isEmpty)throw(0,L.illegalArgument)("range");this.range=M,this.color=re}};e.ColorInformation=St=Le([K],St);let Pt=e.ColorPresentation=class{constructor(M){if(!M||typeof M!="string")throw(0,L.illegalArgument)("label");this.label=M}};e.ColorPresentation=Pt=Le([K],Pt);var ot;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ot||(e.ColorFormat=ot={}));var ht;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(ht||(e.SourceControlInputBoxValidationType=ht={}));var dt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(dt||(e.TerminalExitReason=dt={}));class ye{constructor(M,re,be){if(this.startIndex=M,this.length=re,this.tooltip=be,typeof M!="number"||M<0)throw(0,L.illegalArgument)("startIndex");if(typeof re!="number"||re<1)throw(0,L.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=ye;class De{constructor(M){this.uri=M}}e.TerminalQuickFixOpener=De;class fe{constructor(M){this.terminalCommand=M}}e.TerminalQuickFixCommand=fe;var Q;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Q||(e.TerminalLocation=Q={}));class Pe{constructor(M){if(this.options=M,typeof M!="object")throw(0,L.illegalArgument)("options")}}e.TerminalProfile=Pe;var Fe;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Fe||(e.TaskRevealKind=Fe={}));var xe;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(xe||(e.TaskPanelKind=xe={}));let Me=e.TaskGroup=H=class{static from(M){switch(M){case"clean":return H.Clean;case"build":return H.Build;case"rebuild":return H.Rebuild;case"test":return H.Test;default:return}}constructor(M,re){if(this.label=re,typeof M!="string"||typeof re!="string")throw(0,L.illegalArgument)("name");this.c=M}get id(){return this.c}};Me.Clean=new H("clean","Clean"),Me.Build=new H("build","Build"),Me.Rebuild=new H("rebuild","Rebuild"),Me.Test=new H("test","Test"),e.TaskGroup=Me=H=Le([K],Me);function Qe(B){let M="";for(let re=0;re<B.length;re++)M+=B[re].replace(/,/g,",,")+",";return M}let at=e.ProcessExecution=class{constructor(M,re,be){if(typeof M!="string")throw(0,L.illegalArgument)("process");this.e=[],this.c=M,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=be):this.f=re)}get process(){return this.c}set process(M){if(typeof M!="string")throw(0,L.illegalArgument)("process");this.c=M}get args(){return this.e}set args(M){Array.isArray(M)||(M=[]),this.e=M}get options(){return this.f}set options(M){this.f=M}computeId(){const M=[];if(M.push("process"),this.c!==void 0&&M.push(this.c),this.e&&this.e.length>0)for(const re of this.e)M.push(re);return Qe(M)}};e.ProcessExecution=at=Le([K],at);let pt=e.ShellExecution=class{constructor(M,re,be){if(this.f=[],Array.isArray(re)){if(!M)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,L.illegalArgument)("command");this.e=M,this.f=re,this.g=be}else{if(typeof M!="string")throw(0,L.illegalArgument)("commandLine");this.c=M,this.g=re}}get commandLine(){return this.c}set commandLine(M){if(typeof M!="string")throw(0,L.illegalArgument)("commandLine");this.c=M}get command(){return this.e?this.e:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,L.illegalArgument)("command");this.e=M}get args(){return this.f}set args(M){this.f=M||[]}get options(){return this.g}set options(M){this.g=M}computeId(){const M=[];if(M.push("shell"),this.c!==void 0&&M.push(this.c),this.e!==void 0&&M.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)M.push(typeof re=="string"?re:re.value);return Qe(M)}};e.ShellExecution=pt=Le([K],pt);var vt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(vt||(e.ShellQuoting=vt={}));var lt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(lt||(e.TaskScope=lt={}));class mt{constructor(M){this.c=M}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(M){this.c=M}get callback(){return this.c}}e.CustomExecution=mt;let Bt=e.Task=te=class{constructor(M,re,be,Be,He,Ze){this.j=!1,this.k=this.definition=M;let tt;typeof re=="string"?(this.m=this.name=re,this.t=this.source=be,this.execution=Be,tt=He,this.j=!0):re===lt.Global||re===lt.Workspace?(this.target=re,this.m=this.name=be,this.t=this.source=Be,this.execution=He,tt=Ze):(this.target=re,this.m=this.name=be,this.t=this.source=Be,this.execution=He,tt=Ze),typeof tt=="string"?(this.o=[tt],this.q=!0):Array.isArray(tt)?(this.o=tt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(M){this.h=M}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof at?this.k={type:te.e,id:this.n.computeId()}:this.n instanceof pt?this.k={type:te.f,id:this.n.computeId()}:this.n instanceof mt?this.k={type:te.c,id:this.n.computeId()}:this.k={type:te.g,id:(0,T.generateUuid)()}}get definition(){return this.k}set definition(M){if(M==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=M}get scope(){return this.l}set target(M){this.y(),this.l=M}get name(){return this.m}set name(M){if(typeof M!="string")throw(0,L.illegalArgument)("name");this.y(),this.m=M}get execution(){return this.n}set execution(M){M===null&&(M=void 0),this.y(),this.n=M;const re=this.k.type;(te.g===re||te.e===re||te.f===re||te.c===re)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(M){if(Array.isArray(M))this.y(),this.o=M,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.y(),this.r=M}get source(){return this.t}set source(M){if(typeof M!="string"||M.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.y(),this.t=M}get group(){return this.u}set group(M){M===null&&(M=void 0),this.y(),this.u=M}get detail(){return this.x}set detail(M){M===null&&(M=void 0),this.x=M}get presentationOptions(){return this.v}set presentationOptions(M){M==null&&(M=Object.create(null)),this.y(),this.v=M}get runOptions(){return this.w}set runOptions(M){M==null&&(M=Object.create(null)),this.y(),this.w=M}};Bt.c="customExecution",Bt.e="process",Bt.f="shell",Bt.g="$empty",e.Task=Bt=te=Le([K],Bt);var _t;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(_t||(e.ProgressLocation=_t={}));var ei;(function(B){function M(re){const be=re;return(0,v.isNumber)(be.value)?be.tooltip&&!(0,v.isString)(be.tooltip)?(console.log("INVALID view badge, invalid tooltip",be.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",be.value),!1)}B.isViewBadge=M})(ei||(e.ViewBadge=ei={}));let ti=e.TreeItem=ce=class{static isTreeItem(M,re){const be=M;if(be.checkboxState!==void 0){(0,p.checkProposedApiEnabled)(re,"treeItemCheckbox");const Be=(0,v.isNumber)(be.checkboxState)?be.checkboxState:(0,v.isObject)(be.checkboxState)&&(0,v.isNumber)(be.checkboxState.state)?be.checkboxState.state:void 0,He=!(0,v.isNumber)(be.checkboxState)&&(0,v.isObject)(be.checkboxState)?be.checkboxState.tooltip:void 0;if(Be===void 0||Be!==Ht.Checked&&Be!==Ht.Unchecked||He!==void 0&&!(0,v.isString)(He))return console.log("INVALID tree item, invalid checkboxState",be.checkboxState),!1}if(M instanceof ce)return!0;if(be.label!==void 0&&!(0,v.isString)(be.label)&&!be.label?.label)return console.log("INVALID tree item, invalid label",be.label),!1;if(be.id!==void 0&&!(0,v.isString)(be.id))return console.log("INVALID tree item, invalid id",be.id),!1;if(be.iconPath!==void 0&&!(0,v.isString)(be.iconPath)&&!m.URI.isUri(be.iconPath)&&(!be.iconPath||!(0,v.isString)(be.iconPath.id))){const Be=be.iconPath;if(!Be||!(0,v.isString)(Be.light)&&!m.URI.isUri(Be.light)&&!(0,v.isString)(Be.dark)&&!m.URI.isUri(Be.dark))return console.log("INVALID tree item, invalid iconPath",be.iconPath),!1}return be.description!==void 0&&!(0,v.isString)(be.description)&&typeof be.description!="boolean"?(console.log("INVALID tree item, invalid description",be.description),!1):be.resourceUri!==void 0&&!m.URI.isUri(be.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",be.resourceUri),!1):be.tooltip!==void 0&&!(0,v.isString)(be.tooltip)&&!(be.tooltip instanceof Je)?(console.log("INVALID tree item, invalid tooltip",be.tooltip),!1):be.command!==void 0&&!be.command.command?(console.log("INVALID tree item, invalid command",be.command),!1):be.collapsibleState!==void 0&&be.collapsibleState<jt.None&&be.collapsibleState>jt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",be.collapsibleState),!1):be.contextValue!==void 0&&!(0,v.isString)(be.contextValue)?(console.log("INVALID tree item, invalid contextValue",be.contextValue),!1):be.accessibilityInformation!==void 0&&!be.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",be.accessibilityInformation),!1):!0}constructor(M,re=jt.None){this.collapsibleState=re,m.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.TreeItem=ti=ce=Le([K],ti);var jt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(jt||(e.TreeItemCollapsibleState=jt={}));var Ht;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Ht||(e.TreeItemCheckboxState=Ht={}));let ii=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M,re){this.value=M,this.id=re??(0,T.generateUuid)()}};e.DataTransferItem=ii=Le([K],ii);class un{constructor(M,re,be,Be){this.name=M,this.uri=re,this._itemId=be,this.c=Be}data(){return this.c()}}e.DataTransferFile=un;let ni=e.DataTransfer=class{constructor(M){h.add(this),u.set(this,new Map);for(const[re,be]of M??[]){const Be=nt(this,u,"f").get(nt(this,h,"m",f).call(this,re));Be?Be.push(be):nt(this,u,"f").set(nt(this,h,"m",f).call(this,re),[be])}}get(M){return nt(this,u,"f").get(nt(this,h,"m",f).call(this,M))?.[0]}set(M,re){nt(this,u,"f").set(nt(this,h,"m",f).call(this,M),[re])}forEach(M,re){for(const[be,Be]of nt(this,u,"f"))for(const He of Be)M.call(re,He,be,this)}*[(u=new WeakMap,h=new WeakSet,Symbol.iterator)](){for(const[M,re]of nt(this,u,"f"))for(const be of re)yield[M,be]}};f=function(M){return M.toLowerCase()},e.DataTransfer=ni=Le([K],ni);let ri=e.DocumentDropEdit=class{constructor(M){this.insertText=M}};e.DocumentDropEdit=ri=Le([K],ri);let si=e.DocumentPasteEdit=class{constructor(M){this.insertText=M}};e.DocumentPasteEdit=si=Le([K],si);let Nt=e.ThemeIcon=class{constructor(M,re){this.id=M,this.color=re}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.ThemeIcon=Nt=Le([K],Nt),Nt.File=new Nt("file"),Nt.Folder=new Nt("folder");let oi=e.ThemeColor=class{constructor(M){this.id=M}};e.ThemeColor=oi=Le([K],oi);var ai;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(ai||(e.ConfigurationTarget=ai={}));let li=e.RelativePattern=class{get base(){return this.c}set base(M){this.c=M,this.e=m.URI.file(M)}get baseUri(){return this.e}set baseUri(M){this.e=M,this.c=M.fsPath}constructor(M,re){if(typeof M!="string"&&(!M||!m.URI.isUri(M)&&!m.URI.isUri(M.uri)))throw(0,L.illegalArgument)("base");if(typeof re!="string")throw(0,L.illegalArgument)("pattern");typeof M=="string"?this.baseUri=m.URI.file(M):m.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=li=Le([K],li);const ci=new WeakMap;function hn(B,M){ci.set(B,M)}e.setBreakpointId=hn;let zt=e.Breakpoint=class{constructor(M,re,be,Be){this.enabled=typeof M=="boolean"?M:!0,typeof re=="string"&&(this.condition=re),typeof be=="string"&&(this.hitCondition=be),typeof Be=="string"&&(this.logMessage=Be)}get id(){return this.c||(this.c=ci.get(this)??(0,T.generateUuid)()),this.c}};e.Breakpoint=zt=Le([K],zt);let ui=e.SourceBreakpoint=class extends zt{constructor(M,re,be,Be,He){if(super(re,be,Be,He),M===null)throw(0,L.illegalArgument)("location");this.location=M}};e.SourceBreakpoint=ui=Le([K],ui);let hi=e.FunctionBreakpoint=class extends zt{constructor(M,re,be,Be,He){super(re,be,Be,He),this.functionName=M}};e.FunctionBreakpoint=hi=Le([K],hi);let fi=e.DataBreakpoint=class extends zt{constructor(M,re,be,Be,He,Ze,tt){if(super(Be,He,Ze,tt),!re)throw(0,L.illegalArgument)("dataId");this.label=M,this.dataId=re,this.canPersist=be}};e.DataBreakpoint=fi=Le([K],fi);let di=e.DebugAdapterExecutable=class{constructor(M,re,be){this.command=M,this.args=re||[],this.options=be}};e.DebugAdapterExecutable=di=Le([K],di);let mi=e.DebugAdapterServer=class{constructor(M,re){this.port=M,this.host=re}};e.DebugAdapterServer=mi=Le([K],mi);let gi=e.DebugAdapterNamedPipeServer=class{constructor(M){this.path=M}};e.DebugAdapterNamedPipeServer=gi=Le([K],gi);let pi=e.DebugAdapterInlineImplementation=class{constructor(M){this.implementation=M}};e.DebugAdapterInlineImplementation=pi=Le([K],pi);let vi=e.EvaluatableExpression=class{constructor(M,re){this.range=M,this.expression=re}};e.EvaluatableExpression=vi=Le([K],vi);var bi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(bi||(e.InlineCompletionTriggerKind=bi={}));let Ei=e.InlineValueText=class{constructor(M,re){this.range=M,this.text=re}};e.InlineValueText=Ei=Le([K],Ei);let wi=e.InlineValueVariableLookup=class{constructor(M,re,be=!0){this.range=M,this.variableName=re,this.caseSensitiveLookup=be}};e.InlineValueVariableLookup=wi=Le([K],wi);let yi=e.InlineValueEvaluatableExpression=class{constructor(M,re){this.range=M,this.expression=re}};e.InlineValueEvaluatableExpression=yi=Le([K],yi);let Si=e.InlineValueContext=class{constructor(M,re){this.frameId=M,this.stoppedLocation=re}};e.InlineValueContext=Si=Le([K],Si);var Ii;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ii||(e.FileChangeType=Ii={}));let Di=e.FileSystemError=le=class extends Error{static FileExists(M){return new le(M,y.FileSystemProviderErrorCode.FileExists,le.FileExists)}static FileNotFound(M){return new le(M,y.FileSystemProviderErrorCode.FileNotFound,le.FileNotFound)}static FileNotADirectory(M){return new le(M,y.FileSystemProviderErrorCode.FileNotADirectory,le.FileNotADirectory)}static FileIsADirectory(M){return new le(M,y.FileSystemProviderErrorCode.FileIsADirectory,le.FileIsADirectory)}static NoPermissions(M){return new le(M,y.FileSystemProviderErrorCode.NoPermissions,le.NoPermissions)}static Unavailable(M){return new le(M,y.FileSystemProviderErrorCode.Unavailable,le.Unavailable)}constructor(M,re=y.FileSystemProviderErrorCode.Unknown,be){super(m.URI.isUri(M)?M.toString(!0):M),this.code=be?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,re),Object.setPrototypeOf(this,le.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}};e.FileSystemError=Di=le=Le([K],Di);let Ci=e.FoldingRange=class{constructor(M,re,be){this.start=M,this.end=re,this.kind=be}};e.FoldingRange=Ci=Le([K],Ci);var Pi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Pi||(e.FoldingRangeKind=Pi={}));var ki;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(ki||(e.CommentThreadCollapsibleState=ki={}));var Ai;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ai||(e.CommentMode=Ai={}));var Ri;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ri||(e.CommentState=Ri={}));var Ti;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Ti||(e.CommentThreadState=Ti={}));class fn{constructor(M,re=[]){this.tokenTypes=M,this.tokenModifiers=re}}e.SemanticTokensLegend=fn;function dn(B){return typeof B>"u"||(0,v.isStringArray)(B)}class Jt{constructor(M){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,M){this.l=!0;for(let re=0,be=M.tokenTypes.length;re<be;re++)this.j.set(M.tokenTypes[re],re);for(let re=0,be=M.tokenModifiers.length;re<be;re++)this.k.set(M.tokenModifiers[re],re)}}push(M,re,be,Be,He){if(typeof M=="number"&&typeof re=="number"&&typeof be=="number"&&typeof Be=="number"&&(typeof He=="number"||typeof He>"u"))return typeof He>"u"&&(He=0),this.n(M,re,be,Be,He);if(ne.isRange(M)&&typeof re=="string"&&dn(be))return this.m(M,re,be);throw(0,L.illegalArgument)()}m(M,re,be){if(!this.l)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(re))throw new Error("`tokenType` is not in the provided legend");const Be=M.start.line,He=M.start.character,Ze=M.end.character-M.start.character,tt=this.j.get(re);let ft=0;if(be)for(const bt of be){if(!this.k.has(bt))throw new Error("`tokenModifier` is not in the provided legend");const Dt=this.k.get(bt);ft|=1<<Dt>>>0}this.n(Be,He,Ze,tt,ft)}n(M,re,be,Be,He){if(this.f&&(M<this.c||M===this.c&&re<this.e)){this.f=!1;const ft=this.g.length/5|0;let bt=0,Dt=0;for(let kt=0;kt<ft;kt++){let At=this.g[5*kt],Wt=this.g[5*kt+1];At===0?(At=bt,Wt+=Dt):At+=bt,this.g[5*kt]=At,this.g[5*kt+1]=Wt,bt=At,Dt=Wt}}let Ze=M,tt=re;this.f&&this.h>0&&(Ze-=this.c,Ze===0&&(tt-=this.e)),this.g[this.h++]=Ze,this.g[this.h++]=tt,this.g[this.h++]=be,this.g[this.h++]=Be,this.g[this.h++]=He,this.c=M,this.e=re}static o(M){const re=[],be=M.length/5|0;for(let tt=0;tt<be;tt++)re[tt]=tt;re.sort((tt,ft)=>{const bt=M[5*tt],Dt=M[5*ft];if(bt===Dt){const kt=M[5*tt+1],At=M[5*ft+1];return kt-At}return bt-Dt});const Be=new Uint32Array(M.length);let He=0,Ze=0;for(let tt=0;tt<be;tt++){const ft=5*re[tt],bt=M[ft+0],Dt=M[ft+1],kt=M[ft+2],At=M[ft+3],Wt=M[ft+4],cn=bt-He,Nn=cn===0?Dt-Ze:Dt,xt=5*tt;Be[xt+0]=cn,Be[xt+1]=Nn,Be[xt+2]=kt,Be[xt+3]=At,Be[xt+4]=Wt,He=bt,Ze=Dt}return Be}build(M){return this.f?new Yt(new Uint32Array(this.g),M):new Yt(Jt.o(this.g),M)}}e.SemanticTokensBuilder=Jt;class Yt{constructor(M,re){this.resultId=re,this.data=M}}e.SemanticTokens=Yt;class mn{constructor(M,re,be){this.start=M,this.deleteCount=re,this.data=be}}e.SemanticTokensEdit=mn;class gn{constructor(M,re){this.resultId=re,this.edits=M}}e.SemanticTokensEdits=gn;var Li;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Li||(e.DebugConsoleMode=Li={}));let Xt=e.QuickInputButtons=class{constructor(){}};Xt.Back={iconPath:new Nt("arrow-left")},e.QuickInputButtons=Xt=Le([K],Xt);var Oi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Oi||(e.QuickPickItemKind=Oi={}));var Ni;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Ni||(e.InputBoxValidationSeverity=Ni={}));var Fi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Fi||(e.ExtensionKind=Fi={}));class pn{static validate(M){if(typeof M.badge=="string"){let re=(0,A.nextCharLength)(M.badge,0);if(re<M.badge.length&&(re+=(0,A.nextCharLength)(M.badge,re)),M.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!Nt.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,re,be){this.badge=M,this.tooltip=re,this.color=be}}e.FileDecoration=pn;let Mi=e.ColorTheme=class{constructor(M){this.kind=M}};e.ColorTheme=Mi=Le([K],Mi);var Ui;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ui||(e.ColorThemeKind=Ui={}));class Ft{static isNotebookRange(M){return M instanceof Ft?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(M,re){if(M<0)throw(0,L.illegalArgument)("start must be positive");if(re<0)throw(0,L.illegalArgument)("end must be positive");M<=re?(this.c=M,this.e=re):(this.c=re,this.e=M)}with(M){let re=this.c,be=this.e;return M.start!==void 0&&(re=M.start),M.end!==void 0&&(be=M.end),re===this.c&&be===this.e?this:new Ft(re,be)}}e.NotebookRange=Ft;class Vt{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(re=>Vt.isNotebookCellData(re))}static isNotebookCellData(M){return!0}constructor(M,re,be,Be,He,Ze,tt){this.kind=M,this.value=re,this.languageId=be,this.mime=Be,this.outputs=He??[],this.metadata=Ze,this.executionSummary=tt,Vt.validate(this)}}e.NotebookCellData=Vt;class vn{constructor(M){this.cells=M}}e.NotebookData=vn;class It{static isNotebookCellOutputItem(M){return M instanceof It?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const re={name:M.name,message:M.message,stack:M.stack};return It.json(re,"application/vnd.code.notebook.error")}static stdout(M){return It.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return It.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,re="application/octet-stream"){return new It(M,re)}static text(M,re=C.Mimes.text){const be=nt(It,I,"f",O).encode(String(M));return new It(be,re)}static json(M,re="text/x-json"){const be=JSON.stringify(M,void 0,"	");return It.text(be,re)}constructor(M,re){this.data=M,this.mime=re;const be=(0,C.normalizeMimeType)(re,!0);if(!be)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}}e.NotebookCellOutputItem=It,I=It,O={value:new TextEncoder};class qt{static isNotebookCellOutput(M){return M instanceof qt?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,re=!1){const be=new Set,Be=new Set;for(let He=0;He<M.length;He++){const Ze=M[He],tt=(0,C.normalizeMimeType)(Ze.mime);if(!be.has(tt)||(0,d.isTextStreamMime)(tt)){be.add(tt);continue}Be.add(He),re&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return Be.size===0?M:M.filter((He,Ze)=>!Be.has(Ze))}constructor(M,re,be){this.items=qt.ensureUniqueMimeTypes(M,!0),typeof re=="string"?(this.id=re,this.metadata=be):(this.id=(0,T.generateUuid)(),this.metadata=re??be)}}e.NotebookCellOutput=qt;var Bi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Bi||(e.NotebookCellKind=Bi={}));var ji;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(ji||(e.NotebookCellExecutionState=ji={}));var zi;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(zi||(e.NotebookCellStatusBarAlignment=zi={}));var $i;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})($i||(e.NotebookEditorRevealType=$i={}));class bn{constructor(M,re){this.text=M,this.alignment=re}}e.NotebookCellStatusBarItem=bn;var Wi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Wi||(e.NotebookControllerAffinity=Wi={}));var xi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class En{constructor(M,re=[]){this.uri=M,this.provides=(0,w.asArray)(re)}}e.NotebookRendererScript=En;class wn{constructor(M){this.label=M}}e.NotebookKernelSourceAction=wn;let Hi=e.TimelineItem=class{constructor(M,re){this.label=M,this.timestamp=re}};e.TimelineItem=Hi=Le([K],Hi);var Vi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(Vi||(e.ExtensionMode=Vi={}));var qi;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(qi||(e.ExtensionRuntime=qi={}));var Gi;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Gi||(e.StandardTokenType=Gi={}));class yn{constructor(M,re){this.ranges=M,this.wordPattern=re}}e.LinkedEditingRanges=yn;class Sn{constructor(M,re){this.c=M,this.e=re}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=Sn;var Ki;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Ki||(e.TestResultState=Ki={}));var Ji;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(Ji||(e.TestRunProfileKind=Ji={}));let Qt=e.TestRunRequest=class{constructor(M=void 0,re=void 0,be=void 0,Be=!1){this.include=M,this.exclude=re,this.profile=be,this.continuous=Be}};e.TestRunRequest=Qt=Le([K],Qt);let Yi=e.TestRunRequest2=class extends Qt{};e.TestRunRequest2=Yi=Le([K],Yi);let Xi=e.TestMessage=ue=class{static diff(M,re,be){const Be=new ue(M);return Be.expectedOutput=re,Be.actualOutput=be,Be}constructor(M){this.message=M}};e.TestMessage=Xi=ue=Le([K],Xi);let Qi=e.TestTag=class{constructor(M){this.id=M}};e.TestTag=Qi=Le([K],Qi);let $t=e.CoveredCount=class{constructor(M,re){this.covered=M,this.total=re}};e.CoveredCount=$t=Le([K],$t);let Zi=e.FileCoverage=ve=class{static fromDetails(M,re){const be=new $t(0,0),Be=new $t(0,0),He=new $t(0,0);for(const tt of re)if("branches"in tt){be.total+=1,be.covered+=tt.executionCount>0?1:0;for(const ft of tt.branches)Be.total+=1,Be.covered+=ft.executionCount>0?1:0}else He.total+=1,He.covered+=tt.executionCount>0?1:0;const Ze=new ve(M,be,Be.total>0?Be:void 0,He.total>0?He:void 0);return Ze.detailedCoverage=re,Ze}constructor(M,re,be,Be){this.uri=M,this.statementCoverage=re,this.branchCoverage=be,this.functionCoverage=Be}};e.FileCoverage=Zi=ve=Le([K],Zi);let _i=e.StatementCoverage=class{constructor(M,re,be=[]){this.executionCount=M,this.location=re,this.branches=be}};e.StatementCoverage=_i=Le([K],_i);let en=e.BranchCoverage=class{constructor(M,re){this.executionCount=M,this.location=re}};e.BranchCoverage=en=Le([K],en);let tn=e.FunctionCoverage=class{constructor(M,re){this.executionCount=M,this.location=re}};e.FunctionCoverage=tn=Le([K],tn);var nn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(nn||(e.ExternalUriOpenerPriority=nn={}));var rn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(rn||(e.WorkspaceTrustState=rn={}));var sn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(sn||(e.PortAutoForwardAction=sn={}));class In{constructor(M,re,be,Be,He,Ze){this.kind=M,this.name=re,this.detail=be,this.uri=Be,this.range=He,this.selectionRange=Ze}}e.TypeHierarchyItem=In;class Dn{constructor(M){this.uri=M}}e.TextTabInput=Dn;class Cn{constructor(M,re){this.original=M,this.modified=re}}e.TextDiffTabInput=Cn;class Pn{constructor(M,re,be,Be){this.base=M,this.input1=re,this.input2=be,this.result=Be}}e.TextMergeTabInput=Pn;class kn{constructor(M,re){this.uri=M,this.viewType=re}}e.CustomEditorTabInput=kn;class An{constructor(M){this.viewType=M}}e.WebviewEditorTabInput=An;class Rn{constructor(M,re){this.uri=M,this.notebookType=re}}e.NotebookEditorTabInput=Rn;class Tn{constructor(M,re,be){this.original=M,this.modified=re,this.notebookType=be}}e.NotebookDiffEditorTabInput=Tn;class Ln{constructor(){}}e.TerminalEditorTabInput=Ln;class On{constructor(M,re){this.uri=M,this.inputBoxUri=re}}e.InteractiveWindowInput=On;var on;(function(B){B[B.Up=1]="Up",B[B.Down=2]="Down"})(on||(e.InteractiveSessionVoteDirection=on={}));var an;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(an||(e.InteractiveSessionCopyKind=an={}));var ln;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone"})(ln||(e.InteractiveEditorResponseFeedbackKind=ln={}))}),define(ge[135],pe([1,0,18,15,146,71,98,27,142,61,57,21,8,4,49,167,226,131,88,129,69,89,133,134]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u,f,I,O,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveSessionFollowup=e.InteractiveSessionReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(ye){function De(Q){const{selectionStartLineNumber:Pe,selectionStartColumn:Fe,positionLineNumber:xe,positionColumn:Me}=Q,Qe=new n.Position(Pe-1,Fe-1),at=new n.Position(xe-1,Me-1);return new n.Selection(Qe,at)}ye.to=De;function fe(Q){const{anchor:Pe,active:Fe}=Q;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}ye.from=fe})(r||(e.Selection=r={}));var i;(function(ye){function De(Q){if(!Q)return;const{start:Pe,end:Fe}=Q;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}ye.from=De;function fe(Q){if(!Q)return;const{startLineNumber:Pe,startColumn:Fe,endLineNumber:xe,endColumn:Me}=Q;return new n.Range(Pe-1,Fe-1,xe-1,Me-1)}ye.to=fe})(i||(e.Range=i={}));var a;(function(ye){function De(fe){switch(fe){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}ye.to=De})(a||(e.TokenType=a={}));var l;(function(ye){function De(Q){return new n.Position(Q.lineNumber-1,Q.column-1)}ye.to=De;function fe(Q){return{lineNumber:Q.line+1,column:Q.character+1}}ye.from=fe})(l||(e.Position=l={}));var c;(function(ye){function De(Pe,Fe,xe){return(0,w.coalesce)((0,w.asArray)(Pe).map(Me=>fe(Me,Fe,xe)))}ye.from=De;function fe(Pe,Fe,xe){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:xe?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:Q(Pe.scheme,Fe),pattern:Ie.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:xe?.isBuiltin}}function Q(Pe,Fe){return Fe&&typeof Pe=="string"?Fe.transformOutgoingScheme(Pe):Pe}})(c||(e.DocumentSelector=c={}));var g;(function(ye){function De(Q){switch(Q){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}ye.from=De;function fe(Q){switch(Q){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}ye.to=fe})(g||(e.DiagnosticTag=g={}));var D;(function(ye){function De(Q){let Pe;return Q.code&&((0,E.isString)(Q.code)||(0,E.isNumber)(Q.code)?Pe=String(Q.code):Pe={value:String(Q.code.value),target:Q.code.target}),{...i.from(Q.range),message:Q.message,source:Q.source,code:Pe,severity:S.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(k.from),tags:Array.isArray(Q.tags)?(0,w.coalesce)(Q.tags.map(g.from)):void 0}}ye.from=De;function fe(Q){const Pe=new n.Diagnostic(i.to(Q),Q.message,S.to(Q.severity));return Pe.source=Q.source,Pe.code=(0,E.isString)(Q.code)?Q.code:Q.code?.value,Pe.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(k.to),Pe.tags=Q.tags&&(0,w.coalesce)(Q.tags.map(g.to)),Pe}ye.to=fe})(D||(e.Diagnostic=D={}));var k;(function(ye){function De(Q){return{...i.from(Q.location.range),message:Q.message,resource:Q.location.uri}}ye.from=De;function fe(Q){return new n.DiagnosticRelatedInformation(new n.Location(Q.resource,i.to(Q)),Q.message)}ye.to=fe})(k||(e.DiagnosticRelatedInformation=k={}));var S;(function(ye){function De(Q){switch(Q){case n.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}ye.from=De;function fe(Q){switch(Q){case s.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}ye.to=fe})(S||(e.DiagnosticSeverity=S={}));var F;(function(ye){function De(Q){return typeof Q=="number"&&Q>=n.ViewColumn.One?Q-1:Q===n.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}ye.from=De;function fe(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=fe})(F||(e.ViewColumn=F={}));function H(ye){return typeof ye.range<"u"}function te(ye){return ye.length===0?!0:!!H(ye[0])}e.isDecorationOptionsArr=te;var ce;(function(ye){function De(Me){return Me.map(ye.from)}ye.fromMany=De;function fe(Me){return Me&&typeof Me=="object"&&typeof Me.language=="string"&&typeof Me.value=="string"}function Q(Me){let Qe;if(fe(Me)){const{language:lt,value:mt}=Me;Qe={value:"```"+lt+`
`+mt+"\n```\n"}}else n.MarkdownString.isMarkdownString(Me)?Qe={value:Me.value,isTrusted:Me.isTrusted,supportThemeIcons:Me.supportThemeIcons,supportHtml:Me.supportHtml,baseUri:Me.baseUri}:typeof Me=="string"?Qe={value:Me}:Qe={value:""};const at=Object.create(null);Qe.uris=at;const pt=lt=>{try{let mt=d.URI.parse(lt,!0);mt=mt.with({query:Pe(mt.query,at)}),at[lt]=mt}catch{}return""},vt=new v.marked.Renderer;return vt.link=pt,vt.image=lt=>typeof lt=="string"?pt(C.parseHrefAndDimensions(lt).href):"",(0,v.marked)(Qe.value,{renderer:vt}),Qe}ye.from=Q;function Pe(Me,Qe){if(!Me)return Me;let at;try{at=(0,m.parse)(Me)}catch{}if(!at)return Me;let pt=!1;return at=(0,y.cloneAndChange)(at,vt=>{if(d.URI.isUri(vt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Qe[lt]=vt,pt=!0,lt}else return}),pt?JSON.stringify(at):Me}function Fe(Me){const Qe=new n.MarkdownString(Me.value,Me.supportThemeIcons);return Qe.isTrusted=Me.isTrusted,Qe.supportHtml=Me.supportHtml,Qe.baseUri=Me.baseUri?d.URI.from(Me.baseUri):void 0,Qe}ye.to=Fe;function xe(Me){if(Me)return typeof Me=="string"?Me:ye.from(Me)}ye.fromStrict=xe})(ce||(e.MarkdownString=ce={}));function le(ye){return te(ye)?ye.map(De=>({range:i.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?ce.fromMany(De.hoverMessage):De.hoverMessage?ce.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ye.map(De=>({range:i.from(De)}))}e.fromRangeOrRangeWithMessage=le;function ue(ye){return typeof ye>"u"?ye:typeof ye=="string"?d.URI.file(ye):ye}e.pathOrURIToURI=ue;var ve;(function(ye){function De(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?ue(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ye.from=De})(ve||(e.ThemableDecorationAttachmentRenderOptions=ve={}));var K;(function(ye){function De(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ue(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?ve.from(fe.before):void 0,after:fe.after?ve.from(fe.after):void 0}}ye.from=De})(K||(e.ThemableDecorationRenderOptions=K={}));var ee;(function(ye){function De(fe){if(typeof fe>"u")return fe;switch(fe){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=De})(ee||(e.DecorationRangeBehavior=ee={}));var z;(function(ye){function De(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?ee.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?K.from(fe.light):void 0,dark:fe.dark?K.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ue(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?ve.from(fe.before):void 0,after:fe.after?ve.from(fe.after):void 0}}ye.from=De})(z||(e.DecorationRenderOptions=z={}));var q;(function(ye){function De(Q){return{text:Q.newText,eol:Q.newEol&&Xe.from(Q.newEol),range:i.from(Q.range)}}ye.from=De;function fe(Q){const Pe=new n.TextEdit(i.to(Q.range),Q.text);return Pe.newEol=typeof Q.eol>"u"?void 0:Xe.to(Q.eol),Pe}ye.to=fe})(q||(e.TextEdit=q={}));var G;(function(ye){function De(Q,Pe){const Fe={edits:[]};if(Q instanceof n.WorkspaceEdit){const xe=new A.ResourceSet;for(const Me of Q._allEntries())Me._type===1&&d.URI.isUri(Me.to)&&Me.from===void 0&&xe.add(Me.to);for(const Me of Q._allEntries())if(Me._type===1){let Qe;Me.options?.contents&&(ArrayBuffer.isView(Me.options.contents)?Qe={type:"base64",value:(0,L.encodeBase64)(L.VSBuffer.wrap(Me.options.contents))}:Qe={type:"dataTransferItem",id:Me.options.contents._itemId}),Fe.edits.push({oldResource:Me.from,newResource:Me.to,options:{...Me.options,contents:Qe},metadata:Me.metadata})}else Me._type===2?Fe.edits.push({resource:Me.uri,textEdit:q.from(Me.edit),versionId:xe.has(Me.uri)?void 0:Pe?.getTextDocumentVersion(Me.uri),metadata:Me.metadata}):Me._type===6?Fe.edits.push({resource:Me.uri,textEdit:{range:i.from(Me.range),text:Me.edit.value,insertAsSnippet:!0},versionId:xe.has(Me.uri)?void 0:Pe?.getTextDocumentVersion(Me.uri),metadata:Me.metadata}):Me._type===3?Fe.edits.push({metadata:Me.metadata,resource:Me.uri,cellEdit:Me.edit,notebookMetadata:Me.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(Me.uri)}):Me._type===5&&Fe.edits.push({metadata:Me.metadata,resource:Me.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(Me.uri),cellEdit:{editType:1,index:Me.index,count:Me.count,cells:Me.cells.map(et.from)}})}return Fe}ye.from=De;function fe(Q){const Pe=new n.WorkspaceEdit,Fe=new A.ResourceMap;for(const xe of Q.edits)if(xe.textEdit){const Me=xe,Qe=d.URI.revive(Me.resource),at=i.to(Me.textEdit.range),pt=Me.textEdit.text,vt=Me.textEdit.insertAsSnippet;let lt;vt?lt=n.SnippetTextEdit.replace(at,new n.SnippetString(pt)):lt=n.TextEdit.replace(at,pt);const mt=Fe.get(Qe);mt?mt.push(lt):Fe.set(Qe,[lt])}else Pe.renameFile(d.URI.revive(xe.oldResource),d.URI.revive(xe.newResource),xe.options);for(const[xe,Me]of Fe)Pe.set(xe,Me);return Pe}ye.to=fe})(G||(e.WorkspaceEdit=G={}));var ne;(function(ye){const De=Object.create(null);De[n.SymbolKind.File]=0,De[n.SymbolKind.Module]=1,De[n.SymbolKind.Namespace]=2,De[n.SymbolKind.Package]=3,De[n.SymbolKind.Class]=4,De[n.SymbolKind.Method]=5,De[n.SymbolKind.Property]=6,De[n.SymbolKind.Field]=7,De[n.SymbolKind.Constructor]=8,De[n.SymbolKind.Enum]=9,De[n.SymbolKind.Interface]=10,De[n.SymbolKind.Function]=11,De[n.SymbolKind.Variable]=12,De[n.SymbolKind.Constant]=13,De[n.SymbolKind.String]=14,De[n.SymbolKind.Number]=15,De[n.SymbolKind.Boolean]=16,De[n.SymbolKind.Array]=17,De[n.SymbolKind.Object]=18,De[n.SymbolKind.Key]=19,De[n.SymbolKind.Null]=20,De[n.SymbolKind.EnumMember]=21,De[n.SymbolKind.Struct]=22,De[n.SymbolKind.Event]=23,De[n.SymbolKind.Operator]=24,De[n.SymbolKind.TypeParameter]=25;function fe(Pe){return typeof De[Pe]=="number"?De[Pe]:6}ye.from=fe;function Q(Pe){for(const Fe in De)if(De[Fe]===Pe)return Number(Fe);return n.SymbolKind.Property}ye.to=Q})(ne||(e.SymbolKind=ne={}));var se;(function(ye){function De(Q){switch(Q){case n.SymbolTag.Deprecated:return 1}}ye.from=De;function fe(Q){switch(Q){case 1:return n.SymbolTag.Deprecated}}ye.to=fe})(se||(e.SymbolTag=se={}));var de;(function(ye){function De(Q){return{name:Q.name,kind:ne.from(Q.kind),tags:Q.tags&&Q.tags.map(se.from),containerName:Q.containerName,location:U.from(Q.location)}}ye.from=De;function fe(Q){const Pe=new n.SymbolInformation(Q.name,ne.to(Q.kind),Q.containerName,U.to(Q.location));return Pe.tags=Q.tags&&Q.tags.map(se.to),Pe}ye.to=fe})(de||(e.WorkspaceSymbol=de={}));var W;(function(ye){function De(Q){const Pe={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:i.from(Q.range),selectionRange:i.from(Q.selectionRange),kind:ne.from(Q.kind),tags:Q.tags?.map(se.from)??[]};return Q.children&&(Pe.children=Q.children.map(De)),Pe}ye.from=De;function fe(Q){const Pe=new n.DocumentSymbol(Q.name,Q.detail,ne.to(Q.kind),i.to(Q.range),i.to(Q.selectionRange));return(0,w.isNonEmptyArray)(Q.tags)&&(Pe.tags=Q.tags.map(se.to)),Q.children&&(Pe.children=Q.children.map(fe)),Pe}ye.to=fe})(W||(e.DocumentSymbol=W={}));var x;(function(ye){function De(Q){const Pe=new n.CallHierarchyItem(ne.to(Q.kind),Q.name,Q.detail||"",d.URI.revive(Q.uri),i.to(Q.range),i.to(Q.selectionRange));return Pe._sessionId=Q._sessionId,Pe._itemId=Q._itemId,Pe}ye.to=De;function fe(Q,Pe,Fe){if(Pe=Pe??Q._sessionId,Fe=Fe??Q._itemId,Pe===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Fe,name:Q.name,detail:Q.detail,kind:ne.from(Q.kind),uri:Q.uri,range:i.from(Q.range),selectionRange:i.from(Q.selectionRange),tags:Q.tags?.map(se.from)}}ye.from=fe})(x||(e.CallHierarchyItem=x={}));var N;(function(ye){function De(fe){return new n.CallHierarchyIncomingCall(x.to(fe.from),fe.fromRanges.map(Q=>i.to(Q)))}ye.to=De})(N||(e.CallHierarchyIncomingCall=N={}));var R;(function(ye){function De(fe){return new n.CallHierarchyOutgoingCall(x.to(fe.to),fe.fromRanges.map(Q=>i.to(Q)))}ye.to=De})(R||(e.CallHierarchyOutgoingCall=R={}));var U;(function(ye){function De(Q){return{range:Q.range&&i.from(Q.range),uri:Q.uri}}ye.from=De;function fe(Q){return new n.Location(d.URI.revive(Q.uri),i.to(Q.range))}ye.to=fe})(U||(e.location=U={}));var X;(function(ye){function De(Q){const Pe=Q,Fe=Q;return{originSelectionRange:Pe.originSelectionRange?i.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Fe.uri,range:i.from(Pe.targetRange?Pe.targetRange:Fe.range),targetSelectionRange:Pe.targetSelectionRange?i.from(Pe.targetSelectionRange):void 0}}ye.from=De;function fe(Q){return{targetUri:d.URI.revive(Q.uri),targetRange:i.to(Q.range),targetSelectionRange:Q.targetSelectionRange?i.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?i.to(Q.originSelectionRange):void 0}}ye.to=fe})(X||(e.DefinitionLink=X={}));var ie;(function(ye){function De(Q){return{range:i.from(Q.range),contents:ce.fromMany(Q.contents)}}ye.from=De;function fe(Q){return new n.Hover(Q.contents.map(ce.to),i.to(Q.range))}ye.to=fe})(ie||(e.Hover=ie={}));var j;(function(ye){function De(Q){return{range:i.from(Q.range),expression:Q.expression}}ye.from=De;function fe(Q){return new n.EvaluatableExpression(i.to(Q.range),Q.expression)}ye.to=fe})(j||(e.EvaluatableExpression=j={}));var $;(function(ye){function De(Q){if(Q instanceof n.InlineValueText)return{type:"text",range:i.from(Q.range),text:Q.text};if(Q instanceof n.InlineValueVariableLookup)return{type:"variable",range:i.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof n.InlineValueEvaluatableExpression)return{type:"expression",range:i.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=De;function fe(Q){switch(Q.type){case"text":return{range:i.to(Q.range),text:Q.text};case"variable":return{range:i.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:i.to(Q.range),expression:Q.expression}}}ye.to=fe})($||(e.InlineValue=$={}));var J;(function(ye){function De(Q){return{frameId:Q.frameId,stoppedLocation:i.from(Q.stoppedLocation)}}ye.from=De;function fe(Q){return new n.InlineValueContext(Q.frameId,i.to(Q.stoppedLocation))}ye.to=fe})(J||(e.InlineValueContext=J={}));var V;(function(ye){function De(Q){return{range:i.from(Q.range),kind:Q.kind}}ye.from=De;function fe(Q){return new n.DocumentHighlight(i.to(Q.range),Q.kind)}ye.to=fe})(V||(e.DocumentHighlight=V={}));var Z;(function(ye){function De(fe){switch(fe){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}ye.to=De})(Z||(e.CompletionTriggerKind=Z={}));var Y;(function(ye){function De(fe){return{triggerKind:Z.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ye.to=De})(Y||(e.CompletionContext=Y={}));var _;(function(ye){function De(Q){switch(Q){case n.CompletionItemTag.Deprecated:return 1}}ye.from=De;function fe(Q){switch(Q){case 1:return n.CompletionItemTag.Deprecated}}ye.to=fe})(_||(e.CompletionItemTag=_={}));var ae;(function(ye){const De=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function fe(Fe){return De.get(Fe)??9}ye.from=fe;const Q=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Pe(Fe){return Q.get(Fe)??n.CompletionItemKind.Property}ye.to=Pe})(ae||(e.CompletionItemKind=ae={}));var Ee;(function(ye){function De(fe,Q){const Pe=new n.CompletionItem(fe.label);return Pe.insertText=fe.insertText,Pe.kind=ae.to(fe.kind),Pe.tags=fe.tags?.map(_.to),Pe.detail=fe.detail,Pe.documentation=C.isMarkdownString(fe.documentation)?ce.to(fe.documentation):fe.documentation,Pe.sortText=fe.sortText,Pe.filterText=fe.filterText,Pe.preselect=fe.preselect,Pe.commitCharacters=fe.commitCharacters,p.Range.isIRange(fe.range)?Pe.range=i.to(fe.range):typeof fe.range=="object"&&(Pe.range={inserting:i.to(fe.range.insert),replacing:i.to(fe.range.replace)}),Pe.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Pe.insertText=new n.SnippetString(fe.insertText):(Pe.insertText=fe.insertText,Pe.textEdit=Pe.range instanceof n.Range?new n.TextEdit(Pe.range,Pe.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Pe.additionalTextEdits=fe.additionalTextEdits.map(Fe=>q.to(Fe))),Pe.command=Q&&fe.command?Q.fromInternal(fe.command):void 0,Pe}ye.to=De})(Ee||(e.CompletionItem=Ee={}));var Ce;(function(ye){function De(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:ce.fromStrict(Q.documentation)}}ye.from=De;function fe(Q){return{label:Q.label,documentation:C.isMarkdownString(Q.documentation)?ce.to(Q.documentation):Q.documentation}}ye.to=fe})(Ce||(e.ParameterInformation=Ce={}));var ke;(function(ye){function De(Q){return{label:Q.label,documentation:ce.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(Ce.from):[],activeParameter:Q.activeParameter}}ye.from=De;function fe(Q){return{label:Q.label,documentation:C.isMarkdownString(Q.documentation)?ce.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Ce.to):[],activeParameter:Q.activeParameter}}ye.to=fe})(ke||(e.SignatureInformation=ke={}));var Ue;(function(ye){function De(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ke.from):[]}}ye.from=De;function fe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ke.to):[]}}ye.to=fe})(Ue||(e.SignatureHelp=Ue={}));var ze;(function(ye){function De(fe,Q){const Pe=new n.InlayHint(l.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(me.to.bind(void 0,fe)),Q.kind&&Se.to(Q.kind));return Pe.textEdits=Q.textEdits&&Q.textEdits.map(q.to),Pe.tooltip=C.isMarkdownString(Q.tooltip)?ce.to(Q.tooltip):Q.tooltip,Pe.paddingLeft=Q.paddingLeft,Pe.paddingRight=Q.paddingRight,Pe}ye.to=De})(ze||(e.InlayHint=ze={}));var me;(function(ye){function De(fe,Q){const Pe=new n.InlayHintLabelPart(Q.label);return Pe.tooltip=C.isMarkdownString(Q.tooltip)?ce.to(Q.tooltip):Q.tooltip,b.Command.is(Q.command)&&(Pe.command=fe.fromInternal(Q.command)),Q.location&&(Pe.location=U.to(Q.location)),Pe}ye.to=De})(me||(e.InlayHintLabelPart=me={}));var Se;(function(ye){function De(Q){return Q}ye.from=De;function fe(Q){return Q}ye.to=fe})(Se||(e.InlayHintKind=Se={}));var we;(function(ye){function De(Q){return{range:i.from(Q.range),url:Q.target,tooltip:Q.tooltip}}ye.from=De;function fe(Q){let Pe;if(Q.url)try{Pe=typeof Q.url=="string"?d.URI.parse(Q.url,!0):d.URI.revive(Q.url)}catch{}return new n.DocumentLink(i.to(Q.range),Pe)}ye.to=fe})(we||(e.DocumentLink=we={}));var Oe;(function(ye){function De(Q){const Pe=new n.ColorPresentation(Q.label);return Q.textEdit&&(Pe.textEdit=q.to(Q.textEdit)),Q.additionalTextEdits&&(Pe.additionalTextEdits=Q.additionalTextEdits.map(Fe=>q.to(Fe))),Pe}ye.to=De;function fe(Q){return{label:Q.label,textEdit:Q.textEdit?q.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Pe=>q.from(Pe)):void 0}}ye.from=fe})(Oe||(e.ColorPresentation=Oe={}));var je;(function(ye){function De(Q){return new n.Color(Q[0],Q[1],Q[2],Q[3])}ye.to=De;function fe(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}ye.from=fe})(je||(e.Color=je={}));var _e;(function(ye){function De(Q){return{range:i.from(Q.range)}}ye.from=De;function fe(Q){return new n.SelectionRange(i.to(Q.range))}ye.to=fe})(_e||(e.SelectionRange=_e={}));var Ve;(function(ye){function De(fe){switch(fe){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}ye.to=De})(Ve||(e.TextDocumentSaveReason=Ve={}));var Ye;(function(ye){function De(Q){switch(Q){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=De;function fe(Q){switch(Q){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}ye.to=fe})(Ye||(e.TextEditorLineNumbersStyle=Ye={}));var Xe;(function(ye){function De(Q){if(Q===n.EndOfLine.CRLF)return 1;if(Q===n.EndOfLine.LF)return 0}ye.from=De;function fe(Q){if(Q===1)return n.EndOfLine.CRLF;if(Q===0)return n.EndOfLine.LF}ye.to=fe})(Xe||(e.EndOfLine=Xe={}));var it;(function(ye){function De(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=De})(it||(e.ProgressLocation=it={}));var Je;(function(ye){function De(Q){const Pe={start:Q.start+1,end:Q.end+1};return Q.kind&&(Pe.kind=Ge.from(Q.kind)),Pe}ye.from=De;function fe(Q){const Pe={start:Q.start-1,end:Q.end-1};return Q.kind&&(Pe.kind=Ge.to(Q.kind)),Pe}ye.to=fe})(Je||(e.FoldingRange=Je={}));var Ge;(function(ye){function De(Q){if(Q)switch(Q){case n.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}ye.from=De;function fe(Q){if(Q)switch(Q.value){case b.FoldingRangeKind.Comment.value:return n.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports.value:return n.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region.value:return n.FoldingRangeKind.Region}}ye.to=fe})(Ge||(e.FoldingRangeKind=Ge={}));var he;(function(ye){function De(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?i.from(fe.selection):void 0,override:typeof fe.override=="boolean"?u.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=De})(he||(e.TextEditorOpenOptions=he={}));var Ie;(function(ye){function De(Fe){return Fe instanceof n.RelativePattern?Fe.toJSON():typeof Fe=="string"?Fe:fe(Fe)||Q(Fe)?new n.RelativePattern(Fe.baseUri??Fe.base,Fe.pattern).toJSON():Fe}ye.from=De;function fe(Fe){const xe=Fe;return xe?d.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function Q(Fe){const xe=Fe;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Pe(Fe){return typeof Fe=="string"?Fe:new n.RelativePattern(d.URI.revive(Fe.baseUri),Fe.pattern)}ye.to=Pe})(Ie||(e.GlobPattern=Ie={}));var Te;(function(ye){function De(fe){if(fe){if(Array.isArray(fe))return fe.map(De);if(typeof fe=="string")return fe;{const Q=fe;return{language:Q.language,scheme:Q.scheme,pattern:Ie.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}ye.from=De})(Te||(e.LanguageSelector=Te={}));var Ae;(function(ye){function De(Q){return{start:Q.start,end:Q.end}}ye.from=De;function fe(Q){return new n.NotebookRange(Q.start,Q.end)}ye.to=fe})(Ae||(e.NotebookRange=Ae={}));var Ne;(function(ye){function De(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}ye.to=De;function fe(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}ye.from=fe})(Ne||(e.NotebookCellExecutionSummary=Ne={}));var $e;(function(ye){function De(fe){if(fe===f.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(fe===f.NotebookCellExecutionState.Pending)return;if(fe===f.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ye.to=De})($e||(e.NotebookCellExecutionState=$e={}));var We;(function(ye){function De(Q){switch(Q){case n.NotebookCellKind.Markup:return f.CellKind.Markup;case n.NotebookCellKind.Code:default:return f.CellKind.Code}}ye.from=De;function fe(Q){switch(Q){case f.CellKind.Markup:return n.NotebookCellKind.Markup;case f.CellKind.Code:default:return n.NotebookCellKind.Code}}ye.to=fe})(We||(e.NotebookCellKind=We={}));var Ke;(function(ye){function De(Q){const Pe={metadata:Q.metadata??Object.create(null),cells:[]};for(const Fe of Q.cells)n.NotebookCellData.validate(Fe),Pe.cells.push(et.from(Fe));return Pe}ye.from=De;function fe(Q){const Pe=new n.NotebookData(Q.cells.map(et.to));return(0,E.isEmptyObject)(Q.metadata)||(Pe.metadata=Q.metadata),Pe}ye.to=fe})(Ke||(e.NotebookData=Ke={}));var et;(function(ye){function De(Q){return{cellKind:We.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Ne.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(rt.from):[]}}ye.from=De;function fe(Q){return new n.NotebookCellData(We.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(rt.to):void 0,Q.metadata,Q.internalMetadata?Ne.to(Q.internalMetadata):void 0)}ye.to=fe})(et||(e.NotebookCellData=et={}));var qe;(function(ye){function De(Q){return{mime:Q.mime,valueBytes:L.VSBuffer.wrap(Q.data)}}ye.from=De;function fe(Q){return new n.NotebookCellOutputItem(Q.valueBytes.buffer,Q.mime)}ye.to=fe})(qe||(e.NotebookCellOutputItem=qe={}));var rt;(function(ye){function De(Q){return{outputId:Q.id,items:Q.items.map(qe.from),metadata:Q.metadata}}ye.from=De;function fe(Q){const Pe=Q.items.map(qe.to);return new n.NotebookCellOutput(Pe,Q.outputId,Q.metadata)}ye.to=fe})(rt||(e.NotebookCellOutput=rt={}));var ct;(function(ye){function De(Pe){return Q(Pe)?{include:(0,E.withNullAsUndefined)(Ie.from(Pe.include)),exclude:(0,E.withNullAsUndefined)(Ie.from(Pe.exclude))}:(0,E.withNullAsUndefined)(Ie.from(Pe))}ye.from=De;function fe(Pe){return Q(Pe)?{include:Ie.to(Pe.include),exclude:Ie.to(Pe.exclude)}:Ie.to(Pe)}ye.to=fe;function Q(Pe){const Fe=Pe;return Fe?!(0,E.isUndefinedOrNull)(Fe.include)&&!(0,E.isUndefinedOrNull)(Fe.exclude):!1}})(ct||(e.NotebookExclusiveDocumentPattern=ct={}));var st;(function(ye){function De(fe,Q,Pe){const Fe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Fe,Pe),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ye.from=De})(st||(e.NotebookStatusBarItem=st={}));var Et;(function(ye){function De(fe,Q,Pe){const Fe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:Q.toInternal(Fe,Pe),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}ye.from=De})(Et||(e.NotebookKernelSourceAction=Et={}));var wt;(function(ye){function De(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ye.from=De})(wt||(e.NotebookDocumentContentOptions=wt={}));var Rt;(function(ye){function De(Q){return{uri:Q.uri,provides:Q.provides}}ye.from=De;function fe(Q){return new n.NotebookRendererScript(d.URI.revive(Q.uri),Q.provides)}ye.to=fe})(Rt||(e.NotebookRendererScript=Rt={}));var gt;(function(ye){function De(Q){return{message:ce.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location&&{range:i.from(Q.location.range),uri:Q.location.uri}}}ye.from=De;function fe(Q){const Pe=new n.TestMessage(typeof Q.message=="string"?Q.message:ce.to(Q.message));return Pe.actualOutput=Q.actual,Pe.expectedOutput=Q.expected,Pe.location=Q.location?U.to(Q.location):void 0,Pe}ye.to=fe})(gt||(e.TestMessage=gt={}));var ut;(function(ye){ye.namespace=O.namespaceTestTag,ye.denamespace=O.denamespaceTestTag})(ut||(e.TestTag=ut={}));var yt;(function(ye){function De(Q){const Pe=(0,h.getPrivateApiFor)(Q).controllerId;return{extId:I.TestId.fromExtHostTestItem(Q,Pe).toString(),label:Q.label,uri:d.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Fe=>ut.namespace(Pe,Fe.id)),range:p.Range.lift(i.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&ce.fromStrict(Q.error)||null}}ye.from=De;function fe(Q){return{parent:void 0,error:void 0,id:I.TestId.fromString(Q.extId).localId,label:Q.label,uri:d.URI.revive(Q.uri),tags:(Q.tags||[]).map(Pe=>{const{tagId:Fe}=ut.denamespace(Pe);return new n.TestTag(Fe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}ye.toPlain=fe})(yt||(e.TestItem=yt={})),function(ye){function De(Q){return{id:Q.id}}ye.from=De;function fe(Q){return new n.TestTag(Q.id)}ye.to=fe}(ut||(e.TestTag=ut={}));var Tt;(function(ye){const De=(Q,Pe)=>{const Fe=[];for(const[Me,Qe]of Pe)I.TestId.compare(Qe.item.extId,Me)===2&&(Pe.delete(Me),Fe.push(Qe));const xe={...yt.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(Me=>({state:Me.state,duration:Me.duration,messages:Me.messages.filter(Qe=>Qe.type===0).map(gt.to)})),children:Fe.map(Me=>De(Me,Pe))};for(const Me of xe.children)Me.parent=xe;return xe};function fe(Q){const Pe=[],Fe=new Map;for(const xe of Q.items){Fe.set(xe.item.extId,xe);const Me=I.TestId.root(xe.item.extId);Q.request.targets.some(Qe=>Qe.controllerId===Me&&Qe.testIds.includes(xe.item.extId))&&Pe.push(xe)}return{completedAt:Q.completedAt,results:Pe.map(xe=>De(xe,Fe))}}ye.to=fe})(Tt||(e.TestResults=Tt={}));var Ct;(function(ye){function De(Fe){return{covered:Fe.covered,total:Fe.covered}}function fe(Fe){return"line"in Fe?l.from(Fe):i.from(Fe)}function Q(Fe){return"branches"in Fe?{count:Fe.executionCount,location:fe(Fe.location),type:1,branches:Fe.branches.length?Fe.branches.map(xe=>({count:xe.executionCount,location:xe.location&&fe(xe.location)})):void 0}:{type:0,count:Fe.executionCount,location:fe(Fe.location)}}ye.fromDetailed=Q;function Pe(Fe){return{uri:Fe.uri,statement:De(Fe.statementCoverage),branch:Fe.branchCoverage&&De(Fe.branchCoverage),function:Fe.functionCoverage&&De(Fe.functionCoverage),details:Fe.detailedCoverage?.map(Q)}}ye.fromFile=Pe})(Ct||(e.TestCoverage=Ct={}));var Lt;(function(ye){function De(fe){switch(fe){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}ye.to=De})(Lt||(e.CodeActionTriggerKind=Lt={}));var Ot;(function(ye){function De(Q){const Pe=new n.TypeHierarchyItem(ne.to(Q.kind),Q.name,Q.detail||"",d.URI.revive(Q.uri),i.to(Q.range),i.to(Q.selectionRange));return Pe._sessionId=Q._sessionId,Pe._itemId=Q._itemId,Pe}ye.to=De;function fe(Q,Pe,Fe){if(Pe=Pe??Q._sessionId,Fe=Fe??Q._itemId,Pe===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Fe,kind:ne.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:i.from(Q.range),selectionRange:i.from(Q.selectionRange),tags:Q.tags?.map(se.from)}}ye.from=fe})(Ot||(e.TypeHierarchyItem=Ot={}));var St;(function(ye){function De(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}ye.from=De})(St||(e.ViewBadge=St={}));var Pt;(function(ye){function De(Fe,xe,Me){const Qe=xe.fileData;return Qe?new class extends n.DataTransferItem{asFile(){return new n.DataTransferFile(Qe.name,d.URI.revive(Qe.uri),xe.id,(0,P.once)(()=>Me()))}}("",xe.id):Fe===T.Mimes.uriList&&xe.uriListData?new n.DataTransferItem(Pe(xe.uriListData)):new n.DataTransferItem(xe.asString)}ye.to=De;async function fe(Fe,xe){const Me=await xe.asString();if(Fe===T.Mimes.uriList)return{id:xe.id,asString:Me,fileData:void 0,uriListData:Q(Me)};const Qe=xe.asFile();return{id:xe.id,asString:Me,fileData:Qe?{name:Qe.name,uri:Qe.uri}:void 0}}ye.from=fe;function Q(Fe){return o.UriList.split(Fe).map(xe=>{if(xe.startsWith("#"))return xe;try{return d.URI.parse(xe)}catch{}return xe})}function Pe(Fe){return o.UriList.create(Fe.map(xe=>typeof xe=="string"?xe:d.URI.revive(xe)))}})(Pt||(e.DataTransferItem=Pt={}));var ot;(function(ye){function De(Q,Pe){const Fe=Q.items.map(([xe,Me])=>[xe,Pt.to(xe,Me,()=>Pe(Me.id))]);return new n.DataTransfer(Fe)}ye.toDataTransfer=De;async function fe(Q){const Pe={items:[]},Fe=[];return Q.forEach((xe,Me)=>{Fe.push((async()=>{Pe.items.push([Me,await Pt.from(Me,xe)])})())}),await Promise.all(Fe),Pe}ye.toDataTransferDTO=fe})(ot||(e.DataTransfer=ot={}));var ht;(function(ye){function De(Q){return{message:Q.message,metadata:Q.metadata,title:Q.title,tooltip:Q.tooltip}}ye.to=De;function fe(Q){return{kind:"reply",message:Q.message,metadata:Q.metadata,title:Q.title,tooltip:Q.tooltip}}ye.from=fe})(ht||(e.InteractiveSessionReplyFollowup=ht={}));var dt;(function(ye){function De(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",args:fe.args}:ht.from(fe)}ye.from=De})(dt||(e.InteractiveSessionFollowup=dt={}))}),define(ge[277],pe([1,0,49,131,69,130,89,135,4]),function(oe,e,w,L,o,P,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const m=(f,I,O,t)=>{let n=I;return{enumerable:!0,configurable:!1,get(){return n},set(r){if(!O(n,r)){const i=n;n=r,f.listener?.(t(r,i))}}}},T=(f,I)=>f===I,y={range:(f,I)=>f===I?!0:!f||!I?!1:f.isEqual(I),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(f,I)=>!(f.length!==I.length||f.some(O=>!I.find(t=>O.id===t.id)))},E=f=>I=>({op:4,update:f(I)}),d=(f,I)=>({range:(()=>{let O;const t=E(n=>({range:w.Range.lift(A.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return O},set(n){f.listener?.({op:6}),y.range(O,n)||(O=n,f.listener?.(t(n)))}}})(),label:m(f,I,y.label,E(O=>({label:O}))),description:m(f,void 0,y.description,E(O=>({description:O}))),sortText:m(f,void 0,y.sortText,E(O=>({sortText:O}))),canResolveChildren:m(f,!1,y.canResolveChildren,O=>({op:2,state:O})),busy:m(f,!1,y.busy,E(O=>({busy:O}))),error:m(f,void 0,y.error,E(O=>({error:A.MarkdownString.fromStrict(O)||null}))),tags:m(f,[],y.tags,(O,t)=>({op:1,new:O.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),p=f=>{const I=o.TestId.fromString(f.extId),O=new s(I.controllerId,I.localId,f.label,v.URI.revive(f.uri)||void 0);return O.range=A.Range.to(f.range||void 0),O.description=f.description||void 0,O.sortText=f.sortText||void 0,O.tags=f.tags.map(t=>A.TestTag.to({id:(0,C.denamespaceTestTag)(t).tagId})),O},b=f=>{let I;for(const O of f.tests){const t=p(O.item);(0,L.getPrivateApiFor)(t).parent=I,I=t}return I};e.toItemFromContext=b;class s{constructor(I,O,t,n){if(O.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(O)} symbol`);const r=(0,L.createPrivateApiFor)(this,I);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof h?void 0:r.parent}},children:{value:(0,P.createTestItemChildren)(r,L.getPrivateApiFor,s),enumerable:!0,writable:!1},...d(r,t)})}}e.TestItemImpl=s;class h extends s{constructor(I,O){super(I,I,O,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class u extends P.TestItemCollection{constructor(I,O,t){super({controllerId:I,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:L.getPrivateApiFor,getChildren:n=>n.children,root:new h(I,O),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=u}),define(ge[278],pe([1,0,36,201,52]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function P(C,A,v,m){const T=new w.ExtensionIdentifierMap;return C.forEach(y=>{const E=T.get(y.identifier);E&&m.warn((0,L.localize)(0,null,E.extensionLocation.fsPath,y.extensionLocation.fsPath)),T.set(y.identifier,y)}),A.forEach(y=>{const E=T.get(y.identifier);if(E)if(E.isBuiltin){if(o.gte(E.version,y.version)){m.warn(`Skipping extension ${y.extensionLocation.path} in favour of the builtin extension ${E.extensionLocation.path}.`);return}y.isBuiltin=!0}else m.warn((0,L.localize)(1,null,E.extensionLocation.fsPath,y.extensionLocation.fsPath));else if(y.isBuiltin){m.warn(`Skipping obsolete builtin extension ${y.extensionLocation.path}`);return}T.set(y.identifier,y)}),v.forEach(y=>{m.info((0,L.localize)(2,null,y.extensionLocation.fsPath));const E=T.get(y.identifier);E&&E.isBuiltin&&(y.isBuiltin=!0),T.set(y.identifier,y)}),Array.from(T.values())}e.dedupExtensions=P}),define(ge[279],pe([1,0,7,3,29,4,41,50,64,56,278,13]),function(oe,e,w,L,o,P,C,A,v,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannel=e.RemoteExtensionsScannerService=void 0;class E{constructor(b,s,h,u,f,I,O){this.b=b,this.c=h,this.d=u,this.f=f,this.g=I,this.h=O;const t=s.args["install-builtin-extension"];if(t){f.trace("Installing builtin extensions passed via args...");const r={isMachineScoped:!!s.args["do-not-sync"],installPreReleaseVersion:!!s.args["pre-release"]};C.mark("code/server/willInstallBuiltinExtensions"),this.a=b.installExtensions([],this.i(t),r,!!s.args.force).then(()=>{C.mark("code/server/didInstallBuiltinExtensions"),f.trace("Finished installing builtin extensions")},i=>{f.error(i)})}else this.a=Promise.resolve();const n=s.args["install-extension"];n&&(f.trace("Installing extensions passed via args..."),this.a.then(()=>b.installExtensions(this.i(n),[],{isMachineScoped:!!s.args["do-not-sync"],installPreReleaseVersion:!!s.args["pre-release"],isApplicationScoped:!0},!!s.args.force)).then(()=>{f.trace("Finished installing extensions")},r=>{f.error(r)}))}i(b){return b.map(s=>/\.vsix$/i.test(s)?P.URI.file((0,w.isAbsolute)(s)?s:(0,w.join)((0,o.cwd)(),s)):s)}whenExtensionsReady(){return this.a}async scanExtensions(b,s,h,u){C.mark("code/server/willScanExtensions"),this.f.trace(`Scanning extensions using UI language: ${b}`),await this.whenExtensionsReady();const f=h?h.filter(O=>O.scheme===y.Schemas.file).map(O=>O.fsPath):void 0;s=s??this.c.defaultProfile.extensionsResource;const I=await this.j(s,b??L.language,f,u);return this.f.trace("Scanned Extensions",I),this.q(I),C.mark("code/server/didScanExtensions"),I}async scanSingleExtension(b,s,h){await this.whenExtensionsReady();const u=b.scheme===y.Schemas.file?b.fsPath:null;if(!u)return null;const f=await this.n(u,s,h??L.language);return f?(this.q([f]),f):null}async j(b,s,h,u){await this.o(s,u);const[f,I,O]=await Promise.all([this.l(s),this.m(b,s),this.k(s,h)]);return(0,T.dedupExtensions)(f,I,O,this.f)}async k(b,s){return s?(await Promise.all(s.map(h=>this.d.scanOneOrMultipleExtensions(P.URI.file((0,w.resolve)(h)),1,{language:b})))).flat().map(h=>(0,m.toExtensionDescription)(h,!0)):[]}async l(b){return(await this.d.scanSystemExtensions({language:b,useCache:!0})).map(h=>(0,m.toExtensionDescription)(h,!1))}async m(b,s){return(await this.d.scanUserExtensions({profileLocation:b,language:s,useCache:!0})).map(u=>(0,m.toExtensionDescription)(u,!1))}async n(b,s,h){const u=P.URI.file((0,w.resolve)(b)),f=s?0:1,I=await this.d.scanExistingExtension(u,f,{language:h});return I?(0,m.toExtensionDescription)(I,!1):null}async o(b,s){if(!(b===L.LANGUAGE_DEFAULT||!this.g.isEnabled())){try{if((await this.h.getInstalledLanguages()).find(u=>u.id===b)){this.f.trace(`Language Pack ${b} is already installed. Skipping language pack installation.`);return}}catch(h){this.f.error(h)}if(!s){this.f.trace(`No language pack id provided for language ${b}. Skipping language pack installation.`);return}this.f.trace(`Language Pack ${s} for language ${b} is not installed. It will be installed now.`);try{await this.b.installExtensions([s],[],{isMachineScoped:!0},!0)}catch(h){this.f.error(h)}}}q(b){const s=(t,n)=>t.replace(/file/g,"vscode-remote"),h=t=>{let n="";return n+=t.global?"g":"",n+=t.ignoreCase?"i":"",n+=t.multiline?"m":"",new RegExp(s(t.source,!0),n)},u=new class{mapDefined(t){return v.ContextKeyDefinedExpr.create(t)}mapNot(t){return v.ContextKeyNotExpr.create(t)}mapEquals(t,n){return t==="resourceScheme"&&typeof n=="string"?v.ContextKeyEqualsExpr.create(t,s(n,!1)):v.ContextKeyEqualsExpr.create(t,n)}mapNotEquals(t,n){return t==="resourceScheme"&&typeof n=="string"?v.ContextKeyNotEqualsExpr.create(t,s(n,!1)):v.ContextKeyNotEqualsExpr.create(t,n)}mapGreater(t,n){return v.ContextKeyGreaterExpr.create(t,n)}mapGreaterEquals(t,n){return v.ContextKeyGreaterEqualsExpr.create(t,n)}mapSmaller(t,n){return v.ContextKeySmallerExpr.create(t,n)}mapSmallerEquals(t,n){return v.ContextKeySmallerEqualsExpr.create(t,n)}mapRegex(t,n){return t==="resourceScheme"&&n?v.ContextKeyRegexExpr.create(t,h(n)):v.ContextKeyRegexExpr.create(t,n)}mapIn(t,n){return v.ContextKeyInExpr.create(t,n)}mapNotIn(t,n){return v.ContextKeyNotInExpr.create(t,n)}},f=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const n=v.ContextKeyExpr.deserialize(t.when);if(!n)return;const r=n.map(u);t.when=r.serialize()},I=t=>{if(Array.isArray(t))for(const n of t)f(n);else f(t)},O=t=>{for(const n in t)I(t[n])};b.forEach(t=>{t.contributes&&(t.contributes.menus&&O(t.contributes.menus),t.contributes.keybindings&&I(t.contributes.keybindings),t.contributes.views&&O(t.contributes.views))})}}e.RemoteExtensionsScannerService=E;class d{constructor(b,s){this.a=b,this.b=s}listen(b,s){throw new Error("Invalid listen")}async call(b,s,h){const u=this.b(b);switch(s){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const f=h[0],I=h[1]?P.URI.revive(u.transformIncoming(h[1])):void 0,O=Array.isArray(h[2])?h[2].map(r=>P.URI.revive(u.transformIncoming(r))):void 0,t=h[3];return(await this.a.scanExtensions(f,I,O,t)).map(r=>(0,A.transformOutgoingURIs)(r,u))}case"scanSingleExtension":{const f=await this.a.scanSingleExtension(P.URI.revive(u.transformIncoming(h[0])),h[1],h[2]);return f?(0,A.transformOutgoingURIs)(f,u):null}}throw new Error("Invalid call")}}e.RemoteExtensionsScannerChannel=d}),define(ge[136],pe([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class w{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++w.count}}e.ProxyIdentifier=w,w.count=0;const L=[];function o(A){const v=new w(A);return L[v.nid]=v,v}e.createProxyIdentifier=o;function P(A){return L[A].sid}e.getStringIdentifierForProxy=P;class C{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=C}),define(ge[280],pe([1,0,136]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var o;(function(b){b[b.UnknownInput=0]="UnknownInput",b[b.TextInput=1]="TextInput",b[b.TextDiffInput=2]="TextDiffInput",b[b.TextMergeInput=3]="TextMergeInput",b[b.NotebookInput=4]="NotebookInput",b[b.NotebookDiffInput=5]="NotebookDiffInput",b[b.CustomEditorInput=6]="CustomEditorInput",b[b.WebviewEditorInput=7]="WebviewEditorInput",b[b.TerminalEditorInput=8]="TerminalEditorInput",b[b.InteractiveEditorInput=9]="InteractiveEditorInput"})(o||(e.TabInputKind=o={}));var P;(function(b){b[b.TAB_OPEN=0]="TAB_OPEN",b[b.TAB_CLOSE=1]="TAB_CLOSE",b[b.TAB_UPDATE=2]="TAB_UPDATE",b[b.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var C;(function(b){b[b.Editable=0]="Editable",b[b.SupportsHotExit=1]="SupportsHotExit"})(C||(e.WebviewEditorCapabilities=C={}));var A;(function(b){b[b.Int8Array=1]="Int8Array",b[b.Uint8Array=2]="Uint8Array",b[b.Uint8ClampedArray=3]="Uint8ClampedArray",b[b.Int16Array=4]="Int16Array",b[b.Uint16Array=5]="Uint16Array",b[b.Int32Array=6]="Int32Array",b[b.Uint32Array=7]="Uint32Array",b[b.Float32Array=8]="Float32Array",b[b.Float64Array=9]="Float64Array",b[b.BigInt64Array=10]="BigInt64Array",b[b.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var v;(function(b){b[b.Text=1]="Text",b[b.Error=2]="Error",b[b.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var m;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var T;(function(b){b[b.None=0]="None",b[b.Process=1]="Process",b[b.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class y{static mixin(s){return s._id=y.a++,s}}e.IdObject=y,y.a=0;var E;(function(b){b.label="a",b.kind="b",b.detail="c",b.documentation="d",b.sortText="e",b.filterText="f",b.preselect="g",b.insertText="h",b.insertTextRules="i",b.range="j",b.commitCharacters="k",b.additionalTextEdits="l",b.kindModifier="m",b.commandIdent="n",b.commandId="o",b.commandArguments="p"})(E||(e.ISuggestDataDtoField=E={}));var d;(function(b){b.defaultRanges="a",b.completions="b",b.isIncomplete="c",b.duration="d"})(d||(e.ISuggestResultDtoField=d={}));var p;(function(b){b[b.Workspace=0]="Workspace",b[b.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,w.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,w.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,w.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,w.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,w.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,w.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,w.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,w.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostSemanticSimilarity:(0,w.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,w.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.createProxyIdentifier)("ExtHostIssueReporter")}});var Ut=this&&this.__classPrivateFieldSet||function(oe,e,w,L,o){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!o)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!o:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?o.call(oe,w):o?o.value=w:e.set(oe,w),w},nt=this&&this.__classPrivateFieldGet||function(oe,e,w,L){if(w==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!L:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?L:w==="a"?L.call(oe):L?L.value:e.get(oe)};define(ge[281],pe([1,0,8,134,135,21,280,18,12,61,49,96,4,2,5,264,277,15,136,38,97,37,275]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u,f,I,O,t){"use strict";var n,r,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=e.ExtHostCommands=class{constructor(S,F,H){n.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),i.set(this,void 0),Ut(this,n,S.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=F,Ut(this,i,H,"f"),Ut(this,r,S.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,te=>{const ce=this.c.get(te);return ce?.result===g.Void?ce:void 0},F),this.f=[{processArgument(te){return(0,m.revive)(te)}},{processArgument(te){return(0,P.cloneAndChange)(te,function(ce){if(T.Range.isIRange(ce))return o.Range.to(ce);if(y.Position.isIPosition(ce))return o.Position.to(ce);if(T.Range.isIRange(ce.range)&&E.URI.isUri(ce.uri))return o.location.to(ce);if(ce instanceof h.VSBuffer)return ce.buffer.buffer;if(!Array.isArray(ce))return ce})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const F=this.registerCommand(!1,S.id,async(...H)=>{const te=S.args.map((le,ue)=>{if(!le.validate(H[ue]))throw new Error(`Invalid argument '${le.name}' when running '${S.id}', received: ${H[ue]}`);return le.convert(H[ue])}),ce=await this.executeCommand(S.internalId,...te);return S.result.convert(ce,H,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new L.Disposable(()=>{F.dispose(),this.c.delete(S.id)})}registerCommand(S,F,H,te,ce,le){if(this.d.trace("ExtHostCommands#registerCommand",F),!F.trim().length)throw new Error("invalid id");if(this.b.has(F))throw new Error(`command '${F}' already exists`);return this.b.set(F,{callback:H,thisArg:te,description:ce,extension:le}),S&&nt(this,n,"f").$registerCommand(F),new L.Disposable(()=>{this.b.delete(F)&&S&&nt(this,n,"f").$unregisterCommand(F)})}executeCommand(S,...F){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,F,!0)}async g(S,F,H){if(this.b.has(S))return nt(this,n,"f").$fireCommandActivationEvent(S),this.h(S,F,!1);{let te=!1;const ce=(0,P.cloneAndChange)(F,function(le){if(le instanceof L.Position)return o.Position.from(le);if(le instanceof L.Range)return o.Range.from(le);if(le instanceof L.Location)return o.location.from(le);if(L.NotebookRange.isNotebookRange(le))return o.NotebookRange.from(le);if(le instanceof ArrayBuffer)return te=!0,h.VSBuffer.wrap(new Uint8Array(le));if(le instanceof Uint8Array)return te=!0,h.VSBuffer.wrap(le);if(le instanceof h.VSBuffer)return te=!0,le;if(!Array.isArray(le))return le});try{const le=await nt(this,n,"f").$executeCommand(S,te?new u.SerializableObjectWithBuffers(ce):ce,H);return(0,m.revive)(le)}catch(le){if(le instanceof Error&&le.message==="$executeCommand:retry")return this.g(S,F,!1);throw le}}}async h(S,F,H){const te=this.b.get(S);if(!te)throw new Error("Unknown command");const{callback:ce,thisArg:le,description:ue}=te;if(ue)for(let K=0;K<ue.args.length;K++)try{(0,w.validateConstraint)(F[K],ue.args[K].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${ue.args[K].name}' - ${ue.args[K].description}`)}const ve=I.StopWatch.create();try{return await ce.apply(le,F)}catch(K){if(S===this.converter.delegatingCommandId){const ee=this.converter.getActualCommand(...F);ee&&(S=ee.command)}if(this.d.error(K,S,te.extension?.identifier),!H)throw K;if(te.extension?.identifier){const ee=nt(this,i,"f").onExtensionError(te.extension.identifier,K);this.d.trace("forwarded error to extension?",ee,te.extension?.identifier)}throw new class extends Error{constructor(){super((0,f.toErrorMessage)(K)),this.id=S,this.source=te.extension?.displayName??te.extension?.name}}}finally{this.j(te,S,ve.elapsed())}}j(S,F,H){S.extension&&nt(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new O.TelemetryTrustedValue(F),duration:H})}$executeContributedCommand(S,...F){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const H=this.b.get(S);return H?(F=F.map(te=>this.f.reduce((ce,le)=>le.processArgument(ce,H.extension?.identifier),te)),this.h(S,F,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),nt(this,n,"f").$getCommands().then(F=>(S&&(F=F.filter(H=>H[0]!=="_")),F))}$getContributedCommandHandlerDescriptions(){const S=Object.create(null);for(const[F,H]of this.b){const{description:te}=H;te&&(S[F]=te)}return Promise.resolve(S)}};n=new WeakMap,r=new WeakMap,i=new WeakMap,e.ExtHostCommands=a=Le([Re(0,b.IExtHostRpcService),Re(1,v.ILogService),Re(2,t.IExtHostTelemetry)],a),e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class l{constructor(S,F,H){this.d=S,this.f=F,this.g=H,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,F){if(!S)return;const H={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return H;const te=this.f(S.command);if(te)H.id=te.internalId,H.arguments=te.args.map((ce,le)=>ce.convert(S.arguments&&S.arguments[le]));else if((0,A.isNonEmptyArray)(S.arguments)){const ce=`${S.command}/${++this.c}`;this.b.set(ce,S),F.add((0,d.toDisposable)(()=>{this.b.delete(ce),this.g.trace("CommandsConverter#DISPOSE",ce)})),H.$ident=ce,H.id=this.delegatingCommandId,H.arguments=[ce],this.g.trace("CommandsConverter#CREATE",S.command,ce)}return H}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const F=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],F?F.command:"MISSING"),F?this.d.executeCommand(F.command,...F.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.CommandsConverter=l;class c{constructor(S,F,H,te){this.name=S,this.description=F,this.validate=H,this.convert=te}optional(){return new c(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,F){return new c(S??this.name,F??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",k=>E.URI.isUri(k),k=>k),c.Position=new c("position","A position in a text document",k=>L.Position.isPosition(k),o.Position.from),c.Range=new c("range","A range in a text document",k=>L.Range.isRange(k),o.Range.from),c.Selection=new c("selection","A selection in a text document",k=>L.Selection.isSelection(k),o.Selection.from),c.Number=new c("number","",k=>typeof k=="number",k=>k),c.String=new c("string","",k=>typeof k=="string",k=>k),c.CallHierarchyItem=new c("item","A call hierarchy item",k=>k instanceof L.CallHierarchyItem,o.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",k=>k instanceof L.TypeHierarchyItem,o.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",k=>k instanceof s.TestItemImpl,o.TestItem.from);class g{constructor(S,F){this.description=S,this.convert=F}}e.ApiCommandResult=g,g.Void=new g("no result",k=>k);class D{constructor(S,F,H,te,ce){this.id=S,this.internalId=F,this.description=H,this.args=te,this.result=ce}}e.ApiCommand=D}),define(ge[282],pe([1,0,11,2,13,215]),function(oe,e,w,L,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class C extends P.DiskFileSystemProviderClient{static register(v,m,T){const y=v.getConnection();if(!y)return L.Disposable.None;const E=new L.DisposableStore,d=(async()=>{try{const p=await v.getRawEnvironment();p?m.registerProvider(o.Schemas.vscodeRemote,E.add(new C(p,y))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(p){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,w.getErrorMessage)(p))}})();return E.add(m.onWillActivateFileSystemProvider(p=>{p.scheme===o.Schemas.vscodeRemote&&p.join(d)})),E}constructor(v,m){super(m.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:v.os===3})}}e.RemoteFileSystemProviderClient=C}),define(ge[90],pe([1,0,33,14,7,8,23,168,297,298]),function(oe,e,w,L,o,P,C,A,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const T=new RegExp(e.CorruptZipMessage);class y extends Error{constructor(n,r){let i=r.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=n,this.cause=r}}e.ExtractError=y;function E(t){const n=t.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,i)=>r+i,n&61440)}function d(t){if(t instanceof y)return t;let n;return T.test(t.message)&&(n="CorruptZip"),new y(n,t)}function p(t,n,r,i,a,l){const c=o.dirname(n),g=o.join(i,c);if(!g.startsWith(i))return Promise.reject(new Error(A.localize(0,null,n)));const D=o.join(i,n);let k;return l.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(C.Promises.mkdir(g,{recursive:!0})).then(()=>new Promise((S,F)=>{if(!l.isCancellationRequested)try{k=(0,w.createWriteStream)(D,{mode:r}),k.once("close",()=>S()),k.once("error",F),t.once("error",F),t.pipe(k)}catch(H){F(H)}}))}function b(t,n,r,i){let a=(0,L.createCancelablePromise)(()=>Promise.resolve()),l=0;return i.onCancellationRequested(()=>{a.cancel(),t.close()}),new Promise((c,g)=>{const D=new L.Sequencer,k=S=>{S.isCancellationRequested||(l++,t.readEntry())};t.once("error",g),t.once("close",()=>a.then(()=>{i.isCancellationRequested||t.entryCount===l?c():g(new y("Incomplete",new Error(A.localize(1,null,l,t.entryCount))))},g)),t.readEntry(),t.on("entry",S=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(S.fileName)){k(i);return}const F=S.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(F)){const ce=o.join(n,F);a=(0,L.createCancelablePromise)(le=>C.Promises.mkdir(ce,{recursive:!0}).then(()=>k(le)).then(void 0,g));return}const H=h(t,S),te=E(S);a=(0,L.createCancelablePromise)(ce=>D.queue(()=>H.then(le=>p(le,F,te,n,r,ce).then(()=>k(ce)))).then(null,g))})})}function s(t,n=!1){return new Promise((r,i)=>{(0,v.open)(t,n?{lazyEntries:!0}:void 0,(a,l)=>{a?i(d(a)):r((0,P.assertIsDefined)(l))})})}function h(t,n){return new Promise((r,i)=>{t.openReadStream(n,(a,l)=>{a?i(d(a)):r((0,P.assertIsDefined)(l))})})}function u(t,n){return new Promise((r,i)=>{const a=new m.ZipFile;n.forEach(c=>{c.contents?a.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&a.addFile(c.localPath,c.path)}),a.end();const l=(0,w.createWriteStream)(t);a.outputStream.pipe(l),a.outputStream.once("error",i),l.once("error",i),l.once("finish",()=>r(t))})}e.zip=u;function f(t,n,r={},i){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let l=s(t,!0);return r.overwrite&&(l=l.then(c=>C.Promises.rm(n).then(()=>c))),l.then(c=>b(c,n,{sourcePathRegex:a},i))}e.extract=f;function I(t,n){return s(t).then(r=>new Promise((i,a)=>{r.on("entry",l=>{l.fileName===n&&h(r,l).then(c=>i(c),c=>a(c))}),r.once("close",()=>a(new Error(A.localize(2,null,n))))}))}function O(t,n){return I(t,n).then(r=>new Promise((i,a)=>{const l=[];r.once("error",a),r.on("data",c=>l.push(c)),r.on("end",()=>i(Buffer.concat(l)))}))}e.buffer=O}),define(ge[283],pe([1,0,14,11,2,13,3,19,52,8,22,23,90,24,25,30,34,80,16,12]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let I=e.ExtensionsDownloader=class Zt extends o.Disposable{constructor(t,n,r,i,a,l){super(),this.h=n,this.i=r,this.j=i,this.k=a,this.l=l,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,n,r){await this.g;const i=(0,A.joinPath)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,i,l=>this.i.download(t,l,n))}catch(l){throw new b.ExtensionManagementError(l.message,b.ExtensionManagementErrorCode.Download)}let a=!1;if(r&&this.m(t)){const l=await this.n(t);try{a=await this.k.verify(i.fsPath,l.fsPath,this.l.getLevel()===f.LogLevel.Trace)}catch(c){const g=c;if(a=g.code,g.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${g.output}`),a===b.ExtensionSignaturetErrorCode.PackageIsInvalidZip||a===b.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new b.ExtensionManagementError(E.CorruptZipMessage,b.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(l)}catch(c){this.l.error(c)}}}return a===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):a===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${a}': ${t.identifier.id}`),{location:i,verificationStatus:a}}m(t){if(!t.isSigned)return!1;const n=this.j.getValue("extensions.verifySignature");return(0,m.isBoolean)(n)?n:!0}async n(t){await this.g;const n=(0,A.joinPath)(this.extensionsDownloadDir,`${this.v(t)}${Zt.c}`);return await this.r(t,n,r=>this.i.downloadSignatureArchive(t,r)),n}async r(t,n,r){if(await this.h.exists(n))return;if(n.scheme!==P.Schemas.file){await r(n);return}const i=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,T.generateUuid)()}`);await this.h.exists(i)||await r(i);try{await this.t(i,n,Date.now()+2*60*1e3)}catch(a){try{await this.h.del(i)}catch{}if(a.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.l.info(`Rename failed because of ${(0,L.getErrorMessage)(a)}. Deleted the file from downloaded location`,i.path),a}}async delete(t){await this.g,await this.h.del(t)}async t(t,n,r){try{await y.Promises.rename(t.fsPath,n.fsPath)}catch(i){if(C.isWindows&&i&&i.code==="EPERM"&&Date.now()<r)return this.l.info(`Failed renaming ${t} to ${n} with 'EPERM' error. Trying again...`),this.t(t,n,r);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],r=[],i=[];for(const c of t.children)if(c.name.endsWith(Zt.c))i.push(c.resource);else{const g=s.ExtensionKey.parse(c.name);g&&r.push([g,c])}const a=(0,s.groupByExtension)(r,([c])=>c),l=[];for(const c of a)c.sort((g,D)=>v.rcompare(g[0].version,D[0].version)),n.push(...c.slice(1).map(g=>g[1].resource)),l.push(c[0][1]);l.sort((c,g)=>c.mtime-g.mtime),n.push(...l.slice(0,Math.max(0,l.length-this.f)).map(c=>c.resource)),n.push(...i),await w.Promises.settled(n.map(c=>(this.l.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(t){this.l.error(t)}}v(t){return this.f?s.ExtensionKey.create(t).toString().toLowerCase():(0,T.generateUuid)()}};I.c=".sigzip",e.ExtensionsDownloader=I=Le([Re(0,p.INativeEnvironmentService),Re(1,u.IFileService),Re(2,b.IExtensionGalleryService),Re(3,d.IConfigurationService),Re(4,h.IExtensionSignatureVerificationService),Re(5,f.ILogService)],I)}),define(ge[284],pe([1,0,90,180]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function o(P){return(0,w.buffer)(P,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.getManifest=o}),define(ge[137],pe([1,0,14,15,20,38,11,6,2,27,13,7,3,19,52,8,4,22,23,90,179,79,25,255,30,34,44,56,283,256,284,232,241,77,16,5,12,26,31,35,32]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u,f,I,O,t,n,r,i,a,l,c,g,D,k,S,F,H,te,ce,le,ue,ve,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,te.refineServiceDecorator)(r.IExtensionManagementService);let ee=e.ExtensionManagementService=class extends n.AbstractExtensionManagementService{constructor(W,x,N,R,U,X,ie,j,$,J,V,Z){super(W,x,N,J,Z),this.Z=U,this.ab=X,this.bb=ie,this.cb=$,this.db=V,this.X=this.B(new A.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new m.ResourceSet;const Y=this.B(j.createInstance(g.ExtensionsLifecycle));this.S=this.B(j.createInstance(z,ae=>Y.postUninstall(ae))),this.U=this.B(new k.ExtensionsManifestCache(Z,$,V,this,this.v)),this.W=this.B(j.createInstance(c.ExtensionsDownloader));const _=this.B(new S.ExtensionsWatcher(this,this.Z,Z,X,V,$,N));this.B(_.onDidChangeExtensionsByAnotherSource(ae=>this.kb(ae))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(W){this.v.trace("ExtensionManagementService#zip",W.identifier.id);const x=await this.jb(W),N=await(0,f.zip)((0,d.joinPath)(this.W.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,x);return s.URI.file(N)}async unzip(W){return this.v.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const{location:x,cleanup:N}=await this.fb(W),R=y.resolve(x.fsPath);try{return await(0,D.getManifest)(R)}finally{await N()}}getInstalled(W,x=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(W??null,x)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(W){return this.S.scanUserExtensionAtLocation(W)}async install(W,x={}){this.v.trace("ExtensionManagementService#install",W.toString());const{location:N,cleanup:R}=await this.fb(W);try{const U=await(0,D.getManifest)(y.resolve(N.fsPath));if(U.engines&&U.engines.vscode&&!(0,F.isEngineValid)(U.engines.vscode,this.w.version,this.w.date))throw new Error(I.localize(0,null,(0,i.getGalleryExtensionId)(U.publisher,U.name),this.w.version));return await this.z(U,N,x)}finally{await R()}}async installFromLocation(W,x){this.v.trace("ExtensionManagementService#installFromLocation",W.toString());const N=await this.S.scanUserExtensionAtLocation(W);if(!N)throw new Error(`Cannot find a valid extension from the location ${W.toString()}`);return await this.ob([[N,void 0]],x),this.v.info("Successfully installed extension",N.identifier.id,x.toString()),N}async installExtensionsFromProfile(W,x,N){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",W,x.toString(),N.toString());const R=(await this.S.scanExtensions(1,x)).filter(U=>W.some(X=>(0,i.areSameExtensions)(X,U.identifier)));if(R.length){const U=await Promise.all(R.map(X=>this.S.scanMetadata(X,x)));await this.ob(R.map((X,ie)=>[X,U[ie]]),N),this.v.info("Successfully installed extensions",R.map(X=>X.identifier.id),N.toString())}return R}async updateMetadata(W,x,N=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",W.identifier.id),x.isPreReleaseVersion&&(x.preRelease=!0),x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,x.pinned=x.pinned||void 0,W=await this.S.updateMetadata(W,x,N),this.U.invalidate(N),this.X.fire(W),W}async reinstallFromGallery(W){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",W.identifier.id),!this.t.isEnabled())throw new Error(I.localize(1,null));const x=await this.getTargetPlatform(),[N]=await this.t.getExtensions([{...W.identifier,preRelease:W.preRelease}],{targetPlatform:x,compatible:!0},o.CancellationToken.None);if(!N)throw new Error(I.localize(2,null));await this.S.setUninstalled(W);try{await this.S.removeUninstalledExtension(W)}catch(R){throw new Error(I.localize(3,null,(0,P.toErrorMessage)(R)))}return this.installFromGallery(N)}copyExtensions(W,x){return this.S.copyExtensions(W,x)}markAsUninstalled(...W){return this.S.setUninstalled(...W)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(W){this.v.error(W)}}async download(W,x,N){const{location:R}=await this.W.download(W,x,!N);return R}async fb(W){if(W.scheme===T.Schemas.file)return{location:W,async cleanup(){}};this.v.trace("Downloading extension from",W.toString());const x=(0,d.joinPath)(this.W.extensionsDownloadDir,(0,h.generateUuid)());return await this.bb.download(W,x),this.v.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.cb.del(x)}catch(R){this.v.error(R)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(W,x,N){if(s.URI.isUri(x))return new ne(W,x,N,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const R=i.ExtensionKey.create(x).toString();let U=this.Y.get(R);return U||(this.Y.set(R,U=new G(W,x,N,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),U.waitUntilTaskIsFinished().finally(()=>this.Y.delete(R))),U}R(W,x){return new se(W,x.profileLocation,this.ab)}async jb(W){const x=async R=>{let U=await u.Promises.readdir(R);U=U.map(j=>y.join(R,j));const X=await Promise.all(U.map(j=>u.Promises.stat(j)));let ie=Promise.resolve([]);return X.forEach((j,$)=>{const J=U[$];j.isFile()&&(ie=ie.then(V=>[...V,J])),j.isDirectory()&&(ie=ie.then(V=>x(J).then(Z=>[...V,...Z])))}),ie};return(await x(W.location.fsPath)).map(R=>({path:`extension/${y.relative(W.location.fsPath,R)}`,localPath:R}))}async kb({added:W,removed:x}){if(x)for(const N of x.extensions)this.v.info("Extensions removed from another source",N.id,x.profileLocation.toString()),this.p.fire({identifier:N,profileLocation:x.profileLocation});if(W){const R=(await this.S.scanExtensions(1,W.profileLocation)).filter(U=>W.extensions.some(X=>(0,i.areSameExtensions)(X,U.identifier)));this.m.fire(R.map(U=>(this.v.info("Extensions added from another source",U.identifier.id,W.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:W.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(x=>this.lb.add(x)));const W=await this.cb.resolve(this.Z.userExtensionsLocation);for(const x of W.children??[])x.isDirectory&&this.lb.add(x.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(x=>this.nb(x)))}async nb(W){if(!W.affects(this.Z.userExtensionsLocation,1))return;const x=[];for(const N of W.rawAdded){if(this.lb.has(N)||!this.db.extUri.isEqual(this.db.extUri.dirname(N),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(N,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(N).startsWith(".")||!(await this.cb.stat(N)).isDirectory)continue;const R=await this.S.scanUserExtensionAtLocation(N);R&&R.installedTimestamp===void 0&&(this.lb.add(N),x.push(R))}x.length&&(await this.ob(x.map(N=>[N,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",x.map(N=>N.identifier.id)))}async ob(W,x){const N=W.map(R=>R[0]);await this.pb(N),await this.ab.addExtensionsToProfile(W,x),this.m.fire(N.map(R=>({local:R,identifier:R.identifier,operation:1,profileLocation:x})))}async pb(W){const x=await this.S.getUninstalledExtensions();for(const N of W){const R=i.ExtensionKey.create(N);x[R.toString()]&&(this.v.trace("Removing the extension from uninstalled list:",R.id),await this.S.setInstalled(R),this.v.info("Removed the extension from uninstalled list:",R.id))}}};e.ExtensionManagementService=ee=Le([Re(0,r.IExtensionGalleryService),Re(1,ue.ITelemetryService),Re(2,ce.ILogService),Re(3,t.INativeEnvironmentService),Re(4,l.IExtensionsScannerService),Re(5,a.IExtensionsProfileScannerService),Re(6,O.IDownloadService),Re(7,te.IInstantiationService),Re(8,H.IFileService),Re(9,le.IProductService),Re(10,ve.IUriIdentityService),Re(11,K.IUserDataProfilesService)],ee);let z=e.ExtensionsScanner=class extends v.Disposable{constructor(W,x,N,R,U,X){super(),this.k=W,this.l=x,this.m=N,this.n=R,this.p=U,this.s=X,this.h=this.B(new A.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,d.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new w.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(W,x){const N={includeInvalid:!0,profileLocation:x};let R=[];return W===null||W===0?R.push(...await this.m.scanAllExtensions({includeInvalid:!0},N,!1)):W===1&&R.push(...await this.m.scanUserExtensions(N)),R=W!==null?R.filter(U=>U.type===W):R,Promise.all(R.map(U=>this.y(U)))}async scanAllUserExtensions(W){const x=await this.m.scanUserExtensions({includeAllVersions:!W,includeInvalid:!0});return Promise.all(x.map(N=>this.y(N)))}async scanUserExtensionAtLocation(W){try{const x=await this.m.scanExistingExtension(W,1,{includeInvalid:!0});if(x)return await this.y(x)}catch(x){this.s.error(x)}return null}async extractUserExtension(W,x,N,R){await this.j.catch(()=>{});const U=W.toString(),X=y.join(this.m.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`),ie=y.join(this.m.userExtensionsLocation.fsPath,U);try{await u.Promises.rm(ie)}catch{throw new r.ExtensionManagementError(I.localize(4,null,ie,W.id),r.ExtensionManagementErrorCode.Delete)}await this.u(W,x,X,R),await this.m.updateMetadata(s.URI.file(X),N);try{this.h.fire(s.URI.file(ie)),await this.v(W,X,ie,Date.now()+2*60*1e3),this.s.info("Renamed to",ie)}catch(j){try{await u.Promises.rm(X)}catch{}if(j.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",W.id);else throw this.s.info(`Rename failed because of ${(0,C.getErrorMessage)(j)}. Deleted from extracted location`,X),j}return this.w(s.URI.file(ie),1)}async scanMetadata(W,x){return x?(await this.n.scanProfileExtensions(x)).find(R=>(0,i.areSameExtensions)(R.identifier,W.identifier))?.metadata:this.m.scanMetadata(W.location)}async updateMetadata(W,x,N){return N?await this.n.updateMetadata([[W,x]],N):await this.m.updateMetadata(W.location,x),this.w(W.location,W.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...W){const x=W.map(N=>i.ExtensionKey.create(N));await this.t(N=>x.forEach(R=>{N[R.toString()]=!0,this.s.info("Marked extension as uninstalled",R.toString())}))}async setInstalled(W){await this.t(x=>delete x[W.toString()])}async removeExtension(W,x){this.s.trace(`Deleting ${x} extension from disk`,W.identifier.id,W.location.fsPath);const N=this.p.extUri.joinPath(this.p.extUri.dirname(W.location),`.${(0,h.generateUuid)()}`);await this.v(W.identifier,W.location.fsPath,N.fsPath,Date.now()+2*60*1e3),await this.l.del(N,{recursive:!0}),this.s.info("Deleted from disk",W.identifier.id,W.location.fsPath)}async removeUninstalledExtension(W){await this.removeExtension(W,"uninstalled"),await this.t(x=>delete x[i.ExtensionKey.create(W).toString()])}async copyExtensions(W,x){const N=await this.scanExtensions(1,W),R=await Promise.all(N.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,W)]));await this.n.addExtensionsToProfile(R,x)}async t(W){return this.g.queue(async()=>{let x;try{x=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(R){if((0,H.toFileOperationResult)(R)!==1)throw R}let N={};if(x)try{N=JSON.parse(x)}catch{}return W&&(W(N),Object.keys(N).length?await this.l.writeFile(this.c,L.VSBuffer.fromString(JSON.stringify(N))):await this.l.del(this.c)),N})}async u(W,x,N,R){this.s.trace(`Started extracting the extension from ${x} to ${N}`);try{await u.Promises.rm(N)}catch(U){throw new r.ExtensionManagementError(this.D(U).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,f.extract)(x,N,{sourcePath:"extension",overwrite:!0},R),this.s.info(`Extracted extension to ${N}:`,W.id)}catch(U){try{await u.Promises.rm(N)}catch{}let X=r.ExtensionManagementErrorCode.Extract;throw U instanceof f.ExtractError&&(U.type==="CorruptZip"?X=r.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&(X=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(U.message,X)}}async v(W,x,N,R){try{await u.Promises.rename(x,N)}catch(U){if(E.isWindows&&U&&U.code==="EPERM"&&Date.now()<R)return this.s.info(`Failed renaming ${x} to ${N} with 'EPERM' error. Trying again...`,W.id),this.v(W,x,N,R);throw new r.ExtensionManagementError(U.message||I.localize(5,null,x,N),U.code||r.ExtensionManagementErrorCode.Rename)}}async w(W,x){const N=await this.m.scanExistingExtension(W,x,{includeInvalid:!0});if(N)return this.y(N);throw new Error(I.localize(6,null,W.path))}async y(W){const x=await this.l.resolve(W.location);let N,R;return x.children&&(N=x.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,R=x.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:W.identifier,type:W.type,isBuiltin:W.isBuiltin||!!W.metadata?.isBuiltin,location:W.location,manifest:W.manifest,targetPlatform:W.targetPlatform,validations:W.validations,isValid:W.isValid,readmeUrl:N,changelogUrl:R,publisherDisplayName:W.metadata?.publisherDisplayName||null,publisherId:W.metadata?.publisherId||null,isApplicationScoped:!!W.metadata?.isApplicationScoped,isMachineScoped:!!W.metadata?.isMachineScoped,isPreReleaseVersion:!!W.metadata?.isPreReleaseVersion,preRelease:!!W.metadata?.preRelease,installedTimestamp:W.metadata?.installedTimestamp,updated:!!W.metadata?.updated,pinned:!!W.metadata?.pinned}}async z(){const W=await this.getUninstalledExtensions();if(Object.keys(W).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys(W));const x=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=new Set;for(const U of x)W[i.ExtensionKey.create(U).toString()]||N.add(U.identifier.id.toLowerCase());try{const U=(0,i.groupByExtension)(x,X=>X.identifier);await w.Promises.settled(U.map(async X=>{const ie=X.sort((j,$)=>p.rcompare(j.manifest.version,$.manifest.version))[0];N.has(ie.identifier.id.toLowerCase())||await this.k(await this.y(ie))}))}catch(U){this.s.error(U)}const R=x.filter(U=>U.metadata&&W[i.ExtensionKey.create(U).toString()]);await Promise.allSettled(R.map(U=>this.removeUninstalledExtension(U)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const W=[];let x;try{x=await this.l.resolve(this.m.userExtensionsLocation)}catch(N){(0,H.toFileOperationResult)(N)!==1&&this.s.error(N)}for(const N of x?.children??[])N.isDirectory&&N.name.startsWith(".")&&(0,h.isUUID)(N.name.substring(1))&&W.push((async()=>{this.s.trace("Deleting the generated extension folder",N.resource.toString());try{await this.l.del(N.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",N.resource.toString())}catch(R){this.s.error(R)}})());await Promise.allSettled(W)}D(W){const x=Array.isArray(W)?W:[W];return x.length===1?x[0]instanceof Error?x[0]:new Error(x[0]):x.reduce((N,R)=>new Error(`${N.message}${N.message?",":""}${R instanceof Error?R.message:R}`),new Error(""))}};e.ExtensionsScanner=z=Le([Re(1,H.IFileService),Re(2,l.IExtensionsScannerService),Re(3,a.IExtensionsProfileScannerService),Re(4,ve.IUriIdentityService),Re(5,ce.ILogService)],z);class q extends n.AbstractExtensionTask{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,b.isUndefined)(this.m.operation)?this.l:this.m.operation}constructor(W,x,N,R,U,X,ie,j,$){super(),this.identifier=W,this.source=x,this.m=N,this.n=R,this.o=U,this.p=X,this.q=ie,this.s=j,this.t=$,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(W){const[x,N]=await this.y(W);return this.j=x.isBuiltin||x.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[x,N]],this.j),x}async v({zipPath:W,key:x,metadata:N},R){let U=await this.w(x);return U||(this.t.trace("Extracting extension...",x.id),U=await this.n.extractUserExtension(x,W,N,R),this.t.info("Extracting extension completed.",x.id)),U}async w(W){return await this.x(W)?(this.t.trace("Removing the extension from uninstalled list:",W.id),await this.n.setInstalled(W),this.t.info("Removed the extension from uninstalled list:",W.id),(await this.n.scanAllUserExtensions(!0)).find(R=>i.ExtensionKey.create(R).equals(W))):void 0}async x(W){return!!(await this.n.getUninstalledExtensions())[W.toString()]}}class G extends q{constructor(W,x,N,R,U,X,ie,j,$,J){super(x.identifier,x,N,U,X,ie,j,$,J),this.z=x,this.A=R}async y(W){const N=(await this.n.scanExtensions(null,this.m.profileLocation)).find(ie=>(0,i.areSameExtensions)(ie.identifier,this.z.identifier));N&&(this.l=3);const R={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||N?.isMachineScoped,isBuiltin:this.m.isBuiltin||N?.isBuiltin,isSystem:N?.type===0?!0:void 0,updated:!!N,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,b.isBoolean)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:N?.preRelease)};if(N?.manifest.version===this.z.version)return[await this.n.updateMetadata(N,R),R];const{location:U,verificationStatus:X}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=X,this.C(U.fsPath),[await this.v({zipPath:U.fsPath,key:i.ExtensionKey.create(this.z),metadata:R},W),R]}catch(ie){try{await this.A.delete(U)}catch(j){this.t.warn("Error while deleting the downloaded file",U.toString(),(0,C.getErrorMessage)(j))}throw ie}}async C(W){try{await(0,D.getManifest)(W)}catch(x){throw new r.ExtensionManagementError((0,n.joinErrors)(x).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=G;class ne extends q{constructor(W,x,N,R,U,X,ie,j,$,J){super({id:(0,i.getGalleryExtensionId)(W.publisher,W.name)},x,N,U,X,ie,j,$,J),this.z=W,this.A=x,this.B=R}async h(W){const x=await super.h(W);return this.E(x,W),x}async y(W){const x=new i.ExtensionKey(this.identifier,this.z.version),R=(await this.n.scanExtensions(1,this.m.profileLocation)).find(ie=>(0,i.areSameExtensions)(this.identifier,ie.identifier)),U={isApplicationScoped:this.m.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||R?.isMachineScoped,isBuiltin:this.m.isBuiltin||R?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(R)if(this.l=3,x.equals(new i.ExtensionKey(R.identifier,R.manifest.version)))try{await this.n.removeExtension(R,"existing")}catch{throw new Error(I.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&p.gt(R.manifest.version,this.z.version)&&await this.n.setUninstalled(R);else{const ie=await this.w(x);if(ie)try{await this.n.removeExtension(ie,"existing")}catch{throw new Error(I.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:y.resolve(this.A.fsPath),key:x,metadata:U},W),U]}async E(W,x){try{let[N]=await this.B.getExtensions([{id:W.identifier.id,version:W.manifest.version}],x);if(N||([N]=await this.B.getExtensions([{id:W.identifier.id}],x)),N){const R={id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(W,R,this.m.profileLocation)}}catch{}}}class se extends n.AbstractExtensionTask{constructor(W,x,N){super(),this.extension=W,this.j=x,this.k=N}async h(W){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ge[70],pe([1,0,85,74,28,285,15,11,6,2,7,3,22,42,104]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class b{traceSocketEvent(k,S){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,S)}constructor(k,S=""){this.f=!0,this.debugLabel=S,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=F=>{if(this.traceSocketEvent("error",{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,A.onUnexpectedError)(F)}},this.socket.on("error",this.a),this.b=F=>{this.traceSocketEvent("close",{hadError:F}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const S=F=>{this.traceSocketEvent("read",F),k(C.VSBuffer.wrap(F))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(k){const S=F=>{k({type:0,hadError:F,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(k){const S=()=>{k()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,A.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,A.onUnexpectedError)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=b;var s;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(s||(s={}));var h;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(h||(h={}));class u extends m.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,S){this.socket.traceSocketEvent(k,S)}constructor(k,S,F,H){super(),this.f=this.B(new v.Emitter),this.g=this.B(new v.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:F?.byteLength||0,recordInflateBytes:H}),this.a=this.B(new f(this,S,F,H,this.f,(te,ce)=>this.k(te,ce))),this.B(this.a.onError(te=>{console.error(te),(0,A.onUnexpectedError)(te),this.g.fire({type:0,hadError:!0,error:te})})),this.b=new p.ChunkStream,this.B(this.socket.onData(te=>this.l(te))),this.B(this.socket.onClose(async te=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(te)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let S=0;for(;S<k.byteLength;)this.a.writeMessage(k.slice(S,Math.min(S+262144,k.byteLength))),S+=262144}k(k,S){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let F=2;k.byteLength<126?F+=0:k.byteLength<2**16?F+=2:F+=8;const H=C.VSBuffer.alloc(F);if(S?H.writeUInt8(194,0):H.writeUInt8(130,0),k.byteLength<126)H.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){H.writeUInt8(126,1);let te=1;H.writeUInt8(k.byteLength>>>8&255,++te),H.writeUInt8(k.byteLength>>>0&255,++te)}else{H.writeUInt8(127,1);let te=1;H.writeUInt8(0,++te),H.writeUInt8(0,++te),H.writeUInt8(0,++te),H.writeUInt8(0,++te),H.writeUInt8(k.byteLength>>>24&255,++te),H.writeUInt8(k.byteLength>>>16&255,++te),H.writeUInt8(k.byteLength>>>8&255,++te),H.writeUInt8(k.byteLength>>>0&255,++te)}this.socket.write(C.VSBuffer.concat([H,k]))}end(){this.h=!0,this.socket.end()}l(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),F=S.readUInt8(0),H=(F&128)>>>7,te=(F&64)>>>6,ce=S.readUInt8(1),le=(ce&128)>>>7,ue=ce&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(ue===126?2:0)+(ue===127?8:0),this.j.fin=H,this.j.firstFrameOfMessage&&(this.j.compressed=!!te),this.j.firstFrameOfMessage=!!H,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),F=S.readUInt8(1),H=(F&128)>>>7;let te=F&127,ce=1;te===126?te=S.readUInt8(++ce)*2**8+S.readUInt8(++ce):te===127&&(te=S.readUInt8(++ce)*0+S.readUInt8(++ce)*0+S.readUInt8(++ce)*0+S.readUInt8(++ce)*0+S.readUInt8(++ce)*2**24+S.readUInt8(++ce)*2**16+S.readUInt8(++ce)*2**8+S.readUInt8(++ce));let le=0;H&&(le=S.readUInt8(++ce)*2**24+S.readUInt8(++ce)*2**16+S.readUInt8(++ce)*2**8+S.readUInt8(++ce)),this.j.state=3,this.j.readLen=te,this.j.mask=le,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),t(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(S,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=u;class f extends m.Disposable{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.VSBuffer.alloc(0)}constructor(k,S,F,H,te,ce){super(),this.l=k,this.m=te,this.n=ce,this.a=this.B(new v.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new v.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,S?(this.b=this.B(new I(this.l,H,F,{windowBits:15})),this.f=this.B(new O(this.l,{windowBits:15})),this.B(this.b.onError(le=>this.a.fire(le))),this.B(this.f.onError(le=>this.a.fire(le)))):(this.b=null,this.f=null)}writeMessage(k){this.g.push(k),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const k=this.g.shift();if(this.f){const S=await this.s(this.f,k);this.n(S,!0)}else this.n(k,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(k,S){return new Promise((F,H)=>{k.write(S),k.flush(te=>F(te))})}acceptFrame(k,S,F){this.h.push({data:k,isCompressed:S,isLastFrameOfMessage:F}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const S=await this.w(this.b,k.data,k.isLastFrameOfMessage);this.m.fire(S)}else this.m.fire(k.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(k,S,F){return new Promise((H,te)=>{k.write(S),F&&k.write(C.VSBuffer.fromByteArray([0,0,255,255])),k.flush(ce=>H(ce))})}}class I extends m.Disposable{get recordedInflateBytes(){return this.j?C.VSBuffer.concat(this.f):C.VSBuffer.alloc(0)}constructor(k,S,F,H){super(),this.h=k,this.j=S,this.a=this.B(new v.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(H),this.b.on("error",te=>{this.h.traceSocketEvent("zlibInflateError",{message:te?.message,code:te?.code}),this.a.fire(te)}),this.b.on("data",te=>{this.h.traceSocketEvent("zlibInflateData",te),this.g.push(C.VSBuffer.wrap(te))}),F&&(this.h.traceSocketEvent("zlibInflateInitialWrite",F.buffer),this.b.write(F.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=C.VSBuffer.concat(this.g);this.g.length=0,k(S)})}}class O extends m.Disposable{constructor(k,S){super(),this.g=k,this.a=this.B(new v.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",F=>{this.g.traceSocketEvent("zlibDeflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.g.traceSocketEvent("zlibDeflateData",F),this.f.push(C.VSBuffer.wrap(F))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=C.VSBuffer.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),k(S)})}}function t(D,k){if(k===0)return;const S=D.byteLength>>>2;for(let ue=0;ue<S;ue++){const ve=D.readUInt32BE(ue*4);D.writeUInt32BE(ve^k,ue*4)}const F=S*4,H=D.byteLength-F,te=k>>>24&255,ce=k>>>16&255,le=k>>>8&255;H>=1&&D.writeUInt8(D.readUInt8(F)^te,F),H>=2&&D.writeUInt8(D.readUInt8(F+1)^ce,F+1),H>=3&&D.writeUInt8(D.readUInt8(F+2)^le,F+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function r(){const D=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const k=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,o.tmpdir)(),S=(0,T.join)(k,`vscode-ipc-${D}.sock`);return a(S),S}e.createRandomIPCHandle=r;function i(D,k,S){const F=(0,w.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${S}-${k}-sock`;const H=S.substr(0,4),te=k.substr(0,6),ce=F.substr(0,8);let le;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?le=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${ce}-${H}-${te}.sock`):le=(0,T.join)(D,`${H}-${te}.sock`),a(le),le}e.createStaticIPCHandle=i;function a(D){const k=n[y.platform];typeof k=="number"&&D.length>=k&&console.warn(`WARNING: IPC handle "${D}" is longer than ${k} chars, try a shorter --user-data-dir`)}class l extends d.IPCServer{static b(k){const S=v.Event.fromNodeEventEmitter(k,"connection");return v.Event.map(S,F=>({protocol:new p.Protocol(new b(F,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(F,"close"))}))}constructor(k){super(l.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=l;function c(D){return new Promise((k,S)=>{const F=(0,L.createServer)();F.on("error",S),F.listen(D,()=>{F.removeListener("error",S),k(new l(F))})})}e.serve=c;function g(D,k){return new Promise((S,F)=>{const H=(0,L.createConnection)(D,()=>{H.removeListener("error",F),S(p.Client.fromSocket(new b(H,`ipc-client${k}`),k))});H.once("error",F)})}e.connect=g}),define(ge[138],pe([1,0,83,14,15,11,8,24,25,84,12,43,235,285]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let p=e.RequestService=class extends y.AbstractRequestService{constructor(u,f,I,O){super(!!f.isRemoteServer,O),this.j=u,this.k=f,this.l=I,this.m(),this.B(u.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const u=this.j.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,f){const{f:I,g:O}=this;let t;try{t=await(0,m.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,P.getErrorMessage)(i)))}const n={...process.env,...t},r=u.agent?u.agent:await(0,E.getProxyAgent)(u.url||"",n,{proxyUrl:I,strictSSL:O});return u.agent=r,u.strictSSL=O,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.c(u.isChromiumNetwork?"electron":"node",u,()=>s(u,f))}async resolveProxy(u){}};e.RequestService=p=Le([Re(0,A.IConfigurationService),Re(1,v.INativeEnvironmentService),Re(2,T.ILogService),Re(3,T.ILoggerService)],p);async function b(h){return((0,w.parse)(h.url).protocol==="https:"?await new Promise((I,O)=>{oe(["https"],I,O)}):await new Promise((I,O)=>{oe(["http"],I,O)})).request}async function s(h,u){return L.Promises.withAsyncBody(async(f,I)=>{const O=(0,w.parse)(h.url),t=h.getRawRequest?h.getRawRequest(h):await b(h),n={hostname:O.hostname,port:O.port?parseInt(O.port):O.protocol==="https:"?443:80,protocol:O.protocol,path:O.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,C.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(n.auth=h.user+":"+h.password);const r=t(n,i=>{const a=(0,C.isNumber)(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&a>0&&i.headers.location)s({...h,url:i.headers.location,followRedirects:a-1},u).then(f,I);else{let l=i;!h.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,d.createGunzip)())),f({res:i,stream:(0,o.streamToBufferReadableStream)(l)})}});r.on("error",I),h.timeout&&r.setTimeout(h.timeout),h.isChromiumNetwork&&r.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&r.write(h.data),r.end(),u.onCancellationRequested(()=>{r.abort(),I(new P.CancellationError)})})}e.nodeRequest=s}),define(ge[139],pe([1,0,51,74,127,13,7,15,6,70,84,12,45,3,58,126,2,273,24]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function f(i={},a,l,c,g,D){const k=await(0,o.getNLSConfiguration)(l,c.userDataPath);let S={};if(a)try{S=await(0,T.getResolvedShellEnv)(D,g,c.args,process.env)}catch(ue){g.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ue)}const H={...process.env,...S,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(k,void 0,0),...i},te=c.isBuilt?(0,C.join)(c.appRoot,"bin"):(0,C.join)(c.appRoot,"resources","server","bin-dev"),ce=(0,C.join)(te,"remote-cli");let le=t(H,"PATH");return le?le=ce+C.delimiter+le:le=ce,n(H,"PATH",le),c.args["without-browser-env-var"]||(H.BROWSER=(0,C.join)(te,"helpers",d.isWindows?"browser.cmd":"browser.sh")),r(H),H}e.buildUserEnvironment=f;class I{constructor(a,l){this.socket=a,this.initialDataChunk=l}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let a,l,c;return this.socket instanceof m.NodeSocket?(a=!0,l=!1,c=A.VSBuffer.alloc(0)):(a=!1,l=this.socket.permessageDeflate,c=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:a,permessageDeflate:l,inflateBytes:c.buffer.toString("base64")}}}let O=e.ExtensionHostConnection=class{constructor(a,l,c,g,D,k,S,F){this.i=a,this.j=D,this.l=k,this.m=S,this.n=F,this.b=new v.Emitter,this.onClose=this.b.event,this.c=!d.isWindows||!this.j.args["socket-path"],this.d=!1,this.f=l,this.g=null,this.h=new I(c,g),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(a){this.l.info(`${this.o}${a}`)}q(a){this.l.error(`${this.o}${a}`)}async r(a,l){const c=new s.DisposableStore;c.add(l.socket),c.add((0,s.toDisposable)(()=>{a.destroy()}));const g=()=>{c.dispose()};c.add(l.socket.onEnd(g)),c.add(l.socket.onClose(g)),c.add(v.Event.fromNodeEventEmitter(a,"end")(g)),c.add(v.Event.fromNodeEventEmitter(a,"close")(g)),c.add(v.Event.fromNodeEventEmitter(a,"error")(g)),c.add(l.socket.onData(D=>a.write(D.buffer))),c.add(v.Event.fromNodeEventEmitter(a,"data")(D=>{l.socket.write(A.VSBuffer.wrap(D))})),l.initialDataChunk.byteLength>0&&a.write(l.initialDataChunk.buffer)}async s(a,l){await l.socketDrain();const c=l.toIExtHostSocketMessage();let g;l.socket instanceof m.NodeSocket?g=l.socket.socket:g=l.socket.socket.socket,a.send(c,g)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const a={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(a)}acceptReconnection(a,l,c){this.f=a,this.p("The client has reconnected.");const g=new I(l,c);if(!this.g){this.h=g;return}this.s(this.g,g)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(a){try{let l=process.execArgv?process.execArgv.filter(ce=>!/^--inspect(-brk)?=/.test(ce)):[];a.port&&!process.pkg&&(l=[`--inspect${a.break?"-brk":""}=${a.port}`]);const c=await f(a.env,!0,a.language,this.j,this.l,this.n);(0,p.removeDangerousEnvVariables)(c);let g;if(this.c)(0,h.writeExtHostConnection)(new h.SocketExtHostConnection,c),g=null;else{const{namedPipeServer:ce,pipeName:le}=await this.u();(0,h.writeExtHostConnection)(new h.IPCExtHostConnection(le),c),g=ce}const D={env:c,execArgv:l,silent:!0},k=["--type=extensionHost","--transformURIs"],S=this.j.args["use-host-proxy"];k.push(`--useHostProxy=${S?"true":"false"}`),this.g=w.fork(P.FileAccess.asFileUri("bootstrap-fork").fsPath,k,D);const F=this.g.pid;this.p(`<${F}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const H=v.Event.fromNodeEventEmitter(this.g.stdout,"data"),te=v.Event.fromNodeEventEmitter(this.g.stderr,"data");if(H(ce=>this.p(`<${F}> ${ce}`)),te(ce=>this.p(`<${F}><stderr> ${ce}`)),this.g.on("error",ce=>{this.q(`<${F}> Extension Host Process had an error`),this.l.error(ce),this.t()}),this.g.on("exit",(ce,le)=>{this.m.setExitInfo(this.i,{code:ce,signal:le}),this.p(`<${F}> Extension Host Process exited with code: ${ce}, signal: ${le}.`),this.t()}),g)g.on("connection",ce=>{g.close(),this.r(ce,this.h)});else{const ce=le=>{le.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",ce),this.s(this.g,this.h),this.h=null)};this.g.on("message",ce)}}catch(l){console.error("ExtensionHostConnection errored"),l&&console.error(l)}}u(){return new Promise((a,l)=>{const c=(0,m.createRandomIPCHandle)(),g=L.createServer();g.on("error",l),g.listen(c,()=>{g?.removeListener("error",l),a({pipeName:c,namedPipeServer:g})})})}};e.ExtensionHostConnection=O=Le([Re(4,E.IServerEnvironmentService),Re(5,y.ILogService),Re(6,b.IExtensionHostStatusService),Re(7,u.IConfigurationService)],O);function t(i,a){const l=Object.keys(i).filter(g=>g.toLowerCase()===a.toLowerCase()),c=l.length>0?l[0]:a;return i[c]}function n(i,a,l){const c=Object.keys(i).filter(D=>D.toLowerCase()===a.toLowerCase()),g=c.length>0?c[0]:a;i[g]=l}function r(i){for(const a of Object.keys(i))i[a]===null&&delete i[a]}}),define(ge[286],pe([1,0,81,12,63,114,24,43,138,37,31,30,124,137,80,108,53,2,109,66,13,16,26,45,117,82,118,11,4,7,29,233,79,35,122,62,3,56,128,32,44,67,125,123,111,112,195,103]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u,f,I,O,t,n,r,i,a,l,c,g,D,k,S,F,H,te,ce,le,ue,ve,K,ee,z,q,G,ne,se,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class W extends h.Disposable{constructor(U,X){super(),this.a=U,this.b=X,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const U=await this.f();await U.invokeFunction(async X=>{const ie=X.get(C.IConfigurationService),j=X.get(L.ILogService);process.platform==="win32"&&(0,de.setUNCHostAllowlist)((0,de.toUNCHostAllowlist)(ie.getValue("security.allowedUNCHosts")));try{await this.g(U.createInstance(r.ExtensionManagementCLI,new L.ConsoleLogger(j.getLevel(),!1)))}catch($){throw j.error($),console.error((0,l.getErrorMessage)($)),$}})}async f(){const U=new w.ServiceCollection,X={_serviceBrand:void 0,...s.default};U.set(t.IProductService,X);const ie=new n.ServerEnvironmentService(this.a,X);U.set(n.IServerEnvironmentService,ie);const j=new ne.LoggerService((0,L.getLogLevel)(ie),ie.logsHome);U.set(L.ILoggerService,j);const $=new G.LogService(this.B(j.createLogger("remoteCLI",{name:(0,se.localize)(0,null)})));U.set(L.ILogService,$),$.trace(`Remote configuration data at ${this.b}`),$.trace("process arguments:",this.a);const J=this.B(new u.FileService($));U.set(O.IFileService,J),J.registerProvider(I.Schemas.file,this.B(new f.DiskFileSystemProvider($)));const V=new H.UriIdentityService(J);U.set(F.IUriIdentityService,V);const Z=this.B(new z.ServerUserDataProfilesService(V,ie,J,$));U.set(ve.IUserDataProfilesService,Z);const Y=this.B(new P.ConfigurationService(Z.defaultProfile.settingsResource,J,new ee.NullPolicyService,$));return U.set(C.IConfigurationService,Y),await Promise.all([Y.initialize(),Z.init()]),U.set(A.IRequestService,new o.SyncDescriptor(v.RequestService)),U.set(S.IDownloadService,new o.SyncDescriptor(k.DownloadService)),U.set(T.ITelemetryService,m.NullTelemetryService),U.set(y.IExtensionGalleryService,new o.SyncDescriptor(E.ExtensionGalleryServiceWithNoStorageService)),U.set(K.IExtensionsProfileScannerService,new o.SyncDescriptor(q.ExtensionsProfileScannerService)),U.set(le.IExtensionsScannerService,new o.SyncDescriptor(ue.ExtensionsScannerService)),U.set(p.IExtensionSignatureVerificationService,new o.SyncDescriptor(p.ExtensionSignatureVerificationService)),U.set(d.INativeServerExtensionManagementService,new o.SyncDescriptor(d.ExtensionManagementService)),U.set(i.ILanguagePackService,new o.SyncDescriptor(a.NativeLanguagePackService)),new b.InstantiationService(U)}async g(U){if(this.a["list-extensions"])return U.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const X={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return U.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),X,!!this.a.force)}else{if(this.a["uninstall-extension"])return U.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return U.locateExtension(this.a["locate-extension"])}}h(U){return U.map(X=>/\.vsix$/i.test(X)?c.URI.file((0,g.isAbsolute)(X)?X:(0,g.join)((0,D.cwd)(),X)):X)}}function x(R){setTimeout(()=>process.exit(R),0)}async function N(R,U,X){if(R.help){const j=s.default.serverApplicationName+(ce.isWindows?".cmd":"");console.log((0,te.buildHelpMessage)(s.default.nameLong,j,s.default.version,X,{noInputFiles:!0,noPipe:!0}));return}if(R.version){console.log((0,te.buildVersionMessage)(s.default.version,s.default.commit));return}const ie=new W(R,U);try{await ie.run(),x(0)}catch{x(1)}finally{ie.dispose()}}e.run=N}),define(ge[287],pe([1,0,70,299,33,281,4,12,87]),function(oe,e,w,L,o,P,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class m{constructor(E,d,p){this.b=E,this.c=d,this.f=p,this.a=L.createServer((b,s)=>this.h(b,s)),this.g().catch(b=>(d.error(b),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",E=>this.c.error(E))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(E,d){const p=(s,h)=>{d.writeHead(s,{"content-type":"application/json"}),d.end(JSON.stringify(h||null),u=>u&&this.c.error(u))},b=[];E.setEncoding("utf8"),E.on("data",s=>b.push(s)),E.on("end",async()=>{try{const s=JSON.parse(b.join(""));let h;switch(s.type){case"open":h=await this.i(s);break;case"openExternal":h=await this.j(s);break;case"status":h=await this.l(s);break;case"extensionManagement":h=await this.k(s);break;default:p(404,`Unknown message type: ${s.type}`);break}p(200,h)}catch(s){const h=s instanceof Error?s.message:JSON.stringify(s);p(500,h),this.c.error("Error while processing pipe request",s)}})}async i(E){const{fileURIs:d,folderURIs:p,forceNewWindow:b,diffMode:s,mergeMode:h,addMode:u,forceReuseWindow:f,gotoLineMode:I,waitMarkerFilePath:O,remoteAuthority:t}=E,n=[];if(Array.isArray(p))for(const l of p)try{n.push({folderUri:C.URI.parse(l)})}catch{}if(Array.isArray(d))for(const l of d)try{(0,v.hasWorkspaceFileExtension)(l)?n.push({workspaceUri:C.URI.parse(l)}):n.push({fileUri:C.URI.parse(l)})}catch{}const r=O?C.URI.file(O):void 0,a={forceNewWindow:b,diffMode:s,mergeMode:h,addMode:u,gotoLineMode:I,forceReuseWindow:f,preferNewWindow:!f&&!r&&!u,waitMarkerFileURI:r,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",n,a),""}async j(E){for(const d of E.uris){const p=C.URI.parse(d),b=p.scheme==="file"?p:d;await this.b.executeCommand("_remoteCLI.openExternal",b)}}async k(E){const d=b=>b?.map(s=>/\.vsix$/i.test(s)?C.URI.parse(s):s),p={list:E.list,install:d(E.install),uninstall:d(E.uninstall),force:E.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",p)}async l(E){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&o.existsSync(this.f)&&o.unlinkSync(this.f)}}e.CLIServerBase=m;let T=e.CLIServer=class extends m{constructor(E,d){super(E,d,(0,w.createRandomIPCHandle)())}};e.CLIServer=T=Le([Re(0,P.IExtHostCommands),Re(1,A.ILogService)],T)}),define(ge[288],pe([1,0,28,6,21,2,7,3,4,70,68,287,120,86,268,270,139,8]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class u extends b.AbstractVariableResolverService{constructor(O,t,n,r,i){super({getFolderUri:a=>{const l=t.filter(c=>c.name===a);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.length,getConfigurationValue:(a,l)=>r[`config:${l}`],getExecPath:()=>O.VSCODE_EXEC_PATH,getAppRoot:()=>O.VSCODE_CWD,getFilePath:()=>{if(n)return C.normalize(n.fsPath)},getSelectedText:()=>r.selectedText,getLineNumber:()=>r.lineNumber,getExtension:async a=>{const c=(await i.getInstalled()).find(g=>g.identifier.id===a);return c&&{extensionLocation:c.location}}},void 0,Promise.resolve(w.homedir()),Promise.resolve(O))}}class f extends P.Disposable{constructor(O,t,n,r,i,a){super(),this.g=O,this.h=t,this.i=n,this.j=r,this.l=i,this.m=a,this.a=0,this.b=new Map,this.c=this.B(new L.Emitter),this.onExecuteCommand=this.c.event}async call(O,t,n){switch(t){case"$restartPtyHost":return this.i.restartPtyHost?.apply(this.i,n);case"$createProcess":{const r=(0,T.createURITransformer)(O.remoteAuthority);return this.n(r,n)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,n);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,n);case"$listProcesses":return this.i.listProcesses.apply(this.i,n);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,n);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables?.apply(this.i,n);case"$start":return this.i.start.apply(this.i,n);case"$input":return this.i.input.apply(this.i,n);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,n);case"$shutdown":return this.i.shutdown.apply(this.i,n);case"$resize":return this.i.resize.apply(this.i,n);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,n);case"$getCwd":return this.i.getCwd.apply(this.i,n);case"$processBinary":return this.i.processBinary.apply(this.i,n);case"$sendCommandResult":return this.r(n[0],n[1],n[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,n);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,n);case"$getDefaultSystemShell":return this.s.apply(this,n);case"$getProfiles":return this.t.apply(this,n);case"$getEnvironment":return this.u();case"$getWslPath":return this.w(n[0],n[1]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(n);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(n);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,n);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,n);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,n);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,n);case"$reduceConnectionGraceTime":return this.y();case"$updateIcon":return this.i.updateIcon.apply(this.i,n);case"$updateTitle":return this.i.updateTitle.apply(this.i,n);case"$updateProperty":return this.i.updateProperty.apply(this.i,n);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,n);case"$requestDetachInstance":return this.i.requestDetachInstance(n[0],n[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(n[0],n[1]);case"$freePortKillProcess":return this.i.freePortKillProcess?.apply(this.i,n)}throw new Error(`IPC Command ${t} not found`)}listen(O,t,n){switch(t){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||L.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||L.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||L.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||L.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||L.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||L.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty;default:break}throw new Error("Not supported")}async n(O,t){const n={name:t.shellLaunchConfig.name,executable:t.shellLaunchConfig.executable,args:t.shellLaunchConfig.args,cwd:typeof t.shellLaunchConfig.cwd=="string"||typeof t.shellLaunchConfig.cwd>"u"?t.shellLaunchConfig.cwd:v.URI.revive(O.transformIncoming(t.shellLaunchConfig.cwd)),env:t.shellLaunchConfig.env,useShellEnvironment:t.shellLaunchConfig.useShellEnvironment,reconnectionProperties:t.shellLaunchConfig.reconnectionProperties,type:t.shellLaunchConfig.type,isFeatureTerminal:t.shellLaunchConfig.isFeatureTerminal},r=await(0,s.buildUserEnvironment)(t.resolverEnv,!!t.shellLaunchConfig.useShellEnvironment,A.language,this.g,this.h,this.m);this.h.trace("baseEnv",r);const i=ve=>({uri:v.URI.revive(O.transformIncoming(ve.uri)),name:ve.name,index:ve.index,toResource:()=>{throw new Error("Not implemented")}}),a=t.workspaceFolders.map(i),l=t.activeWorkspaceFolder?i(t.activeWorkspaceFolder):void 0,c=t.activeFileResource?v.URI.revive(O.transformIncoming(t.activeFileResource)):void 0,g=new u(r,a,c,t.resolvedVariables,this.l),D=p.createVariableResolver(l,process.env,g),k=await p.getCwd(n,w.homedir(),D,l?.uri,t.configuration["terminal.integrated.cwd"],this.h);n.cwd=k;const S=A.isWindows?"terminal.integrated.env.windows":A.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",F=t.configuration[S],H=await p.createTerminalEnvironment(n,F,D,this.j.version,t.configuration["terminal.integrated.detectLocale"],r);if(!n.strictEnv){const ve=[];for(const[q,G,ne]of t.envVariableCollections)ve.push([q,{map:(0,d.deserializeEnvironmentVariableCollection)(G),descriptionMap:(0,d.deserializeEnvironmentDescriptionMap)(ne)}]);const K=new Map(ve),ee=new E.MergedEnvironmentVariableCollection(K),z=l?(0,h.withNullAsUndefined)(l):void 0;await ee.applyToProcessEnvironment(H,{workspaceFolder:z},D)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:n,initialCwd:k,cols:t.cols,rows:t.rows,env:H});const te=(0,m.createRandomIPCHandle)();H.VSCODE_IPC_HOOK_CLI=te;const ce=await this.i.createProcess(n,k,t.cols,t.rows,t.unicodeVersion,H,r,t.options,t.shouldPersistTerminal,t.workspaceId,t.workspaceName),le={executeCommand:(ve,...K)=>this.p(ce,ve,K,O)},ue=new y.CLIServerBase(le,this.h,te);return this.i.onProcessExit(ve=>ve.id===ce&&ue.dispose()),{persistentTerminalId:ce,resolvedShellLaunchConfig:n}}p(O,t,n,r){let i,a;const l=new Promise((D,k)=>{i=D,a=k}),c=++this.a;this.b.set(c,{resolve:i,reject:a,uriTransformer:r});const g=(0,o.cloneAndChange)(n,D=>{if(D&&D.$mid===1)return r.transformOutgoing(D);if(D&&D instanceof v.URI)return r.transformOutgoingURI(D)});return this.c.fire({reqId:c,persistentProcessId:O,commandId:t,commandArgs:g}),l}r(O,t,n){const r=this.b.get(O);if(!r)return;this.b.delete(O);const i=(0,o.cloneAndChange)(n,a=>{if(a&&a.$mid===1)return r.uriTransformer.transformIncoming(a)});t?r.reject(i):r.resolve(i)}s(O){return this.i.getDefaultSystemShell(O)}async t(O,t,n,r){return this.i.getProfiles?.(O,t,n,r)||[]}u(){return{...process.env}}w(O,t){return this.i.getWslPath(O,t)}y(){return this.i.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=f}),define(ge[289],pe([1,0,28,6,2,13,7,99,23,42,24,114,78,227,203,79,204,213,222,25,124,30,80,117,214,137,16,109,66,63,108,81,82,118,12,53,26,43,234,138,116,31,37,247,121,254,35,122,265,266,239,245,288,68,45,272,282,126,56,128,44,32,67,246,112,125,123,111,110,197,279,230,258]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u,f,I,O,t,n,r,i,a,l,c,g,D,k,S,F,H,te,ce,le,ue,ve,K,ee,z,q,G,ne,se,de,W,x,N,R,U,X,ie,j,$,J,V,Z,Y,_,ae,Ee,Ce,ke,Ue,ze,me,Se,we,Oe,je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const _e="monacoworkbench";async function Ve(Te,Ae,Ne,$e){const We=new k.ServiceCollection,Ke=new it,et={_serviceBrand:void 0,...te.default};We.set(ce.IProductService,et);const qe=new ie.ServerEnvironmentService(Ae,et);We.set(f.IEnvironmentService,qe),We.set(f.INativeEnvironmentService,qe);const rt=new Ce.LoggerService((0,H.getLogLevel)(qe),qe.logsHome);We.set(H.ILoggerService,rt),Ke.registerChannel("logger",new me.LoggerChannel(rt,ot=>Xe(ot.remoteAuthority)));const ct=rt.createLogger("remoteagent",{name:(0,Se.localize)(0,null)}),st=new ze.LogService(ct,[new Je((0,H.getLogLevel)(qe))]);We.set(H.ILogService,st),setTimeout(()=>Ie(qe.logsHome.fsPath).then(null,ot=>st.error(ot)),1e4),st.onDidChangeLogLevel(ot=>(0,H.log)(st,ot,`Log level changed to ${(0,H.LogLevelToString)(st.getLevel())}`)),st.trace(`Remote configuration data at ${Ne}`),st.trace("process arguments:",qe.args),Array.isArray(et.serverGreeting)&&st.info(`

${et.serverGreeting.join(`
`)}

`),Ke.registerChannel(p.ExtensionHostDebugBroadcastChannel.ChannelName,new p.ExtensionHostDebugBroadcastChannel);const Et=new m.StaticRouter(ot=>ot.clientId==="renderer"),wt=$e.add(new l.FileService(st));We.set(a.IFileService,wt),wt.registerProvider(P.Schemas.file,$e.add(new c.DiskFileSystemProvider(st)));const Rt=new de.UriIdentityService(wt);We.set(se.IUriIdentityService,Rt);const gt=new y.ConfigurationService(qe.machineSettingsResource,wt,new ae.NullPolicyService,st);We.set(T.IConfigurationService,gt);const ut=new ke.ServerUserDataProfilesService(Rt,qe,wt,st);We.set(_.IUserDataProfilesService,ut),Ke.registerChannel("userDataProfiles",new je.RemoteUserDataProfilesServiceChannel(ut,ot=>Xe(ot.remoteAuthority)));const[,,yt]=await Promise.all([gt.initialize(),ut.init(),(0,A.getMachineId)(st.error.bind(st))]),Tt=new J.ExtensionHostStatusService;We.set(J.IExtensionHostStatusService,Tt),We.set(le.IRequestService,new g.SyncDescriptor(ve.RequestService));let Ct=z.NullAppender;const Lt=(0,z.isInternalTelemetry)(et,gt);if((0,z.supportsTelemetry)(et,qe)){et.aiConfig&&et.aiConfig.ariaKey&&(Ct=new Ee.OneDataSystemAppender(Lt,_e,null,et.aiConfig.ariaKey),$e.add((0,o.toDisposable)(()=>Ct?.flush())));const ot={appenders:[Ct],commonProperties:(0,K.resolveCommonProperties)((0,w.release)(),(0,w.hostname)(),process.arch,et.commit,et.version+"-remote",yt,Lt,"remoteAgent"),piiPaths:(0,z.getPiiPathsFromEnvironment)(qe)},ht=qe.args["telemetry-level"];let dt=3;ht==="all"?dt=3:ht==="error"?dt=2:ht==="crash"?dt=1:ht!==void 0&&(dt=0),We.set(R.IServerTelemetryService,new g.SyncDescriptor(R.ServerTelemetryService,[ot,dt]))}else We.set(R.IServerTelemetryService,R.ServerNullTelemetryService);We.set(O.IExtensionGalleryService,new g.SyncDescriptor(I.ExtensionGalleryServiceWithNoStorageService));const Ot=Ke.getChannel("download",Et);We.set(b.IDownloadService,new s.DownloadServiceChannelClient(Ot,()=>Xe("renderer"))),We.set(Y.IExtensionsProfileScannerService,new g.SyncDescriptor(Ue.ExtensionsProfileScannerService)),We.set(V.IExtensionsScannerService,new g.SyncDescriptor(Z.ExtensionsScannerService)),We.set(t.IExtensionSignatureVerificationService,new g.SyncDescriptor(t.ExtensionSignatureVerificationService)),We.set(i.INativeServerExtensionManagementService,new g.SyncDescriptor(i.ExtensionManagementService));const St=new D.InstantiationService(We);We.set(S.ILanguagePackService,St.createInstance(F.NativeLanguagePackService));const Pt=St.createInstance(ne.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:gt.getValue("terminal.integrated.persistentSessionScrollback")??100},!0);return We.set(G.IPtyService,Pt),We.set(h.IEncryptionMainService,new g.SyncDescriptor(u.EncryptionMainService,[yt])),We.set(E.ICredentialsMainService,new g.SyncDescriptor(d.CredentialsWebMainService)),St.invokeFunction(ot=>{const ht=ot.get(i.INativeServerExtensionManagementService),dt=ot.get(V.IExtensionsScannerService),ye=ot.get(O.IExtensionGalleryService),De=ot.get(S.ILanguagePackService),fe=new W.RemoteAgentEnvironmentChannel(Te,qe,ut,Tt);Ke.registerChannel("remoteextensionsenvironment",fe);const Q=new N.ServerTelemetryChannel(ot.get(R.IServerTelemetryService),Ct);Ke.registerChannel("telemetry",Q),Ke.registerChannel(j.REMOTE_TERMINAL_CHANNEL_NAME,new U.RemoteTerminalChannel(qe,st,Pt,et,ht,gt));const Pe=new we.RemoteExtensionsScannerService(St.createInstance(n.ExtensionManagementCLI,st),qe,ut,dt,st,ye,De);Ke.registerChannel(Oe.RemoteExtensionsScannerChannelName,new we.RemoteExtensionsScannerChannel(Pe,at=>Xe(at.remoteAuthority)));const Fe=new x.RemoteAgentFileSystemProviderChannel(st,qe);Ke.registerChannel($.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Fe),Ke.registerChannel("request",new ue.RequestChannel(ot.get(le.IRequestService)));const xe=new r.ExtensionManagementChannel(ht,at=>Xe(at.remoteAuthority));Ke.registerChannel("extensions",xe);const Me=m.ProxyChannel.fromService(ot.get(h.IEncryptionMainService));Ke.registerChannel("encryption",Me);const Qe=m.ProxyChannel.fromService(ot.get(E.ICredentialsMainService));return Ke.registerChannel("credentials",Qe),Pe.whenExtensionsReady().then(()=>ht.cleanUp()),$e.add(new q.default(ot.get(ee.ITelemetryService))),{telemetryService:ot.get(ee.ITelemetryService)}}),{socketServer:Ke,instantiationService:St}}e.setupServerServices=Ve;const Ye=Object.create(null);function Xe(Te){return Ye[Te]||(Ye[Te]=(0,X.createURITransformer)(Te)),Ye[Te]}class it extends m.IPCServer{constructor(){const Ae=new L.Emitter;super(Ae.event),this.b=Ae}acceptConnection(Ae,Ne){this.b.fire({protocol:Ae,onDidClientDisconnect:Ne})}}e.SocketServer=it;class Je extends H.AbstractLogger{constructor(Ae=H.DEFAULT_LOG_LEVEL){super(),this.setLevel(Ae),this.g=!!process.stdout.isTTY}trace(Ae,...Ne){this.f(H.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ge()}]\x1B[0m`,Ae,...Ne):console.log(`[${Ge()}]`,Ae,...Ne))}debug(Ae,...Ne){this.f(H.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ge()}]\x1B[0m`,Ae,...Ne):console.log(`[${Ge()}]`,Ae,...Ne))}info(Ae,...Ne){this.f(H.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ge()}]\x1B[0m`,Ae,...Ne):console.log(`[${Ge()}]`,Ae,...Ne))}warn(Ae,...Ne){this.f(H.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ge()}]\x1B[0m`,Ae,...Ne):console.warn(`[${Ge()}]`,Ae,...Ne))}error(Ae,...Ne){this.f(H.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ge()}]\x1B[0m`,Ae,...Ne):console.error(`[${Ge()}]`,Ae,...Ne))}dispose(){}flush(){}}function Ge(){const Te=new Date;return`${he(Te.getHours())}:${he(Te.getMinutes())}:${he(Te.getSeconds())}`}function he(Te){return Te<10?`0${Te}`:String(Te)}async function Ie(Te){const Ae=C.basename(Te),Ne=C.dirname(Te),Ke=(await v.Promises.readdir(Ne)).filter(qe=>/^\d{8}T\d{6}$/.test(qe)).sort().filter(qe=>qe!==Ae),et=Ke.slice(0,Math.max(0,Ke.length-9));await Promise.all(et.map(qe=>v.Promises.rm(C.join(Ne,qe))))}}),define(ge[290],pe([1,0,85,33,74,291,83,140,15,11,39,2,13,7,41,3,17,4,22,149,103,104,70,24,5,12,26,55,31,139,259,260,45,289,262]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E,d,p,b,s,h,u,f,I,O,t,n,r,i,a,l,c,g,D,k,S,F,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=void 0;const te=5*60*1e3;let ce=class extends y.Disposable{constructor(K,ee,z,q,G,ne,se,de){super(),this.k=K,this.l=ee,this.m=z,this.n=G,this.p=ne,this.r=se,this.s=de,this.h=ue.create(this.p),this.i=(0,l.getRemoteServerRootPath)(ne),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=q?this.s.createInstance(H.WebClientServer,this.l):null,this.r.info("Extension host agent started."),this.F(!0)}async handleRequest(K,ee){if(K.method!=="GET")return(0,H.serveError)(K,ee,405,`Unsupported method ${K.method}`);if(!K.url)return(0,H.serveError)(K,ee,400,"Bad request.");const z=C.parse(K.url,!0);let q=z.pathname;if(!q)return(0,H.serveError)(K,ee,400,"Bad request.");if(q.startsWith(this.i)&&q.charCodeAt(this.i.length)===47&&(q=q.substring(this.i.length)),q==="/version")return ee.writeHead(200,{"Content-Type":"text/plain"}),void ee.end(this.p.commit||"");if(q==="/delay-shutdown")return this.H(),ee.writeHead(200),void ee.end("OK");if(!(0,k.requestHasValidConnectionToken)(this.l,K,z))return(0,H.serveError)(K,ee,403,"Forbidden.");if(q==="/vscode-remote-resource"){const G=z.query.path;if(typeof G!="string")return(0,H.serveError)(K,ee,400,"Bad request.");let ne;try{ne=h.URI.from({scheme:E.Schemas.file,path:G}).fsPath}catch{return(0,H.serveError)(K,ee,400,"Bad request.")}const se=Object.create(null);this.n.isBuilt&&((0,T.isEqualOrParent)(ne,this.n.builtinExtensionsPath,!b.isLinux)||(0,T.isEqualOrParent)(ne,this.n.extensionsPath,!b.isLinux))&&(se["Cache-Control"]="public, max-age=31536000"),se.Vary="Origin";const de=K.headers.origin;return de&&this.h.matches(de)&&(se["Access-Control-Allow-Origin"]=de),(0,H.serveFile)(ne,1,this.r,K,ee,se)}if(this.g){this.g.handle(K,ee,z);return}return ee.writeHead(404,{"Content-Type":"text/plain"}),void ee.end("Not found")}handleUpgrade(K,ee){let z=(0,u.generateUuid)(),q=!1,G=!1;if(K.url){const N=C.parse(K.url,!0).query;typeof N.reconnectionToken=="string"&&(z=N.reconnectionToken),N.reconnection==="true"&&(q=!0),N.skipWebSocketFrames==="true"&&(G=!0)}if(K.headers.upgrade===void 0||K.headers.upgrade.toLowerCase()!=="websocket"){ee.end("HTTP/1.1 400 Bad Request");return}const ne=K.headers["sec-websocket-key"],se=w.createHash("sha1");se.update(ne+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const W=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${se.digest("base64")}`];let x=!1;if(!G&&!this.n.args["disable-websocket-compression"]&&K.headers["sec-websocket-extensions"]){const N=Array.isArray(K.headers["sec-websocket-extensions"])?K.headers["sec-websocket-extensions"]:[K.headers["sec-websocket-extensions"]];for(const R of N)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(R)){if(/\b(permessage-deflate)\b/.test(R)){x=!0,W.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(R)){x=!0,W.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}ee.write(W.join(`\r
`)+`\r
\r
`),ee.setTimeout(0),ee.setNoDelay(!0),G?this.v(new t.NodeSocket(ee,`server-connection-${z}`),q,z):this.v(new t.WebSocketNodeSocket(new t.NodeSocket(ee,`server-connection-${z}`),x,null,!0),q,z)}handleServerError(K){this.r.error("Error occurred in server"),this.r.error(K)}t(K){let ee;return K instanceof t.NodeSocket?ee=K.socket:ee=K.socket.socket,ee.remoteAddress||"<unknown>"}async u(K,ee,z){const q=ee.getSocket();this.r.error(`${K} ${z}.`);const G={type:"error",reason:z};ee.sendControl(v.VSBuffer.fromString(JSON.stringify(G))),ee.dispose(),await q.drain(),q.dispose()}v(K,ee,z){const q=this.t(K),G=`[${q}][${z.substr(0,8)}]`,ne=new O.PersistentProtocol({socket:K}),se=this.m?new this.m.validator:null,de=this.m?new this.m.signer:null;let W;(function(U){U[U.WaitingForAuth=0]="WaitingForAuth",U[U.WaitingForConnectionType=1]="WaitingForConnectionType",U[U.Done=2]="Done",U[U.Error=3]="Error"})(W||(W={}));let x=0;const N=U=>{x=3,R.dispose(),this.u(G,ne,U)},R=ne.onControlMessage(U=>{if(x===0){let X;try{X=JSON.parse(U.toString())}catch{return N("Malformed first message")}if(X.type!=="auth")return N("Invalid first message");if(this.l.type===2&&!this.l.validate(X.auth))return N("Unauthorized client refused: auth mismatch");let ie=(0,u.generateUuid)();if(de)try{ie=de.sign(X.data)}catch{}let j=(0,u.generateUuid)();if(se)try{j=se.createNewMessage(j)}catch{}const $={type:"sign",data:j,signedData:ie};ne.sendControl(v.VSBuffer.fromString(JSON.stringify($))),x=1}else if(x===1){let X;try{X=JSON.parse(U.toString())}catch{return N("Malformed second message")}if(X.type!=="connectionType")return N("Invalid second message");if(typeof X.signedData!="string")return N("Invalid second message field type");const ie=X.commit,j=this.p.commit;if(ie&&j&&ie!==j)return N("Client refused: version mismatch");let $=!1;if(!se)$=!0;else if(this.l.validate(X.signedData))$=!0;else try{$=se.validate(X.signedData)==="ok"}catch{}if(!$){if(this.n.isBuilt)return N("Unauthorized client refused");this.r.error(`${G} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const J in this.b)this.b[J].shortenReconnectionGraceTimeIfNecessary();for(const J in this.a)this.a[J].shortenReconnectionGraceTimeIfNecessary();x=2,R.dispose(),this.w(q,G,ne,K,ee,z,X)}})}async w(K,ee,z,q,G,ne,se){const de=se.desiredConnectionType===1?`${ee}[ManagementConnection]`:se.desiredConnectionType===2?`${ee}[ExtensionHostConnection]`:ee;if(se.desiredConnectionType===1)if(G){if(!this.b[ne])return this.f.has(ne)?this.u(de,z,"Unknown reconnection token (seen before)"):this.u(de,z,"Unknown reconnection token (never seen)");z.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const W=z.readEntireBuffer();z.dispose(),this.b[ne].acceptReconnection(K,q,W)}else{if(this.b[ne])return this.u(de,z,"Duplicate reconnection token");z.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const W=new D.ManagementConnection(this.r,ne,K,z);this.k.acceptConnection(W.protocol,W.onClose),this.b[ne]=W,this.f.add(ne),W.onClose(()=>{delete this.b[ne]})}else if(se.desiredConnectionType===2){const W=se.args||{language:"en"},x=await this.C(W);if(x.port&&this.r.trace(`${de} - startParams debug port ${x.port}`),this.r.trace(`${de} - startParams language: ${x.language}`),this.r.trace(`${de} - startParams env: ${JSON.stringify(x.env)}`),G){if(!this.a[ne])return this.f.has(ne)?this.u(de,z,"Unknown reconnection token (seen before)"):this.u(de,z,"Unknown reconnection token (never seen)");z.sendPause(),z.sendControl(v.VSBuffer.fromString(JSON.stringify(x.port?{debugPort:x.port}:{})));const N=z.readEntireBuffer();z.dispose(),this.a[ne].acceptReconnection(K,q,N)}else{if(this.a[ne])return this.u(de,z,"Duplicate reconnection token");z.sendPause(),z.sendControl(v.VSBuffer.fromString(JSON.stringify(x.port?{debugPort:x.port}:{})));const N=z.readEntireBuffer();z.dispose();const R=this.s.createInstance(g.ExtensionHostConnection,ne,K,q,N);this.a[ne]=R,this.f.add(ne),R.onClose(()=>{delete this.a[ne],this.D()}),R.start(x)}}else if(se.desiredConnectionType===3){const W=se.args;this.y(z,W)}else return this.u(de,z,"Unknown initial data received")}async y(K,ee){const z=K.getSocket().socket,q=K.readEntireBuffer();K.dispose(),z.pause();const G=await this.z(ee.host,ee.port);q.byteLength>0&&G.write(q.buffer),G.on("end",()=>z.end()),G.on("close",()=>z.end()),G.on("error",()=>z.destroy()),z.on("end",()=>G.end()),z.on("close",()=>G.end()),z.on("error",()=>G.destroy()),G.pipe(z),z.pipe(G)}z(K,ee){return new Promise((z,q)=>{const G=o.createConnection({host:K,port:ee},()=>{G.removeListener("error",q),G.pause(),z(G)});G.once("error",q)})}C(K){return typeof K.port=="number"?(0,f.findFreePort)(K.port,10,5e3).then(ee=>(K.port=ee,K)):(K.debugId=void 0,K.port=void 0,K.break=void 0,Promise.resolve(K))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(K=!1){this.n.args["enable-remote-auto-shutdown"]&&(this.n.args["remote-auto-shutdown-without-delay"]&&!K?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},te))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};ce=Le([Re(4,S.IServerEnvironmentService),Re(5,a.IProductService),Re(6,i.ILogService),Re(7,r.IInstantiationService)],ce);async function le(ve,K,ee){const z=await(0,k.determineServerConnectionToken)(K);z instanceof k.ServerConnectionTokenParseError&&(console.warn(z.message),process.exit(1));function q($){(0,m.setUnexpectedErrorHandler)(J=>{(0,m.isSigPipeError)(J)&&J.stack&&/unexpectedErrorHandler/.test(J.stack)||$(J)})}const G=[];q($=>{G.push($),console.error($)});let ne=!1;process.on("SIGPIPE",()=>{ne||(ne=!0,(0,m.onUnexpectedError)(new Error("Unexpected SIGPIPE")))});const se=new y.DisposableStore,{socketServer:de,instantiationService:W}=await(0,F.setupServerServices)(z,K,ee,se);W.invokeFunction($=>{const J=$.get(i.ILogService);G.forEach(V=>J.error(V)),G.length=0,q(V=>J.error(V))}),W.invokeFunction($=>{const J=$.get(n.IConfigurationService);process.platform==="win32"&&(0,I.setUNCHostAllowlist)((0,I.toUNCHostAllowlist)(J.getValue("security.allowedUNCHosts")))}),W.invokeFunction($=>{const J=$.get(i.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const V=(0,d.join)(process.env.HOMEDRIVE,"node_modules"),Z=(0,d.dirname)((0,d.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Y=(0,d.join)(Z,"node_modules");if(L.existsSync(V)||L.existsSync(Y)){const _=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${V}
* ${Y}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;J.warn(_),console.warn(_),process.exit(0)}}});const x=W.invokeFunction($=>{const J=$.get(i.ILogService);if(L.existsSync((0,d.join)(E.FileAccess.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(Z){J.error(Z)}return null}),N=L.existsSync(E.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(N&&ve&&typeof ve!="string"){const $=z.type!==0?`?${E.connectionTokenQueryName}=${z.value}`:"";console.log(`Web UI available at http://localhost${ve.port===80?"":`:${ve.port}`}/${$}`)}const R=W.createInstance(ce,de,z,x,N);p.mark("code/server/ready");const U=P.performance.now(),X=global.vscodeServerStartTime,ie=global.vscodeServerListenTime,j=global.vscodeServerCodeLoadedTime;if(W.invokeFunction($=>{$.get(c.ITelemetryService).publicLog2("serverStart",{startTime:X,startedTime:ie,codeLoadedTime:j,readyTime:U})}),K["print-startup-performance"]){const $=A.LoaderStats.get();let J="";J+=`

### Load AMD-module
`,J+=A.LoaderStats.toMarkdownTable(["Module","Duration"],$.amdLoad),J+=`

### Load commonjs-module
`,J+=A.LoaderStats.toMarkdownTable(["Module","Duration"],$.nodeRequire),J+=`

### Invoke AMD-module factory
`,J+=A.LoaderStats.toMarkdownTable(["Module","Duration"],$.amdInvoke),J+=`

### Invoke commonjs-module
`,J+=A.LoaderStats.toMarkdownTable(["Module","Duration"],$.nodeEval),J+=`Start-up time: ${ie-X}
`,J+=`Code loading time: ${j-X}
`,J+=`Initialized time: ${U-X}
`,J+=`
`,console.log(J)}return R}e.createServer=le;class ue{static create(K){const ee=K.webEndpointUrlTemplate,z=K.commit,q=K.quality;if(!ee||!z||!q)return new ue(null);const G=(0,u.generateUuid)(),se=new URL(ee.replace("{{uuid}}",G).replace("{{commit}}",z).replace("{{quality}}",q)).origin,de=(0,s.escapeRegExpCharacters)(se).replace(G,"[a-zA-Z0-9\\-]+");try{const W=(0,s.createRegExp)(`^${de}$`,!0,{matchCase:!1});return new ue(W)}catch{return new ue(null)}}constructor(K){this.a=K}matches(K){return this.a?this.a.test(K):!1}}}),define(ge[300],pe([1,0,28,33,13,286,290,62,7,291,45,53,41]),function(oe,e,w,L,o,P,C,A,v,m,T,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,E.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=m.performance.now();const d={onMultipleValues:(i,a)=>{console.error(`Option '${i}' can only be defined once. Using value ${a}.`)},onEmptyValue:i=>{console.error(`Ignoring option '${i}': Value must not be empty.`)},onUnknownOption:i=>{console.error(`Ignoring option '${i}': not supported for server.`)},onDeprecatedOption:(i,a)=>{console.warn(`Option '${i}' is deprecated: ${a}`)}},p=(0,A.parseArgs)(process.argv.slice(2),T.serverOptions,d),b=p["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.join)(w.homedir(),y.default.serverDataFolderName||".vscode-remote"),s=(0,v.join)(b,"data"),h=(0,v.join)(s,"User"),u=(0,v.join)(h,"globalStorage"),f=(0,v.join)(h,"History"),I=(0,v.join)(s,"Machine");p["user-data-dir"]=s;const O=(0,v.dirname)(o.FileAccess.asFileUri("").fsPath),t=(0,v.join)(O,"extensions");p["builtin-extensions-dir"]=t,p["extensions-dir"]=p["extensions-dir"]||(0,v.join)(b,"extensions"),[b,p["extensions-dir"],s,h,I,u,f].forEach(i=>{try{L.existsSync(i)||L.mkdirSync(i,{mode:448})}catch(a){console.error(a)}});function n(){(0,P.run)(p,b,T.serverOptions)}e.spawnCli=n;function r(i){return(0,C.createServer)(i,p,b)}e.createServer=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6a995c4f4cc2ced6e3237749973982e751cb0bf9/core/vs/server/node/server.main.js.map
